class Activities
{  
    static loop() 
    {
        Activities.refreshFurnaceActivity()
        Activities.refreshFarmingActivity();
        Activities.refreshTreeActivity();
        Activities.refreshFightPointsActivity();
        Activities.crystalMagicXPNeedsAttentionActivity();
        Activities.refreshWateringCanActivity();
        Activities.refreshBoatsActivity();
        Activities.refreshFoundryActivity();
        Activities.refreshAquariumActivity();
        Activities.refreshCooksBookActivity();
        Activities.refreshRobotWavesActivity();
        if(client_ticks % 60 == 0 || client_ticks <= 10) Activities.refreshBewingNoPotionsActiveTicks();
    }

    static refreshBewingNoPotionsActiveTicks() {
        var showNotif = true;
       
        for (const [key, value] of Object.entries(Brewing.POTION_TIMERS)) {
            if(Items.getItem(key + "_timer") >= 1) {
                showNotif = false;
            }
            if(!showNotif) {
                break;
            }
        }
        if(Items.getItem("brewing_unlocked") == 0) showNotif = false;
        show_notification("potions_inactive", showNotif)
    }

   

    static refreshFurnaceActivity()
    {
        if(Items.getItem("stone_furnace_crafted") == 0)
        {
            show_notification("furnace", false);
            return;
        }

        if(Items.getItemString("furnace_ore_type") == "none") {
            
            show_notification("furnace", true);
            if(Items.getItem("new_settings_checkbox_furnace_browser_tab") == 1)
            {
                title_animation_active = true;
            }
        }
        else {
            show_notification("furnace", false);
        }
    }

    static refreshFarmingActivity()
    {
        if(Items.getItem("farming_unlocked") == 0)
        {
            return;
        }

        if(Items.getItem("farm_timer_1") == 0 
            && Items.getItem("farm_timer_2") == 0 
            && Items.getItem("farm_timer_3") == 0
            && Items.getItem("farm_timer_4") == 0
            && Items.getItem("farm_timer_5") == 0
        ) {
            show_notification("farming_empty", true);
        } else {
            show_notification("farming_empty", false);
        }

        for(var i = 1; i <= 5; i++)
        {
            if(Items.getItem("farm_stage_" + i) == 4)
            {
                show_notification("farming", true);
                
                if(Items.getItem("new_settings_checkbox_farming_browser_tab") == 1)
                {
                    title_animation_active = true;
                }
                return;
            }
        }
        show_notification("farming", false);


    }



    static refreshAquariumActivity() 
    {
        if(Items.getItem("aquarium_unclaimed_unique") == 0)
        {
            show_notification("aquarium", false);
            return;
        }

        if(Items.getItem("aquarium_timer") == 0) 
        {
            show_notification("aquarium", true);
        } else {
            show_notification("aquarium", false);
        }
    }

    static crystalMagicXPNeedsAttentionActivity()
    {
        if(Items.getItem("crystal_ball_bought") == 0)
        {
            show_notification("crystal_magic_xp", false);
            return;
        }

        if(Items.getItem("crystal_ball_timer") == 0) {
            show_notification("crystal_magic_xp", true);
        }
        else {
            show_notification("crystal_magic_xp", false);
        }
    }

    static refreshRobotWavesActivity() {

        if(Items.getItem("robot_completed") == 0)
        {
            hide_element("notification-robot_waves-ready");
            return;
        }
    
        if(Items.getItem("robot_wave_timer") == 0) {
            show_element("notification-robot_waves-ready");
        }
        else {
            hide_element("notification-robot_waves-ready");
        }
    }


    static refreshTreeActivity()
    {
        if(Items.getItem("woodcutting_unlocked") == 0)
        {
            show_notification("trees", false);
            return;
        }
        for(var i = 1; i <= 5; i++)
        {
            if(Items.getItem("tree_stage_" + i) == 4)
            {
                show_notification("trees", true);
                if(Items.getItem("new_settings_checkbox_woodcutting_browser_tab") == 1)
                {
                    title_animation_active = true;
                }
                return;
            }
        }
        show_notification("trees", false);
    }

    static refreshFoundryActivity() {

        if(Items.getItem("charcoal_foundry_crafted") == 0)
        {
            show_notification("foundry", false);
            return;
        }

        if(Items.getItem("foundry_amount") > 0) {
            show_notification("foundry", false);
        }
        else {
            show_notification("foundry", true);
        }

    }

    static refreshFightPointsActivity()
    {
        if(Items.getItem("wooden_sword_bought") == 0)
        {
            show_notification("fight_points", false);
            return;
        }

        if(Items.getItem("fight_points") >= Items.getItem("max_fight_points"))
        {
            if(Items.getItem("new_settings_checkbox_fp_browser_tab") == 1)
            {
                title_animation_active = true;
            }

            
            show_notification("fight_points", true);
        }
        else
        show_notification("fight_points", false);
    }

    static aquariumNeedsAttentionActivity(b)
    {
        hide_element("activity-list-aquarium-icon-warning");
        hide_element("activity-list-aquarium-icon-x");
        hide_element("activity-list-aquarium-icon-check");

        if(b) {
            show_element("activity-list-aquarium-icon-warning");
        }
        else {
            show_element("activity-list-aquarium-icon-check");
        }
    }

    static refreshWateringCanActivity() {
        var waterRequired = 100;
        if((Items.getItemString("criptoe_path_selected") == "nature" || Items.getItem("criptoe_path_perm_nature") > 0) && Items.getItem("researcher_points") >= 50000000)
            waterRequired = 500;

        if(Items.getItem("water") >= waterRequired) {
            set_image_src("notification-watering_can-ready-img", "images/" + Farming.getWateringCanToolData()[0] + ".png");
            show_notification("watering_can", true);
        }
        else {
            show_notification("watering_can", false);
        }
    }


    static minimizeButton() {
        document.getElementById("maximized-activities").style.display = "none";
        document.getElementById("minimized-activities").style.display = "";
    }

    static maximizeButton() {
        document.getElementById("maximized-activities").style.display = "";
        document.getElementById("minimized-activities").style.display = "none";
    }
    
    static refreshActivitySettings(key, value) {
        if(value == 0) {
            document.getElementById("activity-setting-button-" + key).innerHTML = "<img width='15px' src='https://cdn.idle-pixel.com/images/check.png' />";
        }
        else {
            document.getElementById("activity-setting-button-" + key).innerHTML = "<img width='15px' src='https://cdn.idle-pixel.com/images/x.png' />";
        }
    }
    static refreshCooksBookActivity()
    {
        
        if(Items.getItem("cooks_book") == 0) {
            hide_element("notification-cooks_book")
            show_notification("cooksbook_idle", false)
            return;
        }

        if (Items.getItem("cooks_book_timer") == 1){
            show_notification("cooksbook_ready", true);
            show_notification("cooksbook_idle", false)
        }
        else if (Items.getItem("cooks_book_timer") > 1){
            show_notification("cooksbook_idle", false)
            show_notification("cooksbook_ready", false);
        } else {
            show_notification("cooksbook_idle", true)
            show_notification("cooksbook_ready", false);
        }
    }


    static refreshTreasureMapImportantActivity() {
        if(Items.getItem("treasure_map") > 0 || Items.getItem("green_treasure_map") > 0 || Items.getItem("red_treasure_map") > 0)
        {
            show_element("activity-list-important-treasure_map");
        }
        else 
        {
            hide_element("activity-list-important-treasure_map");
        }
    }

    static refreshBoatsActivity() {

        if(Items.getItem("row_boat") == 0)
        {
            show_notification("boats_idle", false);
            return;
        }

        if(Items.getItem("row_boat_timer") == 0 && Items.getItem("canoe_boat_timer") == 0 && Items.getItem("stardust_boat_timer") == 0 && Items.getItem("pirate_ship_timer") == 0 && Items.getItem("submarine_boat_timer") == 0) 
        {
            show_notification("boats_idle", true);
        }
        else {
            show_notification("boats_idle", false);
        }

        if(Items.getItem("row_boat_timer") == 1 || Items.getItem("canoe_boat_timer") == 1 || Items.getItem("stardust_boat_timer") == 1 || Items.getItem("pirate_ship_timer") == 1 || Items.getItem("submarine_boat_timer") == 1 ) {
            show_notification("boats_collect", true);
        } else {
            show_notification("boats_collect", false);
        }
    }
}