class Breeding
{
    static refresh_pens_table() {
        var table = document.getElementById("breeding-table");

        var trs = table.querySelectorAll("[data-purchase-pen]");
        for(var i = 0; i < trs.length; i++) {
            var tr = trs[i];
            var item = tr.getAttribute("data-purchase-pen");
            var img = tr.querySelector("[data-item-x]")
            if(Items.getItem(item + "_obtained") > 0) {
                img.src = "https://cdn.idle-pixel.com/images/check.png"
            }
        }

        
        var levels_spans = table.querySelectorAll("[data-item-breeding-level]")
        for(var i = 0 ; i < levels_spans.length; i++) {
            var levelReq = parseInt(levels_spans[i].innerHTML);
            if(get_level(Items.getItem('breeding_xp')) >= levelReq) {
                levels_spans[i].style.color = "green";
            } else {
                levels_spans[i].style.color = "red";
            }
        }

        var cost_spans = table.querySelectorAll("[data-item-cost-var]")
        for(var i = 0 ; i < cost_spans.length; i++) {
            var item = cost_spans[i].getAttribute("data-item-cost-var");
            var cost = parseInt(cost_spans[i].getAttribute("data-item-cost-amount"));
            if(Items.getItem(item) >= cost) {
                cost_spans[i].style.color = "green";
            } else {
                cost_spans[i].style.color = "red";
            }  
        }
    }

    static clicks_animal_shop_panel() {
        var panel = document.getElementById("panel-breeding-animal-shop");
        var shopitems = panel.querySelectorAll('[data-breeding-animal-shop-level]');
        for(var i = 0; i < shopitems.length; i++) {
            var shopitem = shopitems[i];
            var levelreq = parseInt(shopitem.innerHTML.split(" ")[1]);
            console.log(levelreq)
            if(get_level(Items.getItem('breeding_xp')) >= levelreq) {
                shopitem.style.color = 'green';
            } else {
                shopitem.style.color = 'red';
            }
        }
    }

    static refresh_animals_data(raw) {
        document.getElementById("breeding-chicken-area").innerHTML = "";
        document.getElementById("animal-stats").style.display = "none";
        if(raw == "none" || raw == 0) return;
        var data = [];
        var array = raw.split("=");
        var hasEasyBreedingAchCompleted = Achievements.has_completed_set('breeding', 'easy')
        var chickenHtml = "";

        var totalKillXp = 0;
        var totalFoodMap = {};
        var totalLootMap = {};

        for(var i = 0; i < array.length; i++) {
            var values = array[i].split(",");
            var slug = values[0];
			var animal = values[1];
			var gender = values[2];
			var tier = values[3];
			var playtimeActivatedOn = parseFloat(values[4]);
			var shinyType = parseInt(values[5]);
			var sick = parseInt(values[6]);
            var foodPerDay = values[7];
            var foodConsumed = values[8];
            var lootItemReady = values[9];
            var lootItemAmount = parseInt(values[10]);
            var xpGained = values[11];
            var traitLabel = values[12];
			var extraData1 = values[13];
			var extraData2 = values[14];
			var extraData3 = values[15];
			var extraData4 = values[16];
			var extraData5 = values[17];

            //for stats
            totalKillXp += parseInt(xpGained);
            if(parseInt(foodPerDay) > 0) {
                var breeding_food_image = Breeding.getBreedFoodLabelImage(animal);
                if(breeding_food_image in totalFoodMap) {
                    var currentValue = parseInt(totalFoodMap[breeding_food_image]);
                    currentValue += parseInt(foodPerDay);
                    totalFoodMap[breeding_food_image] = currentValue;
                } else {
                    totalFoodMap[breeding_food_image] = foodPerDay;
                }
            }
            //end for stats
            var css_flip_90_degrees = "";

            if(sick == 1) {
                css_flip_90_degrees = "img-rotate-90"
            }
            if(sick == 2) {
                css_flip_90_degrees = "img-rotate-90";
            }

            var diffPlaytime = Items.getItem("playtime") - playtimeActivatedOn;
            if(diffPlaytime >= 86400 && Items.getItem("ach_easy_7_days") == 0) {
                websocket.send('ACH_CHECK_7_DAYS');
            }
            var img = animal + "_" + Breeding.get_gender_label(gender) + "_" + tier;
            var gender_color = "blue";
            if(gender == 2) gender_color = "pink";
            var hasLootReady = false;
            if(lootItemReady != "none" && lootItemAmount > 0)  hasLootReady = true;

            chickenHtml += "<table onclick='Modals.clicksActivedAnimal(\""+slug+"\", "+sick+", "+hasLootReady+", "+xpGained+")' class='active-animal-table hover'>"
            chickenHtml += "<tr>"
                    chickenHtml += "<td>"
                        chickenHtml += "<div>"+capitalizeFirstLetter(get_item_name(animal))+"</div>";
                    chickenHtml += "</td>"
                    chickenHtml += "<td>"
                        if(gender == 1) {
                            chickenHtml += "<img class='w15' style='float:right;' src='https://cdn.idle-pixel.com/images/male.png' />";
                        } else {
                            chickenHtml += "<img class='w15' style='float:right;' src='https://cdn.idle-pixel.com/images/female.png' />";
                        }
                        chickenHtml += "<div>"+format_time(diffPlaytime)+"</div>";
                    chickenHtml += "</td>";
                chickenHtml += "</tr>"
                chickenHtml += "<tr>"
                    chickenHtml += "<td>"
                        if(shinyType == 1) {
                            chickenHtml +=  "<img style='position:absolute;' class='w100' src='https://cdn.idle-pixel.com/images/shiny.gif' />"
                        } else if(shinyType == 2) {
                            chickenHtml +=  "<img style='position:absolute;' class='w100' src='https://cdn.idle-pixel.com/images/mega_shiny.gif' />"
                        }
                        
                        if(sick == 2) {
                            chickenHtml += "<img class='w50' src='https://cdn.idle-pixel.com/images/death.png' style='opacity: 0.5;z-index:5;position:absolute' />"
                        }
                        if(sick == 1) {
                            chickenHtml += "<img class='w50' src='https://cdn.idle-pixel.com/images/heart.png' style='opacity: 0.5;z-index:5;position:absolute' />"
                        }
                        chickenHtml += "<img class='w100 "+css_flip_90_degrees+"' src='https://cdn.idle-pixel.com/images/"+img+".png' />";
                        chickenHtml += "<div class='font-small color:grey'><span class='dot-green'></span> <span class='dot-grey'></span> <span class='dot-grey'></span> </div>";
                    chickenHtml += "</td>"
                    chickenHtml += "<td style='vertical-align:top;text-align:left;'>"
                        if(sick == 2) {
                            chickenHtml += "<br /><span class='color-red'>This animal has died due to lack of food or disease.</span>"
                        } else if(sick == 1) {
                            chickenHtml += "<br /><span class='color-black'>This animal is currently sick.  You'll need to <u class='hover' onclick='switch_panels(\"panel-brewing\");Modals.open_brew_dialogue(\"cure_animal_disease_potion\");event.stopPropagation();' style='color:blue'>brew a potion</u> from brewing to cure their sickness.</span>"
                        } else {
                            chickenHtml += "<div><b>Trait:</b> "+traitLabel+" <img style='margin-top:-5px;' src='https://cdn.idle-pixel.com/images/"+Breeding.getTraitDesc(traitLabel)[0]+".png' class='w15' /></div>";
                            chickenHtml += "<div class='font-small color-grey'>"+Breeding.getTraitDesc(traitLabel)[1]+"</div>";
                            chickenHtml += "<br />";
                            if(Breeding.getBreedFoodLabel(animal) != "none") {
                                chickenHtml += "<div><b>Food:</b> "+Breeding.getBreedFoodLabel(animal)+"</div>";
                                chickenHtml += "<div class='font-small color-grey'>Consumes <b>"+foodPerDay+"</b> food per day.<br /><span class='color-brown'>"+foodConsumed+" consumed</span></div>";
                                chickenHtml += "<br />";
                            }
                            
                            if(hasEasyBreedingAchCompleted) {
                                chickenHtml += "<div><b>Reproduction Avg. Rate:</b> "+format_time_verbose(Breeding.getReproductionRate(animal, traitLabel))+"</div>";
                                chickenHtml += "<div class='font-small color-grey'>Requires a couple</div>";
                                chickenHtml += "<br />";
                            }
                            

                            if(hasLootReady) {
                                chickenHtml += "<div><b>Loot available:</b> <img class='w15' src='https://cdn.idle-pixel.com/images/"+lootItemReady+".png' /> x "+ lootItemAmount + "</div>";
                                chickenHtml += "<br />";

                                if(lootItemReady in totalLootMap) {
                                    var currentValue = parseInt(totalLootMap[lootItemReady]);
                                    currentValue += parseInt(lootItemAmount);
                                    totalLootMap[lootItemReady] = currentValue;
                                } else {
                                    totalLootMap[lootItemReady] = lootItemAmount;
                                }
                            } else {
                                chickenHtml += "<div><b>Loot available:</b> None <span onclick='Modals.showNextLootAnimals();event.stopPropagation();' class='color-blue hover-underline'>(?)</span></div>";
                                chickenHtml += "<br />";
                            }
                            chickenHtml += "<div class='font-small color-green'>+"+ format_number(xpGained) +" xp when killed</div>";
                        } 
                    chickenHtml += "</td>";
                chickenHtml += "</tr>"
            chickenHtml += "</table>"; 
        }
       
        var statsHTML = "<table>";
        statsHTML += "<tr>";
            statsHTML += "<td><b>Total XP:</b></td>";
            statsHTML += "<td>"+format_number(totalKillXp)+"</td>";
        statsHTML += "</tr>";
        statsHTML += "<tr>";
            statsHTML += "<td><b>Daily Food:</b></td>";
            statsHTML += "<td>";
            if(Object.keys(totalFoodMap).length == 0) {
                statsHTML += "None";
            } else {
                for (var key in totalFoodMap) {
                    var img = key;
                    var amount = totalFoodMap[key];
                    var color = "pink";
                    var classBlink = "blink ";
                    if(amount <= Items.getItem(img)) {
                        color = "lime";
                        classBlink = "";
                    }
                    if(amount * 7 <= Items.getItem(img)) {
                        color = "cyan";
                        classBlink = "";
                    }


                    statsHTML += "<img src='https://cdn.idle-pixel.com/images/"+img+".png' class='"+classBlink+" w15' /> <span style='color:"+color+"'>" + format_number(amount) + "</span>&nbsp;&nbsp;&nbsp;";
                }
            }
            statsHTML += "</td>";
        statsHTML += "</tr>";

        statsHTML += "<tr>";
        statsHTML += "<td><b>Current Loot:</b></td>";
        statsHTML += "<td>";
        if(Object.keys(totalLootMap).length == 0) {
            statsHTML += "None";
        } else {
            for (var key in totalLootMap) {
                var img = key;
                var amount = totalLootMap[key];
                statsHTML += "<img src='https://cdn.idle-pixel.com/images/"+img+".png' class='w15' /> <span>" + format_number(amount) + "</span>&nbsp;&nbsp;&nbsp;";
            }
            statsHTML += "<span onclick='websocket.send(\"COLLECT_ALL_LOOT_ANIMAL\")' class='hover color-pink'> - Loot all</span>"
        }
        statsHTML += "</td>";
        statsHTML += "</tr>";
       
        statsHTML += "</table>";
        
        document.getElementById("animal-stats").style.display = "";
        document.getElementById("animal-stats").innerHTML = statsHTML;
        document.getElementById("breeding-chicken-area").innerHTML = chickenHtml;
    }
    

    static get_token_per_animal(animal) {
        switch(animal) {
            case "chicken":
                return 1;
            case "sheep":
                return 2;
            case "spider":
                return 3;
            case "horse":
                return 10;
            case "camel":
                return 20;
            default:
                return "null";
        }
    }
    static get_gender_label(id) {
        if (id == 1) {
            return "male";
        } else {
            return "female";
        }
    }

    static getBreedFoodLabelImage(animalName) {
        switch(animalName) {
            case "chicken":
                return "breeding_food_seeds";
            case "camel":
                return "none";
            case "dove":
                return "breeding_food_seafood";
            case "spider":
                return "breeding_food_insects";
            case "sheep":
            case "horse":
                return "breeding_food_leaves";
            default:
                return "none";
        }
    }

    static getBreedFoodLabel(animalName) {
        switch(animalName) {
            case "chicken":
                return "Seeds";
            case "camel":
                return "none";
            case "dove":
                return "Seafood";
            case "spider":
                return "Insects";
            case "sheep":
            case "horse":
                return "Leaves";
            default:
                return "null";
        }
    }

    static getFenceRequiredForUpgrade(at) {
		switch(at) {
			case 0:
				return 20;
			case 1:
				return 50;
			case 2:
				return 200;
			case 3:
				return 500;
			case 4:
				return 4000;
			case 5:
				return 10000;
			case 6:
				return 50000;
			case 7:
				return 100000;
			default:
				return 0;
		}
	}

    //[color, desc]
    static getTraitDesc(label) {
        switch(label) {
            case "None":
                return ["none", "This animal does not have any special traits."];
        
            case "Fertile":
                return ["smile_icon", "This animal has an increased reproduction rate."];
            case "Productive":
                return ["smile_icon", "This animal will generate twice the loot."];
            case "XPer":
                return ["smile_icon", "This animal will yield double XP."];
            case "Immunity":
                return ["smile_icon", "This animal cannot get sick."];
            case "Fasting":
                return ["smile_icon", "This animal will eat half as much."];

            case "Weak":
                return ["sad_icon", "This animal has double the chance of becoming sick."];
            case "XPless":
                return ["sad_icon", "This animal will yield half the normal XP."];
            case "Hungry":
                return ["sad_icon", "This animal eats double."];
            case "Unproductive":
                return ["sad_icon", "This animal has a lower chance of producing loot."];
            case "Less Fertile":
                return ["sad_icon", "This animal has reduced reproduction rates."];

            case "Hungerless":
                return ["unique_traite", "This animal can feed on its own."];
            default: 
                return ["warning_icon", "Traite error."];
        }
    }

    
    static getReproductionRate(animal, traite) {
        var val = 0;
        switch(animal) {
            case "chicken":
                val = 10800;
            break;
            case "spider":
                val = 7200;
            break;
            case "sheep":
                val = 43200;
            break;
            case "dove":
                val = 3600;
            break;
            case "horse":
                val = 86400*2;
            break;
            case "camel":
                val = 86400*4;
            break;
            default:
                return 0;
        }

        if(traite == "Fertile") {
            val *= 0.75;
        }
        if(traite == "Less Fertile") {
            val *= 1.5;
        }

        return val;
    }
    // return [name, desc]
    static getTooltipForPokedex(animalName) {
        var green_grey_grey = "<span class='dot-green'></span> <span class='dot-grey'></span> <span class='dot-grey'></span>"
        var green_green_grey = "<span class='dot-green'></span> <span class='dot-green'></span> <span class='dot-grey'></span>"
        var green_green_green = "<span class='dot-green'></span> <span class='dot-green'></span> <span class='dot-green'></span>"
        
        
        switch(animalName) {
            case "chicken":
            {
                var tier1 = ["Feathers"]
                var tier2 = ["Fire Feathers", "Ice Feathers"]
                var tier3 = ["Ancient Feathers"]
                    
                var html = "";
                html += "<br /><br />";
                html += "<u>Production</u><br /><br />";

                if(tier1.length > 0) {
                    html += green_grey_grey + "&nbsp;&nbsp;&nbsp;&nbsp;";
                    html += tier1.join(", ");
                }
                if(tier2.length > 0) {
                    html += "<br />";
                    html += green_green_grey + "&nbsp;&nbsp;&nbsp;&nbsp;";
                    html += tier2.join(", ");
                }
                if(tier3.length > 0) {
                    html += "<br />";
                    html += green_green_green + "&nbsp;&nbsp;&nbsp;&nbsp;";
                    html += tier3.join(", ");
                }

                return [capitalizeFirstLetter(animalName), html]
            }
            case "sheep":
            {
                var tier1 = ["Wool"]
                var tier2 = ["Quality Wool"];
                var tier3 = ["High Quality Wool"]
                
                var html = "";
                html += "<br /><br />";
                html += "<u>Production</u><br /><br />";

                if(tier1.length > 0) {
                    html += green_grey_grey + "&nbsp;&nbsp;&nbsp;&nbsp;";
                    html += tier1.join(", ");
                }
                if(tier2.length > 0) {
                    html += "<br />";
                    html += green_green_grey + "&nbsp;&nbsp;&nbsp;&nbsp;";
                    html += tier2.join(", ");
                }
                if(tier3.length > 0) {
                    html += "<br />";
                    html += green_green_green + "&nbsp;&nbsp;&nbsp;&nbsp;";
                    html += tier3.join(", ");
                }
                return [capitalizeFirstLetter(animalName), html]
            }
            case "spider":
            {
                var tier1 = ["String"]
                var tier2 = ["Thick String"];
                var tier3 = ["Metal String"]
                
                var html = "";
                html += "<br /><br />";
                html += "<u>Production</u><br /><br />";

                if(tier1.length > 0) {
                    html += green_grey_grey + "&nbsp;&nbsp;&nbsp;&nbsp;";
                    html += tier1.join(", ");
                }
                if(tier2.length > 0) {
                    html += "<br />";
                    html += green_green_grey + "&nbsp;&nbsp;&nbsp;&nbsp;";
                    html += tier2.join(", ");
                }
                if(tier3.length > 0) {
                    html += "<br />";
                    html += green_green_green + "&nbsp;&nbsp;&nbsp;&nbsp;";
                    html += tier3.join(", ");
                }
                return [capitalizeFirstLetter(animalName), html]
            }
            case "horse":
            {
                var tier1 = ["Horseshoe"]
                var tier2 = ["Solid Horseshoe"];
                var tier3 = ["Cemented Horeshoe"]
                
                var html = "";
                html += "<br /><br />";
                html += "<u>Production</u><br /><br />";

                if(tier1.length > 0) {
                    html += green_grey_grey + "&nbsp;&nbsp;&nbsp;&nbsp;";
                    html += tier1.join(", ");
                }
                if(tier2.length > 0) {
                    html += "<br />";
                    html += green_green_grey + "&nbsp;&nbsp;&nbsp;&nbsp;";
                    html += tier2.join(", ");
                }
                if(tier3.length > 0) {
                    html += "<br />";
                    html += green_green_green + "&nbsp;&nbsp;&nbsp;&nbsp;";
                    html += tier3.join(", ");
                }
                return [capitalizeFirstLetter(animalName), html]
            }
            case "dove":
            {
                var tier1 = ["Dove feathers"];
                var tier2 = ["Dove feathers"];
                var tier3 = ["Dove feathers"];
                
                var html = "";
                html += "<br /><br />";
                html += "<u>Production</u><br /><br />";

                if(tier1.length > 0) {
                    html += green_grey_grey + "&nbsp;&nbsp;&nbsp;&nbsp;";
                    html += tier1.join(", ");
                }
                if(tier2.length > 0) {
                    html += "<br />";
                    html += green_green_grey + "&nbsp;&nbsp;&nbsp;&nbsp;";
                    html += tier2.join(", ");
                }
                if(tier3.length > 0) {
                    html += "<br />";
                    html += green_green_green + "&nbsp;&nbsp;&nbsp;&nbsp;";
                    html += tier3.join(", ");
                }
                return [capitalizeFirstLetter(animalName), html]
            }
            case "camel":
            {
                var tier1 = ["A bit of animal food"]
                var tier2 = ["Some animal food"];
                var tier3 = ["A lot of animal food"]
                
                var html = "";
                html += "<br /><br />";
                html += "<u>Production</u><br /><br />";

                if(tier1.length > 0) {
                    html += green_grey_grey + "&nbsp;&nbsp;&nbsp;&nbsp;";
                    html += tier1.join(", ");
                }
                if(tier2.length > 0) {
                    html += "<br />";
                    html += green_green_grey + "&nbsp;&nbsp;&nbsp;&nbsp;";
                    html += tier2.join(", ");
                }
                if(tier3.length > 0) {
                    html += "<br />";
                    html += green_green_green + "&nbsp;&nbsp;&nbsp;&nbsp;";
                    html += tier3.join(", ");
                }
                return [capitalizeFirstLetter(animalName), html]
            }
        }
    }


    static animalReproducedPopup(html) {
        document.getElementById("modal-breeding-reproduction-content").innerHTML = html;
        Modals.toggle('modal-breeding-reproduction')
    }

    static loadPokedex() {
        let elements = document.querySelectorAll("[data-breeding-pokedex]");
        for(var i = 0; i < elements.length; i++) {
            let ele = elements[i]
            if(Items.getItem(ele.getAttribute("data-breeding-pokedex") + "_looted") > 0) {
                ele.classList.remove("black-img");
            }
        }
    }
}