class Brewing
{
    static POTION_TIMERS = {
        "stardust_potion": 300,
        "energy_potion": 15,
        "anti_disease_potion": 3600,
        "smelting_upgrade_potion": 120,
        "farming_speed_potion":3600,
        "tree_speed_potion": 3600,
        "rare_monster_potion":30,
        "super_stardust_potion":300,
        "gathering_unique_potion":14400,
        "great_stardust_potion":300,
        "furnace_speed_potion":180,
        "heat_potion":300,
        "bait_potion":6*3600,
        "bone_potion":14400,
        "promethium_potion":28800,
        "breeding_anti_disease_potion":3600*4,
        "oil_potion":86400,
        "super_rare_monster_potion":30,
        "ultra_stardust_potion":300,
        "rocket_potion":3*3600,
        "titanium_potion":8*3600,
        "ancient_potion":86400,
        "geode_potion":12*3600,
        "magic_crystal_ball_potion":600,
        "magic_shiny_crystal_ball_potion": 600,
        "rain_potion":60,
        "birdhouse_potion":300,
        "gathering_worker_potion":86400,
      }

  
    static get_xp_from_materials(material, amount)
    {
        var dict = {
            "dotted_green_leaf": 25,
            "green_leaf": 100,
            "lime_leaf": 250,
            "gold_leaf": 800,
            "crystal_leaf": 2000,
            "red_mushroom": 5,
            "strange_leaf": 500,
            "stranger_leaf": 2500,
            "rocket_fuel": 250,
            "moonstone": 250,
            "blue_shooting_star": 50000,
            "green_shooting_star": 200000,
            "red_shooting_star": 500000,
            "cooks_dust": 20000,
            "fighting_dust": 20000,
            "farm_dust": 20000,
            "tree_dust": 20000,
        }

        var value = dict[material];
        var to_return = value * amount;

        if(isNaN(to_return)) return 0;
        return to_return;

    }

    static switchedToPanel() {
        if(Items.getItem("researcher_points") >= 50000000 && (Items.getItemString("criptoe_path_selected") == "chemist" || Items.getItem("criptoe_path_perm_chemist") > 0)) {
            document.getElementById("itembox-autodrinker").style.display = "";
        } else {
            document.getElementById("itembox-autodrinker").style.display = "none";
        }
    }

    static refresh_table(brewingTable)
    {
        if(brewingTable.getAttribute("copy") == "true") {
            var trs = brewingTable.getElementsByTagName("tr");
            for(var i = 0; i < trs.length; i++) {
                if(!trs[i].hasAttribute("data-brewing-item"))
                    continue;

                var potion = trs[i].getAttribute("data-brewing-item");

                var originalTable = document.getElementById("brewing-table");
                var trLookup = originalTable.querySelector('[data-brewing-item="'+potion+'"]')
                trs[i].innerHTML = trLookup.innerHTML;
            }
        }
        Brewing._refresh_click_events(brewingTable);
        Brewing._refresh_materials(brewingTable);
        Brewing._refresh_timers(brewingTable);
        Brewing._refresh_backgrounds(brewingTable);
        Brewing._refresh_xp_labels(brewingTable);
    }


    static refreshShortbrewingDisplayShortcuts(potion, value) {
        let querySelector = document.querySelector('[data-brewing-potion-shortcut-display="'+potion+'"]')
        if(querySelector != null) {
            if(value > 0) {
                if(querySelector.style.backgroundColor != "green")
                    querySelector.style.backgroundColor = "green"
                if(querySelector.style.borderColor != "lime")
                        querySelector.style.borderColor = "lime"
            } else {
                if(querySelector.style.backgroundColor != "")
                    querySelector.style.backgroundColor = ""
                if(querySelector.style.borderColor != "black")
                        querySelector.style.borderColor = "black"
            }
        }
        
    }
    static fill_in_max_input(potion) {
        var amountFound = Brewing.get_max_potions_to_mix(potion);
        document.getElementById("modal-brew-item-amount").value = amountFound;
    }

    static get_max_potions_to_mix(potion) {
        var materials = Brewing.get_ingredients(potion);
        var max_amount = 10000;
        for(var i = 0; i < materials.length; i++) {
            var name = materials[i];
            i++;
            var amount = parseInt(materials[i]);

            var amountOwned = Items.getItem(name);
            var max_current = amountOwned / amount;
            if(max_current < max_amount)
                max_amount = max_current;
        }
        return parseInt(max_amount);
    }
    
    static get_potion_timer(potion, formatted_time)
    {
        var perc_increase = 0.0;
        var timer = Brewing.POTION_TIMERS[potion];

        if(Items.getItem("diamond_brewing_kit") == 1)
            perc_increase += 1.00;
        if(Items.getItem("ruby_brewing_kit") == 1)
            perc_increase += 0.75;
        if(Items.getItem("emerald_brewing_kit") == 1)
            perc_increase += 0.50;
        if(Items.getItem("sapphire_brewing_kit") == 1)
            perc_increase += 0.25;
        
        
        var result = timer * (1 + parseFloat(perc_increase))

        if(formatted_time)
            return format_time(result);
        
        return result;
    }



    static search(ele) {
        var value = ele.value;

        var brewing_table = document.getElementById("brewing-table");
        var brewing_row_array = brewing_table.getElementsByTagName("tr");
        for(var i = 0; i < brewing_row_array.length; i++) {
            var brewing_row = brewing_row_array[i];
            if(!brewing_row.hasAttribute("data-brewing-item"))
                continue;

           
            brewing_row.style.display = "";
        }

        if(value.length > 0) {
            for(var i = 0; i < brewing_row_array.length; i++) {
                var brewing_row = brewing_row_array[i];
                if(!brewing_row.hasAttribute("data-brewing-item"))
                    continue;

                var firstTd = brewing_row.getElementsByTagName("td")[0];
                var textFound = firstTd.textContent
                var slug = textFound.toLowerCase();

                if(!slug.includes(value.toLowerCase())) {
                    brewing_row.style.display = "none";
                } else {
                    brewing_row.style.display = "";
                }
            }
        }
    }
    static _refresh_click_events(brewing_table)
    {

        var brewing_row_array = brewing_table.getElementsByTagName("tr");

        for(var i = 0; i < brewing_row_array.length; i++)
        {
            var brewing_row = brewing_row_array[i];
            if(!brewing_row.hasAttribute("data-brewing-item"))
                continue;

            if (brewing_row.getAttribute('listener') !== 'true') {
                brewing_row.setAttribute('listener', 'true')
                brewing_row.addEventListener('click', (e) => {
                        var target_clicked = e.target;
                        var tr = target_clicked.closest("tr");
                        var brewing_row_item = tr.getAttribute("data-brewing-item");
                        Modals.open_brew_dialogue(brewing_row_item);
                });
            }

            
        }
        
        
    }

    static potion_clicked(potion) 
    {
        if(Items.getItem(potion) <= 0) {
            Animations.scrollText("images/x.png", "red", "Missing Potion");
            return;
        }

        try {
            if(potion.startsWith("raids")) {
                Modals.open_image_modal("Raids Potion", "images/four_heros.png", "This potion can only be used during a raid.", null, "Close", null);
                return;
            }
        } catch(err) {
            //silently fail
        }
        
        if(Items.getItem('disable_drink_confirmation') == 1)
        {
            document.getElementById('item-box-image-' + potion).classList.add('shake');
            if(document.getElementById('item-box-image-2-' + potion) != null)
                document.getElementById('item-box-image-2-' + potion).classList.add('shake');
            setTimeout(function() {
                document.getElementById('item-box-image-' + potion).classList.remove('shake');
            if(document.getElementById('item-box-image-2-' + potion) != null)
                document.getElementById('item-box-image-2-' + potion).classList.remove('shake');
            }, 500);

            websocket.send('DRINK=' + potion);
            return;
        }
        
        var sd = this.stardustPerSecond(potion);
        var html = "";
        if(sd > 0) {
            html += "<br /><br /><span class='stardust-potion-drink font-small'> <img src='https://cdn.idle-pixel.com/images/stardust.png' class='w10' /> "+sd+" stardust per second</span>"
        }
        Modals.open_image_modal('Drink Potion', 'images/'+potion+'.png', 'Drink potion?' + html, 'Drink', 'Cancel', 'DRINK=' + potion)
    }

    static stardustPerSecond(potion) {
        switch(potion) {
            case 'stardust_potion':
                return 10;
            case 'great_stardust_potion':
                return 100;
            case 'super_stardust_potion':
                return 300;
            case 'ultra_stardust_potion':
                return 1000;            
            default:
                return 0;
        }
    }
    
    static _refresh_xp_labels(brewing_table)
    {
        var brewing_row_array = brewing_table.getElementsByTagName("tr");

        for(var i = 0; i < brewing_row_array.length; i++)
        {
            var tr = brewing_row_array[i];
            var potion = tr.getAttribute("data-brewing-item");

            if(potion != null)
            {
                var materials = tr.getElementsByTagName("item-brewing-table");
                var total_xp = 0;
                for(var j = 0; j < materials.length; j ++)
                {
                    var item = materials[j].getAttribute("data-materials-item");
                    var amount = materials[j].innerHTML;
                    total_xp += Brewing.get_xp_from_materials(item, amount);
                }
                if(brewing_table.querySelector("[data-xp="+potion+"_xp]") != null)
                {
                    brewing_table.querySelector("[data-xp="+potion+"_xp]").innerHTML = "<span class='font-small color-grey'>" + format_number(total_xp) + " xp</span>";
                }
            }
            
        }
    }

    static _refresh_materials(brewing_table)
    {
        var materials_req_array = brewing_table.getElementsByTagName("item-brewing-table");
        var levels_req_array = brewing_table.getElementsByTagName("item-brewing-table-level");

        for(var i = 0; i < materials_req_array.length; i++)
        {
            var materials_req = materials_req_array[i];
            var item = materials_req.getAttribute("data-materials-item");

            if(Items.getItem(item) >= parseInt(materials_req.innerHTML))
                materials_req_array[i].style.color = "#00a200";
            else
                materials_req_array[i].style.color = "red";
        }

        for(var i = 0; i < levels_req_array.length; i++)
        {
            var levels_req = levels_req_array[i];
            var level_found = parseInt(levels_req.innerHTML);
            if(get_level(Items.getItem("brewing_xp")) >= level_found)
                levels_req.style.color = "green";
            else
                levels_req.style.color = "red";
        }
    }

    static _refresh_timers(brewing_table)
    {
        var brewing_row_array = brewing_table.getElementsByTagName("tr");

        for(var i = 0; i < brewing_row_array.length; i++)
        {
            var potion = brewing_row_array[i].getAttribute('data-brewing-item');
            var brewing_tds_array = brewing_row_array[i].getElementsByTagName("td");


            if(brewing_tds_array.length == 5)
            {
                if(brewing_tds_array[4].innerHTML.includes("Cooldown"))
                {}
                else if(brewing_tds_array[4].innerHTML.includes("Consumable"))
                {}
                else
                    brewing_tds_array[4].innerHTML = Brewing.get_potion_timer(potion, true);
            }
            
        }
    }

    static _refresh_backgrounds(brewing_table)
    {
        // too drunk to change variables names atm, TODO
        var crafting_table = brewing_table;
        var crafting_table_trs = crafting_table.getElementsByTagName("tr");

        for(var i = 0; i < crafting_table_trs.length; i++)
        {
            
            if(!crafting_table_trs[i].hasAttribute("data-brewing-item"))
                continue;

            var materials_req_array = crafting_table_trs[i].getElementsByTagName("item-brewing-table");
            var levels_req_array = crafting_table_trs[i].getElementsByTagName("item-brewing-table-level");

            var can_craft = true;

            for(var j = 0; j < materials_req_array.length; j++)
            {
                var materials_req = materials_req_array[j];
                var item = materials_req.getAttribute("data-materials-item");
    
                if(Items.getItem(item) < parseInt(materials_req.innerHTML))
                    can_craft = false;
            }

            for(var j = 0; j < levels_req_array.length; j++)
            {
                var levels_req = levels_req_array[j];
                var level_found = parseInt(levels_req.innerHTML);
                if(get_level(Items.getItem("brewing_xp")) < level_found)
                    can_craft = false;
            }

            if(can_craft)
            {
                crafting_table_trs[i].style.background = "#e6ffe6";
                crafting_table_trs[i].classList.add("hover")
            }
            else
            {
                crafting_table_trs[i].style.background = "#ffe6e6";
                crafting_table_trs[i].classList.add("hover")
            }
        }
    }

    /**
     *  returns an array [item_name, amount, ...]
     */
    static get_ingredients(potion)
    {
        var array = [];
        var entry = $("tr[data-brewing-item='" + potion +"']");
        var materials = entry.find("item-brewing-table");
        materials.each(function (ele) {
            var amount = $(this).text();
            var material = $(this).attr("data-materials-item");
            array.push(material, amount);
        });

        return array;
    }

    static getBrewingKitToolData()
    {
        if(Items.getItem("diamond_brewing_kit"))
            return ["diamond_brewing_kit", "none", "1.00"];
        
        if(Items.getItem("ruby_brewing_kit"))
            return ["ruby_brewing_kit", "diamond", "0.75"];
        
        if(Items.getItem("emerald_brewing_kit"))
            return ["emerald_brewing_kit", "ruby", "0.50"];
    
        if(Items.getItem("sapphire_brewing_kit"))
            return ["sapphire_brewing_kit", "emerald", "0.25"];

        if(Items.getItem("brewing_kit"))
            return ["brewing_kit", "sapphire", "0.0"];

        return ["none", "none", ""];
    }

    static quick_drink_heat_potion()
    {
        if(Items.getItem("heat_potion_timer") > 0)
        {
            Animations.scrollText("images/x.png", "red", "Already Active");
            return;
        }

        if(Items.getItem("heat_potion") > 0)
        {
            websocket.send('DRINK=heat_potion');
            Animations.scrollText("images/heat_potion.png", "purple", "Active");
        }
    }

}