class CToe
{
    
    static call_timer = 0;
    static chartLabels = [
        "14 Days ago",
        "13 Days ago",
        "12 Days ago",
        "11 Days ago",
        "10 Days ago",
        "9 Days ago",
        "8 Days ago",
        "7 Days ago",
        "6 Days ago",
        "5 Days ago",
        "4 Days ago",
        "3 Days ago",
        "2 Days ago",
        "Yesterday",
        "Today",
    ]
    static refresh_panel() {
        CToe.fetch_chart_data();
    }


    static perk_descriptions = {
        "criptoe_research_dwarf_1": "Chisels will now gather large stone geodes.",
        "criptoe_research_dwarf_2": "You will now gain 50,000 mining XP when finding any geode.",
        "criptoe_research_dwarf_3": "Double mineral chance from all geodes.",
        "criptoe_research_dwarf_4": "+25% chance of gaining a charcoal for every log when using foundry.",
        "criptoe_research_dwarf_5": "Plasma from the rocket is doubled.",

        "criptoe_research_nature_1": "Axe will chop an addition +5 logs before applying multipliers.",
        "criptoe_research_nature_2": "Harvesting farming leaves now yields +2 leaves before applying multiplers.",
        "criptoe_research_nature_3": "Watering can now holds 500 charges.",
        "criptoe_research_nature_4": "Doubles the seeds obtained from chopping trees.",
        "criptoe_research_nature_5": "Mega seeds have double yield.",

        "criptoe_research_chemist_1": "Potion timers increased by 25%.",
        "criptoe_research_chemist_2": "Furnace speed potion now smelts at 1000x speed.",
        "criptoe_research_chemist_3": "Ability to set a potion to be auto-drinked when timer hits 0 until you run out.",
        "criptoe_research_chemist_4": "Drinking a dust potion refunds 1-5 dust.",
        "criptoe_research_chemist_5": "Guardian potions will always give double guardian keys when triggered.",

        "criptoe_research_sea_1": "All fishing tools give 10% more XP.",
        "criptoe_research_sea_2": "10% chance to get a second chest when solving any map.",
        "criptoe_research_sea_3": "If you catch a shiny/mega fish, you'll get a second one - including the fishing XP.",
        "criptoe_research_sea_4": "Ability to send all boats at once.",
        "criptoe_research_sea_5": "Cannon may now be set to autofire.<br /><br /><i>Click on your cannon to manage this.</i>",
    }

 
    
    static loadCards(raw) {
        document.getElementById("tcg-area-context").innerHTML = "";
        if(raw == "NONE") return;
        var dataArray = raw.split("~")
        var html = "";
        for(var i = 0; i < dataArray.length; i+=0) {
            var id = dataArray[i]; i++;
            var var_name = dataArray[i]; i++;
            var holo = dataArray[i] == 'true'; i++;

            html += CardData.getCardHTML(id, var_name, holo);
        }
        document.getElementById("tcg-area-context").innerHTML = html
    }

    static has_criptoe_perk(type, researcher_points) {
        if(Items.getItem("criptoe_path_perm_" + type) == 1 && Items.getItem("researcher_points") >= researcher_points)
            return true;

        if(Items.getItemString('criptoe_path_selected') == type) {
            if(Items.getItem("researcher_points") >= researcher_points)
                return true;
        }
        return false;
    }
    
    static refresh_researcher_table() {

        var greenbg = "#d3ffce"
        var testingForId = 0;

        testingForId = 1;
        if(Items.getItem("researcher_points") >= 1000000) {
            var labelElement = document.getElementById("table-criptoe-research-tree-amount-req-label-" + testingForId);
            labelElement.style.color = "green";
            var tds = document.getElementById("table-criptoe-research-tree-amount-req-row-" + testingForId).getElementsByTagName("td");
            for(var i = 0; i < tds.length; i++) {
                tds[i].style.backgroundColor = greenbg;
            }
        }

        testingForId = 2;
        if(Items.getItem("researcher_points") >= 10000000) {
            var labelElement = document.getElementById("table-criptoe-research-tree-amount-req-label-" + testingForId);
            labelElement.style.color = "green";
            var tds = document.getElementById("table-criptoe-research-tree-amount-req-row-" + testingForId).getElementsByTagName("td");
            for(var i = 0; i < tds.length; i++) {
                tds[i].style.backgroundColor = greenbg;
            }
        }

        testingForId = 3;
        if(Items.getItem("researcher_points") >= 50000000) {
            var labelElement = document.getElementById("table-criptoe-research-tree-amount-req-label-" + testingForId);
            labelElement.style.color = "green";
            var tds = document.getElementById("table-criptoe-research-tree-amount-req-row-" + testingForId).getElementsByTagName("td");
            for(var i = 0; i < tds.length; i++) {
                tds[i].style.backgroundColor = greenbg;
            }
        }

        testingForId = 4;
        if(Items.getItem("researcher_points") >= 200000000) {
            var labelElement = document.getElementById("table-criptoe-research-tree-amount-req-label-" + testingForId);
            labelElement.style.color = "green";
            var tds = document.getElementById("table-criptoe-research-tree-amount-req-row-" + testingForId).getElementsByTagName("td");
            for(var i = 0; i < tds.length; i++) {
                tds[i].style.backgroundColor = greenbg;
            }
        }

        testingForId = 5;
        if(Items.getItem("researcher_points") >= 500000000) {
            var labelElement = document.getElementById("table-criptoe-research-tree-amount-req-label-" + testingForId);
            labelElement.style.color = "green";
            var tds = document.getElementById("table-criptoe-research-tree-amount-req-row-" + testingForId).getElementsByTagName("td");
            for(var i = 0; i < tds.length; i++) {
                tds[i].style.backgroundColor = greenbg;
            }
        }
    }

    static fetch_chart_data() {
        if(CToe.call_timer > 0) return;
        
        CToe.call_timer = 60;

        var wallet1 = []
        var wallet2 = []
        var wallet3 = []
        var wallet4 = []
        $.get("../../criptoe/").done(function(data) {
            var json = data['data']
            for(var i = 0; i < json.length; i++) {
                var wallet = json[i]['wallet'];
                switch(wallet) {
                    case 1:
                        wallet1.push(json[i]['percentage'])
                    break;
                    case 2:
                        wallet2.push(json[i]['percentage'])
                    break;
                    case 3:
                        wallet3.push(json[i]['percentage'])
                    break;
                    case 4:
                        wallet4.push(json[i]['percentage'])
                    break;
                }
            }

            CToe.refresh_chart(1, wallet1)
            CToe.refresh_chart(2, wallet2)
            CToe.refresh_chart(3, wallet3)
            CToe.refresh_chart(4, wallet4)

            var isSunday = new Date().getUTCDay() == 0;
        
            if(isSunday) {
                document.getElementById('criptoe-wallet-1-percentage').innerHTML = "N/A on Sundays";
                document.getElementById('criptoe-wallet-1-percentage').style.color = 'yellow';
            } else {
                var percentage1 = wallet1[wallet1.length - 1];
                document.getElementById('criptoe-wallet-1-percentage').innerHTML = percentage1 + " %";
                if(percentage1 >= 0) document.getElementById('criptoe-wallet-1-percentage').style.color = 'lime';
                else document.getElementById('criptoe-wallet-1-percentage').style.color = 'red';
            }
            
            if(isSunday) {
                document.getElementById('criptoe-wallet-2-percentage').innerHTML = "N/A on Sundays";
                document.getElementById('criptoe-wallet-2-percentage').style.color = 'yellow';
            } else {
                var percentage2 = wallet2[wallet2.length - 1];
                document.getElementById('criptoe-wallet-2-percentage').innerHTML = percentage2 + " %";
                if(percentage2 >= 0) document.getElementById('criptoe-wallet-2-percentage').style.color = 'lime';
                else document.getElementById('criptoe-wallet-2-percentage').style.color = 'red';
            }
            
            if(isSunday) {
                document.getElementById('criptoe-wallet-3-percentage').innerHTML = "N/A on Sundays";
                document.getElementById('criptoe-wallet-3-percentage').style.color = 'yellow';
            } else {
                var percentage3 = wallet3[wallet3.length - 1];
                document.getElementById('criptoe-wallet-3-percentage').innerHTML = percentage3 + " %";
                if(percentage3 >= 0) document.getElementById('criptoe-wallet-3-percentage').style.color = 'lime';
                else document.getElementById('criptoe-wallet-3-percentage').style.color = 'red';
            }
           

            if(isSunday) {
                document.getElementById('criptoe-wallet-4-percentage').innerHTML = "N/A on Sundays";
                document.getElementById('criptoe-wallet-4-percentage').style.color = 'yellow';
            } else {
                var percentage4 = wallet4[wallet4.length - 1];
                document.getElementById('criptoe-wallet-4-percentage').innerHTML = percentage4 + " %";
                if(percentage4 >= 0) document.getElementById('criptoe-wallet-4-percentage').style.color = 'lime';
                else document.getElementById('criptoe-wallet-4-percentage').style.color = 'red';
            }
            

            var serverValue = 0;
            if(data['wallet1_server_invested'] == null) serverValue = 0;
            else serverValue = format_number(data['wallet1_server_invested'])
            document.getElementById("wallet1-invested-total-server").innerHTML = serverValue;
            
            if(data['wallet1_server_withdrawal'] == null) serverValue = 0;
            else serverValue = format_number(data['wallet1_server_withdrawal'])
            document.getElementById("wallet1-withdrawal-total-server").innerHTML = serverValue;

            if(data['wallet2_server_invested'] == null) serverValue = 0;
            else serverValue = format_number(data['wallet2_server_invested'])
            document.getElementById("wallet2-invested-total-server").innerHTML = serverValue;
            
            if(data['wallet2_server_withdrawal'] == null) serverValue = 0;
            else serverValue = format_number(data['wallet2_server_withdrawal'])
            document.getElementById("wallet2-withdrawal-total-server").innerHTML = serverValue;

            if(data['wallet3_server_invested'] == null) serverValue = 0;
            else serverValue = format_number(data['wallet3_server_invested'])
            document.getElementById("wallet3-invested-total-server").innerHTML = serverValue;
            
            if(data['wallet3_server_withdrawal'] == null) serverValue = 0;
            else serverValue = format_number(data['wallet3_server_withdrawal'])
            document.getElementById("wallet3-withdrawal-total-server").innerHTML = serverValue;

            if(data['wallet4_server_invested'] == null) serverValue = 0;
            else serverValue = format_number(data['wallet4_server_invested'])
            document.getElementById("wallet4-invested-total-server").innerHTML = serverValue;
            
            if(data['wallet4_server_withdrawal'] == null) serverValue = 0;
            else serverValue = format_number(data['wallet4_server_withdrawal'])
            document.getElementById("wallet4-withdrawal-total-server").innerHTML = serverValue;
        });
    }



    static refresh_chart(wallet, values) {
        var options = {
            chart: {
              foreColor: '#ffffff',
              type: 'line',
              height: '250px',
              toolbar: {
                show: false,
              }          
            },          
            dropShadow: {
                enabled: true,
                top: 1,
                left: 1,
                blur: 2,
                opacity: 0.2,
            },
            series: [{
              name: '%',
              data: values
            }],
            xaxis: {
              categories: CToe.chartLabels
            },
            zoom: {
                enabled: false,
            },
            yaxis: {
                title: {
                    text: 'Percentage',
                    rotate: -90,
                    offsetX: 0,
                    offsetY: 0,
                    style: {
                        fontSize: '12px',
                        fontFamily: 'Helvetica, Arial, sans-serif',
                        fontWeight: 600,
                        cssClass: 'apexcharts-yaxis-title',
                    },
                },
            }
          }
          var chart = document.getElementById("chart-" + wallet);
          new ApexCharts(chart, options).render()
    }
}

