class Chat
{
    static _auto_scroll = true;

    static increase_chat_size(increase)
    {
        var current_height = document.getElementById("chat-area").style.height;
        current_height = current_height.slice(0, -2);

        if(increase)
            current_height = parseInt(current_height) + 100;
        else
            current_height = parseInt(current_height) - 100;

        document.getElementById("chat-area").style.height = current_height + "px";
    }
    static yell_to_chat_box(data)
    {
        var data_array = data.split("~");
        var tag = "Server message";
        var tag_css_class = tag.toLowerCase().replaceAll(" ", "_");
        var sigil_image = "none";
        var usernameSource = data_array[0];
        var message = data_array[1];

        if(Items.getItem("team_chat_on") == 1 && usernameSource != "none") {
            var teamUsernames = Items.getItem("team_usernames").split(",");
            var found = false;
            for(var i = 0; i < teamUsernames.length; i++) {
                
                if(teamUsernames[i] == usernameSource) {
                    found = true;
                    break;
                }
            }

            if(!found) 
                return;
        }

        var html = "";
        html += "<span class='color-green'>"+Chat._get_time()+"</span>";
        if(sigil_image != "none") html += " <img src='https://cdn.idle-pixel.com/images/"+sigil_image+".png' /> ";
        if(tag != "none") html += "<span class='"+tag_css_class+" shadow'>" + tag + "</span> ";
        html += sanitize_input(message);

        $("#chat-area").append("<div style='color:blue'>" + html + "</div>")

        if(Chat._auto_scroll)
            $("#chat-area").scrollTop($("#chat-area")[0].scrollHeight)
    }


    
    static refresh_friends_list(values)
    {
        if(values == "none")
            return;
    
        
        var dataArray = values.split("~")
        var html = "";
    
       

        var firstGoAround = true;
        for(var i = 0; i < dataArray.length; i+=0)
        {
            var id = dataArray[i]; i++;
            var username = dataArray[i]; i++;
            var is_hardcore = dataArray[i]; i++;
            var is_onelife_hardcore = dataArray[i]; i++;
            var is_team = dataArray[i]; i++;

            var global_level = dataArray[i]; i++;
            var global_xp = dataArray[i]; i++;

            var mining_xp = dataArray[i]; i++;
            var crafting_xp = dataArray[i]; i++;
            var gathering_xp = dataArray[i]; i++;
            var farming_xp = dataArray[i]; i++;
            var brewing_xp = dataArray[i]; i++;
            var woodcutting_xp = dataArray[i]; i++;
            var cooking_xp = dataArray[i]; i++;
            var fishing_xp = dataArray[i]; i++;
            var invention_xp = dataArray[i]; i++;
            var melee_xp = dataArray[i]; i++;
            var archery_xp = dataArray[i]; i++;
            var magic_xp = dataArray[i]; i++;

            var trophies = dataArray[i]; i++;
            var criptoe = dataArray[i]; i++;
            var researchPoints = dataArray[i]; i++;

            var head = dataArray[i]; i++;
            var amulet = dataArray[i]; i++;
            var body = dataArray[i]; i++;
            var legs = dataArray[i]; i++;
            var boots = dataArray[i]; i++;
            var gloves = dataArray[i]; i++;
            var shield = dataArray[i]; i++;
            var weapon = dataArray[i]; i++;

            var is_online = dataArray[i]; i++;


            var account_type = "Normal";
            if(is_hardcore == 1) {
                account_type = "<img class='w15' style='margin-top:-3px;' src='https://cdn.idle-pixel.com/images/hardcore_sigil_chat.png' /> Hardcore "
            } else if (is_onelife_hardcore == 1) {
                account_type = "<img class='w15' style='margin-top:-3px;' src='https://cdn.idle-pixel.com/images/extreme_hardcore_sigil_chat.png' /> Hardcore"
            } else if (is_team == 1) {
                account_type = "<img class='w15' style='margin-top:-3px;' src='https://cdn.idle-pixel.com/images/teams_sigil_chat.png' /> Teams"
            }


             html += '<div class="friends-list-entry">';
                if(is_online == 1) {
                    html +=  "<div class='friends-list-online'>Online</div>";
                }
               
                html += "<h1>"+capitalizeFirstLetter(username)+"</h1>";
                if(firstGoAround)
                html += "<div onclick='alert(\"The best player in your friends list.  Sorted by global level, trophies, and then global xp.\")' class='friends-account-right-tag hover'><img class='w15' style='margin-top:-3px;' src='https://cdn.idle-pixel.com/images/diamond.png' /> LEADER</div>";

                html += "<div class='friends-account-type'><img class='w15' style='margin-top:-3px;' src='https://cdn.idle-pixel.com/images/global_sigil_chat.png' /> <span onmouseenter='Chat.onMouseEnterFriendsGlobalLevel(this)' data-global-level-friends='"+global_level+"' data-global-xp-friends='"+global_xp+"' onmouseleave='Chat.onMouseLeaveFriendsGlobalLevel(this)'>"+global_level+" </div>";
                html += "<div class='friends-account-type'><img class='w15' style='margin-top:-3px;' src='https://cdn.idle-pixel.com/images/trophy_icon.png' /> "+trophies+" </div>";
                html += "<div class='friends-account-type'>"+account_type+"</div>";
                
                html += '<img style="left:-50px;top:-40px;z-index:9;position:absolute;width:200px;height:200px;" src="https://cdn.idle-pixel.com/images/hero_head_'+head+'.png">';
                html += '<img style="left:-50px;top:-40px;z-index:11;position:absolute;width:200px;height:200px;" src="https://cdn.idle-pixel.com/images/hero_body_'+body+'.png">';
                html += '<img style="left:-50px;top:-40px;z-index:11;position:absolute;width:200px;height:200px;" src="https://cdn.idle-pixel.com/images/hero_gloves_'+gloves+'.png">';
                html += '<img style="left:-50px;top:-40px;z-index:12;position:absolute;width:200px;height:200px;" src="https://cdn.idle-pixel.com/images/hero_legs_'+legs+'.png">';
                html += '<img style="left:-50px;top:-40px;z-index:11;position:absolute;width:200px;height:200px;" src="https://cdn.idle-pixel.com/images/hero_boots_'+boots+'.png">';
                html += '<img style="left:-50px;top:-40px;z-index:13;position:absolute;width:200px;height:200px;" src="https://cdn.idle-pixel.com/images/hero_shield_'+shield+'.png">';
                html += '<img style="left:-50px;top:-40px;z-index:14;position:absolute;width:200px;height:200px;" src="https://cdn.idle-pixel.com/images/hero_weapon_'+weapon+'.png">';
                html += '<img style="left:-50px;top:-40px;z-index:15;position:absolute;width:200px;height:200px;" src="https://cdn.idle-pixel.com/images/hero_amulet_'+amulet+'.png">';

                html += "<table width='90%' class='friends-list-entry-table'>";
                    html += "<tr>";
                        html += "<td style='width:50%'>" + "<img class='w30' src='https://cdn.idle-pixel.com/images/mining.png' />" + "<span onmouseenter='Chat.onMouseEnterFriends(this)' onmouseleave='Chat.onMouseLeaveFriends(this)' data-item-value='"+mining_xp+"'  class='friends-table-skill-label'>Level " + get_level(mining_xp); + "</span>" + "</td>"
                        html += "<td style='width:50%'>" + "<img class='w30' src='https://cdn.idle-pixel.com/images/crafting.png' />" + "<span onmouseenter='Chat.onMouseEnterFriends(this)' onmouseleave='Chat.onMouseLeaveFriends(this)' data-item-value='"+crafting_xp+"'  class='friends-table-skill-label'>Level " + get_level(crafting_xp); + "</span>" + "</td>"
                    html += "</tr>";
                    html += "<tr>";
                        html += "<td style='width:50%'>" + "<img class='w30' src='https://cdn.idle-pixel.com/images/gathering.png' />" + "<span onmouseenter='Chat.onMouseEnterFriends(this)' onmouseleave='Chat.onMouseLeaveFriends(this)' data-item-value='"+gathering_xp+"'  class='friends-table-skill-label'>Level " + get_level(gathering_xp); + "</span>" + "</td>"
                        html += "<td style='width:50%'>" + "<img class='w30' src='https://cdn.idle-pixel.com/images/farming.png' />" + "<span onmouseenter='Chat.onMouseEnterFriends(this)' onmouseleave='Chat.onMouseLeaveFriends(this)' data-item-value='"+farming_xp+"'  class='friends-table-skill-label'>Level " + get_level(farming_xp); + "</span>" + "</td>"
                    html += "</tr>";
                    html += "<tr>";
                        html += "<td style='width:50%'>" + "<img class='w30' src='https://cdn.idle-pixel.com/images/brewing.png' />" + "<span onmouseenter='Chat.onMouseEnterFriends(this)' onmouseleave='Chat.onMouseLeaveFriends(this)' data-item-value='"+brewing_xp+"'  class='friends-table-skill-label'>Level " + get_level(brewing_xp); + "</span>" + "</td>"
                        html += "<td style='width:50%'>" + "<img class='w30' src='https://cdn.idle-pixel.com/images/woodcutting.png' />" + "<span onmouseenter='Chat.onMouseEnterFriends(this)' onmouseleave='Chat.onMouseLeaveFriends(this)' data-item-value='"+woodcutting_xp+"'  class='friends-table-skill-label'>Level " + get_level(woodcutting_xp); + "</span>" + "</td>"
                    html += "</tr>";
                    html += "<tr>";
                        html += "<td style='width:50%'>" + "<img class='w30' src='https://cdn.idle-pixel.com/images/cooking.png' />" + "<span onmouseenter='Chat.onMouseEnterFriends(this)' onmouseleave='Chat.onMouseLeaveFriends(this)' data-item-value='"+cooking_xp+"'  class='friends-table-skill-label'>Level " + get_level(cooking_xp); + "</span>" + "</td>"
                        html += "<td style='width:50%'>" + "<img class='w30' src='https://cdn.idle-pixel.com/images/fishing.png' />" + "<span onmouseenter='Chat.onMouseEnterFriends(this)' onmouseleave='Chat.onMouseLeaveFriends(this)' data-item-value='"+fishing_xp+"'  class='friends-table-skill-label'>Level " + get_level(fishing_xp); + "</span>" + "</td>"
                    html += "</tr>";
                    html += "<tr>";
                        html += "<td style='width:50%'>" + "<img class='w30' src='https://cdn.idle-pixel.com/images/invention.png' />" + "<span onmouseenter='Chat.onMouseEnterFriends(this)' onmouseleave='Chat.onMouseLeaveFriends(this)' data-item-value='"+invention_xp+"'  class='friends-table-skill-label'>Level " + get_level(invention_xp); + "</span>" + "</td>"
                        html += "<td style='width:50%'>" + "<img class='w30' src='https://cdn.idle-pixel.com/images/melee.png' />" + "<span onmouseenter='Chat.onMouseEnterFriends(this)' onmouseleave='Chat.onMouseLeaveFriends(this)' data-item-value='"+melee_xp+"'  class='friends-table-skill-label'>Level " + get_level(melee_xp); + "</span>" + "</td>"
                    html += "</tr>";
                    html += "<tr>";
                        html += "<td style='width:50%'>" + "<img class='w30' src='https://cdn.idle-pixel.com/images/archery.png' />" + "<span onmouseenter='Chat.onMouseEnterFriends(this)' onmouseleave='Chat.onMouseLeaveFriends(this)' data-item-value='"+archery_xp+"'  class='friends-table-skill-label'>Level " + get_level(archery_xp); + "</span>" + "</td>"
                        html += "<td style='width:50%'>" + "<img class='w30' src='https://cdn.idle-pixel.com/images/magic.png' />" + "<span onmouseenter='Chat.onMouseEnterFriends(this)' onmouseleave='Chat.onMouseLeaveFriends(this)' data-item-value='"+magic_xp+"'  class='friends-table-skill-label'>Level " + get_level(magic_xp); + "</span>" + "</td>"
                    html += "</tr>";
                    
                html += "</table>";
                if(Items.getItem("player_id") != id)
                html += "<center><i class='hover' onclick='Modals.removeFriend("+id+")' style='font-size:6pt'>REMOVE FRIEND</i></center>"
             html += '</div>';

             firstGoAround = false;
        }

        document.getElementById("panel-friends-data").innerHTML = html;
    }

    static onMouseEnterFriends(ele) {
        var xp = ele.getAttribute('data-item-value');
        ele.innerHTML = format_number(xp) + " XP";
    }
    static onMouseLeaveFriends(ele) {
        var xp = ele.getAttribute('data-item-value');
        ele.innerHTML = "Level " + get_level(xp);
    }

    static onMouseEnterFriendsGlobalLevel(ele) {
       
        var xp = ele.getAttribute('data-global-xp-friends');
        ele.innerHTML = format_number(xp) + " XP";
    }
    static onMouseLeaveFriendsGlobalLevel(ele) {
        var lvl = ele.getAttribute('data-global-level-friends');
        ele.innerHTML = lvl;
    }
    
    

    static add_friend_modal_submit() {
        var value = document.getElementById("modal-add-friend-input").value;
        websocket.send('ADD_FRIEND=' + value); 
    }

    static clicksTogglePrivateTeamChat() {
        websocket.send('TOGGLE_TEAMS_CHAT');
    }

    static refresh_chat_tags()
    {
        if(Items.getItem("donor_tag"))
        {
            document.getElementById('donor_tag_price').innerHTML = "";
            document.getElementById('super_donor_tag_price').innerHTML = "<img src='https://cdn.idle-pixel.com/images/donor_coins.png' /> 10";
            hide_element('donor_tag_button')
            show_element('donor_tag_button_set')
            show_element('super_donor_tag_button')
        }

        
        if(Items.getItem("super_donor_tag"))
        {
            document.getElementById('super_donor_tag_price').innerHTML = "";
            document.getElementById('ultra_donor_tag_price').innerHTML = "<img src='https://cdn.idle-pixel.com/images/donor_coins.png' /> 15";
            hide_element('super_donor_tag_button')
            show_element('super_donor_tag_button_set')
            show_element('ultra_donor_tag_button')
        }

        if(Items.getItem("ultra_donor_tag"))
        {
            document.getElementById('ultra_donor_tag_price').innerHTML = "";
            document.getElementById('contributor_tag_price').innerHTML = "<img src='https://cdn.idle-pixel.com/images/donor_coins.png' /> 25";
            hide_element('ultra_donor_tag_button')
            show_element('ultra_donor_tag_button_set')
            show_element('contributor_tag_button')
        }

        if(Items.getItem("contributor_tag"))
        {
            document.getElementById('contributor_tag_price').innerHTML = "";
            document.getElementById('financier_tag_price').innerHTML = "<img src='https://cdn.idle-pixel.com/images/donor_coins.png' /> 50";
            hide_element('contributor_tag_button')
            show_element('contributor_tag_button_set')
            show_element('financier_tag_button')
        }

        if(Items.getItem("financier_tag"))
        {
            document.getElementById('financier_tag_price').innerHTML = "";
            document.getElementById('investor_tag_price').innerHTML = "<img src='https://cdn.idle-pixel.com/images/donor_coins.png' /> 100";
            hide_element('financier_tag_button')
            show_element('financier_tag_button_set')
            show_element('investor_tag_button')
        }

        if(Items.getItem("investor_tag"))
        {
            document.getElementById('investor_tag_price').innerHTML = "";
            document.getElementById('investor_plus_tag_price').innerHTML = "<img src='https://cdn.idle-pixel.com/images/donor_coins.png' /> 200";
            hide_element('investor_tag_button')
            show_element('investor_tag_button_set')
            show_element('investor_plus_tag_button')
        }

        if(Items.getItem("investor_plus_tag"))
        {
            document.getElementById('investor_plus_tag_price').innerHTML = "";
            hide_element('investor_plus_tag_button')
            show_element('investor_plus_tag_button_set')
        }
       
    }

    static add_to_chat_box(data)
    {
        var data_array = data.split("~");
        var username = data_array[0];
        var sigil_image = data_array[1];
        var tag = data_array[2].slice(0, -4); //removes_tag
        var tag_css_class = tag.toLowerCase().replaceAll(" ", "_");
        var level = data_array[3];
        var message = data_array[4];
        var custom = data_array[5];

        

        if(custom != null) {
            if(isNaN(custom)) return;
            username += " <span class=color-green>("+custom+")</span>";
        }

        var html = "";
        html += "<span class='color-green'>"+Chat._get_time()+"</span>";
        if(sigil_image != "none") html += " <img src='https://cdn.idle-pixel.com/images/"+sigil_image+".png' /> ";
        if(tag != "none")
        {
            if(tag == "investor_plus")
                html += "<img src='https://cdn.idle-pixel.com/images/investor_plus_tag_example.gif' /> ";
            else if(tag == "investor")
                html += "<img src='https://cdn.idle-pixel.com/images/investor_tag_example.gif' /> ";
            else
                html += "<span class='"+tag_css_class+"'>" + capitalizeFirstLetter(get_item_name(tag)) + "</span> ";
        }
        html += "<a target='_blank' class='chat-username' href='https://idle-pixel.com/hiscores/search?username="+username+"'>" + username + "</a>";
        html += "<span class='color-grey'> (" + level + "): </span>";
        html += SearchAnythingData.create_link_for_chat(sanitize_input(message));

        $("#chat-area").append("<div>" + html + "</div>")

        if(Chat._auto_scroll)
            $("#chat-area").scrollTop($("#chat-area")[0].scrollHeight)

        var chat_length = document.getElementById('chat-area').innerHTML.length
        if(chat_length >= 200000)
        {
            var current_html = document.getElementById('chat-area').innerHTML;
            document.getElementById('chat-area').innerHTML = current_html.substring(20000);
        }
    }


    static toggle_auto_scroll()
    {
        Chat._auto_scroll = !Chat._auto_scroll;

        if(Chat._auto_scroll)
            document.getElementById("chat-auto-scroll-button").style.color = "green";
        else
            document.getElementById("chat-auto-scroll-button").style.color = "red";
    }
    //credit goes to lux for this function
    static _get_time()
    {     
            var d = new Date();
            if(d.getHours() < 10) 
            {var dHours = "0" + d.getHours()}
            else 
            {var dHours = d.getHours()}
        
            if(d.getMinutes() < 10)
            {var dMinutes = "0" + d.getMinutes()}
            else
            {var dMinutes = d.getMinutes()}
                
            var da = "[" + dHours + ":" + dMinutes + "] ";
            
            return da;
    }

    static send()
    {
        var message = document.getElementById("chat-area-input").value.replace(/~/g, '⁓');
        if(message.length == 0)
            return;

        message = message.substring(0, 255);
        websocket.send("CHAT=" + message);
        document.getElementById("chat-area-input").value = "";

    }

    static enter(event)
    {
        if(event.keyCode == 13)
        {
            Chat.send();
        }
    }

}

