class Combat
{

  static EQUIPMENT_STATS = {
    'wooden_sword': {
      'slot': 'weapon',
      'melee_level': 1,
      'melee_damage': 1,
      'speed': 3,
    },
    'stinger': {
      'slot': 'weapon',
      'melee_level': 5,
      'melee_damage': 2,
      'speed': 3,
    },
    'poison_stinger': {
      'slot': 'weapon',
      'melee_level': 5,
      'melee_damage': 2,
      'speed': 3,
    },
    'iron_dagger': {
      'slot': 'weapon',
      'melee_level': 10,
      'melee_damage': 2,
      'speed': 4,
    },
    'skeleton_sword': {
      'slot': 'weapon',
      'melee_level': 20,
      'melee_damage': 5,
      'accuracy': 1,
      'speed': 3,
    },
    'club': {
      'slot': 'weapon',
      'melee_level': 30,
      'melee_damage': 12,
      'accuracy': 4,
      'speed': 1,
    },
    'spiked_club': {
      'slot': 'weapon',
      'melee_level': 30,
      'melee_damage': 12,
      'accuracy': 4,
      'speed': 1,
    },
    'dense_club': {
      'slot': 'weapon',
      'melee_level': 80,
      'melee_damage': 20,
      'accuracy': 7,
      'speed': 1,
    },
    'spiked_dense_club': {
      'slot': 'weapon',
      'melee_level': 30,
      'melee_damage': 30,
      'accuracy': 7,
      'speed': 1,
    },
    'scythe': {
      'slot': 'weapon',
      'melee_level': 40,
      'melee_damage': 8,
      'accuracy': 4,
      'speed': 3,
    },
    'double_scythe': {
      'slot': 'weapon',
      'melee_level': 100,
      'melee_damage': 8,
      'accuracy': 4,
      'speed': 3,
    },
    'rapier': {
      'slot': 'weapon',
      'melee_level': 90,
      'melee_damage': 12,
      'accuracy': 7,
      'speed': 3,
    },
    'poison_rapier': {
      'slot': 'weapon',
      'melee_level': 90,
      'melee_damage': 12,
      'accuracy': 7,
      'speed': 3,
    },
    'gold_rapier': {
      'slot': 'weapon',
      'melee_level': 90,
      'melee_damage': 12,
      'accuracy': 7,
      'speed': 4,
    },
    'degradable_gold_rapier': {
      'slot': 'weapon',
      'melee_level': 90,
      'melee_damage': 12,
      'accuracy': 7,
      'speed': 4,
    },
    'poison_gold_rapier': {
      'slot': 'weapon',
      'melee_level': 90,
      'melee_damage': 12,
      'accuracy': 7,
      'speed': 4,
    },
    'stinger_dagger': {
      'slot': 'weapon',
      'melee_level': 60,
      'melee_damage': 2,
      'accuracy': 4,
      'speed': 3,
    },
    'long_spear': {
      'slot': 'weapon',
      'melee_level': 70,
      'melee_damage': 6,
      'accuracy': 3,
      'speed': 3,
    },
    'trident': {
      'slot': 'weapon',
      'melee_level': 70,
      'melee_damage': 7,
      'accuracy': 4,
      'speed': 3,
    },
    'long_trident': {
      'slot': 'weapon',
      'melee_level': 70,
      'melee_damage': 7,
      'accuracy': 4,
      'speed': 3,
    },
    'poison_stinger_dagger': {
      'slot': 'weapon',
      'melee_level': 60,
      'melee_damage': 2,
      'accuracy': 4,
      'speed': 3,
    },
    'battle_axe': {
      'slot': 'weapon',
      'melee_level': 65,
      'melee_damage': 7,
      'accuracy': 4,
      'speed': 1,
    },
    'magnet_shield': {
      'slot': 'shield',
    },
    'lantern': {
      'slot': 'shield',
    },
    'flippers': {
      'slot': 'boots',
    },
    'goblin_mask': {
      'slot': 'head',
    },
    'blood_goblin_mask': {
      'slot': 'head',
    },
    'thiefs_mask': {
      'slot': 'head',
    },
    'skeleton_shield': {
      'slot': 'shield',
      'defence': 4,
    },
    'dragon_shield': {
      'slot': 'shield',
      'defence': 8,
    },
    'iron_defender': {
      'slot': 'shield',
      'accuracy': 1,
    },
    'skeleton_defender': {
      'slot': 'shield',
      'accuracy': 2,
    },
    'bone_amulet': {
      'slot': 'amulet',
    },
    'ashes_amulet': {
      'slot': 'amulet',
    },
    'ice_amulet': {
      'slot': 'amulet',
    },
    'blood_amulet': {
      'slot': 'amulet',
    },
    'amulet_of_healing_rain': {
      'slot': 'amulet',
    },
    'wooden_bow': {
      'slot': 'weapon',
      'archery_level': 1,
      'accuracy': 1,
      'speed': 3,
    },
    'long_bow': {
      'slot': 'weapon',
      'archery_level': 25,
      'accuracy': 3,
      'speed': 3,
    },
    'toy_slingshot': {
      'slot': 'weapon',
      'archery_level': 25,
      'accuracy': 3,
      'speed': 3,
    },
    'haunted_bow': {
      'slot': 'weapon',
      'archery_level': 40,
      'accuracy': 4,
      'speed': 3,
    },
    'balista': {
      'slot': 'weapon',
      'archery_level': 80,
      'accuracy': 7,
      'speed': 1,
    },
    
    'wooden_arrows': {
      'slot': 'arrows',
      'arrow_damage': 2,
    },
    'fire_arrows': {
      'slot': 'arrows',
      'arrow_damage': 5,
    },
    'ice_arrows': {
      'slot': 'arrows',
      'arrow_damage': 7,
    },
    'ancient_arrows': {
      'slot': 'arrows',
      'arrow_damage': 12,
    },

    'wooden_staff': {
      'slot': 'weapon',
      'magic_level': 1,
      'melee_damage': 1,
      'magic_bonus': 1,
      'speed': 2,
    },
    'reaper_hood': {
      'slot': 'head',
      'magic_bonus': 1,
    },
    'reaper_body': {
      'slot': 'body',
      'magic_bonus': 1,
    },
    'reaper_skirt': {
      'slot': 'legs',
      'magic_bonus': 1,
    },
    'reaper_boots': {
      'slot': 'boots',
      'magic_bonus': 1,
    },
    'reaper_gloves': {
      'slot': 'gloves',
      'magic_bonus': 1,
    },
    'reaper_super_hood': {
      'slot': 'head',
      'magic_bonus': 2,
    },
    'reaper_super_body': {
      'slot': 'body',
      'magic_bonus': 2,
    },
    'reaper_super_skirt': {
      'slot': 'legs',
      'magic_bonus': 2,
    },
    'reaper_super_boots': {
      'slot': 'boots',
      'magic_bonus': 2,
    },
    'reaper_super_gloves': {
      'slot': 'gloves',
      'magic_bonus': 2,
    },
    'undead_staff': {
      'slot': 'weapon',
      'magic_level': 80,
      'melee_damage': 1,
      'magic_bonus': 5,
      'speed': 2,
    },
    'undead_hp_staff': {
      'slot': 'weapon',
      'magic_level': 85,
      'melee_damage': 1,
      'magic_bonus': 5,
      'speed': 2,
    },
    'undead_mana_staff': {
      'slot': 'weapon',
      'magic_level': 85,
      'melee_damage': 1,
      'magic_bonus': 5,
      'speed': 2,
    },
    'undead_defence_staff': {
      'slot': 'weapon',
      'magic_level': 85,
      'melee_damage': 1,
      'magic_bonus': 5,
      'speed': 2,
    },
    'undead_full_staff': {
      'slot': 'weapon',
      'magic_level': 90,
      'melee_damage': 1,
      'magic_bonus': 5,
      'speed': 2,
    },

    'lizard_mask': {
      'slot': 'head',
      'defence': 2,
    },
    'lizard_body': {
      'slot': 'body',
      'defence': 3,
    },
    'lizard_legs': {
      'slot': 'legs',
      'defence': 2,
    },
    'lizard_gloves': {
      'slot': 'gloves',
      'defence': 1,
    },
    'lizard_boots': {
      'slot': 'boots',
      'defence': 1,
    },
    'bat_mask': {
      'slot': 'head',
      'defence': 3,
    },
    'bat_body': {
      'slot': 'body',
      'defence': 4,
    },
    'bat_legs': {
      'slot': 'legs',
      'defence': 4,
    },
    'bat_gloves': {
      'slot': 'gloves',
      'defence': 2,
    },
    'bat_boots': {
      'slot': 'boots',
      'defence': 2,
    },
    
    'bear_mask': {
      'slot': 'head',
    },
    'bear_body': {
      'slot': 'body',
    },
    'bear_legs': {
      'slot': 'legs',
    },
    'bear_gloves': {
      'slot': 'gloves',
    },
    'bear_boots': {
      'slot': 'boots',
    },

    'moonstone_mask': {
      'slot': 'head',
      'defence': 5,
    },
    'moonstone_body': {
      'slot': 'body',
      'defence': 6,
    },
    'moonstone_legs': {
      'slot': 'legs',
      'defence': 5,
    },
    'moonstone_gloves': {
      'slot': 'gloves',
      'defence': 4,
    },
    'moonstone_boots': {
      'slot': 'boots',
      'defence': 4,
    },
    'crocodile_mask': {
      'slot': 'head',
      'defence': 6,
    },
    'crocodile_body': {
      'slot': 'body',
      'defence': 7,
    },
    'crocodile_legs': {
      'slot': 'legs',
      'defence': 6,
    },
    'crocodile_gloves': {
      'slot': 'gloves',
      'defence': 5,
    },
    'crocodile_boots': {
      'slot': 'boots',
      'defence': 5,
    },
    'frozen_crocodile_mask': {
      'slot': 'head',
      'defence': 6,
    },
    'frozen_crocodile_body': {
      'slot': 'body',
      'defence': 7,
    },
    'frozen_crocodile_legs': {
      'slot': 'legs',
      'defence': 6,
    },
    'frozen_crocodile_gloves': {
      'slot': 'gloves',
      'defence': 5,
    },
    'frozen_crocodile_boots': {
      'slot': 'boots',
      'defence': 5,
    },
    'sea_helmet': {
      'slot': 'head',
      'defence': 10,
    },
    'gold_helmet': {
      'slot': 'head',
      'defence': 6,
    },
    'gold_body': {
      'slot': 'body',
      'defence': 7,
    },
    'gold_legs': {
      'slot': 'legs',
      'defence': 6,
    },
    'gold_gloves': {
      'slot': 'gloves',
      'defence': 5,
    },
    'gold_boots': {
      'slot': 'boots',
      'defence': 5,
    },
    'dragon_helmet': {
      'slot': 'head',
      'defence': 10,
    },
    'dragon_body': {
      'slot': 'body',
      'defence': 15,
    },
    'dragon_legs': {
      'slot': 'legs',
      'defence': 11,
    },
    'dragon_gloves': {
      'slot': 'gloves',
      'defence': 8,
    },
    'dragon_boots': {
      'slot': 'boots',
      'defence': 8,
    },
    'oxygen_mask': {
      'slot': 'heads',
      'defence': 4,
    },
    'oxygen_tank': {
      'slot': 'shield',
      'defence': 5,
    },
  }

  static modal_area_last_selected = "field";
  static modal_blood_area_last_selected = "blood_field";

  static clicks_new_interface_area(area, isBlood) {

    if(isBlood) {
      Combat.modal_blood_area_last_selected = area;
    } else {
      Combat.modal_area_last_selected = area;
    }
    Modals.open_fight_areas_dialogue();
  }

  static refresh_hero_sprite()
  {
      var weapon = Items.getItemString("weapon");
      var shield = Items.getItemString("shield");
      var head = Items.getItemString("head");
      var amulet = Items.getItemString("amulet");
      var body = Items.getItemString("body");
      var legs = Items.getItemString("legs");
      var gloves = Items.getItemString("gloves");
      var boots = Items.getItemString("boots");

      set_image_src("hero_idle_head", "images/hero_head_" + head + ".png");
      set_image_src("hero_idle_amulet", "images/hero_amulet_" + amulet + ".png");
      set_image_src("hero_idle_body", "images/hero_body_" + body + ".png");
      set_image_src("hero_idle_gloves", "images/hero_gloves_" + gloves + ".png");
      set_image_src("hero_idle_legs", "images/hero_legs_" + legs + ".png");
      set_image_src("hero_idle_boots", "images/hero_boots_" + boots + ".png");
      set_image_src("hero_idle_weapon", "images/hero_weapon_" + weapon + ".png");
      set_image_src("hero_idle_shield", "images/hero_shield_" + shield + ".png");
  }

  static refresh_label_faradox_catle_blood_kills() {
    var id = 'faradox-castle-blood-monster-kills';
    var amount = Combat.number_of_blood_monsters_killed();
    var total = 18;

    if(amount >= 14) {
      document.getElementById(id).innerHTML = "<span class='color-green'>("+amount+"/14)</span>";
      document.getElementById('faradox-castle-blood-monster-kills-checkmark').src = 'https://cdn.idle-pixel.com/images/check.png';
    }
    else {
      document.getElementById(id).innerHTML = "<span class='color-red'>("+amount+"/14)</span>";
      document.getElementById('faradox-castle-blood-monster-kills-checkmark').src = 'https://cdn.idle-pixel.com/images/x.png';
    }
  }

  static get_monster_drops(monster_name) {
    switch(monster_name) {
      case "chicken":
        return ['bones', 'raw_chicken', 'feathers', 'dotted_green_leaf', 'green_leaf', 'lime_leaf', 'chicken_sigil'];
      case "rat":
        return ['bones', 'cheese', 'dotted_green_leaf', 'green_leaf', 'lime_leaf', 'gold_leaf', 'rat_sigil'];
      case "spider":
        return ['string', 'dotted_green_leaf', 'green_leaf', 'lime_leaf', 'gold_leaf', 'spider_fields_sigil'];
      case "bee":
        return ['honey', 'stinger', 'bee_sigil'];
      case "lizard":
        return ['bones', 'lizard_skin', 'lizard_mask', 'lizard_body', 'lizard_legs', 'lizard_gloves', 'lizard_boots', 'lizard_sigil'];
      case "snake":
        return ['dotted_green_leaf_seeds', 'poison', 'green_leaf_seeds', 'lime_leaf_seeds', 'gold_leaf_seeds', 'snake_sigil'];
      case "ants":
        return ['ant_needles', 'dotted_green_leaf_seeds', 'green_leaf_seeds', 'lime_leaf_seeds', 'gold_leaf_seeds', 'ants_sigil'];
      case "wolf":
        return ['bones', 'raw_meat', 'max_heart_1', 'dotted_green_leaf_seeds', 'green_leaf_seeds', 'lime_leaf_seeds', 'gold_leaf_seeds', 'wolf_sigil'];  
      case "thief":
        return ['bones', 'coins', 'iron_dagger', 'dotted_green_leaf_seeds', 'green_leaf_seeds', 'lime_leaf_seeds', 'gold_leaf_seeds', 'thief_sigil'];  
      case "forest_ent":
        return ['strange_leaf', 'logs', 'strange_leaf_fertilizer', 'oak_logs', 'willow_logs', 'maple_logs', 'tree_seeds', 'oak_tree_seeds', 'willow_tree_seeds', 'maple_tree_seeds', 'forest_ent_sigil'];  
      case "bear":
        return ['bones', 'bear_fur', 'train_cart_piece_1', 'bear_mask', 'bear_body', 'bear_legs', 'bear_gloves', 'bear_boots', 'bear_sigil'];  
      case "goblin":
        return ['bones', 'lantern', 'train_cart_piece_2', 'goblin_mask', 'stone', 'copper', 'iron', 'silver', 'gold', 'goblin_sigil'];  
      case "bat":
        return ['bones', 'bat_skin', 'train_cart_piece_3', 'bat_mask', 'bat_body', 'bat_legs', 'bat_legs', 'bat_gloves', 'bat_boots', 'bat_caves_sigil'];  
      case "skeleton":
        return ['bones', 'skeleton_sword', 'skeleton_shield', 'train_cart_piece_4', 'skull', 'bone_amulet', 'promethium', 'skeleton_sigil'];  
      case "fire_hawk":
        return ['ashes', 'fire_feathers', 'raw_bird_meat', 'fire_hawk_sigil'];  
      case "fire_snake":
        return ['ashes', 'fire_spellscroll', 'fire_snake_sigil'];  
      case "fire_golem":
        return ['ashes', 'bomb', 'fire_golem_sigil'];  
      case "fire_witch":
        return ['ashes', 'string', 'fire_crystal', 'max_heart_2', 'fire_witch_sigil'];  
      case "ice_hawk":
        return ['ice_bones', 'ice_feathers', 'raw_bird_meat', 'pine_logs', 'pine_tree_seeds', 'ice_hawk_sigil'];  
      case "ice_golem":
        return ['ice_bones', 'wooden_arrows', 'fire_arrows', 'ice_arrows', 'pine_logs', 'long_bow_frame', 'pine_tree_seeds', 'ancient_arrows', 'ice_golem_sigil'];  
      case "ice_witch":
        return ['ice_bones', 'string', 'pine_logs', 'max_heart_3', 'max_mana_2', 'pine_tree_seeds', 'ice_witch_sigil'];  
      case "yeti":
        return ['ice_bones', 'pine_logs', 'ice_crystal', 'pine_tree_seeds', 'club', 'yeti_sigil'];  
      case "ghost":
        return ['ghost_essence', 'green_gaurdian_key', 'ghost_hm_sigil'];  
      case "grandma":
        return ['ghost_essence', 'heal_upgrade_spellscroll', 'green_gaurdian_key', 'grandma_sigil'];  
      case "exorcist":
        return ['ghost_essence', 'oxygen_mask', 'oxygen_tank', 'green_gaurdian_key', 'exorcist_sigil'];  
      case "reaper":
        return ['ghost_essence', 'green_gaurdian_key', 'scythe', 'reaper_hood', 'reaper_body', 'reaper_skirt', 'reaper_boots', 'reaper_gloves', 'reaper_sigil'];  
      case "shark":
        return ['bones', 'seaweed', 'super_bait', 'raw_bloated_shark', 'flippers', 'shark_tooth', 'shark_tooth', 'bait', 'mega_bait', 'crystal_leaf', 'guardians_tear', 'shark_sigil'];
      case "sea_soldier":
        return ['bones', 'seaweed', 'super_bait', 'flippers', 'trident', 'sea_helmet', 'mega_bait', 'crystal_leaf', 'guardians_tear', 'sea_soldier_sigil'];  
      case "puffer_fish":
        return ['bones', 'puffer_needles', 'seaweed', 'super_bait', 'flippers', 'mega_bait', 'crystal_leaf', 'guardians_tear', 'puffer_fish_sigil'];  
      case "saltwater_crocodile":
        return ['big_bones', 'seaweed', 'crocodile_hide', 'super_bait', 'flippers', 'crocodile_mask', 'crocodile_body', 'crocodile_legs', 'crocodile_gloves', 'crocodile_boots', 'mega_bait', 'crystal_leaf', 'guardians_tear', 'saltwater_crocodile_sigil'];

      // blood
      case "blood_chicken":
        return ['blood_chicken_foot', 'blood_bones', 'raw_chicken', 'feathers', 'field_tablette_1', 'dotted_green_leaf', 'egg', 'green_leaf', 'lime_leaf', 'gold_leaf', 'chicken_sigil', 'dragon_shield_left_half', 'dragon_shield_right_half', 'blood_moon_sigil'];  
      case "blood_rat":
        return ['blood_rat_tail', 'blood_bones', 'cheese', 'field_tablette_2', 'dotted_green_leaf', 'green_leaf', 'lime_leaf', 'gold_leaf', 'rat_sigil', 'dragon_shield_left_half', 'dragon_shield_right_half', 'blood_moon_sigil'];  
      case "blood_spider":
        return ['blood_spider_legs', 'string', 'dotted_green_leaf', 'field_tablette_3', 'green_leaf', 'lime_leaf', 'gold_leaf', 'spider_fields_sigil', 'dragon_shield_left_half', 'dragon_shield_right_half', 'blood_moon_sigil'];  
      case "blood_bee":
        return ['blood_bee_wings', 'stinger', 'field_tablette_4', 'bee_sigil', 'dragon_shield_left_half', 'dragon_shield_right_half', 'blood_moon_sigil'];  
      case "blood_lizard":
        return ['blood_lizard_head', 'blood_bones', 'lizard_skin', 'field_tablette_5', 'lizard_mask', 'lizard_body', 'lizard_legs', 'lizard_gloves', 'lizard_boots', 'lizard_sigil', 'dragon_shield_left_half', 'dragon_shield_right_half', 'blood_moon_sigil'];  
      case "blood_snake":
        return ['blood_bones', 'blood_snake_head', 'forest_tablette_1', 'dotted_green_leaf_seeds', 'poison', 'green_leaf_seeds', 'lime_leaf_seeds', 'gold_leaf_seeds', 'snake_sigil', 'dragon_shield_left_half', 'dragon_shield_right_half', 'blood_moon_sigil'];  
      case "blood_ants":
        return ['ant_needles', 'blood_ant_remains', 'forest_tablette_2', 'dotted_green_leaf_seeds', 'green_leaf_seeds', 'lime_leaf_seeds', 'ants_sigil', 'dragon_shield_left_half', 'dragon_shield_right_half', 'blood_moon_sigil'];  
      case "blood_wolf":
        return ['blood_bones', 'blood_wolf_paw', 'raw_meat', 'max_heart_5', 'forest_tablette_3', 'dotted_green_leaf_seeds', 'green_leaf_seeds', 'lime_leaf_seeds', 'gold_leaf_seeds', 'wolf_sigil', 'dragon_shield_left_half', 'dragon_shield_right_half', 'blood_moon_sigil'];  
      case "blood_forest_ent":
        return ['blood_logs', 'strange_leaf', 'stranger_leaf', 'logs', 'oak_logs', 'forest_tablette_4', 'willow_logs', 'maple_logs', 'tree_seeds', 'oak_tree_seeds', 'willow_tree_seeds', 'maple_tree_seeds', 'stardust_tree_seeds', 'forest_ent_sigil', 'dragon_shield_left_half', 'dragon_shield_right_half', 'blood_moon_sigil'];  
      case "blood_thief":
        return ['blood_bones', 'blood_thief_skull', 'coins', 'forest_tablette_5', 'iron_dagger', 'dotted_green_leaf_seeds', 'green_leaf_seeds', 'thiefs_mask', 'lime_leaf_seeds', 'gold_leaf_seeds', 'thief_sigil', 'dragon_shield_left_half', 'dragon_shield_right_half', 'blood_moon_sigil'];  
      case "blood_bear":
        return ['blood_bones', 'blood_bear_paw', 'bear_fur', 'cave_tablette_1', 'bear_mask', 'bear_body', 'bear_legs', 'bear_gloves', 'bear_boots', 'dragon_shield_left_half', 'dragon_shield_right_half', 'bear_sigil', 'blood_moon_sigil'];  
      case "blood_goblin":
        return ['blood_bones', 'blood_goblin_fingers', 'lantern', 'ring_of_light', 'blood_goblin_mask', 'cave_tablette_2', 'stone', 'copper', 'iron', 'silver', 'gold', 'dragon_shield_left_half', 'dragon_shield_right_half', 'goblin_sigil', 'blood_moon_sigil'];  
      case "blood_bat":
        return ['blood_bones', 'blood_bat_wing', 'bat_skin', 'cave_tablette_3', 'bat_mask', 'bat_body', 'bat_legs', 'bat_gloves', 'bat_boots', 'dragon_shield_left_half', 'dragon_shield_right_half', 'bat_caves_sigil', 'blood_moon_sigil'];  
      case "blood_skeleton":
        return ['blood_bones', 'blood_skeleton_ribcage', 'skeleton_sword', 'skeleton_shield', 'cave_tablette_4', 'bone_amulet', 'promethium', 'dragon_shield_left_half', 'dragon_shield_right_half', 'skeleton_sigil', 'blood_moon_sigil'];  
      case "blood_fire_snake":
        return ['ashes', 'blood_fire_snake_tongue', 'fire_upgrade_spellscroll', 'volcano_tablette_1', 'dragon_shield_left_half', 'dragon_shield_right_half', 'fire_snake_sigil', 'blood_moon_sigil'];  
      case "blood_fire_hawk":
        return ['ashes', 'blood_fire_hawk_wing', 'fire_feathers', 'raw_bird_meat', 'volcano_tablette_2', 'dragon_shield_left_half', 'dragon_shield_right_half', 'fire_hawk_sigil', 'blood_moon_sigil'];  
      case "blood_fire_golem":
        return ['ashes', 'blood_fire_golem_head', 'volcano_tablette_3', 'bomb', 'tnt', 'dragon_shield_left_half', 'dragon_shield_right_half', 'fire_golem_sigil', 'blood_moon_sigil'];  
      case "blood_fire_witch":
       return ['ashes', 'string', 'blood_fire_witch_web', 'volcano_tablette_4', 'reflect_upgrade_spellscroll', 'dragon_shield_left_half', 'dragon_shield_right_half', 'fire_witch_sigil', 'blood_moon_sigil'];  
    }
    return []
  }
  static get_monster_uniques(monster_name) {
    switch(monster_name) {
      case "forest_ent":
        return ['strange_leaf_fertilizer'];
      case "wolf":
        return ['max_heart_1'];
      case "bear":
        return ['train_cart_piece_1'];
      case "goblin":
        return ['train_cart_piece_2'];
      case "bat":
        return ['train_cart_piece_3'];
      case "skeleton":
        return ['train_cart_piece_4', 'skull'];
      case "fire_snake":
        return ['fire_spellscroll'];
      case "fire_witch":
        return ['fire_crystal', 'max_heart_2'];
      case "ice_witch":
        return ['max_heart_3', 'max_mana_2'];
      case "yeti":
        return ['ice_crystal'];
      case "grandma":
        return ['heal_upgrade_spellscroll'];
      case "exorcist":
        return ['oxygen_mask', 'oxygen_tank'];
      case "blood_wolf":
        return ['max_heart_5'];
      case "blood_fire_snake":
        return ['fire_upgrade_spellscroll'];
      case "blood_fire_snake":
        return ['reflect_upgrade_spellscroll'];
    }

    return []
  }

  static quickFight(area) {
    if(Items.getItem('quick_fight_warning') == 0) {
      websocket.send('QUICK_FIGHT_WARNING');
    }
    else {
      if(Items.getItem("ice_crystal_touched") > 0 && Items.getItem("found_ticket_printer") == 0 && area == "northern_field") {
        websocket.send("FIND_TICKET_PRINTER");
      } 
      else {
        websocket.send('START_FIGHT=' + area)
        Globals.last_area_fight = area;
      }
      
    }
    
  }

  static refresh_select_combat_are_labels() {
    var testingFor = "";
    var testingForFP = 0;
    var testingForEnergy = 0;

    testingFor = "fields";
    testingForFP = 400;
    if(Items.getItem("badge_field_fp_reduction") > 0) testingForFP = 300;
    testingForEnergy = 10;
    document.getElementById("select-combat-screen-fp-" + testingFor).classList.remove("color-red");
    document.getElementById("select-combat-screen-fp-" + testingFor).classList.remove("color-green");
    document.getElementById("select-combat-screen-energy-" + testingFor).classList.remove("color-red");
    document.getElementById("select-combat-screen-energy-" + testingFor).classList.remove("color-green");
    if(Items.getItem('fight_points') > testingForFP) document.getElementById("select-combat-screen-fp-" + testingFor).classList.add("color-green"); else document.getElementById("select-combat-screen-fp-" + testingFor).classList.add("color-red");
    if(Items.getItem('energy') > testingForEnergy) document.getElementById("select-combat-screen-energy-" + testingFor).classList.add("color-green"); else document.getElementById("select-combat-screen-energy-" + testingFor).classList.add("color-red");

    testingFor = "forest";
    testingForFP = 600;
    testingForEnergy = 200;
    document.getElementById("select-combat-screen-fp-" + testingFor).classList.remove("color-red");
    document.getElementById("select-combat-screen-fp-" + testingFor).classList.remove("color-green");
    document.getElementById("select-combat-screen-energy-" + testingFor).classList.remove("color-red");
    document.getElementById("select-combat-screen-energy-" + testingFor).classList.remove("color-green");
    if(Items.getItem('fight_points') > testingForFP) document.getElementById("select-combat-screen-fp-" + testingFor).classList.add("color-green"); else document.getElementById("select-combat-screen-fp-" + testingFor).classList.add("color-red");
    if(Items.getItem('energy') > testingForEnergy) document.getElementById("select-combat-screen-energy-" + testingFor).classList.add("color-green"); else document.getElementById("select-combat-screen-energy-" + testingFor).classList.add("color-red");

    testingFor = "cave";
    testingForFP = 900;
    testingForEnergy = 500;
    document.getElementById("select-combat-screen-fp-" + testingFor).classList.remove("color-red");
    document.getElementById("select-combat-screen-fp-" + testingFor).classList.remove("color-green");
    document.getElementById("select-combat-screen-energy-" + testingFor).classList.remove("color-red");
    document.getElementById("select-combat-screen-energy-" + testingFor).classList.remove("color-green");
    if(Items.getItem('fight_points') > testingForFP) document.getElementById("select-combat-screen-fp-" + testingFor).classList.add("color-green"); else document.getElementById("select-combat-screen-fp-" + testingFor).classList.add("color-red");
    if(Items.getItem('energy') > testingForEnergy) document.getElementById("select-combat-screen-energy-" + testingFor).classList.add("color-green"); else document.getElementById("select-combat-screen-energy-" + testingFor).classList.add("color-red");

    testingFor = "volcano";
    testingForFP = 1500;
    testingForEnergy = 1000;
    document.getElementById("select-combat-screen-fp-" + testingFor).classList.remove("color-red");
    document.getElementById("select-combat-screen-fp-" + testingFor).classList.remove("color-green");
    document.getElementById("select-combat-screen-energy-" + testingFor).classList.remove("color-red");
    document.getElementById("select-combat-screen-energy-" + testingFor).classList.remove("color-green");
    if(Items.getItem('fight_points') > testingForFP) document.getElementById("select-combat-screen-fp-" + testingFor).classList.add("color-green"); else document.getElementById("select-combat-screen-fp-" + testingFor).classList.add("color-red");
    if(Items.getItem('energy') > testingForEnergy) document.getElementById("select-combat-screen-energy-" + testingFor).classList.add("color-green"); else document.getElementById("select-combat-screen-energy-" + testingFor).classList.add("color-red");

    testingFor = "north_fields";
    testingForFP = 2000;
    testingForEnergy = 3000;
    document.getElementById("select-combat-screen-fp-" + testingFor).classList.remove("color-red");
    document.getElementById("select-combat-screen-fp-" + testingFor).classList.remove("color-green");
    document.getElementById("select-combat-screen-energy-" + testingFor).classList.remove("color-red");
    document.getElementById("select-combat-screen-energy-" + testingFor).classList.remove("color-green");
    if(Items.getItem('fight_points') > testingForFP) document.getElementById("select-combat-screen-fp-" + testingFor).classList.add("color-green"); else document.getElementById("select-combat-screen-fp-" + testingFor).classList.add("color-red");
    if(Items.getItem('energy') > testingForEnergy) document.getElementById("select-combat-screen-energy-" + testingFor).classList.add("color-green"); else document.getElementById("select-combat-screen-energy-" + testingFor).classList.add("color-red");

    testingFor = "mansion";
    testingForFP = 3500;
    testingForEnergy = 5000;
    document.getElementById("select-combat-screen-fp-" + testingFor).classList.remove("color-red");
    document.getElementById("select-combat-screen-fp-" + testingFor).classList.remove("color-green");
    document.getElementById("select-combat-screen-energy-" + testingFor).classList.remove("color-red");
    document.getElementById("select-combat-screen-energy-" + testingFor).classList.remove("color-green");
    if(Items.getItem('fight_points') > testingForFP) document.getElementById("select-combat-screen-fp-" + testingFor).classList.add("color-green"); else document.getElementById("select-combat-screen-fp-" + testingFor).classList.add("color-red");
    if(Items.getItem('energy') > testingForEnergy) document.getElementById("select-combat-screen-energy-" + testingFor).classList.add("color-green"); else document.getElementById("select-combat-screen-energy-" + testingFor).classList.add("color-red");

    testingFor = "beach";
    testingForFP = 5000;
    testingForEnergy = 10000;
    document.getElementById("select-combat-screen-fp-" + testingFor).classList.remove("color-red");
    document.getElementById("select-combat-screen-fp-" + testingFor).classList.remove("color-green");
    document.getElementById("select-combat-screen-energy-" + testingFor).classList.remove("color-red");
    document.getElementById("select-combat-screen-energy-" + testingFor).classList.remove("color-green");
    if(Items.getItem('fight_points') > testingForFP) document.getElementById("select-combat-screen-fp-" + testingFor).classList.add("color-green"); else document.getElementById("select-combat-screen-fp-" + testingFor).classList.add("color-red");
    if(Items.getItem('energy') > testingForEnergy) document.getElementById("select-combat-screen-energy-" + testingFor).classList.add("color-green"); else document.getElementById("select-combat-screen-energy-" + testingFor).classList.add("color-red");


    //bloood
    testingFor = "blood-fields";
    testingForFP = 1000;
    testingForEnergy = 2000;
    document.getElementById("select-combat-screen-fp-" + testingFor).classList.remove("color-red");
    document.getElementById("select-combat-screen-fp-" + testingFor).classList.remove("color-green");
    document.getElementById("select-combat-screen-energy-" + testingFor).classList.remove("color-red");
    document.getElementById("select-combat-screen-energy-" + testingFor).classList.remove("color-green");
    if(Items.getItem('fight_points') > testingForFP) document.getElementById("select-combat-screen-fp-" + testingFor).classList.add("color-green"); else document.getElementById("select-combat-screen-fp-" + testingFor).classList.add("color-red");
    if(Items.getItem('energy') > testingForEnergy) document.getElementById("select-combat-screen-energy-" + testingFor).classList.add("color-green"); else document.getElementById("select-combat-screen-energy-" + testingFor).classList.add("color-red");

    testingFor = "blood-forest";
    testingForFP = 2000;
    testingForEnergy = 4000;
    document.getElementById("select-combat-screen-fp-" + testingFor).classList.remove("color-red");
    document.getElementById("select-combat-screen-fp-" + testingFor).classList.remove("color-green");
    document.getElementById("select-combat-screen-energy-" + testingFor).classList.remove("color-red");
    document.getElementById("select-combat-screen-energy-" + testingFor).classList.remove("color-green");
    if(Items.getItem('fight_points') > testingForFP) document.getElementById("select-combat-screen-fp-" + testingFor).classList.add("color-green"); else document.getElementById("select-combat-screen-fp-" + testingFor).classList.add("color-red");
    if(Items.getItem('energy') > testingForEnergy) document.getElementById("select-combat-screen-energy-" + testingFor).classList.add("color-green"); else document.getElementById("select-combat-screen-energy-" + testingFor).classList.add("color-red");

    testingFor = "blood-cave";
    testingForFP = 3500;
    testingForEnergy = 6000;
    document.getElementById("select-combat-screen-fp-" + testingFor).classList.remove("color-red");
    document.getElementById("select-combat-screen-fp-" + testingFor).classList.remove("color-green");
    document.getElementById("select-combat-screen-energy-" + testingFor).classList.remove("color-red");
    document.getElementById("select-combat-screen-energy-" + testingFor).classList.remove("color-green");
    if(Items.getItem('fight_points') > testingForFP) document.getElementById("select-combat-screen-fp-" + testingFor).classList.add("color-green"); else document.getElementById("select-combat-screen-fp-" + testingFor).classList.add("color-red");
    if(Items.getItem('energy') > testingForEnergy) document.getElementById("select-combat-screen-energy-" + testingFor).classList.add("color-green"); else document.getElementById("select-combat-screen-energy-" + testingFor).classList.add("color-red");

    testingFor = "blood-volcano";
    testingForFP = 5000;
    testingForEnergy = 10000;
    document.getElementById("select-combat-screen-fp-" + testingFor).classList.remove("color-red");
    document.getElementById("select-combat-screen-fp-" + testingFor).classList.remove("color-green");
    document.getElementById("select-combat-screen-energy-" + testingFor).classList.remove("color-red");
    document.getElementById("select-combat-screen-energy-" + testingFor).classList.remove("color-green");
    if(Items.getItem('fight_points') > testingForFP) document.getElementById("select-combat-screen-fp-" + testingFor).classList.add("color-green"); else document.getElementById("select-combat-screen-fp-" + testingFor).classList.add("color-red");
    if(Items.getItem('energy') > testingForEnergy) document.getElementById("select-combat-screen-energy-" + testingFor).classList.add("color-green"); else document.getElementById("select-combat-screen-energy-" + testingFor).classList.add("color-red");

  }

  static number_of_blood_monsters_killed() {
    var counter = 0;

    //area
    if(Items.getItem("blood_chicken_kills") > 0) counter++;
    if(Items.getItem("blood_rat_kills") > 0) counter++;
    if(Items.getItem("blood_spider_kills") > 0) counter++;
    if(Items.getItem("blood_bee_kills") > 0) counter++;
    if(Items.getItem("blood_lizard_kills") > 0) counter++;

    //area
    if(Items.getItem("blood_snake_kills") > 0) counter++;
    if(Items.getItem("blood_ants_kills") > 0) counter++;
    if(Items.getItem("blood_wolf_kills") > 0) counter++;
    if(Items.getItem("blood_forest_ent_kills") > 0) counter++;
    if(Items.getItem("blood_thief_kills") > 0) counter++;

    //area
    if(Items.getItem("blood_bear_kills") > 0) counter++;
    if(Items.getItem("blood_goblin_kills") > 0) counter++;
    if(Items.getItem("blood_bat_kills") > 0) counter++;
    if(Items.getItem("blood_skeleton_kills") > 0) counter++;

    //area
    if(Items.getItem("blood_fire_snake_kills") > 0) counter++;
    if(Items.getItem("blood_fire_hawk_kills") > 0) counter++;
    if(Items.getItem("blood_fire_golem_kills") > 0) counter++;
    if(Items.getItem("blood_fire_witch_kills") > 0) counter++;

    return counter;
  }

  static set_monster_name_label(value, autoformat)
  {
    if(autoformat) {
      value = capitalizeFirstLetter(get_item_name(value));
    }
    set_innerHTML("fighting-monster-label", value)
  }


  static select_monster_directly(area, monster_chosen) {

  }

  static show_hero_in_left_menu_bar()
  {
      document.getElementById("idle-hero-image").style.display = "";   
  }

  static hide_hero_in_left_menu_bar()
  {
      document.getElementById("idle-hero-image").style.display = "none";   
  }


  static hide_left_menu_bar()
  {
    document.getElementById("menu-bar").style.display = "none";
  }

  static show_left_menu_bar()
  {
    document.getElementById("menu-bar").style.display = "";
  }

  static in_combat()
  {
     return Items.getItemString("monster_name") != "none";
  }


  static modal_load_area_data()
  {
    Combat._modal_load_area_data(Combat.modal_area_last_selected)
  }

  static refreshGuardianFightsItemBox() {
    var hasOneKey = false;
    var testingFor = null;

    testingFor = "green_gaurdian_key";
    if(Items.getItem(testingFor) > 0) {
      hasOneKey = true;
      document.getElementById("fight-guardians-itemxbox-large-" + testingFor).style.display = "";
    } else {
      document.getElementById("fight-guardians-itemxbox-large-" + testingFor).style.display = "none";
    }

    testingFor = "blue_gaurdian_key";
    if(Items.getItem(testingFor) > 0) {
      hasOneKey = true;
      document.getElementById("fight-guardians-itemxbox-large-" + testingFor).style.display = "";
    } else {
      document.getElementById("fight-guardians-itemxbox-large-" + testingFor).style.display = "none";
    }

    testingFor = "purple_gaurdian_key";
    if(Items.getItem(testingFor) > 0) {
      hasOneKey = true;
      document.getElementById("fight-guardians-itemxbox-large-" + testingFor).style.display = "";
    } else {
      document.getElementById("fight-guardians-itemxbox-large-" + testingFor).style.display = "none";
    }
    
    testingFor = "mixed_gaurdian_key";
    if(Items.getItem(testingFor) > 0) {
      hasOneKey = true;
      document.getElementById("fight-guardians-itemxbox-large-" + testingFor).style.display = "";
    } else {
      document.getElementById("fight-guardians-itemxbox-large-" + testingFor).style.display = "none";
    }

    if(hasOneKey) {
      document.getElementById("itembox-fight-guardians").style.display = "";
    } else {
      document.getElementById("itembox-fight-guardians").style.display = "none";
    }
    

  }
  static _modal_load_area_data(area)
  {
    var title;
    var image_path;
    var common_monsters_array;
    var rare_monsters_array;
    var energy;
    var fightpoints;

    switch(area)
    {
      case "field":
        title = "FIELDS";
        image_path = "images/gathering_field.png";
        common_monsters_array = ["chicken", "rat", "spider"];
        rare_monsters_array = ["lizard", "bee"];
        energy = 10;
        fightpoints = 400;
        if(Items.getItem("badge_field_fp_reduction") > 0) {
          fightpoints = 300;
        }
        document.getElementById("modal-fight-areas-warning").innerHTML = ""
      break;

      case "forest":
        title = "FOREST";
        image_path = "images/forest.png";
        common_monsters_array = ["snake", "ants", "wolf"];
        rare_monsters_array = ["forest_ent", "thief"];
        energy = 200;
        fightpoints = 600;
        document.getElementById("modal-fight-areas-warning").innerHTML = ""
      break;

      case "cave":
        title = "CAVES";
        image_path = "images/cave.png";
        common_monsters_array = ["bear", "goblin", "bat"];
        rare_monsters_array = ["skeleton"];
        energy = 500;
        fightpoints = 900;
        document.getElementById("modal-fight-areas-warning").innerHTML = "<br /><br /><img src='https://cdn.idle-pixel.com/images/warning.png' class='img-15' /> <b>WARNING: </b> Caves are dark and it might be hard to see.";
      break;

      case "volcano":
        title = "VOLCANO";
        image_path = "images/volcano.png";
        common_monsters_array = ["fire_hawk", "fire_snake", "fire_golem"];
        rare_monsters_array = ["fire_witch"];
        energy = 1000;
        fightpoints = 1500;
        document.getElementById("modal-fight-areas-warning").innerHTML = ""
      break;

      case "northern_field":
        title = "NORTHERN FIELDS";
        image_path = "images/northern_field.png";
        common_monsters_array = ["ice_hawk", "ice_witch", "ice_golem"];
        rare_monsters_array = ["yeti"];
        energy = 3000;
        fightpoints = 2000;
        document.getElementById("modal-fight-areas-warning").innerHTML = "<br /><br /><img src='https://cdn.idle-pixel.com/images/warning.png' class='img-15' /> <b>WARNING: </b> It is very cold here, I should dress warmly.";
      break;

      case "mansion":
        title = "MANSION";
        image_path = "images/mansion.png";
        common_monsters_array = ["ghost", "grandma", "exorcist"];
        rare_monsters_array = ["reaper"];
        energy = 5000;
        fightpoints = 3500;
        document.getElementById("modal-fight-areas-warning").innerHTML = ""
      break;

      case "beach":
        title = "BEACH";
        image_path = "images/beach.png";
        common_monsters_array = ["shark", "sea_soldier", "puffer_fish"];
        rare_monsters_array = ["saltwater_crocodile"];
        energy = 10000;
        fightpoints = 5000;
        document.getElementById("modal-fight-areas-warning").innerHTML = "<br /><br /><img src='https://cdn.idle-pixel.com/images/warning.png' class='img-15' /> <b>WARNING: </b> The water makes it hard to move, decreasing your attack speed.  Also, arrows and fire spell don't work.";
      break;
    }

    // for(var i = 0; i< common_monsters_array.length; i++)
    //   common_monsters_array[i] = "<span onclick='Modals.open_monster_description(this.innerHTML)' class='area-monster-label'>" + common_monsters_array[i] + "</span>";
    // for(var i = 0; i< rare_monsters_array.length; i++)
    //   rare_monsters_array[i] = "<span onclick='Modals.open_monster_description(this.innerHTML)' class='area-monster-label'>" + rare_monsters_array[i] + "</span>";

    var html = "";
    
    var extraTH = "";
    if(area == "mansion" || area == "north_fields" || area == "beach") {
      if(Items.getItem("super_rare_monster_potion") > 0) {
        extraTH = "<th>Drink</th>"
      }
    }
    if(area == "field" || area == "forest" || area == "cave" || area == "volcano") {
      if (Items.getItem("rare_monster_potion") > 0) {
        extraTH = "<th>Drink</th>"
      }
    }
    
    var monsters = common_monsters_array.concat(rare_monsters_array);
    for(var i = 0; i < monsters.length; i++) {
      var monster = monsters[i];
      var has_kills = Items.getItem(monster + "_kills") > 0;

      var hover = ''
      if(Items.getItem('rare_monster_potion_total') > 0 || Items.getItem('super_rare_monster_potion_total') > 0) {
        hover = 'hover';
      }
      var addition_onclick_event = "";
      if(monster == "yeti") {
        addition_onclick_event = "websocket.send('EXAMINE_YETI_STRATEGY');"
      }

      html += "<div class='fight-area-select-monster-card '>";
      html += '<wiki class="wiki" style="float:right;margin-top:-15px;" onclick="'+addition_onclick_event+'event.stopPropagation()"><a href="https://database.idle-pixel.com/'+monster+'/" target="_blank"><img class="hover" src="https://cdn.idle-pixel.com/images/search.png"></a></wiki>';
        html += capitalizeFirstLetter(get_item_name(monster));
        html += "<div class='center'>";

        if(has_kills)
          html += "<img class='w100' src='https://cdn.idle-pixel.com/images/"+monster+"_icon.png' />";
        else
          html += "<img class='w100'  src='https://cdn.idle-pixel.com/images/"+monster+"_icon_black.png' />";
        html += "</div>";

        
        var drops = Combat.get_monster_drops(monster)
        html += "<div class='hover' onclick='event.stopPropagation();websocket.send(\"VIEW_MONSTER_LOOT_DIALOGUE="+monster+"\")'>";
        for(var j = 0; j < drops.length; j++) {
          var drop = drops[j];
          var obtained_style = "style='border-radius:3pt; background-color:#FEB8B8;margin:2px;padding:2px;'"
          if(Items.getItem(monster + "_" + drop) > 0) obtained_style = "style='border-radius:3pt; background-color:#C1FEB8;margin:2px;padding:2px;'"
          html += "<img title='"+capitalizeFirstLetter(get_item_name(drop))+"' "+obtained_style+" src='https://cdn.idle-pixel.com/images/"+drop+".png' class='w30' />";
        }
        html += "</div>";
        
        if(area == "field" || area == "forest" || area == "cave" || area == "volcano") {
        if(Items.getItem("rare_monster_potion") > 0) {
          html += "<center><div onclick='websocket.send(\"DRINK_SELECT_POTION="+monster+"\");' class='rare-monster-pot-shortcut hover'>";
          html += "<img class='w20'  src='https://cdn.idle-pixel.com/images/rare_monster_potion.png' />"
          html += " Drink"
          html += "</div></center>";
        }
      }

        console.log(area)
        if(area == "mansion" || area == "northern_field" || area == "beach") {
          if(Items.getItem("super_rare_monster_potion") > 0) {
            html += "<center><div onclick='websocket.send(\"DRINK_SUPER_SELECT_POTION="+monster+"\");' class='rare-monster-pot-shortcut hover'>";
            html += "<img class='w20'  src='https://cdn.idle-pixel.com/images/super_rare_monster_potion.png' />"
            html += " Drink"
            html += "</div></center>";
        }
      }
        
      html += "</div>";
    }
    //common monsters
    // html += "<center><table width='70%' class='combat-modal-monster-table'>";
    // html += "<tr style='background-color:silver;'><th style='width:30%'>Common Monsters</th><th>Kills</th><th>Drop table</th><th>Unique Drops</th><th>Strategies</th><th>Best Kill Time</th>"+extraTH+"</tr>";
    // for(var i = 0; i< common_monsters_array.length; i++) {
    //   var monster = common_monsters_array[i];
    //   var has_kills = Items.getItem(monster + "_kills") > 0;
    //   if(area == "fields" || area)
    //   html += "<tr>";

    //     html += "<td>";
    //       if(has_kills)
    //         html += "<img src='https://cdn.idle-pixel.com/images/"+monster+"_icon.png' />";
    //       else
    //         html += "<img src='https://cdn.idle-pixel.com/images/"+monster+"_icon_black.png' />";
    //     html += "</td>";

    //     html += "<td>";
    //       html += Items.getItem(monster + "_kills");
    //     html += "</td>";

    //     html += "<td>";
    //       // var values = Monsters.get_total_drops_for_loot_button(monster);
    //       // var drops_obtained = values[0];
    //       // var drops_total = values[1];
    //       // if(Items.getItem(monster + "_kills") > 0)
    //       // {
    //       //   var style = "";
    //       //   if(drops_obtained == drops_total) style="background-color:lime;"; else style="background-color:yellow;";
    //       //   html += "<input type='button' class='monster-loot-button hover' style='"+style+"' onclick='websocket.send(\"VIEW_MONSTER_LOOT_DIALOGUE="+monster+"\")' value='Loot "+(drops_obtained + "/" + drops_total)+"' />";
    //       // }
    //       // else
    //       //   html += "<button class='monster-loot-button hover' style='cursor:not-allowed;background-color:red;' onclick='Modals.cannot_view_loot()'><strike>Loot "+(0 + "/" + drops_total)+"</strike></button>";

    //       // html += "<hr />";

    //       var drops = Combat.get_monster_drops(monster)
    //       html += "<div class='hover' onclick='websocket.send(\"VIEW_MONSTER_LOOT_DIALOGUE="+monster+"\")'>";
    //       for(var j = 0; j < drops.length; j++) {
    //         var drop = drops[j];
    //         var obtained_style = "style='border-radius:3pt; background-color:#FEB8B8;margin:2px;padding:2px;'"
    //         if(Items.getItem(monster + "_" + drop) > 0) obtained_style = "style='border-radius:3pt; background-color:#C1FEB8;margin:2px;padding:2px;'"
    //         html += "<img "+obtained_style+" src='https://cdn.idle-pixel.com/images/"+drop+".png' class='w30' />";
    //       }
    //       html += "</div>";
    //     html += "</td>";

    //     html += "<td>";
    //       var unqiues = Combat.get_monster_uniques(monster);
    //       if(unqiues.length == 0) {
    //         html += "<span class='color-grey font-small'>None</span>";
    //       } else {
    //         for(var j = 0; j < unqiues.length; j++) {
    //           var unqiue = unqiues[j];
    //           var obtained_style = "style='border-radius:3pt; background-color:#FEB8B8;margin:2px;padding:2px;'"
    //           if(Items.getItem(unqiue + "_unique") > 0) obtained_style = "style='border-radius:3pt; background-color:#C1FEB8;margin:2px;padding:2px;'"
    //           html += "<img "+obtained_style+" src='https://cdn.idle-pixel.com/images/"+unqiue+".png' class='w30' />";
    //         }
    //       }
    //     html += "</td>";

    //     html += "<td>";
    //       html += "<a href='http://database.idle-pixel.com/" + monster + "' target='_blank'>";
    //         html += "<button>WIKI</button>"
    //       html += "</a>"
    //     html += "</td>";

    //     html += "<td class='color-grey'>";
    //       if(Items.getItem(monster + "_record_killtime") > 0) html += Items.getItem(monster + "_record_killtime") + " seconds";
    //       else html += "(unset)";
    //     html += "</td>";

    //     if(area == "mansion" || area == "north_fields" || area == "beach") {
    //       if(Items.getItem("super_rare_monster_potion") > 0) {
    //         html += "<td class='color-grey'>";
    //         html +=  "<img onclick='websocket.send(\"DRINK_SUPER_SELECT_POTION="+monster+"\")' src='https://cdn.idle-pixel.com/images/super_rare_monster_potion.png' class='hover w30' />";
    //         html += "</td>";
    //       }
    //     }
    //     if(area == "field" || area == "forest" || area == "cave" || area == "volcano") {
    //       if (Items.getItem("rare_monster_potion") > 0) {
    //         html += "<td class='color-grey'>";
    //         html +=  "<img onclick='websocket.send(\"DRINK_SELECT_POTION="+monster+"\")' src='https://cdn.idle-pixel.com/images/rare_monster_potion.png' class='hover w30' />";
    //         html += "</td>";
    //       }
    //     }

    //   html += "</tr>";
    // }
    // html += "</table></center>";

    // document.getElementById("modal-fight-areas-monster-info").innerHTML = html;
    
    // //rare monsters
    // html = "";
    // html += "<center><table width='70%' class='combat-modal-monster-table'>";
    // html += "<tr style='background-color:silver;'><th style='width:30%'>Rare Monsters</th><th>Kills</th><th>Drop table</th><th>Unique drops</th><th>Strategies</th><th>Best Kill Time</th>"+extraTH+"</tr>"
    // for(var i = 0; i< rare_monsters_array.length; i++) {
    //   var monster = rare_monsters_array[i];
    //   var has_kills = Items.getItem(monster + "_kills") > 0;
    //   html += "<tr>";

    //     html += "<td>";
    //       if(has_kills)
    //         html += "<img src='https://cdn.idle-pixel.com/images/"+monster+"_icon.png' />";
    //       else
    //         html += "<img src='https://cdn.idle-pixel.com/images/"+monster+"_icon_black.png' />";
    //     html += "</td>";

    //     html += "<td>";
    //       html += Items.getItem(monster + "_kills");
    //     html += "</td>";

    //     html += "<td>";
    //       var values = Monsters.get_total_drops_for_loot_button(monster);
    //       var drops_obtained = values[0];
    //       var drops_total = values[1];
    //       if(Items.getItem(monster + "_kills") > 0)
    //       {
    //         var style = "";
    //         if(drops_obtained == drops_total) style="background-color:lime;"; else style="background-color:yellow;";
    //         html += "<input type='button' class='monster-loot-button hover' style='"+style+"' onclick='websocket.send(\"VIEW_MONSTER_LOOT_DIALOGUE="+monster+"\")' value='Loot "+(drops_obtained + "/" + drops_total)+"' />";
    //       }
    //       else
    //         html += "<button class='monster-loot-button hover' style='cursor:not-allowed;background-color:red;' onclick='Modals.cannot_view_loot()'><strike>Loot "+(0 + "/" + drops_total)+"</strike></button>";
    //     html += "</td>";

    //     html += "<td>";
    //     var unqiues = Combat.get_monster_uniques(monster);
    //     if(unqiues.length == 0) {
    //       html += "<span class='color-grey font-small'>None</span>";
    //     } else {
    //       for(var j = 0; j < unqiues.length; j++) {
    //         var unqiue = unqiues[j];
    //         var obtained_style = ""
    //         if(Items.getItem(unqiue + "_unique") > 0) obtained_style = "style='border:1px solid silver; background-color:#C1FEB8;margin:5px;'"
    //         html += "<img "+obtained_style+" src='https://cdn.idle-pixel.com/images/"+unqiue+".png' class='w20' />";
    //       }
    //     }
    //   html += "</td>";

    //     html += "<td>";
    //       if(monster == 'yeti') {
    //         html += "<a href='http://database.idle-pixel.com/" + monster + "' target='_blank'>";
    //           html += "<button onclick='websocket.send(\"EXAMINE_YETI_STRATEGY\")'>WIKI</button>"
    //         html += "</a>"
    //       }
    //       else {
    //         html += "<a href='http://database.idle-pixel.com/" + monster + "' target='_blank'>";
    //           html += "<button>WIKI</button>"
    //         html += "</a>"
    //       }
    //     html += "</td>";

    //     html += "<td class='color-grey'>";
    //       if(Items.getItem(monster + "_record_killtime") > 0) html += Items.getItem(monster + "_record_killtime") + " seconds";
    //       else html += "(unset)";
    //     html += "</td>";

    //     if(area == "mansion" || area == "north_fields" || area == "beach") {
    //       if(Items.getItem("super_rare_monster_potion") > 0) {
    //         html += "<td class='color-grey'>";
    //         html +=  "<img onclick='websocket.send(\"DRINK_SUPER_SELECT_POTION="+monster+"\")' src='https://cdn.idle-pixel.com/images/super_rare_monster_potion.png' class='hover w30' />";
    //         html += "</td>";
    //       }
    //     }
    //     if(area == "field" || area == "forest" || area == "cave" || area == "volcano") {
    //       if (Items.getItem("rare_monster_potion") > 0) {
    //         html += "<td class='color-grey'>";
    //         html +=  "<img onclick='websocket.send(\"DRINK_SELECT_POTION="+monster+"\")' src='https://cdn.idle-pixel.com/images/rare_monster_potion.png' class='hover w30' />";
    //         html += "</td>";
    //       }
    //     }

    //   html += "</tr>";
    // }
    // html += "</table></center>";

    document.getElementById("modal-fight-areas-monster-rare-info").innerHTML = html;

    document.getElementById("modal-fight-areas-image-body").style.background = "url('https://cdn.idle-pixel.com/"+image_path+"') no-repeat";
    document.getElementById("modal-fight-areas-image-body").style.backgroundSize = 'cover'; 

    var energy_check_or_x_img = "<img src='https://cdn.idle-pixel.com/images/x.png' class='w15'>"
    if(Items.getItem('energy') >= energy)
      energy_check_or_x_img = "<img src='https://cdn.idle-pixel.com/images/check.png' class='w15'>"

    var fightpoints_check_or_x_img = "<img src='https://cdn.idle-pixel.com/images/x.png' class='w15'>"
      if(Items.getItem('fight_points') >= fightpoints)
      fightpoints_check_or_x_img = "<img src='https://cdn.idle-pixel.com/images/check.png' class='w15'>"

    set_innerHTML("modal-fight-areas-energy", format_number(energy) + " " + energy_check_or_x_img);
    set_innerHTML("modal-fight-areas-fightpoints", format_number(fightpoints) + " " + fightpoints_check_or_x_img);
    document.getElementById("modal-fight-areas-fight-button").onclick = function()
    {
        if(Items.getItem("ice_crystal_touched") > 0 && Items.getItem("found_ticket_printer") == 0 && Combat.modal_area_last_selected == "northern_field") {
          websocket.send("FIND_TICKET_PRINTER");
        } else {
          websocket.send("START_FIGHT=" + Combat.modal_area_last_selected)
          Globals.last_area_fight = Combat.modal_area_last_selected;
        }
        
    }
  }

  static equip(item)
  {
     if(Quests.theMerchanterShowItem(item)) return;
    
     if(!Needle.isActive(item)) {
      if(item == "degradable_gold_rapier" && Items.getItem("degradable_gold_rapier_timer") == 0) {
        Modals.open_image_modal('DEGRADABLE WEAPON', 'images/degradable_gold_rapier.png', 'Equiping this item will trigger a timer for which it will degrade in 24h.  As soon as you equip it, the weapon may only be used for 24h, it will then be removed.', 'Equip it!', 'Cancel', 'EQUIP=degradable_gold_rapier')
        return;
      }

      Animations.shake_hero();
      websocket.send('EQUIP=' + item);
     }
        
  }

  static switchToRaidFightsScreen() {
    if(get_level(Items.getItem('melee_xp')) >= 30 && get_level(Items.getItem('archery_xp')) >= 30 && get_level(Items.getItem('magic_xp')) >= 30) {
      //nada
    } else {
      Modals.open_image_modal("BADGE", "images/warning_icon.png", "Warning:  It is not recommended to raid without having higher combat stats.<br /><br /><span class='color-grey'>Probably best to train in solo low level areas for a bit.</span>", null, "Close", null);
    }
    document.getElementById('game-panels-combat-items-area').style.display = 'none';
    document.getElementById('combat-stats').style.display = 'none';
    document.getElementById('game-panels-combat-raids').style.display = '';
  }


  static equip_ring(item)
  {
    websocket.send('EQUIP_RING=' + item);
  }

  static clicks_train_path(area)
  {
      if(Items.getItem(area + '_unlocked') > 0)
      {
        Modals.toggle('modal-combat-train-network-choices');
        Modals.show_combat_select_area(area);
      }
      else
      websocket.send('TRAIN_CONDUCTOR_SIGN='+area+'~0')
  }

  static refresh_presets_modal()
  {
    Combat._refresh_preset_icons();
  }

  static _refresh_preset_icons()
  {
    for(var i = 1; i <=5 ; i++)
    {
      document.getElementById("preset-icon-img-" + i).src = get_image("images/" + Items.getItem("combat_preset_icon_" + i));
      document.getElementById("preset-icon-color-" + i).style.backgroundColor = Items.getItemString("combat_preset_color_" + i);
    }
  }

  static load_preset_buttons()
  {

    for(var i = 1; i <= 5; i++)
    {
      if(Items.getItemString("combat_preset_icon_" + i) != "none")
        document.getElementById("in-combat-presets-icon-" + i).src = get_image("images/" + Items.getItemString("combat_preset_icon_" + i));

      if(Items.getItemString("combat_preset_color_" + i) != "none")
        document.getElementById("in-combat-presets-icon-" + i).style.backgroundColor = Items.getItemString("combat_preset_color_" + i);
    }
    
  }

  
  static all_owned_rings_equipped() {
    var rings  = [
      "weak_defence_ring",
      "weak_damage_ring",
      "weak_accuracy_ring",
      "defence_ring",
      "damage_ring",
      "accuracy_ring",
      "good_defence_ring",
      "good_damage_ring",
      "good_accuracy_ring",
      "great_defence_ring",
      "great_damage_ring",
      "great_accuracy_ring",
      "perfect_defence_ring",
      "perfect_damage_ring",
      "perfect_accuracy_ring",
      "ancient_defence_ring",
      "ancient_damage_ring",
      "ancient_accuracy_ring",
      "master_ring",
    ]

    document.getElementById('ring-warning-unequipped').style.display = "none";

    for(var i = 0; i < rings.length; i++) {
      if(Items.getItem(rings[i]) == 0)
        continue;

      if(Items.getItem(rings[i] + "_" + "equipped") == 0)
      {
        document.getElementById('ring-warning-unequipped').style.display = "";
        return;
      }
    }
    
  }

static get_boss_fight_points_requirments()
{
  return Items.getItem('max_fight_points') / 2;
}

static refresh_small_icons_combat_selection() {
  var cloudfront = "https://cdn.idle-pixel.com/images/"
  var all_green = false;
  var green = "green";
  var cyan = "cyan";
  var green_kills = 0; // > than; (so drunk atm)
  var cyan_kills = 99;

  var all_green = true;
  var testingFor = "chicken";
  if(Items.getItem(testingFor + "_kills") > cyan_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+cyan+".png";
  } else if(Items.getItem(testingFor + "_kills") > green_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+green+".png";
  } else {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_black.png";
    all_green = false;
  }

  var testingFor = "rat";
  if(Items.getItem(testingFor + "_kills") > cyan_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+cyan+".png";
  } else if(Items.getItem(testingFor + "_kills") > green_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+green+".png";
  } else {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_black.png";
    all_green = false;
  }

  var testingFor = "spider";
  if(Items.getItem(testingFor + "_kills") > cyan_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+cyan+".png";
  } else if(Items.getItem(testingFor + "_kills") > green_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+green+".png";
  } else {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_black.png";
    all_green = false;
  }

  var testingFor = "lizard";
  if(Items.getItem(testingFor + "_kills") > cyan_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+cyan+".png";
  } else if(Items.getItem(testingFor + "_kills") > green_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+green+".png";
  } else {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_black.png";
    all_green = false;
  }

  var testingFor = "bee";
  if(Items.getItem(testingFor + "_kills") > cyan_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+cyan+".png";
  } else if(Items.getItem(testingFor + "_kills") > green_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+green+".png";
  } else {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_black.png";
    all_green = false;
  }
  if(all_green) document.getElementById("game-panel-combat-select-area-panels-quickfight-field").style.display = "";

  all_green = true;
  var testingFor = "snake";
  if(Items.getItem(testingFor + "_kills") > cyan_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+cyan+".png";
  } else if(Items.getItem(testingFor + "_kills") > green_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+green+".png";
  } else {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_black.png";
    all_green = false;
  }

  var testingFor = "ants";
  if(Items.getItem(testingFor + "_kills") > cyan_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+cyan+".png";
  } else if(Items.getItem(testingFor + "_kills") > green_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+green+".png";
  } else {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_black.png";
    all_green = false;
  }

  
  var testingFor = "wolf";
  if(Items.getItem(testingFor + "_kills") > cyan_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+cyan+".png";
  } else if(Items.getItem(testingFor + "_kills") > green_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+green+".png";
  } else {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_black.png";
    all_green = false;
  }

  
  var testingFor = "forest_ent";
  if(Items.getItem(testingFor + "_kills") > cyan_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+cyan+".png";
  } else if(Items.getItem(testingFor + "_kills") > green_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+green+".png";
  } else {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_black.png";
    all_green = false;
  }

  
  var testingFor = "thief";
  if(Items.getItem(testingFor + "_kills") > cyan_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+cyan+".png";
  } else if(Items.getItem(testingFor + "_kills") > green_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+green+".png";
  } else {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_black.png";
    all_green = false;
  }
  if(all_green) document.getElementById("game-panel-combat-select-area-panels-quickfight-forest").style.display = "";


  all_green = true;
  var testingFor = "bear";
  if(Items.getItem(testingFor + "_kills") > cyan_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+cyan+".png";
  } else if(Items.getItem(testingFor + "_kills") > green_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+green+".png";
  } else {
    all_green = false;
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_black.png";
  }

  var testingFor = "goblin";
  if(Items.getItem(testingFor + "_kills") > cyan_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+cyan+".png";
  } else if(Items.getItem(testingFor + "_kills") > green_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+green+".png";
  } else {
    all_green = false;
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_black.png";
  }

  var testingFor = "bat";
  if(Items.getItem(testingFor + "_kills") > cyan_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+cyan+".png";
  } else if(Items.getItem(testingFor + "_kills") > green_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+green+".png";
  } else {
    all_green = false;
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_black.png";
  }


  var testingFor = "skeleton";
  if(Items.getItem(testingFor + "_kills") > cyan_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+cyan+".png";
  } else if(Items.getItem(testingFor + "_kills") > green_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+green+".png";
  } else {
    all_green = false;
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_black.png";
  }
  if(all_green) document.getElementById("game-panel-combat-select-area-panels-quickfight-cave").style.display = "";



  all_green = true;
  var testingFor = "fire_hawk";
  if(Items.getItem(testingFor + "_kills") > cyan_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+cyan+".png";
  } else if(Items.getItem(testingFor + "_kills") > green_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+green+".png";
  } else {
    all_green = false;
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_black.png";
  }

  
  var testingFor = "fire_snake";
  if(Items.getItem(testingFor + "_kills") > cyan_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+cyan+".png";
  } else if(Items.getItem(testingFor + "_kills") > green_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+green+".png";
  } else {
    all_green = false;
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_black.png";
  }

  
  var testingFor = "fire_golem";
  if(Items.getItem(testingFor + "_kills") > cyan_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+cyan+".png";
  } else if(Items.getItem(testingFor + "_kills") > green_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+green+".png";
  } else {
    all_green = false;
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_black.png";
  }

  
  var testingFor = "fire_witch";
  if(Items.getItem(testingFor + "_kills") > cyan_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+cyan+".png";
  } else if(Items.getItem(testingFor + "_kills") > green_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+green+".png";
  } else {
    all_green = false;
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_black.png";
  }
  if(all_green) document.getElementById("game-panel-combat-select-area-panels-quickfight-volcano").style.display = "";

  all_green = true;
  var testingFor = "ice_hawk";
  if(Items.getItem(testingFor + "_kills") > cyan_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+cyan+".png";
  } else if(Items.getItem(testingFor + "_kills") > green_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+green+".png";
  } else {
    all_green = false;
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_black.png";
  }

  
  var testingFor = "ice_witch";
  if(Items.getItem(testingFor + "_kills") > cyan_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+cyan+".png";
  } else if(Items.getItem(testingFor + "_kills") > green_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+green+".png";
  } else {
    all_green = false;
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_black.png";
  }

  
  var testingFor = "ice_golem";
  if(Items.getItem(testingFor + "_kills") > cyan_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+cyan+".png";
  } else if(Items.getItem(testingFor + "_kills") > green_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+green+".png";
  } else {
    all_green = false;
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_black.png";
  }

  
  var testingFor = "yeti";
  if(Items.getItem(testingFor + "_kills") > cyan_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+cyan+".png";
  } else if(Items.getItem(testingFor + "_kills") > green_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+green+".png";
  } else {
    all_green = false;
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_black.png";
  }
  if(all_green) document.getElementById("game-panel-combat-select-area-panels-quickfight-northern_field").style.display = "";


  all_green = true;
  var testingFor = "ghost";
  if(Items.getItem(testingFor + "_kills") > cyan_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+cyan+".png";
  } else if(Items.getItem(testingFor + "_kills") > green_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+green+".png";
  } else {
    all_green = false;
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_black.png";
  }

  
  var testingFor = "grandma";
  if(Items.getItem(testingFor + "_kills") > cyan_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+cyan+".png";
  } else if(Items.getItem(testingFor + "_kills") > green_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+green+".png";
  } else {
    all_green = false;
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_black.png";
  }

  
  var testingFor = "exorcist";
  if(Items.getItem(testingFor + "_kills") > cyan_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+cyan+".png";
  } else if(Items.getItem(testingFor + "_kills") > green_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+green+".png";
  } else {
    all_green = false;
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_black.png";
  }

  
  var testingFor = "reaper";
  if(Items.getItem(testingFor + "_kills") > cyan_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+cyan+".png";
  } else if(Items.getItem(testingFor + "_kills") > green_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+green+".png";
  } else {
    all_green = false;
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_black.png";
  }
  if(all_green) document.getElementById("game-panel-combat-select-area-panels-quickfight-mansion").style.display = "";


  all_green = true;
  var testingFor = "shark";
  if(Items.getItem(testingFor + "_kills") > cyan_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+cyan+".png";
  } else if(Items.getItem(testingFor + "_kills") > green_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+green+".png";
  } else {
    all_green = false;
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_black.png";
  }

  
  var testingFor = "sea_soldier";
  if(Items.getItem(testingFor + "_kills") > cyan_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+cyan+".png";
  } else if(Items.getItem(testingFor + "_kills") > green_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+green+".png";
  } else {
    all_green = false;
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_black.png";
  }

  
  var testingFor = "puffer_fish";
  if(Items.getItem(testingFor + "_kills") > cyan_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+cyan+".png";
  } else if(Items.getItem(testingFor + "_kills") > green_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+green+".png";
  } else {
    all_green = false;
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_black.png";
  }

  
  var testingFor = "saltwater_crocodile";
  if(Items.getItem(testingFor + "_kills") > cyan_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+cyan+".png";
  } else if(Items.getItem(testingFor + "_kills") > green_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+green+".png";
  } else {
    all_green = false;
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_black.png";
  }
  if(all_green) document.getElementById("game-panel-combat-select-area-panels-quickfight-beach").style.display = "";


  //blood stuff
  all_green = true;
  var testingFor = "blood_chicken";
  if(Items.getItem(testingFor + "_kills") > cyan_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+cyan+".png";
  } else if(Items.getItem(testingFor + "_kills") > green_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+green+".png";
  } else {
    all_green = false;
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_black.png";
  }

  var testingFor = "blood_rat";
  if(Items.getItem(testingFor + "_kills") > cyan_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+cyan+".png";
  } else if(Items.getItem(testingFor + "_kills") > green_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+green+".png";
  } else {
    all_green = false;
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_black.png";
  }
  var testingFor = "blood_spider";
  if(Items.getItem(testingFor + "_kills") > cyan_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+cyan+".png";
  } else if(Items.getItem(testingFor + "_kills") > green_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+green+".png";
  } else {
    all_green = false;
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_black.png";
  }
  var testingFor = "blood_lizard";
  if(Items.getItem(testingFor + "_kills") > cyan_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+cyan+".png";
  } else if(Items.getItem(testingFor + "_kills") > green_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+green+".png";
  } else {
    all_green = false;
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_black.png";
  }
  var testingFor = "blood_bee";
  if(Items.getItem(testingFor + "_kills") > cyan_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+cyan+".png";
  } else if(Items.getItem(testingFor + "_kills") > green_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+green+".png";
  } else {
    all_green = false;
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_black.png";
  }
  if(all_green) document.getElementById("game-panel-combat-select-area-panels-quickfight-blood_field").style.display = "";

  all_green = true;
  var testingFor = "blood_snake";
  if(Items.getItem(testingFor + "_kills") > cyan_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+cyan+".png";
  } else if(Items.getItem(testingFor + "_kills") > green_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+green+".png";
  } else {
    all_green = false;
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_black.png";
  }

  var testingFor = "blood_ants";
  if(Items.getItem(testingFor + "_kills") > cyan_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+cyan+".png";
  } else if(Items.getItem(testingFor + "_kills") > green_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+green+".png";
  } else {
    all_green = false;
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_black.png";
  }

  var testingFor = "blood_wolf";
  if(Items.getItem(testingFor + "_kills") > cyan_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+cyan+".png";
  } else if(Items.getItem(testingFor + "_kills") > green_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+green+".png";
  } else {
    all_green = false;
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_black.png";
  }

  var testingFor = "blood_forest_ent";
  if(Items.getItem(testingFor + "_kills") > cyan_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+cyan+".png";
  } else if(Items.getItem(testingFor + "_kills") > green_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+green+".png";
  } else {
    all_green = false;
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_black.png";
  }

  var testingFor = "blood_thief";
  if(Items.getItem(testingFor + "_kills") > cyan_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+cyan+".png";
  } else if(Items.getItem(testingFor + "_kills") > green_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+green+".png";
  } else {
    all_green = false;
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_black.png";
  }
  if(all_green) document.getElementById("game-panel-combat-select-area-panels-quickfight-blood_forest").style.display = "";

  all_green = true;
  var testingFor = "blood_bat";
  if(Items.getItem(testingFor + "_kills") > cyan_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+cyan+".png";
  } else if(Items.getItem(testingFor + "_kills") > green_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+green+".png";
  } else {
    all_green = false;
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_black.png";
  }

  var testingFor = "blood_goblin";
  if(Items.getItem(testingFor + "_kills") > cyan_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+cyan+".png";
  } else if(Items.getItem(testingFor + "_kills") > green_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+green+".png";
  } else {
    all_green = false;
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_black.png";
  }

  var testingFor = "blood_bear";
  if(Items.getItem(testingFor + "_kills") > cyan_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+cyan+".png";
  } else if(Items.getItem(testingFor + "_kills") > green_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+green+".png";
  } else {
    all_green = false;
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_black.png";
  }

  var testingFor = "blood_skeleton";
  if(Items.getItem(testingFor + "_kills") > cyan_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+cyan+".png";
  } else if(Items.getItem(testingFor + "_kills") > green_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+green+".png";
  } else {
    all_green = false;
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_black.png";
  }
  if(all_green) document.getElementById("game-panel-combat-select-area-panels-quickfight-blood_cave").style.display = "";


  all_green = true;
  var testingFor = "blood_fire_hawk";
  if(Items.getItem(testingFor + "_kills") > cyan_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+cyan+".png";
  } else if(Items.getItem(testingFor + "_kills") > green_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+green+".png";
  } else {
    all_green = false;
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_black.png";
  }

  var testingFor = "blood_fire_snake";
  if(Items.getItem(testingFor + "_kills") > cyan_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+cyan+".png";
  } else if(Items.getItem(testingFor + "_kills") > green_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+green+".png";
  } else {
    all_green = false;
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_black.png";
  }

  var testingFor = "blood_fire_golem";
  if(Items.getItem(testingFor + "_kills") > cyan_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+cyan+".png";
  } else if(Items.getItem(testingFor + "_kills") > green_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+green+".png";
  } else {
    all_green = false;
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_black.png";
  }

  var testingFor = "blood_fire_witch";
  if(Items.getItem(testingFor + "_kills") > cyan_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+cyan+".png";
  } else if(Items.getItem(testingFor + "_kills") > green_kills) {
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_"+green+".png";
  } else {
    all_green = false;
    document.getElementById("game-panel-combat-select-area-panels-monster-" + testingFor).src = cloudfront + testingFor + "_icon_black.png";
  }
  if(all_green) document.getElementById("game-panel-combat-select-area-panels-quickfight-blood_volcano").style.display = "";

}

static refresh_preset_equipment_icon()
  {
    for(var i = 1; i <= 5; i++)
    {
      document.getElementById("preset-equipment-icon-head-" + i).src = get_image("images/" + Items.getItemString("preset_head_" + i) + ".png");
      document.getElementById("preset-equipment-icon-body-" + i).src = get_image("images/" + Items.getItemString("preset_body_" + i) + ".png");
      document.getElementById("preset-equipment-icon-legs-" + i).src = get_image("images/" + Items.getItemString("preset_legs_" + i) + ".png");
      document.getElementById("preset-equipment-icon-gloves-" + i).src = get_image("images/" + Items.getItemString("preset_gloves_" + i) + ".png");
      document.getElementById("preset-equipment-icon-boots-" + i).src = get_image("images/" + Items.getItemString("preset_boots_" + i) + ".png");
      document.getElementById("preset-equipment-icon-weapon-" + i).src = get_image("images/" + Items.getItemString("preset_weapon_" + i) + ".png");
      document.getElementById("preset-equipment-icon-shield-" + i).src = get_image("images/" + Items.getItemString("preset_shield_" + i) + ".png");
      document.getElementById("preset-equipment-icon-amulet-" + i).src = get_image("images/" + Items.getItemString("preset_amulet_" + i) + ".png");
      document.getElementById("preset-equipment-icon-arrows-" + i).src = get_image("images/" + Items.getItemString("preset_arrows_" + i) + ".png");
    }
  }


  static hasArrowsEquipped()
  {
    return Items.getItemString("arrows") != "none"
  }

  static go_to_monster_drop(monster_name)
  {
    websocket.send('READ_COMBAT_LOG');
    switch_panels('panel-combat-log');
    setTimeout(function() {
      var combat_log_table = document.getElementById("combat-log-table-" + monster_name);
      combat_log_table.scrollIntoView();
  
      var button = combat_log_table.getElementsByTagName("button");
      $(button).click();
    }, 2000)
   
   
  }

  static show_loot_button(btn, id)
  {
    var table = document.getElementById("combat-log-table-" + id)
    var tr_array = table.getElementsByTagName("tr");
    for(var i = 0 ; i < tr_array.length; i++)
    {
      tr_array[i].style.display = "";
    }

    btn.style.display = "none";
  }

  static _modal_load_blood_area_data(area)
  {
    var title;
    var image_path;
    var common_monsters_array;
    var rare_monsters_array;
    var energy;
    var fightpoints;

    switch(area)
    {
      case "blood_field":
        title = "BLOOD FIELDS";
        image_path = "images/blood_field.png";
        common_monsters_array = ["blood_chicken", "blood_rat", "blood_spider"];
        rare_monsters_array = ["blood_lizard", "blood_bee"];
        energy = 2000;
        fightpoints = 1000;
        document.getElementById("modal-fight-blood-areas-warning").innerHTML = ""
      break;

      case "blood_forest":
        title = "BLOOD FOREST";
        image_path = "images/blood_forest.png";
        common_monsters_array = ["blood_snake", "blood_ants", "blood_wolf"];
        rare_monsters_array = ["blood_forest_ent", "blood_thief"];
        energy = 4000;
        fightpoints = 2000;
        document.getElementById("modal-fight-blood-areas-warning").innerHTML = ""
      break;

      case "blood_cave":
        title = "BLOOD CAVE";
        image_path = "images/blood_cave.png";
        common_monsters_array = ["blood_bat", "blood_goblin", "blood_bear"];
        rare_monsters_array = ["blood_skeleton"];
        energy = 6000;
        fightpoints = 3500;
        document.getElementById("modal-fight-blood-areas-warning").innerHTML = ""
      break;

      case "blood_volcano":
        title = "BLOOD VOLCANO";
        image_path = "images/blood_volcano.png";
        common_monsters_array = ["blood_fire_hawk", "blood_fire_snake", "blood_fire_golem"];
        rare_monsters_array = ["blood_fire_witch"];
        energy = 10000;
        fightpoints = 5000;
        document.getElementById("modal-fight-blood-areas-warning").innerHTML = ""
      break;
    }

    var html = "";

    var monsters = common_monsters_array.concat(rare_monsters_array);
    for(var i = 0; i < monsters.length; i++) {
      var monster = monsters[i];
      var has_kills = Items.getItem(monster + "_kills") > 0;

      html += "<div class='fight-area-select-monster-card'>";
      html += '<wiki class="wiki" style="float:right;margin-top:-15px;" onclick="event.stopPropagation()"><a href="https://database.idle-pixel.com/'+monster+'/" target="_blank"><img class="hover" src="https://cdn.idle-pixel.com/images/search.png"></a></wiki>';
        html += capitalizeFirstLetter(get_item_name(monster));
        html += "<div class='center'>";

        if(has_kills)
          html += "<img class='w100' src='https://cdn.idle-pixel.com/images/"+monster+"_icon.png' />";
        else
          html += "<img class='w100'  src='https://cdn.idle-pixel.com/images/"+monster+"_icon_black.png' />";
        html += "</div>";

        
        var drops = Combat.get_monster_drops(monster)
        html += "<div class='hover' onclick='event.stopPropagation();websocket.send(\"VIEW_MONSTER_LOOT_DIALOGUE="+monster+"\")'>";
        for(var j = 0; j < drops.length; j++) {
          var drop = drops[j];
          var obtained_style = "style='border-radius:3pt; background-color:#FEB8B8;margin:2px;padding:2px;'"
          if(Items.getItem(monster + "_" + drop) > 0) obtained_style = "style='border-radius:3pt; background-color:#C1FEB8;margin:2px;padding:2px;'"
          html += "<img "+obtained_style+" src='https://cdn.idle-pixel.com/images/"+drop+".png' class='w30' />";
        }
        html += "</div>";

        if(Items.getItem("rare_monster_potion") > 0) {
          html += "<center><div onclick='websocket.send(\"DRINK_SELECT_POTION="+monster.split("_")[1]+"\");' class='rare-monster-pot-shortcut hover'>";
          html += "<img class='w20'  src='https://cdn.idle-pixel.com/images/rare_monster_potion.png' />"
          html += " Drink"
          html += "</div></center>";
        }
        
      html += "</div>";
    }
    
    // var extraTH = "";
    // if (Items.getItem("rare_monster_potion") > 0) {
    //   extraTH = "<th>Drink</th>"
    // }
    

    // //common monsters
    // html += "<center><table width='70%' class='combat-modal-monster-table'>";
    // html += "<tr style='background-color:silver;'><th style='width:30%'>Common Monsters</th><th>Kills</th><th>Drop table</th><th><img class='w20' src='https://cdn.idle-pixel.com/images/invention.png' /> Tablette</th><th>Strategies</th><th>Best Kill Time</th>"+extraTH+"</tr>"
    // for(var i = 0; i< common_monsters_array.length; i++) {
    //   var monster = common_monsters_array[i];
    //   var has_kills = Items.getItem(monster + "_kills") > 0;
    //   html += "<tr>";

    //     html += "<td>";
    //       if(has_kills)
    //         html += "<img src='https://cdn.idle-pixel.com/images/"+monster+"_icon.png' />";
    //       else
    //         html += "<img src='https://cdn.idle-pixel.com/images/"+monster+"_icon_black.png' />";
    //     html += "</td>";

    //     html += "<td>";
    //       html += Items.getItem(monster + "_kills");
    //     html += "</td>";


    //     html += "<td>";
    //         var values = Monsters.get_total_drops_for_loot_button(monster);
    //         var drops_obtained = values[0];
    //         var drops_total = values[1];
    //         if(Items.getItem(monster + "_kills") > 0)
    //         {
    //           var style = "";
    //           if(drops_obtained == drops_total) style="background-color:lime;"; else style="background-color:yellow;";
    //           html += "<input type='button' class='monster-loot-button hover' style='"+style+"' onclick='websocket.send(\"VIEW_MONSTER_LOOT_DIALOGUE="+monster+"\")' value='Loot "+(drops_obtained + "/" + drops_total)+"' />";
    //         }
    //         else
    //           html += "<button class='monster-loot-button hover' style='cursor:not-allowed;background-color:red;' onclick='Modals.cannot_view_loot()'><strike>Loot "+(0 + "/" + drops_total)+"</strike></button>";
    //     html += "</td>";

    //     html += "<td>";
    //         if(MonsterDescriptions.data[monster]["tablette"] != null) {
    //           var tablette = MonsterDescriptions.data[monster]["tablette"]
    //           var checkImg = "https://cdn.idle-pixel.com/images/x.png";
    //           if(Items.getItem(monster + "_" + tablette) > 0)
    //             checkImg = "https://cdn.idle-pixel.com/images/check.png";
    //           html += "<img src='https://cdn.idle-pixel.com/images/"+tablette+".png' class='w20' /> <img src='"+checkImg+"' class='w20' /> ";
    //         }
          
    //     html += "</td>";

    //     html += "<td>";
    //     if(MonsterDescriptions.data[monster]["stratergy"] != "None")
    //         html += "<input type='button'  class='monster-loot-button hover' onclick='Modals.open_monster_description(\""+monster+"\")' value='Read' />";
    //       else 
    //         html += "<span class='color-grey'>(None)</span>"
    //     html += "</td>";

    //     html += "<td class='color-grey'>";
    //       if(Items.getItem(monster + "_record_killtime") > 0) html += Items.getItem(monster + "_record_killtime") + " seconds";
    //       else html += "(unset)";
    //     html += "</td>";

    //     if (Items.getItem("rare_monster_potion") > 0) {
    //       html += "<td class='color-grey'>";
    //       html +=  "<img onclick='websocket.send(\"DRINK_SELECT_POTION="+monster.replace("blood_", "")+"\")' src='https://cdn.idle-pixel.com/images/rare_monster_potion.png' class='hover w30' />";
    //       html += "</td>";
    //     }
        

    //   html += "</tr>";
    // }
    // html += "</table></center>";

    // document.getElementById("modal-fight-blood-areas-monster-info").innerHTML = html;

    // //rare monsters
    // html = "";
    // html += "<center><table width='70%' class='combat-modal-monster-table'>";
    // html += "<tr style='background-color:silver;'><th style='width:30%'>Rare Monsters</th><th>Kills</th><th>Drop table</th><th><img class='w20' src='https://cdn.idle-pixel.com/images/invention.png' /> Tablette</th><th>Strategies</th><th>Best Kill Time</th>"+extraTH+"</tr>"
    // for(var i = 0; i< rare_monsters_array.length; i++) {
    //   var monster = rare_monsters_array[i];
    //   var has_kills = Items.getItem(monster + "_kills") > 0;
    //   html += "<tr>";


    //     html += "<td>";
    //       if(has_kills)
    //         html += "<img src='https://cdn.idle-pixel.com/images/"+monster+"_icon.png' />";
    //       else
    //         html += "<img src='https://cdn.idle-pixel.com/images/"+monster+"_icon_black.png' />";
    //     html += "</td>";

    //     html += "<td>";
    //       html += Items.getItem(monster + "_kills");
    //     html += "</td>";

    //     html += "<td>";
    //         var values = Monsters.get_total_drops_for_loot_button(monster);
    //         var drops_obtained = values[0];
    //         var drops_total = values[1];
    //         if(Items.getItem(monster + "_kills") > 0)
    //         {
    //           var style = "";
    //           if(drops_obtained == drops_total) style="background-color:lime;"; else style="background-color:yellow;";
    //           html += "<input type='button' class='monster-loot-button hover' style='"+style+"' onclick='websocket.send(\"VIEW_MONSTER_LOOT_DIALOGUE="+monster+"\")' value='Loot "+(drops_obtained + "/" + drops_total)+"' />";
    //         }
    //         else
    //           html += "<button class='monster-loot-button hover' style='cursor:not-allowed;background-color:red;' onclick='Modals.cannot_view_loot()'><strike>Loot "+(0 + "/" + drops_total)+"</strike></button>";
    //     html += "</td>";
        
        
    //     html += "<td>";
    //         if(MonsterDescriptions.data[monster]["tablette"] != null) {
    //           var tablette = MonsterDescriptions.data[monster]["tablette"]
    //           var checkImg = "https://cdn.idle-pixel.com/images/x.png";
    //           if(Items.getItem(monster + "_" + tablette) > 0)
    //             checkImg = "https://cdn.idle-pixel.com/images/check.png";
    //           html += "<img src='https://cdn.idle-pixel.com/images/"+tablette+".png' class='w20' /> <img src='"+checkImg+"' class='w20' /> ";
    //         }
          
    //     html += "</td>";
        
    //     html += "<td>";
    //         if(MonsterDescriptions.data[monster]["stratergy"] != "None")
    //         html += "<input type='button'  class='monster-loot-button hover' onclick='Modals.open_monster_description(\""+monster+"\")' value='Read' />";
    //       else 
    //         html += "<span class='color-grey'>(None)</span>"
    //     html += "</td>";

    //     html += "<td class='color-grey'>";
    //       if(Items.getItem(monster + "_record_killtime") > 0) html += Items.getItem(monster + "_record_killtime") + " seconds";
    //       else html += "(unset)";
    //     html += "</td>";

    //     if (Items.getItem("rare_monster_potion") > 0) {
    //       html += "<td class='color-grey'>";
    //       html +=  "<img onclick='websocket.send(\"DRINK_SELECT_POTION="+monster.replace("blood_", "")+"\")' src='https://cdn.idle-pixel.com/images/rare_monster_potion.png' class='hover w30' />";
    //       html += "</td>";
    //     }

    //   html += "</tr>";
    // }
    // html += "</table></center>";

    document.getElementById("modal-fight-blood-areas-monster-rare-info").innerHTML = html;


    set_innerHTML("modal-fight-blood-areas-area-title", title);
    document.getElementById("modal-fight-blood-areas-image-body").style.background = "url('https://cdn.idle-pixel.com/"+image_path+"') no-repeat";
    document.getElementById("modal-fight-blood-areas-image-body").style.backgroundSize = 'cover'; 

    var energy_check_or_x_img = "<img src='https://cdn.idle-pixel.com/images/x.png' class='w15'>"
    if(Items.getItem('energy') >= energy)
      energy_check_or_x_img = "<img src='https://cdn.idle-pixel.com/images/check.png' class='w15'>"

    var fightpoints_check_or_x_img = "<img src='https://cdn.idle-pixel.com/images/x.png' class='w15'>"
      if(Items.getItem('fight_points') >= fightpoints)
      fightpoints_check_or_x_img = "<img src='https://cdn.idle-pixel.com/images/check.png' class='w15'>"


    set_innerHTML("modal-fight-blood-areas-energy", format_number(energy) + " " + energy_check_or_x_img);
    set_innerHTML("modal-fight-blood-areas-fightpoints", format_number(fightpoints) + " " + fightpoints_check_or_x_img);
    document.getElementById("modal-fight-blood-areas-fight-button").onclick = function()
    {
        websocket.send("START_FIGHT=" + Combat.modal_blood_area_last_selected)
        Globals.last_area_fight = Combat.modal_blood_area_last_selected;
    }
  }

  static clicksCollectAndFight() {
    websocket.send('START_FIGHT=' + Globals.last_area_fight)
  }

  // blood moon stuff
  static modal_load_blood_area_data()
  {
      document.getElementById("modal-fight-blood-area-left-arrow").style.visibility = "";
      document.getElementById("modal-fight-blood-area-right-arrow").style.visibility = "";
      document.getElementById("modal-fight-blood-areas-warning").innerHTML = "";
      

      if(Combat.modal_blood_area_last_selected == "blood_field")
      {
        document.getElementById("modal-fight-blood-area-left-arrow").style.visibility = "hidden";

        
        document.getElementById("modal-fight-blood-area-right-arrow").onclick = function()
        {
          document.getElementById("modal-fight-blood-area-right-arrow").style.visibility = "none";
            Combat.modal_blood_area_last_selected = "blood_forest";
            Combat.modal_load_blood_area_data();
        }
      }


      if(Combat.modal_blood_area_last_selected == "blood_forest")
      {
    
        document.getElementById("modal-fight-blood-area-left-arrow").onclick = function()
        {
          document.getElementById("modal-fight-blood-area-left-arrow").style.visibility = "";
            Combat.modal_blood_area_last_selected = "blood_field";
            Combat.modal_load_blood_area_data();
        }

        
        document.getElementById("modal-fight-blood-area-right-arrow").onclick = function()
        {
          document.getElementById("modal-fight-blood-area-right-arrow").style.visibility = "none";
            Combat.modal_blood_area_last_selected = "blood_cave";
            Combat.modal_load_blood_area_data();
        }
      }

      if(Combat.modal_blood_area_last_selected == "blood_cave")
      {
        document.getElementById("modal-fight-blood-area-left-arrow").onclick = function()
        {
          document.getElementById("modal-fight-blood-area-left-arrow").style.visibility = "";
            Combat.modal_blood_area_last_selected = "blood_forest";
            Combat.modal_load_blood_area_data();
        }

        document.getElementById("modal-fight-blood-area-right-arrow").onclick = function()
        {
          document.getElementById("modal-fight-blood-area-right-arrow").style.visibility = "none";
            Combat.modal_blood_area_last_selected = "blood_volcano";
            Combat.modal_load_blood_area_data();
        }
      }

      if(Combat.modal_blood_area_last_selected == "blood_volcano")
      {

        document.getElementById("modal-fight-blood-area-left-arrow").onclick = function()
        {
          document.getElementById("modal-fight-blood-area-left-arrow").style.visibility = "";
            Combat.modal_blood_area_last_selected = "blood_cave";
            Combat.modal_load_blood_area_data();
        }

        document.getElementById("modal-fight-blood-area-right-arrow").onclick = function()
        {
            Combat.modal_blood_area_last_selected = "blood_castle";
            Combat.modal_load_blood_area_data();
        }

      }

      if(Combat.modal_blood_area_last_selected == "blood_castle")
      {
          Modals.toggle('modal-fight-blood-areas')
          Modals.open_faradox_castle();
          return;
      }



      Combat._modal_load_blood_area_data(Combat.modal_blood_area_last_selected)
    }

    static BADGES = {
      'badge_field_fp_reduction': 'Reduces the FP needed for fields by 25%.',
      'badge_chicken_feather': 'Gain twice as many feathers everytime you kill a chicken.',
      'badge_spider_poison': 'Forest snake will cast poison more often, but will drop poison 100% of the time.',
      'badge_ant_needles': 'Gain twice as many ant needles everytime you kill an ant.',
      'badge_strange_leaf': '50% chance of obtaining a second strange leaf from normal ents.',
      'badge_coin_thief': 'Steal 10x the gold from the thief when defeating him.',

      'badge_ten_melee_levels_hp': 'Increases your maximum <b class="color-pink">HP</b> by 1 permanently for every 10 melee levels gained.',
      'badge_ten_archery_levels_hp': 'Increases your maximum <b class="color-pink">HP</b> by 1 permanently for every 10 archery levels gained.',
      'badge_ten_magic_levels_hp': 'Increases your maximum <b class="color-cyan">MANA</b> by 1 permanently for every 10 magic levels gained.',
      'badge_pine_logs': '100% chance of obtaining pine logs for every kill in northern fields.',
      'badge_skeleton_bones': 'Always roll the highest amount of bones possible on skeletons.',
      'badge_molten_glass': 'Double molten glass from volcano.',
      'badge_wield_bucket': 'Double lava from volcano.',
      'badge_fire_hawk_feather': 'Gain twice as many feathers everytime you kill a fire hawk.',
      'badge_ice_hawk_feather': 'Gain twice as many feathers everytime you kill an ice hawk.',
      'badge_grow_pine_farming': 'Killing any enemy in the northern fields will cause your pine trees to grow instantly. (Farming)',
      'badge_grow_pine_woodcutting': 'Killing any enemy in the northern fields will cause your pine trees to grow instantly (Woodcutting)',

      'badge_free_spell_cast': 'The first magic spell casted in combat will not consume any mana.',
      'badge_ghost_essence': 'Double ghost essence loot.',
      'beach_fp_refund': 'Dying to the beach will refund your fightpoints.',
      'badge_double_shark_tooth': 'Doubles your chances of finding the shark tooth drop.',
      'badge_beach_mega_bait': 'Increasing your chances of looting mega bait at beach by 50% chance ',
      'badge_double_guardian_key_one': '50% of getting a second green guardian key when looted.',
      'badge_tsunami': 'Very rarely, sometimes fighting on the beach might trigger a tsunami.',
      'badge_sea_soldier_helmet': 'Doubles the drop rate for the sea soldier helmet.',

      'badge_critical_strike': 'Every 5th melee or archery hit will critical strike.',
      'badge_blood_limbs': '50% chance of getting two limbs instead of one for all blood areas.',
      'badge_double_tnt': '5% chance of blood fire golem to drop a mega tnt.',
      'badge_double_guardian_key_two': 'Eating bloated sharks will always give you two guardian keys.',
      'badge_death_1_hp': 'If you die, you will be revieved with 1 hp, allowing you to potentially squeeze in one more hit.',
      'badge_10_percent_fp': '10% chance of not using any FP when fighting anywhere.',
      'badge_10_percent_energy': '10% chance of not using any energy when fighting anywhere.',

      'badge_ancient_tablette': 'Ability to loot a unique ancient tablette pieces from any blood monster.',
      'badge_double_loot': '50% chance of doubling your loot on all monsters.',
      'badge_20_hp': 'Increases your max HP by 20.',
    }
    static purchase_badge(badge_name) {
      if(Items.getItem(badge_name) >= 1) {
        Modals.open_image_modal("BADGE", "images/" + badge_name + ".png", Combat.BADGES[badge_name] + "<br /><br /><span class='color-grey'>You already have this badge unlocked</span>", null, "Close", null);
      } else {
        Modals.open_image_modal("BADGE", "images/" + badge_name + ".png", Combat.BADGES[badge_name], "Unlock!", "Cancel", "UNLOCK_BADGE=" + badge_name);
      }
      
    }

    static refresh_badge_screen() {
      for (var key in Combat.BADGES) {
        if (Combat.BADGES.hasOwnProperty(key)) {
            if(Items.getItem(key) >= 1) {
              document.getElementById(key).classList.add('badge-unlocked');
            }
        }
      }
    }


    static getBadgesOwnedVsTotal() {
      var unlocked = 0;
      var total = 0;
      for (var key in Combat.BADGES) {
        if (Combat.BADGES.hasOwnProperty(key)) {
            if(Items.getItem(key) >= 1) {
              document.getElementById(key).classList.add('badge-unlocked');
              unlocked++;
            }
            total++;
        }
      }
      
      return {
        "unlocked": unlocked,
        "total": total
      }
    }

    static refreshLabelCombat() {
      var data = Combat.getBadgesOwnedVsTotal();
      document.getElementById("badge-main-combat-label").innerHTML = data['unlocked'] + "/" + data['total'];
    }

    static refreshBadgeLabels() {
      Combat.refresh_badge_screen();
      var pointsGained =  Items.getItem("badge_points_gained");
      var pointsUsed = Items.getItem("badge_points_used");
      var currentPoints = pointsGained - pointsUsed;
      document.getElementById("badge-points-left-label").innerHTML = format_number(currentPoints);
    }
}