class Cooking
{

  static _click_events_loaded = false;

  static LOG_HEAT_MAP = {
    "logs": 1,
    "oak_logs": 2,
    "willow_logs": 3,
    "maple_logs": 4,
    "stardust_logs": 5,
    "pine_logs": 6,
    "redwood_logs": 7,
    "dense_logs": 20,
  }


  static LEVELS_MAP = {
    "raw_chicken": 1,
    "raw_bird_meat": 5,
    "raw_meat": 10,
    "raw_shrimp": 1,
    "raw_shrimp_shiny": 1,
    "raw_shrimp_mega_shiny": 1,
    "raw_anchovy": 5,
    "raw_anchovy_shiny": 5,
    "raw_anchovy_mega_shiny": 5,
    "raw_sardine": 10,
    "raw_sardine_shiny": 10,
    "raw_sardine_mega_shiny": 10,
    "raw_crab": 35,
    "raw_crab_shiny": 35,
    "raw_crab_mega_shiny": 35,
    "raw_piranha": 50,
    "raw_piranha_shiny": 50,
    "raw_piranha_mega_shiny": 50,
    "raw_salmon": 10,
    "raw_salmon_shiny": 10,
    "raw_salmon_mega_shiny": 10,
    "raw_trout": 20,
    "raw_trout_shiny": 20,
    "raw_trout_mega_shiny": 20,
    "cooked_trout_shiny": 20,
    "raw_pike": 35,
    "raw_pike_shiny": 35,
    "raw_pike_mega_shiny": 35,
    "raw_eel": 55,
    "raw_eel_shiny": 55,
    "raw_eel_mega_shiny": 55,
    "raw_rainbow_fish": 70,
    "raw_rainbow_fish_shiny": 70,
    "raw_rainbow_fish_mega_shiny": 70,
    "raw_tuna": 35,
    "raw_tuna_shiny": 35,
    "raw_tuna_mega_shiny": 35,
    "raw_swordfish": 50,
    "raw_swordfish_shiny": 50,
    "raw_swordfish_mega_shiny": 50,
    "raw_manta_ray": 75,
    "raw_manta_ray_shiny": 75,
    "raw_manta_ray_mega_shiny": 75,
    "raw_shark": 82,
    "raw_bloated_shark": 82,
    "raw_shark_shiny": 82,
    "raw_shark_mega_shiny": 82,
    "raw_whale": 90,
    "raw_whale_shiny": 90,
    "raw_whale_mega_shiny": 90,
    "raw_small_stardust_fish": 50,
    "raw_medium_stardust_fish": 60,
    "raw_large_stardust_fish": 70,
    "raw_angler_fish": 100,
  }
  static ENERGY_MAP = {
      "maggots": 1,
      "candy": 1,
      "cheese": 25,
      "apple": 25,
      "maple_syrup": 125,
      "honey": 30,
      "banana": 50,
      "orange": 100,
      "raw_chicken": 50,
      "raw_bird_meat": 100,
      "raw_meat": 200,
      "cooked_chicken": 50,
      "cooked_meat": 200,
      "cooked_bird_meat": 100,
      "coconut": 1000,
      "dragon_fruit": 20000,
      "bread": 500,
      "eggplant": 5000,

      "potato": 1000,
      "carrot": 2000,
      "beet": 3000,
      "broccoli": 5000,

      "raw_shrimp": 25,
      "raw_anchovy": 100,
      "raw_sardine": 200,
      "raw_crab": 500,
      "raw_piranha": 1000,
      "raw_salmon": 100,
      "raw_trout": 300,
      "raw_pike": 1000,
      "raw_eel": 3000,
      "raw_rainbow_fish": 30000,
      "raw_tuna": 500,
      "raw_swordfish": 3000,
      "raw_manta_ray": 9000,
      "raw_shark": 20000,
      "raw_bloated_shark": 20000,
      "raw_whale": 40000,

      "raw_angler_fish": 100000,

      "raw_shrimp_shiny": 25 *5,
      "raw_anchovy_shiny": 100 *5,
      "raw_sardine_shiny": 200 *5,
      "raw_crab_shiny": 500 *5,
      "raw_piranha_shiny": 1000 *5,
      "raw_salmon_shiny": 100 *5,
      "raw_trout_shiny": 300 *5,
      "raw_pike_shiny": 1000 *5,
      "raw_eel_shiny": 3000 *5,
      "raw_rainbow_fish_shiny": 30000 * 5,
      "raw_tuna_shiny": 500 *5,
      "raw_swordfish_shiny": 3000 *5,
      "raw_manta_ray_shiny": 9000 *5,
      "raw_shark_shiny": 20000 *5,
      "raw_whale_shiny": 40000 *5,

      "raw_shrimp_mega_shiny": 25 *25,
      "raw_anchovy_mega_shiny": 100 *25,
      "raw_sardine_mega_shiny": 200 *25,
      "raw_crab_mega_shiny": 500 *25,
      "raw_piranha_mega_shiny": 1000 *25,
      "raw_salmon_mega_shiny": 100 *25,
      "raw_trout_mega_shiny": 300 *25,
      "raw_pike_mega_shiny": 1000 *25,
      "raw_eel_mega_shiny": 3000 *25,
      "raw_rainbow_fish_mega_shiny": 30000 *25,
      "raw_tuna_mega_shiny": 500 *25,
      "raw_swordfish_mega_shiny": 3000 *25,
      "raw_manta_ray_mega_shiny": 9000 *25,
      "raw_shark_mega_shiny": 20000 *25,
      "raw_whale_mega_shiny": 40000 *25,
      
      "cooked_shrimp": 25,
      "cooked_anchovy": 100,
      "cooked_sardine": 200,
      "cooked_crab": 500,
      "cooked_piranha": 1000,
      "cooked_salmon": 100,
      "cooked_trout": 300,
      "cooked_pike": 1000,
      "cooked_eel": 3000,
      "cooked_rainbow_fish": 30000,
      "cooked_tuna": 500,
      "cooked_swordfish": 3000,
      "cooked_manta_ray": 9000,
      "cooked_shark": 20000,
      "cooked_whale": 40000,
      

      "cooked_shrimp_shiny": 25*5,
      "cooked_anchovy_shiny": 100*5,
      "cooked_sardine_shiny": 200*5,
      "cooked_crab_shiny": 500*5,
      "cooked_piranha_shiny": 1000*5,
      "cooked_salmon_shiny": 100*5,
      "cooked_trout_shiny": 300*5,
      "cooked_pike_shiny": 1000*5,
      "cooked_eel_shiny": 3000*5,
      "cooked_rainbow_fish_shiny": 30000*5,
      "cooked_tuna_shiny": 500*5,
      "cooked_swordfish_shiny": 3000*5,
      "cooked_manta_ray_shiny": 9000*5,
      "cooked_shark_shiny": 20000*5,
      "cooked_whale_shiny": 40000*5,

      "cooked_shrimp_mega_shiny": 25*25,
      "cooked_anchovy_mega_shiny": 100*25,
      "cooked_sardine_mega_shiny": 200*25,
      "cooked_crab_mega_shiny": 500*25,
      "cooked_piranha_mega_shiny": 1000*25,
      "cooked_salmon_mega_shiny": 100*25,
      "cooked_trout_mega_shiny": 300*25,
      "cooked_pike_mega_shiny": 1000*25,
      "cooked_eel_mega_shiny": 3000*25,
      "cooked_rainbow_fish_mega_shiny": 30000*25,
      "cooked_tuna_mega_shiny": 500*25,
      "cooked_swordfish_mega_shiny": 3000*25,
      "cooked_manta_ray_mega_shiny": 9000*25,
      "cooked_shark_mega_shiny": 20000*25,
      "cooked_whale_mega_shiny": 40000*25,

      "cooked_bloated_shark": 20000,
      "cooked_angler_fish": 100000,
      
      "raw_small_stardust_fish": 1000,
      "raw_medium_stardust_fish": 2500,
      "raw_large_stardust_fish": 5000,
      "cooked_small_stardust_fish": 1000,
      "cooked_medium_stardust_fish": 2500,
      "cooked_large_stardust_fish": 5000,

      "egg": 50,
      "chocolate": 75,


      "dotted_salad": 1000,
      "chocolate_cake": 1500,
      "lime_leaf_salad": 2000,
      "golden_apple": 2500,
      "banana_jello": 3500,
      "orange_pie": 6000,
      "pancakes": 8000,
      "coconut_stew": 15000,
      "dragon_fruit_salad": 200000,

      "potato_shake": 300000,
      "carrot_shake": 400000,
      "beet_shake": 600000,
      "broccoli_shake": 1000000,
  }


  static FOOD_HEAT_REQ_MAP = {
    "raw_chicken": 10,
    "raw_bird_meat": 20,
    "raw_meat": 40,

    // net
    "raw_shrimp": 10,
    "raw_anchovy": 20,
    "raw_sardine": 40,
    "raw_crab": 75,
    "raw_piranha": 120,

    // rod
    "raw_salmon": 20,
    "raw_trout": 40,
    "raw_pike": 110,
    "raw_eel": 280,
    "raw_rainbow_fish": 840,

    // harpoon
    "raw_tuna": 75,
    "raw_swordfish": 220,
    "raw_manta_ray": 1200,
    "raw_shark": 3000,
    "raw_bloated_shark": 3000,
    "raw_whale": 5000,

    "raw_angler_fish": 10000,

    // net (shiny)
    "raw_shrimp_shiny": 10,
    "raw_anchovy_shiny": 20,
    "raw_sardine_shiny": 40,
    "raw_crab_shiny": 75,
    "raw_piranha_shiny": 120,

    // rod (shiny)
    "raw_salmon_shiny": 20,
    "raw_trout_shiny": 40,
    "raw_pike_shiny": 110,
    "raw_eel_shiny": 280,
    "raw_rainbow_fish_shiny": 840,

    // harpoon (shiny)
    "raw_tuna_shiny": 75,
    "raw_swordfish_shiny": 220,
    "raw_manta_ray_shiny": 1200,
    "raw_shark_shiny": 3000,
    "raw_whale_shiny": 5000,


     // net (mega shiny)
     "raw_shrimp_mega_shiny": 10,
     "raw_anchovy_mega_shiny": 20,
     "raw_sardine_mega_shiny": 40,
     "raw_crab_mega_shiny": 75,
     "raw_piranha_mega_shiny": 120,
 
     // rod (mega shiny)
     "raw_salmon_mega_shiny": 20,
     "raw_trout_mega_shiny": 40,
     "raw_pike_mega_shiny": 110,
     "raw_eel_mega_shiny": 280,
     "raw_rainbow_fish_mega_shiny": 840,
 
     // harpoon (mega shiny)
     "raw_tuna_mega_shiny": 75,
     "raw_swordfish_mega_shiny": 220,
     "raw_manta_ray_mega_shiny": 1200,
     "raw_shark_mega_shiny": 3000,
     "raw_whale_mega_shiny": 5000,


    //stardust fish
    "raw_small_stardust_fish": 300,
    "raw_medium_stardust_fish": 600,
    "raw_large_stardust_fish": 2000,
    
  }

  static refresh_table()
  {
        Cooking._refresh_click_events();
        Cooking._refresh_materials();
  }

  static _refresh_materials()
  {
      var cooking_table = document.getElementById("cooks_book-table");
      var materials_req_array = cooking_table.getElementsByTagName("item-cooks_book-table");

      for(var i = 0; i < materials_req_array.length; i++)
      {
          var materials_req = materials_req_array[i];
          var item = materials_req.getAttribute("data-materials-item");

          if(Items.getItem(item) >= parseInt(materials_req.innerHTML))
              materials_req_array[i].style.color = "#00a200";
          else
              materials_req_array[i].style.color = "red";
      }
  }

    /**
     *  returns an array [item_name, amount, ...]
     */
   static get_ingredients(potion)
   {
       var array = [];
       var entry = $("tr[data-cooks_book-item='" + potion +"']");
       var materials = entry.find("item-cooks_book-table");
       materials.each(function (ele) {
           var amount = $(this).text();
           var material = $(this).attr("data-materials-item");
           array.push(material, amount);
       });

       return array;
   }

  static _refresh_click_events()
  {
      if(!Cooking._click_events_loaded)
      {
          var cooks_book_table = document.getElementById("cooks_book-table");
          var cooks_book_row_array = cooks_book_table.getElementsByTagName("tr");
  
          for(var i = 0; i < cooks_book_row_array.length; i++)
          {
              var cooks_book_row = cooks_book_row_array[i];
              if(!cooks_book_row.hasAttribute("data-cooks_book-item"))
                  continue;
  
              cooks_book_row.addEventListener('click', (e) =>
              {
                  var target_clicked = e.target;
                  var tr = target_clicked.closest("tr");
                  var cooks_book_row_item = tr.getAttribute("data-cooks_book-item");
                  Modals.open_cooks_book_dialogue(cooks_book_row_item);
              });
          }
          Cooking._click_events_loaded = true;
      }
      
  }

  static get_energy(food)
  {
    var energy = Cooking.ENERGY_MAP[food];
    if(Achievements.has_completed_set("cooking", "medium"))
    {
        if(food == "apple" || 
          food == "banana" || 
          food == "orange" || 
          food == "coconut" ||
          food == "dragon_fruit"
        )
        {
            energy *= 1.25;
        }
    }
    return parseInt(energy);
  }

  static clicks_food(food)
  {
    var dict = {}
    dict[food] = 1;
    Modals.open_modern_input_dialogue_with_value(
      food,
        "images/" + food + ".png",
        dict,
        "MAX",
        "<span class='color-grey'><img src='https://cdn.idle-pixel.com/images/energy.png' /> +" + Cooking.get_energy(food) + " each</span>",
        'Consume',
        'CONSUME=' + food
    );
  }

  static can_cook_how_many(food)
  {
    var heat_required = Cooking.FOOD_HEAT_REQ_MAP[food];
    var food_amount = Items.getItem(food);
    var current_heat = Items.getItem("heat");

    var amount = parseInt(current_heat/heat_required);
    if(amount > food_amount)
    return food_amount;

    return amount;
  }

  static clicks_raw_food(food)
  {
      if(Items.getItem("cooking_unlocked") == 0)
      {
        Modals.open_image_modal("COOKING", "images/cooking.png", "You need to unlock the cooking skill to cook this.<br /><br /><span class='color-grey font-small'>You can unlock the cooking skill by crafting an oven.</span>", "Close", null , "");
        return;
      }

      Modals.open_cook_dialogue(food);
  }

  static getOvenBurnRate()
  {
      var testing_for = "";

      testing_for = "bronze_oven";
      if (Items.getItem(testing_for) == 1)
        return "0.5";

      testing_for = "iron_oven";
      if (Items.getItem(testing_for) == 1)
        return "0.4";

      testing_for = "silver_oven";
      if (Items.getItem(testing_for) == 1)
        return "0.3";
          
      testing_for = "gold_oven";
      if (Items.getItem(testing_for) == 1)
        return "0.2";

      testing_for = "promethium_oven";
      if (Items.getItem(testing_for) == 1)
        return "0.1";
      
      testing_for = "titanium_oven";
      if (Items.getItem(testing_for) == 1)
        return "0.05";

      testing_for = "ancient_oven";
      if (Items.getItem(testing_for) == 1)
        return "0.00";

      return 1;

  }

  static getHeatPerLog(log)
  {
    if(Achievements.has_completed_set("cooking", "easy"))
        return parseInt(Cooking.LOG_HEAT_MAP[log]) + 1;

    return Cooking.LOG_HEAT_MAP[log];
  }


  static getOven()
  {
      var testing_for = "";
    
      testing_for = "ancient_oven";
      if (Items.getItem(testing_for) == 1)
          return testing_for;
  
      testing_for = "titanium_oven";
      if (Items.getItem(testing_for) == 1)
          return testing_for;

      testing_for = "promethium_oven";
      if (Items.getItem(testing_for) == 1)
          return testing_for;
        
      testing_for = "gold_oven";
      if (Items.getItem(testing_for) == 1)
          return testing_for;

      testing_for = "silver_oven";
      if (Items.getItem(testing_for) == 1)
          return testing_for;

      testing_for = "iron_oven";
      if (Items.getItem(testing_for) == 1)
          return testing_for;

      testing_for = "bronze_oven";
      if (Items.getItem(testing_for) == 1)
          return testing_for;

      return 1;
  }

  static boilSaltWaterModal() {

    Modals.open_image_modal('Boil Salt', 'images/'+Cooking.getOven()+'.png', 'Boil the salt water to seperate the salt from the water?','Boil','Cancel','BOIL_SALT_WATER');
  }
  static refresh_chefs_hat() {
    if(Items.getItem("chefs_hat") == 0)
      return;

    if(Items.getItem("dotted_salad_prepared_total") >= 5) {
      document.getElementById("time-dotted_salad").innerHTML = "<img src='https://cdn.idle-pixel.com/images/chefs_hat.png' class='w15' /> " + " 6h";
    }
    if(Items.getItem("chocolate_cake_prepared_total") >= 5) {
      document.getElementById("time-chocolate_cake").innerHTML = "<img src='https://cdn.idle-pixel.com/images/chefs_hat.png' class='w15' /> " + " 7.5h";
    }
    if(Items.getItem("lime_leaf_salad_prepared_total") >= 5) {
      document.getElementById("time-lime_leaf_salad").innerHTML = "<img src='https://cdn.idle-pixel.com/images/chefs_hat.png' class='w15' /> " + " 9h";
    }
    if(Items.getItem("golden_apple_prepared_total") >= 5) {
      document.getElementById("time-golden_apple").innerHTML = "<img src='https://cdn.idle-pixel.com/images/chefs_hat.png' class='w15' /> " + " 10.5h";
    }
    if(Items.getItem("banana_jello_prepared_total") >= 5) {
      document.getElementById("time-banana_jello").innerHTML = "<img src='https://cdn.idle-pixel.com/images/chefs_hat.png' class='w15' /> " + " 12h";
    }
    if(Items.getItem("orange_pie_prepared_total") >= 5) {
      document.getElementById("time-orange_pie").innerHTML = "<img src='https://cdn.idle-pixel.com/images/chefs_hat.png' class='w15' /> " + " 14h";
    }
    if(Items.getItem("pancakes_prepared_total") >= 5) {
      document.getElementById("time-pancakes").innerHTML = "<img src='https://cdn.idle-pixel.com/images/chefs_hat.png' class='w15' /> " + " 15h";
    }
    if(Items.getItem("coconut_stew_prepared_total") >= 5) {
      document.getElementById("time-coconut_stew").innerHTML = "<img src='https://cdn.idle-pixel.com/images/chefs_hat.png' class='w15' /> " + " 20h";
    }
    if(Items.getItem("dragon_fruit_salad_prepared_total") >= 5) {
      document.getElementById("time-dragon_fruit_salad").innerHTML = "<img src='https://cdn.idle-pixel.com/images/chefs_hat.png' class='w15' /> " + " 30h";
    }
    if(Items.getItem("potato_shake_prepared_total") >= 5) {
      document.getElementById("time-potato_shake").innerHTML = "<img src='https://cdn.idle-pixel.com/images/chefs_hat.png' class='w15' /> " + " 40h";
    }
    if(Items.getItem("carrot_shake_prepared_total") >= 5) {
      document.getElementById("time-carrot_shake").innerHTML = "<img src='https://cdn.idle-pixel.com/images/chefs_hat.png' class='w15' /> " + " 44h";
    }
    if(Items.getItem("beet_shake_prepared_total") >= 5) {
      document.getElementById("time-beet_shake").innerHTML = "<img src='https://cdn.idle-pixel.com/images/chefs_hat.png' class='w15' /> " + " 50h";
    }
    if(Items.getItem("broccoli_shake_prepared_total") >= 5) {
      document.getElementById("time-broccoli_shake").innerHTML = "<img src='https://cdn.idle-pixel.com/images/chefs_hat.png' class='w15' /> " + " 60h";
    }
  }


  static get_potential_energy() {
    var energy_potential = 0;
    for (var k in Cooking.ENERGY_MAP){
      if (Cooking.ENERGY_MAP.hasOwnProperty(k)) {
          var food = k;
          var energy = Cooking.ENERGY_MAP[k];
          if(!food.startsWith("raw_"))
            energy_potential += Items.getItem(food) * energy;
      }
    }
    return energy_potential;
  }
}

