class Cutscenes
{
    static start(scene)
    {
        var options = [];
        if (scene.includes("=") && scene.includes("~"))
        {
            var data_array = scene.split("=");
            scene = data_array[0];
            options = data_array[1].split("~")
        }

        switch(scene)
        {
            case "FARADOXS_INTRODUCTION_ORB":
                Cutscenes._faradoxs_introduction_orb();
            break;
            case "MAX_HEART_CRYSTAL":
                Cutscenes._max_heart_crystal();
            break;
            case "MAX_MANA_CRYSTAL":
                Cutscenes._max_mana_crystal();
            break;
            case "TELEPORT":
                Cutscenes._teleport();
            break;
            case "TELEPORT_NO_SCROLL_TOP":
                Cutscenes._teleport_no_scroll();
            break;
            case "FIRE_GOLEM_BOMB":
                Cutscenes._fire_golem_bomb();
            break;
            case "BLOODFY":
                Cutscenes._bloodify(options[0], options[1]);
            break;
            case "WELCOME":
                Cutscenes._welcome();
            break;
        }
    }

    static _faradoxs_introduction_orb()
    {
        $(window).scrollTop(0);
        Sounds.play(Sounds.VARIABLE_FARADOX);
        $('#content').animate({opacity:0}, 4200, function () {
            $('#body').removeClass("background-primary-gradient")
            $('#body').addClass("background-black");

            $('#cutscenes-1').delay(3000).fadeIn();

            setTimeout(function()
            {   
                $('#body').addClass("background-primary-gradient")
                $('#body').removeClass("background-black");
                $('#cutscenes-1').delay(0).fadeOut();
                $('#content').animate({opacity:1}, 4200, function() {
                    websocket.send("QUEST=faradoxs_introduction~0")
                });
            }, 6000);
        });
    }

    static _bloodify(tablette, option)
    {
        var data = Invention.get_bloodify_tablette_dict(tablette);
        var items = [];
        var blood = 0;
        if(option == 1)
        {
            blood = data["blood_1"]
            items = data['items_1'];
        }
        else
        {
            blood = data["blood_2"]
            items = data['items_2'];
        }

        $(window).scrollTop(0);
        Sounds.play(Sounds.VARIABLE_BLOODIFY);
        $('#content').animate({opacity:0}, 4200, function () {
            $('#body').removeClass("background-primary-gradient")
            $('#body').addClass("background-black");

            var html = "";
            var content_div = document.getElementById("cutscenes-6-inner");
            $('#cutscenes-6').delay(2000).fadeIn();
            for(var i = 0; i < items.length; i++)
            {
                html += "<img src='https://cdn.idle-pixel.com/images/"+items[i]+".png' /> ";
            }

            html += "<br /><br /><br />";
            html += "<img class='w100' src='https://cdn.idle-pixel.com/images/cleansed_blood.png' /> ";
            html += "<img class='w100' src='https://cdn.idle-pixel.com/images/"+tablette+".png' /> ";
            content_div.innerHTML = html;

            setTimeout(function()
            {   
                html = "<img class='w100 shake' src='https://cdn.idle-pixel.com/images/"+tablette+".png' /> ";
                content_div.innerHTML = html;
            }, 9000);

            setTimeout(function()
            {   
                html = "<img class='w100' src='https://cdn.idle-pixel.com/images/"+tablette+"_charged.png' /> ";
                content_div.innerHTML = html;
            }, 16000);


            setTimeout(function()
            {   
                $('#body').addClass("background-primary-gradient")
                $('#body').removeClass("background-black");
                $('#cutscenes-6').delay(0).fadeOut();
                $('#content').animate({opacity:1}, 4200, function() {});
                Modals.open_image_modal('Charged Tablette', 'images/'+tablette+'_charged.png', 'You gain some knowledge on how to invent things.', null, 'Close', null)
                Invention.refresh_table();
            }, 17000);
        });
    }
    static _max_heart_crystal()
    {
        
        $('#content').animate({opacity:0}, 1000, function () {
            $('#body').removeClass("background-primary-gradient")
            $('#body').addClass("background-black");
            
            $('#cutscenes-2').delay(1000).fadeIn(function(){
                Sounds.play(Sounds.VARIABLE_POWER_UP);
            });

            setTimeout(function()
            {   
                $('#body').addClass("background-primary-gradient")
                $('#body').removeClass("background-black");
                $('#cutscenes-2').delay(0).fadeOut();
                $('#content').animate({opacity:1}, 4200, function() {
                    
                });
            }, 6000);
        });
    }

    
    static _welcome()
    {
        
        $('#content').animate({opacity:0}, 1000, function () {
            $('#body').removeClass("background-primary-gradient")
            $('#body').addClass("background-black");
            
            $('#cutscenes-welcome-img').fadeIn(3000);
            
            setTimeout(function()
            {   
               $('#cutscenes-welcome-img-2').fadeIn(9000);
            }, 3000);


            $('#cutscenes-welcome').delay(3000).fadeIn(function(){
                Sounds.play(Sounds.VARIABLE_CASTLE_KEY_GET);
            });

            setTimeout(function()
            {   
                $('#body').addClass("background-primary-gradient")
                $('#body').removeClass("background-black");
                $('#cutscenes-welcome').delay(0).fadeOut();
                $('#content').animate({opacity:1}, 4200, function() {
                    
                });
            }, 9000);
        });
    }


    static _max_mana_crystal()
    {
        
        $('#content').animate({opacity:0}, 1000, function () {
            $('#body').removeClass("background-primary-gradient")
            $('#body').addClass("background-black");
            
            $('#cutscenes-8').delay(1000).fadeIn(function(){
                Sounds.play(Sounds.VARIABLE_POWER_UP);
            });

            setTimeout(function()
            {   
                $('#body').addClass("background-primary-gradient")
                $('#body').removeClass("background-black");
                $('#cutscenes-8').delay(0).fadeOut();
                $('#content').animate({opacity:1}, 4200, function() {
                    
                });
            }, 6000);
        });
    }

    static _teleport()
    {
        document.getElementById("dim-teleport-screen").style.backgroundColor = "purple";
        $(window).scrollTop(0); 
        $("#dim-teleport-screen").fadeIn(10);
        $("#dim-teleport-screen").fadeOut(1000);
    }
    static _teleport_no_scroll()
    {
        document.getElementById("dim-teleport-screen").style.backgroundColor = "purple";
        $("#dim-teleport-screen").fadeIn(10);
        $("#dim-teleport-screen").fadeOut(1000);
    }

    static _fire_golem_bomb()
    {
        document.getElementById("dim-teleport-screen").style.backgroundColor = "red";
        $(window).scrollTop(0);
        $("#dim-teleport-screen").fadeIn(1000);
        $("#dim-teleport-screen").fadeOut(10000);
    }
}