class EventsSeedPiles
{
    //called onces, when user clicks on the panel
    static clicked_panel() {
        EventsSeedPiles.tick();
    }

    static refreshGlobalList(values) {
        var dataArray = values.split("~")
        var dict = []
        for(var i = 0; i < dataArray.length; i+=0) {
            var user = dataArray[i];
            i++;
            var points = dataArray[i];
            i++;

            dict.push({
                user: user,
                value: parseInt(points)
            });
        }

        dict.sort(function (a, b) {
            if (a.value > b.value) return -1;
            if (a.value < b.value) return 1;
            return 0;
        });

        var html = "";

        for (var i = 0; i < dict.length; i++) {
           
            var user = dict[i].user;
            if(Items.getItemString("username") == user) {
                user = "<span class='color-lime'>" + user + "</span>";
            }
            html += user + " <span class='color-grey'>("+format_number(dict[i].value)+")</span>"
            if(i == 0) {
                html += "<img src='https://cdn.idle-pixel.com/images/first_place.png' />";
            }
            if(i == 1) {
                html += "<img src='https://cdn.idle-pixel.com/images/second_place.png' />";
            }
            if(i == 2) {
                html += "<img src='https://cdn.idle-pixel.com/images/third_place.png' />";
            }
            html += "<br />";
        }

        document.getElementById("events-global-progress-seed_piles").innerHTML = html;
    }

    //only ticks if panel is active
    static tick() {

        if(Items.getItem("event_upcomming_timer") > 0) {
            document.getElementById("panel-events-timer-seed_piles").innerHTML =  "(Starts in "+ format_time(Items.getItem("event_upcomming_timer")) +")";
        }
        if(Items.getItem("event_active_timer") > 0) {
            document.getElementById("panel-events-timer-seed_piles").innerHTML =  "(Ends in "+ format_time(Items.getItem("event_active_timer")) +")";
        }
        
        EventsSeedPiles.tick_seed_pile();
    }

    static get_pretty_title(var_value) {
        return var_value.replaceAll("_", " ");
    }

    static tick_seed_pile() {
        hide_element("event-seed-piles-img-level-1");
        hide_element("event-seed-piles-img-level-20");
        hide_element("event-seed-piles-img-level-40");
        hide_element("event-seed-piles-img-level-60");
        hide_element("event-seed-piles-img-level-80");
        hide_element("event-seed-piles-img-level-100");
        hide_element("event-seed-piles-img-level-random");

        hide_element("event-seed-piles-img-points-x2");
        hide_element("event-seed-piles-img-points-x3");

        hide_element("event-seed-piles-img-extra-points-1");
        hide_element("event-seed-piles-img-extra-points-2");
        hide_element("event-seed-piles-img-extra-points-3");
        hide_element("event-seed-piles-img-extra-points-4");
        hide_element("event-seed-piles-img-extra-points-5");
        

        if(Items.getItem("event_active_timer") == 0 || Items.getItemString("event_name") == "none")
            return;

        show_element("event-seed-piles-img-level-1");
        show_element("event-seed-piles-img-level-20");
        show_element("event-seed-piles-img-level-40");
        show_element("event-seed-piles-img-level-60");
        show_element("event-seed-piles-img-level-80");
        show_element("event-seed-piles-img-level-100");

        if(Items.getItem("event_flag_index_int_1") > 0) {
            show_element("event-seed-piles-img-level-random");
        } else {
            hide_element("event-seed-piles-img-level-random");
        }

        Animations.shake_off("event-seed-piles-img-level-1");
        Animations.shake_off("event-seed-piles-img-level-20");
        Animations.shake_off("event-seed-piles-img-level-40");
        Animations.shake_off("event-seed-piles-img-level-60");
        Animations.shake_off("event-seed-piles-img-level-80");
        Animations.shake_off("event-seed-piles-img-level-100");
        Animations.shake_off("event-seed-piles-img-level-random");

        if(Items.getItemString("event_flag_index_string_1") != "none") {
            Animations.shake_on("event-seed-piles-img-level-" + Items.getItem("event_flag_index_string_1"));
        }

        if(Items.getItem("event_flag_index_int_2") == 1 && Items.getItem("event_multipler_two_used") == 0)
            show_element("event-seed-piles-img-points-x2");
        if(Items.getItem("event_flag_index_int_3") == 1 && Items.getItem("event_multipler_three_used") == 0)
            show_element("event-seed-piles-img-points-x3");

        if(Items.getItem("event_flag_index_int_4") > 0) {
            show_element("event-seed-piles-img-extra-points-" + Items.getItem("event_flag_index_int_4"));
        }
    }

}