class EventsYetiBoss
{
    static bossImageDisplay = false;
    //called onces, when user clicks on the panel
    static clicked_panel() {
        EventsYetiBoss.tick();
    }

    static refreshGlobalList(values) {
        var dataArray = values.split("~")
        var dict = []
        for(var i = 0; i < dataArray.length; i+=0) {
            var user = dataArray[i];
            i++;
            var points = dataArray[i];
            i++;

            dict.push({
                user: user,
                value: parseInt(points)
            });
        }

        dict.sort(function (a, b) {
            if (a.value > b.value) return -1;
            if (a.value < b.value) return 1;
            return 0;
        });

        var html = "";

        for (var i = 0; i < dict.length; i++) {
           
            var user = dict[i].user;
            if(Items.getItemString("username") == user) {
                user = "<span class='color-lime'>" + user + "</span>";
            }
            html += user + " <span class='color-grey'>("+format_number(dict[i].value)+")</span>"
            if(i == 0) {
                html += "<img src='https://cdn.idle-pixel.com/images/first_place.png' />";
            }
            if(i == 1) {
                html += "<img src='https://cdn.idle-pixel.com/images/second_place.png' />";
            }
            if(i == 2) {
                html += "<img src='https://cdn.idle-pixel.com/images/third_place.png' />";
            }
            html += "<br />";
        }

        document.getElementById("events-global-progress-yeti_boss").innerHTML = html;
    }

    //only ticks if panel is active
    static tick() {

        if(Items.getItem("event_upcomming_timer") > 0) {
            document.getElementById("panel-events-timer-yeti_boss").innerHTML =  "(Starts in "+ format_time(Items.getItem("event_upcomming_timer")) +")";
        }
        if(Items.getItem("event_active_timer") > 0) {
            document.getElementById("panel-events-timer-yeti_boss").innerHTML =  "(Ends in "+ format_time(Items.getItem("event_active_timer")) +")";
        }

        EventsYetiBoss.tickYetiBoss()
    }

    static get_pretty_title(var_value) {
        return var_value.replaceAll("_", " ");
    }

    static tickYetiBoss() {
        
        if(Items.getItem("event_active_timer") > 0) {
            if(!EventsYetiBoss.bossImageDisplay) {
                document.getElementById("panel-events-yeti_boss-boss-img").style.display = "";
                document.getElementById("yeti_boss-progress-bar-wrapper").style.display = "";
                EventsYetiBoss.bossImageDisplay = true;
            }

            var maxHP = Items.getItem("yeti_boss_event_max_hp");
            var currentHP = Items.getItem("yeti_boss_event_hp");
            document.getElementById("yeti_boss_event_max_hp").innerHTML = maxHP;
            document.getElementById("yeti_boss_event_hp").innerHTML = currentHP;

            var percentage = currentHP / maxHP * 100;
            if(percentage > 100) percentage = 100;
            document.getElementById("yeti_boss-progress-bar-hp").style.width = percentage + "%"; 

            var playersHitting = Items.getItem('event_flag_index_int_4') - 1;
            for(var i = 0; i < playersHitting; i ++) {
                if(rand(0, 3) == 0)
                EventsYetiBoss.hitSplatFromRandomToMonster();
            }
            

            if(Items.getItem("yeti_boss_event_hero_hp") <= 10) {
                document.getElementById('events-warning-hp-yeti_boss').style.display = '';
            } else {
                document.getElementById('events-warning-hp-yeti_boss').style.display = 'none';
            }

            if(Items.getItem("event_flag_index_int_2") > 0) {
                document.getElementById("events-spell-heal-yeti_boss").innerHTML = "Cooldown: " + Items.getItem("event_flag_index_int_2");
            }
            else {
                document.getElementById("events-spell-heal-yeti_boss").innerHTML = "FULL HEAL SPELL";
            }

            if(Items.getItem("event_flag_index_int_3") > 0) {
                document.getElementById("events-spell-fire-yeti_boss").innerHTML = "Cooldown: " + Items.getItem("event_flag_index_int_3");
            } else {
                document.getElementById("events-spell-fire-yeti_boss").innerHTML = "FIRE SPELL";
            }
        }
    }

    static hitSplatFromPlayterToMonster(image_path, damage) {
        if(Globals.currentPanel == 'panel-events-yeti_boss')
        {
            Animations.scrollTextOnElement('panel-events-yeti_boss-boss-img', image_path, "red", damage, 0, 0);
        }
        
    }

    static hitSplatFromRandomToMonster() {
        if(Globals.currentPanel == 'panel-events-yeti_boss')
        {
            var weapons = [
                "images/stinger.png",
                "images/skeleton_sword.png",
                "images/iron_dagger.png",
                "images/stinger.png",
                "images/skeleton_sword.png",
                "images/iron_dagger.png",
                "images/stinger.png",
                "images/skeleton_sword.png",
                "images/iron_dagger.png",
                "images/stinger.png",
                "images/skeleton_sword.png",
                "images/iron_dagger.png",
                "images/stinger.png",
                "images/skeleton_sword.png",
                "images/iron_dagger.png",
                "images/stinger.png",
                "images/skeleton_sword.png",
                "images/iron_dagger.png",
                "images/poison_stinger.png",
                "images/stinger_dagger.png",
                "images/poison_stinger_dagger.png",
                "images/club.png",
                "images/rapier.png",
                "images/dense_club.png",
                "images/spiked_club.png",
                "images/scythe.png",
                "images/spiked_dense_club.png",
                "images/double_scythe.png",
            ]

            var image_path = weapons[rand(0, weapons.length - 1)];
            var leftOffset = rand(-300, 200);
            var topOffset = rand(-150, 150);
            var damage = rand(0, 20);
            Animations.scrollTextOnElement('panel-events-yeti_boss-boss-img', image_path, "black", damage, leftOffset, topOffset);
        }
    }

   

}