class Farming
{
    static SEED_DATA = {
        "white_leaf_seeds": {
            "level": 70,
            "stops_dying": 100,
            "bonemeal": 0,
            "xp": "Unknown",
            "time": 3600,
        },
        "dotted_green_leaf_seeds": {
            "level": 1,
            "stops_dying": 15,
            "bonemeal": 0,
            "xp": 150,
            "time": 15*60,
        },
        "green_leaf_seeds": {
            "level": 10,
            "stops_dying": 25,
            "bonemeal": 0,
            "xp": 300,
            "time": 1800,
        },
        "lime_leaf_seeds": {
            "level": 25,
            "stops_dying": 40,
            "bonemeal": 1,
            "xp": 390,
            "time": 3600,
        },
        "gold_leaf_seeds": {
            "level": 50,
            "stops_dying": 60,
            "bonemeal": 5,
            "xp": 1000,
            "time": 3600*2,
        },
        "crystal_leaf_seeds": {
            "level": 70,
            "stops_dying": 80,
            "bonemeal": 25,
            "xp": 2452,
            "time": 5*3600,
        },
        "red_mushroom_seeds": {
            "level": 1,
            "stops_dying": 0,
            "bonemeal": 0,
            "xp": 40,
            "time": 5*60,
        },
        "stardust_seeds": {
            "level": 8,
            "stops_dying": 0,
            "bonemeal": 0,
            "xp": 222,
            "time": 20*60,
        },
        "eggplant_seeds": {
            "level": 1,
            "stops_dying": 0,
            "bonemeal": 0,
            "xp": 100,
            "time": 300,
        },

        "tree_seeds": {
            "level": 10,
            "stops_dying": 25,
            "bonemeal": 10,
            "xp": 3000,
            "time": 3600*2,
        },
        "oak_tree_seeds": {
            "level": 25,
            "stops_dying": 40,
            "bonemeal": 25,
            "xp": 10000,
            "time": 3600*4,
        },
        "willow_tree_seeds": {
            "level": 37,
            "stops_dying": 55,
            "bonemeal": 50,
            "xp": 20000,
            "time": 3600*8,
        },
        "apple_tree_seeds": {
            "level": 40,
            "stops_dying": 55,
            "bonemeal": 50,
            "xp": 20000,
            "time": 3600*8,
        },
        "maple_tree_seeds": {
            "level": 50,
            "stops_dying": 65,
            "bonemeal": 120,
            "xp": 45000,
            "time": 3600*12,
        },
        "banana_tree_seeds": {
            "level": 57,
            "stops_dying": 62,
            "bonemeal": 70,
            "xp": 47800,
            "time": 3600*11,
        },
        "stardust_tree_seeds": {
            "level": 65,
            "stops_dying": 80,
            "bonemeal": 150,
            "xp": 70000,
            "time": 3600*15,
        },
        "orange_tree_seeds": {
            "level": 66,
            "stops_dying": 70,
            "bonemeal": 120,
            "xp": 72850,
            "time": 3600*15,
        },
        "pine_tree_seeds": {
            "level": 70,
            "stops_dying": 85,
            "bonemeal": 180,
            "xp": 90000,
            "time": 3600*17,
        },
        "redwood_tree_seeds": {
            "level": 80,
            "stops_dying": 92,
            "bonemeal": 300,
            "xp": 150000,
            "time": 3600*22,
        },
        "palm_tree_seeds": {
            "level": 82,
            "stops_dying": 90,
            "bonemeal": 200,
            "xp": 100000,
            "time": 3600*19,
        },
        "dragon_fruit_tree_seeds": {
            "level": 90,
            "stops_dying": 100,
            "bonemeal": 500,
            "xp": 400000,
            "time": 3600*24,
        },
        "bone_tree_seeds": {
            "level": 80,
            "stops_dying": 88,
            "bonemeal": 0,
            "xp": 200000,
            "time": 3600*18,
        },
        "lava_tree_seeds": {
            "level": 91,
            "stops_dying": 97,
            "bonemeal": 300,
            "xp": 264000,
            "time": 3600*23,
        },
        "strange_tree_seeds": {
            "level": 92,
            "stops_dying": 100,
            "bonemeal": 500,
            "xp": 425145,
            "time": 3600*26,
        },
        
        "potato_seeds": {
            "level": 60,
            "stops_dying": 0,
            "bonemeal": 50,
            "xp": 2142,
            "time": 1800,
        },
        "carrot_seeds": {
            "level": 70,
            "stops_dying": 0,
            "bonemeal": 100,
            "xp": 3518,
            "time": 2700,
        },
        "beet_seeds": {
            "level": 80,
            "stops_dying": 0,
            "bonemeal": 220,
            "xp": 5152,
            "time": 3600,
        },
        "broccoli_seeds": {
            "level": 90,
            "stops_dying": 0,
            "bonemeal": 300,
            "xp": 8758,
            "time": 7200,
        },

        "mixed_seeds": {
            "level": 50,
            "stops_dying": 0,
            "bonemeal": 50,
            "xp": 5000,
            "time": 3600*3,
        },
        "mixed_one_seeds": {
            "level": 50,
            "stops_dying": 0,
            "bonemeal": 50,
            "xp": 5000,
            "time": 3600*3,
        },
        "mixed_seeds": {
            "level": 50,
            "stops_dying": 0,
            "bonemeal": 50,
            "xp": 5000,
            "time": 3600*3,
        },
        "mixed_two_seeds": {
            "level": 50,
            "stops_dying": 0,
            "bonemeal": 50,
            "xp": 20000,
            "time": 3600*3,
        },
        "mixed_three_seeds": {
            "level": 50,
            "stops_dying": 0,
            "bonemeal": 50,
            "xp": 50000,
            "time": 3600*3,
        },
        "mixed_four_seeds": {
            "level": 50,
            "stops_dying": 0,
            "bonemeal": 50,
            "xp": 100000,
            "time": 3600*3,
        },

        "poppy_flower_seeds": {
            "level": 50,
            "stops_dying": 0,
            "bonemeal": 0,
            "xp": 500,
            "time": 3600,
        },

        "rose_flower_seeds": {
            "level": 60,
            "stops_dying": 0,
            "bonemeal": 0,
            "xp": 1000,
            "time": 3600,
        },

        "tulip_flower_seeds": {
            "level": 70,
            "stops_dying": 0,
            "bonemeal": 0,
            "xp": 2500,
            "time": 3600,
        },

        "mega_red_mushroom_seeds": {
            "level": 70,
            "stops_dying": 0,
            "bonemeal": 150,
            "xp": 4000,
            "time": 3600*15,
        },
        "mega_dotted_green_leaf_seeds": {
            "level": 70,
            "stops_dying": 0,
            "bonemeal": 300,
            "xp": 15000,
            "time": 3600*24,
        },
        "mega_red_mushroom_seeds": {
            "level": 80,
            "stops_dying": 0,
            "bonemeal": 500,
            "xp": 30000,
            "time": 3600*15,
        },
        "mega_green_leaf_seeds": {
            "level": 80,
            "stops_dying": 0,
            "bonemeal": 500,
            "xp": 30000,
            "time": 93600,
        },
        "mega_lime_leaf_seeds": {
            "level": 90,
            "stops_dying": 0,
            "bonemeal": 1000,
            "xp": 39000,
            "time": 108000,
        },
        "mega_gold_leaf_seeds": {
            "level": 95,
            "stops_dying": 0,
            "bonemeal": 1850,
            "xp": 100000,
            "time": 3600*37,
        },
        "mega_crystal_leaf_seeds": {
            "level": 100,
            "stops_dying": 0,
            "bonemeal": 3000,
            "xp": 245200,
            "time": 3600*48,
        },
    }
    static refresh()
    {
        document.getElementById("panel-farming-level").innerHTML = get_level(Items.getItem("farming_xp"), false);
        this.refresh_patch(1);
        this.refresh_patch(2);
        this.refresh_patch(3);
        this.refresh_patch(4);
        this.refresh_patch(5);
    }

    static refresh_patch(patch_id)
    {
        var crop = Items.getItemString("farm_" + patch_id);
        var stage = Items.getItem("farm_stage_" + patch_id);
        if(crop != "none")
        {
           if(Items.getItem("farm_death_" + patch_id) == 1)
           {
                if(crop.includes("leaf"))
                    set_image_src("farming-patch-image-" + patch_id, "images/farming_dead_leaf.png");
                
                if(crop.includes("mushroom"))
                    set_image_src("farming-patch-image-" + patch_id, "images/farming_dead_mushroom.png");

                if(crop.includes("tree"))
                    set_image_src("farming-patch-image-" + patch_id, "images/farming_dead_tree.png");
              
           }
           else
           {
                set_image_src("farming-patch-image-" + patch_id, "images/farming_" + crop + "_" + stage + ".png");
           }
           
        }
        else
        {
            //donor
            if(patch_id == 4 || patch_id == 5)
            {
                if(!DonorShop.has_donor_active(Items.getItem("donor_farm_patches_timestamp")))
                {
                    set_image_src("farming-patch-" + patch_id, "images/farming_locked.png");
                }
                else
                {
                    set_image_src("farming-patch-image-" + patch_id, "images/farming_none.png");
                }
            }
            else
            set_image_src("farming-patch-image-" + patch_id, "images/farming_none.png");
        }

    }  

    static getMaxBirdhouseLevel() {
        if(Items.getItem("redwood_birdhouse") > 0) {
            return 25;
        }
        return 20;
    }
    static getBirdhouseSeedValue() {
        var dotted_green_leaf_seeds = Items.getItem("birdhouse_set_dotted_green_leaf_seeds");
		var green_leaf_seeds = Items.getItem("birdhouse_set_green_leaf_seeds");
		var lime_leaf_seeds = Items.getItem("birdhouse_set_lime_leaf_seeds");
		var red_mushroom_seeds = Items.getItem("birdhouse_set_red_mushroom_seeds");
		var stardust_seeds = Items.getItem("birdhouse_set_stardust_seeds");
        var gold_leaf_seeds = Items.getItem("birdhouse_set_gold_leaf_seeds");
        var crystal_leaf_seeds = Items.getItem("birdhouse_set_crystal_leaf_seeds");

        var value = dotted_green_leaf_seeds + (green_leaf_seeds * 2) + (lime_leaf_seeds * 4) + (gold_leaf_seeds * 8) + (crystal_leaf_seeds * 30) + red_mushroom_seeds + stardust_seeds; 
        return value;
    }

    static getBirdhouseMaxSeedValue() {
        if(Items.getItem("redwood_birdhouse") > 0) {
            return 160;
        }
        return 90;
    }

    static hasSeeds()
    {
        if(Items.getItem("dotted_green_leaf_seeds") > 0)
            return true;

        if(Items.getItem("red_mushroom_seeds") > 0)
            return true;

        if(Items.getItem("eggplant_seeds") > 0)
            return true;

        return false;
    }

    static clicks_seed(seed_name)
    {
        var free_patch_id = Farming.get_free_patch_id();
        if(free_patch_id == 0)
        {
            Modals.open_image_modal("PATCHES OCCUPIED", "images/x.png", "All your farming patches are occupied!");
            return;
        }

        if(Items.getItem('disable_plant_confirmation') == 1)
            websocket.send('PLANT=' + seed_name + '~' + free_patch_id);
        else {
            if(Farming.SEED_DATA.hasOwnProperty(seed_name)) {
                
                var level = Farming.SEED_DATA[seed_name]['level'];
                var stops_dying = Farming.SEED_DATA[seed_name]['stops_dying'];
                var bonemeal = Farming.SEED_DATA[seed_name]['bonemeal'];
                var xp = Farming.SEED_DATA[seed_name]['xp'];
                var time = Farming.SEED_DATA[seed_name]['time'];
                
                var html = "";
                var color = "";
                
                
                
                
                html += "<center><table class='table-seed-popup'>";
                    if(get_level(Items.getItem("farming_xp")) >= level) color = "style='color:green'"; else color = "style='color:red'";
                    html += "<tr>";
                        html += "<td><img class='w20' src='https://cdn.idle-pixel.com/images/farming.png'></td>";
                        html += "<td "+color+">Plant Level: "+level+"</td>";
                    html += "</tr>";
                    if(stops_dying > 0) {
                        if(get_level(Items.getItem("farming_xp")) >= stops_dying) color = "style='color:green'"; else color = "style='color:red'";
                        html += "<tr>";
                            html += "<td><img class='w20' src='https://cdn.idle-pixel.com/images/skull_sigil_chat.png'></td>";
                            html += "<td "+color+">Stops Dying Level: "+stops_dying+"</td>";
                        html += "</tr>";
                    } else {
                        html += "<tr>";
                            html += "<td><img class='w20' src='https://cdn.idle-pixel.com/images/skull_sigil_chat.png'></td>";
                            html += "<td style='color:green'>Cannot die</td>";
                        html += "</tr>";
                    }
                    
                    if(bonemeal > 0) {
                        if(Items.getItem("bonemeal") >= bonemeal) color = "style='color:green'"; else color = "style='color:red'";
                        html += "<tr>";
                            html += "<td><img class='w20' src='https://cdn.idle-pixel.com/images/bonemeal.png'></td>";
                            html += "<td "+color+">Bonemeal: "+bonemeal+"</td>";
                        html += "</tr>";
                    }

                    html += "<tr>";
                        html += "<td><img class='w20' src='https://cdn.idle-pixel.com/images/xp_arrow.png'></td>";
                        html += "<td style='color:grey'>Harvest XP: "+xp+"</td>";
                    html += "</tr>";
                    html += "<tr>";
                        html += "<td><img class='w20' src='https://cdn.idle-pixel.com/images/hourglass.png'></td>";
                        html += "<td style='color:grey'>Growtime: "+format_time(time)+"</td>";
                    html += "</tr>";
                html += "</table></center>";

                if(get_level(Items.getItem("farming_xp")) < stops_dying) {
                    html += "<br /><br /><span class='font-small color-grey'>The base chance for a seed to die is 10%</span>"
                }

                Modals.open_image_modal('PLANT','images/'+seed_name+'.png','Plant a seed in an empty patch?<br /><br />' + html,'Plant','Close','PLANT=' + seed_name + '~' + free_patch_id);

            } else {
                Modals.open_image_modal('PLANT','images/'+seed_name+'.png','Plant a seed in an empty patch?','Plant','Close','PLANT=' + seed_name + '~' + free_patch_id);
            }
        }
            
    }

    // return int (1 - 5) ... 0 if none free
    static get_free_patch_id()
    {
        if(Items.getItemString("farm_1") == "none")
            return 1;

        if(Items.getItemString("farm_2") == "none")
            return 2;
        
        if(Items.getItemString("farm_3") == "none")
            return 3;

        if(Items.getItemString("farm_4") == "none" && DonorShop.has_donor_active(Items.getItem("donor_farm_patches_timestamp")))
            return 4;

        if(Items.getItemString("farm_5") == "none" && DonorShop.has_donor_active(Items.getItem("donor_farm_patches_timestamp")))
            return 5;

        return 0;
    }
    


    static clicksPlot(id)
    {
        if(Farming.hasSeeds() || Items.getItemString("farm_" + id) != "none")
        {
            websocket.send('CLICKS_PLOT=' + id)
        }
        else
            Modals.open_image_modal("MISSING SEEDS", "images/warning.png", "You don't have any seeds!<br /><br /><span class='color-grey'>Perhaps I can find some with the help of the gathering skill.</span>");
    }

    static refreshTimers(patch_id)
    {
        var time_label = document.getElementById("farming-patch-timer-" + patch_id);
        var time = Items.getItem("farm_timer_"+ patch_id);

       
        if(time == 0)
            time_label.innerHTML = "";
        else if(time == 1)
        {
            var seed = Items.getItem("farm_" + patch_id);
            var xpLabel = "";
            if(Farming.SEED_DATA.hasOwnProperty(seed)) {
                var xp = Farming.SEED_DATA[seed]['xp']
                if(DonorShop.has_donor_active(Items.getItem('donor_bonus_xp_timestamp'))) xp *= 1.1;
                xpLabel = "<br /><span class='color-lime font-small'>" + format_number(xp) + " xp</span>"
            }
            time_label.innerHTML = "READY" + xpLabel;
        }
        else {
            var seed = Items.getItem("farm_" + patch_id);
            var xpLabel = "";
            if(Farming.SEED_DATA.hasOwnProperty(seed)) {
                var xp = Farming.SEED_DATA[seed]['xp']
                if(DonorShop.has_donor_active(Items.getItem('donor_bonus_xp_timestamp'))) xp *= 1.1;
                xpLabel = "<br /><span class='color-grey font-small'>" + format_number(xp) + " xp</span>"
            }
            time_label.innerHTML = format_time(time) + xpLabel;
        }
            
    }


    static get_bonemeal(bone) {
        var bm = 0;

        switch(bone) {
            case "bones":
                bm = 1;
            break;
            case "big_bones":
                bm = 2;
            break;
            case "ashes":
                bm = 2;
            break;
            case "ice_bones":
                bm = 3;
            break;
            case "blood_bones":
                bm = 4;
            break;
            case "dragon_bones":
                bm = 500;
            break;
        }

        if(Items.getItem("green_bone_orb_absorbed") > 0) {
            bm += 1;
        }

        return {
            'bonemeal': bm,
            'green_orb_applied': Items.getItem("green_bone_orb_absorbed") > 0,
        }
    }

    static clicks_bones(item)
    {
        if(Items.getItem("bonemeal_bin") == 0)
        {
            Modals.open_image_modal("ERROR", "images/x.png", "You need to craft a bonemeal bin to use this.", null, "Close", null, null);
            return;
        }
        
        var dict = {}
        dict[item] = 1;
        Modals.open_modern_input_dialogue_with_value(
            item,
            "images/" + item + ".png",
            dict,
            "MAX",
            null,
            'Add Bonemeal',
            'ADD_BONEMEAL=' + item
        );
    }

    

    static get_seed_rarity(base_rate)
    {
        var current_rake = Farming.getRakeToolData()[0];
        if(current_rake == "none") return base_rate;
        if(current_rake == "sapphire_rake") return format_number(base_rate * 0.95) + " <span class='color-grey'>(-5% applied)</span>";
        if(current_rake == "emerald_rake") return format_number(base_rate * 0.90) + " <span class='color-grey'>(-10% applied)</span>";
        if(current_rake == "ruby_rake") return format_number(base_rate * 0.85) + " <span class='color-grey'>(-15% applied)</span>";
        if(current_rake == "diamond_rake") return format_number(base_rate * 0.80) + " <span class='color-grey'>(-20% applied)</span>";
    }

    // returns ["current", "next_gem or none"]
    static getRakeToolData()
    {
        if(Items.getItem("diamond_rake"))
            return ["diamond_rake", "none"];
        
        if(Items.getItem("ruby_rake"))
            return ["ruby_rake", "diamond"];
        
        if(Items.getItem("emerald_rake"))
            return ["emerald_rake", "ruby"];
    
        if(Items.getItem("sapphire_rake"))
            return ["sapphire_rake", "emerald"];

        if(Items.getItem("rake"))
            return ["rake", "sapphire"];

        return ["none", "none"];
    }

    // returns ["current", "next_gem or none"]
    static getTrowelToolData()
    {
        if(Items.getItem("diamond_trowel"))
        return ["diamond_trowel", "none"];
    
        if(Items.getItem("ruby_trowel"))
            return ["ruby_trowel", "diamond"];
        
        if(Items.getItem("emerald_trowel"))
            return ["emerald_trowel", "ruby"];

        if(Items.getItem("sapphire_trowel"))
            return ["sapphire_trowel", "emerald"];

        if(Items.getItem("trowel"))
            return ["trowel", "sapphire"];

        return ["none", "none"];
    }
    // returns ["current", "next_gem or none"]
    static getWateringCanToolData()
    {
        if(Items.getItem("diamond_watering_can"))
            return ["diamond_watering_can", "none"];
        
        if(Items.getItem("ruby_watering_can"))
            return ["ruby_watering_can", "diamond"];
        
        if(Items.getItem("emerald_watering_can"))
            return ["emerald_watering_can", "ruby"];
    
        if(Items.getItem("sapphire_watering_can"))
            return ["sapphire_watering_can", "emerald"];

        if(Items.getItem("watering_can"))
            return ["watering_can", "sapphire"];

        return ["none", "none"];
    }


    static has_crops_full_grown()
    {
        for(var i = 1; i <= 5; i++)
        {
            if(Items.getItem("farm_stage_" + i) == 4)
            {
                return true;
            }
        }

        return false;
    }

    static birdhouse_add_items () {

        if(Items.getItem("bird_bath") > 0 && Items.getItem("bird_bath_filled") == 0) {
            if(Items.getItem("bird_bath_enchanted") == 0) {
                Modals.toggle('modal-empty-birdbath')
                return;
            }
        }

        var dotted_green_leaf_seeds = document.getElementById("modal-birdhouse-dotted_green_leaf_seeds").value;
        var green_leaf_seeds = document.getElementById("modal-birdhouse-green_leaf_seeds").value;
        var lime_leaf_seeds = document.getElementById("modal-birdhouse-lime_leaf_seeds").value;
        var red_mushroom_seeds = document.getElementById("modal-birdhouse-red_mushroom_seeds").value;
        var stardust_seeds = document.getElementById("modal-birdhouse-stardust_seeds").value;
        var gold_leaf_seeds = document.getElementById("modal-birdhouse-gold_leaf_seeds").value;
        var crystal_leaf_seeds = document.getElementById("modal-birdhouse-crystal_leaf_seeds").value;

        var prep = dotted_green_leaf_seeds + "~";
        prep += green_leaf_seeds + "~";
        prep += lime_leaf_seeds + "~";
        prep += red_mushroom_seeds + "~";
        prep += stardust_seeds + "~";
        prep += gold_leaf_seeds + "~";
        prep += crystal_leaf_seeds;

        websocket.send("PREPARE_BIRDHOUSE=" + prep);
    }

    static birdhouse_add_items_empty_birdbath() {
        var dotted_green_leaf_seeds = document.getElementById("modal-birdhouse-dotted_green_leaf_seeds").value;
        var green_leaf_seeds = document.getElementById("modal-birdhouse-green_leaf_seeds").value;
        var lime_leaf_seeds = document.getElementById("modal-birdhouse-lime_leaf_seeds").value;
        var red_mushroom_seeds = document.getElementById("modal-birdhouse-red_mushroom_seeds").value;
        var stardust_seeds = document.getElementById("modal-birdhouse-stardust_seeds").value;
        var gold_leaf_seeds = document.getElementById("modal-birdhouse-gold_leaf_seeds").value;
        var crystal_leaf_seeds = document.getElementById("modal-birdhouse-crystal_leaf_seeds").value;

        var prep = dotted_green_leaf_seeds + "~";
        prep += green_leaf_seeds + "~";
        prep += lime_leaf_seeds + "~";
        prep += red_mushroom_seeds + "~";
        prep += stardust_seeds + "~";
        prep += gold_leaf_seeds + "~";
        prep += crystal_leaf_seeds;

        websocket.send("PREPARE_BIRDHOUSE=" + prep);
    }

    static beehive_add_items() {
        var poppy = document.getElementById("modal-beehive-poppy").value;
        var rose = document.getElementById("modal-beehive-rose").value;
        var tulip = document.getElementById("modal-beehive-tulip").value;

        var prep = poppy + "~";
        prep += rose + "~";
        prep += tulip;
        
        websocket.send("PREPARE_BEEHIVE=" + prep);
        
    }
}