
class Fighting
{
   
    static FPS = 60;
    static tick_tracker = 0;
    static BOPPING_OFFSET = 0;
    static active_hitsplats_hero_map = {};
    static active_hitsplats_monster_map = {};
    static dim_monster_image = false;
    static dim_hero_image = false;
    static play_monster_death_sound = true;
    static dim_monster_image_death = false;

    static tick()
    {
        if(Globals.currentPanel == "panel-combat-canvas")
        {
            Fighting.tickHeroCanvas();
            Fighting.tickMonsterCanvas();
        }
    }

    static addHitSplatHero(label, icon, label_color, background_color, border_color, source)
    {
        var splat = new HitSplat(label, icon, label_color, background_color, border_color, 150, 450);

        var random_key = rand(1,500000);
        Fighting.active_hitsplats_hero_map[random_key] = splat;

        if(label != 0)
        Fighting.dim_hero_image = true;

        setTimeout(
            function(){
                Fighting.dim_hero_image = false;
            },
            250
        )

        setTimeout(
            function(){
                delete Fighting.active_hitsplats_hero_map[random_key];
            },
            1000
        )
    }

    static addHitSplatMonster(label, icon, label_color, background_color, border_color, source)
    {
        var splat = new HitSplat(label, icon, label_color, background_color, border_color, 200, Monsters.get_hitsplat_start_y_location());

        var random_key = rand(1,500000);
        Fighting.active_hitsplats_monster_map[random_key] = splat;

        if(label != 0 && label.toLowerCase() != "missed")
        Fighting.dim_monster_image = true;

        setTimeout(
            function(){
                Fighting.dim_monster_image = false;
            },
            250
        )

        setTimeout(
            function(){
                delete Fighting.active_hitsplats_monster_map[random_key];
            },
            1000
        )
    }

    static bopping()
    {
        if(Fighting.BOPPING_OFFSET == 0)
            Fighting.BOPPING_OFFSET = rand(1, 5);
        else
            Fighting.BOPPING_OFFSET = 0;
    }

    static track_ticks()
    {
        Fighting.tick_tracker++;

        if(Fighting.tick_tracker > 100000)
            Fighting.tick_tracker = 0;
    }

    
    static tickHeroCanvas()
    {
       _fighting_hero_canvas_context.clearRect(0, 0, _fighting_hero_canvas.width, _fighting_hero_canvas.height);

       if(Fighting.dim_hero_image)
        {
            _fighting_hero_canvas_context.globalAlpha = 0.5;
        }

        if(Items.getItem("hero_invisibile") > 0)
            _fighting_hero_canvas_context.globalAlpha = 0.1;
        else
            _fighting_hero_canvas_context.globalAlpha = 1.0;

       _fighting_hero_canvas_context.drawImage(Cache.getImage("images/hero_head_" + Items.getItemString('head')+".png","hero_fighting_head"), 0, 300 + Fighting.BOPPING_OFFSET);
       _fighting_hero_canvas_context.drawImage(Cache.getImage("images/hero_body_" + Items.getItemString('body')+".png","hero_fighting_body"), 0, 300 + Fighting.BOPPING_OFFSET);
       _fighting_hero_canvas_context.drawImage(Cache.getImage("images/hero_gloves_" + Items.getItemString('gloves')+".png","hero_fighting_gloves"), 0, 300 + Fighting.BOPPING_OFFSET);
       _fighting_hero_canvas_context.drawImage(Cache.getImage("images/hero_legs_" + Items.getItemString('legs')+".png","hero_fighting_legs"), 0, 300);
       _fighting_hero_canvas_context.drawImage(Cache.getImage("images/hero_boots_" + Items.getItemString('boots')+".png","hero_fighting_boots"), 0, 300);
       _fighting_hero_canvas_context.drawImage(Cache.getImage("images/hero_amulet_" + Items.getItemString('amulet')+".png","hero_fighting_amulet"), 0, 300 + Fighting.BOPPING_OFFSET);
       _fighting_hero_canvas_context.drawImage(Cache.getImage("images/hero_shield_" + Items.getItemString('shield')+".png","hero_fighting_shield"), 0, 300 + Fighting.BOPPING_OFFSET);
       _fighting_hero_canvas_context.drawImage(Cache.getImage("images/hero_weapon_" + Items.getItemString('weapon')+".png","hero_fighting_weapon"), 0, 300 + Fighting.BOPPING_OFFSET);
       
       _fighting_hero_canvas_context.globalAlpha = 1;

       

       if(Monsters.hero_frozen)
       {
        _fighting_hero_canvas_context.fillStyle = "rgba(0,255,255, 0.2)";
        _fighting_hero_canvas_context.strokeStyle = "rgba(0,255,255)";
        _fighting_hero_canvas_context.fillRect(0,250,300,350);
        _fighting_hero_canvas_context.beginPath();
        _fighting_hero_canvas_context.rect(0,250,300,350);
        _fighting_hero_canvas_context.stroke();
        _fighting_hero_canvas_context.font = "30px pixel";
        _fighting_hero_canvas_context.strokeText("FROZEN", 10, 290);
       }

       if(Items.getItem("reflect_on") > 0) 
       {
          
            if(Items.getItem("reflect_upgrade_spellscroll_learnt") > 0)
                _fighting_hero_canvas_context.fillStyle = "rgba(255,255,0, 0.8)";
            else
                _fighting_hero_canvas_context.fillStyle = "rgba(255,255,255, 0.8)";
        
            _fighting_hero_canvas_context.beginPath();
            _fighting_hero_canvas_context.roundRect(225,350,25,225, 20);
            _fighting_hero_canvas_context.stroke()
            _fighting_hero_canvas_context.fill();

            // _fighting_hero_canvas_context.beginPath();
            // _fighting_hero_canvas_context.moveTo(250, 400);
            // _fighting_hero_canvas_context.lineTo(270, 380);
            // _fighting_hero_canvas_context.lineWidth = 1;
            // _fighting_hero_canvas_context.strokeStyle = 'grey';
            // _fighting_hero_canvas_context.stroke();

            // _fighting_hero_canvas_context.beginPath();
            // _fighting_hero_canvas_context.moveTo(250, 400);
            // _fighting_hero_canvas_context.lineTo(270, 420);
            // _fighting_hero_canvas_context.strokeStyle = 'grey';
            // _fighting_hero_canvas_context.stroke();
       }

       
       if(Items.getItem("beach_rain_timer") > 0 || Items.getItem("guaridan_two_rain") == 1)
       {
            _fighting_hero_canvas_context.font = "30px pixel";
            _fighting_hero_canvas_context.strokeStyle = "rgba(0,255,255)";
            _fighting_hero_canvas_context.strokeText("RAINING", 10, 30);
       }
       if(Items.getItem("guaridan_two_rain") == 2)
       {
            _fighting_hero_canvas_context.font = "30px pixel";
            _fighting_hero_canvas_context.strokeStyle = "rgba(204,102,0)";
            _fighting_hero_canvas_context.strokeText("RAINING TAR", 10, 30);
       }
      


    

        if(Fighting.tick_tracker % 50 == 0  && !Monsters.hero_frozen)
            Fighting.bopping();

        Fighting.track_ticks();
        Fighting.manage_hitplats();

        _fighting_hero_canvas_context.font = "10px Arial";
        _fighting_hero_canvas_context.strokeStyle = "rgba(155,155,155)";
        _fighting_hero_canvas_context.strokeText("Attack in:  " + (Items.getItem("current_fight_speed") - 1), 130, 590);
    } 

    static reset_animations(monster_name)
    {
        var monster_split_array = monster_name.split("_");
        var className = "";
        for(var i = 0; i < monster_split_array.length; i++)
        {
            className += monster_split_array[i].charAt(0).toUpperCase() + monster_split_array[i].slice(1);
        }
        if(className === "None") return;
        get_class(className).animation_index = 0;
        get_class(className).animation_selected = "idle_animation";
    }
   
    static lastClassNameLoadedForCash = "";
    static tickMonsterCanvas()
    {

        var monster_name = Items.getItem("monster_name");
        var monster_split_array = monster_name.split("_");
        var className = "";
        for(var i = 0; i < monster_split_array.length; i++)
        {
            className += monster_split_array[i].charAt(0).toUpperCase() + monster_split_array[i].slice(1);
        }
        if(className === "None") return;
        if(Fighting.lastClassNameLoadedForCash != className)
        {
            Fighting.lastClassNameLoadedForCash = className;
            Monsters.preload_images(get_class(className))
        }
        
        Monsters.tick_canvas(get_class(className));
    }

    static manage_hitplats()
    {
        for (var key in Fighting.active_hitsplats_hero_map) 
        {
            Fighting.active_hitsplats_hero_map[key].draw(_fighting_hero_canvas_context);
        }
    }

    static refreshHeroHpProgressBar()
    {
        var hp = Items.getItem("hp");
        var max_hp = Items.getItem("max_hp");

        var percentage = hp / max_hp * 100;
        if(percentage > 100) percentage = 100;
        document.getElementById("hero-progress-bar-hp").style.width = percentage + "%"; 
    }

    static refreshHeroManaProgressBar()
    {
        var mana = Items.getItem("mana");
        var max_mana = Items.getItem("max_mana");
        var percentage = mana / max_mana * 100;
        if(percentage > 100) percentage = 100;
        document.getElementById("hero-progress-bar-mana").style.width = percentage + "%"; 
    }

    
    static refreshMonsterHpProgressBar()
    {
        var hp = Items.getItem("monster_hp");
        var max_hp = Items.getItem("monster_max_hp");

        var percentage = hp / max_hp * 100;
        if(percentage > 100) percentage = 100;
        document.getElementById("monster-progress-bar-hp").style.width = percentage + "%"; 

        if(hp <= 0 && Combat.in_combat())
        {
            Fighting.dim_monster_image_death = true;
        }

    }
}


class HitSplat
{
    constructor(label, icon, label_color, background_color, border_color, start_x, start_y) 
    {
        this.label = label;
        this.icon = icon;
        this.label_color = label_color;
        this.background_color = background_color;
        this.border_color = border_color;

        this.start_x = parseFloat(start_x);
        this.start_y = parseFloat(start_y);
        this.offset_x = 0 - Math.random() + Math.random();
        this.offset_y = 0 - Math.random() + Math.random();
        //this.offset_x = 0; // no diversions for now.
        //this.offset_y = 0; // no diversions for now.
    }

    draw(ctx)
    {
        ctx.font = "30px pixel";
        var hit_splat_width = 100;
        var hit_splat_height = 50;

        //DEPRECATED
        // if(this.label.length > 2)
        //     hit_splat_width = 150;
    
        // if(this.label == "BLOCKED" || this.label == "MISSED")
        //     hit_splat_width = 200;

        // if(this.label == "Can't reach!")
        //     hit_splat_width = 260;

        if(this.label.length >= 4)
        {
            this.start_x = 40;
            this.offset_x = -0.5;
            this.offset_y = 0;
        }

        hit_splat_width = ctx.measureText(this.label).width
        hit_splat_width += 70

        
        ctx.strokeStyle = "black";
        ctx.beginPath();
        ctx.rect(this.start_x,this.start_y,hit_splat_width,hit_splat_height);
        ctx.stroke();
        ctx.fillStyle = this.background_color;
        ctx.fillRect(this.start_x,this.start_y,hit_splat_width,hit_splat_height);
        ctx.drawImage(Cache.getImage(this.icon, "hitsplat_" + this.icon), this.start_x, this.start_y);
        ctx.font = "30px pixel";
        ctx.fillStyle = this.label_color;
        ctx.fillText(this.label, this.start_x + 60, this.start_y + 35);
        this.start_x += this.offset_x;
        this.start_y += this.offset_y;
        this.start_y-=2;
    }
}