class Gathering
{

    static _animation_flag = false;
    static progresss_bar_time_ms = 8000;
    static stop_animation()
    {
        Gathering._animation_flag = false;

        $("#progress-bar-gathering-mines").stop();
        $("#progress-bar-gathering-fields").stop();
        $("#progress-bar-gathering-forest").stop();
        $("#progress-bar-gathering-fishing_pond").stop();
        $("#progress-bar-gathering-gem_mine").stop();
        $("#progress-bar-gathering-kitchen").stop();
        $("#progress-bar-gathering-castle").stop();

        document.getElementById("progress-bar-gathering-mines").style.width = "0%";
        document.getElementById("progress-bar-gathering-fields").style.width = "0%";
        document.getElementById("progress-bar-gathering-forest").style.width = "0%";
        document.getElementById("progress-bar-gathering-fishing_pond").style.width = "0%";
        document.getElementById("progress-bar-gathering-gem_mine").style.width = "0%";
        document.getElementById("progress-bar-gathering-kitchen").style.width = "0%";
        document.getElementById("progress-bar-gathering-castle").style.width = "0%";
        
    }

    static get_total_bag_from_gatherer()
    {
        var i = 0;
        i += Items.getItem("gathering_working_gathering_loot_bag_fields");
        i += Items.getItem("gathering_working_gathering_loot_bag_forest");
        i += Items.getItem("gathering_working_gathering_loot_bag_mines");
        i += Items.getItem("gathering_working_gathering_loot_bag_fishing_pond");
        i += Items.getItem("gathering_working_gathering_loot_bag_gem_mine");
        i += Items.getItem("gathering_working_gathering_loot_bag_kitchen");
        return i;
    }
    static start_progress_bar(area)
    {
        var progress_bar = document.getElementById("progress-bar-gathering-" + area);
        progress_bar.style.width = "0%";
        Gathering._animation_flag = true;
        animate();

        function animate()
        {
            $(progress_bar).animate({
                    width:"100%"
                },
                Gathering.progresss_bar_time_ms,
                "linear",
                function() 
                {
                    progress_bar.style.width = "0%";
                    if(Gathering._animation_flag) animate();
                }
            );
        }
    }

    static MINES_REGULAR = [
        {
            "label": "Junk",
            "item":"junk",
            "chance": "1/1",
        },
        {
            "label": "Stone",
            "item":"stone",
            "chance": "1/10",
        },
        {
            "label": "Rocket Fuel",
            "item":"rocket_fuel",
            "chance": "1/20,000",
        },
    ]
    static MINES_UNIQUES = 
    [
        {
            "label": "Broken Rake",
            "item":"broken_rake",
            "item_unique_tracker": "broken_rake_unclaimed_unique",
            "level":3,
            "chance": "1/5",
            "xp": 500
        },
        {
            "label": "Chisel",
            "item":"chisel",
            "item_unique_tracker": "chisel_unclaimed_unique",
            "level":50,
            "chance": "1/20,000",
            "xp": 100000
        },
        {
            "label": "Booster (1)",
            "item":"booster_1",
            "item_unique_tracker": "booster_1_unclaimed_unique",
            "level":58,
            "chance": "1/10,000",
            "xp": 50000
        },
        {
            "label": "Booster (2)",
            "item":"booster_2",
            "item_unique_tracker": "booster_2_unclaimed_unique",
            "level":58,
            "chance": "1/10,000",
            "xp": 70000
        },
        {
            "label": "Booster (3)",
            "item":"booster_3",
            "item_unique_tracker": "booster_3_unclaimed_unique",
            "level":58,
            "chance": "1/10,000",
            "xp": 90000
        },
        {
            "label": "Booster (4)",
            "item":"booster_4",
            "item_unique_tracker": "booster_4_unclaimed_unique",
            "level":58,
            "chance": "1/10,000",
            "xp": 110000
        },
        {
            "label": "Mega Boosters",
            "item":"mega_boosters",
            "item_unique_tracker": "mega_boosters_unclaimed_unique",
            "level":85,
            "chance": "1/80,000",
            "xp": 491000
        },
        {
            "label": "Dark Diamond Fragment",
            "item":"dark_diamond_fragments_1",
            "item_unique_tracker": "dark_diamond_fragments_1_unclaimed_unique",
            "level":100,
            "chance": "1/80,000",
            "xp": 1212452
        },
    ];

    static FIELDS_REGULAR = [
        {
            "label": "Junk",
            "item":"junk",
            "chance": "1/1",
        },
        {
            "label": "Bones",
            "item":"bones",
            "chance": "1/800",
        },
        {
            "label": "Red Mushroom Seeds",
            "item":"red_mushroom_seeds",
            "chance": "1/1000",
        },
        {
            "label": "Dotted Green Leaf Seeds",
            "item":"dotted_green_leaf_seeds",
            "chance": "1/2500",
        },
        {
            "label": "Green Leaf Seeds",
            "item":"green_leaf_seeds",
            "chance": "1/20,000",
        },
        {
            "label": "Lime Leaf Seeds",
            "item":"lime_leaf_seeds",
            "chance": "1/50,000",
        },
        {
            "label": "Mega Seed",
            "item":"mega_dotted_green_leaf_seeds",
            "chance": "1/1,000,000",
        },
    ]

    static FIELDS_UNIQUES = 
    [
        {
            "label": "Watering Can",
            "item":"watering_can",
            "item_unique_tracker": "watering_can_unclaimed_unique",
            "level":70,
            "chance": "1/80,000",
            "xp": "175000"
        },
        {
            "label": "Dark Diamond Fragment",
            "item":"dark_diamond_fragments_2",
            "item_unique_tracker": "dark_diamond_fragments_2_unclaimed_unique",
            "level":100,
            "chance": "1/80,000",
            "xp": "1457124"

        },
        
    ];

    static FOREST_REGULAR = [
        {
            "label": "Junk",
            "item":"junk",
            "chance": "1/1",
        },
        {
            "label": "Logs",
            "item":"logs",
            "chance": "1/100",
        },
        {
            "label": "Oak Logs",
            "item":"oak_logs",
            "chance": "1/200",
        },
        {
            "label": "Willow Logs",
            "item":"willow_logs",
            "chance": "1/2000",
        },
        {
            "label": "Dotted Green Leaf",
            "item":"dotted_green_leaf",
            "chance": "1/2000",
        },
        {
            "label": "Bones",
            "item":"big_bones",
            "chance": "1/3600",
        },
        {
            "label": "Green Leaf",
            "item":"green_leaf",
            "chance": "1/5000",
        },
        {
            "label": "Maple Logs",
            "item":"maple_logs",
            "chance": "1/10,000",
        },
        {
            "label": "Lime Leaf",
            "item":"lime_leaf",
            "chance": "1/15,000",
        },
        {
            "label": "Gold Leaf",
            "item":"gold_leaf",
            "chance": "1/40,000",
        },
        {
            "label": "Crystal Leaf",
            "item":"crystal_leaf",
            "chance": "1/300,000",
        },
    ]

    static FOREST_UNIQUES = 
    [
        // {
        //     "label": "Axe",
        //     "item":"axe",
        //     "item_unique_tracker": "axe_unclaimed_unique",
        //     "level":20,
        //     "chance": "1/4000",
        //     "xp": "70000"
        // },
        {
            "label": "Fruit tree fertilizer",
            "item":"fruit_tree_fertilizer",
            "item_unique_tracker": "fruit_tree_fertilizer_unclaimed_unique",
            "level":40,
            "chance": "1/15,000",
            "xp": "88000"
        },
        {
            "label": "Machete",
            "item":"machete",
            "item_unique_tracker": "machete_unclaimed_unique",
            "level":90,
            "chance": "1/80,000",
            "xp": "1000000"
        },
        {
            "label": "Dark Diamond Fragment",
            "item":"dark_diamond_fragments_3",
            "item_unique_tracker": "dark_diamond_fragments_3_unclaimed_unique",
            "level":100,
            "chance": "1/80,000",
            "xp": "1141145"
        },
        
    ];

    static GEM_MINE_REGULAR = [
        {
            "label": "Junk",
            "item":"junk",
            "chance": "1/1",
        },
        {
            "label": "Stone",
            "item":"stone",
            "chance": "1/30",
        },
        {
            "label": "Sapphire Fragments",
            "item":"gathering_sapphire_fragments",
            "chance": "1/6000",
        },
        {
            "label": "Emerald Fragments",
            "item":"gathering_emerald_fragments",
            "chance": "1/12,000",
        },
        {
            "label": "Ruby Fragments",
            "item":"gathering_ruby_fragments",
            "chance": "1/30,000",
        },
        {
            "label": "Diamond Fragments",
            "item":"gathering_diamond_fragments",
            "chance": "1/60,000",
        },
        {
            "label": "Blood Diamond",
            "item":"blood_diamond",
            "chance": "1/1,000,000,000",
        },
    ]
    
    static GEM_MINE_UNIQUES = 
    [
        {
            "label": "Socket Scroll",
            "item":"socket_scroll",
            "item_unique_tracker": "socket_scroll_unclaimed_unique",
            "level":20,
            "chance": "1/4000",
            "xp": "20000"
        },
        {
            "label": "Toolkit",
            "item":"toolkit",
            "item_unique_tracker": "toolkit_unclaimed_unique",
            "level":60,
            "chance": "1/6000",
            "xp": "666666"
        },
        {
            "label": "Dark Diamond Fragment",
            "item":"dark_diamond_fragments_6",
            "item_unique_tracker": "dark_diamond_fragments_6_unclaimed_unique",
            "level":100,
            "chance": "1/80,000",
            "xp": "1010254"
        },
    ];

    static FISHING_POND_REGULAR = [
        {
            "label": "Junk",
            "item":"junk",
            "chance": "1/1",
        },
        {
            "label": "Seaweed",
            "item":"seaweed",
            "chance": "1/5000",
        },
        {
            "label": "Bait",
            "item":"bait",
            "chance": "1/10,000",
        },
    ]


    static FISHING_POND_UNIQUES = 
    [
        {
            "label": "Fishing Rod",
            "item":"fishing_rod",
            "item_unique_tracker": "fishing_rod_unclaimed_unique",
            "level":30,
            "chance": "1/4000",
            "xp": "40000"
        },
        {
            "label": "Aquarium",
            "item":"aquarium",
            "item_unique_tracker": "aquarium_unclaimed_unique",
            "level":50,
            "chance": "1/8000",
            "xp": "55000"
        }
        ,
        {
            "label": "Harpoon",
            "item":"harpoon",
            "item_unique_tracker": "harpoon_unclaimed_unique",
            "level":60,
            "chance": "1/60,000",
            "xp": "250000"
        }
        ,
        {
            "label": "Pirate's Monoculars",
            "item":"monoculars",
            "item_unique_tracker": "monoculars_unclaimed_unique",
            "level":75,
            "chance": "1/80,000",
            "xp": "350000"
        },
        {
            "label": "Dark Diamond Fragment",
            "item":"dark_diamond_fragments_4",
            "item_unique_tracker": "dark_diamond_fragments_4_unclaimed_unique",
            "level":100,
            "chance": "1/80,000",
            "xp": "1241874"
        },
    ];

    
    static KITCHEN_REGULAR = [
        {
            "label": "Junk",
            "item":"junk",
            "chance": "1/1",
        },
        {
            "label": "Maggots",
            "item":"maggots",
            "chance": "1/10",
        },
        {
            "label": "Egg",
            "item":"egg",
            "chance": "1/3000",
        },
        {
            "label": "Chocolate",
            "item":"chocolate",
            "chance": "1/5000",
        },
        {
            "label": "Flour",
            "item":"flour",
            "chance": "1/10,000",
        },
    ]

    static KITCHEN = 
    [
        {
            "label": "Cooks Book",
            "item":"cooks_book",
            "item_unique_tracker": "cooks_book_unclaimed_unique",
            "level":45,
            "chance": "1/10,000",
            "xp": "35000"
        },
        {
            "label": "Chef's Hat",
            "item":"chefs_hat",
            "item_unique_tracker": "chefs_hat_unclaimed_unique",
            "level":80,
            "chance": "1/120,000",
            "xp": "400000"
        },
        {
            "label": "Dark Diamond Fragment",
            "item":"dark_diamond_fragments_5",
            "item_unique_tracker": "dark_diamond_fragments_5_unclaimed_unique",
            "level":100,
            "chance": "1/80,000",
            "xp": "1215899"
        },
    ];

    static CASTLE_REGULAR = [
        {
            "label": "Junk",
            "item":"junk",
            "chance": "1/1",
        },
        {
            "label": "Tainted Coins",
            "item":"tainted_coins",
            "chance": "1/1",
        },
        {
            "label": "Dragon Fire",
            "item":"dragon_fire",
            "chance": "1/50,000",
        },
        {
            "label": "Dragon Ore",
            "item":"dragon_ore",
            "chance": "1/300,000",
        },
        {
            "label": "Dragon Bar",
            "item":"dragon_bar",
            "chance": "1/800,000",
        },
    ]

    static CASTLE = 
    [
        {
            "label": "Portal Base (Floor 2)",
            "item":"portal_base_floor_2",
            "item_unique_tracker": "portal_base_floor_2_unclaimed_unique",
            "level":100,
            "chance": "1/200,000",
            "xp": "2010321"
        },
        {
            "label": "Portal Base (Floor 3)",
            "item":"portal_base_floor_3",
            "item_unique_tracker": "portal_base_floor_3_unclaimed_unique",
            "level":100,
            "chance": "1/200,000",
            "xp": "3410142"
        },
    ];
   
    static refresh_uniques_found_label()
    {
        var total = 0; //changes based on area
        var unqiues_found = 0;

        total = 0;
        unqiues_found = 0;
        total++; if(Items.getItem("broken_rake_unclaimed_unique"))unqiues_found++;
        total++; if(Items.getItem("chisel_unclaimed_unique")) unqiues_found++;
        total++; if(Items.getItem("booster_1_unclaimed_unique")) unqiues_found++;
        total++; if(Items.getItem("booster_2_unclaimed_unique")) unqiues_found++;
        total++; if(Items.getItem("booster_3_unclaimed_unique")) unqiues_found++;
        total++; if(Items.getItem("booster_4_unclaimed_unique")) unqiues_found++;
        total++; if(Items.getItem("mega_boosters_unclaimed_unique")) unqiues_found++;
        total++; if(Items.getItem("dark_diamond_fragments_1_unclaimed_unique")) unqiues_found++;
        document.getElementById("gathering-desert-mines").innerHTML = unqiues_found + "/" + total;

        total = 0;
        unqiues_found = 0;
        total++; if(Items.getItem("watering_can_unclaimed_unique"))unqiues_found++;
        total++; if(Items.getItem("dark_diamond_fragments_2_unclaimed_unique")) unqiues_found++;
        document.getElementById("gathering-forever-fields").innerHTML = unqiues_found + "/" + total;

        total = 0;
        unqiues_found = 0;
        total++; if(Items.getItem("fruit_tree_fertilizer_unclaimed_unique")) unqiues_found++;
        total++; if(Items.getItem("machete_unclaimed_unique")) unqiues_found++;
        total++; if(Items.getItem("dark_diamond_fragments_3_unclaimed_unique")) unqiues_found++;
        document.getElementById("gathering-friendly-forest").innerHTML = unqiues_found + "/" + total;

        total = 0;
        unqiues_found = 0;
        total++; if(Items.getItem("fishing_rod_unclaimed_unique"))unqiues_found++;
        total++; if(Items.getItem("aquarium_unclaimed_unique")) unqiues_found++;
        total++; if(Items.getItem("harpoon_unclaimed_unique")) unqiues_found++;
        total++; if(Items.getItem("monoculars_unclaimed_unique")) unqiues_found++;
        total++; if(Items.getItem("dark_diamond_fragments_4_unclaimed_unique")) unqiues_found++;
        document.getElementById("gathering-quiet-pond").innerHTML = unqiues_found + "/" + total;

        total = 0;
        unqiues_found = 0;
        total++; if(Items.getItem("cooks_book_unclaimed_unique"))unqiues_found++;
        total++; if(Items.getItem("chefs_hat_unclaimed_unique"))unqiues_found++;
        total++; if(Items.getItem("dark_diamond_fragments_5_unclaimed_unique")) unqiues_found++;
        document.getElementById("gathering-dirty-kitchen").innerHTML = unqiues_found + "/" + total;

        total = 0;
        unqiues_found = 0;
        total++; if(Items.getItem("socket_scroll_unclaimed_unique"))unqiues_found++;
        total++; if(Items.getItem("toolkit_unclaimed_unique")) unqiues_found++;
        total++; if(Items.getItem("dark_diamond_fragments_6_unclaimed_unique")) unqiues_found++;
        document.getElementById("gathering-gem-mine").innerHTML = unqiues_found + "/" + total;

        total = 0;
        unqiues_found = 0;
        total++; if(Items.getItem("portal_base_floor_2_unclaimed_unique"))unqiues_found++;
        total++; if(Items.getItem("portal_base_floor_3_unclaimed_unique")) unqiues_found++;
        document.getElementById("gathering-castle").innerHTML = unqiues_found + "/" + total;
        
    }
 
    
    static notificationGatheringUnique() {
        var listUnclaimedVars = [
            "broken_rake_unclaimed",
            "chisel_unclaimed",
            "booster_1_unclaimed",
            "booster_2_unclaimed",
            "booster_3_unclaimed",
            "booster_4_unclaimed",
            "mega_boosters_unclaimed",
            "dark_diamond_fragments_1_unclaimed",

            "watering_can_unclaimed",
            "dark_diamond_fragments_2_unclaimed",

            "axe_unclaimed",
            "fruit_tree_fertilizer_unclaimed",
            "machete_unclaimed",
            "dark_diamond_fragments_3_unclaimed",

            "fishing_rod_unclaimed",
            "harpoon_unclaimed",
            "aquarium_unclaimed",
            "monoculars_unclaimed",
            "dark_diamond_fragments_4_unclaimed",


            "cooks_book_unclaimed",
            "chefs_hat_unclaimed",
            "dark_diamond_fragments_5_unclaimed",

            "socket_scroll_unclaimed",
            "toolkit_unclaimed",
            "dark_diamond_fragments_6_unclaimed",

            "portal_base_floor_2_unclaimed",
            "portal_base_floor_3_unclaimed"
        ]

        document.getElementById("notification-gathering_unique").style.display = "none";
        show_notification("gathering_unique", false)
        for(var i = 0; i < listUnclaimedVars.length; i ++) {
            var indexItem = listUnclaimedVars[i];
            if(Items.getItem(indexItem) > 0) {
                show_notification("gathering_unique", true)
                break;
            }
        }
    }
}