class Invention
{
  static _click_events_loaded = false;

  static refresh_table()
  {
      if(
        Items.getItem("field_tablette_charged") == 0 &&
        Items.getItem("forest_tablette_charged") == 0
      )
        document.getElementById("invention-table").style.display = "none";
      else
        document.getElementById("invention-table").style.display = "";
  

      Invention._refresh_click_events();
      Invention._refresh_materials();
      Invention._hide_unique_assembles();
  }

  static _hide_unique_assembles() 
  {
    var invention_table = document.getElementById("invention-table");
    var invention_row_array = invention_table.getElementsByTagName("tr");

    for(var i = 0; i < invention_row_array.length; i++) {
      var invention_row = invention_row_array[i];
      
        if(!invention_row.hasAttribute("data-tablette-required"))
          continue;

        var itemVar = invention_row.getAttribute("data-invention-item");
        switch(itemVar) {
          case "master_ring":
          case "peekaboo_ring":
          case "magic_ring":
          case "mega_shiny_glass_ball_leaf":
          case "mega_shiny_glass_ball_fish":
          case "mega_shiny_glass_ball_logs":
          case "mega_shiny_glass_ball_monsters":
            if(Items.getItem(itemVar + "_assembled") >= 1) {
              invention_row.style.display = "none";
            }
          break
         
        }
    }
  }

  static get_tablette_pieces_drop_info(area) {
    switch(area) {
      case 'field':
      {
        var hasTablettePiece1 = 0;
        var hasTablettePiece2 = 0;
        var hasTablettePiece3 = 0;
        var hasTablettePiece4 = 0;
        var hasTablettePiece5 = 0;
        if(Items.getItem(area + "_tablette_1")) hasTablettePiece1 = 1;
        if(Items.getItem(area + "_tablette_2")) hasTablettePiece2 = 1;
        if(Items.getItem(area + "_tablette_3")) hasTablettePiece3 = 1;
        if(Items.getItem(area + "_tablette_4")) hasTablettePiece4 = 1;
        if(Items.getItem(area + "_tablette_5")) hasTablettePiece5 = 1;
        return [
          'blood_chicken', hasTablettePiece1,
          'blood_rat', hasTablettePiece2,
          'blood_spider', hasTablettePiece3,
          'blood_bee', hasTablettePiece4,
          'blood_lizard', hasTablettePiece5,
        ]
      }
      case 'forest':
      {
        var hasTablettePiece1 = 0;
        var hasTablettePiece2 = 0;
        var hasTablettePiece3 = 0;
        var hasTablettePiece4 = 0;
        var hasTablettePiece5 = 0;
        if(Items.getItem(area + "_tablette_1")) hasTablettePiece1 = 1;
        if(Items.getItem(area + "_tablette_2")) hasTablettePiece2 = 1;
        if(Items.getItem(area + "_tablette_3")) hasTablettePiece3 = 1;
        if(Items.getItem(area + "_tablette_4")) hasTablettePiece4 = 1;
        if(Items.getItem(area + "_tablette_5")) hasTablettePiece5 = 1;
        return [
          'blood_snake', hasTablettePiece1,
          'blood_ants', hasTablettePiece2,
          'blood_wolf', hasTablettePiece3,
          'blood_forest_ent', hasTablettePiece4,
          'blood_thief', hasTablettePiece5,
        ]
      }
      case 'cave':
      {
        var hasTablettePiece1 = 0;
        var hasTablettePiece2 = 0;
        var hasTablettePiece3 = 0;
        var hasTablettePiece4 = 0;
        if(Items.getItem(area + "_tablette_1")) hasTablettePiece1 = 1;
        if(Items.getItem(area + "_tablette_2")) hasTablettePiece2 = 1;
        if(Items.getItem(area + "_tablette_3")) hasTablettePiece3 = 1;
        if(Items.getItem(area + "_tablette_4")) hasTablettePiece4 = 1;
        return [
          'blood_bear', hasTablettePiece1,
          'blood_goblin', hasTablettePiece2,
          'blood_bat', hasTablettePiece3,
          'blood_skeleton', hasTablettePiece4,
        ]
      }
      case 'volcano':
      {
        var hasTablettePiece1 = 0;
        var hasTablettePiece2 = 0;
        var hasTablettePiece3 = 0;
        var hasTablettePiece4 = 0;
        if(Items.getItem(area + "_tablette_1")) hasTablettePiece1 = 1;
        if(Items.getItem(area + "_tablette_2")) hasTablettePiece2 = 1;
        if(Items.getItem(area + "_tablette_3")) hasTablettePiece3 = 1;
        if(Items.getItem(area + "_tablette_4")) hasTablettePiece4 = 1;
        return [
          'blood_fire_snake', hasTablettePiece1,
          'blood_fire_hawk', hasTablettePiece2,
          'blood_fire_golem', hasTablettePiece3,
          'blood_fire_witch', hasTablettePiece4,
        ]
      }
      case 'ancient':
      {
        var hasTablettePiece1 = 0;
        var hasTablettePiece2 = 0;
        var hasTablettePiece3 = 0;
        var hasTablettePiece4 = 0;
        if(Items.getItem(area + "_tablette_1")) hasTablettePiece1 = 1;
        if(Items.getItem(area + "_tablette_2")) hasTablettePiece2 = 1;
        if(Items.getItem(area + "_tablette_3")) hasTablettePiece3 = 1;
        if(Items.getItem(area + "_tablette_4")) hasTablettePiece4 = 1;
        return [
          'ancient_tablette_1', hasTablettePiece1,
          'ancient_tablette_2', hasTablettePiece2,
          'ancient_tablette_3', hasTablettePiece3,
          'ancient_tablette_4', hasTablettePiece4,
        ]
      }
    }
  }
  static _refresh_click_events()
  {
    var invention_table = document.getElementById("invention-table");
    var invention_row_array = invention_table.getElementsByTagName("tr");
  
    for(var i = 0; i < invention_row_array.length; i++)
    {
        var invention_row = invention_row_array[i];
      
        if(!invention_row.hasAttribute("data-tablette-required"))
          continue;

        var tablette_required = invention_row.getAttribute("data-tablette-required");
        if(Items.getItem(tablette_required) == 0)
          invention_row.style.display = "none"
        else
          invention_row.style.display = "" 
    }

    if(!Invention._click_events_loaded)
      {
          for(var i = 0; i < invention_row_array.length; i++)
          {
              var invention_row = invention_row_array[i];
              if(!invention_row.hasAttribute("data-invention-item"))
                  continue;

              invention_row.addEventListener('click', (e) =>
              {
                  var target_clicked = e.target;
                  var tr = target_clicked.closest("tr");
                  var invention_row_item = tr.getAttribute("data-invention-item");
                  Modals.open_invention_craft_dialogue(invention_row_item);
              });
          }
          Invention._click_events_loaded = true;
      }
      
  }

  static donateTablettes() {
    Modals.open_image_modal('Add Unused Tablettes', 'images/invention.png', 'Add all unused tablette pieces to the mega tablette for extra invention XP?<br /><br /><span class="color-grey">Note that tablette pieces that are still useful for crafting will not be donated</span>','Donate Extra Tablette Pieces!','Close','DONATE_TABLETTE_PIECES');
  }

  /**
     *  returns an array [item_name, amount, ...]
     */
   static get_materials(item)
   {
       var array = [];
       var entry = $("tr[data-invention-item='" + item +"']");
       var materials = entry.find("item-invention-table");
       materials.each(function (ele) {
           var amount = $(this).text();
           var material = $(this).attr("data-materials-item");
           array.push(material, amount);
       });

       return array;
   }

  static _refresh_materials()
    {
        var invention_table = document.getElementById("invention-table");
        var materials_req_array = invention_table.getElementsByTagName("item-invention-table");

        for(var i = 0; i < materials_req_array.length; i++)
        {
            var materials_req = materials_req_array[i];
            var item = materials_req.getAttribute("data-materials-item");

            if(Items.getItem(item) >= parseInt(materials_req.innerHTML))
                materials_req_array[i].style.color = "#00a200";
            else
                materials_req_array[i].style.color = "red";
        }
    }



  static clicks_limb(item)
  {
    if(Items.getItem("blood_grinder") <= 0)
    {
      Modals.open_image_modal("GRINDER", "images/blood_grinder.png", "You need a blood grinder to do this.", null, "Close", null);
      return;
    }

    var dict = {}
        dict[item] = 1;

        Modals.open_modern_input_dialogue_with_value(
          item,
          "images/" + item + ".png",
          dict,
          "MAX",
          null,
          'Grind',
          'GRIND=' + item
        );
  }

  static clicks_blood_glass_shrine()
  {
    Modals.open_input_dialogue_with_value('evil_blood', 'Cleanse', '<img src="https://cdn.idle-pixel.com/images/blood_glass_shrine.png" /> <img src="https://cdn.idle-pixel.com/images/evil_blood.png" /><br /><br /> How many?<br /><br /><img src="https://cdn.idle-pixel.com/images/magic.png" class="w20" /> <span class="color-blue"> Success rate improved based on magic level. </span>', Items.getItem('evil_blood'), 'CLEANSE_EVIL_BLOOD')
  }

  static clicks_evil_blood()
  {
    if(Items.getItem("blood_glass_shrine") <= 0)
    {
      Modals.open_image_modal("GRINDER", "images/blood_glass_shrine.png", "You need a blood glass statue in order to pray and use your magic to remove the evil from this blood.", null, "Close", null);
      return;
    }

    Invention.clicks_blood_glass_shrine();
  }

  static dissambleChance(item)
  {
    var level = get_level(Items.getItem("invention_xp"));

    switch(item)
		{
			case "stinger":
				if(level >= 30)
					return 1;
				if(level >= 25)
					return 0.8;
				if(level >= 15)
					return 0.7;
				else
					return 0.5;

      case "iron_dagger":
            if(level >= 40)
              return 1;
            if(level >= 30)
              return 0.8;
            if(level >= 20)
              return 0.7;
            else
              return 0.0;

      case "skeleton_sword":
        if(level >= 50)
          return 1;
        if(level >= 40)
          return 0.8;
        if(level >= 30)
          return 0.7;
        else
          return 0.0;

      case "bone_amulet":
        if(level >= 60)
          return 1;
        if(level >= 50)
          return 0.8;
        if(level >= 40)
          return 0.7;
        else
          return 0.0;

        case "club":
        case "spiked_club":
          if(level >= 95)
            return 1;
          if(level >= 80)
            return 0.8;
          if(level >= 70)
            return 0.7;
          else
            return 0.0;

        case "scythe":
          if(level >= 100)
            return 1;
          if(level >= 70)
            return 0.5;
          else
            return 0.0;

        case "trident":
          if(level >= 100)
            return 1;
          if(level >= 85)
            return 0.5;
          else
            return 0.0;

        case "undead_staff":
          if(level >= 90)
            return 1;
          else
            return 0.0;
		}
  }

  static get_bloodify_tablette_dict(item)
  {
    switch(item) {
        case "lab_tablette":
          return {
            "tablette_name": item,
            
            "items_1": [],
            "amounts_1": [],
            "level_1": 1,
            "blood_1": 74,

            "items_2": [],
            "amounts_2": [],
            "level_2": 1,
            "blood_2": 74,
          }
        break;
        case "field_tablette":
          return {
            "tablette_name": item,
            
            "items_1": ["honey", "feathers", "raw_chicken", "lizard_skin"],
            "amounts_1": [10, 19, 3, 20],
            "level_1": 10,
            "blood_1": 500,

            "items_2": ["stinger", "lime_leaf"],
            "amounts_2": [5, 1],
            "level_2": 15,
            "blood_2": 200,
          }
        break;
        case "forest_tablette":
          return {
            "tablette_name": item,
            
            "items_1": ["strange_leaf", "maple_logs", "maple_tree_seeds", "lizard_skin", "lime_leaf_seeds"],
            "amounts_1": [12, 88, 3, 50, 2],
            "level_1": 25,
            "blood_1": 1500,

            "items_2": ["iron_dagger", "willow_logs", "coins", "lizard_skin"],
            "amounts_2": [2, 44, 50000, 35],
            "level_2": 40,
            "blood_2": 650,
          }
        break;
        case "cave_tablette":
          return {
            "tablette_name": item,
            
            "items_1": ["stone", "copper", "iron", "bat_skin", "bear_fur", "lantern"],
            "amounts_1": [100000, 50000, 25000, 50, 30, 3],
            "level_1": 35,
            "blood_1": 2000,

            "items_2": ["bones", "ashes", "ice_bones", "blood_bones", "lantern"],
            "amounts_2": [50, 30, 10, 5, 1],
            "level_2": 50,
            "blood_2": 950,
          }
        break;
        case "volcano_tablette":
          return {
            "tablette_name": item,
            
            "items_1": ["lava", "charcoal"],
            "amounts_1": [250, 300],
            "level_1": 45,
            "blood_1": 4000,

            "items_2": ["fire_feathers", "bomb"],
            "amounts_2": [80, 3],
            "level_2": 65,
            "blood_2": 2500,
          }
        break;
        case "ancient_tablette":
          return {
            "tablette_name": item,
            
            "items_1": ["shark_tooth", "mega_bait"],
            "amounts_1": [15, 3],
            "level_1": 90,
            "blood_1": 25000,

            "items_2": ["shark_tooth", "crocodile_hide", "moonstone"],
            "amounts_2": [10, 20, 5],
            "level_2": 100,
            "blood_2": 8000,
          }
        break;
        case "castle_tablette":
          return {
            "tablette_name": item,
            
            "items_1": ["dragon_ore"],
            "amounts_1": [1],
            "level_1": 80,
            "blood_1": 15000,

            "items_2": ["dragon_bar"],
            "amounts_2": [1],
            "level_2": 85,
            "blood_2": 5000,
          }
        break;
    }
  }
  
  static getMagnetToolData()
  {
        if(Items.getItem("diamond_magnet"))
            return ["diamond_watering_can", "none"];
        
        if(Items.getItem("ruby_magnet"))
            return ["ruby_magnet", "diamond"];
        
        if(Items.getItem("emerald_magnet"))
            return ["emerald_magnet", "ruby"];
    
        if(Items.getItem("sapphire_magnet"))
            return ["sapphire_magnet", "emerald"];

        if(Items.getItem("magnet"))
            return ["magnet", "sapphire"];

        return ["none", "none"];
  }

  static getToolkitToolData()
  {
        if(Items.getItem("diamond_toolkit"))
            return ["diamond_watering_can", "none"];
        
        if(Items.getItem("ruby_toolkit"))
            return ["ruby_toolkit", "diamond"];
        
        if(Items.getItem("emerald_toolkit"))
            return ["emerald_toolkit", "ruby"];
    
        if(Items.getItem("sapphire_toolkit"))
            return ["sapphire_toolkit", "emerald"];

        if(Items.getItem("toolkit"))
            return ["toolkit", "sapphire"];

        return ["none", "none"];
  }
}
