class Items
{
    static set(key, value)
    {
        window["var_" + key] = value;
    }

    static load(item_data)
    {
        var item_data_array = item_data.split("~");
        for(var i = 0; i < item_data_array.length; i+=0)
        {
            var key = item_data_array[i];
            i++;
            var value = item_data_array[i];
            i++;
            
            Items.set(key, value);
            Items.action(key, value);
        }
    }

    static refreshDisplays()
    {       
        var elements_array = document.getElementsByTagName("item-display");
       
        for(var i = 0; i < elements_array.length; i++)
        {
            var element = elements_array[i];
            var key = element.getAttribute("data-key");

            var value = Items.getItem(key);
            if(value == null)
                value = 0;

            if(element.getAttribute("data-format") == "number")
                value = format_number(value);
            if(element.getAttribute("data-format") == "timer")
                value = format_time(value);
            if(element.getAttribute("data-format") == "hide-on-none")
             {
                if(value == 0 || value == "none")
                    hide_element_using_tag(element);
                else
                    show_element_using_tag(element);
             }

            element.textContent  = value;
        }
    }

    static refreshItemBoxes()
    {
        var elements_array = document.getElementsByTagName("itembox");
        for(var i = 0; i < elements_array.length; i++)
        {
            var element = elements_array[i];
            var item = element.getAttribute("data-item");

            if(Items.getItem(item) > 0)
                show_element_using_tag(element);
            else
                hide_element_using_tag(element);
        }
    }

    static getItem(key)
    {
        if(window["var_" + key] == null)
            return 0;
        
        var value = window["var_" + key];

        if(isNaN(value))
            return value;

        return parseInt(value);
    }

    static getItemString(key)
    {
        if(window["var_" + key] == null)
            return "none";
        
        return window["var_" + key];
    }

    static get_skilling_outfit_xp_boost_label(skill)
    {
        var total = 0;

        if(Items.getItem(skill + "_skilling_gloves") > 0) total++;
        if(Items.getItem(skill + "_skilling_boots") > 0) total++;
        if(Items.getItem(skill + "_skilling_shirt") > 0) total++;
        if(Items.getItem(skill + "_skilling_pants") > 0) total++;

        if(total == 4) 
            return 5;
        else 
            return total;
    }

    static refresh_closet_label()
    {
        var total = 0;

        if(Items.getItem("mining_skilling_gloves") > 0) total++;
        if(Items.getItem("mining_skilling_boots") > 0) total++;
        if(Items.getItem("mining_skilling_shirt") > 0) total++;
        if(Items.getItem("mining_skilling_pants") > 0) total++;

        if(Items.getItem("crafting_skilling_gloves") > 0) total++;
        if(Items.getItem("crafting_skilling_boots") > 0) total++;
        if(Items.getItem("crafting_skilling_shirt") > 0) total++;
        if(Items.getItem("crafting_skilling_pants") > 0) total++;

        if(Items.getItem("gathering_skilling_gloves") > 0) total++;
        if(Items.getItem("gathering_skilling_boots") > 0) total++;
        if(Items.getItem("gathering_skilling_shirt") > 0) total++;
        if(Items.getItem("gathering_skilling_pants") > 0) total++;

        if(Items.getItem("farming_skilling_gloves") > 0) total++;
        if(Items.getItem("farming_skilling_boots") > 0) total++;
        if(Items.getItem("farming_skilling_shirt") > 0) total++;
        if(Items.getItem("farming_skilling_pants") > 0) total++;

        if(Items.getItem("brewing_skilling_gloves") > 0) total++;
        if(Items.getItem("brewing_skilling_boots") > 0) total++;
        if(Items.getItem("brewing_skilling_shirt") > 0) total++;
        if(Items.getItem("brewing_skilling_pants") > 0) total++;

        if(Items.getItem("woodcutting_skilling_gloves") > 0) total++;
        if(Items.getItem("woodcutting_skilling_boots") > 0) total++;
        if(Items.getItem("woodcutting_skilling_shirt") > 0) total++;
        if(Items.getItem("woodcutting_skilling_pants") > 0) total++;

        if(Items.getItem("cooking_skilling_gloves") > 0) total++;
        if(Items.getItem("cooking_skilling_boots") > 0) total++;
        if(Items.getItem("cooking_skilling_shirt") > 0) total++;
        if(Items.getItem("cooking_skilling_pants") > 0) total++;

        if(Items.getItem("fishing_skilling_gloves") > 0) total++;
        if(Items.getItem("fishing_skilling_boots") > 0) total++;
        if(Items.getItem("fishing_skilling_shirt") > 0) total++;
        if(Items.getItem("fishing_skilling_pants") > 0) total++;

        if(total >= 32) document.getElementById("closet-box-label").style.color = "lime";
        document.getElementById("closet-box-label").innerHTML = total + "/32";
    }
    static get_pretty_item_name(variable)
    {
        variable = variable.replaceAll("_", " ");
        return titleCase(variable);
    
        function titleCase(str) {
            var splitStr = str.toLowerCase().split(' ');
            for (var i = 0; i < splitStr.length; i++) {
                splitStr[i] = splitStr[i].charAt(0).toUpperCase() + splitStr[i].substring(1);     
            }
            return splitStr.join(' '); 
            }
    
    }

    static get_short_version(variable)
    {
       var variable_lower_case = variable.toLowerCase();
       switch(variable_lower_case) {
           case "unbound donor coins":
               return "Donor Coins";
       }

       return variable;
    }

    static action(key, value)
    {
        if(key.endsWith("_crafted"))
        {
            Crafting._refresh_item_display(document.getElementById('crafting-table'));
        }

        if(key.endsWith("_quest") && value == -1 && key != "the_collector_quest")
        {
            document.getElementById(key + "_difficulty").innerHTML = "<span style='color:lime'>(COMPLETED)</span>";
            Quests.refreshQuestBoxes();
        }

        if(key.endsWith("_quest") && value > 0)
        {
            show_element("notification-quests");
            set_innerHTML("notification-quests-label", Quests.getQuestNameFromVar(key))
        }

        if(key.startsWith("preset_"))
        {
            Combat.refresh_preset_equipment_icon();
        }
        
        if(key.endsWith("_potion_timer"))
        {
            Brewing.refreshShortbrewingDisplayShortcuts(key, value);
            
            if(value > 0) {
                document.getElementById("notification-potion-" + key).style.display = "";
            }
            else {
                document.getElementById("notification-potion-" + key).style.display = "none";
            }
        }

        if(key.endsWith("ring_equipped") || key == "ring_of_light_equipped")
        {
            if(value == 0)
                document.getElementById(key + "-checkmark").style.display = "none";
            else
                document.getElementById(key + "-checkmark").style.display = "";
        }

        if(Combat.BADGES.hasOwnProperty(key))
        {
            Combat.refreshBadgeLabels();
        }

        switch(key)
        {

            case "mining_xp":
                refresh_xp_bar("mining");
                refresh_skill_levels_menu_bar("mining");
            break;
            case "crafting_xp":
                refresh_xp_bar("crafting");
                refresh_skill_levels_menu_bar("crafting");
            break;
            case "gathering_xp":
                refresh_xp_bar("gathering");
                refresh_skill_levels_menu_bar("gathering");
            break;
            case "brewing_xp":
                refresh_xp_bar("brewing");
                refresh_skill_levels_menu_bar("brewing");
            break;
            case "woodcutting_xp":
                refresh_xp_bar("woodcutting");
                refresh_skill_levels_menu_bar("woodcutting");
            break;
            case "cooking_xp":
                refresh_xp_bar("cooking");
                refresh_skill_levels_menu_bar("cooking");
            break;
            case "farming_xp":
                refresh_xp_bar("farming");
                refresh_skill_levels_menu_bar("farming");
            break;
            case "fishing_xp":
                refresh_xp_bar("fishing");
                refresh_skill_levels_menu_bar("fishing");
            break;
            case "breeding_xp":
                Quests.displayMiniQuestButtons("mini_quest_breeding_shop");
                refresh_xp_bar("breeding");
                refresh_skill_levels_menu_bar("breeding");
            break;
            case "mining_unlocked":
                unlock_skill("mining");
            break;
            case "crafting_unlocked":
                unlock_skill("crafting");
            break;
            case "melee_unlocked":
                unlock_skill("melee");
            break;
            case "archery_unlocked":
                unlock_skill("archery");
            break;
            case "magic_unlocked":
                unlock_skill("magic");
            break;
            case "melee_xp":
                refresh_xp_bar("melee");
                refresh_skill_levels_menu_bar("melee");
            break;
            case "archery_xp":
                refresh_xp_bar("archery");
                refresh_skill_levels_menu_bar("archery");
            break;
            case "magic_xp":
                refresh_xp_bar("magic");
                refresh_skill_levels_menu_bar("magic");
            break;
            case "invention_xp":
                refresh_xp_bar("invention");
                refresh_skill_levels_menu_bar("invention");
            break;
            case "gathering_unlocked":
                unlock_skill("gathering");
            break;
            case "farming_unlocked":
                unlock_skill("farming");
            break;
            case "fishing_unlocked":
                unlock_skill("fishing");
            break;
            case "invention_unlocked":
                if(value > 0) {
                    document.getElementById("menu-bar-invention-table-btn-wrapper-unlockable").style.display = "none";
                    unlock_skill("invention");
                }
                
            break;
            case "breeding_disease":
            case "breeding_death":
                if(value == 1) {
                    document.getElementById("notification-" + key).style.display = "";
                } else {
                    document.getElementById("notification-" + key).style.display = "none";
                }
            break;
            case "team_chat_on":
                if(value == 1) {
                    set_image_src("btn-label-check-teamchat-mode", "images/check.png");
                } else {
                    set_image_src("btn-label-check-teamchat-mode", "images/x.png");
                }
            break;
            case "brewing_unlocked":
                unlock_skill("brewing");
                var eles = document.querySelectorAll('[data-brewing-shortcut-btn]');
                for(var i = 0; i < eles.length; i++) {
                    eles[i].style.display = "";
                }
            break;
            case "breeding_unlocked":
                unlock_skill("breeding");
                document.getElementById("notification-breeding_can_unlocked").style.display = "none";
            break;
            case "breeding_chicken_egg":
                if(Items.getItem("breeding_unlocked") == 0) {
                    document.getElementById("notification-breeding_can_unlocked").style.display = "";
                }
                
            break;
            case "woodcutting_unlocked":
                unlock_skill("woodcutting");
            break;
            case "cooking_unlocked":
                document.getElementById("menu-bar-heat").style.display = "";
                document.getElementById("menu-bar-heat-2").style.display = "";
                unlock_skill("cooking");
            break;
            case "achievements_unlocked":
                document.getElementById("menu-bar-achievements-icon").src = get_image("images/achievements.png");
                document.getElementById("left-panel-item_panel-achievements").style.display = "";
            break;
            case "username":
                set_innerHTML('fighting-hero-label', capitalizeFirstLetter(value))
                document.getElementById('search-username-hiscores').href = '../../hiscores/search?username='+value
                document.getElementById("chat-area-input").placeholder = value;
            break;
            case "has_purchased_donor_coins":
                if(value > 0) {
                    document.getElementById("referral-program-message-donor").style.display = "";
                }
            break;
            case "friends_online":
                if(value > 0) {
                    document.getElementById("notification-friends_online").style.display = "";
                } else {
                    document.getElementById("notification-friends_online").style.display = "none";
                }
            break;
            case "referral_program":
                if(value == 1 || value == 2) {
                    var user = Items.getItemString("username");
                    var link = "https://idle-pixel.com/playnow?ref=" + user;
                    var html = "<span id='reference-link-topbar-link'>"+link+"</span> ";
                    var arrow = ''
                    if(value == 1) {
                        arrow = '<img class="w25" src="https://cdn.idle-pixel.com/images/left_arrow.gif" />'
                    }

                    html += '<img class="w15 hover" onclick="copyReferenceLink()"  src="https://cdn.idle-pixel.com/images/copy-icon-grey.svg" />&nbsp;<img class="w15 hover" onclick="switch_panels(\'panel-referral\');"  src="https://cdn.idle-pixel.com/images/grey-cogwheel-icon.svg" /> '+arrow+' &nbsp; | &nbsp;&nbsp;&nbsp;';
                    document.getElementById("reference-link-topbar").innerHTML = html;
                    document.getElementById("input-text-referral-link").innerHTML = link;
                }
            break;
            case "hp":
                Fighting.refreshHeroHpProgressBar();
                document.getElementById("combat_hp").innerHTML = value;
            break;

            case "animal_data":
                Breeding.refresh_animals_data(value);
            break;

            case "chicken_pen_obtained":
            case "sheep_pen_obtained":
            case "dove_pen_obtained": 
            case "horse_pen_obtained": 
            case "camel_pen_obtained": 
            case "spider_pen_obtained":
                Breeding.refresh_pens_table();
            break;
            
            case "new_settings_checkbox_condense_main_items":
            case "new_settings_checkbox_show_progress_bars":
            case "new_settings_checkbox_show_levels":
            case "new_settings_checkbox_show_labels":
            case "new_settings_checkbox_show_extra_labels":
            case "new_settings_checkbox_machines_left":
            case "new_settings_checkbox_machines_top":
            case "new_settings_checkbox_rocket_idle_left":
            case "new_settings_checkbox_rocket_idle_top":
            case "new_settings_checkbox_rocket_landed_left":
            case "new_settings_checkbox_rocket_landed_top":
            case "new_settings_checkbox_furnace_left":
            case "new_settings_checkbox_furnace_top":
            case "new_settings_checkbox_foundry_left":
            case "new_settings_checkbox_foundry_top":
            case "new_settings_checkbox_gathering_unique_left":
            case "new_settings_checkbox_gathering_unique_top":
            case "new_settings_checkbox_trees_left":
            case "new_settings_checkbox_trees_top":
            case "new_settings_checkbox_farming_left":
            case "new_settings_checkbox_farming_top":
            case "new_settings_checkbox_farming_empty_left":
            case "new_settings_checkbox_farming_empty_top":
            case "new_settings_checkbox_watering_can_left":
            case "new_settings_checkbox_watering_can_top":
            case "new_settings_checkbox_birdhouse_idle_left":
            case "new_settings_checkbox_birdhouse_idle_top":
            case "new_settings_checkbox_birdhouse_ready_left":
            case "new_settings_checkbox_birdhouse_ready_top":
            case "new_settings_checkbox_potions_inactive_left":
            case "new_settings_checkbox_potions_inactive_top":
            case "new_settings_checkbox_cooksbook_idle_left":
            case "new_settings_checkbox_cooksbook_idle_top":
            case "new_settings_checkbox_cooksbook_ready_left":
            case "new_settings_checkbox_cooksbook_ready_top":
            case "new_settings_checkbox_boats_idle_left":
            case "new_settings_checkbox_boats_idle_top":
            case "new_settings_checkbox_boats_collect_left":
            case "new_settings_checkbox_boats_collect_top":
            case "new_settings_checkbox_treasure_map_left":
            case "new_settings_checkbox_treasure_map_top":
            case "new_settings_checkbox_green_treasure_map_left":
            case "new_settings_checkbox_green_treasure_map_top":
            case "new_settings_checkbox_red_treasure_map_left":
            case "new_settings_checkbox_red_treasure_map_top":
            case "new_settings_checkbox_stardust_watch_top":
            case "new_settings_checkbox_fight_points_left":
            case "new_settings_checkbox_fight_points_top":
            case "new_settings_checkbox_crystal_magic_xp_left":
            case "new_settings_checkbox_crystal_magic_xp_top":
            case "new_settings_checkbox_aquarium_left":
            case "new_settings_checkbox_aquarium_top":
            case "new_settings_checkbox_furnace_browser_tab":
            case "new_settings_checkbox_farming_browser_tab":
            case "new_settings_checkbox_woodcutting_browser_tab":
            case "new_settings_checkbox_fp_browser_tab":
            case "new_settings_checkbox_hide_reproduction_popup":
                Modals.manageBooleanSetting(value == 1, key)
                Modals.toggleSettingsCheckBox(value == 1, key)
            break;

           

            case "in_raids":
                if(value > 0) {
                    show_element("notification-raid");
                } else {
                    hide_element("notification-raid");
                    Raids.critsPotionActiveBy = "none";
                }
            break;
            case "beach_rain_timer":
                if(Items.getItem("disable_rain") == 0)
                {
                    if(value > 0)
                    {
                        show_element("combat-rain");
                    }
                    else
                    {
                        hide_element("combat-rain");
                    }
                }
            break;

            case "team_member_active1":
                {
                    var index = 1;
                    if(value > 0) {
                        show_element('raids-left-hero-magic-fordisplay-team' + index);
                        show_element('raids-left-hero-hp-bars-' + index);
                    } else {
                        hide_element('raids-left-hero-hp-bars-' + index);
                        hide_element('raids-left-hero-magic-fordisplay-team' + index);
                    }
                }
            break;
            case "team_member_active2":
                {
                    var index = 2;
                    if(value > 0) {
                        show_element('raids-left-hero-magic-fordisplay-team' + index);
                        show_element('raids-left-hero-hp-bars-' + index);
                    } else {
                        hide_element('raids-left-hero-hp-bars-' + index);
                        hide_element('raids-left-hero-magic-fordisplay-team' + index);
                    }
                }
            break;
            case "team_member_active3":
                {
                    var index = 3;
                    if(value > 0) {
                        show_element('raids-left-hero-magic-fordisplay-team' + index);
                        show_element('raids-left-hero-hp-bars-' + index);
                    } else {
                        hide_element('raids-left-hero-hp-bars-' + index);
                        hide_element('raids-left-hero-magic-fordisplay-team' + index);
                    }
                }
            break;
            case "team_member_active4":
                {
                    var index = 4;
                    if(value > 0) {
                        show_element('raids-left-hero-magic-fordisplay-team' + index);
                        show_element('raids-left-hero-hp-bars-' + index);
                    } else {
                        hide_element('raids-left-hero-hp-bars-' + index);
                        hide_element('raids-left-hero-magic-fordisplay-team' + index);
                    }
                }
            break;

            case "crystal_ball_monster":
            case "crystal_ball_spell":
                Magic.refreshCrystalAngelBallIcon();
            break;
            case "stone":
                if(Globals.currentPanel == "panel-crafting" && Items.getItem("stone_statue_crafted") == 0) Crafting.refresh_table(document.getElementById('crafting-table'));
            break;
            case "coins":
                if(Globals.currentPanel == "panel-shop") {
                    refresh_shop();
                }
            break;

            case "raids_username1":
                document.getElementById("raids-left-player-1-label").innerHTML = value;
            break;
            case "raids_username2":
                document.getElementById("raids-left-player-2-label").innerHTML = value;
            break;
            case "raids_username3":
                document.getElementById("raids-left-player-3-label").innerHTML = value;
            break;
            case "raids_username4":
                document.getElementById("raids-left-player-4-label").innerHTML = value;
            break;


            case "raids_hp1":
                Raids.refreshHeroHpProgressBar(1);
                document.getElementById("combat_hp-hero-raids-1").innerHTML = value; 
            break;
            case "raids_hp2":
                Raids.refreshHeroHpProgressBar(2);
                document.getElementById("combat_hp-hero-raids-2").innerHTML = value; 
            break;
            case "raids_hp3":
                Raids.refreshHeroHpProgressBar(3);
                document.getElementById("combat_hp-hero-raids-3").innerHTML = value; 
            break;
            case "raids_hp4":
                Raids.refreshHeroHpProgressBar(4);
                document.getElementById("combat_hp-hero-raids-4").innerHTML = value; 
            break;
            case "raids_max_hp1":
                Raids.refreshHeroHpProgressBar(1);
                document.getElementById("combat_max_hp-hero-raids-1").innerHTML = value;
            break;
            case "raids_max_hp2":
                Raids.refreshHeroHpProgressBar(2);
                document.getElementById("combat_max_hp-hero-raids-2").innerHTML = value;
            break;
            case "raids_max_hp3":
                Raids.refreshHeroHpProgressBar(3);
                document.getElementById("combat_max_hp-hero-raids-3").innerHTML = value;
            break;
            case "raids_max_hp4":
                Raids.refreshHeroHpProgressBar(4);
                document.getElementById("combat_max_hp-hero-raids-4").innerHTML = value;
            break;

            case "raids_mana1":
                Raids.refreshHeroManaProgressBar(1);
                document.getElementById("combat_mana-hero-raids-1").innerHTML = value; 
            break;
            case "raids_mana2":
                Raids.refreshHeroManaProgressBar(2);
                document.getElementById("combat_mana-hero-raids-2").innerHTML = value; 
            break;
            case "raids_mana3":
                Raids.refreshHeroManaProgressBar(3);
                document.getElementById("combat_mana-hero-raids-3").innerHTML = value; 
            break;
            case "raids_mana4":
                Raids.refreshHeroManaProgressBar(4);
                document.getElementById("combat_mana-hero-raids-4").innerHTML = value; 
            break;

            case "raids_spell_cooldown_heal1":
                Raids.refreshSpell('heal', value, 1);
            break;
            case "raids_spell_cooldown_heal2":
                Raids.refreshSpell('heal', value, 2);
            break;
            case "raids_spell_cooldown_heal3":
                Raids.refreshSpell('heal', value, 3);
            break;
            case "raids_spell_cooldown_heal4":
                Raids.refreshSpell('heal', value, 4);
            break;

            case "raids_spell_cooldown_fire1":
                Raids.refreshSpell('fire', value, 1);
            break;
            case "raids_spell_cooldown_fire2":
                Raids.refreshSpell('fire', value, 2);
            break;
            case "raids_spell_cooldown_fire3":
                Raids.refreshSpell('fire', value, 3);
            break;
            case "raids_spell_cooldown_fire4":
                Raids.refreshSpell('fire', value, 4);
            break;

            case "raids_spell_cooldown_reflect1":
                Raids.refreshSpell('reflect', value, 1);
            break;
            case "raids_spell_cooldown_reflect2":
                Raids.refreshSpell('reflect', value, 2);
            break;
            case "raids_spell_cooldown_reflect3":
                Raids.refreshSpell('reflect', value, 3);
            break;
            case "raids_spell_cooldown_reflect4":
                Raids.refreshSpell('reflect', value, 4);
            break;

            case "raids_spell_cooldown_invisibility1":
                Raids.refreshSpell('invisibility', value, 1);
            break;
            case "raids_spell_cooldown_invisibility2":
                Raids.refreshSpell('invisibility', value, 2);
            break;
            case "raids_spell_cooldown_invisibility3":
                Raids.refreshSpell('invisibility', value, 3);
            break;
            case "raids_spell_cooldown_invisibility4":
                Raids.refreshSpell('invisibility', value, 4);
            break;

            case "raids_max_mana1":
                Raids.refreshHeroManaProgressBar(1);
                document.getElementById("combat_max_mana-hero-raids-1").innerHTML = value;
            break;
            case "raids_max_mana2":
                Raids.refreshHeroManaProgressBar(2);
                document.getElementById("combat_max_mana-hero-raids-2").innerHTML = value;
            break;
            case "raids_max_mana3":
                Raids.refreshHeroManaProgressBar(3);
                document.getElementById("combat_max_mana-hero-raids-3").innerHTML = value;
            break;
            case "raids_max_mana4":
                Raids.refreshHeroManaProgressBar(4);
                document.getElementById("combat_max_mana-hero-raids-4").innerHTML = value;
            break;

            case "guaridan_two_rain":
                if(Items.getItem("disable_rain") == 0)
                {
                    if(value == 1)
                    {
                        hide_element("combat-tar-rain");
                        show_element("combat-rain");
                        show_element("combat-rain-2");
                        
                    }
                    else if(value == 2)
                    {
                        hide_element("combat-rain");
                        hide_element("combat-rain-2");
                        show_element("combat-tar-rain");
                    }
                    else
                    {
                        hide_element("combat-rain");
                        hide_element("combat-rain-2");
                        hide_element("combat-tar-rain");
                    }
                } 
            break;

            case "broken_rake_unclaimed_unique":
                Gathering.refresh_uniques_found_label();
            break;
            case "robot_wave_timer":
                
                if(value > 0)
                {
                    show_element("notification-robot_waves");
                }
                else
                {
                    hide_element("notification-robot_waves");
                }
            break;

           
            case "menu_bar_show_energy_potential_on":
                if(value == 1) {
                    document.getElementById("left-menu-bar-energy-potential-label").innerHTML = format_number(Cooking.get_potential_energy());
                    document.getElementById("left-menu-bar-energy-potential-label-2").innerHTML = format_number(Cooking.get_potential_energy());
                    document.getElementById("settings-menu-bar-show-energy-potential-checkbox").checked = true;
                } else {
                    document.getElementById("settings-menu-bar-show-energy-potential-checkbox").checked = false;
                }
            break;


            


            case "settings_activity_log_off":
                if(value == 1) {
                    document.getElementById("settings-activity-log").innerHTML = "Off";
                    hide_element("activity-log-area")
                } else {
                    document.getElementById("settings-activity-log").innerHTML = "On";
                    show_element("activity-log-area")
                }
            break;
            

        

            case "tcg_active":
                CardData.fetchData();
            break;

            case "green_gaurdian_key":
            case "blue_gaurdian_key":
            case "purple_gaurdian_key":
            case "mixed_gaurdian_key":
                Combat.refreshGuardianFightsItemBox();
            break;
            case "tcg_timer":
                if(value > 0) {
                    document.getElementById("tcg-shop-itembox").innerHTML = format_time(value);
                } else {
                    document.getElementById("tcg-shop-itembox").innerHTML = 'READY'
                }
            break;

            case "monster_collection_log_total":
            case "monster_collection_log_player_total":
                var playerTotal = Items.getItem("monster_collection_log_player_total");
                var serverTotal = Items.getItem("monster_collection_log_total");

                var color = "yellow";
                if(playerTotal == serverTotal) {
                    color = "lime";
                } else if(playerTotal == 0) {
                    color = "red";
                }
                document.getElementById("combat_log_label").style.color = color;
                document.getElementById("combat_log_label").innerHTML = playerTotal + "/" + serverTotal;
            break;

            case "let_us_invent_things_quest":
                if(value == 6) {
                    document.getElementById("blood-lab-panel").style.display = "";
                } else {
                    document.getElementById("blood-lab-panel").style.display = "none";
                }
            break;

            case "event_upcomming_timer":
                if(value > 0) {
                    show_element("notification-event-timer");
                    document.getElementById("notification-event-timer-value").innerHTML = format_time(value);
                }
                else {
                    hide_element("notification-event-timer");
                }
            break;
            case "event_active_timer":
                if(value > 0) {
                    show_element("notification-event-live");
                }
                else {
                    hide_element("notification-event-live");
                }
            break;

           
            case "teleport_crystal_cooldown":
                if(value > 0) {
                    set_image_src("item-box-teleport_crystal-image", "images/teleport_crystal_depleted.png");
                    document.getElementById("itembox-teleport_crystal-label").textContent = format_time(value)
                }
                else {
                    set_image_src("item-box-teleport_crystal-image", "images/teleport_crystal.png");
                    document.getElementById("itembox-teleport_crystal-label").textContent = 'READY';
                }
            break;
            case "max_hp":
                Fighting.refreshHeroHpProgressBar();
                document.getElementById("combat_max_hp").innerHTML = value;
            break;
            case "mana":
                Fighting.refreshHeroManaProgressBar();
                Magic.refreshSpellStatus();

                document.getElementById("combat_mana").innerHTML = value;
            break;
            case "max_mana":
                document.getElementById("combat_max_mana").innerHTML = value;
            break;
            
            case "monster_accuracy":
                document.getElementById("combat_monster_accuracy").innerHTML = value;
            break;
            case "monster_attack":
                document.getElementById("combat_monster_attack").innerHTML = value;
            break;
            case "monster_defence":
                document.getElementById("combat_monster_defence").innerHTML = value;
            break;
            case "monster_speed":
                document.getElementById("combat_monster_speed").innerHTML = value;
            break;

    
            
            case "monster_hp":
                document.getElementById("combat_monster_hp").innerHTML = value;
                Fighting.refreshMonsterHpProgressBar();
            break;

            case "bronze_bar":
            case "iron_bar":
            case "silver_bar":
            case "gold_bar":
                if(Globals.currentPanel == "panel-crafting") Crafting.refresh_table(document.getElementById('crafting-table'));
            break;

            case "optional_quests_unlocked":
                document.getElementById('optional-quest-tab-button-label').innerHTML = Quests.getOptionalQuestsDataLabel();
            break;

            case "mini_quest_breeding_shop":
            case "mini_quest_chop_ent":
            case "mini_quest_green_leaf_buddy":
                Quests.displayMiniQuestButtons(key);
            break;
            case "gameloop_tick_difference":
                show_element("gameloop_tick_difference-label");
            break;
            case "chefs_hat":
            case "dotted_salad_prepared_total":
                Cooking.refresh_chefs_hat();
            break;
            case "monster_max_hp":
                document.getElementById("combat_monster_max_hp").innerHTML = value;
            break;
            case "merchant_timer":
                if(value > 0)
                {
                    document.getElementById("merchant-label").innerHTML = format_time(value);
                    document.getElementById("shop-merchant-3").style.display = 'none';
                    document.getElementById("shop-merchant-2").style.display = 'none';
                    document.getElementById("shop-merchant-1").style.display = 'none';
                    document.getElementById("notification-merchant").style.display = "";
                }
                else if(value == 0)
                {
                    document.getElementById("notification-merchant").style.display = "none";
                    document.getElementById("merchant-label").innerHTML = "Shop Open";

                }
            break;
            case "merchant":
                document.getElementById("merchant").style.display = "";
            break;
            case "monster_name":
                if(value == "none")
                    hide_element("notification-combat");
                else
                {
                    Fighting.reset_animations(value);
                    show_element("notification-combat");
                    Combat.set_monster_name_label(value, true);
                    Magic.refreshSpellStatus();
                }
            break;
            
            case "oil_in":
                if(value > 0) {
                    show_element("menu-bar-oil-in");
                    show_element("menu-bar-oil-in-2");
                }
                   
            break;
            case "oil_out":
                if(value > 0) {
                    show_element("menu-bar-oil-out");
                    show_element("menu-bar-oil-out-2");
                }
                    
            break;

            case "drill_timer":
                var perc = value/12;
                perc = perc * 100;
                if(perc <= 0) perc = 1;
                document.getElementById("itembox-progress-bar-drill").style.width = perc + "%";
            break;
            case "crusher_timer":
                var perc = value/12;
                perc = perc * 100;
                if(perc <= 0) perc = 1;
                document.getElementById("itembox-progress-bar-crusher").style.width = perc + "%";
            break;
            case "giant_drill_timer":
                var perc = value/12;
                perc = perc * 100;
                if(perc <= 0) perc = 1;
                document.getElementById("itembox-progress-bar-giant_drill").style.width = perc + "%";
            break;
            case "excavator_timer":
                var perc = value/12;
                perc = perc * 100;
                if(perc <= 0) perc = 1;
                document.getElementById("itembox-progress-bar-excavator").style.width = perc + "%";
            break;
            case "giant_excavator_timer":
                var perc = value/12;
                perc = perc * 100;
                if(perc <= 0) perc = 1;
                document.getElementById("itembox-progress-bar-giant_excavator").style.width = perc + "%";
            break;
            case "massive_excavator_timer":
                var perc = value/12;
                perc = perc * 100;
                if(perc <= 0) perc = 1;
                document.getElementById("itembox-progress-bar-massive_excavator").style.width = perc + "%";
            break;
            case "pickaxe_timer":
                var perc = value/12;
                perc = perc * 100;
                if(perc <= 0) perc = 1;
                document.getElementById("itembox-progress-bar-pickaxe").style.width = perc + "%";
                document.getElementById("itembox-progress-bar-sapphire_pickaxe").style.width = perc + "%";
                document.getElementById("itembox-progress-bar-emerald_pickaxe").style.width = perc + "%";
                document.getElementById("itembox-progress-bar-ruby_pickaxe").style.width = perc + "%";
                document.getElementById("itembox-progress-bar-diamond_pickaxe").style.width = perc + "%";
            break;
            case "ach_perk_unlocked_notif":
                if(value == 1) {
                    show_element("notification-menu-ach-perk");
                } else {
                    hide_element("notification-menu-ach-perk");
                }
            break;
            case "furnace_ore_amount_at":
            case "furnace_ore_amount_set":
                    if(value > 0)
                    {
                        show_element("notification-furnace-running");
                        set_image_src("notification-furnace-image", "images/" + Furnace.get_bar_for_ore(Items.getItemString("furnace_ore_type")) + ".png");
                       
                        document.getElementById("notification-furnace-label").innerText = 
                            format_number(Items.getItem("furnace_ore_amount_at")) + "/" +
                            format_number(Items.getItem("furnace_ore_amount_set"));

                        
                        var at = Items.getItem("furnace_ore_amount_at")
                        var set = Items.getItem("furnace_ore_amount_set");

                        if(set > 0) {
                            var perc = at/set;
                            perc = perc * 100;
                            if(perc <= 0) perc = 1;
                            document.getElementById("itembox-progress-bar-stone_furnace").style.width = perc + "%";
                            document.getElementById("itembox-progress-bar-bronze_furnace").style.width = perc + "%";
                            document.getElementById("itembox-progress-bar-iron_furnace").style.width = perc + "%";
                            document.getElementById("itembox-progress-bar-silver_furnace").style.width = perc + "%";
                            document.getElementById("itembox-progress-bar-gold_furnace").style.width = perc + "%";
                            document.getElementById("itembox-progress-bar-promethium_furnace").style.width = perc + "%";
                            document.getElementById("itembox-progress-bar-titanium_furnace").style.width = perc + "%";
                            document.getElementById("itembox-progress-bar-ancient_furnace").style.width = perc + "%";
                            document.getElementById("itembox-progress-bar-dragon_furnace").style.width = perc + "%";
                        }
                        
                        
                    }
            break;

            case "aquarium":
            case "aquarium_timer":
            case "raw_shrimp_aquarium":
            case "raw_anchovy_aquarium":
            case "raw_sardine_aquarium":
            case "raw_crab_aquarium":
            case "raw_piranha_aquarium":
                    if(Items.getItem("aquarium") >= 1) break;

                    if(Items.getItem("aquarium_timer") == 0)
                    {
                        if(Fishing.has_aquarium_with_fish())
                        {
                            document.getElementById("item-box-raw_shrimp_aquarium-label").innerHTML = "<span class='color-pink'>HUNGRY!</span>"
                            document.getElementById("item-box-raw_anchovy_aquarium-label").innerHTML = "<span class='color-pink'>HUNGRY!</span>"
                            document.getElementById("item-box-raw_sardine_aquarium-label").innerHTML = "<span class='color-pink'>HUNGRY!</span>"
                            document.getElementById("item-box-raw_crab_aquarium-label").innerHTML = "<span class='color-pink'>HUNGRY!</span>"
                            document.getElementById("item-box-raw_piranha_aquarium-label").innerHTML = "<span class='color-pink'>HUNGRY!</span>"
                            document.getElementById("modal-aquarium-menu-feed-timer").innerHTML = "HUNGRY NOW!"
                        }
                    }
                    else 
                    {
                        if(Items.getItemString("aquarium_last_food") == "mega_bait")
                        {
                            document.getElementById("item-box-raw_shrimp_aquarium-label").innerHTML = "<span class='color-purple'>PERFECT!</span>"
                            document.getElementById("item-box-raw_anchovy_aquarium-label").innerHTML = "<span class='color-purple'>PERFECT!</span>"
                            document.getElementById("item-box-raw_sardine_aquarium-label").innerHTML = "<span class='color-purple'>PERFECT!</span>"
                            document.getElementById("item-box-raw_crab_aquarium-label").innerHTML = "<span class='color-purple'>PERFECT!</span>"
                            document.getElementById("item-box-raw_piranha_aquarium-label").innerHTML = "<span class='color-purple'>PERFECT!</span>"
    
                        }
                        else if(Items.getItemString("aquarium_last_food") == "super_bait")
                        {
                            document.getElementById("item-box-raw_shrimp_aquarium-label").innerHTML = "<span class='color-cyan'>HAPPY+</span>"
                            document.getElementById("item-box-raw_anchovy_aquarium-label").innerHTML = "<span class='color-cyan'>HAPPY+</span>"
                            document.getElementById("item-box-raw_sardine_aquarium-label").innerHTML = "<span class='color-cyan'>HAPPY+</span>"
                            document.getElementById("item-box-raw_crab_aquarium-label").innerHTML = "<span class='color-cyan'>HAPPY+</span>"
                            document.getElementById("item-box-raw_piranha_aquarium-label").innerHTML = "<span class='color-cyan'>HAPPY+</span>"
    
                        }
                        else if(Items.getItemString("aquarium_last_food") == "bait")
                        {
                            document.getElementById("item-box-raw_shrimp_aquarium-label").innerHTML = "<span class='color-lime'>HAPPY</span>"
                            document.getElementById("item-box-raw_anchovy_aquarium-label").innerHTML = "<span class='color-lime'>HAPPY</span>"
                            document.getElementById("item-box-raw_sardine_aquarium-label").innerHTML = "<span class='color-lime'>HAPPY</span>"
                            document.getElementById("item-box-raw_crab_aquarium-label").innerHTML = "<span class='color-lime'>HAPPY</span>"
                            document.getElementById("item-box-raw_piranha_aquarium-label").innerHTML = "<span class='color-lime'>HAPPY</span>"
    
                        }
                        else {
                            document.getElementById("item-box-raw_shrimp_aquarium-label").innerHTML = "<span class='color-orange'>SATISFIED</span>"
                            document.getElementById("item-box-raw_anchovy_aquarium-label").innerHTML = "<span class='color-orange'>SATISFIED</span>"
                            document.getElementById("item-box-raw_sardine_aquarium-label").innerHTML = "<span class='color-orange'>SATISFIED</span>"
                            document.getElementById("item-box-raw_crab_aquarium-label").innerHTML = "<span class='color-orange'>SATISFIED</span>"
                            document.getElementById("item-box-raw_piranha_aquarium-label").innerHTML = "<span class='color-orange'>SATISFIED</span>"
    
                        }
                       

                        if(Fishing.has_aquarium_with_fish())
                        {
                            document.getElementById("modal-aquarium-menu-feed-timer").innerHTML = format_time(Items.getItem("aquarium_timer"));
                        }
                        else
                            document.getElementById("modal-aquarium-menu-feed-timer").innerHTML = "N/A"
                        
                    }
            break;

            case "moon_distance":
                var element = document.getElementById("top-bar-moon-distance");
                var color = "";
                if(value >= 400000)
                    color = "red";
                else if(value >= 350000 && value < 400000) {
                    color = "orange";
                }
                else if(value >= 300000 && value < 350000) {
                    color = "yellow";
                } else if (value < 300000) {
                    color = "lime";
                }
                element.style.color = color;
            break;

            case "sun_distance":
                var element = document.getElementById("top-bar-sun-distance");
                var color = "";
                if(value >= 175000000)
                    color = "red";
                else if(value >= 150000000 && value < 175000000) {
                    color = "orange";
                }
                else if(value >= 125000000 && value < 150000000) {
                    color = "yellow";
                } else if (value < 125000000) {
                    color = "lime";
                }
                element.style.color = color;
            break;

            case "blood_moon_active":
                if(value > 0)
                {
                    set_image_src("moon-box-label", "images/blood_moon.png");
                    document.getElementById("select-fighting-section-normal-areas").style.display = "none";
                    document.getElementById("select-fighting-section-blood-areas").style.display = "";
                }
                else {
                    set_image_src("moon-box-label", "images/moon.png");
                    document.getElementById("select-fighting-section-normal-areas").style.display = "";
                    document.getElementById("select-fighting-section-blood-areas").style.display = "none";
                }
            break;

            case "blood_moon_unlocked":
                if(value > 0) {
                    document.getElementById("blood-moon-combat-box").style.display = "";
                    document.getElementById("blood-moon-unlock-combat-area-event").style.display = "none";
                }
                
            break;

            case "brewing_xp_mixer_selected":
                document.getElementById("data-current-potion-mixer").setAttribute("data-current-potion", Items.getItemString("brewing_xp_mixer_selected"))
                document.getElementById("data-current-potion-mixer-2").setAttribute("data-current-potion-2", Items.getItemString("brewing_xp_mixer_selected"))
                document.getElementById("modal-brewing-xp-mixer-potion-label").innerHTML = Items.get_pretty_item_name(Items.getItemString("brewing_xp_mixer_selected"));
                set_image_src("modal-brewing-xp-mixer-potion-img", "images/" + Items.getItemString("brewing_xp_mixer_selected") + ".png");

                //extra top bar
                show_element("brewing-kit-extra-label");
                set_image_src("modal-brewing-xp-mixer-potion-img", "images/" + Items.getItemString("brewing_xp_mixer_selected") + ".png");
                document.getElementById("brewing-kit-extra-label-value").innerHTML = Items.get_pretty_item_name(Items.getItemString("brewing_xp_mixer_selected")); 
            break;
            case "gatherer_location":
                
                if(value == "gem_mine")
                    value = "gem mine";

                if(value == "fishing_pond")
                    value = "pond";

                
                document.getElementById('item-box-gathering_worker-label').innerHTML = value.toUpperCase();
                document.getElementById("currently-exploring-gatherer").innerHTML = "CURRENTLY EXPLORING " + value.toUpperCase();
            break;
            case "titanium_charcoal_foundry":
                if(value > 0) {
                    set_image_src("notification-foundry-img","images/titanium_charcoal_foundry.png");
                    set_image_src("notification-foundry-running-img","images/titanium_charcoal_foundry.png");
                }
            break;
            case "foundry_log":
                if(Items.getItemString("foundry_log") == "none")
                {
                    hide_element("notification-foundry-running")
                    document.getElementById("charcoal_foundry-status").innerHTML = "Idle";
                    document.getElementById("titanium_charcoal_foundry-status").innerHTML = "Idle";
                    Animations.shake_off("itembox-img-charcoal_foundry");
                    Animations.shake_off("itembox-img-titanium_charcoal_foundry");
                }
                else
                {
                    document.getElementById("charcoal_foundry-status").innerHTML = "Running";
                    document.getElementById("titanium_charcoal_foundry-status").innerHTML = "Running";
                    Animations.shake_on("itembox-img-charcoal_foundry");
                    Animations.shake_on("itembox-img-titanium_charcoal_foundry");
                    show_element("notification-foundry-running");
                }
            break;
            case "incinerator_cooldown":
            case "incinerator_active":
                if(Items.getItem('incinerator_active') > 0)
                {
                    document.getElementById("incinerator-label").innerHTML = "Running"
                    Animations.shake_on("itembox-incinerator-img");
                }
                else
                {
                    if(Items.getItem('incinerator_cooldown') > 0)
                        document.getElementById("incinerator-label").innerHTML = format_time(Items.getItem('incinerator_cooldown'))
                    else
                        document.getElementById("incinerator-label").innerHTML = "Ready"

                    Animations.shake_off("itembox-incinerator-img");
                }
            break;
            case "foundry_amount":
                document.getElementById("notification-foundry-label").innerHTML = value + " " + get_item_name(Items.getItemString("foundry_log"));
            break;

            case "badge_field_fp_reduction":
                if(value > 0) {
                    document.getElementById("select-combat-screen-fp-fields").innerHTML = "FP: 300"
                }
            break;
            // castle
            case "castle_map":
                if(value > 0)
                {
                    Castle.load_map(value);
                }
            break;
            case "castle_key_1_used":
            case "castle_key_2_used":
            case "castle_key_3_used":
            case "castle_key_4_used":
            case "castle_key_5_used":
            case "castle_key_6_used":
            case "castle_key_7_used":
            case "castle_key_8_used":
            case "castle_key_9_used":
            case "castle_key_10_used":
            case "castle_key_11_used":
            case "castle_key_12_used":
            case "castle_key_13_used":
            case "castle_key_14_used":
            case "castle_key_15_used":
            case "castle_key_16_used":
            case "castle_key_17_used":
            case "castle_key_18_used":
            case "castle_key_19_used":
            case "castle_key_20_used":
            case "castle_key_21_used":
            case "castle_key_22_used":
            case "castle_key_23_used":
            case "castle_key_24_used":
            case "castle_key_25_used":
            case "castle_key_26_used":
            case "castle_key_27_used":
            case "castle_key_28_used":
            case "castle_key_29_used":
            case "castle_key_30_used":
            case "castle_key_1_picked_up":
            case "castle_key_2_picked_up":
            case "castle_key_3_picked_up":
            case "castle_key_4_picked_up":
            case "castle_key_5_picked_up":
            case "castle_key_6_picked_up":
            case "castle_key_7_picked_up":
            case "castle_key_8_picked_up":
            case "castle_key_9_picked_up":
            case "castle_key_10_picked_up":
            case "castle_key_11_picked_up":
            case "castle_key_12_picked_up":
            case "castle_key_13_picked_up":
            case "castle_key_14_picked_up":
            case "castle_key_15_picked_up":
            case "castle_key_16_picked_up":
            case "castle_key_17_picked_up":
            case "castle_key_18_picked_up":
            case "castle_key_19_picked_up":
            case "castle_key_20_picked_up":
            case "castle_key_21_picked_up":
            case "castle_key_22_picked_up":
            case "castle_key_23_picked_up":
            case "castle_key_24_picked_up":
            case "castle_key_25_picked_up":
            case "castle_key_26_picked_up":
            case "castle_key_27_picked_up":
            case "castle_key_28_picked_up":
            case "castle_key_29_picked_up":
            case "castle_key_30_picked_up":
            case "arrow_hidden_1":
            case "arrow_hidden_2":
            case "arrow_hidden_3":
            case "arrow_hidden_4":
            case "arrow_hidden_5":
            case "arrow_hidden_6":
            case "arrow_hidden_7":
            case "arrow_hidden_8":
            case "arrow_hidden_9":
            case "arrow_hidden_10":
            case "hidden_castle_chest_1":
            case "hidden_castle_chest_2":
            case "hidden_castle_chest_3":
            case "hidden_castle_chest_4":
            case "hidden_castle_chest_5":
            case "strange_leaf_tree_picked_up":
            case "castle_ants_kills":
            case "castle_saltwater_crocodile_kills":
            case "green_ball_picked_up":
            case "red_ball_picked_up":
            case "blue_ball_picked_up":
            case "castle_quiz_1_completed":
            case "clicks_wizard_1_found":
            case "castle_yeti_kills":
            case "sledge_hammer_picked_up":
            case "pressure_plate_1_used":
            case "castle_chest_tablette":
            case "castle_chest_tablette_opened":
                Castle.load_map(Items.getItem("castle_map"));
            break;
            case "castle_chest_tablette_2":
            case "castle_chest_tablette_2_opened":
            case "looted_train_cond":
                Castle.load_map(Items.getItem("castle_map"));
            break;
            //end castle
            case "heat_pending":
                if(value > 0)
                {
                    show_element("notification-oven");

                    document.getElementById("notification-oven-label").innerText = 
                        "Heating: " + format_number(Items.getItem("heat_pending"));

                        Animations.shake_on("itembox-img-bronze_oven");
                        Animations.shake_on("itembox-img-iron_oven");
                        Animations.shake_on("itembox-img-silver_oven");
                        Animations.shake_on("itembox-img-gold_oven");
                        Animations.shake_on("itembox-img-promethium_oven");
                        Animations.shake_on("itembox-img-titanium_oven");
                        Animations.shake_on("itembox-img-ancient_oven");
                }
                else
                {
                    hide_element("notification-oven");
                    Animations.shake_off("itembox-img-bronze_oven");
                    Animations.shake_off("itembox-img-iron_oven");
                    Animations.shake_off("itembox-img-silver_oven");
                    Animations.shake_off("itembox-img-gold_oven");
                    Animations.shake_off("itembox-img-promethium_oven");
                    Animations.shake_off("itembox-img-titanium_oven");
                    Animations.shake_off("itembox-img-ancient_oven");
                }
            break;

            case "pickaxe":
            case "sapphire_pickaxe":
            case "emerald_pickaxe":
            case "ruby_pickaxe":
            case "diamond_pickaxe":
                if(value > 0)
                {
                    hide_element("mining-message-to-buy-shop")
                    document.getElementById("shop-pickaxe").style.display = "none";
                    document.getElementById("socket-tools-pickaxe").src = get_image("images/" + key + ".png")

                    if(key == "diamond_pickaxe")
                        document.getElementById("sockets-tools-upgrade-btn-pickaxe").style.display = "none";

                }
            break;

            case "team_id":
                if(value > 0) {
                    document.getElementById("left-panel-item_panel-teams").style.display = "";
                }
            break;

            case "team_name":
                document.getElementById("left-panel-item_panel-teams-label").innerHTML = capitalizeFirstLetter(value);
                document.getElementById("panel-teams-title").innerHTML = capitalizeFirstLetter(value);
            break;
            case "team_usernames":
                var size = value.split(",").length;
                document.getElementById("left-panel-item_panel-teams-label-sublabel").innerHTML = "Team Size: " + size;
            break;

            case "last_take_from_storage_var":
            case "last_take_from_storage_amount":
                Modals.refreshBTNRememberTakeFromStore();
            break;
            case "trowel":
            case "sapphire_trowel":
            case "emerald_trowel":
            case "ruby_trowel":
            case "diamond_trowel":
                if(value > 0)
                {
                    document.getElementById("socket-tools-trowel").src = get_image("images/" + key + ".png")

                    if(key == "diamond_trowel")
                        document.getElementById("sockets-tools-upgrade-btn-trowel").style.display = "none";
                } 
            break;
            

            case "watering_can_active":
                if(value == 1)
                {
                    var watering_can = Farming.getWateringCanToolData()[0];

                    if(watering_can == "watering_can")
                    {
                        document.getElementById("img-farm_rain_1").style.display = "";
                    }

                    if(watering_can == "sapphire_watering_can")
                    {
                        document.getElementById("img-farm_rain_1").style.display = "";
                        document.getElementById("img-farm_rain_2").style.display = "";
                    }

                    if(watering_can == "emerald_watering_can")
                    {
                        document.getElementById("img-farm_rain_1").style.display = "";
                        document.getElementById("img-farm_rain_2").style.display = "";
                        document.getElementById("img-farm_rain_3").style.display = "";
                    }

                    if(watering_can == "ruby_watering_can")
                    {
                        document.getElementById("img-farm_rain_1").style.display = "";
                        document.getElementById("img-farm_rain_2").style.display = "";
                        document.getElementById("img-farm_rain_3").style.display = "";
                        document.getElementById("img-farm_rain_4").style.display = "";
                    }

                    if(watering_can == "diamond_watering_can")
                    {
                        document.getElementById("img-farm_rain_1").style.display = "";
                        document.getElementById("img-farm_rain_2").style.display = "";
                        document.getElementById("img-farm_rain_3").style.display = "";
                        document.getElementById("img-farm_rain_4").style.display = "";
                        document.getElementById("img-farm_rain_5").style.display = "";
                    }
                }
                else if(value == 0)
                {
                    document.getElementById("img-farm_rain_1").style.display = "none";
                    document.getElementById("img-farm_rain_2").style.display = "none";
                    document.getElementById("img-farm_rain_3").style.display = "none";
                    document.getElementById("img-farm_rain_4").style.display = "none";
                    document.getElementById("img-farm_rain_5").style.display = "none";
                }
            break;
            case "water":
                
            break;
            case "watering_can":
            case "sapphire_watering_can":
            case "emerald_watering_can":
            case "ruby_watering_can":
            case "diamond_watering_can":
                if(value > 0)
                {
                    hide_element("mining-message-to-buy-shop")
                    document.getElementById("socket-tools-watering_can").src = get_image("images/" + key + ".png")

                    if(key == "diamond_watering_can")
                        document.getElementById("sockets-tools-upgrade-btn-watering_can").style.display = "none";
                } 
            break;
            case "toolkit":
            case "sapphire_toolkit":
            case "emerald_toolkit":
            case "ruby_toolkit":
            case "diamond_toolkit":
                if(value > 0)
                {
                    document.getElementById("socket-tools-toolkit").src = get_image("images/" + key + ".png")

                    if(key == "diamond_toolkit")
                        document.getElementById("sockets-tools-upgrade-btn-toolkit").style.display = "none";
                } 
            break;

            case "mega_rocket":
                set_image_src("notification-rocket-idle-img", "images/mega_rocket.png")
                set_image_src("notification-rocket-idle-img-2", "images/mega_rocket.png")
                set_image_src("notification-rocket-image", "images/mega_rocket.png")
            break;

            case "brewing_xp_mixer_used":
                document.getElementById('item-box-brewing_xp_mixer').innerHTML = value;
                document.getElementById('item-box-stardust_brewing_xp_mixer').innerHTML = value;
                
            break;

            case "hammer":
            case "sapphire_hammer":
            case "emerald_hammer":
            case "ruby_hammer":
            case "diamond_hammer":
                if(value > 0)
                {
                    document.getElementById("socket-tools-hammer").src = get_image("images/" + key + ".png")

                    if(key == "diamond_hammer")
                        document.getElementById("sockets-tools-upgrade-btn-hammer").style.display = "none";
                }
            break;

            case "accuracy":
                document.getElementById("combat_hero_accuracy").innerHTML = value;
            break;
            case "melee_damage":
                document.getElementById("combat_hero_melee_damage").innerHTML = value;
            break;
            case "arrow_damage":
                document.getElementById("combat_hero_arrow_damage").innerHTML = value;
            break;
            case "rocket_km":
                if(value == 0)
                {
                    document.getElementById("rocket-item-box-label").innerHTML = "Idle";
                    set_image_src("item-box-rocket-img", "images/rocket_idle.png");
                    Animations.shake_off("item-box-rocket-img");
                    //mega
                    
                    document.getElementById("mega_rocket-item-box-label").innerHTML = "Idle";
                    set_image_src("item-box-mega_rocket-img", "images/mega_rocket_idle.png");
                    Animations.shake_off("item-box-mega_rocket-img");

                    show_notification("rocket_idle", true);
                    show_notification("rocket_landed", false);
                    hide_element("notification-rocket");

                }
                else if(value > 0)
                {
                    if(value == Items.getItem("rocket_distance_required"))
                    {
                        document.getElementById('notification-rocket-label').innerHTML = "Landed";
                        document.getElementById("rocket-item-box-label").innerHTML = "Landed";
                        set_image_src("item-box-rocket-img", "images/rocket_idle.png");
                        Animations.shake_off("item-box-rocket-img");

                        //mega
                        document.getElementById('notification-mega_rocket-label').innerHTML = "Landed";
                        document.getElementById("mega_rocket-item-box-label").innerHTML = "Landed";
                        set_image_src("item-box-mega_rocket-img", "images/mega_rocket_idle.png");
                        Animations.shake_off("item-box-mega_rocket-img");

                        show_notification("rocket_landed", true);
                        show_notification("rocket_idle", false);
                        hide_element("notification-rocket");
                    } 
                    else
                    {
                        document.getElementById("rocket-item-box-label").innerHTML = "Operating";
                        set_image_src("item-box-rocket-img", "images/rocket.gif");
                        Animations.shake_on("item-box-rocket-img");
                        if(Items.getItemString("rocket_status") == "from_sun" || Items.getItemString("rocket_status") == "from_moon") {
                            document.getElementById('notification-rocket-label').innerHTML = format_number(value);
                            document.getElementById("notification-rocket-image").classList.add("img-vert");
                        } else {
                            document.getElementById("notification-rocket-image").classList.remove("img-vert");
                            document.getElementById('notification-rocket-label').innerHTML = format_number(value) + "/" + format_number(Items.getItem("rocket_distance_required")) + " km";
                            var req = parseInt(Items.getItem("rocket_distance_required"));
                            if(req == 0) {
                                document.getElementById("rocket-item-box-label").innerHTML = "0 %";
                            } else {
                                var perc = parseInt(value) / req;
                                perc *= 100;
                                document.getElementById("rocket-item-box-label").innerHTML = parseFloat(perc).toFixed(2)  + " %";
                            } 
                        }
                        

                        //mega
                        set_image_src("item-box-mega_rocket-img", "images/mega_rocket.gif");
                        Animations.shake_on("item-box-mega_rocket-img");
                        if(Items.getItemString("rocket_status") == "from_sun" || Items.getItemString("rocket_status") == "from_moon") {
                            document.getElementById('notification-mega_rocket-label').innerHTML = format_number(value);
                            document.getElementById("notification-rocket-image").classList.add("img-vert");
                            document.getElementById("mega_rocket-item-box-label").innerHTML = "Returning";
                        } else {
                            document.getElementById("notification-rocket-image").classList.remove("img-vert");
                            document.getElementById('notification-mega_rocket-label').innerHTML = format_number(value) + "/" + format_number(Items.getItem("rocket_distance_required")) + " km";
                            var req = parseInt(Items.getItem("rocket_distance_required"));
                            if(req == 0) {
                                document.getElementById("mega_rocket-item-box-label").innerHTML = "0 %";
                            } else {
                                var perc = parseInt(value) / req;
                                perc *= 100;
                                document.getElementById("mega_rocket-item-box-label").innerHTML = parseFloat(perc).toFixed(2)  + " %";
                            }  
                        }
                        

                        show_notification("rocket_landed", false);
                        show_notification("rocket_idle", false);
                        show_element("notification-rocket");

                    }
                }
            break;
            case "magic_bonus":
                document.getElementById("combat_hero_magic_bonus").innerHTML = value;
            break;
            case "speed":
                document.getElementById("combat_hero_speed").innerHTML = value;
            break;
            case "defence":
                document.getElementById("combat_hero_defence").innerHTML = value;
            break;

            case "weak_defence_ring":
			case "weak_damage_ring":
			case "weak_accuracy_ring":
			case "defence_ring":
			case "damage_ring":
			case "accuracy_ring":
            case "good_defence_ring":
			case "good_damage_ring":
			case "good_accuracy_ring":
            case "great_defence_ring":
			case "great_damage_ring":
			case "great_accuracy_ring":
            case "perfect_defence_ring":
            case "perfect_damage_ring":
            case "perfect_accuracy_ring":
            case "ancient_defence_ring":
            case "ancient_damage_ring":
            case "ancient_accuracy_ring":
                document.getElementById('itembox-rings').style.display = "";
            break;

            case "is_hardcore":
                if(value > 0)
                {
                    if(Items.getItem("team_id") == 0) {
                        document.getElementById("settings-hardcore-panel").style.display = "";
                        document.getElementById("remove-hardcore-button").style.display = "";
                    }
                    
                }
            break;
            

            case "one_life_hardcore_total":
                if(value > 0)
                {
                    document.getElementById("settings-hardcore-panel").style.display = "";
                    document.getElementById("reset-account-button").style.display = "";
                }
            break;
           

            case "merchant_selling_item_1":
            case "merchant_selling_item_2":
            case "merchant_selling_item_3":
            case "merchant_barter_item_1":
            case "merchant_barter_item_2":
            case "merchant_barter_item_3":
            case "merchant_selling_item_amount_1":
            case "merchant_selling_item_amount_2":
            case "merchant_selling_item_amount_3":
            case "merchant_barter_amount_1":
            case "merchant_barter_amount_2":
            case "merchant_barter_amount_3":
                refresh_merchant();
            break;

            case "row_boat_timer":
                if(value == 0)
                {
                    set_innerHTML("label-row_boat", "Idle");
                    hide_element("notification-row_boat")
                }
                else if(value > 1)
                {
                    show_element("notification-row_boat")
                    set_innerHTML("label-row_boat", format_time(value));
                    set_innerHTML("notification-row_boat-label", format_time(value));
                }
                else if(value == 1)
                {
                    set_innerHTML("label-row_boat", "Collect");
                    set_innerHTML("notification-row_boat-label", "Collect");
                } 
            break;
            case "canoe_boat_timer":
                if(value == 0)
                {
                    hide_element("notification-canoe_boat")
                    set_innerHTML("label-canoe_boat", "Idle");
                }
                else if(value > 1)
                {
                    show_element("notification-canoe_boat")
                    set_innerHTML("label-canoe_boat", format_time(value));
                    set_innerHTML("notification-canoe_boat-label", format_time(value));
                }
                else if(value == 1)
                {
                    show_element("notification-canoe_boat")
                    set_innerHTML("label-canoe_boat", "Collect");
                    set_innerHTML("notification-canoe_boat-label", "Collect");
                } 
            break;
            case "stardust_boat_timer":
                
                if(value == 0)
                {
                    set_innerHTML("label-stardust_boat", "Idle");
                    hide_element("notification-stardust_boat")
                }
                else if(value > 1)
                {
                    show_element("notification-stardust_boat")
                    set_innerHTML("label-stardust_boat", format_time(value));
                    set_innerHTML("notification-stardust_boat-label", format_time(value));
                }
                else if(value == 1)
                {
                    show_element("notification-stardust_boat")
                    set_innerHTML("label-stardust_boat", "Collect");
                    set_innerHTML("notification-stardust_boat-label", "Collect");
                } 
            break;
            case "pirate_ship_timer":   
                if(value == 0)
                {
                    set_innerHTML("label-pirate_ship", "Idle");
                    hide_element("notification-pirate_ship")
                }
                else if(value > 1)
                {
                    show_element("notification-pirate_ship")
                    set_innerHTML("label-pirate_ship", format_time(value));
                    set_innerHTML("notification-pirate_ship-label", format_time(value));
                }
                else if(value == 1)
                {
                    show_element("notification-pirate_ship")
                    set_innerHTML("label-pirate_ship", "Collect");
                    set_innerHTML("notification-pirate_ship-label", "Collect");
                } 
            break;
            case "submarine_boat_timer":   
                if(value == 0)
                {
                    hide_element("notification-submarine_boat")
                    set_innerHTML("label-submarine_boat", "Idle");
                }
                else if(value > 1)
                {
                    show_element("notification-submarine_boat")
                    set_innerHTML("label-submarine_boat", format_time_short(value));
                    set_innerHTML("notification-submarine_boat-label", format_time(value));
                }
                else if(value == 1)
                {
                    show_element("notification-submarine_boat")
                    set_innerHTML("label-submarine_boat", "Collect");
                    set_innerHTML("notification-submarine_boat-label", "Collect");
                } 
            break;


            case "red_farming_orb_absorbed_timer":
            case "red_woodcutting_orb_absorbed_timer":
            case "red_combat_orb_absorbed_timer":
                if(value == 0)
                {
                    document.getElementById("notification-" + key).style.display = "none";
                    document.getElementById("box_label_" + key).innerHTML = "BOUND";
                    document.getElementById("box_check_" + key).style.display = "";

                }
                else
                {
                    document.getElementById("notification-" + key).style.display = "";
                    document.getElementById("box_label_" + key).innerHTML = format_time_short(value);
                    document.getElementById("box_check_" + key).style.display = "none";
                }
            break;

            case "disable_plant_confirmation":
                if(value == 0)
                {
                    document.getElementById("setting-disable-plant-confirmation").innerHTML = "DISABLED";
                }
                if(value == 1)
                {
                    document.getElementById("setting-disable-plant-confirmation").innerHTML = "ENABLED";
                }
            break;
            case "disable_drink_confirmation":
                if(value == 0)
                {
                    document.getElementById("setting-disable-drink-confirmation").innerHTML = "DISABLED";
                }
                if(value == 1)
                {
                    document.getElementById("setting-disable-drink-confirmation").innerHTML = "ENABLED";
                }
            break;
           

            case "brewing_kit":
            case "sapphire_brewing_kit":
            case "emerald_brewing_kit":
            case "ruby_brewing_kit":
            case "diamond_brewing_kit":
                if(value > 0)
                {
                    document.getElementById("socket-tools-brewing_kit").src = get_image("images/" + key + ".png")

                    if(key == "diamond_brewing_kit")
                        document.getElementById("sockets-tools-upgrade-btn-brewing_kit").style.display = "none";

                    load_brewing_timer_tooltips();
                }
            break;

            case "combat_countdown_timer":
                if(value > 0) 
                {
                    document.getElementById("fighting-countdown").style.display = "";
                    document.getElementById("fighting-countdown").innerHTML = "FIGHT IN " + value;
                }
                else {
                    document.getElementById("fighting-countdown").style.display = "none";
                }

            break;

            case "chisel":
            case "sapphire_chisel":
            case "emerald_chisel":
            case "ruby_chisel":
            case "diamond_chisel":
                if(value > 0)
                {
                    document.getElementById("socket-tools-chisel").src = get_image("images/" + key + ".png")

                    if(key == "diamond_chisel")
                        document.getElementById("sockets-tools-upgrade-btn-chisel").style.display = "none";
                }
            break;

            case "needle":
            case "sapphire_needle":
            case "emerald_needle":
            case "ruby_needle":
            case "diamond_needle":
                if(value > 0)
                {
                    document.getElementById("socket-tools-needle").src = get_image("images/" + key + ".png")

                    if(key == "diamond_needle")
                        document.getElementById("sockets-tools-upgrade-btn-needle").style.display = "none";
                }
            break;

            case "train_cart_active":
                show_element("train-cart-active-img");
            break;

            case "volcano_unlocked":
                
                if(value > 0)
                {
                    set_image_src("volcano-train-sign-img", "images/volcano_fields_sign_unlocked.png");
                    document.getElementById("modal-combat-train-network-path-volcano-label").innerHTML = "<span class='color-green'>UNLOCKED</span>"
                    document.getElementById("game-panels-combat-select-area-card-volcano-locked").style.display = 'none';
                    document.getElementById("game-panels-combat-select-area-card-volcano").style.display = '';
                }
            break;

            case "guardian_three_kills": 
                if(value > 0) {
                    document.getElementById('guardian-key-3-extra-label').style.display = "";
                }
            break;

            case "nades_purple_key_monster":
            case "nades_purple_key_rarity":
                document.getElementById("guardian-key-3-extra-label-value").innerHTML = capitalizeFirstLetter(get_item_name(Items.getItemString('nades_purple_key_monster'))) + " ("+get_item_name(Items.getItemString('nades_purple_key_rarity'))+")"
            break;

            case "stardust_watch_crafted": 
                if(value > 0) {
                    document.getElementById('stardust-watch-extra-label').style.display = "";
                }
            break;
            

            case "northern_field_unlocked":
                if(value > 0) {
                    set_image_src("northern-field-train-sign-img", "images/northern_fields_sign_unlocked.png");
                    document.getElementById("modal-combat-train-network-path-nf-label").innerHTML = "<span class='color-green'>UNLOCKED</span>"
                    document.getElementById("game-panels-combat-select-area-card-nf-locked").style.display = 'none';
                    document.getElementById("game-panels-combat-select-area-card-nf").style.display = '';
                }
            break;
            
            case "mansion_unlocked":
                if(value > 0) {
                    set_image_src("mansion-train-sign-img", "images/mansion_fields_sign_unlocked.png");
                    document.getElementById("modal-combat-train-network-path-mansion-label").innerHTML = "<span class='color-green'>UNLOCKED</span>"
                    document.getElementById("game-panels-combat-select-area-card-hm-locked").style.display = 'none';
                    document.getElementById("game-panels-combat-select-area-card-hm").style.display = '';
                } 
            break;

            case "beach_map_bought":
                if(value > 0) {
                    document.getElementById('ghost-shop-' + key).style.display = "none";
                    document.getElementById("game-panels-combat-select-area-card-beach-locked").style.display = 'none';
                    document.getElementById("game-panels-combat-select-area-card-beach").style.display = '';
                }
            break;


            case "criptoe_path_perm_dwarf":
            case "criptoe_path_perm_nature":
            case "criptoe_path_perm_chemist":
            case "criptoe_path_perm_sea":
                document.getElementById(key + "-label").style.display = "";
           
            break;

            case "ring_parts_bought":
                if(value > 0) {
                    document.getElementById('ghost-shop-' + key).style.display = "none";
                    document.getElementById("game-panels-combat-select-area-card-beach-locked").style.display = 'none';
                    document.getElementById("game-panels-combat-select-area-card-beach").style.display = '';
                }
            break;

            case "fishing_net":
            case "sapphire_fishing_net":
            case "emerald_fishing_net":
            case "ruby_fishing_net":
            case "diamond_fishing_net":
                if(value > 0)
                {
                    document.getElementById("socket-tools-fishing_net").src = get_image("images/" + key + ".png")

                    if(key == "diamond_fishing_net")
                        document.getElementById("sockets-tools-upgrade-btn-fishing_net").style.display = "none";
                }

                if(key != "fishing_net" && value > 0)
                    show_element("earn-extra-xp-fishing-net-label");
            break;
            
            case "magnet":
                case "sapphire_magnet":
                case "emerald_magnet":
                case "ruby_magnet":
                case "diamond_magnet":
                    if(value > 0)
                    {
                        document.getElementById("socket-tools-magnet").src = get_image("images/" + key + ".png")
    
                        if(key == "diamond_magnet")
                            document.getElementById("sockets-tools-upgrade-btn-magnet").style.display = "none";
                    }
                break;


            case "house_0":
            case "house_1":
            case "house_2":
            case "house_3":
            case "house_4":
            case "house_5":
            case "house_6":
            case "house_7":
                if(value > 0) document.getElementById("the-carpenter-cabin-img").src = get_image("images/" + key + ".png")
            break;
            case "player_frozen":
                if(value > 0)
                    Monsters.hero_frozen = true;
                else 
                    Monsters.hero_frozen = false;
            break;
            case "monster_frozen":
                if(value > 0)
                    Monsters.monster_frozen = true;
                else 
                    Monsters.monster_frozen = false;
            break;
            case "fishing_rod":
            case "sapphire_fishing_rod":
            case "emerald_fishing_rod":
            case "ruby_fishing_rod":
            case "diamond_fishing_rod":
                if(value > 0)
                {
                    document.getElementById("socket-tools-fishing_rod").src = get_image("images/" + key + ".png")

                    if(key == "diamond_fishing_rod")
                        document.getElementById("sockets-tools-upgrade-btn-fishing_rod").style.display = "none";
                }

                if(key != "fishing_rod" && value > 0)
                    show_element("earn-extra-xp-fishing-rod-label");
            break;

            case "harpoon":
            case "sapphire_harpoon":
            case "emerald_harpoon":
            case "ruby_harpoon":
            case "diamond_harpoon":
                if(value > 0)
                {
                    document.getElementById("socket-tools-harpoon").src = get_image("images/" + key + ".png")

                    if(key == "diamond_harpoon")
                        document.getElementById("sockets-tools-upgrade-btn-harpoon").style.display = "none";
                }

                if(key != "harpoon" && value > 0)
                    show_element("earn-extra-xp-harpoon-label");
            break;

            case "rake":
            case "sapphire_rake":
            case "emerald_rake":
            case "ruby_rake":
            case "diamond_rake":
                if(value > 0)
                {
                    document.getElementById("socket-tools-rake").src = get_image("images/" + key + ".png")

                    if(key == "diamond_rake")
                        document.getElementById("sockets-tools-upgrade-btn-rake").style.display = "none";
                }
            break;

            case "axe":
            case "sapphire_axe":
            case "emerald_axe":
            case "ruby_axe":
            case "diamond_axe":
                if(value > 0)
                {
                    document.getElementById("socket-tools-axe").src = get_image("images/" + key + ".png")

                    if(key == "diamond_axe")
                        document.getElementById("sockets-tools-upgrade-btn-axe").style.display = "none";
                }
            break;

           
            case "machete":
            case "sapphire_machete":
            case "emerald_machete":
            case "ruby_machete":
            case "diamond_machete":
                if(value > 0)
                {
                    document.getElementById("socket-tools-machete").src = get_image("images/" + key + ".png")

                    if(key == "diamond_machete")
                        document.getElementById("sockets-tools-upgrade-btn-machete").style.display = "none";
                }
            break;

            case "force_sd_mining":
                if(value != 1) {
                    document.getElementById("mining-xp-sd-force-label").style.display = "none";
                } else {
                    document.getElementById("mining-xp-sd-force-label").style.display = "";
                }
            break;

            case "force_sd_crafting":
                if(value != 1) {
                    document.getElementById("crafting-xp-sd-force-label").style.display = "none";
                } else {
                    document.getElementById("crafting-xp-sd-force-label").style.display = "";
                }
            break;
            
            case "quest_available":
                if(value == 0) hide_element("notification-quest-available");
                if(value == 1)
                {
                    if(!Globals.new_quest_splash_flash_triggered && Items.getItem("doric_the_crafter_quest") == -1)
                    {
                        Globals.new_quest_splash_flash_triggered = true;
                        show_splash("images/quests.png", "You have the requirements to start a new quest!", true, false);
                    }
                        
                    
                    show_element("notification-quest-available");
                }
            break;
            case "raids_brewing_scroll_hp_learnt":
                document.getElementById("id-raids_hp_potion").style.display = "";
            break;
            case "raids_brewing_scroll_mana_learnt":
                document.getElementById("id-raids_mana_potion").style.display = "";
            break;
            case "raids_brewing_scroll_crits_learnt":
                document.getElementById("id-raids_crits_potion").style.display = "";
            break;

            case "fighting_background":
                change_fighting_background(value);
            break;
            case "furnace_ore_type":
                if(value == "none")
                {
                    hide_element("notification-furnace-running");

                    show_element("itembox-img-stone_furnace-label");
                    show_element("itembox-img-bronze_furnace-label");
                    show_element("itembox-img-iron_furnace-label");
                    show_element("itembox-img-silver_furnace-label");
                    show_element("itembox-img-gold_furnace-label");
                    show_element("itembox-img-promethium_furnace-label");
                    show_element("itembox-img-titanium_furnace-label");
                    show_element("itembox-img-ancient_furnace-label");
                    show_element("itembox-img-dragon_furnace-label");

                    hide_element("itembox-img-stone_furnace-progress-bar");
                    hide_element("itembox-img-bronze_furnace-progress-bar");
                    hide_element("itembox-img-iron_furnace-progress-bar");
                    hide_element("itembox-img-silver_furnace-progress-bar");
                    hide_element("itembox-img-gold_furnace-progress-bar");
                    hide_element("itembox-img-promethium_furnace-progress-bar");
                    hide_element("itembox-img-titanium_furnace-progress-bar");
                    hide_element("itembox-img-ancient_furnace-progress-bar");
                    hide_element("itembox-img-dragon_furnace-progress-bar");

                    set_image_src("itembox-img-stone_furnace", "images/stone_furnace.png");
                    set_image_src("itembox-img-bronze_furnace", "images/bronze_furnace.png");
                    set_image_src("itembox-img-iron_furnace", "images/iron_furnace.png");
                    set_image_src("itembox-img-silver_furnace", "images/silver_furnace.png");
                    set_image_src("itembox-img-gold_furnace", "images/gold_furnace.png");
                    set_image_src("itembox-img-promethium_furnace", "images/promethium_furnace.png");
                    set_image_src("itembox-img-titanium_furnace", "images/titanium_furnace.png");
                    set_image_src("itembox-img-ancient_furnace", "images/ancient_furnace.png");
                    set_image_src("itembox-img-dragon_furnace", "images/dragon_furnace.png");
                }
                else
                {
                    hide_element("itembox-img-stone_furnace-label");
                    hide_element("itembox-img-bronze_furnace-label");
                    hide_element("itembox-img-iron_furnace-label");
                    hide_element("itembox-img-silver_furnace-label");
                    hide_element("itembox-img-gold_furnace-label");
                    hide_element("itembox-img-promethium_furnace-label");
                    hide_element("itembox-img-titanium_furnace-label");
                    hide_element("itembox-img-ancient_furnace-label");
                    hide_element("itembox-img-dragon_furnace-label");

                    show_element("itembox-img-stone_furnace-progress-bar");
                    show_element("itembox-img-bronze_furnace-progress-bar");
                    show_element("itembox-img-iron_furnace-progress-bar");
                    show_element("itembox-img-silver_furnace-progress-bar");
                    show_element("itembox-img-gold_furnace-progress-bar");
                    show_element("itembox-img-promethium_furnace-progress-bar");
                    show_element("itembox-img-titanium_furnace-progress-bar");
                    show_element("itembox-img-ancient_furnace-progress-bar");
                    show_element("itembox-img-dragon_furnace-progress-bar");

                    set_image_src("itembox-img-stone_furnace", "images/stone_furnace.gif");
                    set_image_src("itembox-img-bronze_furnace", "images/bronze_furnace.gif");
                    set_image_src("itembox-img-iron_furnace", "images/iron_furnace.gif");
                    set_image_src("itembox-img-silver_furnace", "images/silver_furnace.gif");
                    set_image_src("itembox-img-gold_furnace", "images/gold_furnace.gif");
                    set_image_src("itembox-img-promethium_furnace", "images/promethium_furnace.gif");
                    set_image_src("itembox-img-titanium_furnace", "images/titanium_furnace.gif");
                    set_image_src("itembox-img-ancient_furnace", "images/ancient_furnace.gif");
                    set_image_src("itembox-img-dragon_furnace", "images/dragon_furnace.gif");

                    set_image_src("notification-furnace-image", "images/" + Furnace.get_bar_for_ore(value) + ".png");
                }

            break;
            case "drill_on":
                document.getElementById("modal-mining-machinery-on").innerHTML = value;
                if(value > 0)
                {
                    show_element("notification-drill");
                    set_image_src("item-box-drill-img", "images/drill.gif");
                    document.getElementById("notification-drill-label").innerHTML = value + " running"

                }
                else
                {
                    set_image_src("item-box-drill-img", "images/drill.png");
                    hide_element("notification-drill");
                }
            break;

            case "faradox_bosses_unlocked":
                $('#select-area-combat-faradox-final-1').delay(500).fadeIn();
                $('#select-area-combat-faradox-final-2').delay(500).fadeIn();
                $('#select-area-combat-faradox-final-3').delay(500).fadeIn();
                $('#select-area-combat-faradox-final-4').delay(500).fadeIn();
                $('#select-area-combat-faradox-final-5').delay(500).fadeIn();
                $('#select-area-combat-faradox-final-6').delay(500).fadeIn();
            break;
            case "faradox_castle_unlocked":
                if(value > 0) 
                {
                    document.getElementById("arrow-up-tomb-stone").style.display = "none";
                    document.getElementById("arrow-up-castle").style.display = "";

                    document.getElementById("select-area-combat-faradox-castle-unlock").style.display = "none";
                    document.getElementById("select-area-combat-faradox-castle").style.display = "";

                    set_image_src("modal-faradox-castle-img", "images/faradox_castle.png")
                }
            break;

    

            case "tree_shiny_1":
            case "tree_shiny_2":
            case "tree_shiny_3":
            case "tree_shiny_4":
            case "tree_shiny_5":
                var last_char = key.slice(key.length - 1);
                if(value == 1) 
                    show_element('img-tree_shiny_' + last_char);
                else 
                    hide_element('img-tree_shiny_' + last_char)
            break;

            case "tree_mega_shiny_1":
            case "tree_mega_shiny_2":
            case "tree_mega_shiny_3":
            case "tree_mega_shiny_4":
            case "tree_mega_shiny_5":
                var last_char = key.slice(key.length - 1);
                if(value == 1) 
                    show_element('img-mega_tree_shiny_' + last_char);
                else 
                    hide_element('img-mega_tree_shiny_' + last_char)
            break;

            case "monster_shiny":
                if(value == 1) 
                    show_element('img-monster_shiny');
                else 
                    hide_element('img-monster_shiny')
            break;
            case "monster_mega_shiny":
                if(value == 1) 
                    show_element('img-mega_monster_shiny');
                else 
                    hide_element('img-mega_monster_shiny')
            break;

            case "farm_shiny_1":
            case "farm_shiny_2":
            case "farm_shiny_3":
            case "farm_shiny_4":
            case "farm_shiny_5":
                var last_char = key.slice(key.length - 1);
                if(value == 1) 
                    show_element('img-farm_shiny_' + last_char);
                else 
                    hide_element('img-farm_shiny_' + last_char);
            break;

            case "farm_mega_shiny_1":
            case "farm_mega_shiny_2":
            case "farm_mega_shiny_3":
            case "farm_mega_shiny_4":
            case "farm_mega_shiny_5":
                var last_char = key.slice(key.length - 1);
                if(value == 1) 
                    show_element('img-mega_farm_shiny_' + last_char);
                else 
                    hide_element('img-mega_farm_shiny_' + last_char);
            break;

            case "crusher_on":
                document.getElementById("modal-mining-machinery-on").innerHTML = value;
                if(value > 0)
                {
                    show_element("notification-crusher");
                    set_image_src("item-box-crusher-img", "images/crusher.gif");
                    document.getElementById("notification-crusher-label").innerHTML = value + " running"
                }
                else
                {
                    set_image_src("item-box-crusher-img", "images/crusher.png");
                    hide_element("notification-crusher");
                }
            break;

            case "giant_drill_on":
                document.getElementById("modal-mining-machinery-on").innerHTML = value;
                if(value > 0)
                {
                    show_element("notification-giant_drill");
                    set_image_src("item-box-giant_drill-img", "images/giant_drill.gif");
                    document.getElementById("notification-giant_drill-label").innerHTML = value + " running"
                }
                else
                {
                    set_image_src("item-box-giant_drill-img", "images/giant_drill.png");
                    hide_element("notification-giant_drill");
                }
            break;

            case "excavator_on":
                document.getElementById("modal-mining-machinery-on").innerHTML = value;
                if(value > 0)
                {
                    set_image_src("item-box-excavator-img", "images/excavator.gif");
                    show_element("notification-excavator");
                    document.getElementById("notification-excavator-label").innerHTML = value + " running"
                }
                else
                {
                    set_image_src("item-box-excavator-img", "images/excavator.png");
                    hide_element("notification-excavator");
                }
            break;

            case "giant_excavator_on":
                document.getElementById("modal-mining-machinery-on").innerHTML = value;
                if(value > 0)
                {
                    set_image_src("item-box-giant_excavator-img", "images/giant_excavator.gif");
                    show_element("notification-giant_excavator");
                    document.getElementById("notification-giant_excavator-label").innerHTML = value + " running"
                }
                else
                {
                    set_image_src("item-box-giant_excavator-img", "images/giant_excavator.png");
                    hide_element("notification-giant_excavator");
                }
            break;

            case "massive_excavator_on":
                document.getElementById("modal-mining-machinery-on").innerHTML = value;
                if(value > 0)
                {
                    show_element("notification-massive_excavator");
                    set_image_src("item-box-massive_excavator-img", "images/massive_excavator.gif");
                    document.getElementById("notification-massive_excavator-label").innerHTML = value + " running"
                }
                else
                {
                    set_image_src("item-box-massive_excavator-img", "images/massive_excavator.png");
                    hide_element("notification-massive_excavator");
                }
            break;

            case "current_gathering_area":
                if(value != "none" && value != 0)
                {
                    Gathering.stop_animation();
                    Gathering.start_progress_bar(value);
                }
            break;
            case "keyitems_section_unlocked":
                show_element("left-panel-item_panel-keyitems");
                switch_panels('panel-keyitems');
            break;

            case "bread":
                if(value > 0)
                switch_panels('panel-keyitems');
            break;

            case "stardust_unlocked":
                show_element("menu-bar-stardust");
                show_element("menu-bar-stardust-2");
            break;

            case "energy_unlocked":
                show_element("menu-bar-energy");
                show_element("menu-bar-energy-2");
            break;
            
            case "farm_stage_1":
            case "farm_stage_2":
            case "farm_stage_3":
            case "farm_stage_4":
            case "farm_stage_5":
                
            break;
            case "tree_stage_1":
            case "tree_stage_2":
            case "tree_stage_3":
            case "tree_stage_4":
            case "tree_stage_5":
                
            break;

            case "account_rights":
                switch(value){
                    case "owner":
                    case "tester":
                        show_element("top-bar-admin-link");
                    break;
                }
            break;

            case "player_market":
                document.getElementById("left-panel-item_panel-player-market").style.display = "";
            break;

            case "donor_shop":
                document.getElementById("left-panel-item_panel-donor-shop").style.display = "";
            break;

            case "donor_tag":
            case "super_donor_tag":
            case "ultra_donor_tag":
            case "contributor_tag":
            case "financier_tag":
            case "investor_tag":
            case "investor_plus_tag":
                Chat.refresh_chat_tags();
            break;
            case "farm_timer_1":
                Farming.refreshTimers(1);
            break;
            case "farm_timer_2":
                Farming.refreshTimers(2);
            break;
            case "farm_timer_3":
                Farming.refreshTimers(3);
            break;
            case "farm_timer_4":
                Farming.refreshTimers(4);
            break;
            case "farm_timer_5":
                Farming.refreshTimers(5);
            break;
            case "tree_timer_1":
                Woodcutting.refreshTimers(1);
            break;
            case "tree_timer_2":
                Woodcutting.refreshTimers(2);
            break;
            case "tree_timer_3":
                Woodcutting.refreshTimers(3);
            break;
            case "tree_timer_4":
                Woodcutting.refreshTimers(4);
            break;
            case "tree_timer_5":
                Woodcutting.refreshTimers(5);
            break;
            case "stardust_expert_hat_taken":
                if(value > 0)
                {
                    set_image_src("stardust_expert_image", "images/stardust_expert_naked.png");
                }
            break;
            case "weapon":
            case "shield":
            case "head":
            case "body":
            case "legs":
            case "gloves":
            case "boots":
            case "amulet":
                Combat.refresh_hero_sprite();
            break;

 
            // case "tut":

            // if(value == -1) {
            //     document.getElementById("tutorial-toaster").style.display = "none";
            //     break;
            // }

            // if(value >= 1) {
            //     document.getElementById("tutorial-toaster").style.display = "";
            // } else {
            //     document.getElementById("tutorial-toaster").style.display = "none";
            // }

            // if(value >= 1) {
            //     document.getElementById("tutorial-toaster-" + value).src = "https://cdn.idle-pixel.com/images/check.png";
            // }
            // if(value >= 2) {
            //     document.getElementById("tutorial-toaster-" + value).src = "https://cdn.idle-pixel.com/images/check.png";
            // }
            // if(value >= 3) {
            //     document.getElementById("tutorial-toaster-" + value).src = "https://cdn.idle-pixel.com/images/check.png";
            // }
            // if(value >= 4) {
            //     document.getElementById("tutorial-toaster-" + value).src = "https://cdn.idle-pixel.com/images/check.png";
            // }
            // break;
            case "arrows":
                
                
                hide_element("menu-bar-idle-hero-arrows-area");
                document.getElementById("menu-bar-idle-hero-arrows-area-2").style.visibility = "hidden";

                //hide arrows selected in itembox
                hide_element("item-box-check-img-wooden_arrows");
                hide_element("item-box-check-img-fire_arrows");
                hide_element("item-box-check-img-ice_arrows");
                hide_element("item-box-check-img-ancient_arrows");

                if(value > 0 || value != "none")
                {
                    show_element("menu-bar-idle-hero-arrows-area");
                    document.getElementById("menu-bar-idle-hero-arrows-area-2").style.visibility = "visible";

                    set_image_src("menu-bar-idle-hero-arrows-image", "images/" + value + ".png")
                    set_image_src("menu-bar-idle-hero-arrows-image-2", "images/" + value + ".png")

                    
                    set_innerHTML("menu-bar-idle-hero-arrows", get_item_name(value))
                    
                    set_innerHTML("menu-bar-idle-hero-arrows-amount", Items.getItem(value));
                    set_innerHTML("menu-bar-idle-hero-arrows-amount-2", Items.getItem(value));

                    //show arrows selected in itembox
                    show_element("item-box-check-img-" + value);
                }
            break;
            case "donor_farm_patches_timestamp":
            case "donor_tree_patches_timestamp":
            case "donor_offline_timer_timestamp":
            case "donor_potion_stacker_timestamp":
            case "donor_bonus_xp_timestamp":
                DonorShop.refresh_active_labels();
            break;
            case "wooden_arrows":
            case "fire_arrows":
            case "ice_arrows":
                set_innerHTML("menu-bar-idle-hero-arrows-amount", value);
                set_innerHTML("menu-bar-idle-hero-arrows-amount-2", value);
            break;
            case "heal_spellscroll_learnt":
            case "fire_spellscroll_learnt":
            case "reflect_spellscroll_learnt":
            case "invisibility_spellscroll_learnt":
                if(value > 0)
                {
                    document.getElementById("fighting-spell-" + key.split("_")[0]).style.display = "";
                }
            break;
            case "invisibility_freebee_used":
                if(value == 0) {
                    set_image_src("image-invisibility_spell_icon", "images/upgraded_invisibility_spell_icon.png");
                } else {
                    set_image_src("image-invisibility_spell_icon", "images/invisibility_spell_icon.png");  
                }
            break;

            case "heal_upgrade_spellscroll_learnt":
            if(value > 0)
                {
                    set_image_src("image-heal_spell_icon", "images/upgraded_heal_spell_icon.png");
                }
            break;
            case "fire_upgrade_spellscroll_learnt":
                if(value > 0)
                {
                    set_image_src("image-fire_spell_icon", "images/upgraded_fire_spell_icon.png");
                }
            break;
            case "reflect_upgrade_spellscroll_learnt":
                if(value > 0)
                {
                    set_image_src("image-reflect_spell_icon", "images/upgraded_reflect_spell_icon.png");
                }
            break;

            case "wooden_sword":
                document.getElementById("menu-bar-melee-table-btn-wrapper").style.display = "";
                document.getElementById("menu-bar-fp").style.display = "";
                document.getElementById("menu-bar-fp-2").style.display = "";
                show_element("menu-bar-energy");
                show_element("menu-bar-energy-2");
            break;
            case "wooden_bow":
                document.getElementById("menu-bar-archery-table-btn-wrapper").style.display = "";
                document.getElementById("menu-bar-fp").style.display = "";
                document.getElementById("menu-bar-fp-2").style.display = "";
                show_element("menu-bar-energy");
                show_element("menu-bar-energy-2");
            break;
            case "wooden_staff":
                document.getElementById("menu-bar-magic-table-btn-wrapper").style.display = "";
                document.getElementById("menu-bar-fp").style.display = "";
                document.getElementById("menu-bar-fp-2").style.display = "";
                show_element("menu-bar-energy");
                show_element("menu-bar-energy-2");
            break;

            case "notifications_wiki_icons":
                if(value == 1) {
                    hide_wiki_icons();
                    document.getElementById("settings-wiki-item-icons").innerHTML = "Hidden";
                } else {
                    show_wiki_icons();
                    document.getElementById("settings-wiki-item-icons").innerHTML = "Visible";
                }
            break;
            case "beehive_timer":
                if(value > 1)
                {
                    Animations.shake_on("itembox-beehive-img");
                    show_element("notification-beehive");
                    set_innerHTML("notification-beehive-label", format_time(value))
                    set_innerHTML("itembox-beehive-label", format_time_short(value))
                }
                else if(value ==  1)
                {
                    Animations.shake_off("itembox-beehive-img");
                    hide_element("notification-beehive");
                    set_innerHTML("notification-beehive-label", "Collect")
                    set_innerHTML("itembox-beehive-label", "Collect")
                    
                }
                else
                {
                    Animations.shake_off("itembox-beehive-img");
                    hide_element("notification-beehive");
                    set_innerHTML("itembox-beehive-label", "Idle")
                }
            break;

            case "redwood_birdhouse":
                set_image_src("itembox-birdhouse-img", "images/redwood_birdhouse.png");
                set_image_src("modal-birdhouse-img-top", "images/redwood_birdhouse.png");
                show_element("modal-birdhouse-loot-ancient-feathers-tr");
                document.getElementById("itembox-birdhouse-label").innerHTML = "Level " + Items.getItem("birdhouse_level") + "/" + Farming.getMaxBirdhouseLevel();
            break;
            case "birdhouse_timer":
            case "birdhouse_level":
                if(Items.getItem("birdhouse_timer") > 1)
                {
                    Animations.shake_on("itembox-birdhouse-img");
                    show_element("notification-birdhouse");
                    set_innerHTML("notification-birdhouse-label", format_time(value))
                    show_notification("birdhouse_ready", false);
                    show_notification("birdhouse_idle", false);
                    document.getElementById("itembox-birdhouse-label").innerHTML = format_time(Items.getItem("birdhouse_timer"));
                }
                else if(Items.getItem("birdhouse_timer") ==  1)
                {
                    Animations.shake_off("itembox-birdhouse-img");
                    hide_element("notification-birdhouse");
                    show_notification("birdhouse_ready", true);
                    show_notification("birdhouse_idle", false);
                    document.getElementById("itembox-birdhouse-label").innerHTML = "Collect";
                }
                else
                {
                    Animations.shake_off("itembox-birdhouse-img");
                    show_notification("birdhouse_ready", false);
                    show_notification("birdhouse_idle", true);
                    hide_element("notification-birdhouse");
                    document.getElementById("itembox-birdhouse-label").innerHTML = "Level " + Items.getItem("birdhouse_level") + "/" + Farming.getMaxBirdhouseLevel();
                }
            break;

            case "badge_points_used":
            case "badge_points_gained": 
                Combat.refreshBadgeLabels();
            break;
            case "cooks_book_timer":
                if(value > 1)
                {
                    Animations.shake_on("item-box-cooks_book-img");
                    show_element("notification-cooks_book");
                    set_image_src("notification-cooks_book-img", "images/"+Items.getItemString("cooks_book_item")+".png");
                    set_innerHTML("notification-cooks_book-label", format_time(value))
                    set_innerHTML("cooks-book-item-status", "Cooking")
                }
                else if(value ==  1)
                {
                    Animations.shake_off("item-box-cooks_book-img");
                    show_element("notification-cooks_book");
                    set_innerHTML("notification-cooks_book-label", "Ready" + " <span class='color-grey'>("+capitalizeFirstLetter(get_item_name(Items.getItemString("cooks_book_item")))+")</span>")
                    set_image_src("notification-cooks_book-img", "images/cooks_book.png");
                    set_innerHTML("cooks-book-item-status", "Ready")
                }
                else
                {
                    Animations.shake_off("item-box-cooks_book-img");
                    hide_element("notification-cooks_book");
                    set_image_src("notification-cooks_book-img", "images/cooks_book.png");
                    set_innerHTML("cooks-book-item-status", "Idle")
                }
            break;
            case "cooks_book":
                document.getElementById('cooks_book-table').style.display = "";
            break;
            case "mansion_shop":
                document.getElementById('ghost-shop').style.display = "";
            break;
            case "combat_presets":
                document.getElementById("combat-presets-area").style.display = "";
            break;
            case "treasure_map":
            case "green_treasure_map":
            case "red_treasure_map":
                show_notification(key, value > 0);
            break;

            case "max_heart_4_bought":
            case "max_mana_3_bought":
            case "scythe_bought":
            case "reaper_hood_bought":
            case "reaper_body_bought":
            case "reaper_skirt_bought":
            case "reaper_gloves_bought":
            case "reaper_boots_bought":
            case "haunted_bow_frame_bought":
            case "skeleton_sword_bought":
            case "gold_leaf_seeds_bought":
            case "charcoal_bought":
            case "bones_bought":
            case "strange_leaf_bought":
                if(value > 0)
                document.getElementById('ghost-shop-' + key).style.display = "none";
            break;


       

            case "crystal_ball_timer":
                if(value == 0)
                {
                    document.getElementById('item-box-label-crystal_ball').style.color = 'lime';
                    document.getElementById('item-box-label-crystal_ball').innerHTML = "Ready";
                    Magic.refresh_magic_crystal_label();
                    hide_element("angel-ball-extra-label-value-timer")
                    show_element("angel-ball-extra-label-value")  
                    
                }
                else
                {
                    show_element("angel-ball-extra-label-value-timer")
                    hide_element("angel-ball-extra-label-value")  
                    document.getElementById('item-box-label-crystal_ball').style.color = 'white';
                    document.getElementById('item-box-label-crystal_ball').innerHTML = format_time_short(value);
                    
                }
            break;

            case "autodrinker_selected":
                var potionSelected = Items.getItem("autodrinker_selected");
                document.getElementById("item-box-label-autodrinker").innerHTML = "<img src='https://cdn.idle-pixel.com/images/"+potionSelected+".png' class='w15'/> ACTIVE"
            break;

            case "four_crystals_finished":
                document.getElementById("select-area-combat-faradox").style.display = "";
            break;
            case "forest_crystal_touched":
            case "earth_crystal_touched":
            case "fire_crystal_touched":
            case "ice_crystal_touched":
            case "forest_crystal_final_touched":
            case "earth_crystal_final_touched":
            case "fire_crystal_final_touched":
            case "ice_crystal_final_touched":
                if(value > 0)
                {
                    document.getElementById("menu-bar-crystals").style.display = "";
                    document.getElementById("menu-bar-crystals-2").style.display = "";

                    var total_crystals_touched = Items.getItem("earth_crystal_touched") + Items.getItem("forest_crystal_touched") + Items.getItem("fire_crystal_touched")  + Items.getItem("ice_crystal_touched");
                    document.getElementById("menu-bar-crystals-value").innerHTML =  total_crystals_touched + "/4";
                    document.getElementById("menu-bar-crystals-value-2").innerHTML =  total_crystals_touched + "/4";
                    if(Items.getItem('the_four_crystals_quest') == -1)
                    {
                        var total_crystals_final_touched = Items.getItem("forest_crystal_final_touched");
                        total_crystals_final_touched += Items.getItem("earth_crystal_final_touched");
                        total_crystals_final_touched += Items.getItem("fire_crystal_final_touched");
                        total_crystals_final_touched += Items.getItem("ice_crystal_final_touched");
                        document.getElementById("menu-bar-crystals-value").innerHTML =  total_crystals_final_touched + "/4";
                        document.getElementById("menu-bar-crystals-value-2").innerHTML =  total_crystals_final_touched + "/4";
                    }
                        
                }
            break;

            case "the_four_crystals_quest":
                if(value == -1)
                {
                    set_image_src("quest-combat_tutor-1", "images/dead_combat_tutor.png");
                    set_image_src("quest-dwarf-1", "images/dead_dwarf.png");
                    set_image_src("quest-dwarf-2", "images/dead_dwarf.png");
                }
                
            break;

            case "oil":
                if(Items.getItem("max_oil") == Items.getItem("oil") && Items.getItem("oil_out") == 0 && Items.getItem("drill") > 0) {
                    show_notification("machines", true);
                } else {
                    show_notification("machines", false);
                }
            break;
            case "pirate":
                if(value == 1) document.getElementById("pirate-shop-cost").innerHTML = "100K";
                else if(value == 2) document.getElementById("pirate-shop-cost").innerHTML = "175K";
                else if(value == 3) document.getElementById("pirate-shop-cost").innerHTML = "250K";
                else if(value == 4) document.getElementById("pirate-shop-cost").innerHTML = "500K";
                else if(value == 5) document.getElementById("pirate-shop-cost").innerHTML = "800K";
                else if(value == 6) document.getElementById("pirate-shop-cost").innerHTML = "1.2M";
                else if(value == 7) document.getElementById("pirate-shop-cost").innerHTML = "3M";
                else if(value == 8) document.getElementById("pirate-shop-cost").innerHTML = "5M";
                else if(value == 9) document.getElementById("pirate-shop-cost").innerHTML = "10M";
                else if(value == 10) document.getElementById("shop-pirate").style.display = "none";
            break;
            case "oil_factory_workers":
                set_innerHTML("oil-factory-oil-label", value * 2);
            break;

            case "ui_font":
                document.getElementById("body").classList.remove("font-famlies");
                document.getElementById("body").classList.remove("legacy-font-families");
                document.getElementById("body").style.fontFamily = "";
                if(value == "DEFAULT")
                {
                    document.getElementById("body").classList.add("font-famlies");
                }
                else if(value == "LEGACY")
                {
                    document.getElementById("body").classList.add("legacy-font-families");
                }
                else
                {
                    document.getElementById("body").style.fontFamily = value;
                }
            break;

            case "ui_main_background_color":
                if(Items.getItemString(key) == "none")
                {
                    document.getElementById("body").style.backgroundColor = "";
                }
                else
                {
                    document.getElementById("body").style.backgroundColor = value;
                    document.getElementById("ui-main-background-color").value = value;
                }
            break;

            case "ui_primary_background_color":
                if(Items.getItemString(key) == "none")
                {
                    document.getElementById("panels").style.backgroundColor = "";
                }
                else
                {
                    document.getElementById("panels").style.backgroundColor = value;
                    document.getElementById("ui-primary-background-color").value = value;
                }
            break;

            case "ui_menu_background_color":
                if(Items.getItemString(key) == "none")
                {
                    document.getElementById("menu-bar").style.backgroundColor = "";
                }
                else
                {
                    document.getElementById("menu-bar").style.backgroundColor = value;
                    document.getElementById("ui-menu-background-color").value = value;
                }
            break;

            case "ui_top_bar_background_color":
                if(Items.getItemString(key) == "none")
                {
                    document.getElementById("top-bar").style.backgroundColor = "";
                }
                else
                {
                    document.getElementById("top-bar").style.backgroundColor = value;
                    document.getElementById("ui-top_bar-background-color").value = value;
                }
            break;

            case "ui_chat_background_color":
                if(Items.getItemString(key) == "none")
                {
                    document.getElementById("game-chat").style.backgroundColor = "";
                }
                else
                {
                    document.getElementById("game-chat").style.backgroundColor = value;
                    document.getElementById("ui-chat-background-color").value = value;
                }
            break;

            case "ui_chat_area_background_color":
                if(Items.getItemString(key) == "none")
                {
                    document.getElementById("chat-area").style.backgroundColor = "";
                    document.getElementById("chat-area-input").style.backgroundColor = "";
                }
                else
                {
                    document.getElementById("chat-area").style.backgroundColor = value;
                    document.getElementById("chat-area-input").style.backgroundColor = value;
                    document.getElementById("ui-chat_area-background-color").value = value;
                }
            break;
            
            

            case "ui_panel_borders_off":
                document.getElementById("radio-button-skill-panel-borders-on").checked = false;
                document.getElementById("radio-button-skill-panel-borders-off").checked = false;
                if(value == "TRUE")
                {
                    document.getElementById("radio-button-skill-panel-borders-off").checked = true;
                    document.getElementById("panel-keyitems").classList.remove("pretty-panel");
                    document.getElementById("panel-mining").classList.remove("pretty-panel");
                    document.getElementById("panel-crafting").classList.remove("pretty-panel");
                    document.getElementById("panel-gathering").classList.remove("pretty-panel");
                    document.getElementById("panel-farming").classList.remove("pretty-panel");
                    document.getElementById("panel-brewing").classList.remove("pretty-panel");
                    document.getElementById("panel-woodcutting").classList.remove("pretty-panel");
                    document.getElementById("panel-cooking").classList.remove("pretty-panel");
                    document.getElementById("panel-fishing").classList.remove("pretty-panel");
                    document.getElementById("panel-invention").classList.remove("pretty-panel");
                    document.getElementById("panel-combat").classList.remove("pretty-panel");
                    document.getElementById("panel-events-seed_piles").classList.remove("pretty-panel");
                    

                }
                else
                {
                    document.getElementById("radio-button-skill-panel-borders-on").checked = true;
                    document.getElementById("panel-keyitems").classList.add("pretty-panel");
                    document.getElementById("panel-mining").classList.add("pretty-panel");
                    document.getElementById("panel-crafting").classList.add("pretty-panel");
                    document.getElementById("panel-gathering").classList.add("pretty-panel");
                    document.getElementById("panel-farming").classList.add("pretty-panel");
                    document.getElementById("panel-brewing").classList.add("pretty-panel");
                    document.getElementById("panel-woodcutting").classList.add("pretty-panel");
                    document.getElementById("panel-cooking").classList.add("pretty-panel");
                    document.getElementById("panel-fishing").classList.add("pretty-panel");
                    document.getElementById("panel-invention").classList.add("pretty-panel");
                    document.getElementById("panel-combat").classList.add("pretty-panel");
                    document.getElementById("panel-events-seed_piles").classList.add("pretty-panel");
                }
            break;

            case "ui_chat_location":
                document.getElementById("radio-button-chat-location-bottom").checked = false;
                document.getElementById("radio-button-chat-location-right").checked = false;
                document.getElementById("chat-increase-size-button").style.display = "";
                document.getElementById("chat-decrease-size-button").style.display = "";
                document.getElementById("game-chat").style.display = "";
                if(value == "DEFAULT")
                {
                    //show bottom
                    document.getElementById("radio-button-chat-location-bottom").checked = true;
                    $("#content").removeClass("side-chat");
                }
                else if(value == "RIGHT")
                {
                    document.getElementById("radio-button-chat-location-right").checked = true;
                    document.getElementById("chat-increase-size-button").style.display = "none";
                    document.getElementById("chat-decrease-size-button").style.display = "none";
                    $("#content").addClass("side-chat");
                }
            break;

            
            case "disable_rain":
                if(value > 0)
                {
                    document.getElementById("setting-disable-rain-button").innerHTML = "DISABLED";
                }
                else 
                {
                    document.getElementById("setting-disable-rain-button").innerHTML = "ENABLED";
                }
            break;
            case "settings_sound":
                if(value == 0)
                    document.getElementById("setting-sounds-button").innerHTML = "100%"
                else if(value == 1)
                    document.getElementById("setting-sounds-button").innerHTML = "75%"
                else if(value == 2)
                    document.getElementById("setting-sounds-button").innerHTML = "50%"
                else if(value == 3)
                    document.getElementById("setting-sounds-button").innerHTML = "25%"
                else if(value == 4)
                    document.getElementById("setting-sounds-button").innerHTML = "Off"
            break;
            case "fight_points":
              
            break;
            case "sapphire_fight_points":
            case "emerald_fight_points":
            case "ruby_fight_points":
            case "diamond_fight_points":
                if(Items.getItem("sapphire_fight_points") == 1)
                {
                    set_image_src("fight-points-image", "images/sapphire_fight_points.png");
                    set_image_src("fight-points-image-2", "images/sapphire_fight_points.png");
                    set_image_src("fight-points-image-3", "images/sapphire_fight_points.png");
                    set_image_src("modal-fightpoints-image", "images/sapphire_fight_points.png");
                    set_image_src("notification-fight_points-full-img", "images/sapphire_fight_points.png");
                }
                if(Items.getItem("emerald_fight_points") == 1)
                {
                    set_image_src("fight-points-image", "images/emerald_fight_points.png");
                    set_image_src("fight-points-image-2", "images/emerald_fight_points.png");
                    set_image_src("fight-points-image-3", "images/emerald_fight_points.png");
                    set_image_src("modal-fightpoints-image", "images/emerald_fight_points.png");
                    set_image_src("notification-fight_points-full-img", "images/emerald_fight_points.png");
                }
                if(Items.getItem("ruby_fight_points") == 1)
                {
                    set_image_src("fight-points-image", "images/ruby_fight_points.png");
                    set_image_src("fight-points-image-2", "images/ruby_fight_points.png");
                    set_image_src("fight-points-image-3", "images/ruby_fight_points.png");
                    set_image_src("modal-fightpoints-image", "images/ruby_fight_points.png");
                    set_image_src("notification-fight_points-full-img", "images/ruby_fight_points.png");
                }  
                if(Items.getItem("diamond_fight_points") == 1)
                {
                    set_image_src("fight-points-image", "images/diamond_fight_points.png");
                    set_image_src("fight-points-image-2", "images/diamond_fight_points.png");
                    set_image_src("fight-points-image-3", "images/diamond_fight_points.png");
                    set_image_src("modal-fightpoints-image", "images/diamond_fight_points.png");
                    set_image_src("notification-fight_points-full-img", "images/diamond_fight_points.png");
                }
            break;

            case "combat_presets_quest":
                if(value == -1)
                {
                    document.getElementById("preset-change-icon-button-1").style.display = "";
                    document.getElementById("preset-change-icon-button-2").style.display = "";
                    document.getElementById("preset-change-icon-button-3").style.display = "";
                    document.getElementById("preset-change-icon-button-4").style.display = "";
                    document.getElementById("preset-change-icon-button-5").style.display = "";
                }
            break;

            case "criptoe_path_selected":
                if(Items.getItemString("criptoe_path_selected") != "none") {
                    set_image_src("select-path-image", "images/criptoe_" + value + ".png");
                    show_element("criptoe_path_selected-left-label")
                    document.getElementById("criptoe_path_selected-left-label").innerHTML = "<br />" + capitalizeFirstLetter(value) + " path";
                
                } 
            break;

            case "researcher1":
                document.getElementById("criptoe-shop-researcher1").style.display = "none";
            break;
            case "researcher2":
                document.getElementById("criptoe-shop-researcher2").style.display = "none";
            break;
            case "researcher3":
                document.getElementById("criptoe-shop-researcher3").style.display = "none";
            break;
            case "researcher4":
                document.getElementById("criptoe-shop-researcher4").style.display = "none";
            break;
            case "researcher5":
                document.getElementById("criptoe-shop-researcher5").style.display = "none";
            break;
            case "banker1":
                document.getElementById("criptoe-shop-banker1").style.display = "none";
            break;
            case "banker2":
                document.getElementById("criptoe-shop-banker2").style.display = "none";
            break;
            case "banker3":
                document.getElementById("criptoe-shop-banker3").style.display = "none";
            break;
            case "banker4":
                document.getElementById("criptoe-shop-banker4").style.display = "none";
            break;
            case "banker5":
                document.getElementById("criptoe-shop-banker5").style.display = "none";
            break;
            case "cannon_damage":
                if(Items.getItem("iron_cannonball") == 0)
                    document.getElementById("cannon-damage-label").innerHTML = "<span style='color:red'>No ammo</span>";
                else
                    document.getElementById("cannon-damage-label").innerHTML = value;
            break;
            case "criptoe_market":
                show_element("left-panel-item_panel-criptoe-market");
            break;
            case "fisherman_timer":
                if(value > 0) set_innerHTML("figherman-timer", format_time(value));
            break;
            case "guardian_key_potion_active":
                if(value == 1)
                {
                    document.getElementById("notification-potion-label-guardian_key_potion_active").innerHTML = " (ACTIVE)";
                }
                else
                {
                    document.getElementById("notification-potion-label-guardian_key_potion_active").innerHTML = " <strike>(ACTIVE)</strike>";
                }
            break;
        }
    }

    
}