class LogManager
{
    static KEY = "idlepixel_history";

    constructor() {
        this.data = []
        if(localStorage.getItem(LogManager.KEY + "_" + Items.getItem('username')) != null) {
            this.data = this.get();
        }
    }
    init_fake_add() {
        var test = {
            'datetime': new Date(),
            'slug': 'monster_drop',
            'data':[
                {'image': 'https://cdn.idle-pixel.com/images/diamond.png', 'label': '1 diamond', 'color': 'cyan'},
                {'image': 'https://cdn.idle-pixel.com/images/ruby.png', 'label': '1 ruby', 'color': 'cyan'},
            ],
        }
        this.data.push(test)
    }

    add_entry(slug, data) {
        var result = {
            'datetime': new Date(),
            'slug': slug,
            'data':data,
        }

        this.data.push(result)
        if(this.data.length >= 1000) this.data.shift();
        this.save();
    }

    reset() {
        localStorage.removeItem(LogManager.KEY + "_" + Items.getItem('username'));
    }

    save() {
        localStorage.setItem(LogManager.KEY + "_" + Items.getItem('username'), JSON.stringify(this.data));
    }
    
    get() {
        return JSON.parse(localStorage.getItem(LogManager.KEY + "_" + Items.getItem('username')));
    }
    

    refresh_panel() {
        var content = document.getElementById("panel-history-content");

        var html = "";
        for(var i = this.data.length - 1; i >= 0; i--) {
            var entry = this.data[i];

            var dt = entry.datetime;
            var slug = entry.slug;
            var monster_drops = entry.data;

            var nowObj = new Date();
            var dtObj = new Date(dt);
            var detla = nowObj - dtObj
            var deltaSeconds = parseInt(detla/1000);
            var deltaMinutes  = parseInt(deltaSeconds/60);
            var deltaHours  = parseInt(deltaMinutes/60);
            var deltaDays  = parseInt(deltaDays/24);

            var timeLabel = "1 second ago";
            if(deltaDays > 0) {
                timeLabel = deltaDays + " days ago";
            }
            else if(deltaHours > 0) {
                if(deltaHours == 1)
                timeLabel = deltaHours + " hour ago";
                else
                timeLabel = deltaHours + " hours ago";
            }
            else if(deltaMinutes > 0) {
                if(deltaMinutes == 1)
                timeLabel = deltaMinutes + " minute ago";
                else
                timeLabel = deltaMinutes + " minutes ago";
            }
            else if(deltaSeconds > 1) {
                timeLabel = deltaSeconds + " seconds ago";
            }
            html += "<div class='drop-log-div'>";
                html += "<div class='drop-log-dt'>"+timeLabel+"</div>"
                for(var j = 0; j < monster_drops.length; j++) {
                    var image = monster_drops[j].image;
                    var label = monster_drops[j].label;
                    var color = monster_drops[j].color;
                    html += "<div class='loot' style='background-color:"+color+"'>";
                    html += "<img src='https://cdn.idle-pixel.com/"+image+"' class='w50 me-3'>";
                    html += label; 
                    html += "</div>";
                }
            html += "</div><br /><br />";
        }

        if(html == "") {
            html = "<br /><br /><div class='center'>You have no data yet.  Loot something and come back to check!</div>"
        }
        content.innerHTML = html;
    }
}