class Magic
{
    static spell_info = {
        "heal": {
            "mana_cost": 2,
            "magic_bonus": 0,
            "spell_id": "heal",
        },
        "fire": {
            "mana_cost": 3,
            "magic_bonus": 1,
            "spell_id": "fire",
        },
        "reflect": {
            "mana_cost": 1,
            "magic_bonus": 0,
            "spell_id": "reflect",
        },
        "invisibility": {
            "mana_cost": 2,
            "magic_bonus": 0,
            "spell_id": "invisibility",
        },
    }


    static refreshCrystalAngelBallIcon() {

        //top bar extra
        var monster = Items.getItemString("crystal_ball_monster");
        var spell = Items.getItemString("crystal_ball_spell");

        var imgMonster =  "<img src='https://cdn.idle-pixel.com/images/"+monster+"_icon.png' class='w15' />";
        var imgSpell =  "<img src='https://cdn.idle-pixel.com/images/"+spell+"_spell_icon.png' class='w15' />";

        document.getElementById("angel-ball-extra-label").style.display = "";
        document.getElementById("angel-ball-extra-label-value").innerHTML = Items.get_pretty_item_name(monster) + " ("+spell+")";

        var label_id = "";

        label_id = "fields";
        document.getElementById("crystal-ball-icon-" + label_id).style.display = "none";
        document.getElementById("crystal-ball-icon-blood-" + label_id).style.display = "none";
        label_id = "forest";
        document.getElementById("crystal-ball-icon-" + label_id).style.display = "none";
        document.getElementById("crystal-ball-icon-blood-" + label_id).style.display = "none";
        label_id = "caves";
        document.getElementById("crystal-ball-icon-" + label_id).style.display = "none";
        document.getElementById("crystal-ball-icon-blood-" + label_id).style.display = "none";
        label_id = "volcano";
        document.getElementById("crystal-ball-icon-" + label_id).style.display = "none";
        document.getElementById("crystal-ball-icon-blood-" + label_id).style.display = "none";
        label_id = "northfields";
        document.getElementById("crystal-ball-icon-" + label_id).style.display = "none";
        label_id = "mansion";
        document.getElementById("crystal-ball-icon-" + label_id).style.display = "none";
        label_id = "beach";
        document.getElementById("crystal-ball-icon-" + label_id).style.display = "none";
        
        if(Items.getItem("crystal_ball_timer") > 1) {
            return;
        }
        switch(monster) {
            case "chicken":
            case "rat":
            case "spider":
            case "bee":
            case "lizard":
                label_id = "fields"
                document.getElementById("crystal-ball-icon-" + label_id).style.display = "";
                document.getElementById("crystal-ball-icon-"+ label_id + "-label").innerHTML =  imgMonster + "<br />" + imgSpell;
                document.getElementById("crystal-ball-icon-blood-" + label_id).style.display = "";
                document.getElementById("crystal-ball-icon-blood-"+ label_id + "-label").innerHTML =  imgMonster + "<br />" + imgSpell;
            break;

            case "snake":
            case "ants":
            case "wolf":
            case "thief":
            case "forest_ent":
                label_id = "forest"
                document.getElementById("crystal-ball-icon-" + label_id).style.display = "";
                document.getElementById("crystal-ball-icon-"+ label_id + "-label").innerHTML =  imgMonster + "<br />" + imgSpell;
                document.getElementById("crystal-ball-icon-blood-" + label_id).style.display = "";
                document.getElementById("crystal-ball-icon-blood-"+ label_id + "-label").innerHTML =  imgMonster + "<br />" + imgSpell;
            break;
            
            case "bear":
            case "goblin":
            case "bat":
            case "skeleton":
                label_id = "caves"
                document.getElementById("crystal-ball-icon-" + label_id).style.display = "";
                document.getElementById("crystal-ball-icon-"+ label_id + "-label").innerHTML =  imgMonster + "<br />" + imgSpell;
                document.getElementById("crystal-ball-icon-blood-" + label_id).style.display = "";
                document.getElementById("crystal-ball-icon-blood-"+ label_id + "-label").innerHTML =  imgMonster + "<br />" + imgSpell;
            break;

            case "fire_hawk":
            case "fire_snake":
            case "fire_golem":
            case "fire_witch":
                label_id = "volcano"
                document.getElementById("crystal-ball-icon-" + label_id).style.display = "";
                document.getElementById("crystal-ball-icon-"+ label_id + "-label").innerHTML =  imgMonster + "<br />" + imgSpell;
                document.getElementById("crystal-ball-icon-blood-" + label_id).style.display = "";
                document.getElementById("crystal-ball-icon-blood-"+ label_id + "-label").innerHTML =  imgMonster + "<br />" + imgSpell;
            break;

            case "ice_hawk":
            case "ice_golem":
            case "ice_witch":
            case "yeti":
                label_id = "northfields"
                document.getElementById("crystal-ball-icon-" + label_id).style.display = "";
                document.getElementById("crystal-ball-icon-"+ label_id + "-label").innerHTML =  imgMonster + "<br />" + imgSpell;
            break;

            case "ghost":
            case "grandma":
            case "exorcist":
            case "reaper":
                label_id = "mansion"
                document.getElementById("crystal-ball-icon-" + label_id).style.display = "";
                document.getElementById("crystal-ball-icon-"+ label_id + "-label").innerHTML =  imgMonster + "<br />" + imgSpell;
            break;

            case "shark":
            case "sea_soldier":
            case "puffer_fish":
            case "saltwater_crocodile":
                label_id = "beach"
                document.getElementById("crystal-ball-icon-" + label_id).style.display = "";
                document.getElementById("crystal-ball-icon-"+ label_id + "-label").innerHTML =  imgMonster + "<br />" + imgSpell;
            break;
        }
    }


    static cast_raid_spell(element, spell) {
        websocket.send('CAST_RAID_SPELL=' + spell)
    }

    static refresh_magic_crystal_label()
    {
        if(Items.getItem("crystal_ball_timer") == 0 && Items.getItem("crystal_ball") == 1)
        {
            var monster = Items.getItemString("crystal_ball_monster");
            var spell = Items.getItem("crystal_ball_spell");
                    
            document.getElementById('item-box-label-crystal_ball').innerHTML = "<img class='w25' src='https://cdn.idle-pixel.com/images/"+monster+"_icon.png' /> <img class='w25' src='https://cdn.idle-pixel.com/images/"+spell+"_spell_icon.png' />";
        }

        Magic.refreshCrystalAngelBallIcon();
    }
    static cast_spell(element, spell)
    {
        websocket.send("SPELL=" + spell);
    }

    static refreshSpellStatus()
    {
        if(Items.getItem('heal_spellscroll_learnt') == 0)
            return;

        for(var key in Magic.spell_info) {

            var spell_info = Magic.spell_info[key];
            
            var mana_cost = spell_info['mana_cost'];
            var magic_bonus_req = spell_info['magic_bonus'];
            var spell_slug = spell_info['spell_id']
            var current_cooldown = Items.getItem(spell_slug + '_cooldown');

           
            if(mana_cost > Items.getItem('mana'))
            {
                set_innerHTML('fighting-spell-label-' + spell_slug, 'NO MANA')
                Magic._change_color_spell_text('fighting-spell-label-' + spell_slug, 'red');
            }
            else if(current_cooldown > 0)
            {
                set_innerHTML('fighting-spell-label-' + spell_slug, current_cooldown);
                Magic._change_color_spell_text('fighting-spell-label-' + spell_slug, 'yellow');
            }
            else if(magic_bonus_req > Items.getItem('magic_bonus'))
            {
                set_innerHTML('fighting-spell-label-' + spell_slug, 'MAGIC BONUS')
                Magic._change_color_spell_text('fighting-spell-label-' + spell_slug, 'red');
            }
            else
            {
                var shortcut_html = "";
                if(spell_slug == "heal") shortcut_html = " <span class='color-grey'>(Q)</span>";
                if(spell_slug == "fire") shortcut_html = " <span class='color-grey'>(W)</span>";
                if(spell_slug == "reflect") shortcut_html = " <span class='color-grey'>(E)</span>";
                if(spell_slug == "invisibility") shortcut_html = " <span class='color-grey'>(R)</span>";

                Magic._change_color_spell_text('fighting-spell-label-' + spell_slug, 'white');
                set_innerHTML('fighting-spell-label-' + spell_slug, capitalizeFirstLetter(spell_slug) + shortcut_html)
            }

        }
    }

    static _change_color_spell_text(id, color)
    {
        if(document.getElementById(id) != null)
            document.getElementById(id).style.color = color;
    }

    static enchantWaterBucketModal() {

        Modals.open_image_modal('Enchant Water', 'images/magic.png', 'Enchant the water with magic?  This causes the bucket to include infinite water.','Enchant','Cancel','ENCHANT_WATER_BUCKET');
      }


    static refreshSpellMagicBonusStatus()
    {
        if(Items.getItem('heal_spellscroll_learnt') == 0)
            return;

        var magic_bonus = Items.getItem('magic_bonus');

        for(var key in Magic.spell_info) {

            if(key != 'heal') continue;
            
            var spell_info = Magic.spell_info[key];
            if(spell_info['mana_cost'] > player_mana)
            {
                show_element(key + '-nomana-label');
            }
            else
            {
                hide_element(key + '-nomana-label');
            }
        }
    }

    static use_spell_scroll(item)
    {
        var mana_cost = 0;
        var magic_bonus = 0;
        var description = "";
        var cooldown = 0;
        switch(item)
        {
            case "heal_spellscroll":
                mana_cost = Magic.spell_info["heal"]["mana_cost"];
                magic_bonus = Magic.spell_info["heal"]["magic_bonus"];
                description = "Instantly heals you for 1 hp.";
                cooldown = 5;
            break;
            case "fire_spellscroll":
                mana_cost = Magic.spell_info["fire"]["mana_cost"];
                magic_bonus = Magic.spell_info["fire"]["magic_bonus"];
                description = "Deal up to 5 fire damage.";
                cooldown = 10;
            break;
            case "reflect_spellscroll":
                mana_cost = Magic.spell_info["reflect"]["mana_cost"];
                magic_bonus = Magic.spell_info["reflect"]["magic_bonus"];
                description = "Reflect damage back to enemy on next hit.";
                cooldown = 30;
            break;
            case "invisibility_spellscroll":
                mana_cost = Magic.spell_info["invisibility"]["mana_cost"];
                magic_bonus = Magic.spell_info["invisibility"]["magic_bonus"];
                description = "Lets you go invisibile for a couple seconds, avoid all damage.";
                cooldown = 30;
            break;
        }

        if(mana_cost > 0 || magic_bonus > 0 || description != "")
        {
            Modals.open_image_modal('Learn new spell?', 'images/'+item+'.png', '<center><u>Learn New Spell</u><br /><br />'+description+'<br /><br /><span class="color-grey"><img src="https://cdn.idle-pixel.com/images/wooden_staff.png" class="w20" /> <b>Magic Bonus Required: </b>'+magic_bonus+'<br/ ><img src="https://cdn.idle-pixel.com/images/mana.png" class="w20" /> <b>Mana Required: </b>'+mana_cost+'<br /><img src="https://cdn.idle-pixel.com/images/cooldown.png" class="w20" /> <b>Cooldown: </b>'+cooldown+' seconds</span><center>', 'Read Scroll', 'Cancel', 'READ_SPELLSCROLL=' + item)
        }
    }
}