class Market
{

  _slot_selected = 0;

  static tradables = [];
  static clicks_sell_item_button(slot)
  {
      Market._slot_selected = slot;
      websocket.send("MARKET_SELL_BUTTON_CLICKED");
  }

  static clicks_browse_player_market_button()
  {
    Market._slot_selected = 0;
    websocket.send("MARKET_BROWSE_BUTTON_CLICKED");
  }

  static history(values) {
  
    var data_array = values.split("~");

    var html = "<table class='market-history-table' width='100%'>";
    html += "<th>Item</th><th></th><th>Amount</th><th>Price Each</th><th>TRANSACTION</th><th>DATE</th>";
    for(var i = 0; i < data_array.length; i+=0) {
      html += "<tr>";
      var item = data_array[i];
      i++;
      var amount = data_array[i];
      i++;
      var price_each = data_array[i];
      i++;
      var datetime = data_array[i];
      i++;
      var is_bought = data_array[i] == "BOUGHT";
      var buy_label = "PURCHASED";
      if(!is_bought) {
        buy_label = "SOLD";
      }
      i++;

      html += "<td>"+item+"</td>";
      html += "<td>" + "<img src='https://cdn.idle-pixel.com/images/"+item+".png' />" + "</td>";
      html += "<td>"+ format_number(amount) + "</td>";
      html += "<td>" + "<img class='w15' src='https://cdn.idle-pixel.com/images/coins.png' />"  + format_number(price_each) + "</td>";
      html += "<td>" + buy_label + "</td>";
      html += "<td>" + datetime + "</td>";
      
      html += "</tr>";
    }
    html += "</table>";
    document.getElementById("modal-market-history-content").innerHTML = html;
    Modals.toggle('modal-market-history')
  }


  static load_tradables(data)
  {
      var data_array = data.split("~");
      var html = "";
      Market.tradables = [];
      
      for(var i = 0; i < data_array.length; i+=0)
      {
          var item = data_array[i]; i++;
          var lower_limit = data_array[i]; i++;
          var upper_limit = data_array[i]; i++;
          var category = data_array[i]; i++;

          Market.tradables.push(new MarketTradables(item, lower_limit, upper_limit, category));
      }
  }


  static get_category_background_color(category)
  {
    switch(category)
    {
      case "gems":
        return "#b3ffff";
      case "ores":
        return "#DDDDDD";
      case "bars":
        return "#c2c2a3";
      case "bones":
        return "#ffffff";
      case "seeds":
        return "#ccffcc";
      case "logs":
        return "#99ffcc";
      case "brewing":
        return "#ffccff";
      case "weapons":
        return "#ffcccc";
      case "armour":
        return "#ffcccc";
      case "other_equipment":
        return "#ffcccc";
      case "breeding":
          return "#964B00";
      case "raw_fish":
        return "#b3e6ff";
      case "cooked_fish":
        return "#ffb366";
      case "donor":
        return "#ccccff";
      case "sigils":
        return "white";
    }
  }


  static post_item()
  {
    Modals.toggle("modal-market-configure-item-to-sell");
    var slot = Market._slot_selected;
    var item = document.getElementById("modal-market-configure-item-to-sell").value;
    var amount = get_number_with_letters(document.getElementById("modal-market-configure-item-to-sell-amount").value);
    var price_each = get_number_with_letters(document.getElementById("modal-market-configure-item-to-sell-price-each").value);
    websocket.send("MARKET_POST=" + slot + "~" + item + "~" + amount + "~" + price_each);
  }


  static refresh_slots(data)
  {
      var data_array = data.split("~");
      document.getElementById("player-market-slot-empty-1").style.display = "";
      document.getElementById("player-market-slot-empty-2").style.display = "";
      document.getElementById("player-market-slot-empty-3").style.display = "";

      document.getElementById("player-market-slot-occupied-1").style.display = "none";
      document.getElementById("player-market-slot-occupied-2").style.display = "none";
      document.getElementById("player-market-slot-occupied-3").style.display = "none";

      //empty data - all trading slots are unused
      if(data == "")
        return;

      for(var i = 0; i < data_array.length; i+=0)
      {

        var slot = data_array[i]; i++;
        var item = data_array[i]; i++;
        var amount = data_array[i]; i++;
        var price_each = data_array[i]; i++;
        var collect = data_array[i]; i++;
        var category = data_array[i]; i++;
        var timestamp = data_array[i]; i++;

        document.getElementById("player-market-slot-empty-" + slot).style.display = "none";
        var item_label = Items.get_pretty_item_name(item);
        item_label = Items.get_short_version(item_label);

        document.getElementById("player-market-slot-item-item-label-" + slot).innerHTML = item_label;
        document.getElementById("player-market-slot-item-image-" + slot).src = get_image("images/" + item + ".png");
        document.getElementById("player-market-slot-item-amount-left-" + slot).innerHTML = format_number(amount);
        document.getElementById("player-market-slot-item-price-each-" + slot).innerHTML = format_number(price_each);
        document.getElementById("player-market-slot-collect-amount-" + slot).innerHTML = "<img src='https://cdn.idle-pixel.com/images/coins.png' /> Collect: " + format_number(collect);
        document.getElementById("player-market-slot-expires-" + slot).innerHTML = Market._get_expire_time(timestamp);

        document.getElementById("player-market-slot-occupied-" + slot).style.display = "";
      }

  }

  static _get_expire_time(timestamp)
  {
    var expires = 259200000 // 72h
    var expires_in = parseInt((expires + parseInt(timestamp) - get_current_millis()) / 1000 / 60/ 60);

    if(expires_in < 0)
      return "Expired";
    else
      return expires_in + " Hours";
  }

  static purchase_item()
  {
    var market_id = document.getElementById("modal-market-purchase-item-market-id").value;
    var amount = get_number_with_letters(document.getElementById("modal-market-purchase-item-amount-input").value);
    websocket.send("MARKET_PURCHASE=" + market_id + "~" + amount);
  }

  static get_price_after_tax(amount)
  {
    amount = parseInt(amount * 1.01);
    return format_number(amount);
  }
  static browse_get_table(item_name)
  {
    hide_element("market-table");
    show_element("market-loading");
    return $.get("../../market/browse/" + item_name + "/?username=" + Items.getItemString('username'))
      .done(function(data) {
        var json = data
        var html = "";
        html += "<tr><th>ITEM</th><th></th><th>AMOUNT</th><th>PRICE EACH</th><th>CATEGORY</th><th>EXPIRES IN</th><th></th></tr>";

        for(var i = 0; i < json.length; i++)
        {
          var market_id = json[i].market_id;
          var player_id = json[i].player_id;
          var item_name = json[i].market_item_name;
          var amount = json[i].market_item_amount;
          var price_each = json[i].market_item_price_each;
          var category = json[i].market_item_category;
          var timestamp = json[i].market_item_post_timestamp;

          var your_entry = "";
          if(Items.getItem("player_id") == player_id)
            your_entry = "<span class='color-grey font-small'><br /><br />(Your Item)</span>";
  
          html += "<tr onclick='Modals.market_purchase_item(\""+market_id+"\", \""+item_name+"\", \""+amount+"\" ,\""+price_each+"\")' class='hover'>";
          html += "<td>" + Items.get_pretty_item_name(item_name) + your_entry + "</td>";
          html += "<td>" + "<img src='https://cdn.idle-pixel.com/images/"+item_name+".png' />" + "</td>";
          html += "<td>" + format_number(amount) + "</td>";
          html += "<td>" + "<img src='https://cdn.idle-pixel.com/images/coins.png' /> " + Market.get_price_after_tax(price_each) + "</td>";
          html += "<td>" + category + "</td>";
          html += "<td>" + Market._get_expire_time(timestamp); + "</td>";
          html += "<td>" + "<a onclick='event.stopPropagation()' target='_blank' href='https://data.idle-pixel.com/market/?item="+item_name+"&range=7d'><img class='hover' src='https://cdn.idle-pixel.com/images/stocks.png' /></a>" + "</td>";
          html += "</tr>";
        }

        hide_element("market-loading");
        show_element("market-table");
        document.getElementById("market-table").innerHTML = html;
    });
  }
}