class Ores
{
    static MINERALS_XP_MAP = {
        "blue_marble_mineral": 1000,
		"amethyst_mineral":2000,
		"sea_crystal_mineral":5000,

		"dense_marble_mineral":3000,
		"fluorite_mineral":8000,
		"clear_marble_mineral":15000,

		"jade_mineral":5000,
		"lime_quartz_mineral":10000,
		"opal_mineral":20000,

		"purple_quartz_mineral":8000,
		"amber_mineral":16000,
		"smooth_pearl_mineral":30000,

		"sulfer_mineral":10000,
		"topaz_mineral":25000,
		"tanzanite_mineral":100000,

        "magnesium_mineral":25000,
		"frozen_mineral":50000,
		"blood_crystal_mineral":200000,
      }

    static getOilCost(machine)
    {
        var oil_cost = 0;

        switch(machine)
        {
            case "drill":
                oil_cost = 1;
            break;
            case "crusher":
                oil_cost = 3;
                if(Achievements.has_completed_set("mining", "medium")) oil_cost = 2;
            break;
            case "giant_drill":
                oil_cost = 8;
                if(Achievements.has_completed_set("mining", "medium")) oil_cost = 6;
            break;
            case "excavator":
                oil_cost = 15;
                if(Achievements.has_completed_set("mining", "medium")) oil_cost = 10;
            break;
            case "giant_excavator":
                oil_cost = 30;
                if(Achievements.has_completed_set("mining", "medium")) oil_cost = 20;
            break;
            case "massive_excavator":
                oil_cost = 100;
                if(Achievements.has_completed_set("mining", "medium")) oil_cost = 100;
            break;
        }

        return oil_cost;
    }

    static getMachineriesOn(machine)
    {
        return Items.getItem(machine + "_on");
    }

    static clicksOilFactory()
    {
        Modals.open_oil_factory_dialogue();
    }

    static getMachineLevel(machine)
    {
        switch(machine)
        {
            case "massive_excavator":
                return 100;
            case "giant_excavator":
                return 80;
            case "excavator":
                return 60;
            case "giant_drill":
                return 25;
            case "crusher":
                return 10;
            default:
                return 1;
        }
    }

    static getRingsCompletedFromMineral(mineral) {
        if(mineral == "blue_marble_mineral" || mineral == "amethyst_mineral" || mineral == "sea_crystal_mineral") {
            var html = "";

            if(Items.getItem("weak_defence_ring_crafted") > 0) {
                html += "<img src='https://cdn.idle-pixel.com/images/weak_defence_ring.png' class='w15' /> <span class='color-grey'>Defence</span> " + "<img src='https://cdn.idle-pixel.com/images/check.png' class='w15' /><br />";
            }
            else {
                html += "<img src='https://cdn.idle-pixel.com/images/weak_defence_ring.png' class='w15' /> <span class='color-grey'>Defence</span> " + "<img src='https://cdn.idle-pixel.com/images/x.png' class='w15' /><br />";
            }

            if(Items.getItem("weak_damage_ring_crafted") > 0) {
                html += "<img src='https://cdn.idle-pixel.com/images/weak_damage_ring.png' class='w15' /> <span class='color-grey'>Damage</span> " + "<img src='https://cdn.idle-pixel.com/images/check.png' class='w15' /><br />";
            }
            else {
                html += "<img src='https://cdn.idle-pixel.com/images/weak_damage_ring.png' class='w15' /> <span class='color-grey'>Damage</span> " + "<img src='https://cdn.idle-pixel.com/images/x.png' class='w15' /><br />";
            }

            if(Items.getItem("weak_accuracy_ring_crafted") > 0) {
                html += "<img src='https://cdn.idle-pixel.com/images/weak_accuracy_ring.png' class='w15' /> <span class='color-grey'>Accuracy</span> " + "<img src='https://cdn.idle-pixel.com/images/check.png' class='w15' /><br />";
            }
            else {
                html += "<img src='https://cdn.idle-pixel.com/images/weak_accuracy_ring.png' class='w15' /> <span class='color-grey'>Accuracy</span> " + "<img src='https://cdn.idle-pixel.com/images/x.png' class='w15' /><br />";
            }
        }

        if(mineral == "dense_marble_mineral" || mineral == "fluorite_mineral" || mineral == "clear_marble_mineral") {
            var html = "";

            if(Items.getItem("defence_ring_crafted") > 0) {
                html += "<img src='https://cdn.idle-pixel.com/images/defence_ring.png' class='w15' /> <span class='color-grey'>Defence</span> " + "<img src='https://cdn.idle-pixel.com/images/check.png' class='w15' /><br />";
            }
            else {
                html += "<img src='https://cdn.idle-pixel.com/images/defence_ring.png' class='w15' /> <span class='color-grey'>Defence</span> " + "<img src='https://cdn.idle-pixel.com/images/x.png' class='w15' /><br />";
            }

            if(Items.getItem("damage_ring_crafted") > 0) {
                html += "<img src='https://cdn.idle-pixel.com/images/damage_ring.png' class='w15' /> <span class='color-grey'>Damage</span> " + "<img src='https://cdn.idle-pixel.com/images/check.png' class='w15' /><br />";
            }
            else {
                html += "<img src='https://cdn.idle-pixel.com/images/damage_ring.png' class='w15' /> <span class='color-grey'>Damage</span> " + "<img src='https://cdn.idle-pixel.com/images/x.png' class='w15' /><br />";
            }

            if(Items.getItem("accuracy_ring_crafted") > 0) {
                html += "<img src='https://cdn.idle-pixel.com/images/accuracy_ring.png' class='w15' /> <span class='color-grey'>Accuracy</span> " + "<img src='https://cdn.idle-pixel.com/images/check.png' class='w15' /><br />";
            }
            else {
                html += "<img src='https://cdn.idle-pixel.com/images/accuracy_ring.png' class='w15' /> <span class='color-grey'>Accuracy</span> " + "<img src='https://cdn.idle-pixel.com/images/x.png' class='w15' /><br />";
            }
        }

        if(mineral == "jade_mineral" || mineral == "lime_quartz_mineral" || mineral == "opal_mineral") {
            var html = "";

            if(Items.getItem("good_defence_ring_crafted") > 0) {
                html += "<img src='https://cdn.idle-pixel.com/images/good_defence_ring.png' class='w15' /> <span class='color-grey'>Defence</span> " + "<img src='https://cdn.idle-pixel.com/images/check.png' class='w15' /><br />";
            }
            else {
                html += "<img src='https://cdn.idle-pixel.com/images/good_defence_ring.png' class='w15' /> <span class='color-grey'>Defence</span> " + "<img src='https://cdn.idle-pixel.com/images/x.png' class='w15' /><br />";
            }

            if(Items.getItem("good_damage_ring_crafted") > 0) {
                html += "<img src='https://cdn.idle-pixel.com/images/good_damage_ring.png' class='w15' /> <span class='color-grey'>Damage</span> " + "<img src='https://cdn.idle-pixel.com/images/check.png' class='w15' /><br />";
            }
            else {
                html += "<img src='https://cdn.idle-pixel.com/images/good_damage_ring.png' class='w15' /> <span class='color-grey'>Damage</span> " + "<img src='https://cdn.idle-pixel.com/images/x.png' class='w15' /><br />";
            }

            if(Items.getItem("good_accuracy_ring_crafted") > 0) {
                html += "<img src='https://cdn.idle-pixel.com/images/good_accuracy_ring.png' class='w15' /> <span class='color-grey'>Accuracy</span> " + "<img src='https://cdn.idle-pixel.com/images/check.png' class='w15' /><br />";
            }
            else {
                html += "<img src='https://cdn.idle-pixel.com/images/good_accuracy_ring.png' class='w15' /> <span class='color-grey'>Accuracy</span> " + "<img src='https://cdn.idle-pixel.com/images/x.png' class='w15' /><br />";
            }
        }

        if(mineral == "purple_quartz_mineral" || mineral == "amber_mineral" || mineral == "smooth_pearl_mineral") {
            var html = "";

            if(Items.getItem("great_defence_ring_crafted") > 0) {
                html += "<img src='https://cdn.idle-pixel.com/images/great_defence_ring.png' class='w15' /> <span class='color-grey'>Defence</span> " + "<img src='https://cdn.idle-pixel.com/images/check.png' class='w15' /><br />";
            }
            else {
                html += "<img src='https://cdn.idle-pixel.com/images/great_defence_ring.png' class='w15' /> <span class='color-grey'>Defence</span> " + "<img src='https://cdn.idle-pixel.com/images/x.png' class='w15' /><br />";
            }

            if(Items.getItem("great_damage_ring_crafted") > 0) {
                html += "<img src='https://cdn.idle-pixel.com/images/great_damage_ring.png' class='w15' /> <span class='color-grey'>Damage</span> " + "<img src='https://cdn.idle-pixel.com/images/check.png' class='w15' /><br />";
            }
            else {
                html += "<img src='https://cdn.idle-pixel.com/images/great_damage_ring.png' class='w15' /> <span class='color-grey'>Damage</span> " + "<img src='https://cdn.idle-pixel.com/images/x.png' class='w15' /><br />";
            }

            if(Items.getItem("great_accuracy_ring_crafted") > 0) {
                html += "<img src='https://cdn.idle-pixel.com/images/great_accuracy_ring.png' class='w15' /> <span class='color-grey'>Accuracy</span> " + "<img src='https://cdn.idle-pixel.com/images/check.png' class='w15' /><br />";
            }
            else {
                html += "<img src='https://cdn.idle-pixel.com/images/great_accuracy_ring.png' class='w15' /> <span class='color-grey'>Accuracy</span> " + "<img src='https://cdn.idle-pixel.com/images/x.png' class='w15' /><br />";
            }
        }


        if(mineral == "sulfer_mineral" || mineral == "topaz_mineral" || mineral == "tanzanite_mineral") {
            var html = "";

            if(Items.getItem("perfect_defence_ring_crafted") > 0) {
                html += "<img src='https://cdn.idle-pixel.com/images/perfect_defence_ring.png' class='w15' /> <span class='color-grey'>Defence</span> " + "<img src='https://cdn.idle-pixel.com/images/check.png' class='w15' /><br />";
            }
            else {
                html += "<img src='https://cdn.idle-pixel.com/images/perfect_defence_ring.png' class='w15' /> <span class='color-grey'>Defence</span> " + "<img src='https://cdn.idle-pixel.com/images/x.png' class='w15' /><br />";
            }

            if(Items.getItem("perfect_damage_ring_crafted") > 0) {
                html += "<img src='https://cdn.idle-pixel.com/images/perfect_damage_ring.png' class='w15' /> <span class='color-grey'>Damage</span> " + "<img src='https://cdn.idle-pixel.com/images/check.png' class='w15' /><br />";
            }
            else {
                html += "<img src='https://cdn.idle-pixel.com/images/perfect_damage_ring.png' class='w15' /> <span class='color-grey'>Damage</span> " + "<img src='https://cdn.idle-pixel.com/images/x.png' class='w15' /><br />";
            }

            if(Items.getItem("perfect_accuracy_ring_crafted") > 0) {
                html += "<img src='https://cdn.idle-pixel.com/images/perfect_accuracy_ring.png' class='w15' /> <span class='color-grey'>Accuracy</span> " + "<img src='https://cdn.idle-pixel.com/images/check.png' class='w15' /><br />";
            }
            else {
                html += "<img src='https://cdn.idle-pixel.com/images/perfect_accuracy_ring.png' class='w15' /> <span class='color-grey'>Accuracy</span> " + "<img src='https://cdn.idle-pixel.com/images/x.png' class='w15' /><br />";
            }
        }

        if(mineral == "magnesium_mineral" || mineral == "frozen_mineral" || mineral == "blood_crystal_mineral") {
            var html = "";

            if(Items.getItem("ancient_defence_ring_crafted") > 0) {
                html += "<img src='https://cdn.idle-pixel.com/images/ancient_defence_ring.png' class='w15' /> <span class='color-grey'>Defence</span> " + "<img src='https://cdn.idle-pixel.com/images/check.png' class='w15' /><br />";
            }
            else {
                html += "<img src='https://cdn.idle-pixel.com/images/ancient_defence_ring.png' class='w15' /> <span class='color-grey'>Defence</span> " + "<img src='https://cdn.idle-pixel.com/images/x.png' class='w15' /><br />";
            }

            if(Items.getItem("ancient_damage_ring_crafted") > 0) {
                html += "<img src='https://cdn.idle-pixel.com/images/ancient_damage_ring.png' class='w15' /> <span class='color-grey'>Damage</span> " + "<img src='https://cdn.idle-pixel.com/images/check.png' class='w15' /><br />";
            }
            else {
                html += "<img src='https://cdn.idle-pixel.com/images/ancient_damage_ring.png' class='w15' /> <span class='color-grey'>Damage</span> " + "<img src='https://cdn.idle-pixel.com/images/x.png' class='w15' /><br />";
            }

            if(Items.getItem("ancient_accuracy_ring_crafted") > 0) {
                html += "<img src='https://cdn.idle-pixel.com/images/ancient_accuracy_ring.png' class='w15' /> <span class='color-grey'>Accuracy</span> " + "<img src='https://cdn.idle-pixel.com/images/check.png' class='w15' /><br />";
            }
            else {
                html += "<img src='https://cdn.idle-pixel.com/images/ancient_accuracy_ring.png' class='w15' /> <span class='color-grey'>Accuracy</span> " + "<img src='https://cdn.idle-pixel.com/images/x.png' class='w15' /><br />";
            }
        }

        return html;
    }

    static getOres(machine)
    {
        switch(machine)
        {
            case "drill":
                return ["stone","copper","iron","silver"];
            case "crusher":
                return ["stone","copper","iron","silver", "gold"];
            case "giant_drill":
                return ["silver", "gold", "promethium"];
            case "excavator":
                return ["gold", "promethium", "titanium"];
            case "giant_excavator":
                return ["titanium", "ancient_ore"];
            case "massive_excavator":
                return ["ancient_ore", "dragon_ore"];
            default:
                return [];
        }
    }

    // returns ["current", "next_gem or none", "stardust per xp"]
    static getPickaxeToolData()
    {
        if(Items.getItem("diamond_pickaxe"))
            return ["diamond_pickaxe", "none", 9];
        
        if(Items.getItem("ruby_pickaxe"))
            return ["ruby_pickaxe", "diamond", 10];
        
        if(Items.getItem("emerald_pickaxe"))
            return ["emerald_pickaxe", "ruby", 11];
    
        if(Items.getItem("sapphire_pickaxe"))
            return ["sapphire_pickaxe", "emerald", 12];

        if(Items.getItem("pickaxe"))
            return ["pickaxe", "sapphire", 13];

        return ["none", "none", 13];
    }

    static getChiselToolData()
    {
        if(Items.getItem("diamond_chisel"))
            return ["diamond_chisel", "none"];
        
        if(Items.getItem("ruby_chisel"))
            return ["ruby_chisel", "diamond"];
        
        if(Items.getItem("emerald_chisel"))
            return ["emerald_chisel", "ruby"];
    
        if(Items.getItem("sapphire_chisel"))
            return ["sapphire_chisel", "emerald"];

        if(Items.getItem("chisel"))
            return ["chisel", "sapphire"];

        return ["none", "none"];
    }

    static getStardustPerXp()
    {
        var stardust_per_xp = Ores.getPickaxeToolData()[2];
        if(Items.getItem("blue_pickaxe_orb_absorbed") > 0)
            stardust_per_xp -= 2;

    
        if(
            Items.getItem("mining_skilling_gloves") > 0 &&
            Items.getItem("mining_skilling_boots") > 0 &&
            Items.getItem("mining_skilling_shirt") > 0 &&
            Items.getItem("mining_skilling_pants") > 0
        )
        stardust_per_xp -= 1;

        return stardust_per_xp;
    }
}