class Quests
{
    static refreshQuestBoxes()
    {
        var quest_area = document.getElementById("quest-area");
        var quest_buttons = quest_area.getElementsByTagName("div");

        for(var i = 0; i < quest_buttons.length; i++)
        {
            var quest_button = quest_buttons[i];
            if(quest_button.getAttribute("data-previous-quest") == null)
                continue;

            var previous_quest_required = quest_button.getAttribute("data-previous-quest");
            var image = quest_button.getElementsByTagName("img")[0];
            if(Quests.questCompleted(previous_quest_required))
            {
                quest_button.classList.remove("quest-disable");
                quest_button.classList.add("hover");
                image.classList.remove("image-quest-disable");
            }
            else
            {
                quest_button.classList.add("quest-disable");
                quest_button.classList.remove("hover");
                image.classList.add("image-quest-disable");
            }
            
        }
    }

    static questCompleted(name)
    {
        return Items.getItem(name + "_quest") == -1;
    }

    static theMerchanterShowItem(item)
    {
        if(item == "magnet" && Items.getItem("show_the_merchant") == "diamond_magnet")
            {
                Modals.open_image_modal("The Merchant", "images/merchant.png","Pwahaha, you call that a magnet!  it's so weak!  Get lost.", null, "Close", null);
                return true;
            }

        if(Items.getItem("show_the_merchant") == item)
        { 
            websocket.send('SHOW_MERCHANT=' + item);
            return true;
        }

        return false;
    }

   
    static clicksQuest(questBoxElement, questName)
    {

        if(questBoxElement != null)
        if(questBoxElement.getAttribute("data-previous-quest") != null)
        {
            var previous_quest_required = questBoxElement.getAttribute("data-previous-quest");
            if(!Quests.questCompleted(previous_quest_required))
            {
                return;
            }
        }
        var questStep = Items.getItem(questName + "_quest");

        switch(questName)
        {
            case "doric_the_crafter":
                Quests._doricTheCrafter(questName, questStep);
            break;
            case "the_gem_seeker":
                Quests._theGemSeeker(questName, questStep);
            break;
            case "the_achiever":
                Quests._theAchiever(questName, questStep);
            break;
            case "stardust_expert":
                Quests._stardustExpert(questName, questStep);
            break;
            case "combat_tutor":
                Quests._combatTutor(questName, questStep);
            break;
            case "ent_boss":
                Quests._entBoss(questName, questStep);
            break;
            case "faradoxs_introduction":
                Quests._faradoxsIntroduction(questName, questStep);
            break;
            case "fisherman":
                Quests._fisherman(questName, questStep);
            break;
            case "combat_collection_log":
                Quests._combat_collection_log(questName, questStep);
            break;
            case "tank_boss":
                Quests._tankBoss(questName, questStep);
            break;
            case "ghost_miner_boss":
                Quests._ghostMinerBoss(questName, questStep);
            break;
            case "thief_leader":
                Quests._thiefLeader(questName, questStep);
            break;
            case "dad_goblin":
                Quests._dadGoblin(questName, questStep);
            break;
            case "combat_presets":
                Quests._combatPresets(questName, questStep);
            break;
            case "shiny_resources":
                Quests._shinyResources(questName, questStep);
            break;
            case "fire_witch_sister":
                Quests._fireWitchSister(questName, questStep)
            break;
            case "the_carpenter":
                Quests._theCarpenter(questName, questStep)
            break;
            case "the_four_crystals":
                Quests._theFourCrystals(questName, questStep)
            break;
            case "bob_the_farmer":
                Quests._bobTheFarmer(questName, questStep)
            break;
            case "junk_collector":
                Quests._junkCollector(questName, questStep)
            break;
            case "the_merchant":
                Quests._theMerchant(questName, questStep)
            break;
            case "junk_planet":
                Quests._planetJunk(questName, questStep)
            break;
            case "faradox_attempt":
                Quests._faradoxAttempt(questName, questStep)
            break;

            //optional
            case "odd_one_out":
                Quests._oddOneOut(questName, questStep)
            break;
            case "the_four_metals":
                Quests._theFourMetals(questName, questStep)
            break;
            case "pyre_log_priest":
                Quests._pyreLogPriest(questName, questStep)
            break;
            case "teleport_crystal":
                Quests._teleportCrystal(questName, questStep)
            break;
            case "train_combat_network":
                Quests._trainCombatNetwork(questName, questStep)
            break;
            case "let_us_invent_things":
                Quests._letUsInventThings(questName, questStep)
            break;
            case "time_warp_chemist":
                Quests._timeWarpChemist(questName, questStep)
            break;
            case "enchanted_birdbath":
                Quests._birdbathEnchanted(questName, questStep)
            break;
            case "mega_tablette":
                Quests._megaTablette(questName, questStep)
            break;
            case "tcg_card_collection":
                Quests._TCGCardCollection(questName, questStep);
            break;
            case "mega_seeds":
                Quests._megaSeeds(questName, questStep);
            break;
            
        }
    }

    static _doricTheCrafter(questName, questStep)
    {
        if(questStep == 0)
        {
            var requirements = "<strike>Bring me 6 clay, 4 copper and 2 iron ore.</strike><br /><br /><img class='w20' src='https://cdn.idle-pixel.com/images/bronze_bar.png' /> Smelt a bronze bar.";
            Modals.open_image_modal(
                "QUEST", 
                "images/dwarf.png",
                "<h2>Start quest?</h2><br /><div class='quest-requirements'><span class='color-black'><u>Requirements:</u><br /><br />" + requirements + "</span></div>",
                "Start",
                "Cancel",
                "QUEST=" + questName + "~" + 0
            )
        }
        else
        {
            websocket.send("QUEST=" + questName + "~" + 0)
        }
    }

    static _theGemSeeker(questName, questStep)
    {
        if(questStep == 0)
        {
            var requirements = "<img class='w20' src='https://cdn.idle-pixel.com/images/oil.png' /> Collect 25 oil<br /><br /><u>Hint:</u><br /><br />Craft an oil well to gain oil.";
            Modals.open_image_modal(
                "QUEST", 
                "images/miner.png",
                "<h2>Start quest?</h2><br /><div class='quest-requirements'><span class='color-black'><u>Requirements:</u><br /><br />" + requirements + "</span></div>",
                "Start",
                "Cancel",
                "QUEST=" + questName + "~" + 0
            )
        }
        else
        {
            websocket.send("QUEST=" + questName + "~" + 0)
        }
    }

    static _theAchiever(questName, questStep)
    {
        if(questStep == 0)
        {
            var requirements = "<img class='w20' src='https://cdn.idle-pixel.com/images/gathering.png' /> Unlock the garthering skill.<br /><br /><u>Hint:</u><br /><br />You can unlock the gathering skill by crafting leather gloves.  Leather can be purchased in the game shop.";
            Modals.open_image_modal(
                "QUEST", 
                "images/the_achiever.png",
                "<h2>Start quest?</h2><br /><div class='quest-requirements'><span class='color-black'><u>Requirements:</u><br /><br />" + requirements + "</span></div>",
                "Start",
                "Cancel",
                "QUEST=" + questName + "~" + 0
            )
        }
        else
        {
            websocket.send("QUEST=" + questName + "~" + 0)
        }
    }

    

    static _stardustExpert(questName, questStep)
    {
        if(questStep == 0)
        {
            var requirements = "<img class='w20' src='https://cdn.idle-pixel.com/images/dotted_green_leaf.png' /> Harvest dotted green leaf seeds.<br /><br /><u>Hint:</u><br /><br />You can quicky obtain dotted green leaf seeds by opening gathering bags found in the forever fields.";
            Modals.open_image_modal(
                "QUEST", 
                "images/stardust_expert.png",
                "<h2>Start quest?</h2><br /><div class='quest-requirements'><span class='color-black'><u>Requirements:</u><br /><br />" + requirements + "</span></div>",
                "Start",
                "Cancel",
                "QUEST=" + questName + "~" + 0
            )
        }
        else
        {
            websocket.send("QUEST=" + questName + "~" + 0)
        }
    }
    static _combatTutor(questName, questStep)
    {
        if(questStep == 0)
        {
            var requirements = "<img class='w20' src='https://cdn.idle-pixel.com/images/sword_icon.png' /> Attempted to fight with either a sword, bow or staff.";
            Modals.open_image_modal(
                "QUEST", 
                "images/combat_tutor.png",
                "<h2>Start quest?</h2><br /><div class='quest-requirements'><span class='color-black'><u>Requirements:</u><br /><br />" + requirements + "</span></div>",
                "Start",
                "Cancel",
                "QUEST=" + questName + "~" + 0
            )
        }
        else
        {
            websocket.send("QUEST=" + questName + "~" + 0)
        }
    }
    static _entBoss(questName, questStep)
    {
        if(questStep == 0)
        {
            var requirements = "<img class='w20' src='https://cdn.idle-pixel.com/images/chicken_icon.png' /> Kill any enemy in the fields.";
            Modals.open_image_modal(
                "QUEST", 
                "images/monster_ent_black.png",
                "<h2>Start quest?</h2><br /><div class='quest-requirements'><span class='color-black'><u>Requirements:</u><br /><br />" + requirements + "</span></div>",
                "Start",
                "Cancel",
                "QUEST=" + questName + "~" + 0
            )
        }
        else
        {
            websocket.send("QUEST=" + questName + "~" + 0)
        }
    }

    static _faradoxsIntroduction(questName, questStep)
    {
        if(questStep == 0)
        {
            var requirements = "<img class='w20' src='https://cdn.idle-pixel.com/images/melee.png' /> Level 2 in the melee skill.<br /><img class='w20' src='https://cdn.idle-pixel.com/images/archery.png' /> Level 2 in the archery skill.<br /><img class='w20' src='https://cdn.idle-pixel.com/images/wooden_staff.png' /> Bought the wooden staff from the shop.";

            Modals.open_image_modal(
                "QUEST", 
                "images/wizard.png",
                "<h2>Start quest?</h2><br /><div class='quest-requirements'><span class='color-black'><u>Requirements:</u><br /><br />" + requirements + "</span></div>",
                "Start",
                "Cancel",
                "QUEST=" + questName + "~" + 0
            )
        }
        else
        {
            websocket.send("QUEST=" + questName + "~" + 0)
        }
    }
    static _fisherman(questName, questStep)
    {
        if(questStep == 0)
        {
            var requirements = "<img class='w20' src='https://cdn.idle-pixel.com/images/crafting.png' /> Craft a fishing net using string.<br /><img class='w20' src='https://cdn.idle-pixel.com/images/fishing.png' />Attempt to use the fishing net.<br /><br /><u>Hint:</u><br /><br />String used to craft the fishing net can be found from killing spiders in the fields.";
            Modals.open_image_modal(
                "QUEST", 
                "images/fisherman.png",
                "<h2>Start quest?</h2><br /><div class='quest-requirements'><span class='color-black'><u>Requirements:</u><br /><br />" + requirements + "</span></div>",
                "Start",
                "Cancel",
                "QUEST=" + questName + "~" + 0
            )
        }
        else
        {
            websocket.send("QUEST=" + questName + "~" + 0)
        }
    }
    static _combat_collection_log(questName, questStep)
    {
        if(questStep == 0)
        {
            var requirements = "<img class='w20' src='https://cdn.idle-pixel.com/images/wolf_icon.png' /> Kill a wolf found in the forest.<br /><br /><u>Hint:</u><br /><br />A good passive source of energy can be found by gathering in the dirty kitchen.";

            Modals.open_image_modal(
                "QUEST", 
                "images/women_knight.png",
                "<h2>Start quest?</h2><br /><div class='quest-requirements'><span class='color-black'><u>Requirements:</u><br /><br />" + requirements + "</span></div>",
                "Start",
                "Cancel",
                "QUEST=" + questName + "~" + 0
            )
        }
        else
        {
            websocket.send("QUEST=" + questName + "~" + 0)
        }
    }
    static _tankBoss(questName, questStep)
    {
        if(questStep == 0)
        {
            var requirements = "<span class='color-grey'>No requirements</span><br /><br /><u>Hint:</u><br /><br />This boss has a very high defence.  Poison is required to kill it.  Poison can be found as a drop from the snake in the forest.";
            Modals.open_image_modal(
                "QUEST", 
                "images/monster_tank_black.png",
                "<h2>Start quest?</h2><br /><div class='quest-requirements'><span class='color-black'><u>Requirements:</u><br /><br />" + requirements + "</span></div>",
                "Start",
                "Cancel",
                "QUEST=" + questName + "~" + 0
            )
        }
        else
        {
            websocket.send("QUEST=" + questName + "~" + 0)
        }
    }
    static _ghostMinerBoss(questName, questStep)
    {
        if(questStep == 0)
        {
            var requirements = "<img class='w20' src='https://cdn.idle-pixel.com/images/ghost_icon.png' /> Kill a ghost in the haunted mansion.<br /><img class='w20' src='https://cdn.idle-pixel.com/images/grandma_icon.png' /> Kill a grandma in the haunted mansion.<br /><img class='w20' src='https://cdn.idle-pixel.com/images/exorcist_icon.png' /> Kill exorcist in the haunted mansion.<br /><img class='w20' src='https://cdn.idle-pixel.com/images/reaper_icon.png' /> Kill a reaper in the haunted mansion.";
            Modals.open_image_modal(
                "QUEST", 
                "images/ghost_miner.png",
                "<h2>Start quest?</h2><br /><div class='quest-requirements'><span class='color-black'><u>Requirements:</u><br /><br />" + requirements + "</span></div>",
                "Start",
                "Cancel",
                "QUEST=" + questName + "~" + 0
            )
        }
        else
        {
            websocket.send("QUEST=" + questName + "~" + 0)
        }
    }
    static _thiefLeader(questName, questStep)
    {
        if(questStep == 0)
        {
            var requirements = "<img class='w20' src='https://cdn.idle-pixel.com/images/thief_icon.png' /> Killed at least "+Items.getItem("thief_kills")+"/3 thieves in the forest.";
            Modals.open_image_modal(
                "QUEST", 
                "images/thief_leader.png",
                "<h2>Start quest?</h2><br /><div class='quest-requirements'><span class='color-black'><u>Requirements:</u><br /><br />" + requirements + "</span></div>",
                "Start",
                "Cancel",
                "QUEST=" + questName + "~" + 0
            )
        }
        else
        {
            websocket.send("QUEST=" + questName + "~" + 0)
        }
    }

    static _dadGoblin(questName, questStep)
    {
        if(questStep == 0)
        {
            var requirements = "<span class='color-grey'>No requirements</span>";
            Modals.open_image_modal(
                "QUEST", 
                "images/dad_goblin.png",
                "<h2>Start quest?</h2><br /><div class='quest-requirements'><span class='color-black'><u>Requirements:</u><br /><br />" + requirements + "</span></div>",
                "Start",
                "Cancel",
                "QUEST=" + questName + "~" + 0
            )
        }
        else
        {
            websocket.send("QUEST=" + questName + "~" + 0)
        }
    }


    static _combatPresets(questName, questStep)
    {
        if(questStep == 0)
        {
            var requirements = "<img class='w20' src='https://cdn.idle-pixel.com/images/fire_spell_icon.png' /> Unlock the fire spell and use it "+Items.getItem("fire_casted")+"/5 times in combat.";
            Modals.open_image_modal(
                "QUEST", 
                "images/wizard.png",
                "<h2>Start quest?</h2><br /><div class='quest-requirements'><span class='color-black'><u>Requirements:</u><br /><br />" + requirements + "</span></div>",
                "Start",
                "Cancel",
                "QUEST=" + questName + "~" + 0
            )
        }
        else
        {
            websocket.send("QUEST=" + questName + "~" + 0)
        }
    }

    static _shinyResources(questName, questStep)
    {
        if(questStep == 0)
        {
            var requirements = "<img class='w20' src='https://cdn.idle-pixel.com/images/bomb.png' /> Set off the bomb from the fire golem in the volcano using your fire spell.";
            Modals.open_image_modal(
                "QUEST", 
                "images/dwarf.png",
                "<h2>Start quest?</h2><br /><div class='quest-requirements'><span class='color-black'><u>Requirements:</u><br /><br />" + requirements + "</span></div>",
                "Start",
                "Cancel",
                "QUEST=" + questName + "~" + 0
            )
        }
        else
        {
            websocket.send("QUEST=" + questName + "~" + 0)
        }
    }

    static _fireWitchSister(questName, questStep)
    {
        if(questStep == 0)
        {
            var requirements = "<img class='w20' src='https://cdn.idle-pixel.com/images/fire_witch_icon.png' /> Die to the firewitch while she has one hp left.";
            Modals.open_image_modal(
                "QUEST", 
                "images/sad_witch.png",
                "<h2>Start quest?</h2><br /><div class='quest-requirements'><span class='color-black'><u>Requirements:</u><br /><br />" + requirements + "</span></div>",
                "Start",
                "Cancel",
                "QUEST=" + questName + "~" + 0
            )
        }
        else
        {
            websocket.send("QUEST=" + questName + "~" + 0)
        }
    }

    static _theCarpenter(questName, questStep)
    {
        if(questStep == 0)
        {
            var requirements = "<img class='w20' src='https://cdn.idle-pixel.com/images/snowflake_sigil.png' /> Kill any monster in the northern fields.";
            Modals.open_image_modal(
                "QUEST", 
                "images/carpenter.png",
                "<h2>Start quest?</h2><br /><div class='quest-requirements'><span class='color-black'><u>Requirements:</u><br /><br />" + requirements + "</span></div>",
                "Start",
                "Cancel",
                "QUEST=" + questName + "~" + 0
            )
        }
        else
        {
            websocket.send("QUEST=" + questName + "~" + 0)
        }
    }

    static _theFourCrystals(questName, questStep)
    {
        if(questStep == 0)
        {
            var requirements = "<img class='w20' src='https://cdn.idle-pixel.com/images/ice_crystal.png' /> Have found and touched all crystals.";
            Modals.open_image_modal(
                "QUEST", 
                "images/wizard.png",
                "<h2>Start quest?</h2><br /><div class='quest-requirements'><span class='color-black'><u>Requirements:</u><br /><br />" + requirements + "</span></div>",
                "Start",
                "Cancel",
                "QUEST=" + questName + "~" + 0
            )
        }
        else
        {
            websocket.send("QUEST=" + questName + "~" + 0)
        }
    }

    static _bobTheFarmer(questName, questStep)
    {
        if(questStep == 0)
        {
            var requirements = "<img class='w20' src='https://cdn.idle-pixel.com/images/crystal_leaf.png' /> Planted crystal leaf seeds.";
            Modals.open_image_modal(
                "QUEST", 
                "images/bob.png",
                "<h2>Start quest?</h2><br /><div class='quest-requirements'><span class='color-black'><u>Requirements:</u><br /><br />" + requirements + "</span></div>",
                "Start",
                "Cancel",
                "QUEST=" + questName + "~" + 0
            )
        }
        else
        {
            websocket.send("QUEST=" + questName + "~" + 0)
        }
    }

    static _theFourMetals(questName, questStep)
    {
        if(questStep == 0)
        {
            var requirements = "<img class='w20' src='https://cdn.idle-pixel.com/images/crafting.png' /> Level 20 crafting.<br /><img class='w20' src='https://cdn.idle-pixel.com/images/copper.png' /> Mined some copper ore.<br /><img class='w20' src='https://cdn.idle-pixel.com/images/iron.png' /> Mined some iron ore.<br /><img class='w20' src='https://cdn.idle-pixel.com/images/silver.png' /> Mined some silver ore.<br /><img class='w20' src='https://cdn.idle-pixel.com/images/gold.png' /> Mined some gold ore.";
            Modals.open_image_modal(
                "QUEST", 
                "images/four_metal_bars.png",
                "<h2>Start quest?</h2><br /><div class='quest-requirements'><span class='color-black'><u>Requirements:</u><br /><br />" + requirements + "</span></div>",
                "Start",
                "Cancel",
                "QUEST=" + questName + "~" + 0
            )
        }
        else
        {
            websocket.send("QUEST=" + questName + "~" + 0)
        }
    }
    
    static _oddOneOut(questName, questStep) 
    {
        if(questStep == 0)
        {
            var requirements = "<span class='color-grey'>No requirements</span>";
            Modals.open_image_modal(
                "QUEST", 
                "images/odd_one_out.png",
                "<h2>Start quest?</h2><br /><div class='quest-requirements'><span class='color-black'><u>Requirements:</u><br /><br />" + requirements + "</span></div>",
                "Start",
                "Cancel",
                "QUEST=" + questName + "~" + 0
            )
        }
        else
        {
            websocket.send("QUEST=" + questName + "~" + 0)
        }
    }

    static _birdbathEnchanted(questName, questStep)
    {
        if(questStep == 0)
        {
            var requirements = "<img class='w20' src='https://cdn.idle-pixel.com/images/birdhouse.png' /> Level 5 birdhouse<br /><img class='w20' src='https://cdn.idle-pixel.com/images/bird_bath_filled.png' /> Water-filled bird bath<br /><img class='w20' src='https://cdn.idle-pixel.com/images/magic.png' /> Level 60 Magic<br /><img class='w20' src='https://cdn.idle-pixel.com/images/promethium_oven.png' /> Promethium oven or better";
            Modals.open_image_modal(
                "QUEST", 
                "images/bird_bath_enchanted.png",
                "<h2>Start quest?</h2><br /><div class='quest-requirements'><span class='color-black'><u>Requirements:</u><br /><br />" + requirements + "</span></div>",
                "Start",
                "Cancel",
                "QUEST=" + questName + "~" + 0
            )
        }
        else
        {
            websocket.send("QUEST=" + questName + "~" + 0)
        }
    }

    static _megaTablette(questName, questStep)
    {
        if(questStep == 0)
        {
            var requirements = "<img class='w20' src='https://cdn.idle-pixel.com/images/invention.png' /> Level 80 invention.";
            Modals.open_image_modal(
                "QUEST", 
                "images/mega_tablette.png",
                "<h2>Start quest?</h2><br /><div class='quest-requirements'><span class='color-black'><u>Requirements:</u><br /><br />" + requirements + "</span></div>",
                "Start",
                "Cancel",
                "QUEST=" + questName + "~" + 0
            )
        }
        else
        {
            websocket.send("QUEST=" + questName + "~" + 0)
        }
    }

    static _TCGCardCollection(questName, questStep) 
    {
        if(questStep == 0)
        {
            var requirements = "<img class='w20' src='https://cdn.idle-pixel.com/images/criptoe_coin.png' /> Have 100,000 criptoe coins.";
            Modals.open_image_modal(
                "QUEST", 
                "images/tcg_back_100.png",
                "<h2>Start quest?</h2><br /><div class='quest-requirements'><span class='color-black'><u>Requirements:</u><br /><br />" + requirements + "</span></div>",
                "Start",
                "Cancel",
                "QUEST=" + questName + "~" + 0
            )
        }
        else
        {
            websocket.send("QUEST=" + questName + "~" + 0)
        }
    }

    static _megaSeeds(questName, questStep) 
    {
        if(questStep == 0)
        {
            var requirements = "<img class='w20' src='https://cdn.idle-pixel.com/images/bob.png' /> Completed the quest: Bob The Farmer.<br />";
            requirements += "<img class='w20' src='https://cdn.idle-pixel.com/images/farming_sigil.png' /> Plant a total of 3000 seeds.<br />";
            Modals.open_image_modal(
                "QUEST", 
                "images/mega_magic_beans_seeds.png",
                "<h2>Start quest?</h2><br /><div class='quest-requirements'><span class='color-black'><u>Requirements:</u><br /><br />" + requirements + "</span></div>",
                "Start",
                "Cancel",
                "QUEST=" + questName + "~" + 0
            )
        }
        else
        {
            websocket.send("QUEST=" + questName + "~" + 0)
        }
    }

    
    static _pyreLogPriest(questName, questStep)
    {
        if(questStep == 0)
        {
            var requirements = "<img class='w20' src='https://cdn.idle-pixel.com/images/skull.png' /> Looted a skull from fighting the skeleton in the caves area.";
            Modals.open_image_modal(
                "QUEST", 
                "images/pyre_log_priest.png",
                "<h2>Start quest?</h2><br /><div class='quest-requirements'><span class='color-black'><u>Requirements:</u><br /><br />" + requirements + "</span></div>",
                "Start",
                "Cancel",
                "QUEST=" + questName + "~" + 0
            )
        }
        else
        {
            websocket.send("QUEST=" + questName + "~" + 0)
        }
    }

    static _teleportCrystal(questName, questStep)
    {
        if(questStep == 0)
        {
            var requirements = "<img class='w20' src='https://cdn.idle-pixel.com/images/combat_equipment.png' /> Defeated any enemy in the caves.<br /><img class='w20' src='https://cdn.idle-pixel.com/images/blue_marble_mineral.png' /> Have blue marble on you - obtained from grey geodes.";
            Modals.open_image_modal(
                "QUEST", 
                "images/teleport_crystal.png",
                "<h2>Start quest?</h2><br /><div class='quest-requirements'><span class='color-black'><u>Requirements:</u><br /><br />" + requirements + "</span></div>",
                "Start",
                "Cancel",
                "QUEST=" + questName + "~" + 0
            )
        }
        else
        {
            websocket.send("QUEST=" + questName + "~" + 0)
        }
    }

    static _trainCombatNetwork(questName, questStep)
    {
        if(questStep == 0)
        {
            var requirements = "<img class='w20' src='https://cdn.idle-pixel.com/images/train_cart_completed.png' /> Loot train pieces from all cave monsters.<br /><img class='w20' src='https://cdn.idle-pixel.com/images/crafting.png' /> Craft a train cart with pieces mentioned.<br />";
            Modals.open_image_modal(
                "QUEST", 
                "images/train_conductor_quest.png",
                "<h2>Start quest?</h2><br /><div class='quest-requirements'><span class='color-black'><u>Requirements:</u><br /><br />" + requirements + "</span></div>",
                "Start",
                "Cancel",
                "QUEST=" + questName + "~" + 0
            )
        }
        else
        {
            websocket.send("QUEST=" + questName + "~" + 0)
        }
    }

    static _letUsInventThings(questName, questStep) 
    {
        if(questStep == 0)
        {
            var requirements = "<img class='w20' src='https://cdn.idle-pixel.com/images/mining.png' /> Level 60 mining.";
            requirements += "<br />";
            requirements += "<img class='w20' src='https://cdn.idle-pixel.com/images/crafting.png' /> Level 60 crafting.";
            requirements += "<br />";
            requirements += "<img class='w20' src='https://cdn.idle-pixel.com/images/gathering.png' /> Level 60 gathering.";
            requirements += "<br />";
            requirements += "<img class='w20' src='https://cdn.idle-pixel.com/images/farming.png' /> Level 60 farming.";
            requirements += "<br />";
            requirements += "<img class='w20' src='https://cdn.idle-pixel.com/images/brewing.png' /> Level 60 brewing.";
            requirements += "<br />";
            requirements += "<img class='w20' src='https://cdn.idle-pixel.com/images/woodcutting.png' /> Level 60 woodcutting.";
            requirements += "<br />";
            requirements += "<img class='w20' src='https://cdn.idle-pixel.com/images/cooking.png' /> Level 60 cooking.";
            requirements += "<br />";
            requirements += "<img class='w20' src='https://cdn.idle-pixel.com/images/fishing.png' /> Level 60 fishing.";
            requirements += "<br />";
            requirements += "<img class='w20' src='https://cdn.idle-pixel.com/images/blood_moon_icon.png' /> Blood moon unlocked.";
            Modals.open_image_modal(
                "QUEST", 
                "images/invention_sigil.png",
                "<h2>Start quest?</h2><br /><div class='quest-requirements'><span class='color-black'><u>Requirements:</u><br /><br />" + requirements + "</span></div>",
                "Start",
                "Cancel",
                "QUEST=" + questName + "~" + 0
            )
        }
        else
        {
            websocket.send("QUEST=" + questName + "~" + 0)
        }
    }

    static _timeWarpChemist(questName, questStep)
    {
        if(questStep == 0)
        {
            var requirements = "<img class='w20' src='https://cdn.idle-pixel.com/images/brewing.png' /> Level 50 brewing.";
            Modals.open_image_modal(
                "QUEST", 
                "images/speed_chemist.png",
                "<h2>Start quest?</h2><br /><div class='quest-requirements'><span class='color-black'><u>Requirements:</u><br /><br />" + requirements + "</span></div>",
                "Start",
                "Cancel",
                "QUEST=" + questName + "~" + 0
            )
        }
        else
        {
            websocket.send("QUEST=" + questName + "~" + 0)
        }
    }

    
    static _junkCollector(questName, questStep)
    {
        if(questStep == 0)
        {
            
            var requirements = "<img class='w20' src='https://cdn.idle-pixel.com/images/invention.png' /> Level 50 invention<br /><img class='w20' src='https://cdn.idle-pixel.com/images/emerald_magnet.png' /> Own a magnet that has been upgraded to at least an emerald.";
            Modals.open_image_modal(
                "QUEST", 
                "images/junk_collector.png",
                "<h2>Start quest?</h2><br /><div class='quest-requirements'><span class='color-black'><u>Requirements:</u><br /><br />" + requirements + "</span></div>",
                "Start",
                "Cancel",
                "QUEST=" + questName + "~" + 0
            )
        }
        else
        {
            websocket.send("QUEST=" + questName + "~" + 0)
        }
    }

    static _theMerchant(questName, questStep)
    {
        if(questStep == 0)
        {
            var requirements = "<img class='w20' src='https://cdn.idle-pixel.com/images/saltwater_crocodile_icon.png' /> Killed a crocodile from the beach.";
            Modals.open_image_modal(
                "QUEST", 
                "images/merchant.png",
                "<h2>Start quest?</h2><br /><div class='quest-requirements'><span class='color-black'><u>Requirements:</u><br /><br />" + requirements + "</span></div>",
                "Start",
                "Cancel",
                "QUEST=" + questName + "~" + 0
            )
        }
        else
        {
            websocket.send("QUEST=" + questName + "~" + 0)
        }
    }

    static _planetJunk(questName, questStep)
    {
        if(questStep == 0)
        {
            var requirements = "<img class='w20' src='https://cdn.idle-pixel.com/images/robot_medium.png' /> Defeated the medium robot waves.";
            Modals.open_image_modal(
                "QUEST", 
                "images/junk_planet.png",
                "<h2>Start quest?</h2><br /><div class='quest-requirements'><span class='color-black'><u>Requirements:</u><br /><br />" + requirements + "</span></div>",
                "Start",
                "Cancel",
                "QUEST=" + questName + "~" + 0
            )
        }
        else
        {
            websocket.send("QUEST=" + questName + "~" + 0)
        }
    }

    static _faradoxAttempt(questName, questStep)
    {
        if(questStep == 0)
        {
            var requirements = "<img class='w20' src='https://cdn.idle-pixel.com/images/skull_sigil.png' /> Died to faradox on castle floor 3.";
            Modals.open_image_modal(
                "QUEST", 
                "images/faradox.png",
                "<h2>Start quest?</h2><br /><div class='quest-requirements'><span class='color-black'><u>Requirements:</u><br /><br />" + requirements + "</span></div>",
                "Start",
                "Cancel",
                "QUEST=" + questName + "~" + 0
            )
        }
        else
        {
            websocket.send("QUEST=" + questName + "~" + 0)
        }
    }

    static getQuestNameFromVar(value)
    {
        var elements = value.split("_");
        elements.pop();
        var quest_name = elements.join(" ");
        quest_name = quest_name.charAt(0).toUpperCase() + quest_name.slice(1);
        return quest_name;
    }

    static getQuestsDataLabel() {
        var result = this.getQuestsData();

        var totalCompleted = result[0];
        var total = result[1];

        if(totalCompleted == total) {
            return "<span class='color-green'>"+totalCompleted+"/"+total+"</span>";
        } 
        else if(totalCompleted == 0) {
            return "<span class='color-red'>"+totalCompleted+"/"+total+"</span>";
        }
        else {
            return "<span class='color-yellow'>"+totalCompleted+"/"+total+"</span>";
        }
    }
    // returns [completed, total]
    static getQuestsData() {
        var quests = [
            "doric_the_crafter",
            "the_gem_seeker",
            "the_achiever",
            "stardust_expert",
            "combat_tutor",
            "ent_boss",
            "faradoxs_introduction",
            "fisherman",
            "combat_collection_log",
            "tank_boss",
            "thief_leader",
            "dad_goblin",
            "combat_presets",
            "shiny_resources",
            "fire_witch_sister",
            "the_carpenter",
            "the_four_crystals",
            "ghost_miner_boss",
            "bob_the_farmer",
            "junk_collector",
            "the_merchant",
            "junk_planet",
            "faradox_attempt",
        ];

        var totalCompleted = 0;
        for(var i = 0; i < quests.length; i++) {
            if(Items.getItem(quests[i] + "_quest") == -1)
                totalCompleted++;
        }

        return [totalCompleted, quests.length];
    }


    static getOptionalQuestsDataLabel() {
        var result = this.getOptionalQuestsData();

        var totalCompleted = result[0];
        var total = result[1];

        if(Items.getItem("optional_quests_unlocked") == 0) {
            return "<img src='https://cdn.idle-pixel.com/images/lock.png' class='w15' /><span class='color-red'>LOCKED</span>";
        }
        
        if(totalCompleted == total) {
            return "<span class='color-green'>"+totalCompleted+"/"+total+"</span>";
        } 
        else if(totalCompleted == 0) {
            return "<span class='color-red'>"+totalCompleted+"/"+total+"</span>";
        }
        else {
            return "<span class='color-yellow'>"+totalCompleted+"/"+total+"</span>";
        }
    }

    // returns [completed, total]
    static getOptionalQuestsData() {
        var quests = [
            "odd_one_out",
            "the_four_metals",
            "pyre_log_priest",
            "time_warp_chemist",
            "teleport_crystal",
            "enchanted_birdbath",
            "mega_tablette",
            "train_combat_network",
            "let_us_invent_things",
            "tcg_card_collection",
            "mega_seeds",
        ];

        var totalCompleted = 0;
        for(var i = 0; i < quests.length; i++) {
            if(Items.getItem(quests[i] + "_quest") == -1)
                totalCompleted++;
        }

        return [totalCompleted, quests.length];
    }

     // returns [completed, total, label]
     static getMiniQuestsData() {
        var quests = [
            "mini_quest_breeding_shop",
            "mini_quest_chop_ent",
            "mini_quest_green_leaf_buddy",
        ];

        var totalCompleted = 0;
        for(var i = 0; i < quests.length; i++) {
            if(Items.getItem(quests[i]) == 2)
                totalCompleted++;
        }

        var lbl = "";
        if(totalCompleted == quests.length) {
            lbl = "<span class='color-green'>"+totalCompleted+"/"+quests.length+"</span>"
        } else if(totalCompleted == 0) {
            lbl = "<span class='color-red'>"+totalCompleted+"/"+quests.length+"</span>"
        } else {
            lbl = "<span class='color-yellow'>"+totalCompleted+"/"+quests.length+"</span>"
        }

        
        return [totalCompleted, quests.length, lbl];
    }

    static clicksTutorialToolkit() {
        if(Items.getItem("let_us_invent_things_quest") == 4) {
            websocket.send('QUEST=let_us_invent_things~1');
        } else {
           
        }
    }

    // [desc, reward, img]
    static getMiniQuestDescription(miniquest_var) {
        switch(miniquest_var) {
            case "mini_quest_green_leaf_buddy":
                return [
                    "Apparently, there is a green leaf that can come to life!  It can take a while to find the correct seed though.  I should plant as many as green leaf seeds as possible.",
                    "Ability to harvest all crops in one click.",
                    "images/green_leaf_buddy.png",
                ]
            case "mini_quest_chop_ent":
                return [
                    "Did you know you can actually equip your diamond axe?  Try it!  Click it from the woodcutting inventory!  I wonder what I could chop fighting in the forest?",
                    "Ability to chop all trees in one click.",
                    "images/diamond_axe.png",
                ]
            case "mini_quest_breeding_shop":
                return [
                    "Obtain a toy heart which can be found raiding the toybox in normal mode.",
                    "Ability to select a gender when buying an animal.",
                    "images/toy_heart.png",
                ]
            default:
                return [
                    "undef",
                    "undef",
                    "undef",
                ]
        }
    }
    static displayMiniQuestButtons(miniquest_var) {
        var ele = document.getElementById(miniquest_var);
        if(Items.getItem(miniquest_var) == 2){
            ele.style.display = "none";
            return;
        }

        var descArray = Quests.getMiniQuestDescription(miniquest_var);
        if(Items.getItem(miniquest_var) > 0) {
            var html = "";
            html += descArray[0];
            html += "<br />";
            html += "<b class='font-small' style='color:silver;'>Reward: " + descArray[1]; + "</b>"
            document.getElementById(miniquest_var + '_task').innerHTML = html;
            document.getElementById(miniquest_var + "_img").src = "https://cdn.idle-pixel.com/" + descArray[2];
        }

        switch(miniquest_var) {
            case "mini_quest_breeding_shop":
            {
                if(get_level(Items.getItem("breeding_xp")) >= 5) {
                    ele.style.display = "";
                }
            }  
            break;
            case "mini_quest_chop_ent":
            {
                if(get_level(Items.getItem("diamond_axe")) >= 1) {
                    ele.style.display = "";
                }
            }
            case "mini_quest_green_leaf_buddy":
            {
                if(Items.getItem("green_leaf_seeds_planted") >= 50) {
                    ele.style.display = "";
                }
            }  
            break;
        }
    }

    static refreshMiniQuestCheckbox() {
        var eles = document.querySelectorAll('[data-miniquest-var-img]');
        for(var i = 0; i < eles.length; i++) {
            var ele = eles[i];
            var miniQuestVar = ele.getAttribute('data-miniquest-var-img');
            if(Items.getItem(miniQuestVar) == 2) {
                ele.src = "https://cdn.idle-pixel.com/images/check.png";
            }
        }
    }



    static clicksEvilBlood() {
        if(Items.getItem("let_us_invent_things_quest") == 10) {
            websocket.send('QUEST=let_us_invent_things~1');
        }
    }

    static clicksBloodLimb() {
        if(Items.getItem("let_us_invent_things_quest") == 8 || Items.getItem("let_us_invent_things_quest") == 9) {
            websocket.send('QUEST=let_us_invent_things~1');
        }
    }

    static clicksBloodLab() {
        if(Items.getItem("lab_tablette_1") > 0) {
            document.getElementById("modal-clicks-blood-lab-tablette-1-check").src = "https://cdn.idle-pixel.com/images/check.png";
        }
        if(Items.getItem("lab_tablette_2") > 0) {
            document.getElementById("modal-clicks-blood-lab-tablette-2-check").src = "https://cdn.idle-pixel.com/images/check.png";
        }
        if(Items.getItem("lab_tablette_3") > 0) {
            document.getElementById("modal-clicks-blood-lab-tablette-3-check").src = "https://cdn.idle-pixel.com/images/check.png";
        }
        Modals.toggle('modal-clicks-blood-lab');
    }

    static clicksUnchargedLabTablette() {
        if(Items.getItem("let_us_invent_things_quest") == 7 || Items.getItem("let_us_invent_things_quest") == 8 || Items.getItem("let_us_invent_things_quest") == 11) {
            websocket.send('QUEST=let_us_invent_things~1');
        }
    }
    
    static clicksChargedLabTablette() {
        if(Items.getItem("let_us_invent_things_quest") == 12) {
            websocket.send('QUEST=let_us_invent_things~1');
        }
        
    }

    static clicksRapierMaterials() {
        if(Items.getItem("let_us_invent_things_quest") == 13) {
            websocket.send('QUEST=let_us_invent_things~1');
        }
        
    }

    static changeQuestTabs(value) {

        document.getElementById('story-quest-tab').style.display = "none";
        document.getElementById('optional-quest-tab').style.display = "none";
        document.getElementById('mini-quest-tab').style.display = "none";
        document.getElementById('story-quest-tab-button').style.backgroundColor = "";
        document.getElementById('optional-quest-tab-button').style.backgroundColor = "";
        document.getElementById('mini-quest-tab-button').style.backgroundColor = "";

        if(value == 'story') {
            document.getElementById('story-quest-tab').style.display = "";
            document.getElementById('story-quest-tab-button').style.backgroundColor = "#f77a81";
        } else if(value == 'optional'){
            document.getElementById("side-quest-arrow-img").style.display = "none";
            if(Items.getItem('optional_quests_unlocked') == 0) {
                document.getElementById('story-quest-tab').style.display = "";
                document.getElementById('story-quest-tab-button').style.backgroundColor = "#f77a81";
                Modals.open_image_modal('SIDE QUESTS', 'images/lock.png', 'Unlock side quests?  You need to complete at least 4 of the main story quests to unlock this.','Unlock Optional Quests!','Cancel','UNLOCK_OPTIONAL_QUESTS');
                return;
            }
            document.getElementById('optional-quest-tab').style.display = "";
            document.getElementById('optional-quest-tab-button').style.backgroundColor = "#f77a81";
        }  else if(value == 'mini'){
            document.getElementById('mini-quest-tab').style.display = "";
            document.getElementById('mini-quest-tab-button').style.backgroundColor = "#f77a81";
        }
    }
}