class RaidsToyCute {

  static canvas_tick = 0;
  static idle_animation_index = 0;
  static idle_animation = ['images/toy_cute_monster_idle_0.png', 'images/toy_cute_monster_idle_1.png']

  static every60Tick(cls) {
    cls.idle_animation_index++;
    if(cls.idle_animation_index > 1)
    cls.idle_animation_index = 0;
  }

  static draw(ctx) {
    var cls = RaidsToyCute
    cls.canvas_tick++;
    if(cls.canvas_tick % 60 == 0) cls.every60Tick(cls);

    ctx.drawImage(
      Cache.getImage(
        cls.idle_animation[cls.idle_animation_index],
        cls.idle_animation[cls.idle_animation_index],
      ), 
      390,
      330,
    );

    


    drawAll(ctx)
    
  }
}

class RaidsToySlinky {
  static canvas_tick = 0;
  static idle_animation_index = 0;
  static idle_animation = ['images/toy_slinky_monster_idle_0.png', 'images/toy_slinky_monster_idle_1.png']

  static every60Tick(cls) {
    cls.idle_animation_index++;
    if(cls.idle_animation_index > 1)
    cls.idle_animation_index = 0;
  }

  static draw(ctx) {
    var cls = RaidsToySlinky
    cls.canvas_tick++;
    if(cls.canvas_tick % 30 == 0) cls.every60Tick(cls);

    ctx.drawImage(
      Cache.getImage(
        cls.idle_animation[cls.idle_animation_index],
        cls.idle_animation[cls.idle_animation_index],
      ), 
      390,
      330,
    );

    
    drawAll(ctx)
    
  }
}


class RaidsToyTeddy {

  static canvas_tick = 0;
  static status = 0;

  static reset() {
    RaidsToyTeddy.status = 0;
  }
  static draw(ctx) {
    var cls = RaidsToyTeddy
    cls.canvas_tick++;

    if(cls.status == 0) {
      ctx.drawImage(
        Cache.getImage(
          "images/toy_teddy_monster_happy_0.png",
          "images/toy_teddy_monster_happy_0.png",
        ), 
        390,
        50,
      );
    } else if(cls.status == 1) {
      ctx.drawImage(
        Cache.getImage(
          "images/toy_teddy_monster_idle_0.png",
          "images/toy_teddy_monster_idle_0.png",
        ), 
        390,
        50,
      );
    } else if(cls.status == 2) {
      ctx.drawImage(
        Cache.getImage(
          "images/toy_teddy_monster_mad_0.png",
          "images/toy_teddy_monster_mad_0.png",
        ), 
        390,
        50,
      );
    } 
    

    
    drawAll(ctx)
    
  }
}

class RaidsToyDwarf {

  static canvas_tick = 0;
  static status = 0;
  static boss_timer = 10;
  static idle_animation_index = 0;
  static idle_animation = ['images/toy_dwarf_monster_idle_0.png', 'images/toy_dwarf_monster_idle_1.png']

  static reset() {
    RaidsToyDwarf.boss_timer = 10;
  }

  static every60Tick(cls) {
    cls.idle_animation_index++;
    if(cls.idle_animation_index > 1)
    cls.idle_animation_index = 0;
  }
  
  static draw(ctx) {
    var cls = RaidsToyDwarf

    if(RaidsToyDwarf.boss_timer > 0) {
      ctx.font = "50px pixel";
      ctx.fillStyle = "red";
      ctx.fillText("Boss in: " + cls.boss_timer , 200, 200);
      return;
    }

    cls.canvas_tick++;

    if(cls.canvas_tick % 60 == 0) cls.every60Tick(cls);

    ctx.drawImage(
      Cache.getImage(
        cls.idle_animation[cls.idle_animation_index],
        cls.idle_animation[cls.idle_animation_index],
      ), 
      400,
      75,
    );

    drawAll(ctx);
  }
}

class RaidsUndeadLeader {

  static canvas_tick = 0;
  static status = "obelisk";
  static boss_timer = 10;
  static bobble = 0;
  static skeleton_hp = 0;

  static reset() {
    RaidsUndeadLeader.boss_timer = 10;
  }

  static every60Tick(cls) {
    if(cls.bobble == 0)
      cls.bobble = 5;
    else if(cls.bobble == 5)
      cls.bobble = 0;
  }

  static draw(ctx) {
    var cls = RaidsUndeadLeader
  

    if(cls.boss_timer > 0) {
      ctx.font = "50px pixel";
      ctx.fillStyle = "red";
      ctx.fillText("Boss in: " + cls.boss_timer , 200, 200);
      return;
    }

    cls.canvas_tick++;

   

    if(cls.status == "obelisk_final" || cls.status == "obelisk_final_active" ) {
      ctx.drawImage(
        Cache.getImage(
          "images/obelisk.png",
          "images/obelisk.png",
        ), 
        450,
        300,
      );

      if(cls.status == "obelisk_final_active") {
        for(var i = 0; i <= 100; i++) {
          ctx.beginPath();
          ctx.strokeStyle = '#FFFF00';
          ctx.moveTo(520, 300);
          ctx.lineTo(400 + rand(10, 50), 0 + rand(10, 300));
          ctx.stroke();
        }
      }

      
    } else if(cls.status == "obelisk") {
      ctx.drawImage(
        Cache.getImage(
          "images/undead_blood_pool.png",
          "images/undead_blood_pool.png",
        ), 
        200,
        0,
      );
  
      ctx.drawImage(
        Cache.getImage(
          "images/obelisk.png",
          "images/obelisk.png",
        ), 
        50,
        300,
      );
  
      ctx.beginPath();
      ctx.strokeStyle = '#00ff00';
      ctx.moveTo(120, 300);
      ctx.lineTo(400 + rand(10, 50), 450 + rand(10, 50));
      ctx.stroke();
  
      ctx.beginPath();
      ctx.strokeStyle = '#00ff00';
      ctx.moveTo(120, 300);
      ctx.lineTo(400 + rand(10, 50), 450 + rand(10, 50));
      ctx.stroke();
  
      ctx.beginPath();
      ctx.strokeStyle = '#00ff00';
      ctx.moveTo(120, 300);
      ctx.lineTo(400 + rand(10, 50), 450 + rand(10, 50));
      ctx.stroke();
  
      ctx.beginPath();
      ctx.strokeStyle = '#00ff00';
      ctx.moveTo(120, 300);
      ctx.lineTo(400 + rand(10, 50), 450 + rand(10, 50));
      ctx.stroke();
  
      ctx.beginPath();
      ctx.strokeStyle = '#00ff00';
      ctx.moveTo(120, 300);
      ctx.lineTo(400 + rand(10, 50), 450 + rand(10, 50));
      ctx.stroke();

      if(cls.canvas_tick % 60 == 0) {
        Raids.addHitSplatMonster("", "images/max_heart_1.png", "", "", "", "")
      }

    } else if(cls.status == "skeleton" || cls.status == "skeleton_0_hp" || cls.status == "skeleton_guard") {
      var image_path = "images/undead_leader.png";
      var x = 200;
      var y = 0 + cls.bobble
      if(cls.status == "skeleton_0_hp") { 
        image_path = "images/obelisk_side.png";
        x = 370;
        y = 400 + cls.bobble
      }
      if(cls.status == "skeleton_guard") {
        image_path = "images/undead_final_leader.png";
      }
    
      if(cls.canvas_tick % 60 == 0) cls.every60Tick(cls);
      ctx.drawImage(
        Cache.getImage(
          "images/undead_blood_pool.png",
          "images/undead_blood_pool.png",
        ), 
        200,
        0,
      );
      ctx.drawImage(
        Cache.getImage(
          image_path,
          image_path,
        ), 
        x,
        y,
      );

      if(cls.status != "skeleton_0_hp") {
        ctx.font = "50px pixel";
        ctx.fillStyle = "red";
        ctx.drawImage(
          Cache.getImage(
            "images/max_heart_1.png",
            "images/max_heart_1.png",
          ), 
          300,
          0,
        );
        ctx.fillText(format_number(cls.skeleton_hp), 350, 50);
      }
    }

    if(cls.status == "obelisk_final" || cls.status == "obelisk_final_active" || cls.status == "obelisk" || cls.status == "skeleton_0_hp") {
      ctx.font = "50px pixel";
      ctx.fillStyle = "red";
      ctx.drawImage(
        Cache.getImage(
          "images/max_heart_1.png",
          "images/max_heart_1.png",
        ), 
        300,
        0,
      );
      ctx.fillText("obelisk", 350, 50);
    }
    drawAll(ctx);
  }
}

class RaidsBabyBunny {

  static canvas_tick = 0;
  static idle_animation_index = 0;
  static idle_animation = ['images/baby_bunny_monster_idle_0.png', 'images/baby_bunny_monster_idle_1.png']
  static cry_animation = ['images/baby_bunny_monster_cry_0.png', 'images/baby_bunny_monster_cry_1.png']
  static crying = false;
  

  static every60Tick(cls) {
    cls.idle_animation_index++;
    if(cls.idle_animation_index > 1)
    cls.idle_animation_index = 0;
  }
  
  static reset() {
    RaidsBabyBunny.crying = false;
  }

  static draw(ctx) {
    var cls = RaidsBabyBunny

    cls.canvas_tick++;

    if(cls.canvas_tick % 60 == 0) cls.every60Tick(cls);

    if(cls.crying) {
      ctx.drawImage(
        Cache.getImage(
          cls.cry_animation[cls.idle_animation_index],
          cls.cry_animation[cls.idle_animation_index],
        ), 
        400,
        300,
      );
    } else {
      ctx.drawImage(
        Cache.getImage(
          cls.idle_animation[cls.idle_animation_index],
          cls.idle_animation[cls.idle_animation_index],
        ), 
        400,
        300,
      );
    }
    

    drawAll(ctx)
  }
}


function drawAll(ctx) {
  ctx.font = "16px pixel";
  ctx.fillStyle = "yellow";
  if(Raids.timer >= 0)
    ctx.fillText(Raids.timer, 20, 20);
  else {
    ctx.fillText("Fight in: " + (Raids.timer * -1), 20, 20);
  }

  if(Raids.critsPotionActiveBy != "none") {
    ctx.fillStyle = "lime";
    ctx.fillText("Team Critical Potion Active (From " + Raids.critsPotionActiveBy + ")", 20, 40);
  }
}

class RaidsMommyBunny {

  static canvas_tick = 0;
  static idle_animation_index = 0;
  static idle_animation = ['images/mommy_bunny_monster_idle_0.png', 'images/mommy_bunny_monster_idle_1.png']
  

  static every60Tick(cls) {
    cls.idle_animation_index++;
    if(cls.idle_animation_index > 1)
    cls.idle_animation_index = 0;
  }

  static reset() {
    RaidsMommyBunny.boss_timer = 10;
  }
  

  static draw(ctx) {
    var cls = RaidsMommyBunny

    if(cls.boss_timer > 0) {
      ctx.font = "50px pixel";
      ctx.fillStyle = "red";
      ctx.fillText("Boss in: " + cls.boss_timer , 200, 200);
      return;
    }

    cls.canvas_tick++;

    if(cls.canvas_tick % 60 == 0) cls.every60Tick(cls);

    ctx.drawImage(
      Cache.getImage(
        cls.idle_animation[cls.idle_animation_index],
        cls.idle_animation[cls.idle_animation_index],
      ), 
      400,
      120,
    );
    
    

    drawAll(ctx)
  }
}

class RaidsUndeadChicken {

  static canvas_tick = 0;
  static idle_animation_index = 0;
  static idle_animation = ['images/undead_chicken_monster_idle_0.png', 'images/undead_chicken_monster_idle_1.png']

  static every60Tick() {
    RaidsUndeadChicken.idle_animation_index++;
    if(RaidsUndeadChicken.idle_animation_index > 1)
    RaidsUndeadChicken.idle_animation_index = 0;
  }

  static draw(ctx) {
    var cls = RaidsUndeadChicken
    cls.canvas_tick++;
    if(cls.canvas_tick % 60 == 0) cls.every60Tick();

    ctx.drawImage(
      Cache.getImage(
        cls.idle_animation[cls.idle_animation_index],
        cls.idle_animation[cls.idle_animation_index],
      ), 
      0,
      0,
    );

    
    drawAll(ctx)
    
    
  }
}

class RaidsUndeadChickenMad {

  static canvas_tick = 0;
  static idle_animation_index = 0;
  static idle_animation = ['images/undead_chicken_mad_monster_idle_0.png', 'images/undead_chicken_mad_monster_idle_1.png']

  static every60Tick() {
    RaidsUndeadChicken.idle_animation_index++;
    if(RaidsUndeadChicken.idle_animation_index > 1)
    RaidsUndeadChicken.idle_animation_index = 0;
  }

  static draw(ctx) {
    var cls = RaidsUndeadChickenMad
    cls.canvas_tick++;
    if(cls.canvas_tick % 60 == 0) cls.every60Tick();

    ctx.drawImage(
      Cache.getImage(
        cls.idle_animation[cls.idle_animation_index],
        cls.idle_animation[cls.idle_animation_index],
      ), 
      0,
      0,
    );

    
    drawAll(ctx)
    
    
  }
}

class RaidsUndeadZombie {

  static canvas_tick = 0;
  static idle_animation_index = 0;
  static idle_animation_index_2 = 0;

  static idle_animation = ['images/undead_zombie_monster_idle_0.png', 'images/undead_zombie_monster_idle_1.png']

  static flying_animation = ['images/undead_zombie_flying_monster_idle_0.png', 'images/undead_zombie_flying_monster_idle_1.png']
  static flying = false;

  static reset() {
    RaidsUndeadZombie.flying = false;
  }

  static every60Tick(cls) {
    cls.idle_animation_index++;
    if(cls.idle_animation_index > 1)
    cls.idle_animation_index = 0;
  }
  static every15Tick(cls) {
    cls.idle_animation_index_2++;
    if(cls.idle_animation_index_2 > 1)
    cls.idle_animation_index_2 = 0;
  }

  static draw(ctx) {
    var cls = RaidsUndeadZombie
    cls.canvas_tick++;
    if(cls.canvas_tick % 60 == 0) cls.every60Tick(cls);
    if(cls.canvas_tick % 15 == 0) cls.every15Tick(cls);
    

    if(!cls.flying) {
      ctx.drawImage(
        Cache.getImage(
          cls.idle_animation[cls.idle_animation_index],
          cls.idle_animation[cls.idle_animation_index],
        ), 
        400,
        200,
      );
    } else {
      if(cls.idle_animation_index_2 == 1) {
        ctx.drawImage(
          Cache.getImage(
            cls.flying_animation[cls.idle_animation_index],
            cls.flying_animation[cls.idle_animation_index],
          ), 
          500,
          50,
        );
      }
      else {
        ctx.drawImage(
          Cache.getImage(
            cls.flying_animation[cls.idle_animation_index],
            cls.flying_animation[cls.idle_animation_index],
          ), 
          500,
          40,
        );
      }
      
    }
    

    
    drawAll(ctx)
    
    
  }
}

class RaidsSpikedSkeleton {

  static canvas_tick = 0;
  static idle_animation_index = 0;
  static chargingProjectileFlag = false;

  static idle_animation = ['images/undead_spiked_skeleton_monster_idle_0.png', 'images/undead_spiked_skeleton_monster_idle_1.png']

  static reset() {
    RaidsSpikedSkeleton.chargingProjectileFlag = false;
  }
  

  static every60Tick(cls) {
    cls.idle_animation_index++;
    if(cls.idle_animation_index > 1)
    cls.idle_animation_index = 0;
  }


  static draw(ctx) {
    var cls = RaidsSpikedSkeleton
    cls.canvas_tick++;
    if(cls.canvas_tick % 60 == 0) cls.every60Tick(cls);
    
    if(!cls.chargingProjectileFlag) {
      ctx.drawImage(
        Cache.getImage(
          cls.idle_animation[cls.idle_animation_index],
          cls.idle_animation[cls.idle_animation_index],
        ), 
        400,
        70,
      );
    } else {
      ctx.drawImage(
        Cache.getImage(
          "images/undead_spiked_skeleton_monster_attack_0.png",
          "images/undead_spiked_skeleton_monster_attack_0.png",
        ), 
        400,
        70,
      );
    }
    
    drawAll(ctx)
  }
}

class RaidsUndeadYeti {

  static canvas_tick = 0;
  static idle_animation_index = 0;
  static idle_animation = ['images/undead_yeti_monster_idle_0.png', 'images/undead_yeti_monster_idle_1.png']

  // if = 1, animation starts
  static aniamtionIceCubeAttack = 0;
  static aniamtionIceCubeAttackCountered = false;


  static reset() {
    RaidsUndeadYeti.aniamtionIceCubeAttack = 0;
    RaidsUndeadYeti.aniamtionIceCubeAttackCountered = 0;
  }
  
  static every60Tick() {
    RaidsUndeadYeti.idle_animation_index++;
    if(RaidsUndeadYeti.idle_animation_index > 1)
    RaidsUndeadYeti.idle_animation_index = 0;
  }

  static draw(ctx) {
    var cls = RaidsUndeadYeti
    cls.canvas_tick++;
    if(cls.canvas_tick % 60 == 0) cls.every60Tick();

    ctx.drawImage(
      Cache.getImage(
        cls.idle_animation[cls.idle_animation_index],
        cls.idle_animation[cls.idle_animation_index],
      ), 
      358,
      167,
    );

    
    drawAll(ctx)

    if(cls.aniamtionIceCubeAttack > 0) {
      var imgPath = "images/ice_cube.png";
      if(cls.aniamtionIceCubeAttackCountered) {
        imgPath = "images/red_ice_cube.png";
      }
      for(var i = 0; i < cls.aniamtionIceCubeAttack; i++) {
        ctx.drawImage(
          Cache.getImage(
            imgPath,
            imgPath,
          ), 
          rand(0, 800),
          rand(0, 800),
        );
      }
      cls.aniamtionIceCubeAttack++;
    }
  
  }
}

class RaidsUndeadRoamingGhost {

  static canvas_tick = 0;
  static idle_animation_index = 0;
  static idle_animation = ['images/undead_roaming_ghost_monster_idle_0.png']
  static yIdleOffset = 0;
  static offsetDirection = 0;
  static charging = false;



  static reset() {
    var cls = RaidsUndeadRoamingGhost
    cls.yIdleOffset = 0;
    cls.charging = false;
  }
  
  static every60Tick(cls) {
  }

  static draw(ctx) {
    var cls = RaidsUndeadRoamingGhost
    cls.canvas_tick++;

    if(cls.offsetDirection == 0) {
      cls.yIdleOffset++;
    } else {
      cls.yIdleOffset--;
    }

    if(cls.yIdleOffset >= 100) {
      cls.offsetDirection = 1;
    }
    if(cls.yIdleOffset <= 0) {
      cls.offsetDirection = 0;
    }
    

    if(cls.charging) {
      ctx.drawImage(
        Cache.getImage(
          "images/undead_roaming_ghost_monster_attack_0.png",
          "images/undead_roaming_ghost_monster_attack_0.png",
        ), 
        458,
        167 + cls.yIdleOffset,
      );
    } else {
      ctx.drawImage(
        Cache.getImage(
          cls.idle_animation[cls.idle_animation_index],
          cls.idle_animation[cls.idle_animation_index],
        ), 
        458,
        167 + cls.yIdleOffset,
      );
    }
    


    
    drawAll(ctx)

    if(cls.aniamtionIceCubeAttack > 0) {
      var imgPath = "images/ice_cube.png";
      if(cls.aniamtionIceCubeAttackCountered) {
        imgPath = "images/red_ice_cube.png";
      }
      for(var i = 0; i < cls.aniamtionIceCubeAttack; i++) {
        ctx.drawImage(
          Cache.getImage(
            imgPath,
            imgPath,
          ), 
          rand(0, 800),
          rand(0, 800),
        );
      }
      cls.aniamtionIceCubeAttack++;
    }
  
  }
}

class RaidsUndeadSkeletonZombie {

  static canvas_tick = 0;
  static skeletonsToDraw = 1;

  static reset() {
    RaidsUndeadSkeletonZombie.skeletonsToDraw = 1;
  }
  static draw(ctx) {
    var cls = RaidsUndeadSkeletonZombie
    cls.canvas_tick++;

    if(cls.skeletonsToDraw == 1) {
      ctx.drawImage(
        Cache.getImage(
          "images/undead_skeleton_zombie.png",
          "images/undead_skeleton_zombie.png",
        ), 
        500,
        300,
      );
    } else if(cls.skeletonsToDraw == 2) {
      ctx.drawImage(
        Cache.getImage(
          "images/undead_skeleton_zombie.png",
          "images/undead_skeleton_zombie.png",
        ), 
        350,
        350,
      );
      ctx.drawImage(
        Cache.getImage(
          "images/undead_skeleton_zombie.png",
          "images/undead_skeleton_zombie.png",
        ), 
        550,
        300,
      );
    } else if(cls.skeletonsToDraw == 3) {
      ctx.drawImage(
        Cache.getImage(
          "images/undead_skeleton_zombie.png",
          "images/undead_skeleton_zombie.png",
        ), 
        175,
        111,
      );
      ctx.drawImage(
        Cache.getImage(
          "images/undead_skeleton_zombie.png",
          "images/undead_skeleton_zombie.png",
        ), 
        521,
        132,
      );
      ctx.drawImage(
        Cache.getImage(
          "images/undead_skeleton_zombie.png",
          "images/undead_skeleton_zombie.png",
        ), 
        592,
        391,
      );
    } else if(cls.skeletonsToDraw == 4) {
      ctx.drawImage(
        Cache.getImage(
          "images/undead_skeleton_zombie.png",
          "images/undead_skeleton_zombie.png",
        ), 
        144,
        93,
      );
      ctx.drawImage(
        Cache.getImage(
          "images/undead_skeleton_zombie.png",
          "images/undead_skeleton_zombie.png",
        ), 
        581,
        90,
      );
      ctx.drawImage(
        Cache.getImage(
          "images/undead_skeleton_zombie.png",
          "images/undead_skeleton_zombie.png",
        ), 
        143,
        377,
      );
      ctx.drawImage(
        Cache.getImage(
          "images/undead_skeleton_zombie.png",
          "images/undead_skeleton_zombie.png",
        ), 
        570,
        387,
      );
    } else if(cls.skeletonsToDraw == 5) {
      ctx.drawImage(
        Cache.getImage(
          "images/undead_skeleton_zombie.png",
          "images/undead_skeleton_zombie.png",
        ), 
        59,
        66,
      );
      ctx.drawImage(
        Cache.getImage(
          "images/undead_skeleton_zombie.png",
          "images/undead_skeleton_zombie.png",
        ), 
        315,
        72,
      );
      ctx.drawImage(
        Cache.getImage(
          "images/undead_skeleton_zombie.png",
          "images/undead_skeleton_zombie.png",
        ), 
        600,
        92,
      );
      ctx.drawImage(
        Cache.getImage(
          "images/undead_skeleton_zombie.png",
          "images/undead_skeleton_zombie.png",
        ), 
        156,
        333,
      );
      ctx.drawImage(
        Cache.getImage(
          "images/undead_skeleton_zombie.png",
          "images/undead_skeleton_zombie.png",
        ), 
        536,
        332,
      );
    } else if(cls.skeletonsToDraw == 6) {
      ctx.drawImage(
        Cache.getImage(
          "images/undead_skeleton_zombie.png",
          "images/undead_skeleton_zombie.png",
        ), 
        57,
        72,
      );
      ctx.drawImage(
        Cache.getImage(
          "images/undead_skeleton_zombie.png",
          "images/undead_skeleton_zombie.png",
        ), 
        323,
        67,
      );
      ctx.drawImage(
        Cache.getImage(
          "images/undead_skeleton_zombie.png",
          "images/undead_skeleton_zombie.png",
        ), 
        620,
        68,
      );
      ctx.drawImage(
        Cache.getImage(
          "images/undead_skeleton_zombie.png",
          "images/undead_skeleton_zombie.png",
        ), 
        48,
        346,
      );
      ctx.drawImage(
        Cache.getImage(
          "images/undead_skeleton_zombie.png",
          "images/undead_skeleton_zombie.png",
        ), 
        333,
        355,
      );
      ctx.drawImage(
        Cache.getImage(
          "images/undead_skeleton_zombie.png",
          "images/undead_skeleton_zombie.png",
        ), 
        591,
        339,
      );
    } else if(cls.skeletonsToDraw == 7) {
      for(var i = 0; i <= 20; i++) {
        ctx.drawImage(
          Cache.getImage(
            "images/undead_skeleton_zombie.png",
            "images/undead_skeleton_zombie.png",
          ), 
          rand(0, 800),
          rand(0, 800),
        );
      }
    }
  
    
    drawAll(ctx)
    
  }
}

