class Raids
{
  static FPS = 60;
  static tick_tracker = 0;
  static BOPPING_OFFSET = 0;
  static active_hitsplats_hero_map = {};
  static active_hitsplats_monster_map = {};
  static active_canvas_animations_map = {};
  static currentMonster = null;
  static timer = -10;
  static critsPotionActiveBy = "smitty";


  static teamMember1InviteActive = false;
  static teamMember2InviteActive = false;
  static teamMember3InviteActive = false;
  static teamMember4InviteActive = false;

  static refresh_raids_team_info(data) {
    
    var slug = data[0];
    var member1Username = data[1];
    var member2Username = data[2];
    var member3Username = data[3];
    var member4Username = data[4];

    document.getElementById("raids-create-or-join-team-btns").style.display = "none";
    document.getElementById("raids-team-panel").style.display = "";

    if(member1Username == "null") member1Username = "<span style='color:grey'>(none)</span>"; else member1Username = "<span style='color:lime'>" + member1Username + "</span>";
    if(member2Username == "null") member2Username = "<span style='color:grey'>(none)</span>"; else member2Username = "<span style='color:lime'>" + member2Username + "</span>";
    if(member3Username == "null") member3Username = "<span style='color:grey'>(none)</span>"; else member3Username = "<span style='color:lime'>" + member3Username + "</span>";
    if(member4Username == "null") member4Username = "<span style='color:grey'>(none)</span>"; else member4Username = "<span style='color:lime'>" + member4Username + "</span>";
    
    document.getElementById("raids-team-panel-user1").innerHTML = member1Username;
    document.getElementById("raids-team-panel-user2").innerHTML = member2Username;
    document.getElementById("raids-team-panel-user3").innerHTML = member3Username;
    document.getElementById("raids-team-panel-user4").innerHTML = member4Username;

    document.getElementById("raids-team-panel-uuid").innerHTML = slug;
  }

  static reset_team() {
    document.getElementById("raids-create-or-join-team-btns").style.display = "";
    document.getElementById("raids-team-panel").style.display = "none";

    var member1Username = "<span style='color:grey'>(none)</span>";
    var member2Username = "<span style='color:grey'>(none)</span>";
    var member3Username = "<span style='color:grey'>(none)</span>";
    var member4Username = "<span style='color:grey'>(none)</span>";
    
    document.getElementById("raids-team-panel-user1").innerHTML = member1Username;
    document.getElementById("raids-team-panel-user2").innerHTML = member2Username;
    document.getElementById("raids-team-panel-user3").innerHTML = member3Username;
    document.getElementById("raids-team-panel-user4").innerHTML = member4Username;

    document.getElementById("raids-team-panel-uuid").innerHTML = "";
  }

  static invisSpellCasted(teamMemberId) {
    switch(teamMemberId) {
      case "1":
        Raids.teamMember1InviteActive = true;
        setTimeout(function() { Raids.teamMember1InviteActive = false;}, 3000)
      break;
      case "2":
        Raids.teamMember2InviteActive = true;
        setTimeout(function() { Raids.teamMember2InviteActive = false;}, 3000)
      break;
      case "3":
        Raids.teamMember3InviteActive = true;
        setTimeout(function() { Raids.teamMember3InviteActive = false;}, 3000)
      break;
      case "4":
        Raids.teamMember4InviteActive = true;
        setTimeout(function() { Raids.teamMember4InviteActive = false;}, 3000)
      break;
    }
  }


  static refreshHeroHpProgressBar(index) {
      var hp = Items.getItem("raids_hp" + index);
      var max_hp = Items.getItem("raids_max_hp" + index);

      var percentage = hp / max_hp * 100;
      if(percentage > 100) percentage = 100;
      document.getElementById("hero-progress-bar-hp-hero-raids-" + index).style.width = percentage + "%"; 
  }

  static drinkPotion(potion) {
    websocket.send('DRINK_RAIDS_POTION=' + potion);
  }

  static refreshPotionIconsForTeamMember(teamMemberIndex, raw) {
    var dataArray = raw.split("~");

    //0 = does not own, 1 = owns, 2 = used
    var hpPotion = parseInt(dataArray[0]);
    var manaPotion = parseInt(dataArray[1]);
    var critsPotion = parseInt(dataArray[2]);

    if(hpPotion == 1) {
      document.getElementById("raids-hero-potion-raids_hp_potion-" + teamMemberIndex).style.display = "";
    } else {
      document.getElementById("raids-hero-potion-raids_hp_potion-" + teamMemberIndex).style.display = "none";
    }
    if(manaPotion == 1) {
      document.getElementById("raids-hero-potion-raids_mana_potion-" + teamMemberIndex).style.display = "";
    } else {
      document.getElementById("raids-hero-potion-raids_mana_potion-" + teamMemberIndex).style.display = "none";
    }
    if(critsPotion == 1) {
      document.getElementById("raids-hero-potion-raids_crits_potion-" + teamMemberIndex).style.display = "";
    } else {
      document.getElementById("raids-hero-potion-raids_crits_potion-" + teamMemberIndex).style.display = "none";
    }
  }


  static refreshSpellIconsForTeamMember(teamMemberIndex, raw) {
    var dataArray = raw.split("~");
    var healValue = dataArray[0];
    var fireValue = dataArray[1];
    var reflectValue = dataArray[2];
    var invisValue = dataArray[3];

    if(healValue == 0) {
      set_image_src("raids-hero-spells-img-heal_team_member" + teamMemberIndex, "images/lock.png")
    } else if(healValue == 1) {
      set_image_src("raids-hero-spells-img-heal_team_member" + teamMemberIndex, "images/heal_spell_icon.png")
    } else {
      set_image_src("raids-hero-spells-img-heal_team_member" + teamMemberIndex, "images/upgraded_heal_spell_icon.png")
    }

    if(fireValue == 0) {
      set_image_src("raids-hero-spells-img-fire_team_member" + teamMemberIndex, "images/lock.png")
    } else if(fireValue == 1) {
      set_image_src("raids-hero-spells-img-fire_team_member" + teamMemberIndex, "images/fire_spell_icon.png")
    } else {
      set_image_src("raids-hero-spells-img-fire_team_member" + teamMemberIndex, "images/upgraded_fire_spell_icon.png")
    }

    if(reflectValue == 0) {
      set_image_src("raids-hero-spells-img-reflect_team_member" + teamMemberIndex, "images/lock.png")
    } else if(reflectValue == 1) {
      set_image_src("raids-hero-spells-img-reflect_team_member" + teamMemberIndex, "images/reflect_spell_icon.png")
    } else {
      set_image_src("raids-hero-spells-img-reflect_team_member" + teamMemberIndex, "images/upgraded_reflect_spell_icon.png")
    }

    if(invisValue == 0) {
      set_image_src("raids-hero-spells-img-invisibility_team_member" + teamMemberIndex, "images/lock.png")
    } else if(invisValue == 1) {
      set_image_src("raids-hero-spells-img-invisibility_team_member" + teamMemberIndex, "images/invisibility_spell_icon.png")
    } else {
      set_image_src("raids-hero-spells-img-invisibility_team_member" + teamMemberIndex, "images/upgraded_invisibility_spell_icon.png")
    }
  }

  static refreshHeroManaProgressBar(index) {
    var hp = Items.getItem("raids_mana" + index);
    var max_hp = Items.getItem("raids_max_mana" + index);

    var percentage = hp / max_hp * 100;
    if(percentage > 100) percentage = 100;
    document.getElementById("hero-progress-bar-mana-hero-raids-" + index).style.width = percentage + "%"; 
}


  static refreshSpell(spell_name, value, playerIndex) {
    if(value > 0) {
      document.getElementById('raids-hero-spells-img-'+spell_name+'_team_member' + playerIndex).style.display = 'none';
      document.getElementById('raids-hero-spells-cd-'+spell_name+'_team_member' + playerIndex).style.display = '';
      document.getElementById('raids-hero-spells-cd-'+spell_name+'_team_member' + playerIndex).innerHTML = value;
    } else {
      document.getElementById('raids-hero-spells-img-'+spell_name+'_team_member' + playerIndex).style.display = '';
      document.getElementById('raids-hero-spells-cd-'+spell_name+'_team_member' + playerIndex).style.display = 'none'
    }
  }

  static bopping()
  {
      if(Raids.BOPPING_OFFSET == 0)
        Raids.BOPPING_OFFSET = rand(1, 5);
      else
        Raids.BOPPING_OFFSET = 0;
  }

  static addHitSplatHero(label, icon, label_color, background_color, border_color, team_member_index, source)
  {
      var splat = null;
      if(team_member_index == 1) {
        splat = new RaidsHitSplat(label, icon, label_color, background_color, border_color, 50, 500);
      }
      if(team_member_index == 2) {
        splat = new RaidsHitSplat(label, icon, label_color, background_color, border_color, 50, 350);
      }
      if(team_member_index == 3) {
        splat = new RaidsHitSplat(label, icon, label_color, background_color, border_color, 50, 200);
      }
      if(team_member_index == 4) {
        splat = new RaidsHitSplat(label, icon, label_color, background_color, border_color, 50, 0);
      }

      if(splat == null) {
        console.log("ERROR IN ADDING HIT SPLAT");
        return;
      }
      
      var random_key = rand(1,500000);
      Raids.active_hitsplats_hero_map[random_key] = splat;

      if(label != 0)
      Raids.dim_hero_image = true;

      setTimeout(
          function(){
            Raids.dim_hero_image = false;
          },
          250
      )

      setTimeout(
          function(){
              delete Raids.active_hitsplats_hero_map[random_key];
          },
          1000
      )
  }

  static copyPassword() {
    var id = 'raids-team-panel-uuid'
    var r = document.createRange();
    r.selectNode(document.getElementById(id));
    window.getSelection().removeAllRanges();
    window.getSelection().addRange(r);
    document.execCommand('copy');
    window.getSelection().removeAllRanges();

  }

  static refreshMonsterHpBar(currentHp, maxHp) {
    var hp = currentHp;
    var max_hp = maxHp;

    var percentage = hp / max_hp * 100;
    if(percentage > 100) percentage = 100;
    document.getElementById("monster-raids-progress-bar-hp").style.width = percentage + "%"; 
    document.getElementById("combat_monster_hp-raids").innerHTML = hp;
    document.getElementById("combat_monster_max_hp-raids").innerHTML = max_hp;
  }
  
  static addHitSplatMonster(label, icon, label_color, background_color, border_color, team_member_username)
  {
      var splat = new RaidsHitSplatOnMonster(
        label,
        icon,
        label_color,
        background_color,
        border_color,
        RaidsHitSplatOnMonsterPosition.start_x,
        RaidsHitSplatOnMonsterPosition.start_y
      );
      var random_key = rand(1,500000);
      Raids.active_hitsplats_monster_map[random_key] = splat;

      setTimeout(
          function(){
              delete Raids.active_hitsplats_monster_map[random_key];
          },
          1000
      )
  }

  static addCanvasAnimationObject(path, start_x, start_y, end_x, end_y, timeMS)
  {

      var obj = new CanvasAnimationObject(path, start_x, start_y, end_x, end_y, timeMS);
      var random_key = rand(1,500000);
      Raids.active_canvas_animations_map[random_key] = obj;

      setTimeout(
          function(){
              delete Raids.active_canvas_animations_map[random_key];
          },
          timeMS
      )
  }

  static setMonsterLabels(label, accuracy, damage, speed, defence) {
    var labelValue = capitalizeFirstLetter(get_item_name(label));
    document.getElementById("fighting-monster-raid-label").innerHTML = labelValue;
    document.getElementById("combat_raid_monster_accuracy").innerHTML = accuracy;
    document.getElementById("combat_raid_monster_attack").innerHTML = damage;
    document.getElementById("combat_raid_monster_speed").innerHTML = speed;
    document.getElementById("combat_raid_monster_defence").innerHTML = defence;
  }

  static track_ticks()
  {
        Raids.tick_tracker++;

        if(Raids.tick_tracker > 100000)
          Raids.tick_tracker = 0;
  }

  static manage_hitplats()
  {
      for (var key in Raids.active_hitsplats_hero_map) 
      {
        Raids.active_hitsplats_hero_map[key].draw(_fighting_hero_canvas_context_raids);
      }
  }
  
  static manage_canvas_animations()
  {
      for (var key in Raids.active_canvas_animations_map) 
      {
        Raids.active_canvas_animations_map[key].draw(_fighting_monster_canvas_context_raids);
      }
  }

  static manage_monster_hitplats()
  {
      for (var key in Raids.active_hitsplats_monster_map) 
      {
        Raids.active_hitsplats_monster_map[key].draw(_fighting_monster_canvas_context_raids);
      }
  }

  static resetMonsterVariables() {
    RaidsUndeadSkeletonZombie.reset();
    RaidsUndeadYeti.reset();
    RaidsUndeadZombie.reset();
    RaidsSpikedSkeleton.reset();
    RaidsToyTeddy.reset();
    RaidsToyDwarf.reset();
    RaidsBabyBunny.reset();
    RaidsUndeadRoamingGhost.reset();
  }


  static raids_monster_fps;
  static raids_monster_fpsInterval;
  static raids_monster_startTime;
  static raids_monster_now;
  static raids_monster_then;
  static raids_monster_elapsed;
  static raids_monster_frameCount = 0;
  static raids_monster_canvasStarted = false;
  static startRaidsMonsterCanvas() {
    if(Raids.raids_monster_canvasStarted) {
      return;
    }
    var FPS = 60
    Raids.raids_monster_fps = 0;
    Raids.raids_monster_elapsed = 0;
    Raids.raids_monster_frameCount = 0;
    Raids.raids_monster_fpsInterval = 1000 / FPS;
    Raids.raids_monster_then = Date.now();
    Raids.raids_monster_startTime = TestCanvas.then;
    Raids.raids_monster_canvasStarted = true;
    Raids.tickRaidsMonsterCanvas();
  }

  static tickRaidsMonsterCanvas() {
    if (Globals.currentPanel != 'panel-combat-canvas-raids') {
      Raids.raids_monster_canvasStarted = false;
      return;
    }

    requestAnimationFrame(Raids.tickRaidsMonsterCanvas);
    Raids.raids_monster_now = Date.now();
    Raids.raids_monster_elapsed = Raids.raids_monster_now - Raids.raids_monster_then;

    if (Raids.raids_monster_elapsed > Raids.raids_monster_fpsInterval) {
      Raids.raids_monster_then = Raids.raids_monster_now - (Raids.raids_monster_elapsed % Raids.raids_monster_fpsInterval);

      //We draw here
      _fighting_monster_canvas_context_raids.clearRect(0, 0, 800, 600);

      switch(Raids.currentMonster) {
        case"undead_chicken": 
          RaidsUndeadChicken.draw(_fighting_monster_canvas_context_raids)
        break;
        case"undead_chicken_mad": 
          RaidsUndeadChickenMad.draw(_fighting_monster_canvas_context_raids)
        break;
        case"undead_skeleton_zombie": 
          RaidsUndeadSkeletonZombie.draw(_fighting_monster_canvas_context_raids)
        break;
        case"undead_yeti": 
          RaidsUndeadYeti.draw(_fighting_monster_canvas_context_raids)
        break;
        case "undead_roaming_ghost":
          RaidsUndeadRoamingGhost.draw(_fighting_monster_canvas_context_raids)
        break;
        case"undead_zombie": 
          RaidsUndeadZombie.draw(_fighting_monster_canvas_context_raids)
        break;
        case"undead_spiked_skeleton": 
          RaidsSpikedSkeleton.draw(_fighting_monster_canvas_context_raids)
        break;
        case"toy_cute": 
          RaidsToyCute.draw(_fighting_monster_canvas_context_raids)
        break;
        case"toy_slinky": 
          RaidsToySlinky.draw(_fighting_monster_canvas_context_raids)
        break;
        case"toy_teddy": 
          RaidsToyTeddy.draw(_fighting_monster_canvas_context_raids)
        break;
        case"toy_dwarf": 
          RaidsToyDwarf.draw(_fighting_monster_canvas_context_raids)
        break;
        case"baby_bunny": 
          RaidsBabyBunny.draw(_fighting_monster_canvas_context_raids)
        break;
        case "mommy_bunny":
          RaidsMommyBunny.draw(_fighting_monster_canvas_context_raids)
        break;
        case "undead_leader":
          RaidsUndeadLeader.draw(_fighting_monster_canvas_context_raids)
        break;
      }

      Raids.manage_monster_hitplats();
      Raids.manage_canvas_animations();
    }
  }

  
  static raids_team_fps;
  static raids_team_fpsInterval;
  static raids_team_startTime;
  static raids_team_now;
  static raids_team_then;
  static raids_team_elapsed;
  static raids_team_frameCount = 0;
  static raids_team_canvasStarted = false;
  static startRaidsTeamCanvas() {
    if(Raids.raids_team_canvasStarted) {
      return;
    }
    var FPS = 60
    Raids.raids_team_fps = 0;
    Raids.raids_team_elapsed = 0;
    Raids.raids_team_frameCount = 0;
    Raids.raids_team_fpsInterval = 1000 / FPS;
    Raids.raids_team_then = Date.now();
    Raids.raids_team_startTime = TestCanvas.then;
    Raids.raids_team_canvasStarted = true;
    Raids.tickTeamCanvas();
  }

  static tickTeamCanvas() {

    if (Globals.currentPanel != 'panel-combat-canvas-raids') {
      Raids.raids_team_canvasStarted = false;
      return;
    }
    requestAnimationFrame(Raids.tickTeamCanvas);
    Raids.raids_team_now = Date.now();
    Raids.raids_team_elapsed = Raids.raids_team_now - Raids.raids_team_then;
    if (Raids.raids_team_elapsed > Raids.raids_team_fpsInterval) {
      Raids.raids_team_then = Raids.raids_team_now - (Raids.raids_team_elapsed % Raids.raids_team_fpsInterval);

    //draw here
    _fighting_hero_canvas_context_raids.clearRect(0, 0, _fighting_hero_canvas_raids.width, _fighting_hero_canvas_raids.height);

    var xPositionHero = 0;
    if(Items.getItem("team_member_active4") == 1) {
      if(Items.getItem("raids_hp4") > 0 || Raids.timer <= 0) {
        if(Raids.teamMember4InviteActive)  {
          _fighting_hero_canvas_context_raids.globalAlpha = 0.1;
        }
        _fighting_hero_canvas_context_raids.drawImage(Cache.getImage("images/hero_head_" + Items.getItemString('head_team4')+".png","hero_fighting_head_raids4"), xPositionHero, 0 + Raids.BOPPING_OFFSET, 150, 150);
        _fighting_hero_canvas_context_raids.drawImage(Cache.getImage("images/hero_body_" + Items.getItemString('body_team4')+".png","hero_fighting_body_raids4"), xPositionHero, 0 + Raids.BOPPING_OFFSET, 150, 150);
        _fighting_hero_canvas_context_raids.drawImage(Cache.getImage("images/hero_gloves_" + Items.getItemString('gloves_team4')+".png","hero_fighting_gloves_raids4"), xPositionHero, 0 + Raids.BOPPING_OFFSET, 150, 150);
        _fighting_hero_canvas_context_raids.drawImage(Cache.getImage("images/hero_legs_" + Items.getItemString('legs_team4')+".png","hero_fighting_legs_raids4"), xPositionHero, 0, 150, 150);
        _fighting_hero_canvas_context_raids.drawImage(Cache.getImage("images/hero_boots_" + Items.getItemString('boots_team4')+".png","hero_fighting_boots_raids4"), xPositionHero, 0, 150, 150);
        _fighting_hero_canvas_context_raids.drawImage(Cache.getImage("images/hero_amulet_" + Items.getItemString('amulet_team4')+".png","hero_fighting_amulet_raids4"), xPositionHero, 0 + Raids.BOPPING_OFFSET, 150, 150);
        _fighting_hero_canvas_context_raids.drawImage(Cache.getImage("images/hero_shield_" + Items.getItemString('shield_team4')+".png","hero_fighting_shield_raids4"), xPositionHero, 0 + Raids.BOPPING_OFFSET, 150, 150);
        _fighting_hero_canvas_context_raids.drawImage(Cache.getImage("images/hero_weapon_" + Items.getItemString('weapon_team4')+".png","hero_fighting_weapon_raids4"), xPositionHero, 0 + Raids.BOPPING_OFFSET, 150, 150);
      } else {
        _fighting_hero_canvas_context_raids.drawImage(Cache.getImage("images/hero_dead.png","hero_dead"), xPositionHero, 0, 150, 150);
      }
      _fighting_hero_canvas_context_raids.globalAlpha = 1.0;
    }
    
    if(Items.getItem("team_member_active3") == 1) {
      if(Items.getItem("raids_hp3") > 0 || Raids.timer <= 0) {

        if(Raids.teamMember3InviteActive)  {
          _fighting_hero_canvas_context_raids.globalAlpha = 0.1;
        }

        _fighting_hero_canvas_context_raids.drawImage(Cache.getImage("images/hero_head_" + Items.getItemString('head_team3')+".png","hero_fighting_head_raids3"), xPositionHero, 150 + Raids.BOPPING_OFFSET, 150, 150);
        _fighting_hero_canvas_context_raids.drawImage(Cache.getImage("images/hero_body_" + Items.getItemString('body_team3')+".png","hero_fighting_body_raids3"), xPositionHero, 150 + Raids.BOPPING_OFFSET, 150, 150);
        _fighting_hero_canvas_context_raids.drawImage(Cache.getImage("images/hero_gloves_" + Items.getItemString('gloves_team3')+".png","hero_fighting_gloves_raids3"), xPositionHero, 150 + Raids.BOPPING_OFFSET, 150, 150);
        _fighting_hero_canvas_context_raids.drawImage(Cache.getImage("images/hero_legs_" + Items.getItemString('legs_team3')+".png","hero_fighting_legs_raids3"), xPositionHero, 150, 150, 150);
        _fighting_hero_canvas_context_raids.drawImage(Cache.getImage("images/hero_boots_" + Items.getItemString('boots_team3')+".png","hero_fighting_boots_raids3"), xPositionHero, 150, 150, 150);
        _fighting_hero_canvas_context_raids.drawImage(Cache.getImage("images/hero_amulet_" + Items.getItemString('amulet_team3')+".png","hero_fighting_amulet_raids3"), xPositionHero, 150 + Raids.BOPPING_OFFSET, 150, 150);
        _fighting_hero_canvas_context_raids.drawImage(Cache.getImage("images/hero_shield_" + Items.getItemString('shield_team3')+".png","hero_fighting_shield_raids3"), xPositionHero, 150 + Raids.BOPPING_OFFSET, 150, 150);
        _fighting_hero_canvas_context_raids.drawImage(Cache.getImage("images/hero_weapon_" + Items.getItemString('weapon_team3')+".png","hero_fighting_weapon_raids3"), xPositionHero, 150 + Raids.BOPPING_OFFSET, 150, 150);
      } else {
        _fighting_hero_canvas_context_raids.drawImage(Cache.getImage("images/hero_dead.png","hero_dead"), xPositionHero, 150, 150, 150);
      }
      _fighting_hero_canvas_context_raids.globalAlpha = 1.0;
    }

    if(Items.getItem("team_member_active2") == 1) {
      if(Items.getItem("raids_hp2") > 0 || Raids.timer <= 0) {
        if(Raids.teamMember2InviteActive)  {
          _fighting_hero_canvas_context_raids.globalAlpha = 0.1;
        }


        _fighting_hero_canvas_context_raids.drawImage(Cache.getImage("images/hero_head_" + Items.getItemString('head_team2')+".png","hero_fighting_head_raids2"), xPositionHero, 300 + Raids.BOPPING_OFFSET, 150, 150);
        _fighting_hero_canvas_context_raids.drawImage(Cache.getImage("images/hero_body_" + Items.getItemString('body_team2')+".png","hero_fighting_body_raids2"), xPositionHero, 300 + Raids.BOPPING_OFFSET, 150, 150);
        _fighting_hero_canvas_context_raids.drawImage(Cache.getImage("images/hero_gloves_" + Items.getItemString('gloves_team2')+".png","hero_fighting_gloves_raids2"), xPositionHero, 300 + Raids.BOPPING_OFFSET, 150, 150);
        _fighting_hero_canvas_context_raids.drawImage(Cache.getImage("images/hero_legs_" + Items.getItemString('legs_team2')+".png","hero_fighting_legs_raids2"), xPositionHero, 300, 150, 150);
        _fighting_hero_canvas_context_raids.drawImage(Cache.getImage("images/hero_boots_" + Items.getItemString('boots_team2')+".png","hero_fighting_boots_raids2"), xPositionHero, 300, 150, 150);
        _fighting_hero_canvas_context_raids.drawImage(Cache.getImage("images/hero_amulet_" + Items.getItemString('amulet_team2')+".png","hero_fighting_amulet_raids2"), xPositionHero, 300 + Raids.BOPPING_OFFSET, 150, 150);
        _fighting_hero_canvas_context_raids.drawImage(Cache.getImage("images/hero_shield_" + Items.getItemString('shield_team2')+".png","hero_fighting_shield_raids2"), xPositionHero, 300 + Raids.BOPPING_OFFSET, 150, 150);
        _fighting_hero_canvas_context_raids.drawImage(Cache.getImage("images/hero_weapon_" + Items.getItemString('weapon_team2')+".png","hero_fighting_weapon_raids2"), xPositionHero, 300 + Raids.BOPPING_OFFSET, 150, 150);
      } else {
        _fighting_hero_canvas_context_raids.drawImage(Cache.getImage("images/hero_dead.png","hero_dead"), xPositionHero, 300, 150, 150);
      }
      _fighting_hero_canvas_context_raids.globalAlpha = 1.0;
    }

    if(Items.getItem("team_member_active1") == 1) {
      if(Items.getItem("raids_hp1") > 0 || Raids.timer <= 0) {

        if(Raids.teamMember1InviteActive)  {
          _fighting_hero_canvas_context_raids.globalAlpha = 0.1;
        }

        _fighting_hero_canvas_context_raids.drawImage(Cache.getImage("images/hero_head_" + Items.getItemString('head_team1')+".png","hero_fighting_head_raids1"), xPositionHero, 450 + Raids.BOPPING_OFFSET, 150, 150);
        _fighting_hero_canvas_context_raids.drawImage(Cache.getImage("images/hero_body_" + Items.getItemString('body_team1')+".png","hero_fighting_body_raids1"), xPositionHero, 450 + Raids.BOPPING_OFFSET, 150, 150);
        _fighting_hero_canvas_context_raids.drawImage(Cache.getImage("images/hero_gloves_" + Items.getItemString('gloves_team1')+".png","hero_fighting_gloves_raids1"), xPositionHero, 450 + Raids.BOPPING_OFFSET, 150, 150);
        _fighting_hero_canvas_context_raids.drawImage(Cache.getImage("images/hero_legs_" + Items.getItemString('legs_team1')+".png","hero_fighting_legs_raids1"), xPositionHero, 450, 150, 150);
        _fighting_hero_canvas_context_raids.drawImage(Cache.getImage("images/hero_boots_" + Items.getItemString('boots_team1')+".png","hero_fighting_boots_raids1"), xPositionHero, 450, 150, 150);
        _fighting_hero_canvas_context_raids.drawImage(Cache.getImage("images/hero_amulet_" + Items.getItemString('amulet_team1')+".png","hero_fighting_amulet_raids1"), xPositionHero, 450 + Raids.BOPPING_OFFSET, 150, 150);
        _fighting_hero_canvas_context_raids.drawImage(Cache.getImage("images/hero_shield_" + Items.getItemString('shield_team1')+".png","hero_fighting_shield_raids1"), xPositionHero, 450 + Raids.BOPPING_OFFSET, 150, 150);
        _fighting_hero_canvas_context_raids.drawImage(Cache.getImage("images/hero_weapon_" + Items.getItemString('weapon_team1')+".png","hero_fighting_weapon_raids1"), xPositionHero, 450 + Raids.BOPPING_OFFSET, 150, 150);
      } else {
        _fighting_hero_canvas_context_raids.drawImage(Cache.getImage("images/hero_dead.png","hero_dead"), xPositionHero, 450, 150, 150);
      }
      _fighting_hero_canvas_context_raids.globalAlpha = 1.0;
    }
      if(Raids.tick_tracker % 50 == 0) Raids.bopping();
      Raids.track_ticks();
      Raids.manage_hitplats();
    }
  }
}



class RaidsHitSplatOnMonsterPosition {
  static start_x = 400;
  static start_y = 400;

  static changeHitSplatPosition(monsterName) {
    console.log(monsterName)
    switch(monsterName) {
      case "undead_chicken":
        RaidsHitSplatOnMonsterPosition.start_x = 611;
        RaidsHitSplatOnMonsterPosition.start_y = 393;
      break;
      case "undead_chicken_mad":
        RaidsHitSplatOnMonsterPosition.start_x = 611;
        RaidsHitSplatOnMonsterPosition.start_y = 393;
      break;
      case "undead_skeleton_zombie":
        RaidsHitSplatOnMonsterPosition.start_x = 600;
        RaidsHitSplatOnMonsterPosition.start_y = 400;
      break;
      case "undead_spiked_skeleton":
        RaidsHitSplatOnMonsterPosition.start_x = 500;
        RaidsHitSplatOnMonsterPosition.start_y = 300;
      break;
      default:
        RaidsHitSplatOnMonsterPosition.start_x = 400;
        RaidsHitSplatOnMonsterPosition.start_y = 400;
      break;
    }
  }

}

class RaidsHitSplatOnMonster {
  constructor(label, icon, label_color, background_color, border_color, start_x, start_y) 
    {
        this.label = label;
        this.icon = icon;
        this.label_color = label_color;
        this.background_color = background_color;
        this.border_color = border_color;

        this.start_x = parseFloat(start_x);
        this.start_y = parseFloat(start_y);
        this.offset_x = 0 - Math.random() + Math.random();
        this.offset_y = 0 - Math.random() + Math.random();
        //this.offset_x = 0; // no diversions for now.
        //this.offset_y = 0; // no diversions for now.
    }

    draw(ctx)
    {
        ctx.font = "30px pixel";
        var hit_splat_width = 100;
        var hit_splat_height = 50;

        //DEPRECATED
        // if(this.label.length > 2)
        //     hit_splat_width = 150;
    
        // if(this.label == "BLOCKED" || this.label == "MISSED")
        //     hit_splat_width = 200;

        // if(this.label == "Can't reach!")
        //     hit_splat_width = 260;

        
        if(this.label.length >= 4)
        {
            // this.start_x = 40;
            // this.offset_x = -0.5;
            // this.offset_y = 0;
        }

        

        if(this.label.length > 0) {
          hit_splat_width = ctx.measureText(this.label).width
          hit_splat_width += 70
        } else {
          hit_splat_width = 50;
        }

        if(this.background_color.length > 0) {
          ctx.strokeStyle = "black";
          ctx.beginPath();
          ctx.rect(this.start_x,this.start_y,hit_splat_width,hit_splat_height);
          ctx.stroke();
          ctx.fillStyle = this.background_color;
          ctx.fillRect(this.start_x,this.start_y,hit_splat_width,hit_splat_height);
        }
        ctx.drawImage(Cache.getImage(this.icon, "hitsplat_" + this.icon), this.start_x, this.start_y);
        ctx.font = "30px pixel";
        ctx.fillStyle = this.label_color;
        ctx.fillText(this.label, this.start_x + 60, this.start_y + 35);
        this.start_x += this.offset_x;
        this.start_y += this.offset_y;
        this.start_y-=2;
    }
}

class CanvasAnimationObject {

  // Raids.addCanvasAnimationObject("images/projectile_1.png", 545, 358, 40, 500, 1000)
  // Raids.addCanvasAnimationObject("images/projectile_1.png", 545, 358, 40, 350, 1000)
  // Raids.addCanvasAnimationObject("images/projectile_1.png", 545, 358, 40, 200, 1000)
  // Raids.addCanvasAnimationObject("images/projectile_1.png", 545, 358, 40, 50, 1000)


  constructor(path, start_x, start_y, end_x, end_y, timeMS) {
    this.path = path;
    this.start_x = parseInt(start_x);
    this.start_y = parseInt(start_y);
    this.end_x = parseInt(end_x);
    this.end_y = parseInt(end_y);
    this.timeMS = parseInt(timeMS);

    this.at_x = this.start_x;
    this.at_y = this.start_y;

    var diff_x = Math.abs(this.start_x - this.end_x);
    var diff_y = Math.abs(this.start_y - this.end_y);

    this.increment_x = diff_x / 60 / (timeMS/1000);
    this.increment_y = diff_y / 60 / (timeMS/1000);

    this.x_orientation = -1;
    this.y_orientation = 1;
    if(this.start_y > this.end_y) {
      this.y_orientation = -1;
    }
  }

  draw(ctx)
  {
    this.at_x += this.increment_x * this.x_orientation;
    this.at_y += this.increment_y * this.y_orientation;

    ctx.drawImage(
      Cache.getImage(
        this.path,
        this.path,
      ), 
      this.at_x,
      this.at_y,
    );
  }
}

class RaidsHitSplat
{
    constructor(label, icon, label_color, background_color, border_color, start_x, start_y) 
    {
        this.label = label;
        this.icon = icon;
        this.label_color = label_color;
        this.background_color = background_color;
        this.border_color = border_color;

        this.start_x = parseFloat(start_x);
        this.start_y = parseFloat(start_y);
        this.offset_x = 0 - Math.random() + Math.random();
        this.offset_y = 0 - Math.random() + Math.random();
        //this.offset_x = 0; // no diversions for now.
        //this.offset_y = 0; // no diversions for now.
    }

    draw(ctx)
    {
        ctx.font = "20px pixel";
        var hit_splat_width = 60;
        var hit_splat_height = 30;
        hit_splat_width = ctx.measureText(this.label).width
        hit_splat_width += 40

        
        ctx.strokeStyle = "black";
        ctx.beginPath();
        ctx.rect(this.start_x, this.start_y, hit_splat_width, hit_splat_height);
        ctx.stroke();
        ctx.fillStyle = this.background_color;
        ctx.fillRect(this.start_x,this.start_y,hit_splat_width,hit_splat_height);
        ctx.drawImage(Cache.getImage(this.icon, "raids_hitsplat_" + this.icon), this.start_x, this.start_y, 30, 30);
        ctx.font = "20px pixel";
        ctx.fillStyle = this.label_color;
        ctx.fillText(this.label, this.start_x + 35, this.start_y + 22);
        this.start_x += this.offset_x;
        this.start_y += this.offset_y;
        this.start_y-=0.5;
    }
}