class Trophies
{
  static data = [
    {
      'slug': '1b_xp',
      'desc': 'Earn a grand total for 1 billion XP.'
    },
    {
    'slug': 'max_one_skill',
    'desc': 'Obtain level 100 in any skill.'
    },
    {
      'slug': 'max_all_skill',
      'desc': 'Obtain level 100 in all skills.'
    },
    {
      'slug': 'find_all_gems_trophy',
      'desc': 'Find all four gems.'
    },
    {
      'slug': 'all_diamond_tools',
      'desc': 'Upgrade all tools to diamond.',
    },
    {
      'slug': 'plant_all_seeds',
      'desc': 'Plant every seed in the game.'
    },
    {
      'slug': 'chop_all_trees',
      'desc': 'Chop all trees in the game.'
    },
    {
      'slug': '100_kills',
      'desc': 'Kill every area monster 100 times.'
    },
    {
      'slug': '20_guardian_kills',
      'desc': 'Kill all guardians 20 times.'
    },
    {
      'slug': '10b_researcher_points',
      'desc': 'Earn 10 billion researcher points from criptoe.'
    },
    {
      'slug': 'bind_blue_orbs',
      'desc': 'Bind all blue orbs.'
    },
    {
      'slug': 'bind_green_orbs',
      'desc': 'Bind all green orbs.'
    },
    {
      'slug': 'bind_red_orbs',
      'desc': 'Bind all red orbs.'
    },
    {
      'slug': 'all_achievements',
      'desc': 'Complete all achievments.'
    },
    {
      'slug': '25_meals',
      'desc': 'Prepare 25 of each meal from cooks book.'
    },
    {
      'slug': '100_potions',
      'desc': 'brew a total of 100 most potions.'
    },
    {
      'slug': 'assemble_master_ring',
      'desc': 'Assemble the master ring.'
    },
    {
      'slug': 'held_legendary_card_trophy',
      'desc': 'Have a legendary card in your possession.'
    },
    {
      'slug': '100_boats_sent',
      'desc': 'Send each boat 100 times.'
    },
    {
      'slug': 'brewing_mixer_1000',
      'desc': 'Using the brewing XP mixer 1000 times.'
    },
    {
      'slug': 'undead_raid_50',
      'desc': 'Complete the undead raid on hard mode 50 times.'
    },
    {
      'slug': 'mega_planter',
      'desc': 'Plant each mega seed once.'
    },
    {
      'slug': 'master_planter',
      'desc': 'Plant a total of 10,000 seeds.'
    },
    {
      'slug': 'magic_angel_10m',
      'desc': 'Gain an extra 10 million xp using the magic crystal ball.'
    },
  ]

  
  static load_trophies_content() {
    var content = document.getElementById("panel-completionist-content");

    var html = "";
    for(var i = 0; i < Trophies.data.length; i++) {
        var slug = Trophies.data[i]['slug'];
        var desc = Trophies.data[i]['desc'];

         var img_name = "trophy_icon.png";
        if(Items.getItem(slug) == 0)
          img_name = "trophy_icon_dark.png";

        html += "<span class='hover' onclick='Trophies.open_trophie_hint(\""+slug+"\")'>";
        html += "<table class='trophy-content-table'><tr><td><img class='w35' src='https://cdn.idle-pixel.com/images/"+img_name+"' /></td><td>"+desc+"<br/>"+Trophies.get_subtitle(slug)+"</td></tr></table>"
        html += "</span>";
    }

    content.innerHTML = html;
  }

  static get_subtitle(slug) {
    var html = "";
    switch(slug) {
      case "1b_xp":
        html = "<span class='color-grey font-small'>"+format_number(get_global_xp())+" xp</span>";
      break;
    }

    return html;
  }
  
  static open_trophie_hint(slug) {
    var html = "";
    var data = []
    if(slug == "all_diamond_tools") {
      var data = [
        {'item': 'diamond_pickaxe', 'amount': 1, 'image': 'diamond_pickaxe'},
        {'item': 'diamond_hammer', 'amount': 1, 'image': 'diamond_hammer'},
        {'item': 'diamond_rake', 'amount': 1, 'image': 'diamond_rake'},
        {'item': 'diamond_axe', 'amount': 1, 'image': 'diamond_axe'},
        {'item': 'diamond_fishing_net', 'amount': 1, 'image': 'diamond_fishing_net'},
        {'item': 'diamond_fishing_rod', 'amount': 1, 'image': 'diamond_fishing_rod'},
        {'item': 'diamond_harpoon', 'amount': 1, 'image': 'diamond_harpoon'},
        {'item': 'diamond_needle', 'amount': 1, 'image': 'diamond_needle'},
        {'item': 'diamond_brewing_kit', 'amount': 1, 'image': 'diamond_brewing_kit'},
        {'item': 'diamond_chisel', 'amount': 1, 'image': 'diamond_chisel'},
        {'item': 'diamond_watering_can', 'amount': 1, 'image': 'diamond_watering_can'},
        {'item': 'diamond_magnet', 'amount': 1, 'image': 'diamond_magnet'},
        {'item': 'diamond_machete', 'amount': 1, 'image': 'diamond_machete'},
        {'item': 'diamond_trowel', 'amount': 1, 'image': 'diamond_trowel'},
      ]
    }


    if(slug == "plant_all_seeds") {
      var data = [
        {'item': 'dotted_green_leaf_seeds_planted', 'amount': 1, 'image': 'dotted_green_leaf_seeds'},
        {'item': 'stardust_seeds_planted', 'amount': 1, 'image': 'stardust_seeds'},
        {'item': 'green_leaf_seeds_planted', 'amount': 1, 'image': 'green_leaf_seeds'},
        {'item': 'lime_leaf_seeds_planted', 'amount': 1, 'image': 'lime_leaf_seeds'},
        {'item': 'gold_leaf_seeds_planted', 'amount': 1, 'image': 'gold_leaf_seeds'},
        {'item': 'crystal_leaf_seeds_planted', 'amount': 1, 'image': 'crystal_leaf_seeds'},
        {'item': 'red_mushroom_seeds_planted', 'amount': 1, 'image': 'red_mushroom_seeds'},
        {'item': 'tree_seeds_planted', 'amount': 1, 'image': 'tree_seeds'},
        {'item': 'oak_tree_seeds_planted', 'amount': 1, 'image': 'oak_tree_seeds'},
        {'item': 'willow_tree_seeds_planted', 'amount': 1, 'image': 'willow_tree_seeds'},
        {'item': 'apple_tree_seeds_planted', 'amount': 1, 'image': 'apple_tree_seeds'},
        {'item': 'maple_tree_seeds_planted', 'amount': 1, 'image': 'maple_tree_seeds'},
        {'item': 'banana_tree_seeds_planted', 'amount': 1, 'image': 'banana_tree_seeds'},
        {'item': 'stardust_tree_seeds_planted', 'amount': 1, 'image': 'stardust_tree_seeds'},
        {'item': 'orange_tree_seeds_planted', 'amount': 1, 'image': 'orange_tree_seeds'},
        {'item': 'pine_tree_seeds_planted', 'amount': 1, 'image': 'pine_tree_seeds'},
        {'item': 'redwood_tree_seeds_planted', 'amount': 1, 'image': 'redwood_tree_seeds'},
        {'item': 'palm_tree_seeds_planted', 'amount': 1, 'image': 'palm_tree_seeds'},
        {'item': 'dragon_fruit_tree_seeds_planted', 'amount': 1, 'image': 'dragon_fruit_tree_seeds'},
        {'item': 'bone_tree_seeds_planted', 'amount': 1, 'image': 'bone_tree_seeds'},
        {'item': 'lava_tree_seeds_planted', 'amount': 1, 'image': 'lava_tree_seeds'},
        {'item': 'potato_seeds_planted', 'amount': 1, 'image': 'potato_seeds'},
        {'item': 'carrot_seeds_planted', 'amount': 1, 'image': 'carrot_seeds'},
        {'item': 'beet_seeds_planted', 'amount': 1, 'image': 'beet_seeds'},
        {'item': 'broccoli_seeds_planted', 'amount': 1, 'image': 'broccoli_seeds'},
        {'item': 'poppy_flower_seeds_planted', 'amount': 1, 'image': 'poppy_flower_seeds'},
        {'item': 'rose_flower_seeds_planted', 'amount': 1, 'image': 'rose_flower_seeds'},
        {'item': 'tulip_flower_seeds_planted', 'amount': 1, 'image': 'tulip_flower_seeds'},
      ]
    }

    if(slug == "chop_all_trees") {
      var data = [
        {'item': 'tree_chopped', 'amount': 1, 'image': 'woodcutting_tree_4'},
        {'item': 'oak_tree_chopped', 'amount': 1, 'image': 'woodcutting_oak_tree_4'},
        {'item': 'willow_tree_chopped', 'amount': 1, 'image': 'woodcutting_willow_tree_4'},
        {'item': 'apple_tree_chopped', 'amount': 1, 'image': 'woodcutting_apple_tree_4'},
        {'item': 'maple_tree_chopped', 'amount': 1, 'image': 'woodcutting_maple_tree_4'},
        {'item': 'stardust_tree_chopped', 'amount': 1, 'image': 'woodcutting_stardust_tree_4'},
        {'item': 'pine_tree_chopped', 'amount': 1, 'image': 'woodcutting_pine_tree_4'},
        {'item': 'redwood_tree_chopped', 'amount': 1, 'image': 'woodcutting_redwood_tree_4'},
        {'item': 'banana_tree_chopped', 'amount': 1, 'image': 'woodcutting_banana_tree_4'},
        {'item': 'orange_tree_chopped', 'amount': 1, 'image': 'woodcutting_orange_tree_4'},
        {'item': 'palm_tree_chopped', 'amount': 1, 'image': 'woodcutting_palm_tree_4'},
        {'item': 'bone_tree_chopped', 'amount': 1, 'image': 'woodcutting_bone_tree_4'},
        {'item': 'lava_tree_chopped', 'amount': 1, 'image': 'woodcutting_lava_tree_4'},
        {'item': 'strange_tree_chopped', 'amount': 1, 'image': 'woodcutting_strange_tree_4'},
        {'item': 'dragon_fruit_tree_chopped', 'amount': 1, 'image': 'woodcutting_dragon_fruit_tree_4'},
      ]
    }

    if(slug == "100_kills") {
      var data = [
        {'item': 'chicken_kills', 'amount': 100, 'image': 'chicken_icon'},
        {'item': 'rat_kills', 'amount': 100, 'image': 'rat_icon'},
        {'item': 'spider_kills', 'amount': 100, 'image': 'spider_icon'},
        {'item': 'bee_kills', 'amount': 100, 'image': 'bee_icon'},
        {'item': 'lizard_kills', 'amount': 100, 'image': 'lizard_icon'},
        {'item': 'snake_kills', 'amount': 100, 'image': 'snake_icon'},
        {'item': 'ants_kills', 'amount': 100, 'image': 'ants_icon'},
        {'item': 'wolf_kills', 'amount': 100, 'image': 'wolf_icon'},
        {'item': 'thief_kills', 'amount': 100, 'image': 'thief_icon'},
        {'item': 'forest_ent_kills', 'amount': 100, 'image': 'forest_ent_icon'},
        {'item': 'bear_kills', 'amount': 100, 'image': 'bear_icon'},
        {'item': 'goblin_kills', 'amount': 100, 'image': 'goblin_icon'},
        {'item': 'bat_kills', 'amount': 100, 'image': 'bat_icon'},
        {'item': 'skeleton_kills', 'amount': 100, 'image': 'skeleton_icon'},
        {'item': 'fire_hawk_kills', 'amount': 100, 'image': 'fire_hawk_icon'},
        {'item': 'fire_snake_kills', 'amount': 100, 'image': 'fire_snake_icon'},
        {'item': 'fire_golem_kills', 'amount': 100, 'image': 'fire_golem_icon'},
        {'item': 'fire_witch_kills', 'amount': 100, 'image': 'fire_witch_icon'},
        {'item': 'ice_hawk_kills', 'amount': 100, 'image': 'ice_hawk_icon'},
        {'item': 'ice_golem_kills', 'amount': 100, 'image': 'ice_golem_icon'},
        {'item': 'ice_witch_kills', 'amount': 100, 'image': 'ice_witch_icon'},
        {'item': 'yeti_kills', 'amount': 100, 'image': 'yeti_icon'},
        {'item': 'ghost_kills', 'amount': 100, 'image': 'ghost_icon'},
        {'item': 'grandma_kills', 'amount': 100, 'image': 'grandma_icon'},
        {'item': 'exorcist_kills', 'amount': 100, 'image': 'exorcist_icon'},
        {'item': 'reaper_kills', 'amount': 100, 'image': 'reaper_icon'},
        {'item': 'shark_kills', 'amount': 100, 'image': 'shark_icon'},
        {'item': 'sea_soldier_kills', 'amount': 100, 'image': 'sea_soldier_icon'},
        {'item': 'puffer_fish_kills', 'amount': 100, 'image': 'puffer_fish_icon'},
        {'item': 'saltwater_crocodile_kills', 'amount': 100, 'image': 'saltwater_crocodile_icon'},
        {'item': 'blood_chicken_kills', 'amount': 100, 'image': 'blood_chicken_icon'},
        {'item': 'blood_rat_kills', 'amount': 100, 'image': 'blood_rat_icon'},
        {'item': 'blood_spider_kills', 'amount': 100, 'image': 'blood_spider_icon'},
        {'item': 'blood_bee_kills', 'amount': 100, 'image': 'blood_bee_icon'},
        {'item': 'blood_lizard_kills', 'amount': 100, 'image': 'blood_lizard_icon'},
        {'item': 'blood_snake_kills', 'amount': 100, 'image': 'blood_snake_icon'},
        {'item': 'blood_ants_kills', 'amount': 100, 'image': 'blood_ants_icon'},
        {'item': 'blood_wolf_kills', 'amount': 100, 'image': 'blood_wolf_icon'},
        {'item': 'blood_forest_ent_kills', 'amount': 100, 'image': 'blood_forest_ent_icon'},
        {'item': 'blood_thief_kills', 'amount': 100, 'image': 'blood_thief_icon'},
        {'item': 'blood_bear_kills', 'amount': 100, 'image': 'blood_bear_icon'},
        {'item': 'blood_goblin_kills', 'amount': 100, 'image': 'blood_goblin_icon'},
        {'item': 'blood_bat_kills', 'amount': 100, 'image': 'blood_bat_icon'},
        {'item': 'blood_skeleton_kills', 'amount': 100, 'image': 'blood_skeleton_icon'},
        {'item': 'blood_fire_snake_kills', 'amount': 100, 'image': 'blood_fire_snake_icon'},
        {'item': 'blood_fire_hawk_kills', 'amount': 100, 'image': 'blood_fire_hawk_icon'},
        {'item': 'blood_fire_golem_kills', 'amount': 100, 'image': 'blood_fire_golem_icon'},
        {'item': 'blood_fire_witch_kills', 'amount': 100, 'image': 'blood_fire_witch_icon'},
      ]
    }

    if(slug == "20_guardian_kills") {
      var data = [
        {'item': 'guardian_one_kills', 'amount': 20, 'image': 'green_gaurdian_key'},
        {'item': 'guardian_two_kills', 'amount': 20, 'image': 'blue_gaurdian_key'},
        {'item': 'guardian_three_kills', 'amount': 20, 'image': 'purple_gaurdian_key'},
        {'item': 'guardian_four_kills', 'amount': 20, 'image': 'mixed_gaurdian_key'},
      ]
    }

    if(slug == "bind_blue_orbs") {
      var data = [
        {'item': 'blue_pickaxe_orb_absorbed', 'amount': 1, 'image': 'blue_pickaxe_orb'},
        {'item': 'blue_hammer_orb_absorbed', 'amount': 1, 'image': 'blue_hammer_orb'},
        {'item': 'blue_woodcutting_orb_absorbed', 'amount': 1, 'image': 'blue_woodcutting_orb'},
        {'item': 'blue_oil_storage_orb_absorbed', 'amount': 1, 'image': 'blue_oil_storage_orb'},
        {'item': 'blue_oil_well_orb_absorbed', 'amount': 1, 'image': 'blue_oil_well_orb'},
        {'item': 'blue_farming_orb_absorbed', 'amount': 1, 'image': 'blue_farming_orb'},
        {'item': 'blue_breeding_anti_sickness_orb_absorbed', 'amount': 1, 'image': 'blue_breeding_anti_sickness_orb'},
      ]
    }

    if(slug == "bind_green_orbs") {
      var data = [
        {'item': 'green_arrow_orb_absorbed', 'amount': 1, 'image': 'green_arrow_orb'},
        {'item': 'green_boat_orb_absorbed', 'amount': 1, 'image': 'green_boat_orb'},
        {'item': 'green_bone_orb_absorbed', 'amount': 1, 'image': 'green_bone_orb'},
        {'item': 'green_charcoal_orb_absorbed', 'amount': 1, 'image': 'green_charcoal_orb'},
        {'item': 'green_log_orb_absorbed', 'amount': 1, 'image': 'green_log_orb'},
      ]
    }

    

    if(slug == "magic_angel_10m") {
      var data = [
        {'item': 'crystal_ball_xp_total', 'amount': 10000000, 'image': 'magic'},
      ]
    }

    if(slug == "bind_red_orbs") {
      var data = [
        {'item': 'red_farming_orb_absorbed', 'amount': 1, 'image': 'red_farming_orb'},
        {'item': 'red_woodcutting_orb_absorbed', 'amount': 1, 'image': 'red_woodcutting_orb'},
        {'item': 'red_combat_orb_absorbed', 'amount': 1, 'image': 'red_combat_orb'},
        {'item': 'red_oil_factory_orb_absorbed', 'amount': 1, 'image': 'red_oil_factory_orb'},
        {'item': 'red_stardust_watch_orb_absorbed', 'amount': 1, 'image': 'red_stardust_watch_orb'},
        {'item': 'red_criptoe_orb_absorbed', 'amount': 1, 'image': 'red_criptoe_orb'},
      ]
    }

    if(slug == "25_meals") {
      var data = [
        {'item': 'dotted_salad_prepared_total', 'amount': 25, 'image': 'dotted_salad'},
        {'item': 'chocolate_cake_prepared_total', 'amount': 25, 'image': 'chocolate_cake'},
        {'item': 'lime_leaf_salad_prepared_total', 'amount': 25, 'image': 'lime_leaf_salad'},
        {'item': 'golden_apple_prepared_total', 'amount': 25, 'image': 'golden_apple'},
        {'item': 'banana_jello_prepared_total', 'amount': 25, 'image': 'banana_jello'},
        {'item': 'orange_pie_prepared_total', 'amount': 25, 'image': 'orange_pie'},
        {'item': 'pancakes_prepared_total', 'amount': 25, 'image': 'pancakes'},
        {'item': 'coconut_stew_prepared_total', 'amount': 25, 'image': 'coconut_stew'},
        {'item': 'dragon_fruit_salad_prepared_total', 'amount': 25, 'image': 'dragon_fruit_salad'},
        {'item': 'potato_shake_prepared_total', 'amount': 25, 'image': 'potato_shake'},
        {'item': 'carrot_shake_prepared_total', 'amount': 25, 'image': 'carrot_shake'},
        {'item': 'beet_shake_prepared_total', 'amount': 25, 'image': 'beet_shake'},
        {'item': 'broccoli_shake_prepared_total', 'amount': 25, 'image': 'broccoli_shake'},
      ]
    }

    if(slug == "100_boats_sent") {
      var data = [
        {'item': 'row_boat_sent_total', 'amount': 100, 'image': 'row_boat'},
        {'item': 'canoe_boat_sent_total', 'amount': 100, 'image': 'canoe_boat'},
        {'item': 'stardust_boat_sent_total', 'amount': 100, 'image': 'stardust_boat'},
        {'item': 'pirate_ship_sent_total', 'amount': 100, 'image': 'pirate_ship'},
        {'item': 'submarine_boat_sent_total', 'amount': 100, 'image': 'submarine_boat'},
      ]
    }
    
    if(slug == "brewing_mixer_1000") {
      var data = [
        {'item': 'brewing_xp_mixer_activated', 'amount': 1000, 'image': 'stardust_brewing_xp_mixer'},
      ]
    }

    if(slug == "undead_raid_50") {
      var data = [
        {'item': 'raids_mansion_completions_hard', 'amount': 50, 'image': 'double_scythe_sigil_chat'},
      ]
    }

    if(slug == "mega_planter") {
      var data = [
        {'item': 'mega_dotted_green_leaf_seeds_planted', 'amount': 1, 'image': 'mega_dotted_green_leaf_seeds'},
        {'item': 'mega_green_leaf_seeds_planted', 'amount': 1, 'image': 'mega_green_leaf_seeds'},
        {'item': 'mega_lime_leaf_seeds_planted', 'amount': 1, 'image': 'mega_lime_leaf_seeds'},
        {'item': 'mega_gold_leaf_seeds_planted', 'amount': 1, 'image': 'mega_gold_leaf_seeds'},
        {'item': 'mega_crystal_leaf_seeds_planted', 'amount': 1, 'image': 'mega_crystal_leaf_seeds'},
        {'item': 'mega_magic_beans_seeds_planted', 'amount': 1, 'image': 'mega_magic_beans_seeds'},
      ]
    }

    if(slug == "master_planter") {
      var data = [
        {'item': 'total_seeds_planted', 'amount': 10000, 'image': 'mixed_seeds'},
      ]
    }

    

    if(slug == "100_potions") {
      var data = [
        {'item': 'stardust_potion_total', 'amount': 100, 'image': 'stardust_potion'},
        {'item': 'energy_potion_total', 'amount': 100, 'image': 'energy_potion'},
        {'item': 'anti_disease_potion_total', 'amount': 100, 'image': 'anti_disease_potion'},
        {'item': 'tree_speed_potion_total', 'amount': 100, 'image': 'tree_speed_potion'},
        {'item': 'smelting_upgrade_potion_total', 'amount': 100, 'image': 'smelting_upgrade_potion'},
        {'item': 'great_stardust_potion_total', 'amount': 100, 'image': 'great_stardust_potion'},
        {'item': 'farming_speed_potion_total', 'amount': 100, 'image': 'farming_speed_potion'},
        {'item': 'rare_monster_potion_total', 'amount': 100, 'image': 'rare_monster_potion'},
        {'item': 'super_stardust_potion_total', 'amount': 100, 'image': 'super_stardust_potion'},
        {'item': 'gathering_unique_potion_total', 'amount': 100, 'image': 'gathering_unique_potion'},
        {'item': 'heat_potion_total', 'amount': 100, 'image': 'heat_potion'},
        {'item': 'bait_potion_total', 'amount': 100, 'image': 'bait_potion'},
        {'item': 'furnace_speed_potion_total', 'amount': 100, 'image': 'furnace_speed_potion'},
        {'item': 'promethium_potion_total', 'amount': 100, 'image': 'promethium_potion'},
        {'item': 'super_rare_monster_potion_total', 'amount': 100, 'image': 'super_rare_monster_potion'},
        {'item': 'ultra_stardust_potion_total', 'amount': 100, 'image': 'ultra_stardust_potion'},
        {'item': 'magic_shiny_crystal_ball_potion_total', 'amount': 100, 'image': 'magic_shiny_crystal_ball_potion'},
        {'item': 'birdhouse_potion_total', 'amount': 100, 'image': 'birdhouse_potion'},
        {'item': 'rocket_potion_total', 'amount': 100, 'image': 'rocket_potion'},
        {'item': 'titanium_potion_total', 'amount': 100, 'image': 'titanium_potion'},
        {'item': 'geode_potion_total', 'amount': 100, 'image': 'geode_potion'},
        {'item': 'magic_crystal_ball_potion_total', 'amount': 100, 'image': 'magic_crystal_ball_potion'},
        {'item': 'stone_converter_potion_total', 'amount': 100, 'image': 'stone_converter_potion'},
        {'item': 'rain_potion_total', 'amount': 100, 'image': 'rain_potion'},
        {'item': 'ancient_potion_total', 'amount': 100, 'image': 'ancient_potion'},
      ]
    }

    if(data.length == 0) {
      Modals.open_image_modal("TROPHY PROGRESS", "images/trophy_icon.png", "<i class='color-grey'>Nothing important to show here, try another one.</i>", null, "Cancel", null);
      return;
    } 
    

    html += "<center><table class='trophy-table'>";
    html += "<tr>";
      html += "<th><center>Entity</center></th>";
      html += "<th><center>Amount Req</center></th>";
      html += "<th><center>Completed</center></th>";
    html += "</tr>";
      for(var i = 0; i < data.length; i++) {
        html += "<tr>";
        var item = data[i]['item'];
        var amount = data[i]['amount'];
        var image = data[i]['image'];

        html += "<td>";
          html += "<center><img class='w35' src='https://cdn.idle-pixel.com/images/"+image+".png'></center>";
        html += "</td>";
        html += "<td>";
          html += "<center>" + format_number(Items.getItem(item)) + "/" + format_number(amount) + "</center>";
        html += "</td>";

        if(Items.getItem(item) >= amount) {
          html += "<td>";
            html += '<center><img class="w20" src="https://cdn.idle-pixel.com/images/check.png"></center>'
          html += "</td>";
        } else {
          html += "<td>";
            html += '<center><img class="w20" src="https://cdn.idle-pixel.com/images/x.png"></center>'
          html += "</td>";
        }
        html += "</tr>";
      }
      html += "</table></center>";

      Modals.open_image_modal("TROPHY PROGRESS", "images/trophy_icon.png", html, null, "Cancel", null);
  }



}