class WebSockeManager
{

    close()
    {
        this.connected_socket.close();
    }

    constructor() {
        this.connectionAttempts = 3;
    }

    
    connect()
    {   
        this.connected_socket = new WebSocket(websocket_url)

        
        try
	    {
            this.connected_socket.onopen = function(event)
            {
                websocket.send("LOGIN=" + signature)
            }

            this.connected_socket.onclose = function(event)
            {
                
            }

            this.connected_socket.onerror = function(event)
            {
                Modals.open_image_modal('Server Offline','images/server.png', 'Game is offline.  Try to login again in a minute.', null, "Close", null)
            }

            this.connected_socket.onmessage = function(event)
            {
               
                var data = event.data;

                var key = data;
                var values = null;
                var values_array = null;

                if(data.includes("="))
                {
                    var data_array = data.split("=");
                    key = data_array[0];
                    values = data.substring(data.indexOf('=')+1)

                    if(values.includes("~"))
                    {
                        values_array = values.split("~");
                    }
                }

                switch(key)
                {
                    case "INVALID_SERVER_ID":
                        Modals.open_image_modal('Error Fetching Account','images/x.png', 'There was a problem with the login server.  Please contact the Administrator (Smitty)', null, "Close", null)
                    break;
                    case "PING_ECHO":
                        var diff = Date.now() - Globals.ping;
                        document.getElementById("ping-label").innerHTML = parseInt(diff);
                    break;
                    case "VALID_LOGIN":
                    case "VALID_LOGIN_TOKEN":
                        show_element("game-screen");
                        show_element("game-chat");
                        remove_class("body", "background-primary-gradient");
                        add_class("body", "background-game");
                        setInterval(loop, 1000);
                        //load_woodcutting_tooltips();

                        if(Achievements.has_completed_set("cooking", "medium")) 
                            load_fruit_bonus_energy_from_medium_ach();


                        for (const [key, value] of Object.entries(server_config)) {
                            if(value["domain"] == websocket_url)
                            {
                                document.getElementById("playing-on-server-label-settings").innerHTML = key.toUpperCase();
                                break;
                            }
                        } 

                        if(Items.getItem("keyitems_section_unlocked") == 0) {
                            switch_panels('panel-mining')
                        }

                        if(localStorage.getItem("hide_left_menu_bar") != null) {
                            Animations.toggle_collapse_menu_bar();
                        }
                        
                    break;
                    case "RAIDS_TIMER":
                        Raids.timer = values;
                    break;
                    case "MARKET_HISTORY_MODAL":
                        Market.history(values)
                    break;
                    case "RAIDS_SKELETON_ZOMBIES_AMOUNT":
                        RaidsUndeadSkeletonZombie.skeletonsToDraw = parseInt(values)
                    break;
                    case "UNDEAD_ZOMBIE_FLYING_ON":
                        RaidsUndeadZombie.flying = true;
                    break;
                    case "RAIDS_RESET_CLASS_VARS":
                        Raids.resetMonsterVariables();
                    break;
                    case "UNDEAD_SPIKED_SKELETON_TURN":
                        console.log(values)
                        if(values == "0") {
                            RaidsSpikedSkeleton.chargingProjectileFlag = false;
                        } else {
                            RaidsSpikedSkeleton.chargingProjectileFlag = true;
                        }
                    break;
                    case "RAIDS_MONSTER_FIGHTING_CURRENTLY":
                        Raids.currentMonster = values;
                        RaidsHitSplatOnMonsterPosition.changeHitSplatPosition(values);
                    break;
                    case "EVENT_GLOBAL_PROGRESS":
                        if(Items.getItem('event_name') == 'SEED_PILES') {
                            EventsSeedPiles.refreshGlobalList(values);
                        }
                        else if(Items.getItem('event_name') == 'YETI_BOSS') { 
                            EventsYetiBoss.refreshGlobalList(values);
                        }
                    break;
                    case "YETI_BOSS_EVENT_PLAYER_HIT_SPLAT":
                        EventsYetiBoss.hitSplatFromPlayterToMonster(values_array[0], values_array[1]);
                    break;
                    case "REFRESH_TCG":
                        CToe.loadCards(values)
                    break;
                    case "CONFIGURE_CHARACTER_ON":
                        set_default_cahracter_screen(true);
                        remove_modal_dropback();
                        document.getElementById("create-your-hero-title").innerHTML = values;
                    break;
                    case "CONFIGURE_CHARACTER_OFF":
                        set_default_cahracter_screen(false);
                    break;
                    case "TEAMS_TRADABLES_MODAL":
                        Modals.open_team_tradables(values);
                    break;
                    case "TEAMS_USER_LIST":
                        refresh_teams_panel_users(values);
                    break;
                    case "TEAMS_ADD_LOGGER":
                        append_team_storage_logger(values)
                    break;
                    case "RAIDS_INVIS_SPELL_CASTED":
                        Raids.invisSpellCasted(values)
                    break;
                    case "TEAMS_STORAGE_DATA":
                        Modals.refreshTeamStorageData(values)
                    break;
                    // case "CUSTOM":
                    //     Anwinity's command
                    //     console.log(data)
                    // break;
                    case "VALID_LOGIN_TOKEN_FAILED":
                        Modals.toggle("modal-image-text");
                        localStorage.removeItem("DHP_TOKEN");
                    break;
                    case "SET_ITEMS":
                        Items.load(values);
                        
                        if(Globals.currentPanel != "panel-combat-canvas")
                        {
                            Items.refreshDisplays();
                            Items.refreshItemBoxes();
                        }
                    break;
                    case "ENTER_RAIDS_FIGHT_PANEL":
                        switch_panels('panel-combat-canvas-raids')
                    break;
                   
                    case "MARKET_BAN_DATE":
                        document.getElementById('market-banned-message').style.display = "";
                        document.getElementById('market-banned-message-date').innerHTML = values;
                    break;

                    case "RAIDS_PROJECILE":
                        Raids.addCanvasAnimationObject(
                            values_array[0],
                            values_array[1],
                            values_array[2],
                            values_array[3],
                            values_array[4],
                            values_array[5],
                        );
                    break;

                    case "REFRESH_RAIDS_MAGIC_SPELLS_ICONS_TEAM_MEMBER1":
                        Raids.refreshSpellIconsForTeamMember(1, values)
                    break;
                    case "REFRESH_RAIDS_MAGIC_SPELLS_ICONS_TEAM_MEMBER2":
                        Raids.refreshSpellIconsForTeamMember(2, values)
                    break;
                    case "REFRESH_RAIDS_MAGIC_SPELLS_ICONS_TEAM_MEMBER3":
                        Raids.refreshSpellIconsForTeamMember(3, values)
                    break;
                    case "REFRESH_RAIDS_MAGIC_SPELLS_ICONS_TEAM_MEMBER4":
                        Raids.refreshSpellIconsForTeamMember(4, values)
                    break;

                    case "REFRESH_RAIDS_POTIONS_ICONS_TEAM_MEMBER1":
                        Raids.refreshPotionIconsForTeamMember(1, values)
                    break;
                    case "REFRESH_RAIDS_POTIONS_ICONS_TEAM_MEMBER2":
                        Raids.refreshPotionIconsForTeamMember(2, values)
                    break;
                    case "REFRESH_RAIDS_POTIONS_ICONS_TEAM_MEMBER3":
                        Raids.refreshPotionIconsForTeamMember(3, values)
                    break;
                    case "REFRESH_RAIDS_POTIONS_ICONS_TEAM_MEMBER4":
                        Raids.refreshPotionIconsForTeamMember(4, values)
                    break;

                    case "UNDEAD_ROAMING_GHOST_CHARGE":
                        if(values == "1") {
                            RaidsUndeadRoamingGhost.charging = true;
                        } else {
                            RaidsUndeadRoamingGhost.charging = false;
                        }
                    break;

                    case "MARKET_WARNING_DATE":
                        document.getElementById('market-warning-message').style.display = "";
                        document.getElementById('market-warning-message-date').innerHTML = values;
                    break;
                    case "SET_LOCAL_STORAGE":
                        localStorage.setItem(values_array[0], values_array[1]);
                    break;
                    case "REMOVE_LOCAL_STORAGE":
                        localStorage.removeItem(values);
                    break;
                    case "OPEN_TIME_WARP_CHEMIST_MODAL":
                        Modals.open_time_warp_chemist_quest_modal();
                    break;
                    case "ENCHANTED_BIRDHOUSE_POOP":
                        Modals.toggle('modal-bird-poop')
                    break;
                    case "SWITCH_TABS":
                        switch_panels(values);
                    break;
                    case "RAIDS_TEAM_INFO":
                        Raids.refresh_raids_team_info(values_array)
                    break;
                    case "RAIDS_TEAM_INFO_DESTROYED":
                        Raids.reset_team()
                    break;
                    case "SHOW_TOAST":
                        //show_toast(values_array[0], values_array[1])
                        Animations.scrollText("none", "green", values_array[1]);
                    break;
                    case "ANIMATION_XP_FADEIN_MENU_BAR":
                        show_xp_gained_left_menu_bar(values_array[0], values_array[1]);
                    break;
                    case "SHOW_SPLASH":
                        //show_splash(values_array[0], values_array[1], values_array[2] == "true", values_array[3] == "true");
                    break;
                    case "OPEN_ROCKET_DIALOGUE":
                        Modals.open_send_rocket_dialogue(values_array[0], values_array[1]);
                    break;
                    case "SPELL_CASTED_ANIMATION":
                        var magic_image_element = document.getElementById("image-"+values+"_spell_icon");
                        magic_image_element.classList.add('shake');
                        setTimeout(function() {
                            magic_image_element.classList.remove('shake');
                        }, 500)
                    break;
                    case "LEAVE_RAIDS_COMBAT_TAB":
                        switch_panels('panel-combat');
                    break;
                    case "ANIMATE_LEVEL_100":
                        Animations.level_100_animation()
                    break;
                    case "ANIMATE_MINING_UNLOCKED":
                        Animations.unlock_mining()
                    break;
                    case "ANIMATE_FARADOX_LAST_PANEL":
                        Animations.animateFaradoxLastPanel();
                    break;
                    case "ANIMATE_UNLOCK_SKILL_MELEE":
                        Animations.unlock_melee()
                    break;
                    case "ANIMATE_UNLOCK_SKILL_ARCHERY":
                        Animations.unlock_archery()
                    break;
                    case "ANIMATE_UNLOCK_SKILL_MAGIC":
                        Animations.unlock_magic()
                    break;
                    
                    case "SCROLL_TOAST":
                        show_toast("MESSAGE", values_array[2])
                        Animations.scrollText(values_array[0], values_array[1], values_array[2]);
                    break;
                    case "SCROLL_TOAST_DELAY":
                        setTimeout(function() {
                            show_toast("MESSAGE", values_array[2])
                            Animations.scrollText(values_array[0], values_array[1], values_array[2]);
                        }, 1000)
                       
                    break;
                    case "SET_COUNTRY":
                        set_country(values);
                    break;
                    case "REVERT_UNDEAD_STAFF":
                        Modals.toggle("modal-revert-undead-staff");
                    break;
                    case "REFRESH_MENU_SKILL_LEVELS":
                        refresh_skill_levels_menu_bar(values);
                    break;
                    case "CASTLE_TRIGGER":
                        Castle.open_quiz(values)
                    break;
                    case "REFRESH_FRUIT_ENERGY_TOOLTIPS":
                        load_fruit_bonus_energy_from_medium_ach();
                    break;
                    case "TOGGLE_DIALOGUE":
                        Modals.toggle_dialogue(values);
                    break;
                    case "OPEN_DIALOGUE_CALLBACK":
                        var values_array_temp = data.split("=");
                        values_array_temp.shift();
                        var values_array = values_array_temp.join("=").split("`")
                        Modals.open_image_modal(values_array[0], values_array[1], values_array[2], values_array[3], "Close", values_array[4]);
                    break;
                    case "OPEN_DIALOGUE":
                        Modals.open_image_modal(values_array[0], values_array[1], values_array[2], null, "Close", null, values_array[3] == "true");
                    break;
                    case "OPEN_DIALOGUE_NO_COMBAT":
                        if(Items.getItemString('monster_name') == "none")
                            Modals.open_image_modal(values_array[0], values_array[1], values_array[2], null, "Close", null, false);
                    break;
                    case "OPEN_TEXT_DIALOGUE":
                        Modals.open_image_modal(values_array[0], null, values_array[1], null, "Close", null, values_array[2] == "true");
                    break;
                    case "OPEN_DIALOGUE_DELAY":
                        setTimeout(
                            function() {
                                Modals.open_image_modal(values_array[0], values_array[1], values_array[2], null, "Close", null, values_array[3] == "true");
                            }, values_array[4]
                        )
                    break;
                    case "SHAKE_COINS":
                        Animations.animate_spending_coins()
                    break;
                    case "REFRESH_BREWING_HTML_TABLE":
                        setTimeout(
                            function() {
                                Brewing.refresh_table(document.getElementById("brewing-table"));
                            }, 1200
                        )
                    break;
                    case "REFRESH_CRAFTING_HTML_TABLE":
                        setTimeout(
                            function() {
                                Crafting.refresh_table(document.getElementById('crafting-table'));
                            }, 1200
                        )
                        setTimeout(
                            function() {
                                Crafting.refresh_data_craft_icon_shortcuts();
                            }, 1200
                        )
                    break;
                    case "SHOW_CONVERT_GUEST_BUTTON":
                        document.getElementById("guest-account-top-bar").style.display = "";
                        document.getElementById("guest-account-top-bar").href = "../../convert-guest-account?guest_token=" + values;
                    break;
                    case "CLOSE_QUEST_DIALOGUE":
                        Modals.close_quest_dialogue();
                    break;
                    case "SET_GATHERING_SPEED_4000":
                        Gathering.progresss_bar_time_ms = 4000;
                    break;
                    case "SHOW_BLOODLAB_MODAL":
                        Modals.showBloodLab();
                    break;
                    case "TRAIN_COMBAT_NETWORK_CHOOSE":
                        Modals.train_combat_network_unlock()
                    break;
                    case "TSUNAMI_ANIMATE":
                        Animations.tsunami_animation();
                    break;
                    case "ACTIVITY_LOG":
                        ActivityLogger.add_to_console(values_array[0], values_array[1]);
                    break;
                    case "CRYSTAL_BALL_ANGEL_COMBAT":
                        Monsters.angel_crystal_activated = true;
                        setTimeout(function() {
                            Monsters.angel_crystal_activated = false;
                        }, 1000);
                    break;
                    case "OPEN_QUEST_DIALOGUE":
                        
                        var values_array_temp = data.split("=");
                        values_array_temp.shift();
                        var values_array = values_array_temp.join("=").split("`")
                        Modals.open_quest_dialogue(
                            values_array[0],
                            values_array[1],
                            values_array[2],
                            values_array[3],
                            values_array[4],
                            values_array[5],
                            values_array[6],
                            values_array[7],
                            values_array[8],
                            values_array[9],
                            values_array[10],
                            values_array[11] == "true",
                        )
                    break;
                    case "QUEST_COMPLETE":
                        var quest_name = Items.get_pretty_item_name(values);
                        Modals.open_quest_compeleted_dialogue(values, quest_name);
                    break;
                    case "STARDUST_UNLOCKED_ANIMATION":
                        Animations.unlock_stardust();
                    break;
                    case "UNLOCK_FARADOX_CASTLE":
                        Animations.unlock_faradox_castle();
                    break;
                    case "CRYSTALS_UNOCKED_ANIMATION":
                        Animations.unlock_crystals();
                    break;
                    case "CRYSTALS_UNOCKED_ANIMATION_FINAL":
                        Animations.unlock_crystals_final();
                    break;
                    case "CRYSTALS_UNOCKED_ANIMATION_FINAL_2":
                        Animations.unlock_crystals_final_2();
                    break;
                    case "CRYSTALS_UNOCKED_ANIMATION_FINAL_3":
                        Animations.unlock_crystals_final_3();
                    break;
                    case "SWITCH_TO_COMBAT_FIGHTING_TAB":
                        Castle.exit();
                    break;
                    case "CRYSTALS_UNOCKED_ANIMATION_FINAL_4":
                        Animations.unlock_crystals_final_4();
                    break;
                    case "ALL_CRYSTALS_UNOCKED":
                        $("#faradox-huge-image").fadeIn(3000, function() { $("#faradox-huge-image").fadeOut(1000)});
                    break;
                    case "ALL_CRYSTALS_UNOCKED":
                        $("#faradox-huge-image").fadeIn(3000, function() { $("#faradox-huge-image").fadeOut(1000)});
                    break;
                    case "GIVE_CRYSTALS":
                        Animations.give_crystals_wizard();
                    break;
                    case "ALL_CRYSTALS_UNOCKED":
                        switch_panels('panel-keyitems')
                    break;
                    case "ENERGY_UNLOCKED_ANIMATION":
                        Animations.unlock_energy();
                    break;
                    case "UPDATE_TIMER":
                        if(values > 0)
                        {
                            show_element("notification-update-timer")
                            document.getElementById('notification-update-timer-value').innerHTML = values;
                            show_element("notification-update-timer-2")
                           
                        }
                       
                    break;
                    case "ACHIEVEMENT_UNLOCKED_ANIMATION":
                        Animations.unlock_achievements();
                    break;
                    case "REFRESH_FARMING_PANEL":
                        Farming.refresh();
                    break;
                    case "YELL":
                        Chat.yell_to_chat_box(values);
                    break;
                    case "FRIENDS_LIST":
                        Chat.refresh_friends_list(values);
                    break;
                    case "REFRESH_PENGUIN_TICKETS":
                        Modals.refresh_penguin_tickets_data(values);
                    break;
                    case "JUNK_PLANET_COORDS_MODAL":
                        Modals.open_junk_planet_coordinates_modal();
                    break;
                    case "CHAT":
                        Chat.add_to_chat_box(values);
                    break; 
                    case "OPEN_MONSTER_LOOT_DIALOGUE":
                        Monsters.open_info_dialogue(values)
                    break;
                    case "SHOW_OPTION_QUESTS_ARROW":
                        document.getElementById("side-quest-arrow-img").style.display = "";
                    break;
                    case "SEND_CRITS_FOR_ALL_LABEL":
                        Raids.critsPotionActiveBy = values;
                    break;
                    case "OPEN_LOOT_DIALOGUE":
                        var images = [];
                        var labels = [];
                        var background = [];
                        var extra_data = values_array[0];
                        var levelups_data = values_array[1];
                        for(var i = 2; i < values_array.length; i+=0)
                        {
                            images.push(values_array[i]);
                            i++;
                            labels.push(values_array[i]);
                            i++;
                            background.push(values_array[i]);
                            i++;
                        }

                        Modals.open_loot_dialogue(images, labels, background, extra_data, levelups_data);
                    break;
                    case "UNDEAD_LEADER_STATUS":
                        RaidsUndeadLeader.status = values;
                    break;
                    case "REFRESH_BREWING_ACTIVE_POTIONS_NOTIFICATION_1S":
                        setInterval(Activities.refreshBewingNoPotionsActiveTicks, 1500);
                    break;
                    case "REFRESH_RAID_STATS_MONSTER_LABELS":
                        Raids.setMonsterLabels(values_array[0], values_array[1], values_array[2], values_array[3], values_array[4]);
                    break;
                    case "MONSTER_RAIDS_HP_LABELS":
                        Raids.refreshMonsterHpBar(values_array[0], values_array[1])
                    break;
                    case "BABY_BUNNY_CRY":
                        RaidsBabyBunny.crying = true;
                    break;
                    case "HIT_SPLAT_RAID_PLAYER":
                        // delay todo
                        Raids.addHitSplatHero(values_array[0], values_array[1], values_array[2], values_array[3], values_array[4], values_array[5]);
                    break;
                    case "HIT_SPLAT_RAID_MONSTER":
                        // delay todo
                        Raids.addHitSplatMonster(values_array[0], values_array[1], values_array[2], values_array[3], values_array[4], values_array[5]);
                    break;
                    case "UNDEAD_LEADER_SPECIAL_ANIMATION":
                        if(values == "0") {
                            Raids.addCanvasAnimationObject("images/undead_leader_full_death.png", 600, 0, 0, 0, 1000)
                        }
                        if(values == "1" || values == "2" || values == "3" || values == "4") {
                            Raids.addCanvasAnimationObject("images/undead_leader_full_death_"+values+".png", 600, 0, 0, 0, 2000)
                        }
                    break;
                    case "UNDEAD_LEADER_SKELE_HP":
                        RaidsUndeadLeader.skeleton_hp = parseInt(values)
                    break;
                    case "UNDEAD_LEADER_SPECIAL_HEAL_ANIMATION":
                        if(values == "0") {
                            Raids.addCanvasAnimationObject("images/undead_leader_full_heal.png", 600, 0, 0, 0, 1000)
                        }
                        if(values == "1" || values == "2" || values == "3" || values == "4") {
                            Raids.addCanvasAnimationObject("images/undead_leader_full_heal_"+values+".png", 600, 0, 0, 0, 2000)
                        }
                    break;
                    case "UNDEAD_YETI_ICE_HEAL_ATTACK_TRUE":
                        RaidsUndeadYeti.aniamtionIceCubeAttack = 1;
                    break;  
                    case "UNDEAD_YETI_FIRE_ACTIVE":
                        setTimeout(function() {
                            RaidsUndeadYeti.aniamtionIceCubeAttack = 0;
                        }, 2000);
                        RaidsUndeadYeti.aniamtionIceCubeAttackCountered = true;
                        setTimeout(function() {
                            RaidsUndeadYeti.aniamtionIceCubeAttackCountered = false;
                        }, 2000);
                    break;
                    case "HITSPLAT_ON_MONSTER":
                        var delay = parseInt(values_array[5]);
                        if(delay == 0)
                            Fighting.addHitSplatMonster(values_array[0], values_array[1], values_array[2], values_array[3], values_array[4], "monster");
                        else {
                            setTimeout(function(){
                                Fighting.addHitSplatMonster(values_array[0], values_array[1], values_array[2], values_array[3], values_array[4], "monster");
                            }, 1000)
                        }
                    break;
                    case "HITSPLAT_ON_HERO":
                        var delay = parseInt(values_array[5]);
                        if(delay == 0)
                            Fighting.addHitSplatHero(values_array[0], values_array[1], values_array[2], values_array[3], values_array[4], "hero");
                        else {
                                setTimeout(function(){
                                    Fighting.addHitSplatHero(values_array[0], values_array[1], values_array[2], values_array[3], values_array[4], "hero");
                                }, delay)
                            }
                    break;
                    case "LEAVE_COMBAT_TAB":
                        if(Globals.currentPanel == "panel-combat-canvas")
                        {
                            switch_panels("panel-combat");
                        }
                    break;
                    //market stuff below
                    case "MARKET_SELL_ITEM_TRADABLES_MODAL":
                        Market.load_tradables(values);
                        Modals.market_select_tradable_item(true);
                    break;
                    case "MARKET_BROWSE_ITEM_TRADABLES_MODAL":
                        Market.load_tradables(values);
                        Modals.market_select_tradable_item(false);
                    break;
                    case "REFRESH_MARKET_SLOT_DATA":
                        Market.refresh_slots(values);
                    break;
                    case "ANIMAL_REPRODUCED":
                        Breeding.animalReproducedPopup(values);
                    break;
                    case "PLAY_SOUND":
                        Sounds.play(values);
                    break;
                    case "CUTESCENE":
                        Cutscenes.start(values);
                    break;
                    case "OPEN_ODD_ONE_OUT_PUZZLE":
                        Modals.open_odd_one_out_puzzle();
                    break;
                    case "TOY_TEDDY_STATUS":
                        RaidsToyTeddy.status = parseInt(values);
                    break;
                    case "UNDEAD_MANSION_BOSS_TIMER":
                        RaidsUndeadLeader.boss_timer = parseInt(values);
                    break; 
                    case "TOY_BOX_BOSS_TIMER":
                        RaidsToyDwarf.boss_timer = parseInt(values);
                    break;
                    case "EASSTER2024_BOSS_TIMER":
                        RaidsMommyBunny.boss_timer = parseInt(values);
                    break;
                    case "COOKING_RESULTS":
                        Modals.open_cooking_results_dialogue(
                            values_array[0],
                            values_array[1],
                            values_array[2],
                            values_array[3],
                            values_array[4],
                        );
                    break;
                    case "OPEN_MUTE_DIALOGUE":
                        Modals.open_mute_dialogue(values);
                    break;
                    case "ANIMATE_MONSTER_SPRITE":
                        Monsters.animate_sprite(values_array[0], values_array[1] == "true");
                    break;
                    case "ANIMATE_MONSTER_CANVAS":
                        Monsters.animate_canvas(values_array[0], values_array[1], values_array[2]);
                    break;
                    case "ANIMATE_MONSTER_ANIMATION_SPEED":
                        Monsters.animate_animation_speed(values_array[0], values_array[1]);
                    break;
                    case "ANIMATE_LEVEL_UP":
                        Sounds.play(Sounds.VARIABLE_SPLASH_SPECIAL);
                        Animations.level_up_animation(values_array[0], values_array[1]);
                    break;
                    case "ANIMATE_NEW_SKILL":
                        Sounds.play(Sounds.VARIABLE_SPLASH_SPECIAL);
                        Animations.new_skill_animation(values);
                    break;
                    case "EARNED_TROPHY":
                        document.getElementById("top-bar-trophy-icon-arrow").style.display = "";
                        document.getElementById("top-bar-trophy-icon").classList.add('blink')
                        $("#trophy-banner-area").fadeIn(3000, function() {
                            $("#trophy-banner-area").fadeOut(10000, function() {
                                document.getElementById("top-bar-trophy-icon").classList.remove('blink')
                                document.getElementById("top-bar-trophy-icon-arrow").style.display = "none";
                            });
                        })
                    break;
                    
                    case "ANIMATE_ACHIEV":
                        Animations.achievement_perk(values);
                    break;
                    case "RESET_ANIMATE_MONSTER_CANVAS":
                        Monsters.animate_canvas_reset_variables();
                    break;
                    case "COMBAT_LOG":
                        document.getElementById("combat-log-body").innerHTML = values;
                    break;
                    case "SHOW_INSTA_FEED":
                        Modals.show_instagram_popup();
                    break;
                    case "RUN_FUNC":
                        run_function(values);
                    break;
                    case "REDIRECT_LOGIN":
                        window.location.href = '../../../';
                    break;
                    case "ALREADY_CONNECTED":
                        var server_label = "(Unknown)"
                    for (const [key, value] of Object.entries(server_config)) {
                        if(value["domain"] == values)
                        {
                            server_label = key;
                            break;
                        }
                    } 
                        Modals.open_image_modal('ALREADY LOGGED IN','images/warning.png','<b>Account already logged in on:</b> ' + server_label + '<br /><br /><span class="color-grey">Please either:<br /><br />1) Log into the same server as the one shown above<br />2) Logout from the account on the other device before trying again.</span><br /><br /><u style="color:blue;cursor:pointer" onclick="window.location.href = \'../../login\'" />Click here to try again</u>',null,null,null) 
                    break;

                    case "MAX_CAPACITY":
                        Modals.open_image_modal('MAX CAPACITY','images/warning.png','<b>This server has reached its maximum capacity of players!</b><br /><br /><span class="color-grey">Please navigate back to the login page and select a server that has less players in it.</span><br /><br /><u style="color:blue;cursor:pointer" onclick="window.location.href = \'../../login\'" />Click here to select another server</u>',null,null,null) 
                    break;
                }
            }
        }
        catch(err) 
        { 
            console.log(err.message);
        }
    }

    send(message)
    {
        this.connected_socket.send(message);
    }
}