class Woodcutting
{

    static TREE_DATA = {
        "tree": {
            "xp": 1000,
        },
        "oak_tree": {
            "xp": 2000,
        },
        "willow_tree": {
            "xp": 4000,
        },
        "apple_tree": {
            "xp": 4000,
        },
        "maple_tree": {
            "xp": 10000,
        },
        "stardust_tree": {
            "xp": 15000,
        },
        "pine_tree": {
            "xp": 17000,
        },
        "redwood_tree": {
            "xp": 25000,
        },
        "banana_tree": {
            "xp": 12000,
        },
        "orange_tree": {
            "xp": 20000,
        },
        "palm_tree": {
            "xp": 25000,
        },
        "bone_tree": {
            "xp": 28000,
        },
        "lava_tree": {
            "xp": 32000,
        },
        "strange_tree": {
            "xp": 50000,
        },
        "dragon_fruit_tree": {
            "xp": 400000,
        },
        "gloves_oak_tree": {
            "xp": 2000,
        },
        "boots_maple_tree": {
            "xp": 10000,
        },
        "shirt_banana_tree": {
            "xp": 12000,
        },
        "pants_stardust_tree": {
            "xp": 15000,
        },
    }

    static refresh()
    {
        document.getElementById("panel-woodcutting-level").innerHTML = get_level(Items.getItem("woodcutting_xp"), false);
        
        Woodcutting.refresh_patch(1);
        Woodcutting.refresh_patch(2);
        Woodcutting.refresh_patch(3);
        Woodcutting.refresh_patch(4);
        Woodcutting.refresh_patch(5);
    }

    static refresh_patch(patch_id)
    {
        var tree = Items.getItemString("tree_" + patch_id);
        var stage = Items.getItem("tree_stage_" + patch_id);

        if(tree != "none")
        {
            set_image_src("woodcutting-patch-image-" + patch_id, "images/woodcutting_" + tree + "_" + stage + ".png");
        }
        else
        {
            //donor
            if(patch_id == 4 || patch_id == 5)
            {
                if(!DonorShop.has_donor_active(Items.getItem("donor_tree_patches_timestamp")))
                {
                    set_image_src("woodcutting-patch-image-" + patch_id, "images/woodcutting_locked.png");
                }
                else
                {
                    set_image_src("woodcutting-patch-image-" + patch_id, "images/woodcutting_none.png");
                }
            }
            else
                set_image_src("woodcutting-patch-image-" + patch_id, "images/woodcutting_none.png");
        }
        
    }

    static clicksPlot(id)
    {
        websocket.send("CHOP_TREE=" + id);
    }

    
    static refreshTimers(patch_id)
    {
        var time_label = document.getElementById("woodcutting-patch-timer-" + patch_id);
        var time = Items.getItem("tree_timer_"+ patch_id);

        if(time == 0)
            time_label.innerHTML = "";
        else if(time == 1) {
            var tree = Items.getItem("tree_" + patch_id);
            var xpLabel = "";
            if(Woodcutting.TREE_DATA.hasOwnProperty(tree)) {
                var xp = Woodcutting.TREE_DATA[tree]['xp']
                if(DonorShop.has_donor_active(Items.getItem('donor_bonus_xp_timestamp'))) xp *= 1.1;
                xpLabel = "<br /><span class='color-lime font-small'>" + format_number(xp) + " xp</span>"
            }
            time_label.innerHTML = "READY" + xpLabel;
        }
        else {
            var tree = Items.getItem("tree_" + patch_id);
            var xpLabel = "";
            if(Woodcutting.TREE_DATA.hasOwnProperty(tree)) {
                var xp = Woodcutting.TREE_DATA[tree]['xp']
                if(DonorShop.has_donor_active(Items.getItem('donor_bonus_xp_timestamp'))) xp *= 1.1;
                xpLabel = "<br /><span class='color-grey font-small'>" + format_number(xp) + " xp</span>"
            }
            time_label.innerHTML = format_time(time) + xpLabel;
        }
            
    }

    // returns ["current", "next_gem or none", "extra logs"]
    static getAxeToolData()
    {
        if(Items.getItem("diamond_axe"))
            return ["diamond_axe", "none", 20];
        
        if(Items.getItem("ruby_axe"))
            return ["ruby_axe", "diamond", 15];
        
        if(Items.getItem("emerald_axe"))
            return ["emerald_axe", "ruby", 10];
    
        if(Items.getItem("sapphire_axe"))
            return ["sapphire_axe", "emerald", 5];

        if(Items.getItem("axe"))
            return ["axe", "sapphire", 0];

        return ["none", "none", 0];
    }



    static has_tree_fully_grown()
    {
        for(var i = 1; i <= 5; i++)
        {
            if(Items.getItem("tree_stage_" + i) == 4)
            {
                return true;
            }
        }

        return false;
    }

    static getMacheteToolData()
    {
        if(Items.getItem("diamond_machete"))
            return ["diamond_machete", "none"];
        
        if(Items.getItem("ruby_machete"))
            return ["ruby_machete", "diamond"];
        
        if(Items.getItem("emerald_machete"))
            return ["emerald_machete", "ruby"];
    
        if(Items.getItem("sapphire_machete"))
            return ["sapphire_machete", "emerald"];

        if(Items.getItem("machete"))
            return ["machete", "sapphire", 0];

        return ["none", "none", 0];
    }
}