var team_storage_logger = [];

function switch_event_panels() {
    if(Items.getItem('event_name') == 'SEED_PILES') {
        switch_panels('panel-events-seed_piles');
    } 
    else if (Items.getItem('event_name') == 'YETI_BOSS') {
        switch_panels('panel-events-yeti_boss');
    }
}

function switch_panels(id)
{
    Sounds.play(Sounds.VARIABLE_MENU);

    reset_fighting_background();
    Combat.show_left_menu_bar();
    
    if(id == "panel-breeding" && Items.getItem("breeding_unlocked") == 0)
    {
        Modals.open_image_modal("Skill Locked", "images/breeding_chicken_egg.png", "You need to have obtained an animal's egg from combat in order to unlock breeding.<br /><br /><span class='color-grey font-small'>Chickens have a 1/20 chance to drop an egg to unlock this skill.</span>", "Unlock skill", "Cancel", "UNLOCK_BREEDING");
        return;
    }
    
    if(id == "panel-mining" && Items.getItem("mining_unlocked") == 0)
    {
        Modals.open_image_modal("Skill Locked", "images/lock.png", "You have not unlocked this skill yet.");
        return;
    }

    if(id == "panel-crafting" && Items.getItem("crafting_unlocked") == 0)
    {
        Modals.open_image_modal("Skill Locked", "images/crafting_sigil.png", "You need to buy a stone anvil from the shop to unlock this skill.");
        return;
    }

    if(id == "panel-invention" && Items.getItem("invention_unlocked") == 0)
    {

        Modals.open_image_modal("Skill Locked", "images/lock.png", "<b>This elite skill requires every other skill to be at least level 60 to unlock.<br /><br /><span class='color-grey'>Combat skills at level 60 are not required, but is highly recommended</b>", "Unlock Invention!", "Close", "UNLOCK_INVENTION");
        return;
    }

    if(id == "panel-gathering" && Items.getItem("gathering_unlocked") == 0)
    {
        Modals.open_image_modal("Skill Locked", "images/leather_gloves.png", "You can unlock this skill by crafting <b style='color:red'><i>gloves</i></b>.");
        return;
    }

    if(id == "panel-farming" && Items.getItem("farming_unlocked") == 0)
    {
        Modals.open_image_modal("Skill Locked", "images/broken_rake.png", "You need to fix a rake obtained from gathering desert mines to unlock farming.");
        return;
    }

    if(id == "panel-achievements" && Items.getItem("achievements_unlocked") == 0)
    {
        Modals.open_image_modal("Achievements Locked", "images/lock.png", "You have not unlocked achievements yet.");
        return;
    }

    if(id == "panel-brewing" && Items.getItem("brewing_unlocked") == 0)
    {
        Modals.open_image_modal("Skill Locked", "images/quests.png", "You need to complete the quest: Stardust Expert.");
        return;
    }

    if(id == "panel-woodcutting" && Items.getItem("woodcutting_unlocked") == 0)
    {
        Modals.open_image_modal("Skill Locked", "images/axe.png", "You must craft an <b><i style='color:red'>axe</i></b> to unlock woodcutting.");
        return;
    }

    if(id == "panel-cooking" && Items.getItem("cooking_unlocked") == 0)
    {
        Modals.open_image_modal("Skill Locked", "images/bronze_oven.png", "You need to craft a bronze oven to unlock cooking.");
        return;
    }

    if(id == "panel-fishing" && Items.getItem("fishing_unlocked") == 0)
    {
        Modals.open_image_modal("Skill Locked", "images/quests.png", "You must complete the quest: The Fisherman");
        return;
    }

    if(id == "panel-combat" && Items.getItem("melee_unlocked") == 0 && Items.getItem("archery_unlocked") == 0 && Items.getItem("magic_unlocked") == 0)
    {
        Modals.open_image_modal("Skill Locked", "images/lock.png", "Buy any weapon from the shop to unlock.");
        return;
    }

    if(id == "panel-player-market" && Items.getItem("player_market") == 0)
    {
        Modals.open_image_modal("LOCKED", "images/lock.png", "The online player market can be unlocked by purchasing it in the main shop.");
        return;
    }

    if(id == "panel-donor-shop" && Items.getItem("donor_shop") == 0)
    {
        Modals.open_image_modal("LOCKED", "images/lock.png", "The donor shop can be unlocked by purchasing it in the main shop.");
        return;
    }

    if(id == "panel-criptoe-tcg" && Items.getItem('tcg_active') == 0) {
        Modals.open_image_modal("LOCKED", "images/lock.png", "You need to complete the quest: TCG Card Collection for this.");
        return;
    }

    if(id == "panel-criptoe-market" && Items.getItem("criptoe_market") == 0)
    {
        Modals.open_image_modal("LOCKED", "images/lock.png", "The criptoe market can be unlocked by purchasing it in the main shop after crafting community center 4.");
        return;
    }

    if(id == 'panel-referral') {

        if(Items.getItem('referral_program') == 1)
            websocket.send('REFERRAL_PANEL_CLICKED');
    
        calculate_referral_score_ajax(false);
    }
    if(id == "panel-quests")
    {
       if(Items.getItem("doric_the_crafter_quest") == -1 && Items.getItem("the_gem_seeker") == 0)
       {
            if(!Globals.faradox_image_after_dorics_quest_triggered  && Items.getItem("doric_the_crafter_quest") == -1 && Items.getItem("the_gem_seeker_quest") == 0)
            {
                 $("#faradox-huge-image").fadeIn(3000, function() { $("#faradox-huge-image").fadeOut(1000)});
                 Globals.faradox_image_after_dorics_quest_triggered = true;
            }
       }
       
       document.getElementById('story-quest-tab-button-label').innerHTML = Quests.getQuestsDataLabel();
       document.getElementById('optional-quest-tab-button-label').innerHTML = Quests.getOptionalQuestsDataLabel();
       document.getElementById('mini-quest-tab-button-label').innerHTML = Quests.getMiniQuestsData()[2];
       Quests.refreshMiniQuestCheckbox();
    }

    

    if(id == "panel-combat")
        document.getElementById("menu-bar").style.height = "100%";
    else
        document.getElementById("menu-bar").style.height = "";

    document.getElementById("panel-main").style.display = "none";
    document.getElementById("panel-mining").style.display = "none";
    document.getElementById("panel-crafting").style.display = "none";
    document.getElementById("panel-teams").style.display = "none";
    document.getElementById("panel-shop").style.display = "none";
    document.getElementById("panel-donor-shop").style.display = "none";
    document.getElementById("panel-quests").style.display = "none";
    document.getElementById("panel-breeding").style.display = "none";
    document.getElementById("panel-gathering").style.display = "none";
    document.getElementById("panel-keyitems").style.display = "none";
    document.getElementById("panel-farming").style.display = "none";
    document.getElementById("panel-invention").style.display = "none";
    document.getElementById("panel-email").style.display = "none";
    document.getElementById("panel-brewing").style.display = "none";
    document.getElementById("panel-woodcutting").style.display = "none";
    document.getElementById("panel-cooking").style.display = "none";
    document.getElementById("panel-fishing").style.display = "none";
    document.getElementById("panel-history").style.display = "none";
    document.getElementById("panel-events-seed_piles").style.display = "none";
    document.getElementById("panel-criptoe-shop").style.display = "none";
    document.getElementById("panel-criptoe-tcg").style.display = "none";
    document.getElementById("panel-criptoe-research-tree").style.display = "none";
    document.getElementById("panel-mega_tablette").style.display = "none";
    document.getElementById("panel-penguin").style.display = "none";
    document.getElementById("panel-events-yeti_boss").style.display = "none";
    document.getElementById("panel-combat").style.display = "none";
    document.getElementById("panel-combat-canvas").style.display = "none";
    document.getElementById("panel-combat-canvas-raids").style.display = "none";
    document.getElementById("panel-canvas-test").style.display = "none";
    document.getElementById("panel-achievements").style.display = "none";
    document.getElementById("panel-player-market").style.display = "none";
    document.getElementById("panel-player-market-rules").style.display = "none";
    document.getElementById("panel-sockets").style.display = "none";
    document.getElementById("panel-arcade_1").style.display = "none";
    document.getElementById("panel-arcade_2").style.display = "none";
    document.getElementById("panel-combat-log").style.display = "none";
    document.getElementById("panel-settings").style.display = "none";
    document.getElementById("panel-referral").style.display = "none";
    document.getElementById("panel-friends").style.display = "none";
    document.getElementById("panel-sigils").style.display = "none";
    document.getElementById("panel-database").style.display = "none";
    document.getElementById("panel-completionist").style.display = "none";
    document.getElementById("panel-tags").style.display = "none";
    document.getElementById("panel-admin").style.display = "none";
    document.getElementById("panel-criptoe-market").style.display = "none";
    document.getElementById("panel-the-carpenter").style.display = "none";
    document.getElementById("panel-breeding-food-shop").style.display = "none";
    document.getElementById("panel-breeding-animal-shop").style.display = "none";
    document.getElementById("panel-breeding-animal-stats").style.display = "none";
    document.getElementById("panel-breeding-pen-shop").style.display = "none";

    
    document.getElementById(id).style.display = "";
    Globals.currentPanel = id;
    highlight_panel_left(id)

    _panel_switch_action(id);

    Crafting.refresh_data_craft_icon_shortcuts();
}

function highlight_panel_left(id) {

    var ids = [
        "left-panel-item_panel-teams",
        "left-panel-item_panel-keyitems",
        "left-panel-item_panel-mining",
        "left-panel-item_panel-crafting",
        "left-panel-item_panel-gathering",
        "left-panel-item_panel-breeding",
        "left-panel-item_panel-farming",
        "left-panel-item_panel-brewing",
        "left-panel-item_panel-woodcutting",
        "left-panel-item_panel-cooking",
        "left-panel-item_panel-fishing",
        "left-panel-item_panel-invention",
        "left-panel-item_panel-melee",
        "left-panel-item_panel-archery",
        "left-panel-item_panel-magic",
        "left-panel-item_panel-shop",
        "left-panel-item_panel-player-market",
        "left-panel-item_panel-donor-shop",
        "left-panel-item_panel-criptoe-market",
        "left-panel-item_panel-quests",
        "left-panel-item_panel-achievements",
        "left-panel-item_panel-history",
        "left-panel-item_panel-friends",
        "left-panel-item_panel-database",
    ]

    for(var i = 0; i < ids.length; i ++) {
        document.getElementById(ids[i]).style.border = "";
    }

    if(document.getElementById("left-panel-item_" + id) != null) {
        document.getElementById("left-panel-item_" + id).style.border = "1px solid green";
    }
}

function clicks_combat_switch_panel() {
    if(Globals.currentPanel != "panel-combat") {
        Globals.previousPanelBeforeCombat = Globals.currentPanel;
    }
    
    switch_panels('panel-combat');
    Combat.refresh_label_faradox_catle_blood_kills();
    document.getElementById('combat-stats').style.display = 'none';
    document.getElementById('game-panels-combat-items-area').style.display = 'none';
    document.getElementById('game-panels-combat-items-area-select').style.display = '';
    Combat.refresh_small_icons_combat_selection();
}

function append_team_storage_logger(value) {
    team_storage_logger.push(value);
    refresh_team_storage_logger();
}


function clear_team_storage_logger() {
    team_storage_logger = [];
    document.getElementById("team-stoage-logger-context").innerHTML = "";
    document.getElementById("team-stoage-logger-context").style.display = "none";
}

function refresh_team_storage_logger() {
    var html = "<u style='color:blue;float:right' onclick='clear_team_storage_logger()' class='hover'>clear</u>";
    for(var i = 0; i < team_storage_logger.length; i++) {
        html += team_storage_logger[i] + "<br />";
    }

    document.getElementById("team-stoage-logger-context").style.display = "";
    document.getElementById("team-stoage-logger-context").innerHTML = html;
}

function add_team_member(input) {
    if(isNaN(input)) {
        alert('Invalid input')
        return;
    }
    if(input.length == 0) {
        alert('Invalid input')
        return;
    }
    $.post("../../teams/add/", { key: api_user_key_dont_share, input : input}).done(function(data) { 
        alert(data['message'])
    })
}

function mark_as_read(pk) {
    $.post("../../mail/read/", { key: api_user_key_dont_share, pk : pk}).done(function(data) { 
        
    })
}

var calculate_referral_score_ajax_lasttime = 0
function calculate_referral_score_ajax(show_alert) {
    if(Items.getItem("referral_program") == 0) return;

    var doSend = false;
    if(calculate_referral_score_ajax_lasttime == 0) {
        doSend = true;
        calculate_referral_score_ajax_lasttime = Date.now();
    } else if(Date.now() >= calculate_referral_score_ajax_lasttime + 60000) {
        doSend = true;
        calculate_referral_score_ajax_lasttime = Date.now();
    }

    if(doSend) {
        $.get("../../referral/score/?key=" + api_user_key_dont_share).done(function(data) { 
            if(data['player_table'] != 'none') {
                var html = "";
                html += "<tr><th>User Linked</th><th>Global Level</th></tr>";
                for(var i = 0; i < data['player_table'].length; i++) {
                    var obj = data['player_table'][i][0];
                    var username_val = obj['username']
                    var global_level = obj['global_level']
                    
                    html += "<tr>";
                        html += "<td>" + username_val + "</td>";
                        html += "<td>" + global_level + "</td>";
                    html += "</tr>";
                    document.getElementById("table-notifications-referrals-tag").innerHTML = html;
                }
            }

            var score = parseInt(data['score']);
            if(score == 0) {
                document.getElementById("referral-score").innerHTML = "<span class='color-red'>" + score + "</span>";
            } else {
                document.getElementById("referral-score").innerHTML = "<span class='color-green'>" + score + "</span>";
            }
            
        })
    } else {
        if(show_alert) {
            alert('This value is calculated every minute, try again shortly.')
        }
        
    }

}

// could be from combat screen or the combat menu/items.
function clicks_back_button_combat_tab()
{
    if(Globals.currentPanel == "panel-combat-canvas")
        switch_panels('panel-combat');
    else {
        if(!document.getElementById("left-panel-item_" + Globals.previousPanelBeforeCombat) == null)
            highlight_panel_left(document.getElementById("left-panel-item_" + Globals.previousPanelBeforeCombat))
        switch_panels(Globals.previousPanelBeforeCombat);
    }
}

function refresh_teams_panel_users(values) {
    var arr = values.split("~");
    var html = "";
    var teamSizeCounter = 0;
    for(var i = 0; i < arr.length; i+=0) {
        var username = arr[i]; i++;
        var isOnline = arr[i]; i++;

        if(isOnline == "1") {
            html += "<div onclick='switch_panels(\"panel-friends\")' class='hover team-username-online'><span class='online-dot'></span>&nbsp;&nbsp;";
            html += username;
            html += "</div>"
        } else {
            html += "<div onclick='switch_panels(\"panel-friends\")' class='hover team-username-offline'><span class='offline-dot'></span>&nbsp;&nbsp;";
            html += username;
            html += "</div>"
        }
        teamSizeCounter++;
        
    }

    if(teamSizeCounter < 8) {
        html += "<div onclick='Modals.toggle(\"modal-add-team-member\");' class='hover team-username-offline'>";
            html += "<u>Add Player</u>";
        html += "</div>"
    }
    document.getElementById("panel-teams-users").innerHTML = html;
}

function border_left_menu_bar(panel) {


    document.getElementById("left-panel-item_panel-keyitems").style.border = "none";
    document.getElementById("left-panel-item_panel-mining").style.border = "none";


    document.getElementById("left-panel-item_" + panel).style.border = "1px solid lime";
    
}

// UNUSED - TODO
function refresh_remaining_required_xp_label(skill)
{
    var current_xp = Items.getItem(skill + '_xp');
    var next_level_xp = parseInt(get_xp_required(1 + get_level(Items.getItem(skill + '_xp'))));
    var difference = next_level_xp - current_xp;
    document.getElementById("panel-"+skill+"-xp-required").innerHTML = "("+format_number(difference) +" to level)"
}

function _panel_switch_action(id)
{
    hide_element("menu-bar-hero");
    show_element("menu-bar-buttons");
    if(Items.getItem("new_settings_checkbox_condense_main_items") == 0) show_element("top-menu-bar-labels");
    show_element("game-chat");
    ActivityLogger.show();

    if(id == "panel-settings")
    {
        document.getElementById('change-password-form-username').value = Items.getItemString('username')
    }
    if(id == "panel-crafting")
        Crafting.refresh_table(document.getElementById('crafting-table'));
    if(id == "panel-quests")
    {
        if(Items.getItem("optional_quests_unlocked") == 0 && Items.getItem("stardust_expert_quest") == -1) {
            websocket.send('UNLOCK_OPTIONAL_QUESTS')
        }
        Quests.refreshQuestBoxes();
    }
    if(id == "panel-achievements") {
        Achievements.refresh_achievement_buttons();
        Achievements.load_achievement_counts();
        websocket.send('REMOVE_NOTIF_ACHIEV_PERK')
    }
    if(id == "panel-farming")
    {
        Farming.refresh();
        onDragEnd();
        Quests.displayMiniQuestButtons("mini_quest_green_leaf_buddy");
    }
    if(id == "panel-history") {
        try {
            var logObj = new LogManager();
            logObj.refresh_panel();
          } catch (error) {
            console.log(error);
          }
    }
    if(id == "panel-brewing")
    {
        Brewing.switchedToPanel();
        Brewing.refresh_table(document.getElementById("brewing-table"));
    }
    if(id == "panel-criptoe-tcg") {
        websocket.send('RFRESH_TCG_CLIENT');
    }
    
    if(id == "panel-penguin") {
        websocket.send('REFRESH_PENGUIN_TICKETS');
    }
    if(id == "panel-invention")
    {
        Invention.refresh_table();
    }
    if(id == "panel-criptoe-market") {
        CToe.refresh_panel();
    }
    if(id == "panel-criptoe-research-tree") {
        CToe.refresh_researcher_table();
    }
    if(id == 'panel-breeding-animal-shop') {
        Breeding.clicks_animal_shop_panel();
    }
    
    if(id == "panel-keyitems")
    {
        Items.refresh_closet_label();
        ScrollSockets.refreshSocketScrollLabels();
        ScrollSockets.refreshSocketScrollLabelsTab();
    }
    if(id == "panel-cooking")
    {
        Cooking.refresh_table();
    }
    if(id == "panel-combat")
    {
        show_element("menu-bar-hero");
        hide_element("menu-bar-buttons");
        Combat.show_hero_in_left_menu_bar();
        Combat.refresh_hero_sprite();
        Magic.refresh_magic_crystal_label();
        Combat.all_owned_rings_equipped();
    }

    if(id == "panel-breeding-animal-stats") {
        Breeding.loadPokedex();
    }

    if(id == "panel-events-seed_piles") {
        EventsSeedPiles.clicked_panel()
    }
    if(id == "panel-events-yeti_boss") {
        EventsYetiBoss.clicked_panel()
    }

    if(id == "panel-combat-canvas-raids") {
        Combat.hide_left_menu_bar();
        hide_element("game-chat");
        hide_element("menu-bar-buttons");
        if(Items.getItem("new_settings_checkbox_condense_main_items") == 0) hide_element("top-menu-bar-labels");
        change_fighting_background("images/raids_1_fighting_background.png");
        ActivityLogger.hide();
        Raids.startRaidsMonsterCanvas();
        Raids.startRaidsTeamCanvas();
    }
    if(id == "panel-email") {
        document.getElementById("notificaitons-mail").style.display = "none";
    }
    if(id == "panel-combat-canvas")
    {
        Combat.hide_left_menu_bar();
        show_element("menu-bar-hero");
        hide_element("menu-bar-buttons");
        if(Items.getItem("new_settings_checkbox_condense_main_items") == 0) hide_element("top-menu-bar-labels");
        hide_element("game-chat");
        ActivityLogger.hide();
        if(Items.getItemString("fighting_background") != "none")
        {
            change_fighting_background(Items.getItemString("fighting_background"));
        }

        Combat.load_preset_buttons();

        
        var hasCombatPotions = false;
        if(Items.getItem("magic_shiny_crystal_ball_potion") > 0)
        {
            document.getElementById("in-combat-shiny-angel").style.display = "";
            hasCombatPotions= true;
        }
        else
        {
            document.getElementById("in-combat-shiny-angel").style.display = "none";
        }

        if(Items.getItem("combat_loot_potion") > 0)
        {
            document.getElementById("in-combat-loot-potion").style.display = "";
            hasCombatPotions= true;
        }
        else
        {
            document.getElementById("in-combat-loot-potion").style.display = "none";
        }

        if(Items.getItem("rain_potion") > 0)
        {
            document.getElementById("in-combat-rain-potion").style.display = "";
            hasCombatPotions= true;
        }
        else
        {
            document.getElementById("in-combat-rain-potion").style.display = "none";
        }

        if(hasCombatPotions)
            document.getElementById("combat-potions-area").style.display = "";
        else
            document.getElementById("combat-potions-area").style.display = "none";

        document.getElementById("combat-cannon-area").style.display = "none";
        if(Items.getItem("cannon") > 0)
        {
            if(Items.getItem("cannon_used") == 0)
                document.getElementById("combat-cannon-area").style.display = "";
        }

        hide_element("fighting-hero-label-tele-crystal");
        hide_element("fighting-hero-label-tele-crystal-depleted");
        if(Items.getItem("teleport_crystal") > 0) {
            if(Items.getItem("teleport_crystal_cooldown") > 0) {
                show_element("fighting-hero-label-tele-crystal-depleted");
            } else {
                show_element("fighting-hero-label-tele-crystal");
            }
        }
    }

    if(id == "panel-shop")
    {
        if(Items.getItem("tut") == 0) {
            websocket.send('INCREASE_TUT=1');
        }
        refresh_shop();
        // if(Items.getItem("stone_total") <= 0)
        // show_splash("images/coins.png", "Your coins can be found on the top of the left panel.", true, false);
    }

    if(id == "panel-donor-shop")
    {
        DonorShop.refresh_active_labels();
        websocket.send("OPEN_DONOR_SHOP");
    }

    if(id == "panel-player-market")
    {
        if(Items.getItem('player_market_accepted') == 0)
        {
            switch_panels('panel-player-market-rules')
            return;
        }
        websocket.send("MARKET_REFRESH_SLOTS");

        if(!Globals.visitedMarketTabDuringSession)
        {
            Globals.visitedMarketTabDuringSession = true;
            Market.browse_get_table('all');
        }
    }

    if(id == "panel-gathering")
    {
        if(Items.getItem("farming_unlocked")) document.getElementById("gathering-farming-x-img").style.display = "none";
        if(Items.getItem("woodcutting_unlocked")) document.getElementById("gathering-woodcutting-x-img").style.display = "none";
        if(Items.getItem("fishing_unlocked")) document.getElementById("gathering-fishing-x-img").style.display = "none";
        if(Items.getItem("cooking_unlocked")) document.getElementById("gathering-cooking-x-img").style.display = "none";
        
        if(
            Items.getItem("crafting_unlocked") == 1 &&
            Items.getItem("gathering_unlocked") == 1 &&
            Items.getItem("farming_unlocked") == 1 &&
            Items.getItem("brewing_unlocked") == 1 &&
            Items.getItem("woodcutting_unlocked") == 1 &&
            Items.getItem("cooking_unlocked") == 1 &&
            Items.getItem("fishing_unlocked") == 1 &&
            Items.getItem("melee_unlocked") == 1 &&
            Items.getItem("archery_unlocked") == 1 &&
            Items.getItem("magic_unlocked") == 1
           
        )

        if(Items.getItem("gathering_castle") > 0) document.getElementById("gathering-box-castle").style.display = "";

        document.getElementById("gathering-all-x-img").style.display = "none";
        Gathering.refresh_uniques_found_label();
    }
    
    if(id == "panel-sockets")
    {
        ScrollSockets.refresh_tab();
    }

    if(id == "panel-completionist") {
        Trophies.load_trophies_content();
    }

    if(id == "panel-friends")
    {
        websocket.send('REFRESH_FRIENDS_LIST')
    }

    if(id == "panel-sigils" || id == "panel-tags")
    {
        setTimeout(function () {
            window.scrollTo(0, 0);
        },100);
    }

    if(id == "panel-settings")
    {
        if(Items.getItem("is_moderator") > 0)
            document.getElementById("settings-moderator").style.display = "";
    }

    if(id == 'panel-teams') {
        websocket.send('TEAM_REFRESH_STORAGE');
        websocket.send('TEAM_REFRESH_MISC');
    }
    if(id == 'panel-tags')
    {
        Chat.refresh_chat_tags();
    }

    if(id == 'panel-woodcutting')
    {
        Quests.displayMiniQuestButtons("mini_quest_chop_ent");
        Woodcutting.refresh();
    }

}

//used for select character screen
function remove_modal_dropback()  {
    var array = document.getElementsByClassName("modal-backdrop");
    for(var i = 0; i < array.length; i++) {
        array[i].remove();
    }
}

function set_default_cahracter_screen(show) {
    if(show) {
        document.getElementById("content").style.display = "none";
        document.getElementById("content-set-default-character").style.display = "";
    } else {
        document.getElementById("content").style.display = "";
        document.getElementById("content-set-default-character").style.display = "none";
    }
}

function show_left_menu_progress_bars() {
    let elements = document.querySelectorAll('[data-left-menu-progress-bars]');
    for(var i = 0; i < elements.length; i++) {
        elements[i].style.display = "";
    }
}

function hide_left_menu_progress_bars() {
    let elements = document.querySelectorAll('[data-left-menu-progress-bars]');
    for(var i = 0; i < elements.length; i++) {
        elements[i].style.display = "none";
    }
}

function show_left_menu_levels() {
    let elements = document.querySelectorAll('[data-menu-bar-levels-label]');
    for(var i = 0; i < elements.length; i++) {
        elements[i].style.display = "";
    }
}

function hide_left_menu_levels() {
    let elements = document.querySelectorAll('[data-menu-bar-levels-label]');
    for(var i = 0; i < elements.length; i++) {
        elements[i].style.display = "none";
    }
}

function show_left_menu_skillnames() {
    let elements = document.querySelectorAll('[data-menu-bar-skill-label]');
    for(var i = 0; i < elements.length; i++) {
        elements[i].style.display = "";
    }
}

function hide_left_menu_skillnames() {
    let elements = document.querySelectorAll('[data-menu-bar-skill-label]');
    for(var i = 0; i < elements.length; i++) {
        elements[i].style.display = "none";
    }
}


function copyReferenceLink() {
    var id = 'reference-link-topbar-link'
    var r = document.createRange();
    r.selectNode(document.getElementById(id));
    window.getSelection().removeAllRanges();
    window.getSelection().addRange(r);
    document.execCommand('copy');
    window.getSelection().removeAllRanges();
  }

