
// String.prototype.replaceAll = function(find, replace) {
//     var str = this;
//     return str.replace(new RegExp(find, 'g'), replace);
// };

String.prototype.replaceAll = function(strReplace, strWith) {
    // See http://stackoverflow.com/a/3561711/556609
    var esc = strReplace.replace(/[-\/\\^$*+?.()|[\]{}]/g, '\\$&');
    var reg = new RegExp(esc, 'ig');
    return this.replace(reg, strWith);
};


var _cls_ = {}; // serves as a cache, speed up later lookups
function get_class(name)
{
    if (!_cls_[name]) {
        // cache is not ready, fill it up
        if (name.match(/^[a-zA-Z0-9_]+$/)) {
        // proceed only if the name is a single word string
        _cls_[name] = eval(name);
        } else {
        // arbitrary code is detected 
        throw new Error("Who let the dogs out?");
        }
        }
    return _cls_[name];
}

function show_hide_elements(id_array_show, id_array_hide)
{
    id_array_show.forEach(id => document.getElementById(id).style.display = '');
    id_array_hide.forEach(id => document.getElementById(id).style.display = 'none');
}

function show_element(id)
{
    if(document.getElementById(id) == null)
    {
        console.log("ERROR: show_element FUNCTION id not found: " + id);
        return;
    }
    document.getElementById(id).style.display = ''
}

function hide_element(id)
{
   
    if(document.getElementById(id) == null)
    {
        console.log("ERROR: hide_element FUNCTION id not found" + "("+id+")");
        return;
    }
    document.getElementById(id).style.display = 'none'
}

function show_element_using_tag(tag)
{
    tag.style.display = ''
}

function hide_element_using_tag(tag)
{
    tag.style.display = 'none'
}

function remove_class(id, className)
{
    document.getElementById(id).classList.remove(className);
}

function add_class(id, className)
{
    document.getElementById(id).classList.add(className);
}

function set_image_src(element_id, src)
{
    src = get_image(src);
    if(src == null)
    {
        document.getElementById(element_id).removeAttribute("src");
    }
    else
    {
        if(!document.getElementById(element_id).src.endsWith(src))
        {
            document.getElementById(element_id).src = src;
        }
    }
   
}

function run_function(slug)
{
    switch(slug) {
        case "refresh_woodcutting_tooltips":
            //load_woodcutting_tooltips();
        break;
    }
}

function set_innerHTML(id, value)
{
    if(document.getElementById(id) == null)
    {
        console.log('COULD NOT SET innerHTML of id:' + id);
        return;
    }
    document.getElementById(id).innerHTML = value;
}

function get_current_millis()
{
    return Date.now();
}


function show_notification(var_slug, show) {
    if(show) {
        if(Items.getItem("new_settings_checkbox_" + var_slug + "_top") == 1) {
            show_element("notification-" + var_slug);
        }
        if(Items.getItem("new_settings_checkbox_" + var_slug + "_left") == 1) {
            show_element("notification-" + var_slug + "-2");
        }
    } else {
        hide_element("notification-" + var_slug);
        hide_element("notification-" + var_slug + "-2");
    }
}

function get_number_with_letters(value)
{

    if ((value + "").indexOf("k") !=-1 || (value + "").indexOf("K") !=-1 ) 
    {
        value = value.toUpperCase();
        value = value.replace('K','');
        value = value * 1000;
    }
    if ((value + "").indexOf("m") !=-1 || (value + "").indexOf("M") !=-1 ) 
    {
        value = value.toUpperCase();
        value = value.replace('M','');
        value = value * 1000000;
    }
    if ((value + "").indexOf("b") !=-1 || (value + "").indexOf("B") !=-1 ) 
    {
        value = value.toUpperCase();
        value = value.replace('B','');
        value = value * 1000000000;
    }
    
    return parseFloat(value);
}

function format_completionist(value) {
    return (value * 100).toFixed(2) + "%";
}

function format_number(numberToFormat)
{
    
    if(numberToFormat == "INF")
        return "<span style='font-size:20pt;vertical-align: middle;'>&#8734;</span>"
    if(isNaN(numberToFormat))
        return numberToFormat;
    
    var characterToAppend = "";
    if(numberToFormat >= 1000000000 && numberToFormat < 10000000000)
    {
        numberToFormat /= 1000000;
        characterToAppend = "M";
    }
    else if(numberToFormat >= 10000000000)
    {
        numberToFormat /= 1000000000;
        characterToAppend = "B";
    }
    
    return Math.floor(numberToFormat).toString().replace(/\B(?=(\d{3})+(?!\d))/g, ",") + "" + characterToAppend;
}

function format_number_decimal(numberToFormat)
{
    
    if(numberToFormat == "INF")
        return "<span style='font-size:20pt;vertical-align: middle;'>&#8734;</span>"
    if(isNaN(numberToFormat))
        return numberToFormat;
    
    var characterToAppend = "";
    if(numberToFormat >= 1000000000 && numberToFormat < 10000000000)
    {
        numberToFormat /= 1000000;
        characterToAppend = "M";
    }
    else if(numberToFormat >= 10000000000)
    {
        numberToFormat /= 1000000000;
        characterToAppend = "B";
    }
    
    return Math.floor(numberToFormat).toString().replace(/\B(?=(\d{3})+(?!\d))/g, ",") + "" + characterToAppend;
}

function format_time_short(seconds)
{
    if(seconds <= 0)
        return "0";

        var time = seconds;
         // Hours, minutes and seconds
        var hrs = ~~(time / 3600);
        var mins = ~~((time % 3600) / 60);
        var secs = (time % 60).toFixed(0);

        // Output like "1:01" or "4:03:59" or "123:03:59"
        var ret = "";

        days = 0;
        while(hrs >= 24)
        {
            hrs -= 24;
            days ++;
            
        }
        if (hrs > 0) {
            ret += "" + hrs + ":" + (mins < 10 ? "0" : "");
        }

        ret += "" + mins + ":" + (secs < 10 ? "0" : "");
        ret += "" + secs;
        
        if(days > 1)
            return days +"d, " + ret;
        else if(days == 1)
            return days + "d, " + ret;
        else
        return ret;

}
function get_utc_time() {
    var utc =  new Date(Date.now()).toUTCString()
    return utc.slice(0, -3);
}

function format_time_verbose(seconds) {
    if(seconds >= 3600) {
        return parseFloat(parseFloat(seconds / 3600).toFixed(2)) + " hours";
    }
    else if(seconds < 3600) {
        return parseInt(seconds / 60) + " minutes";
    }
}

function format_time(seconds)
{
    if(seconds <= 0)
        return "0";

        var time = seconds;
         // Hours, minutes and seconds
        var hrs = ~~(time / 3600);
        var mins = ~~((time % 3600) / 60);
        var secs = (time % 60).toFixed(0);

        // Output like "1:01" or "4:03:59" or "123:03:59"
        var ret = "";

        days = 0;
        while(hrs >= 24)
        {
            hrs -= 24;
            days ++;
            
        }
        if (hrs > 0) {
            ret += "" + hrs + ":" + (mins < 10 ? "0" : "");
        }

        ret += "" + mins + ":" + (secs < 10 ? "0" : "");
        ret += "" + secs;
        
        if(days > 1)
            return days +" days, " + ret;
        else if(days == 1)
            return days + " day, " + ret;
        else
        return ret;

}


/**
 * Convert string to camel case
 */
function getItemName(itemName)
{
    var output = itemName.charAt(0).toUpperCase();
    for(var i = 1; i < itemName.length; i++)
    {
        if(itemName.charAt(i) == itemName.charAt(i).toUpperCase() && itemName.charAt(i) != "'")
            output += " ";
        
        output += itemName.charAt(i);
    }
    
    return output;
}

function sanitize_input(string) {
    const map = {
        '&': '&amp;',
        '<': '&lt;',
        '>': '&gt;',
        '"': '&quot;',
        "'": '&#x27;',
        "/": '&#47;',
    };
    const reg = /[&<>"'/]/ig;
    return string.replace(reg, (match)=>(map[match]));
  }

//   function add_links(message) {
//     return message
// .replace(/</g, "&lt;")
// .replace(/>/g, "&gt;")
// .replace(/(?<!")https?:\/\/(www\.)?[-a-zA-Z0-9@:%._\+~#=]{1,256}\.[a-zA-Z0-9()]{1,6}\b([-a-zA-Z0-9()@:%_\+.~#?&//=]*)(?!")/g, (m) => `<a href="${m}" target="_blank">${m}</a>`);

// }

function get_item_name(name)
{
    return name.replaceAll("_", " ");
}

function capitalizeFirstLetter(string) {
    return string.charAt(0).toUpperCase() + string.slice(1);
}

function rand(min, max) 
{
    return parseInt(Math.random() * (max - min) + min);
}

function reset_fighting_background()
{
    add_class("body", "background-game");
    document.getElementById("body").style.backgroundImage = "";
    document.getElementById("panels").style.backgroundImage = "";
    document.getElementById("notifications-area").style.display = "";
}

function change_fighting_background(image_path)
{
    if(Globals.currentPanel == "panel-combat-canvas" || Globals.currentPanel == "panel-combat-canvas-raids") {
        remove_class("body", "background-game");
        document.getElementById("body").style.backgroundImage = "url('https://cdn.idle-pixel.com/"+image_path+"')";
        document.getElementById("panels").style.background = "none"
        document.getElementById("body").style.backgroundSize = "cover";
        document.getElementById("notifications-area").style.display = "none";
    }
}

function get_image(relative_path) 
{
    return "https://cdn.idle-pixel.com/" + relative_path;
}


function getMousePosition(canvas, event) {
    let rect = canvas.getBoundingClientRect();
    let x = event.clientX - rect.left;
    let y = event.clientY - rect.top;
    console.log("Coordinate x: " + x,
        "Coordinate y: " + y);
}