class Modals
{
    static toggle(id, force_unclosable)
    {
        if(id == "modal-quest-completed" || id == "modal-quest" || force_unclosable)
        {
            $('#' + id).modal({backdrop: 'static', keyboard: false});
        }
        if(id == "modal-quest-completed")
        {
            Sounds.play(Sounds.VARIABLE_QUEST_COMPLETED);
            hide_element("notification-quests");
        }

        let modal = document.getElementById(id);

        // var isSafari = navigator.vendor && navigator.vendor.indexOf('Apple') > -1 &&
        // navigator.userAgent &&
        // navigator.userAgent.indexOf('CriOS') == -1 &&
        // navigator.userAgent.indexOf('FxiOS') == -1;

        // if(isSafari)
        // {
        //     modal.style.top = '0px';
        // }
        // else
        //     modal.style.top = window.scrollY;

        var is_chrome = navigator.userAgent.indexOf('Chrome') > -1;
        var is_safari = navigator.userAgent.indexOf("Safari") > -1;

        function isSafariBrowser(){
            if (is_safari){
                if (is_chrome)  // Chrome seems to have both Chrome and Safari userAgents
                    return false;
                else
                    return true;
            }
            return false;
        }
        
        if(isSafariBrowser())
        {
            modal.style.top = '0px';
        }
        else
        {
            modal.style.top = window.scrollY;
        }

        $(modal).modal();
        $(modal).modal('toggle');
    }

    static show_sigils_dialogue()
    {
        Modals.toggle("modal-sigils");
    }

    static open_junk_planet_coordinates_modal()
    {
        Modals.toggle("modal-junk-planet-coords");
    }

    static submit_junk_planet_coords()
    {
        var x = document.getElementById("modal-junk-planet-coords-x").value;
        var y = document.getElementById("modal-junk-planet-coords-y").value;
        var z = document.getElementById("modal-junk-planet-coords-z").value;
        websocket.send('TELESCOPE_COORDS=' + x + "~" + y + "~" + z);
    }

    static toggleNewSetting(checkboxElement) {
        websocket.send('NEW_SETTINGS=' + checkboxElement.getAttribute('data-item-checkbox-var'))
        return false;
    }

    static showNextLootAnimals() {
        var timer = 86400 - Items.getItem("playtime") % 86400;
        Modals.open_image_modal('LOOT MECHANICS', 'images/info.png', 'Animals will attempt to generate loot each time your playtime timer reaches a new day.<br /><br /><span class="color-grey font-small">In about ' + format_time(timer), null, 'Close', null);
    }

    
    static openBrewingShortcutModel(skill) {
        var shortcutTable = document.getElementById('brewing-shortcut-table');
        var originalTable = document.getElementById("brewing-table");
        var trs = originalTable.getElementsByTagName("tr");

        while (shortcutTable.rows.length > 1) {
            shortcutTable.deleteRow(1);
        }

        var lowestLevel = 1000;
        for(var i = 0; i < trs.length; i++) {
            if(!trs[i].hasAttribute("data-brewing-item"))
                continue;

            if(trs[i].getAttribute('data-brewing-item-category') == skill) {
                var level = parseInt(trs[i].getElementsByTagName("item-brewing-table-level")[0].innerHTML)
                if(level < lowestLevel) {
                    lowestLevel = level;
                }
                var tr = document.createElement("tr");
                tr.setAttribute("data-brewing-item", trs[i].getAttribute('data-brewing-item'))
                tr.classList.add(["center", "border", "hover-tr"])
                shortcutTable.appendChild(tr);
            }
        }

        if(get_level(Items.getItem("brewing_xp")) < lowestLevel) {
            Modals.open_image_modal('BREWING LEVEL TOO LOW', 'images/brewing.png', 'You need at least <b>level ' + lowestLevel + '</b> brewing to make potions related to the ' + skill + ' skill.<br /><br /><span class="color-grey">You can brew lower level potions directly in the <u style="color:blue" data-bs-dismiss="modal" class="hover" onclick="switch_panels(\'panel-brewing\')" >brewing skill</u></span>')
            return;
        }
        
        Brewing.refresh_table(shortcutTable);
        Modals.toggle('modal-brewing-table-shortcut')

    }

    static manageBooleanSetting(bool, key) {
        switch(key) {
            case "new_settings_checkbox_show_levels":
                if(bool) {
                    show_left_menu_levels();
                } else {
                    hide_left_menu_levels();
                }
            break;
            case "new_settings_checkbox_show_extra_labels":
                if(bool) {
                    document.getElementById("top-menu-bar-optional-labels").style.display = "";
                } else {
                    document.getElementById("top-menu-bar-optional-labels").style.display = "none";
                }
            break;
            case "new_settings_checkbox_stardust_watch_top":
                if(bool) {
                    show_element("notification-stardust_watch");
                } else {
                    hide_element("notification-stardust_watch");
                }
                
            break;
            case "new_settings_checkbox_show_labels":
                if(bool) {
                    show_left_menu_skillnames();
                } else {
                    hide_left_menu_skillnames();
                }
            break;
            case "new_settings_checkbox_show_progress_bars":
                if(bool) {
                    show_left_menu_progress_bars();
                } else {
                    hide_left_menu_progress_bars();
                }
            break;
            case "new_settings_checkbox_condense_main_items":
                if(bool) {
                    document.getElementById("left-menu-bar-labels").style.display = "";
                    document.getElementById("top-menu-bar-labels").style.display = "none";
                } else {
                    document.getElementById("left-menu-bar-labels").style.display = "none";
                    document.getElementById("top-menu-bar-labels").style.display = "";
                }
            break;
            case "new_settings_checkbox_machines_left":
            case "new_settings_checkbox_machines_top":
            case "new_settings_checkbox_rocket_idle_left":
            case "new_settings_checkbox_rocket_idle_top":
            case "new_settings_checkbox_rocket_landed_left":
            case "new_settings_checkbox_rocket_landed_top":
            case "new_settings_checkbox_furnace_left":
            case "new_settings_checkbox_furnace_top":
            case "new_settings_checkbox_foundry_left":
            case "new_settings_checkbox_foundry_top":
            case "new_settings_checkbox_gathering_unique_left":
            case "new_settings_checkbox_gathering_unique_top":
            case "new_settings_checkbox_trees_left":
            case "new_settings_checkbox_trees_top":
            case "new_settings_checkbox_farming_left":
            case "new_settings_checkbox_farming_top":
            case "new_settings_checkbox_farming_empty_left":
            case "new_settings_checkbox_farming_empty_top":
            case "new_settings_checkbox_watering_can_left":
            case "new_settings_checkbox_watering_can_top":
            case "new_settings_checkbox_birdhouse_idle_left":
            case "new_settings_checkbox_birdhouse_idle_top":
            case "new_settings_checkbox_birdhouse_ready_left":
            case "new_settings_checkbox_birdhouse_ready_top":
            case "new_settings_checkbox_potions_inactive_left":
            case "new_settings_checkbox_potions_inactive_top":
            case "new_settings_checkbox_cooksbook_idle_left":
            case "new_settings_checkbox_cooksbook_idle_top":
            case "new_settings_checkbox_cooksbook_ready_left":
            case "new_settings_checkbox_cooksbook_ready_top":
            case "new_settings_checkbox_boats_idle_left":
            case "new_settings_checkbox_boats_idle_top":
            case "new_settings_checkbox_boats_collect_left":
            case "new_settings_checkbox_boats_collect_top":
            case "new_settings_checkbox_treasure_map_left":
            case "new_settings_checkbox_treasure_map_top":
            case "new_settings_checkbox_green_treasure_map_left":
            case "new_settings_checkbox_green_treasure_map_top":
            case "new_settings_checkbox_red_treasure_map_left":
            case "new_settings_checkbox_red_treasure_map_top":
            case "new_settings_checkbox_fight_points_left":
            case "new_settings_checkbox_fight_points_top":
            case "new_settings_checkbox_crystal_magic_xp_left":
            case "new_settings_checkbox_crystal_magic_xp_top":
            case "new_settings_checkbox_aquarium_left":
            case "new_settings_checkbox_aquarium_top":
            {
                if(!bool) {
                    var data_array = key.split("_");
                    data_array.pop();
                    data_array.shift();
                    data_array.shift();
                    data_array.shift();
                    var data = data_array.join("_");
                    show_notification(data, false);
                }
                
            } 
            break;
        }
    }

    static toggleSettingsCheckBox(bool, key) {
        document.querySelector('[data-item-checkbox-var='+key+']').checked = bool;
    }

    static open_image_modal(title, image_path, message, primary_button_text, secondary_button_text, command, force_unclosable)
    {
        document.getElementById("modal-image-text-title").innerHTML = title;

        
        if(image_path == null || image_path == "none")
        {
            document.getElementById("modal-image-text-image-src").style.display = "none";
            document.getElementById("modal-image-text-image-src").src = get_image("images/none.png");
            document.getElementById("modal-image-section").style.display = "none";
        }
        else
        {
            document.getElementById("modal-image-text-image-src").style.display = "";
            document.getElementById("modal-image-text-image-src").src = get_image(image_path);
            document.getElementById("modal-image-section").style.display = "";
        }

        document.getElementById("modal-image-text-message").innerHTML = message;

        if(primary_button_text != null)
        {
            document.getElementById("modal-image-text-btn-primary").parentElement.style.display = "";
            document.getElementById("modal-image-text-btn-primary").innerHTML = primary_button_text;
        }
        else
        {
            document.getElementById("modal-image-text-btn-primary").parentElement.style.display = "none";
        }

        if(secondary_button_text != null)
        {
            document.getElementById("modal-image-text-btn-secondary").parentElement.style.display = "";
            document.getElementById("modal-image-text-btn-secondary").innerHTML = secondary_button_text;
        }
        else
        {
            document.getElementById("modal-image-text-btn-secondary").parentElement.style.display = "none";
        }

        if(command != null)
        {
            document.getElementById("modal-image-btn-primary").onclick = function()
            {
                if(command.length > 0)
                websocket.send(command);
                Modals.toggle("modal-image-text")
            }
        }
        else
        {
            document.getElementById("modal-image-btn-primary").onclick = function() {}
        }
        
        Modals.toggle("modal-image-text", force_unclosable);
    }

    static refreshTeamStorageData(raw) {
        var dataArray = raw.split("~");
        var html = "";
        for(var i = 0; i < dataArray.length; i+=0) {
            var itemName = dataArray[i];
            i++;
            var itemAmount = parseInt(dataArray[i]);
            i++;

            if(itemAmount > 0) {
                html += "<div data-item-team-storage='"+itemName+"' onclick='Modals.clicksTeamStorageItem(\""+itemName+"\", "+itemAmount+")' class='team-trading-box-entry hover'>";
                    html  += "<img src='https://cdn.idle-pixel.com/images/"+itemName+".png' />"
                    html += "<span>"+format_number(itemAmount)+"</span>";
                html += "</div>";
            }
           
        }

        document.getElementById("team-storage-box-content").innerHTML = html;
    }

    static clicksTeamStorageItem(item_var, amount) {
        if(item_var == "fight_points") {
            var current = Items.getItem("fight_points");
            var max = Items.getItem("max_fight_points");
            amount = max - current;
        }
        Modals.open_input_dialogue_with_value(item_var, "Take from Storage", "Enter the amount you wish to take from team storage", amount, "TEAM_TAKE_ITEM");
    }

    static removeFriend(id) {
        if(confirm('Are you sure you want to remove this friend?')) {
            websocket.send('REMOVE_FRIEND=' + id)
        }
    }

    
    static open_incinerator()
    {
        Modals.open_image_modal("INCINERATOR", "images/incinerator.png", "Add <img src='https://cdn.idle-pixel.com/images/lava.png' width='15px' />  10 buckets of lava to your incinerator?<br /><br /><span class='color-grey'>Your incinerator will consume your bones for 10 minutes, converting them to ashes.</span><br /><br /><img src='https://cdn.idle-pixel.com/images/ashes.png' width='15px' /> <b>Ashes created: </b> " + Items.getItem("incinerator_ashes"), "Activate", "Cancel", "INCINERATOR");
    }

    static open_action_modal(title, image_path, message, primary_button_text, secondary_button_text, command)
    {
        document.getElementById("modal-action-text-title").innerHTML = title;

        
        if(image_path == null)
        {
            document.getElementById("modal-action-text-image-src").style.display = "none";
            document.getElementById("modal-action-text-image-src").src = get_image("images/none.png");
        }
        else
        {
            document.getElementById("modal-action-text-image-src").style.display = "";
            document.getElementById("modal-action-text-image-src").src = get_image(image_path);
        }

        document.getElementById("modal-action-text-message").innerHTML = message;

        if(primary_button_text != null)
        {
            document.getElementById("modal-action-text-btn-primary").parentElement.style.display = "";
            document.getElementById("modal-action-text-btn-primary").innerHTML = primary_button_text;
        }
        else
        {
            document.getElementById("modal-action-text-btn-primary").parentElement.style.display = "none";
        }

        if(secondary_button_text != null)
        {
            document.getElementById("modal-action-text-btn-secondary").parentElement.style.display = "";
            document.getElementById("modal-action-text-btn-secondary").innerHTML = secondary_button_text;
        }
        else
        {
            document.getElementById("modal-action-text-btn-secondary").parentElement.style.display = "none";
        }

        if(command != null)
        {
            document.getElementById("modal-action-btn-primary").onclick = function()
            {
                Action.action(command);
                Modals.toggle("modal-action-text")
            }
        }
        else
        {
            document.getElementById("modal-action-btn-primary").onclick = function() {}
        }

        Modals.toggle("modal-action-text");
    }

    static open_monster_description(monster_name)
    {
        if(monster_name == "yeti") websocket.send('EXAMINE_YETI_STRATEGY')
        document.getElementById('monster-description-name').innerHTML = monster_name;
        document.getElementById('monster-description-description').innerHTML = MonsterDescriptions.data[monster_name]['desc'];
        document.getElementById('monster-description-stratergy').innerHTML = MonsterDescriptions.data[monster_name]['stratergy'];
        Modals.toggle("modal-monster-description");
    }

    static open_input_dialogue(item, btn_text, desc, server_comand)
    {
        Modals.open_input_dialogue_with_value(item, btn_text, desc, "", server_comand)
    }

    static open_input_dialogue_with_value(item, btn_text, desc, value, server_comand)
    {
        document.getElementById("modal-input-image").innerHTML = "images/"+item+".png";
        document.getElementById("modal-input-description").innerHTML = desc;
        document.getElementById("modal-input-text").value = value;
        document.getElementById("modal-input-button-text").innerHTML = btn_text;

        document.getElementById("modal-input-button").onclick = function()
        {
            websocket.send(server_comand + "=" + item + "~" + get_number_with_letters(document.getElementById("modal-input-text").value));
        }

        Modals.toggle("modal-item-input");
    }
  

    static clicks_gathering_bag(item, area) {
        var dict = {}
        dict[item] = 1;
        Modals.open_modern_input_dialogue_with_value(
            item,
            "images/" + item + ".png",
            dict,
            "MAX",
            null,
            'Open Bags',
            'OPEN_GATHERING_LOOT=' + area
        );
    }


    /**
     * 
     * dict_per_input = {
     *      'dotted_green_leaf': 5,
     *      ...
     * }
     * 
     * default_value_slug = none, one or max
     */
    
    static open_modern_input_dialogue_with_value(item_var, image_path, dict_per_input, default_value_slug, extra_html, submit_label, serverPrefex)
    {
        Globals.modal_modern_input_dict = dict_per_input;
        document.getElementById("modal-item-modern-input-input").value = 0;
        document.getElementById('modal-item-modern-input-img').src = "https://cdn.idle-pixel.com/" + image_path;
        if(extra_html != null) {
            document.getElementById("modal-item-modern-input-extrahtml").innerHTML = extra_html;
        } else {
            document.getElementById("modal-item-modern-input-extrahtml").innerHTML = "";
        }
        document.getElementById("modal-item-modern-input-submit-label").innerHTML = submit_label;
        document.getElementById("modal-item-modern-input-submit-btn").onclick = function() {
            websocket.send(serverPrefex + "~" + document.getElementById("modal-item-modern-input-input").value);
        }
        Modals.open_modern_input_dialogue_with_value_control(default_value_slug)
        Modals.toggle("modal-item-modern-input");
    }

    
    static open_modern_input_dialogue_with_value_control(control_type) {
        var dict = Globals.modal_modern_input_dict;
        var inputValue = document.getElementById("modal-item-modern-input-input").value;
        if(inputValue.length > 0) {
            inputValue = parseInt(inputValue);
        }

        var maxAmountFound = 10000000;
        for (const [key, value] of Object.entries(dict)) {
            if(Items.getItem(key) < maxAmountFound * value) {
                maxAmountFound = parseInt(Items.getItem(key) / value)
            }
        }

        switch(control_type) {
            case 'MAX':
                document.getElementById("modal-item-modern-input-input").value = maxAmountFound;
            break;
            case "HALF":
                if(isNaN(inputValue) || inputValue.length == 0 || inputValue == 0) {
                    document.getElementById("modal-item-modern-input-input").value = parseInt(maxAmountFound / 2);
                } else {
                    document.getElementById("modal-item-modern-input-input").value = parseInt(inputValue / 2);
                }
            break;
            case "PLUS_ONE":
                if(isNaN(inputValue) || inputValue.length == 0 || inputValue == 0) {
                    document.getElementById("modal-item-modern-input-input").value = 1;
                } else {
                    document.getElementById("modal-item-modern-input-input").value = inputValue + 1
                }
            break;
            case "MINUS_ONE":
                if(isNaN(inputValue) || inputValue.length == 0 || inputValue == 0) {
                    document.getElementById("modal-item-modern-input-input").value = 0;
                } else {
                    document.getElementById("modal-item-modern-input-input").value = inputValue - 1
                }
            break;
        }

       Modals.refresh_modern_panel_values();
    }

    static refresh_modern_panel_values() {
        document.getElementById("modal-item-modern-input-panels").innerHTML = "";

        //show items panels at bottom
        var dict = Globals.modal_modern_input_dict
        var finalValue = parseInt(document.getElementById("modal-item-modern-input-input").value);

        if(isNaN(finalValue)) return;
        if(finalValue.length == 0) return;

        var html = "";
        for (const [key, value] of Object.entries(dict)) {
            var requiredAmount = value * finalValue;
            var style = "background-color:#CDF7BA;"
            if(Items.getItem(key) < requiredAmount) {
                style = "background-color:#F7BABA;"
            }
            html += "<table style='"+style+"display:inline-block;margin:10px;border-radius:5pt'>";
                html += "<tr>";
                    html += "<td style='padding:8px;'>";
                        html += "<img class='w30' src='https://cdn.idle-pixel.com/images/"+key+".png'>";
                    html += "</td>";
                    html += "<td style='color:grey;padding:8px;'>";
                        html += capitalizeFirstLetter(get_item_name(key)) + " x " + format_number(requiredAmount); 
                    html += "</td>";
                html += "</tr>";
            html += "</table>";
        }
        document.getElementById("modal-item-modern-input-panels").innerHTML = html;
    }

    static open_criptoe_invest_dialogue(wallet_id) {
        Modals.open_input_dialogue_with_value(
            "wallet_" + wallet_id,
            "Add Investment",
            "Enter the amount you wish to invest.<br /><br /><b>Note that it is impossible to wtihdraw criptoe from a wallet you invested in on the same day.</b>",
            "",
            "INVEST_WALLET"
        );
    }
    

    static open_criptoe_withdrawal_dialogue(wallet_id) {
        var invested = Items.getItem("wallet1_invested"); 
        Modals.open_image_modal(
            "Criptoe Withdrawal",
            "images/buy_criptoe.png",
            "Would you like Cash out all your criptoe for wallet #"+wallet_id+"?<br /><br /><b class='color-red'>WARNING: This wallet will be locked until the week is over, you won't be able to invest in it until sunday passes.</b>",
            "Cash out!",
            "Cancel",
            "CRIPTOE_WITHDRAWAL_WALLET=wallet_" + wallet_id
        );
    }

    static open_team_tradables(data) {
        var dataArray = data.split("~");
        var html = "";

        html += "<center>";
        html += "<input type='text' onkeyup='Modals.searchTeamStorageSelectItemKeyPress(this)' placeholder='Search' /><br /><br />";
        
        for(var i = 0; i < dataArray.length; i++) {
            var item = dataArray[i];
            
            html += "<div data-bs-dismiss='modal' onclick='Modals.teamStorageSelectItem(\""+item+"\")'  data-modal-team-storage='"+item+"' class='model-team-storage-item hover'>";
                html += "<img class='w30' src='https://cdn.idle-pixel.com/images/"+item+".png' />";
            html += "</div>"
        }
        html += "</center>";

        
        document.getElementById("modal-teamstorage-select-item-content").innerHTML = html;
        Modals.toggle("modal-teamstorage-select-item");
        document.getElementById("add-item-teams-label").innerHTML = "Add Item"
    }   

    static teamStorageSelectItem(item_var) {
        Modals.open_input_dialogue_with_value(item_var, "Add to Storage", "Enter the amount you wish to store for your team", Items.getItem(item_var), "TEAM_STORE_ITEM");
    }
    
    static searchTeamStorageSelectItemKeyPress(inputEle) {
        var input = inputEle.value;
        var content = document.getElementById("modal-teamstorage-select-item-content");
        var items = content.querySelectorAll("[data-modal-team-storage]")
        
        for(var i = 0; i < items.length; i++) {

            var itemValue = items[i].getAttribute("data-modal-team-storage").replaceAll("_", " ");
            if(itemValue.includes(input) || input.length == 0) {
                items[i].style.display = "";
            } else {
                items[i].style.display = "none";
            }
            
        }
    }

    static searchTeamStorageKeyPress(inputEle) {
        var input = inputEle.value;
        var content = document.getElementById("team-storage-box-content");
        var items = content.querySelectorAll("[data-item-team-storage]")
        
        for(var i = 0; i < items.length; i++) {

            var itemValue = items[i].getAttribute("data-item-team-storage").replaceAll("_", " ");
            if(itemValue.includes(input) || input.length == 0) {
                items[i].style.display = "";
            } else {
                items[i].style.display = "none";
            }
            
        }
    }

    static clicks_autodrinker() {
        var potions = [
            "stardust_potion",
		    "energy_potion",
		    "anti_disease_potion",
		    "tree_speed_potion",
		    "smelting_upgrade_potion",
		    "great_stardust_potion",
		    "tree_speed_potion",
		    "farming_speed_potion",
		    "super_stardust_potion",
		    "heat_potion",
		    "bait_potion",
		    "bone_potion",
		    "furnace_speed_potion",
		    "promethium_potion",
		    "ultra_stardust_potion",
		    "titanium_potion",
		    "geode_potion",
		    "ancient_potion"
        ]

        var html = "Select a Potion<br /><br /><span class ='color-grey'>When the timer hits 0, you will automatically drink the selected potion until you run out.</span>";
        html += "<br />";
        html += "<br />";

        if(Items.getItemString("autodrinker_selected") != "none") {
            html += "<div style='background-color:#FFD9D9' onclick='websocket.send(\"SET_AUTODRINKER=OFF\")' data-bs-dismiss='modal' class='fake-button hover btn-width-400'><img class='w20' src='https://cdn.idle-pixel.com/images/x.png' /> Turn Off </div>"
        }
        

        

        for(var i = 0; i < potions.length; i++) {
            var styling = "";
            if(Items.getItemString("autodrinker_selected") == potions[i])
                styling = "style=background-color:#99ff99";

            html += "<div "+styling+" onclick='websocket.send(\"SET_AUTODRINKER="+potions[i]+"\")' data-bs-dismiss='modal' class='fake-button hover btn-width-400'><img class='w20' src='https://cdn.idle-pixel.com/images/"+potions[i]+".png' /> "+capitalizeFirstLetter(get_item_name(potions[i]))+" </div>"
        }

        Modals.open_image_modal("AutoDrinker (Chemist Path Research)", "images/" + "autodrinker" + ".png", html, null, "Cancel", null);
        
    }
    static critpoe_choose_path() {
        var cooldown = Items.getItem("criptoe_path_timer");
        if(cooldown == 0) {
            document.getElementById("select-path-cooldown-label").innerHTML = "Now!";
        } else {
            document.getElementById("select-path-cooldown-label").innerHTML = "in " +  format_time(cooldown);
        }
        Modals.toggle("modal-select-path");
    }

    static clicks_criptoe_perk(slug) {
        Modals.open_image_modal("PERK", "images/" + slug + ".png", CToe.perk_descriptions[slug], null, "Close", null);
    }

    static clicks_banker(id) {
        var criptoePerHour = 0;
        if(id == 1) criptoePerHour = 10;
        else if(id == 2) criptoePerHour = 30;
        else if(id == 3) criptoePerHour = 80;
        else if(id == 4) criptoePerHour = 500;
        else if(id == 5) criptoePerHour = 1200;

        Modals.open_image_modal("BANKER", "images/banker"+id+".png","I am currently generating " + criptoePerHour + " per hour (on average)<br /><br /><span class='color-grey'>So far, I made you <img src='https://cdn.idle-pixel.com/images/criptoe_coin.png'> " + Items.getItem("banker" + id + "_gainz") + " criptoe.</span>", null, "Close", null);
    }
    static clicks_researcher(id) {
        var multiplier = 0;
        if(id == 1) multiplier = 1;
        else if(id == 2) multiplier = 2;
        else if(id == 3) multiplier = 4;
        else if(id == 4) multiplier = 8;
        else if(id == 5) multiplier = 36;

        Modals.open_image_modal("BANKER", "images/researcher"+id+".png","You will gain more researcher points as you actively invest.  I am multiplying your points by: " + multiplier, null, "Close", null);
    }
    static open_stardust_or_sell_item_dialogue(category, item)
    {
        if(Quests.theMerchanterShowItem(item)) return;
        
        if(Items.getItem("stardust") == 0 || Items.getItem("stardust_expert_quest") == 2)
        {
            Modals.open_sell_item_dialogue(item);
            return;
        }

        // sell button
        document.getElementById("modal-stardust-or-sell-sell-btn").onclick = function()
        {
            Modals.open_sell_item_dialogue(item);
        }
        // use stardust button
        document.getElementById("modal-stardust-or-sell-convert-xp-btn").onclick = function()
        {
            document.getElementById("modal-use-stardust-input").value = "";
            document.getElementById("modal-use-stardust-xp-to-gain").innerHTML = "";
            document.getElementById("modal-use-stardust-stardust-required").innerHTML = "";
            Modals.toggle("modal-use-stardust");
        }

        // set up stardust modal
        var xp_per_item  = Stardust.xp_conversion_rates[item];

        var bonus_xp = 1.0;
        if(DonorShop.has_donor_active(Items.getItem('donor_bonus_xp_timestamp')))
            bonus_xp += 0.1;
        
        xp_per_item = xp_per_item * bonus_xp;

        document.getElementById("modal-use-stardust-image").src = get_image("images/" + item + ".png");
        document.getElementById("modal-use-stardust-xp-per-item").innerHTML = parseFloat(xp_per_item).toFixed(2);


        //hide images
        document.getElementById('stardust-required-img-icon').style.display = "none";
        document.getElementById('stardust-modal-skills-img-icon').style.display = "none";

        var stardust_per_xp = 13;

        switch(category){
            case "mining":
                stardust_per_xp = Ores.getStardustPerXp();
            break;
            case "crafting":
                stardust_per_xp = Crafting.getStardustPerXp();
            break;
        }
        document.getElementById("stardust-per-xp").innerHTML = stardust_per_xp;

        // max button
        document.getElementById("convert-itme-into-xp-max-btn").onclick = function(e) {
            var max_amount = parseFloat(Items.getItem('stardust')) / parseFloat(stardust_per_xp) / parseFloat(xp_per_item);
            if(max_amount > Items.getItem(item))
                max_amount = Items.getItem(item);

            document.getElementById('modal-use-stardust-input').value = parseInt(max_amount);
            update_values();
        }   
        // input box
        document.getElementById("modal-use-stardust-input").onkeyup = function(e)
        {
            update_values();
        }
        

        document.getElementById("modal-use-stardust-button").onclick = function()
        {
            websocket.send("CONVERT_STARDUST=" + item + "~" + document.getElementById("modal-use-stardust-input").value);
        }

        Modals.toggle("modal-stardust-or-sell");

        function update_values() {
            var input_value = document.getElementById('modal-use-stardust-input').value;
            var xp_to_gain = parseInt(input_value * xp_per_item);
            var stardust_cost = xp_to_gain * stardust_per_xp;

            if(input_value == "")
            {
                document.getElementById("modal-use-stardust-xp-to-gain").innerHTML = "";
                document.getElementById("modal-use-stardust-stardust-required").innerHTML = "";
                document.getElementById('stardust-required-img-icon').style.display = "none";
                document.getElementById('stardust-modal-skills-img-icon').style.display = "none";
            }
            else if(xp_to_gain == 0)
            {
                document.getElementById("modal-use-stardust-xp-to-gain").innerHTML = "<span class='color-red'>You must use at least 10 stone to gain 1 XP.</span>";
                document.getElementById("modal-use-stardust-stardust-required").innerHTML = "";
                document.getElementById('stardust-required-img-icon').style.display = "none";
                document.getElementById('stardust-modal-skills-img-icon').style.display = "none";
            }
            else
            {
                document.getElementById("modal-use-stardust-xp-to-gain").innerHTML = format_number(xp_to_gain) + " xp";
                document.getElementById("modal-use-stardust-stardust-required").innerHTML = format_number(stardust_cost) + " stardust";
                document.getElementById('stardust-required-img-icon').style.display = "";
                document.getElementById('stardust-modal-skills-img-icon').style.display = "";
            }
        }
    }
    static open_sell_item_dialogue(item)
    {
        var dict = {}
        dict[item] = 1;
        
        var image = "images/" + item + ".png";
        if(item == "blood_diamond")
            image = "images/" + item + ".gif";
        Modals.open_modern_input_dialogue_with_value(
            item,
            image,
            dict,
            "MAX",
            null,
            'Sell',
            'SHOP_SELL=' + item
        ); 
        
        // var amount = Items.getItem(item);
        // document.getElementById("modal-sell-item-name-hidden").value = item;
        // document.getElementById("modal-sell-item-text-title").innerHTML = getItemName(item);

        // if(item == "blood_diamond")
        //     document.getElementById("modal-sell-item-image").src = get_image("images/" + item + ".gif");
        // else
        //     document.getElementById("modal-sell-item-image").src = get_image("images/" + item + ".png");

        // document.getElementById('modal-sell-item-price-value').innerHTML = format_number(get_sell_price(item));
        // document.getElementById("modal-sell-item-amount").value = amount;
        // Modals.toggle("modal-sell-item");
    }

    static open_brew_dialogue(item)
    {
      

        
        document.getElementById("modal-brew-item-name-hidden").value = item;
        document.getElementById("modal-brew-item-image").src = get_image("images/" + item + ".png");
        document.getElementById("modal-brew-item-amount").value = "1";
        var materials = Brewing.get_ingredients(item);
        var html = "<b>INGREDIENTS</b><hr />";
        var dict = {};
        for(var i = 0; i < materials.length; i++)
        {
            var name = materials[i];
            i++;
            var amount = materials[i];
            html += "<img class='w40' src='https://cdn.idle-pixel.com/images/"+name+".png' /> " + format_number(amount);
            html += "<br />";
            dict[name] = amount;
        }
        document.getElementById("modal-brew-ingredients").innerHTML = html;
        Modals.open_modern_input_dialogue_with_value(
            item,
            "images/" + item + ".png",
            dict,
            'PLUS_ONE',
            null,
            "Brew",
            "BREW=" + item,
        )
    }

    static open_invention_craft_dialogue(item)
    {
        document.getElementById("modal-invention-item-name-hidden").value = item;
        document.getElementById("modal-invention-item-image").src = get_image("images/" + item + ".png");
        var materials = Invention.get_materials(item);
        var html = "<b>COMPONENTS</b><hr />";
        for(var i = 0; i < materials.length; i++)
        {
            var name = materials[i];
            i++;
            var amount = materials[i];
            html += "<img class='w40' src='https://cdn.idle-pixel.com/images/"+name+".png' /> " + format_number(amount);
            html += "<br />";

        }
        document.getElementById("modal-invention-ingredients").innerHTML = html;
        Modals.toggle("modal-craft-invention");
    }

    static open_cooks_book_dialogue(item)
    {
        document.getElementById("modal-cooks_book-item-name-hidden").value = item;
        document.getElementById("modal-cooks_book-item-image").src = get_image("images/" + item + ".png");
        var materials = Cooking.get_ingredients(item);
        var html = "<b>INGREDIENTS</b><hr />";
        for(var i = 0; i < materials.length; i++)
        {
            var name = materials[i];
            i++;
            var amount = materials[i];
            html += "<img class='w40' src='https://cdn.idle-pixel.com/images/"+name+".png' /> " + format_number(amount);
            html += "<br />";

        }
        document.getElementById("modal-cooks_book-ingredients").innerHTML = html;
        Modals.toggle("modal-cooks-book");
    }

    
    static buy_donor_item(item, image_path)
    {
        Modals.open_image_modal("DONOR PERK", image_path,"Purchase this perk for your account?", "Purchase", "Cancel", "DONOR_SHOP=" + item);
    }
    
    static clicks_offline_time_info() {
        if(Items.getItem("balance_life") == 1) {
            document.getElementById("offline-time-8h-flag").src = "https://cdn.idle-pixel.com/images/check.png"
        }
        if(DonorShop.has_donor_active(Items.getItem("donor_offline_timer_timestamp"))) {
            document.getElementById("offline-time-12h-flag").src = "https://cdn.idle-pixel.com/images/check.png"
        }
        Modals.toggle('modal-image-text');
        Modals.toggle('modal-offline-time-info');
    }

    static open_quest_compeleted_dialogue(quest_name, quest_name_pretty)
    {
        document.getElementById("modal-quest-completed-animation").style.visibility = "hidden";
        document.getElementById("modal-quest-completed-quest-name").innerHTML = quest_name_pretty;
        var reward_btn = document.getElementById("modal-quest-completed-reward-button");

        setTimeout(function() {
            document.getElementById('story-quest-tab-button-label').innerHTML = Quests.getQuestsDataLabel();
            document.getElementById('optional-quest-tab-button-label').innerHTML = Quests.getOptionalQuestsDataLabel();
        }, 2000);
    
        switch(quest_name)
        {
            case "doric_the_crafter":
                reward_btn.onclick = function()
                {
                    Modals.open_loot_dialogue(
                        ["images/coins.png", "images/bronze_bar.png", "images/iron_bar.png"],
                        ["100 coins", "10 Bronze Bars", "5 Iron Bars"],
                        ["#cce6ff", "#cce6ff", "#cce6ff"]
                    );
                }
            break;
            case "the_gem_seeker":
                reward_btn.onclick = function()
                {
                    Modals.open_loot_dialogue(
                        ["images/gems.png", "images/copper.png"],
                        ["Ability to find gems.", "Some copper ore"],
                        ["#cce6ff", "#cce6ff"]
                    );
                }
            break;
            case "the_achiever":
                reward_btn.onclick = function()
                {
                    Modals.open_loot_dialogue(
                        ["images/achievements.png"],
                        ["Access to achievements."],
                        ["#cce6ff"]
                    );
                }
            break;
            case "combat_tutor":
                reward_btn.onclick = function()
                {
                    Modals.open_loot_dialogue(
                        ["images/wooden_arrows.png"],
                        ["50 wooden arrows."],
                        ["#cce6ff"]
                    );
                }
            break;
            case "ent_boss":
                reward_btn.onclick = function()
                {
                    Modals.open_loot_dialogue(
                        ["images/logs.png", "images/tree_seeds.png", "images/strange_leaf.png"],
                        ["500 Logs", "3 Tree seeds", "1 Strange leaf"],
                        ["#cce6ff","#cce6ff","#cce6ff"]
                    );
                }
            break;
            case "faradoxs_introduction":
                reward_btn.onclick = function()
                {
                    Modals.open_loot_dialogue(
                        ["images/magic.png", "images/earth_crystal.png"],
                        ["Ability to cast magic spells.", "Obtained one of four crystals."],
                        ["#cce6ff", "#e0b3ff"]
                    );
                }
            break;
            case "combat_collection_log":
                reward_btn.onclick = function()
                {
                    Modals.open_loot_dialogue(
                        ["images/wooden_arrows.png", "images/combat_log.png"],
                        ["20 wooden arrows", "Combat log"],
                        ["#cce6ff", "#e0b3ff"]
                    );
                }
            break;
            case "fisherman":
                reward_btn.onclick = function()
                {
                    Modals.open_loot_dialogue(
                        ["images/fishing.png"],
                        ["Unlocked the fishing skill!"],
                        ["#cce6ff"]
                    );
                }
            break;
            case "tank_boss":
                reward_btn.onclick = function()
                {
                    Modals.open_loot_dialogue(
                        ["images/gold_bar.png", "images/iron_cannonball.png"],
                        ["20 gold bars", "1 - 6 iron cannonball"],
                        ["#cce6ff", "#cce6ff"]
                    );
                }
            break;
            case "thief_leader":
                reward_btn.onclick = function()
                {
                    Modals.open_loot_dialogue(
                        ["images/coins.png", "images/gold.png", "images/forest_crystal.png"],
                        ["Your coins back", "50 gold ore", "Forest crystal"],
                        ["#cce6ff", "#cce6ff", "#e0b3ff"]
                    );
                }
            break;
            case "dad_goblin":
                reward_btn.onclick = function()
                {
                    Modals.open_loot_dialogue(
                        ["images/gem_goblin_scroll.png"],
                        ["Gem goblin 'missing' scroll (key items)"],
                        ["#cce6ff"]
                    );
                }
            break;

            case "combat_presets":
                reward_btn.onclick = function()
                {
                    Modals.open_loot_dialogue(
                        ["images/max_mana_1.png","images/combat_presets.png"],
                        ["Mana crystal", "Ability to use presets in combat."],
                        ["#cce6ff", "#e0b3ff"]
                    );
                }
            break;

            case "shiny_resources":
                reward_btn.onclick = function()
                {
                    Modals.open_loot_dialogue(
                        ["images/molten_glass.png", "images/shiny_resources_reward.png"],
                        ["Ability to get molten glass from volcano.", "Reward from the dwarf in key items."],
                        ["#cce6ff", "#e0b3ff"]
                    );
                }
            break;

            case "fire_witch_sister":
                reward_btn.onclick = function()
                {
                    Modals.open_loot_dialogue(
                        ["images/reflect_spellscroll.png"],
                        ["Reflect Spellscroll (added to combat tab)"],
                        ["#cce6ff"]
                    );
                }
            break;

            case "the_carpenter":
                reward_btn.onclick = function()
                {
                    Modals.open_loot_dialogue(
                        ["images/crafting.png", "images/energy.png"],
                        ["+10,000 crafting XP", "The carpenter will feed you for every kill in the northern fields!"],
                        ["#cce6ff", "e0b3ff"]
                    );
                }
            break;

            case "the_four_crystals":
                reward_btn.onclick = function()
                {
                    Modals.open_loot_dialogue(
                        ["images/faradox_gaurdians_notes.png"],
                        ["Faradox info added to key items."],
                        ["#cce6ff"]
                    );
                    switch_panels('panel-keyitems');
                }
            break;

           

            case "ghost_miner_boss":
                reward_btn.onclick = function()
                {
                    Modals.open_loot_dialogue(
                        ["images/bomb.png", "images/tnt.png", "images/pickaxe.png"],
                        ["3 bombs", "1 tnt", "Your ores back stolen from last fight."],
                        ["#cce6ff", "#cce6ff", "#e0b3ff"]
                    );
                }
            break;

            case "bob_the_farmer":
                reward_btn.onclick = function()
                {
                    Modals.open_loot_dialogue(
                        ["images/crystal_leaf_seeds.png", "images/gold_leaf_seeds.png", "images/farming.png"],
                        ["3 crystal leaf seeds", "5 gold leaf seeds", "500,000 farming XP"],
                        ["#cce6ff", "#cce6ff", "#e0b3ff"]
                    );
                }
            break;

            case "junk_collector":
                reward_btn.onclick = function()
                {
                    Modals.open_loot_dialogue(
                        ["images/junk_collector_loot.png"],
                        ["Special combat junk loot bag (amount scaled based on task)"],
                        ["#cce6ff"]
                    );
                }
            break;

            case "the_merchant":
                reward_btn.onclick = function()
                {
                    Modals.open_loot_dialogue(
                        ["images/merchant.png"],
                        ["Ability to barter with the merchant in the shop section."],
                        ["#cce6ff"]
                    );
                }
            break;

            case "junk_planet":
                reward_btn.onclick = function()
                {
                    if(Items.getItem("telescope_shooting_star") > 0)
                    {
                        Modals.open_loot_dialogue(
                            ["images/rocket.png", "images/moonstone.png", "images/shooting_star.png"],
                            ["Double rocket speed permanently", "5 - 8 moonstone", "1 shooting star"],
                            ["#cce6ff", "#cce6ff", "#cce6ff"]
                        );
                    }
                    else
                    {
                        Modals.open_loot_dialogue(
                            ["images/rocket.png", "images/moonstone.png"],
                            ["Double rocket speed permanently", "5 - 8 moonstone"],
                            ["#cce6ff", "#cce6ff"]
                        );
                    }
                    
                }
            break;

            case "faradox_attempt":
                reward_btn.onclick = function()
                {
                    Modals.open_loot_dialogue(
                        ["images/faradox_gaurdian_4.png"],
                        ["Access to dungeon castle."],
                        ["#cce6ff"]
                    );
                }
            break;

            //optional
            case "the_four_metals":
                reward_btn.onclick = function()
                {
                    Modals.open_loot_dialogue(
                        ["images/mixed_bar.png"],
                        ["A weird metal bar."],
                        ["#cce6ff"]
                    );
                }
            break;
            case "pyre_log_priest":
                reward_btn.onclick = function()
                {
                    Modals.open_loot_dialogue(
                        ["images/pyre_logs.png"],
                        ["Pyre logs"],
                        ["#cce6ff"]
                    );
                }
            break;
            case "teleport_crystal":
                reward_btn.onclick = function()
                {
                    Modals.open_loot_dialogue(
                        ["images/teleport_crystal.png"],
                        ["Teleport Crystal (Cooldown reset)"],
                        ["#cce6ff"]
                    );
                }
            break;
            case "time_warp_chemist":
                reward_btn.onclick = function()
                {
                    Modals.open_loot_dialogue(
                        ["images/quests.png", "images/speed_chemist_reward.png"],
                        ["Ability to find dust from cooks book, farming, trees and fighting shiny monsters.", "5 of each dust in brewing section."],
                        ["lime", "#cce6ff"]
                    );
                }
            break;
            case "enchanted_birdbath":
                reward_btn.onclick = function()
                {
                    Modals.open_loot_dialogue(
                        ["images/bird_bath_enchanted.png", "images/poppy_flower_seeds.png", "images/rose_flower_seeds.png", "images/tulip_flower_seeds.png"],
                        ["Birdbath will never empty when using birdhouse.", "Poppy seeds.", "Rose seeds.", "Tulip seeds."],
                        ["lime", "#cce6ff", "#cce6ff", "#cce6ff"]
                    );
                }
            break;
            case "mega_tablette":
                reward_btn.onclick = function()
                {
                    Modals.open_loot_dialogue(
                        ["images/mega_tablette_50.png"],
                        ["Invention Tab - Access to contribute to mega tablette for additional invention XP."],
                        ["lime"]
                    );
                }
            break;
            case "tcg_card_collection":
                reward_btn.onclick = function()
                {
                    Modals.open_loot_dialogue(
                        ["images/tcg_back_50.png"],
                        ["Access to collectible trading cards in criptoe tab."],
                        ["#cce6ff"]
                    );
                }
            break;
            case "mega_seeds":
                reward_btn.onclick = function()
                {
                    Modals.open_loot_dialogue(
                        ["images/seed_compactor.png"],
                        ["Ability to compact seeds into its mega form"],
                        ["#cce6ff"]
                    );
                }
            break;
            case "odd_one_out":
                reward_btn.onclick = function()
                {
                    Modals.open_loot_dialogue(
                        ["images/balance.png"],
                        ["Balance of Life (Active it in mining section)"],
                        ["#cce6ff"]
                    );
                }
            break;
            case "train_combat_network":
                reward_btn.onclick = function()
                {
                    Modals.open_loot_dialogue(
                        ["images/lava.png", "images/club.png", "images/scythe.png"],
                        ["Access to Volcano", "Access to Northern Fields", "Access to Haunted Mansion"],
                        ["#cce6ff","#cce6ff","#cce6ff"]
                    );
                }
            break;
            case "let_us_invent_things":
                reward_btn.onclick = function()
                {
                    Modals.open_loot_dialogue(
                        ["images/invention_icon.png", "images/degradable_gold_rapier.png", "images/combat_general.png"],
                        ["Invenction skill unlocked!", "Gold Rapier", "Combat XP from lab monsters"],
                        ["yellow","#cce6ff","#cce6ff"]
                    );
                }
            break;
        }

        Modals.toggle("modal-quest-completed");
        $('#modal-quest-completed-animation').css('visibility','visible').hide().fadeIn(3000)
    }

    static open_loot_dialogue(loot_images_array, loot_labels_array, loot_background_color_array, extra_data, levelups_data)
    {
        if(extra_data == null) extra_data = "";
        document.getElementById("modal-loot-collect-and-fight").style.display = "none";
        
        var loot_body = document.getElementById("modal-loot-body");

        if(loot_images_array.length > 8) {
            document.getElementById("modal-loot-size").classList.remove('modal-lg')
            document.getElementById("modal-loot-size").classList.add('modal-xl')
        } else {
            document.getElementById("modal-loot-size").classList.remove('modal-xl')
            document.getElementById("modal-loot-size").classList.add('modal-lg')
        }
        var html = "";
        var logger = []

        var xp_image = [];
        var xp_label = [];
        var progress_bar = [];

        var levelUpArray = []
        if(levelups_data != null && levelups_data != "none") {
            levelUpArray = levelups_data.split(",");
        }
        
        var level_up_data_dict = {}
        for(var i = 0; i < levelUpArray.length; i+=0) {
            var skill = levelUpArray[i]
            i++;
            var oldXp = levelUpArray[i]
            i++;
            var newXp = levelUpArray[i]
            i++;

            var is_level_up = false;
            var old_level = get_level(oldXp);
            var new_level = get_level(newXp);
            level_up_data_dict[skill] = {
                'old_xp': oldXp,
                'new_xp': newXp,
                'level_up': old_level < new_level,
            }

        }
        for(var i = 0; i < loot_images_array.length; i++)
        {
            
            var image = loot_images_array[i];
            var label = loot_labels_array[i];
            var background_color = loot_background_color_array[i];


            logger.push({
                'image': image,
                'label': label,
                'color': background_color,
            })

            
            if(image == "images/melee.png") {
                var skill = "melee"
                var old_xp = parseFloat(level_up_data_dict[skill]["old_xp"]);
                var new_xp = parseFloat(level_up_data_dict[skill]["new_xp"]);
                var current_level = get_level(new_xp);
                var xp_required = get_xp_required(current_level + 1);
                var xp_required_previous_level = get_xp_required(current_level);

                xp_image.push(image);
                if(level_up_data_dict[skill]['level_up'])
                    xp_label.push("<b class='font-large shine'> Your "+skill+" is now level " + current_level);
                else
                    xp_label.push(label);


                var percentage_width_old = (xp_required - old_xp) / (xp_required - xp_required_previous_level) * 100;
                percentage_width_old = 100 - percentage_width_old;
                console.log(percentage_width_old)
                var percentage_width_new = (xp_required - new_xp) / (xp_required - xp_required_previous_level) * 100;
                percentage_width_new = 100 - percentage_width_new;
                console.log(percentage_width_new)

                if(level_up_data_dict[skill]["level_up"] || current_level >= 100) {
                    percentage_width_new = "100"
                }
                if(percentage_width_new >= 100) {
                    percentage_width_new = 100;
                }
                var backgroundColor = "lime";
                if(current_level >= 100) {
                    backgroundColor = "cyan";
                }

   
                continue;
            }

            if(image == "images/archery.png") {
                var skill = "archery"
                var old_xp = parseFloat(level_up_data_dict[skill]["old_xp"]);
                var new_xp = parseFloat(level_up_data_dict[skill]["new_xp"]);
                var current_level = get_level(new_xp);
                var xp_required = get_xp_required(current_level + 1);
                var xp_required_previous_level = get_xp_required(current_level);

                xp_image.push(image);
                if(level_up_data_dict[skill]['level_up'])
                    xp_label.push("<b class='font-large shine'> Your "+skill+" is now level " + current_level);
                else
                    xp_label.push(label);


                var percentage_width_old = (xp_required - old_xp) / (xp_required - xp_required_previous_level) * 100;
                percentage_width_old = 100 - percentage_width_old;
                console.log(percentage_width_old)
                var percentage_width_new = (xp_required - new_xp) / (xp_required - xp_required_previous_level) * 100;
                percentage_width_new = 100 - percentage_width_new;
                console.log(percentage_width_new)

                if(level_up_data_dict[skill]["level_up"] || current_level >= 100) {
                    percentage_width_new = "100"
                }
                if(percentage_width_new >= 100) {
                    percentage_width_new = 100;
                }
                var backgroundColor = "lime";
                if(current_level >= 100) {
                    backgroundColor = "cyan";
                }

                continue;
            }
            if(image == "images/magic.png") {
                var skill = "magic"
                var old_xp = parseFloat(level_up_data_dict[skill]["old_xp"]);
                var new_xp = parseFloat(level_up_data_dict[skill]["new_xp"]);
                var current_level = get_level(new_xp);
                var xp_required = get_xp_required(current_level + 1);
                var xp_required_previous_level = get_xp_required(current_level);

                xp_image.push(image);
                if(level_up_data_dict[skill]['level_up'])
                    xp_label.push("<b class='font-large shine'> Your "+skill+" is now level " + current_level);
                else
                    xp_label.push(label);


                var percentage_width_old = (xp_required - old_xp) / (xp_required - xp_required_previous_level) * 100;
                percentage_width_old = 100 - percentage_width_old;
                console.log(percentage_width_old)
                var percentage_width_new = (xp_required - new_xp) / (xp_required - xp_required_previous_level) * 100;
                percentage_width_new = 100 - percentage_width_new;
                console.log(percentage_width_new)

                if(level_up_data_dict[skill]["level_up"] || current_level >= 100) {
                    percentage_width_new = "100"
                }
                if(percentage_width_new >= 100) {
                    percentage_width_new = 100;
                }
                var backgroundColor = "lime";
                if(current_level >= 100) {
                    backgroundColor = "cyan";
                }

                continue;
            }

            if(image == "images/woodcutting.png") {
                var skill = "woodcutting"
                var old_xp = parseFloat(level_up_data_dict[skill]["old_xp"]);
                var new_xp = parseFloat(level_up_data_dict[skill]["new_xp"]);
                var current_level = get_level(new_xp);
                var xp_required = get_xp_required(current_level + 1);
                var xp_required_previous_level = get_xp_required(current_level);

                xp_image.push(image);
                if(level_up_data_dict[skill]['level_up'])
                    xp_label.push("<b class='font-large shine'> Your "+skill+" is now level " + current_level);
                else
                    xp_label.push(label);


                var percentage_width_old = (xp_required - old_xp) / (xp_required - xp_required_previous_level) * 100;
                percentage_width_old = 100 - percentage_width_old;
                console.log(percentage_width_old)
                var percentage_width_new = (xp_required - new_xp) / (xp_required - xp_required_previous_level) * 100;
                percentage_width_new = 100 - percentage_width_new;
                console.log(percentage_width_new)

                if(level_up_data_dict[skill]["level_up"] || current_level >= 100) {
                    percentage_width_new = "100"
                }
                if(percentage_width_new >= 100) {
                    percentage_width_new = 100;
                }
                var backgroundColor = "lime";
                if(current_level >= 100) {
                    backgroundColor = "cyan";
                }


                continue;
            }
            if(image == "images/fishing.png") {
                var skill = "fishing"
                var old_xp = parseFloat(level_up_data_dict[skill]["old_xp"]);
                var new_xp = parseFloat(level_up_data_dict[skill]["new_xp"]);
                var current_level = get_level(new_xp);
                var xp_required = get_xp_required(current_level + 1);
                var xp_required_previous_level = get_xp_required(current_level);

                xp_image.push(image);
                if(level_up_data_dict[skill]['level_up'])
                    xp_label.push("<b class='font-large shine'> Your "+skill+" is now level " + current_level);
                else
                    xp_label.push(label);


                var percentage_width_old = (xp_required - old_xp) / (xp_required - xp_required_previous_level) * 100;
                percentage_width_old = 100 - percentage_width_old;
                console.log(percentage_width_old)
                var percentage_width_new = (xp_required - new_xp) / (xp_required - xp_required_previous_level) * 100;
                percentage_width_new = 100 - percentage_width_new;
                console.log(percentage_width_new)

                if(level_up_data_dict[skill]["level_up"] || current_level >= 100) {
                    percentage_width_new = "100"
                }
                if(percentage_width_new >= 100) {
                    percentage_width_new = 100;
                }
                var backgroundColor = "lime";
                if(current_level >= 100) {
                    backgroundColor = "cyan";
                }


                continue;
            }
            if(image == "images/cooking.png") {
                var skill = "cooking"
                var old_xp = parseFloat(level_up_data_dict[skill]["old_xp"]);
                var new_xp = parseFloat(level_up_data_dict[skill]["new_xp"]);
                var current_level = get_level(new_xp);
                var xp_required = get_xp_required(current_level + 1);
                var xp_required_previous_level = get_xp_required(current_level);

                xp_image.push(image);
                if(level_up_data_dict[skill]['level_up'])
                    xp_label.push("<b class='font-large shine'> Your "+skill+" is now level " + current_level);
                else
                    xp_label.push(label);


                var percentage_width_old = (xp_required - old_xp) / (xp_required - xp_required_previous_level) * 100;
                percentage_width_old = 100 - percentage_width_old;
                console.log(percentage_width_old)
                var percentage_width_new = (xp_required - new_xp) / (xp_required - xp_required_previous_level) * 100;
                percentage_width_new = 100 - percentage_width_new;
                console.log(percentage_width_new)

                if(level_up_data_dict[skill]["level_up"] || current_level >= 100) {
                    percentage_width_new = "100"
                }
                if(percentage_width_new >= 100) {
                    percentage_width_new = 100;
                }
                var backgroundColor = "lime";
                if(current_level >= 100) {
                    backgroundColor = "cyan";
                }

                continue;
            }
            if(image == "images/breeding.png") {
                var skill = "breeding"
                var old_xp = parseFloat(level_up_data_dict[skill]["old_xp"]);
                var new_xp = parseFloat(level_up_data_dict[skill]["new_xp"]);
                var current_level = get_level(new_xp);
                var xp_required = get_xp_required(current_level + 1);
                var xp_required_previous_level = get_xp_required(current_level);

                xp_image.push(image);
                if(level_up_data_dict[skill]['level_up'])
                    xp_label.push("<b class='font-large shine'> Your "+skill+" is now level " + current_level);
                else
                    xp_label.push(label);


                var percentage_width_old = (xp_required - old_xp) / (xp_required - xp_required_previous_level) * 100;
                percentage_width_old = 100 - percentage_width_old;
                console.log(percentage_width_old)
                var percentage_width_new = (xp_required - new_xp) / (xp_required - xp_required_previous_level) * 100;
                percentage_width_new = 100 - percentage_width_new;
                console.log(percentage_width_new)

                if(level_up_data_dict[skill]["level_up"] || current_level >= 100) {
                    percentage_width_new = "100"
                }
                if(percentage_width_new >= 100) {
                    percentage_width_new = 100;
                }
                var backgroundColor = "lime";
                if(current_level >= 100) {
                    backgroundColor = "cyan";
                }


                continue;
            }
            if(image == "images/farming.png") {
                var skill = "farming"
                var old_xp = parseFloat(level_up_data_dict[skill]["old_xp"]);
                var new_xp = parseFloat(level_up_data_dict[skill]["new_xp"]);
                var current_level = get_level(new_xp);
                var xp_required = get_xp_required(current_level + 1);
                var xp_required_previous_level = get_xp_required(current_level);

                xp_image.push(image);
                if(level_up_data_dict[skill]['level_up'])
                    xp_label.push("<b class='font-large shine'> Your "+skill+" is now level " + current_level);
                else
                    xp_label.push(label);


                var percentage_width_old = (xp_required - old_xp) / (xp_required - xp_required_previous_level) * 100;
                percentage_width_old = 100 - percentage_width_old;
                console.log(percentage_width_old)
                var percentage_width_new = (xp_required - new_xp) / (xp_required - xp_required_previous_level) * 100;
                percentage_width_new = 100 - percentage_width_new;
                console.log(percentage_width_new)

                if(level_up_data_dict[skill]["level_up"] || current_level >= 100) {
                    percentage_width_new = "100"
                }
                if(percentage_width_new >= 100) {
                    percentage_width_new = 100;
                }
                var backgroundColor = "lime";
                if(current_level >= 100) {
                    backgroundColor = "cyan";
                }


                continue;
            }
            if(image == "images/brewing.png") {
                var skill = "brewing"
                var old_xp = parseFloat(level_up_data_dict[skill]["old_xp"]);
                var new_xp = parseFloat(level_up_data_dict[skill]["new_xp"]);
                var current_level = get_level(new_xp);
                var xp_required = get_xp_required(current_level + 1);
                var xp_required_previous_level = get_xp_required(current_level);

                xp_image.push(image);
                if(level_up_data_dict[skill]['level_up'])
                    xp_label.push("<b class='font-large shine'> Your "+skill+" is now level " + current_level);
                else
                    xp_label.push(label);


                var percentage_width_old = (xp_required - old_xp) / (xp_required - xp_required_previous_level) * 100;
                percentage_width_old = 100 - percentage_width_old;
                console.log(percentage_width_old)
                var percentage_width_new = (xp_required - new_xp) / (xp_required - xp_required_previous_level) * 100;
                percentage_width_new = 100 - percentage_width_new;
                console.log(percentage_width_new)

                if(level_up_data_dict[skill]["level_up"] || current_level >= 100) {
                    percentage_width_new = "100"
                }
                if(percentage_width_new >= 100) {
                    percentage_width_new = 100;
                }
                var backgroundColor = "lime";
                if(current_level >= 100) {
                    backgroundColor = "cyan";
                }

                continue;
            }
            if(image == "images/invention.png") {
                var skill = "invention"
                var old_xp = parseFloat(level_up_data_dict[skill]["old_xp"]);
                var new_xp = parseFloat(level_up_data_dict[skill]["new_xp"]);
                var current_level = get_level(new_xp);
                var xp_required = get_xp_required(current_level + 1);
                var xp_required_previous_level = get_xp_required(current_level);

                xp_image.push(image);
                if(level_up_data_dict[skill]['level_up'])
                    xp_label.push("<b class='font-large shine'> Your "+skill+" is now level " + current_level);
                else
                    xp_label.push(label);


                var percentage_width_old = (xp_required - old_xp) / (xp_required - xp_required_previous_level) * 100;
                percentage_width_old = 100 - percentage_width_old;
                console.log(percentage_width_old)
                var percentage_width_new = (xp_required - new_xp) / (xp_required - xp_required_previous_level) * 100;
                percentage_width_new = 100 - percentage_width_new;
                console.log(percentage_width_new)

                if(level_up_data_dict[skill]["level_up"] || current_level >= 100) {
                    percentage_width_new = "100"
                }
                if(percentage_width_new >= 100) {
                    percentage_width_new = 100;
                }
                var backgroundColor = "lime";
                if(current_level >= 100) {
                    backgroundColor = "cyan";
                }

                continue;
            }
            if(image == "images/gathering.png") {
                var skill = "gathering"
                var old_xp = parseFloat(level_up_data_dict[skill]["old_xp"]);
                var new_xp = parseFloat(level_up_data_dict[skill]["new_xp"]);
                var current_level = get_level(new_xp);
                var xp_required = get_xp_required(current_level + 1);
                var xp_required_previous_level = get_xp_required(current_level);

                xp_image.push(image);
                if(level_up_data_dict[skill]['level_up'])
                    xp_label.push("<b class='font-large shine'> Your "+skill+" is now level " + current_level);
                else
                    xp_label.push(label);


                var percentage_width_old = (xp_required - old_xp) / (xp_required - xp_required_previous_level) * 100;
                percentage_width_old = 100 - percentage_width_old;
                console.log(percentage_width_old)
                var percentage_width_new = (xp_required - new_xp) / (xp_required - xp_required_previous_level) * 100;
                percentage_width_new = 100 - percentage_width_new;
                console.log(percentage_width_new)

                if(level_up_data_dict[skill]["level_up"] || current_level >= 100) {
                    percentage_width_new = "100"
                }
                if(percentage_width_new >= 100) {
                    percentage_width_new = 100;
                }
                var backgroundColor = "lime";
                if(current_level >= 100) {
                    backgroundColor = "cyan";
                }

                continue;
            }
            if(image == "images/crafting.png") {
                var skill = "crafting"
                var old_xp = parseFloat(level_up_data_dict[skill]["old_xp"]);
                var new_xp = parseFloat(level_up_data_dict[skill]["new_xp"]);
                var current_level = get_level(new_xp);
                var xp_required = get_xp_required(current_level + 1);
                var xp_required_previous_level = get_xp_required(current_level);

                xp_image.push(image);
                if(level_up_data_dict[skill]['level_up'])
                    xp_label.push("<b class='font-large shine'> Your "+skill+" is now level " + current_level);
                else
                    xp_label.push(label);


                var percentage_width_old = (xp_required - old_xp) / (xp_required - xp_required_previous_level) * 100;
                percentage_width_old = 100 - percentage_width_old;
                console.log(percentage_width_old)
                var percentage_width_new = (xp_required - new_xp) / (xp_required - xp_required_previous_level) * 100;
                percentage_width_new = 100 - percentage_width_new;
                console.log(percentage_width_new)

                if(level_up_data_dict[skill]["level_up"] || current_level >= 100) {
                    percentage_width_new = "100"
                }
                if(percentage_width_new >= 100) {
                    percentage_width_new = 100;
                }
                var backgroundColor = "lime";
                if(current_level >= 100) {
                    backgroundColor = "cyan";
                }


                continue;
            }
            if(image == "images/mining.png") {
                var skill = "mining"
                var old_xp = parseFloat(level_up_data_dict[skill]["old_xp"]);
                var new_xp = parseFloat(level_up_data_dict[skill]["new_xp"]);
                var current_level = get_level(new_xp);
                var xp_required = get_xp_required(current_level + 1);
                var xp_required_previous_level = get_xp_required(current_level);

                xp_image.push(image);
                if(level_up_data_dict[skill]['level_up'])
                    xp_label.push("<b class='font-large shine'> Your "+skill+" is now level " + current_level);
                else
                    xp_label.push(label);


                var percentage_width_old = (xp_required - old_xp) / (xp_required - xp_required_previous_level) * 100;
                percentage_width_old = 100 - percentage_width_old;
                console.log(percentage_width_old)
                var percentage_width_new = (xp_required - new_xp) / (xp_required - xp_required_previous_level) * 100;
                percentage_width_new = 100 - percentage_width_new;
                console.log(percentage_width_new)

                if(level_up_data_dict[skill]["level_up"] || current_level >= 100) {
                    percentage_width_new = "100"
                }
                if(percentage_width_new >= 100) {
                    percentage_width_new = 100;
                }
                var backgroundColor = "lime";
                if(current_level >= 100) {
                    backgroundColor = "cyan";
                }


                continue;
            }

            if(!isNaN(label))
                label = "+" + format_number(label);

            if(label.endsWith("(NEW)"))
            {
                label = label.substring(0, label.length-5);
                label += " <img class='blink' src='https://cdn.idle-pixel.com/images/new.png' />"
            }
            if(label.endsWith("(UNIQUE)"))
            {
                label = label.substring(0, label.length-8);
                label += " <img class='blink' src='https://cdn.idle-pixel.com/images/unique.png' />"
            }
            html += "<div class='loot' style='background-color:"+background_color+"'>";
                html += "<img src='https://cdn.idle-pixel.com/"+image+"' class='w50 me-3' />";
                html += label;
            html += "</div>";
        }

        if(xp_image.length > 0) {
            html += "<div style='background-color:#DEDEDE;border-radius:5pt;padding:10px;'>";
        }
        for(var i = 0; i < xp_image.length; i++ ) {
            html += "<div style='margin:10px 0px;'>";
            html += "<table width='100%'>";
                html += "<tr>";
                    html += "<td width='60px'>";
                        html += "<center><img src='https://cdn.idle-pixel.com/"+xp_image[i]+"' class='w50' /></center>";
                    html += "</td>";
                    html += "<td>";
                        html += xp_label[i];
                        if(progress_bar[i] != null)
                    html += "<br /><span class='color-grey font-large'>" + progress_bar[i] + '</span>';
                    html += "</td>";
                html += "</tr>";
            html += "</table>";
        html += "</div>";
        }
        if(xp_image.length > 0) {
            html += "</div>";
        }

        if(extra_data.startsWith("RAW_HTML=")) {
            html += extra_data.substring(9);
        }
        if(extra_data == "is_area_monster") {

            if(Globals.last_area_fight != "none") {
                document.getElementById("modal-loot-collect-and-fight").style.display = "";
            }
            
        }

        loot_body.innerHTML = html;

        document.getElementById("modal-loot-collect-button").onclick = function()
        {
            switch(extra_data)
            {
                case "brewing_required":
                    Modals.open_image_modal("WARNING","images/warning.png", "You will only have access to your harvests once you've unlocked the brewing skill.<br /><br /><span class='color-grey font-small'>Try questing to unlock this skill.</span>");
                break;
            }
        }
        try {
            var logObj = new LogManager()
            logObj.add_entry('monster_drop', logger);
          } catch (error) {
            console.log(error);
          }
          
        
        
        Modals.toggle("modal-loot");
    }

    static clicks_balance() {
        Modals.open_image_modal('The Balance of Life', 'images/balance.png', 'Binding this to your account means that <b>your account will continue to run up to 8h when you are not online!</b>', 'Activate', 'Cancel', 'ACTIVATE_BALANCE_OF_LIFE')
    }

    static clicks_pyre_logs() {
        Modals.open_image_modal('Pyre Logs', 'images/pyre_logs.png', 'Burn pyre logs in your oven?<br /><br /><i class="color-grey">Note that heat potion works here.</i>', 'Burn', 'Cancel', 'BURN_PYRE_LOGS')
    }

    static clicks_faradox_fake_final() {
        alert('todo')
        return;
        Modals.open_image_modal('Faradox', 'images/faradox_100.png', 'Are you sure you want to fight me?', 'Fight!', 'Cancel', 'FIGHT_FARADOX_FINAL_PANEL_FAKE=1')
    }

    static purchase_animal(item, img_var) {
        if(Items.getItem("mini_quest_breeding_shop") == 2) {
            Modals.purchase_animal_gender(item, img_var);
            return;
        }
        Modals.open_image_modal('Purchase Animal', 'images/'+img_var+'.png', 'Did you want to purchase this?', 'Buy the Animal!', 'Cancel', 'BUY_ANIMAL=' + item + "~random")
    }

    static clicks_diamond_axe() {
        if(Items.getItem("mini_quest_chop_ent") == 1) {
            websocket.send('CLICKS_DIAMOND_AXE')
            return;
        }
        Modals.clicks_general_tool();
    }
    static purchase_animal_gender(item, img_var) {
        var maleBtn = "<button class='background-primary' data-bs-dismiss='modal' onclick='websocket.send(\"BUY_ANIMAL="+item+"~male\")'>Buy Male</button>";
        var femaleBtn = "<button  class='background-primary' data-bs-dismiss='modal' onclick='websocket.send(\"BUY_ANIMAL="+item+"~female\")'>Buy Female</button>";
        var extraHTML = maleBtn + "&nbsp;&nbsp;" + femaleBtn;
        Modals.open_image_modal('Purchase Animal', 'images/'+img_var+'.png', 'Did you want to purchase this?<br /><br />' + extraHTML, null, 'Cancel', null);
    }

    static clicksActivedAnimal(slug, sick, hasLoot, xp) {

        if(hasLoot && sick == 0) {
            Modals.open_image_modal('COLLECT LOOT', 'images/loot_bag.png', "Loot is available from this animal.<br /><br /><span class='color-grey font-small'>Animals typically produce loot every 24h of your playtime.</span>", 'Collect', 'Cancel', 'COLLECT_LOOT_ANIMAL=' + slug);
            return;
        }
        var text = "Do you want to kill this animal?";
        var text2 = "You will gain "+format_number(xp)+" breeding XP."

        if(sick == 1) {
            text2 = "You will only gain 75% of the breeding XP. Consider curing the animal with the help of brewing."
        } else if(sick == 2) {
            text2 = "You will only gain 75% of the breeding XP as this animal has died."
        }
        Modals.open_image_modal('SLAUGHTER', 'images/death.png', text + "<br /><br /><span class='color-grey font-small'>"+text2+"</span>", 'Kill', 'Cancel', 'KILL_ANIMAL=' + slug);
    }

    static activate_animal(animal) {
        var animal_general_name = animal.split("_")[1];
        document.getElementById("id-modal-inactive-animal").src = "https://cdn.idle-pixel.com/images/"+animal+".png";
        document.getElementById("id-modal-inactive-animal-pen-img").src = "https://cdn.idle-pixel.com/images/"+animal_general_name+"_pen.png";
        document.getElementById("id-modal-inactive-animal-pen-tokens").innerHTML = Breeding.get_token_per_animal(animal_general_name);
        
        document.getElementById("id-modal-inactive-animal-activate-btn").onclick = function() {
            websocket.send('ACTIVATE_ANIMAL=' + animal);
        }
        document.getElementById("id-modal-inactive-animal-trade-btn").onclick = function() {
            Modals.convert_to_tokens_animal(animal)
        }
        Modals.toggle('modal-inactive-animal')
    }

    static convert_to_tokens_animal(animal) {
        Modals.open_input_dialogue_with_value(
            animal,
               "Trade for Tokens",
               "Enter the amount of animals you wish to trade for tokens",
               Items.getItem(animal),
               "SELL_ANIMAL"
        );
    }

    static clicks_mushed_food() {
        Modals.open_input_dialogue_with_value(
            "mushed_food",
               "Mushed Food",
               "Enter the amount of mushed food you wish to reuse",
               Items.getItem("mushed_food"),
               "CAMEL_MUSHED_FOOD"
        );
    }
    
    static clicks_breeding_egg(item) {
        if(Items.getItem(item) == 1) {
            Modals.open_image_modal('Crack Breeding Egg', 'images/'+item+'.png', 'Cracking an egg will give you a male or female <b>inactive</b> animal.<br /><br /><span class="color-grey font-small">Inactive animals do not consume food or produce any products.  You may own as many as you want without worrying.</span>', 'Crack Egg', 'Cancel', 'BREEDING_CRACK_EGG=' + item + "~" + 1)
        } else {
            Modals.open_input_dialogue_with_value(
                item,
                   "Crack Eggs",
                   "Enter the amount of eggs you wish to crack",
                   Items.getItem(item),
                   "BREEDING_CRACK_EGG"
            );
        }
        
    }

    static fight_faradox_boss(id) {
        Modals.open_image_modal('Faradox', 'images/boss_'+id+'_monster_idle_0.png', 'Do you want to fight?', 'Yes!', 'Cancel', 'FIGHT_FARADOX_BOSS=1')
    }

    static clicks_breeding_exchange_food(item_req, food_var) {
        var dict = {}
        dict[item_req] = 1;

        Modals.open_modern_input_dialogue_with_value(
            item_req,
            "images/"+food_var+".png",
            dict,
            "PLUS_ONE",
            null,
            'Trade for Breeding Food',
            'BUY_BREEDING_FOOD=' + item_req,
        );
    }

    static clicks_pen_tr(value) {
        Modals.open_image_modal('Trade', 'images/'+value+'.png', 'Trade animals for land?', 'Make the Trade', 'Cancel', 'TRADE_BREEDING_LAND=' + value);
    }

    static clicks_teleport_crystal() {
        var html = "";
        var cooldownHtml = "";
        var img = "teleport_crystal";

        if(Items.getItem("teleport_crystal_cooldown") > 0) {
            img = "teleport_crystal_depleted";
            cooldownHtml += "<br /><br /><span class='color-grey'>You may not use the teleport crystal for: " + format_time(Items.getItem("teleport_crystal_cooldown"));
        }

        var checked = "checked";
        if(Items.getItem("toggle_teleprot_crystal_shortcut") == 1) checked = "";
        html += "Can be used to teleport out of combat by clicking your name.  You can also use the shortcut 'T' to activate the crystal in combat.<br /><br />Note that the crystal can only be used every 24h.<br /><br /><input onclick='websocket.send(\"CUSTOMIZE_UI=toggle_teleprot_crystal_shortcut~none\");' type='checkbox' "+checked+" /> 'T' shortcut active"

        Modals.open_image_modal('Teleport Crystal', 'images/'+img+'.png', html + cooldownHtml, null, 'Close', null);
    }
    static clicks_gem_bag() {
        Modals.open_image_modal('Gem Bag', 'images/gem_bag.png', 'Open one gem bag?', 'Open', 'Cancel', 'OPEN_GEM_BAG')
    }

    static clicks_general_tool() {
        if(Items.getItem("socket_scroll") == 0) {
            Modals.open_image_modal('Upgrading Tools', 'images/socket_scroll.png', 'You can only upgrade tools after finding the gem socket scroll book in the gathering area: <b>gem mine</b>.', null, 'Close', null);
        } else {
            switch_panels('panel-sockets');
        }
    }
    static open_time_warp_chemist_quest_modal() {
        document.getElementById("modal-time-warp-chemist-quest-menu-tree_dust_quest").innerHTML = Items.getItem('tree_dust_quest');
        document.getElementById("modal-time-warp-chemist-quest-menu-farm_dust_quest").innerHTML = Items.getItem('farm_dust_quest');
        document.getElementById("modal-time-warp-chemist-quest-menu-cooks_dust_quest").innerHTML = Items.getItem('cooks_dust_quest');
        document.getElementById("modal-time-warp-chemist-quest-menu-fighting_dust_quest").innerHTML = Items.getItem('fighting_dust_quest');

        Modals.toggle('modal-time-warp-chemist-quest-menu')
    }

    static open_time_warp_chemist_quest_mix_modal() {
        Modals.toggle('modal-time-warp-chemist-quest-mix')
    }

    static time_warp_chemist_mix() {
        var tree_dust_quest = document.getElementById("modal-time-warp-chemist-quest-mix-tree_dust_quest").value;
        var farm_dust_quest = document.getElementById("modal-time-warp-chemist-quest-mix-farm_dust_quest").value;
        var cooks_dust_quest = document.getElementById("modal-time-warp-chemist-quest-mix-cooks_dust_quest").value;
        var fighting_dust_quest = document.getElementById("modal-time-warp-chemist-quest-mix-fighting_dust_quest").value;

        websocket.send('TIME_WARP_CHEMIST_MIX=' + tree_dust_quest + '~' + farm_dust_quest + '~' + cooks_dust_quest + '~' + fighting_dust_quest);
       
    }
    static open_shop_merchant_item(id)
    {
        var merchantItem = Items.getItemString("merchant_selling_item_" + id);
        var merchantAmount = Items.getItemString("merchant_selling_item_amount_" + id);

        var barterItem = Items.getItemString("merchant_barter_item_" + id);
        var barterAmount = Items.getItemString("merchant_barter_amount_" + id);

        Modals.open_image_modal('Merchant', 'images/merchant.png', '<img style="margin-top:-5px" src="https://cdn.idle-pixel.com/images/'+merchantItem+'.png" class="w50" /> <span style="font-size:20pt">' + format_number(merchantAmount) + ' ' + merchantItem.replace(/_/g, " ") + '</span><br /><br /><b><span style="font-size:20pt;color:grey;">FOR YOUR</span></b><br /><br /><img class="w50" src="https://cdn.idle-pixel.com/images/'+barterItem+'.png" style="margin-top:-5px" /> <span style="font-size:20pt">' + barterAmount + ' ' + barterItem.replace(/_/g, " ") + '</span>', 'Make the Trade', 'No thanks.', "MERCHANT_BARTER=" + id);
    }

    static clicks_chocolate_egg(egg)
    {
        if(Items.getItem("chocolate_egg_given") == 0)
        {
            websocket.send('GIVE_EGG=chocolate_egg');
        }
        else
        {
            Modals.open_custom_crafting('easter_2023')
        }
    }

    
    static clicks_chocolate_crafted_egg(egg)
    {
        Modals.open_image_modal('Easter Bunny', 'images/'+egg+'.png', 'Make the easter bunny taste this egg type?', 'Give to Bunny', 'Cancel', 'GIVE_EGG=' + egg)
    }

    
    static clicks_merchant()
    {
        if(Items.getItem('merchant_timer') > 0)
            Modals.open_image_modal('Merchant', 'images/x.png', 'The merchant is currently setting up shop.', null, 'Close', null)
        else
            Modals.open_image_modal('Merchant', 'images/merchant.png', 'Would you like me to rotate items from the shop?  This might take some time as I need to go back home and fetch these items.<br /><br />Rotating items takes 24h.<br /><br /><i>You cannot buy items when the merchant is gone to get new items.</i>', 'Rotate Items', 'Cancel', 'ROTATE_MERCHANT')
    }

    static train_combat_network_unlock() {
        Modals.toggle("modal-combat-train-network-choices");
    }

    static is_quest_modal_visible()
    {
        return $('#modal-quest').is(':visible');
    }

    static open_odd_one_out_puzzle() {
        OddOneOutPuzzle.reset(0);
        Modals.toggle("modal-odd-one-out-puzzle");
    }
    

    static clicksSeedCompactor() {
        var contentDOM = document.getElementById("modal-seed-compactor-content");
        var spans = contentDOM.querySelectorAll('[data-seed]')
        for(var i = 0; i < spans.length; i++) {
            var seedValue = spans[i].getAttribute("data-seed");
            if(Items.getItem(seedValue) >= 100) {
                spans[i].style.color = "green";
            } else {
                spans[i].style.color = "red";
            }
        }
        Modals.toggle("modal-seed-compactor");
    }
    static close_quest_dialogue()
    {
        if(Modals.is_quest_modal_visible())
            Modals.toggle("modal-quest");
    }
    

    static chocolateFactory() {
        if(Items.getItem('chocolate_factory') == 1) {
            set_image_src("modal-chocolate-factory-item", "images/" + Items.getItemString("easter2024_item") + ".png");
            document.getElementById("modal-chocolate-factory-amount").innerHTML = format_number(Items.getItem("easter2024_amount"));
            Modals.toggle('modal-chocolate-factory')
        }
    }


    static quest_animation_scroll_timeout = 20
    static skipQuestAnimation() {
        Modals.quest_animation_scroll_timeout = 0;
    }
    static open_quest_dialogue(title, image, message, btnName1, btnName2,
        btnName3, btnName4, btnCallback1, btnCallback2, btnCallback3, btnCallback4, animate)
    {
        document.getElementById("modal-quest-title").innerHTML = title;
        document.getElementById("modal-quest-image-src").src = get_image(image);
        document.getElementById("modal-quest-message").innerHTML = "";

        if(!Modals.is_quest_modal_visible())
            Modals.toggle("modal-quest");

        hide_buttons();
        play_text(message, animate, 0)
        function play_text(text, animate, i)
        {
            
            if(!animate || Modals.quest_animation_scroll_timeout == 0)
            {
                document.getElementById("modal-quest-message").innerHTML = text;
                configure_buttons();
                Modals.quest_animation_scroll_timeout = 20;
                if(Sounds.audio != null) {
                    Sounds.audio.pause();
                    Sounds.audio.currentTime = 0;
                }
                return;
            }
            
            Sounds.play("https://cdn.idle-pixel.com/sounds/scroll_text.mp3");
            setTimeout(function() {
                var txt = text[i];
                $('#modal-quest-message').append(txt)
                if($('#modal-quest-message').text().length >= text.length)
                {
                    configure_buttons();
                    if(Sounds.audio != null) {
                        Sounds.audio.pause();
                        Sounds.audio.currentTime = 0;
                    }
            
                    return;
                }
                play_text(text, true, i+=1)

            }, Modals.quest_animation_scroll_timeout)
            
        }

        function hide_buttons()
        {
            configure_button("", "", 1);
            configure_button("", "", 2);
            configure_button("", "", 3);
            configure_button("", "", 4);
        }

        function configure_buttons()
        {
            configure_button(btnName1, btnCallback1, 1);
            configure_button(btnName2, btnCallback2, 2);
            configure_button(btnName3, btnCallback3, 3);
            configure_button(btnName4, btnCallback4, 4);
        }
        

        function configure_button(btnName, btnCommand, index)
        {
            document.getElementById("modal-quest-btn-" + index).innerHTML = btnName;
            if(btnName.length > 0)
            {
                document.getElementById("modal-quest-btn-" + index).style.display = "";
            }
            else
            {
                document.getElementById("modal-quest-btn-" + index).style.display = "none";
            }

            if(btnCommand.length > 0)
            {
                document.getElementById("modal-quest-btn-" + index).onclick = function()
                {
                    Sounds.play(Sounds.VARIABLE_MENU);
                    websocket.send("QUEST=" + btnCommand);
                }
            }
            else
            {
                document.getElementById("modal-quest-btn-" + index).onclick = function()
                {
                    Modals.close_quest_dialogue();
                    Sounds.play(Sounds.VARIABLE_MENU);
                }
            }
        }
    }

    static open_error_dialogue(msg) {
        Modals.open_image_modal("ERROR","images/x.png", msg, null, "Close", null);
    }

    static clicksFightPointsItemBox() {
        Modals.toggle('modal-fightpoints');
    }
    
    static clicksCannon() {
        if((Items.getItem("researcher_points") >= 500000000 && Items.getItemString("criptoe_path_selected") == "sea") || Items.getItem('criptoe_path_perm_sea') > 0) {
            var autoCannonOn = Items.getItem('auto_cannon_on') >= 1;

            if(autoCannonOn) {
                Modals.open_image_modal("AUTOCANNON","images/cannon_large.png", "Turn auto cannon <b>OFF</b>?<br /><br /><i class='color-grey'>With it off, you're cannon will no longer fire automatically.</i>", "Turn OFF", "Cancel", "SETTINGS=auto_cannon_on");
            } else {
                Modals.open_image_modal("AUTOCANNON","images/cannon_large.png", "Turn auto cannon <b>ON</b>?<br /><br /><i class='color-grey'>With it on, you're cannon will automatically fire if the rolled number is over 80% of possible values.</i>", "Turn ON", "Cancel", "SETTINGS=auto_cannon_on");
            }
        }   
    }

    static open_furnace_dialogue()
    {
        if(Items.getItemString("furnace_ore_type") != "none")
        {
            Modals.open_image_modal("FURNACE RUNNING","images/warning.png", "You're furnace is already running.  Would you like to stop?<br /><br /><span class='color-grey font-small'>Remaining ore and oil will be lost.</span>", "Stop Furnace", "Cancel", "RESET_FURNACE");
        }
        else
        {
            document.getElementById("modal-furnace-image").src = "https://cdn.idle-pixel.com/images/"+Furnace.getFurnace()+".png";
            document.getElementById("modal-furnace-capacity").innerHTML = Furnace.getFurnaceCapacity();
            document.getElementById("modal-furnace-select-ore").style.display= "";
            document.getElementById("modal-furnace-input").style.display= "none";
            document.getElementById("modal-furnace-capacty").innerHTML = "<img src='https://cdn.idle-pixel.com/images/"+Furnace.getFurnace()+".png' class='w20' /> " + Furnace.getFurnaceCapacity() + " Capacity";


            if(Items.getItem("oil") >= 5) {
                document.getElementById("furnace-smelt-ore-iron-oil").style.color = "lime";
            } else {
                document.getElementById("furnace-smelt-ore-iron-oil").style.color = "red";
            }
            if(Items.getItem("oil") >= 15) {
                document.getElementById("furnace-smelt-ore-silver-oil").style.color = "lime";
            } else {
                document.getElementById("furnace-smelt-ore-silver-oil").style.color = "red";
            }
            if(Items.getItem("oil") >= 50) {
                document.getElementById("furnace-smelt-ore-gold-oil").style.color = "lime";
            } else {
                document.getElementById("furnace-smelt-ore-gold-oil").style.color = "red";
            }

            if(Items.getItem("oil") >= 100) {
                document.getElementById("furnace-smelt-ore-promethium-oil").style.color = "lime";
            } else {
                document.getElementById("furnace-smelt-ore-promethium-oil").style.color = "red";
            }

            if(Items.getItem("charcoal") >= 5) {
                document.getElementById("furnace-smelt-ore-promethium-charcoal").style.color = "lime";
            } else {
                document.getElementById("furnace-smelt-ore-promethium-charcoal").style.color = "red";
            }

            
            if(Items.getItem("oil") >= 1000) {
                document.getElementById("furnace-smelt-ore-titanium-oil").style.color = "lime";
            } else {
                document.getElementById("furnace-smelt-ore-titanium-oil").style.color = "red";
            }

            if(Items.getItem("charcoal") >= 20) {
                document.getElementById("furnace-smelt-ore-titanium-charcoal").style.color = "lime";
            } else {
                document.getElementById("furnace-smelt-ore-titanium-charcoal").style.color = "red";
            }

            if(Items.getItem("lava") >= 1) {
                document.getElementById("furnace-smelt-ore-titanium-lava").style.color = "lime";
            } else {
                document.getElementById("furnace-smelt-ore-titanium-lava").style.color = "red";
            }

            if(Items.getItem("oil") >= 5000) {
                document.getElementById("furnace-smelt-ore-ancient-oil").style.color = "lime";
            } else {
                document.getElementById("furnace-smelt-ore-ancient-oil").style.color = "red";
            }

            if(Items.getItem("charcoal") >= 40) {
                document.getElementById("furnace-smelt-ore-ancient-charcoal").style.color = "lime";
            } else {
                document.getElementById("furnace-smelt-ore-ancient-charcoal").style.color = "red";
            }

            if(Items.getItem("lava") >= 2) {
                document.getElementById("furnace-smelt-ore-ancient-lava").style.color = "lime";
            } else {
                document.getElementById("furnace-smelt-ore-ancient-lava").style.color = "red";
            }

            if(Items.getItem("plasma") >= 1) {
                document.getElementById("furnace-smelt-ore-ancient-plasma").style.color = "lime";
            } else {
                document.getElementById("furnace-smelt-ore-ancient-plasma").style.color = "red";
            }

            if(Items.getItem("oil") >= 10000) {
                document.getElementById("furnace-smelt-ore-dragon-oil").style.color = "lime";
            } else {
                document.getElementById("furnace-smelt-ore-dragon-oil").style.color = "red";
            }

            if(Items.getItem("lava") >= 5) {
                document.getElementById("furnace-smelt-ore-dragon-lava").style.color = "lime";
            } else {
                document.getElementById("furnace-smelt-ore-dragon-lava").style.color = "red";
            }

            if(Items.getItem("plasma") >= 3) {
                document.getElementById("furnace-smelt-ore-dragon-plasma").style.color = "lime";
            } else {
                document.getElementById("furnace-smelt-ore-dragon-plasma").style.color = "red";
            }

            if(Items.getItem("dragon_fire") >= 1) {
                document.getElementById("furnace-smelt-ore-dragon-dragon_fire").style.color = "lime";
            } else {
                document.getElementById("furnace-smelt-ore-dragon-dragon_fire").style.color = "red";
            }

            if(Items.getItem("iron_bar_unlocked") > 0) {
                document.getElementById("modal-furnace-locked-iron").style.display = "none";
                document.getElementById("modal-furnace-unlocked-iron").style.display = "";
            } else {
                if(Items.getItem("bronze_bar_total") > 0) {
                    document.getElementById("modal-furnace-locked-iron-btn").style.color = "yellow";
                    document.getElementById("modal-furnace-locked-iron-btn").innerHTML = "CAN UNLOCK!";
                    document.getElementById("modal-furnace-locked-iron-btn").classList.add('animation-glow')
                }
            }
            if(Items.getItem("silver_bar_unlocked") > 0) {
                document.getElementById("modal-furnace-locked-silver").style.display = "none";
                document.getElementById("modal-furnace-unlocked-silver").style.display = "";
            } else {
                if(Items.getItem("iron_bar_total") > 0) {
                    document.getElementById("modal-furnace-locked-silver-btn").style.color = "yellow";
                    document.getElementById("modal-furnace-locked-silver-btn").innerHTML = "CAN UNLOCK!";
                    document.getElementById("modal-furnace-locked-silver-btn").classList.add('animation-glow')
                }
            }
            if(Items.getItem("gold_bar_unlocked") > 0) {
                document.getElementById("modal-furnace-locked-gold").style.display = "none";
                document.getElementById("modal-furnace-unlocked-gold").style.display = "";
            } else {
                if(Items.getItem("silver_bar_total") > 0) {
                    document.getElementById("modal-furnace-locked-gold-btn").style.color = "yellow";
                    document.getElementById("modal-furnace-locked-gold-btn").innerHTML = "CAN UNLOCK!";
                    document.getElementById("modal-furnace-locked-gold-btn").classList.add('animation-glow')
                }
            }
            if(Items.getItem("promethium_bar_unlocked") > 0) {
                document.getElementById("modal-furnace-locked-promethium").style.display = "none";
                document.getElementById("modal-furnace-unlocked-promethium").style.display = "";
            } else {
                if(Items.getItem("gold_bar_total") > 0) {
                    document.getElementById("modal-furnace-locked-promethium-btn").style.color = "yellow";
                    document.getElementById("modal-furnace-locked-promethium-btn").innerHTML = "CAN UNLOCK!";
                    document.getElementById("modal-furnace-locked-promethium-btn").classList.add('animation-glow')
                }
            }
            if(Items.getItem("titanium_bar_unlocked") > 0) {
                document.getElementById("modal-furnace-locked-titanium").style.display = "none";
                document.getElementById("modal-furnace-unlocked-titanium").style.display = "";
            } else {
                if(Items.getItem("promethium_bar_total") > 0) {
                    document.getElementById("modal-furnace-locked-titanium-btn").style.color = "yellow";
                    document.getElementById("modal-furnace-locked-titanium-btn").innerHTML = "CAN UNLOCK!";
                    document.getElementById("modal-furnace-locked-titanium-btn").classList.add('animation-glow')
                }
            }
            if(Items.getItem("ancient_bar_unlocked") > 0) {
                document.getElementById("modal-furnace-locked-ancient").style.display = "none";
                document.getElementById("modal-furnace-unlocked-ancient").style.display = "";
            } else {
                if(Items.getItem("titanium_bar_total") > 0) {
                    document.getElementById("modal-furnace-locked-ancient-btn").style.color = "yellow";
                    document.getElementById("modal-furnace-locked-ancient-btn").innerHTML = "CAN UNLOCK!";
                    document.getElementById("modal-furnace-locked-ancient-btn").classList.add('animation-glow')
                }
            }
            if(Items.getItem("dragon_bar_unlocked") > 0) {
                document.getElementById("modal-furnace-locked-dragon").style.display = "none";
                document.getElementById("modal-furnace-unlocked-dragon").style.display = "";
            } else {
                if(Items.getItem("ancient_bar_total") > 0) {
                    document.getElementById("modal-furnace-locked-dragon-btn").style.color = "yellow";
                    document.getElementById("modal-furnace-locked-dragon-btn").innerHTML = "CAN UNLOCK!";
                    document.getElementById("modal-furnace-locked-dragon-btn").classList.add('animation-glow')
                }
            }
            
            document.getElementById("furnace-smelt-ore-copper-value").value = Modals.load_max_ore_smelt_possible('copper');
            document.getElementById("furnace-smelt-ore-iron-value").value = Modals.load_max_ore_smelt_possible('iron');
            document.getElementById("furnace-smelt-ore-silver-value").value = Modals.load_max_ore_smelt_possible('silver');
            document.getElementById("furnace-smelt-ore-gold-value").value = Modals.load_max_ore_smelt_possible('gold');
            document.getElementById("furnace-smelt-ore-promethium-value").value = Modals.load_max_ore_smelt_possible('promethium');
            document.getElementById("furnace-smelt-ore-titanium-value").value = Modals.load_max_ore_smelt_possible('titanium');
            document.getElementById("furnace-smelt-ore-ancient-value").value = Modals.load_max_ore_smelt_possible('ancient_ore');
            document.getElementById("furnace-smelt-ore-dragon-value").value = Modals.load_max_ore_smelt_possible('dragon_ore');
            Modals.toggle("modal-furnace");
        }
        
    }

    static open_foundry_dialogue()
    {
        if(Items.getItemString("foundry_log") != "none")
        {
            Modals.open_image_modal("CHARCOAL FOUNDRY RUNNING","images/warning.png", "You're charcoal foundry is already running.  Would you like to stop?<br /><br /><span class='color-grey font-small'>Remaining logs and oil will be lost.</span>", "Stop Foundy", "Cancel", "RESET_FOUNDRY");
        }
        else
        {
            if(Items.getItem("oak_logs") == 0) hide_element("foundry-button-oak_logs");
            if(Items.getItem("oak_logs") > 0) show_element("foundry-button-oak_logs");
            
            if(Items.getItem("willow_logs") == 0) hide_element("foundry-button-willow_logs");
            if(Items.getItem("willow_logs") > 0) show_element("foundry-button-willow_logs");

            if(Items.getItem("maple_logs") == 0) hide_element("foundry-button-maple_logs");
            if(Items.getItem("maple_logs") > 0) show_element("foundry-button-maple_logs");

            if(Items.getItem("stardust_logs") == 0) hide_element("foundry-button-stardust_logs");
            if(Items.getItem("stardust_logs") > 0) show_element("foundry-button-stardust_logs");

            if(Items.getItem("pine_logs") == 0) hide_element("foundry-button-pine_logs");
            if(Items.getItem("pine_logs") > 0) show_element("foundry-button-pine_logs");

            if(Items.getItem("redwood_logs") == 0) hide_element("foundry-button-redwood_logs");
            if(Items.getItem("redwood_logs") > 0) show_element("foundry-button-redwood_logs");

            if(Items.getItem("dense_logs") == 0) hide_element("foundry-button-dense_logs");
            if(Items.getItem("dense_logs") > 0) show_element("foundry-button-dense_logs");


            document.getElementById("modal-foundry-select-logs").style.display= "";
            document.getElementById("modal-foundry-input").style.display = "none";

            Modals.toggle("modal-foundry");
        }
        
    }

    static open_foundry_clicks_log(log)
    {
        document.getElementById("modal-foundry-select-logs").style.display= "none";
        document.getElementById("modal-foundry-input").style.display= "";
        document.getElementById("modal-foundry-input-logs").value = log;

        var max_capacity = 100;
        if(Items.getItem("foundry_storage") > 0) max_capacity = 1000;

        var logs_amount = Items.getItem(log);
        if(logs_amount > max_capacity) logs_amount = max_capacity;
        document.getElementById('modal-foundry-input-text').value = logs_amount;
    }
    
    static clicks_green_gardian_key()
    {
        var html = "";

        html += "<b>FIGHT FARADOX GUARDIAN #1?</b>";
        html += "<br /><br />";
        html += '<a href="http://database.idle-pixel.com/faradox_gaurdian_1/" target="_blank"><button>Strategy</button></a>';
        html += "<br /><br />";
        Modals.open_image_modal('GREEN GUARDIAN KEY', 'images/green_gaurdian_key.png', html,'Fight Guardian!','Not now','FIGHT_GUARDIAN=1');
    }

    static clicks_tomb_loot_bags() {
        Modals.open_input_dialogue_with_value(
            "guardian_combo_loot",
               "Open Loot",
               "Enter the amount of loot you wish to open",
               Items.getItem("guardian_combo_loot"),
               "OPEN_GUARDIAN_COMBOT_LOOT"
        );
    }
    
    static clicks_blue_gardian_key()
    {
        var html = "";

        html += "<b>FIGHT FARADOX GUARDIAN #2?</b>";
        html += "<br /><br />";
        html += "<span style='color:grey'>";
        html += '<a href="http://database.idle-pixel.com/faradox_gaurdian_2/" target="_blank"><button>Strategy</button></a>';
        html += "<br /><br />";

        Modals.open_image_modal('BLUE GUARDIAN KEY', 'images/blue_gaurdian_key.png', html,'Fight Guardian!','Not now','FIGHT_GUARDIAN=2');
    }

    static clicks_purple_gardian_key()
    {
        var html = "";

        html += "<b>FIGHT FARADOX GUARDIAN #3?</b>";
        html += "<br /><br />";
        html += "<span style='color:grey'>";
        html += "<u>Strategy</u>";
        html += "<br /><br />";
        html += "<b style='color:red'>Keep an eye on type of arrow used against you.</b>";
        html += "<br /><br />";
        html += "<span class='color-grey'>If he hits you with a red arrow, you will be infected and your melee attacks will always hit zero from this point on until another arrow is used.</span>";
        html += "<br /><br />";
        html += "<span class='color-grey'>If he hits you with a green arrow, you will be infected and your archery attacks will always hit zero from this point on until another arrow is used.</span>";
        html += "<br /><br />";
        html += "<span class='color-grey'>If he hits you with a blue arrow, you will be infected and your magic spells will be disabled until another arrow is used</span>";
        html += "<br /><br />";
        html += "<span class='color-grey'>If he hits you with a black shiny arrow, he will do a massive amount of damage.</span>";
        html += "<br /><br />";
        html += "</span>";
        Modals.open_image_modal('PURPLE GUARDIAN KEY', 'images/purple_gaurdian_key.png', html,'Fight Guardian!','Not now','FIGHT_GUARDIAN=3');
    }

    static clicks_criptoe_man() {
        Modals.toggle('modal-criptoe-guide');
    }

    static buy_criptoe() {
        Modals.toggle('modal-buy-criptoe')
    }
    static clicks_mixed_gardian_key()
    {
        var html = "";

        html += "<b>FIGHT THE LAST FARADOX GUARDIAN?</b>";
        html += "<br /><br />";
        html += "<span style='color:grey'>";
        html += '<a href="http://database.idle-pixel.com/faradox_gaurdian_4/" target="_blank"><button>Strategy</button></a>';
        html += "<br /><br />";

        Modals.open_image_modal('MISC GUARDIAN KEY', 'images/mixed_gaurdian_key.png', html,'Fight Guardian!','Not now','FIGHT_GUARDIAN=5');
    }

    static combat_xp_lamp()
    {
        Modals.toggle("modal-combat-xp-lamp");
    }


    static clicks_dark_diamond_fragments ()
    {
        if(Items.getItem("dark_diamond_fragments_1") == 0 ||
        Items.getItem("dark_diamond_fragments_2") == 0 ||
        Items.getItem("dark_diamond_fragments_3") == 0 ||
        Items.getItem("dark_diamond_fragments_4") == 0 ||
        Items.getItem("dark_diamond_fragments_5") == 0 ||
        Items.getItem("dark_diamond_fragments_6") == 0)
        {
            Modals.open_image_modal('Dark Diamond Fragments', 'images/x.png', "J∆ƒƒ∆Ǥ∆ʓ∆",null,'Close', null);
        }
        else
        {
            Modals.toggle("modal-dark-diamond-elements");
        }
    }

    static clicks_dark_diamond_stoned()
    {
        Modals.open_image_modal('Dark Diamond', 'images/dark_diamond_stoned.png', "There seems to be tar stuck to the gem.  Do you want to remove it?<br /><br /><span class='color-grey'>Requires a level of 100 mining</span>",'Remove Tar','Close', 'DARK_DIAMOND=remove_tar');
    }

    static clicks_dark_diamond_unpowered()
    {
        Modals.open_image_modal('Dark Diamond', 'images/dark_diamond_unpowered.png', "This gem has lost its power as it was lost centuries ago.  Would you want to restore it with magic?<br /><br /><span class='color-grey'>Requires a level of 100 magic</span>",'Enchant','Close', 'DARK_DIAMOND=restore');
    }

    static dark_diamond_combine_code()
    {
        var value1 = document.getElementById('dark-diamond-input-1').value;
        var value2 = document.getElementById('dark-diamond-input-2').value;
        var value3 = document.getElementById('dark-diamond-input-3').value;
        var value4 = document.getElementById('dark-diamond-input-4').value;

        if(value1.toLowerCase() == 'air' || value1.toLowerCase() == 'water' || value1.toLowerCase() == 'earth' || value1.toLowerCase() == 'fire')
        {}
        else
        {
            Modals.open_image_modal('Dark Diamond Fragments', 'images/faradox.png', "J∆ƒƒ",null,'Close', null);
            return;
        }

        if(value2.toLowerCase() == 'air' || value2.toLowerCase() == 'water' || value2.toLowerCase() == 'earth' || value2.toLowerCase() == 'fire')
        {}
        else
        {
            Modals.open_image_modal('Dark Diamond Fragments', 'images/faradox.png', "J∆ƒƒ",null,'Close', null);
            return;
        }


        if(value3.toLowerCase() == 'air' || value3.toLowerCase() == 'water' || value3.toLowerCase() == 'earth' || value3.toLowerCase() == 'fire')
        {}
        else
        {
            Modals.open_image_modal('Dark Diamond Fragments', 'images/faradox.png', "J∆ƒƒ",null,'Close', null);
            return;
        }

        if(value4.toLowerCase() == 'air' || value4.toLowerCase() == 'water' || value4.toLowerCase() == 'earth' || value4.toLowerCase() == 'fire')
        {}
        else
        {
            Modals.open_image_modal('Dark Diamond Fragments', 'images/faradox.png', "J∆ƒƒ",null,'Close', null);
            return;
        }

        Modals.open_image_modal('Dark Diamond Fragments', 'images/dark_diamond_stoned.png', "Combine fragements into a dark diamond?",'Combine','Close', "DARK_DIAMOND=combine");
    }

    static open_closet()
    {

        if(Items.getItem("mining_skilling_gloves") > 0) document.getElementById("modal-closet-mining-gloves").src = "https://cdn.idle-pixel.com/images/check.png"
        if(Items.getItem("mining_skilling_boots") > 0) document.getElementById("modal-closet-mining-boots").src = "https://cdn.idle-pixel.com/images/check.png"
        if(Items.getItem("mining_skilling_shirt") > 0) document.getElementById("modal-closet-mining-shirt").src = "https://cdn.idle-pixel.com/images/check.png"
        if(Items.getItem("mining_skilling_pants") > 0) document.getElementById("modal-closet-mining-pants").src = "https://cdn.idle-pixel.com/images/check.png"
        
        if(
            Items.getItem("mining_skilling_gloves") > 0 &&
            Items.getItem("mining_skilling_boots") > 0 &&
            Items.getItem("mining_skilling_shirt") > 0 &&
            Items.getItem("mining_skilling_pants") > 0
        )
        document.getElementById("modal-closet-mining-bonus-xp").innerHTML = "-1";
    
        if(Items.getItem("crafting_skilling_gloves") > 0) document.getElementById("modal-closet-crafting-gloves").src = "https://cdn.idle-pixel.com/images/check.png"
        if(Items.getItem("crafting_skilling_boots") > 0) document.getElementById("modal-closet-crafting-boots").src = "https://cdn.idle-pixel.com/images/check.png"
        if(Items.getItem("crafting_skilling_shirt") > 0) document.getElementById("modal-closet-crafting-shirt").src = "https://cdn.idle-pixel.com/images/check.png"
        if(Items.getItem("crafting_skilling_pants") > 0) document.getElementById("modal-closet-crafting-pants").src = "https://cdn.idle-pixel.com/images/check.png"
        if(
            Items.getItem("crafting_skilling_gloves") > 0 &&
            Items.getItem("crafting_skilling_boots") > 0 &&
            Items.getItem("crafting_skilling_shirt") > 0 &&
            Items.getItem("crafting_skilling_pants") > 0
        )
        document.getElementById("modal-closet-crafting-bonus-xp").innerHTML = "-1";

        if(Items.getItem("gathering_skilling_gloves") > 0) document.getElementById("modal-closet-gathering-gloves").src = "https://cdn.idle-pixel.com/images/check.png"
        if(Items.getItem("gathering_skilling_boots") > 0) document.getElementById("modal-closet-gathering-boots").src = "https://cdn.idle-pixel.com/images/check.png"
        if(Items.getItem("gathering_skilling_shirt") > 0) document.getElementById("modal-closet-gathering-shirt").src = "https://cdn.idle-pixel.com/images/check.png"
        if(Items.getItem("gathering_skilling_pants") > 0) document.getElementById("modal-closet-gathering-pants").src = "https://cdn.idle-pixel.com/images/check.png"
        document.getElementById("modal-closet-gathering-bonus-xp").innerHTML = Items.get_skilling_outfit_xp_boost_label('gathering') + "%";

        if(Items.getItem("farming_skilling_gloves") > 0) document.getElementById("modal-closet-farming-gloves").src = "https://cdn.idle-pixel.com/images/check.png"
        if(Items.getItem("farming_skilling_boots") > 0) document.getElementById("modal-closet-farming-boots").src = "https://cdn.idle-pixel.com/images/check.png"
        if(Items.getItem("farming_skilling_shirt") > 0) document.getElementById("modal-closet-farming-shirt").src = "https://cdn.idle-pixel.com/images/check.png"
        if(Items.getItem("farming_skilling_pants") > 0) document.getElementById("modal-closet-farming-pants").src = "https://cdn.idle-pixel.com/images/check.png"
        document.getElementById("modal-closet-farming-bonus-xp").innerHTML = Items.get_skilling_outfit_xp_boost_label('farming') + "%";

        if(Items.getItem("brewing_skilling_gloves") > 0) document.getElementById("modal-closet-brewing-gloves").src = "https://cdn.idle-pixel.com/images/check.png"
        if(Items.getItem("brewing_skilling_boots") > 0) document.getElementById("modal-closet-brewing-boots").src = "https://cdn.idle-pixel.com/images/check.png"
        if(Items.getItem("brewing_skilling_shirt") > 0) document.getElementById("modal-closet-brewing-shirt").src = "https://cdn.idle-pixel.com/images/check.png"
        if(Items.getItem("brewing_skilling_pants") > 0) document.getElementById("modal-closet-brewing-pants").src = "https://cdn.idle-pixel.com/images/check.png"
        document.getElementById("modal-closet-brewing-bonus-xp").innerHTML = Items.get_skilling_outfit_xp_boost_label('brewing') + "%";

        if(Items.getItem("woodcutting_skilling_gloves") > 0) document.getElementById("modal-closet-woodcutting-gloves").src = "https://cdn.idle-pixel.com/images/check.png"
        if(Items.getItem("woodcutting_skilling_boots") > 0) document.getElementById("modal-closet-woodcutting-boots").src = "https://cdn.idle-pixel.com/images/check.png"
        if(Items.getItem("woodcutting_skilling_shirt") > 0) document.getElementById("modal-closet-woodcutting-shirt").src = "https://cdn.idle-pixel.com/images/check.png"
        if(Items.getItem("woodcutting_skilling_pants") > 0) document.getElementById("modal-closet-woodcutting-pants").src = "https://cdn.idle-pixel.com/images/check.png"
        document.getElementById("modal-closet-woodcutting-bonus-xp").innerHTML = Items.get_skilling_outfit_xp_boost_label('woodcutting') + "%";

        if(Items.getItem("cooking_skilling_gloves") > 0) document.getElementById("modal-closet-cooking-gloves").src = "https://cdn.idle-pixel.com/images/check.png"
        if(Items.getItem("cooking_skilling_boots") > 0) document.getElementById("modal-closet-cooking-boots").src = "https://cdn.idle-pixel.com/images/check.png"
        if(Items.getItem("cooking_skilling_shirt") > 0) document.getElementById("modal-closet-cooking-shirt").src = "https://cdn.idle-pixel.com/images/check.png"
        if(Items.getItem("cooking_skilling_pants") > 0) document.getElementById("modal-closet-cooking-pants").src = "https://cdn.idle-pixel.com/images/check.png"
        document.getElementById("modal-closet-cooking-bonus-xp").innerHTML = Items.get_skilling_outfit_xp_boost_label('cooking') + "%";

        if(Items.getItem("fishing_skilling_gloves") > 0) document.getElementById("modal-closet-fishing-gloves").src = "https://cdn.idle-pixel.com/images/check.png"
        if(Items.getItem("fishing_skilling_boots") > 0) document.getElementById("modal-closet-fishing-boots").src = "https://cdn.idle-pixel.com/images/check.png"
        if(Items.getItem("fishing_skilling_shirt") > 0) document.getElementById("modal-closet-fishing-shirt").src = "https://cdn.idle-pixel.com/images/check.png"
        if(Items.getItem("fishing_skilling_pants") > 0) document.getElementById("modal-closet-fishing-pants").src = "https://cdn.idle-pixel.com/images/check.png"
        document.getElementById("modal-closet-fishing-bonus-xp").innerHTML = Items.get_skilling_outfit_xp_boost_label('fishing') + "%";
    
        Modals.toggle("modal-closet");
    }

    static open_faradox_castle()
    {
            Modals.toggle("modal-faradox-castle");
    }

    static clicks_stardust_watch()
    {
        Modals.open_image_modal("STARDUST WATCH", "images/stardust_watch.png", "Fast foward the time by one hour?<br /><br />Requires <img src='https://cdn.idle-pixel.com/images/stardust.png' class='w15' /> 100,000 stardust to operate.", "Activate!", "Close", "ACTIVATE_STARDUST_WATCH");
    }

    static unlock_faradox_castle()
    {
        if(Combat.number_of_blood_monsters_killed() < 14) {
            Modals.open_image_modal("CASTLE", "images/x.png", "You need to kill 14 blood monsters to access the castle.", null, "Close", null, null);
            return;
        }

        Modals.open_image_modal("CASTLE", "images/open_castle_icon.png", "Approach the castle?<br /><br /><span class='color-grey'><i>DonT Do Itt</i></span>", "Approach", "Close", "ACTIVATE_FARADOX_CASTLE");
    }

    static set_country() 
    {   
        var countryElement = document.getElementById("select-country");
        var value = countryElement.value;
        websocket.send('SET_COUNTRY=' + value);
    }
    
    static load_max_ore_smelt_possible(ore) {

        var oil_required_per_ore = Crafting.getOilPerBar(ore);
        var charcoal_per_bar = Crafting.getCharcoalPerBar(ore);
        var lava_per_bar = Crafting.getLavaPerBar(ore);
        var plasma_per_bar = Crafting.getPlasmaPerBar(ore);
        var dragon_fire_per_bar = Crafting.getDragonFirePerBar(ore);
    
        
        var capacity = Furnace.getFurnaceCapacity();
        
        var input_value = capacity;

        if(input_value * oil_required_per_ore > Items.getItem("oil"))
        {
            input_value = Items.getItem("oil") / oil_required_per_ore;
        }

        if(input_value * charcoal_per_bar > Items.getItem("charcoal"))
        {
            input_value = Items.getItem("charcoal") / charcoal_per_bar;
        }

        if(input_value * plasma_per_bar > Items.getItem("plasma"))
        {
            input_value = Items.getItem("plasma") / plasma_per_bar;
        }

        if(input_value * lava_per_bar > Items.getItem("lava"))
        {
            input_value = Items.getItem("lava") / lava_per_bar;
        }

        if(input_value * dragon_fire_per_bar > Items.getItem("dragon_fire"))
        {
            input_value = Items.getItem("dragon_fire") / dragon_fire_per_bar;
        }

        if(input_value > Items.getItem(ore))
            input_value = Items.getItem(ore);
        

        return parseInt(input_value);
    }

    static open_furnace_clicks_ore(ore)
    {
        if(Crafting.getOilPerBar(ore) > Items.getItem("oil"))
        {
            Modals.open_image_modal("FURNACE", "images/x.png", "You don't have enough oil to smelt this ore.", "Close", null , "");
            return;
        }

        if(Items.getItem(ore) == 0)
        {
            Modals.open_image_modal("FURNACE", "images/x.png", "You don't have this ore!", "Close", null , "");
            return;
        }

        document.getElementById("modal-furnace-select-ore").style.display= "none";
        document.getElementById("modal-furnace-input").style.display= "";
        document.getElementById("modal-furnace-input-ore").value = ore;
        document.getElementById("modal-furnace-ore-selected").innerHTML = "<img src='https://cdn.idle-pixel.com/images/"+ore+".png' class='w30' /> " + getItemName(ore);
        document.getElementById("modal-furnace-oil-required").innerHTML = "<img src='https://cdn.idle-pixel.com/images/oil.png' class='w15' /> " + Crafting.getOilPerBar(ore) + " per bar";

        var charcoal_per_bar = Crafting.getCharcoalPerBar(ore);
        var lava_per_bar = Crafting.getLavaPerBar(ore);
        var plasma_per_bar = Crafting.getPlasmaPerBar(ore);
        var dragon_fire_per_bar = Crafting.getDragonFirePerBar(ore);
        if(charcoal_per_bar > 0) show_element("modal-furnace-charcoal-div"); else hide_element("modal-furnace-charcoal-div");
        if(lava_per_bar > 0) show_element("modal-furnace-lava-div"); else hide_element("modal-furnace-lava-div");
        if(plasma_per_bar > 0) show_element("modal-furnace-plasma-div"); else hide_element("modal-furnace-plasma-div");
        if(dragon_fire_per_bar > 0) show_element("modal-furnace-dragon-div"); else hide_element("modal-furnace-dragon-div");
    
        document.getElementById("modal-furnace-charcoal-required").innerHTML = "<img src='https://cdn.idle-pixel.com/images/charcoal.png' class='w15' /> " + Crafting.getCharcoalPerBar(ore) + " per bar";
        document.getElementById("modal-furnace-lava-required").innerHTML = "<img src='https://cdn.idle-pixel.com/images/lava.png' class='w15' /> " + Crafting.getLavaPerBar(ore) + " per bar";
        document.getElementById("modal-furnace-plasma-required").innerHTML = "<img src='https://cdn.idle-pixel.com/images/plasma.png' class='w15' /> " + Crafting.getPlasmaPerBar(ore) + " per bar";
        document.getElementById("modal-furnace-dragon-required").innerHTML = "<img src='https://cdn.idle-pixel.com/images/dragon_fire.png' class='w15' /> " + Crafting.getDragonFirePerBar(ore) + " per bar";

        
        var capacity = Furnace.getFurnaceCapacity();
        var oil_required_per_ore = Crafting.getOilPerBar(ore);
        var input_value = capacity;

        if(input_value * oil_required_per_ore > Items.getItem("oil"))
        {
            input_value = Items.getItem("oil") / oil_required_per_ore;
        }

        if(input_value * charcoal_per_bar > Items.getItem("charcoal"))
        {
            input_value = Items.getItem("charcoal") / charcoal_per_bar;
        }

        if(input_value * plasma_per_bar > Items.getItem("plasma"))
        {
            input_value = Items.getItem("plasma") / plasma_per_bar;
        }

        if(input_value * dragon_fire_per_bar > Items.getItem("dragon_fire"))
        {
            input_value = Items.getItem("dragon_fire") / dragon_fire_per_bar;
        }

        if(input_value > Items.getItem(ore))
            input_value = Items.getItem(ore);
        

        document.getElementById("modal-furnace-input-text").value = parseInt(input_value);
    }

    static open_furnace_clicks_back()
    {
        document.getElementById("modal-furnace-select-ore").style.display= "";
        document.getElementById("modal-furnace-input").style.display= "none";
        document.getElementById("modal-furnace-input-ore").value = "";
    }

    static open_foundry_clicks_back()
    {
        document.getElementById("modal-foundry-select-logs").style.display= "";
        document.getElementById("modal-foundry-input").style.display= "none";
        document.getElementById("modal-foundry-input-logs").value = "";
    }

    static open_mining_machinery(machine)
    {
        document.getElementById("modal-mining-machinery-image").src = get_image("images/" + machine + ".png");
        document.getElementById("modal-mining-machinery-oil").innerHTML = Ores.getOilCost(machine);
        document.getElementById("modal-mining-machinery-on").innerHTML = Ores.getMachineriesOn(machine);
        document.getElementById("modal-mining-machinery-total").innerHTML = Items.getItem(machine);

        var levelReq = Ores.getMachineLevel(machine);
        var check_img = " <img class='w15' src='https://cdn.idle-pixel.com/images/x.png' />";
        if(get_level(Items.getItem("mining_xp")) >= levelReq)
            check_img = " <img class='w15' src='https://cdn.idle-pixel.com/images/check.png' />";

            document.getElementById("modal-mining-machinery-level-label").innerHTML = Ores.getMachineLevel(machine) + check_img;

        document.getElementById("modal-mining-machinery-left-arrow").onclick = function() {
            websocket.send("MACHINERY=" + machine + "~" + "decrease");
        }

        document.getElementById("modal-mining-machinery-right-arrow").onclick = function() {
            websocket.send("MACHINERY=" + machine + "~" + "increase");
        }

        if(machine == "drill") {
            var html = "";
            html += "<table width='70%' class='table-list-ores-chances'>";
                html += "<tr>";
                    html += "<th colspan=2>Ore</th>";
                    html += "<th>Chance</th>";
                html += "</tr>";
                html += "<tr>";
                    html += "<td><img src='https://cdn.idle-pixel.com/images/stone.png' /></td>";
                    html += "<td style='border-right:1px solid silver'>Stone</td>";
                    html += "<td>Always</td>";
                html += "</tr>";
                html += "<tr>";
                    html += "<td><img src='https://cdn.idle-pixel.com/images/copper.png' /></td>";
                    html += "<td style='border-right:1px solid silver'>Copper</td>";
                    html += "<td>1/2</td>";
                html += "</tr>";
                html += "<tr>";
                    html += "<td><img src='https://cdn.idle-pixel.com/images/iron.png' /></td>";
                    html += "<td style='border-right:1px solid silver'>Iron</td>";
                    html += "<td>1/7</td>";
                html += "</tr>";
                html += "<tr>";
                    html += "<td><img src='https://cdn.idle-pixel.com/images/silver.png' /></td>";
                    html += "<td style='border-right:1px solid silver'>Silver</td>";
                    html += "<td>1/42</td>";
                html += "</tr>";
            html += "</table>";
            document.getElementById("modal-mining-machinery-chance-table").innerHTML = html;
        }
        if(machine == "crusher") {
            var html = "";
            html += "<table width='70%' class='table-list-ores-chances'>";
                html += "<tr>";
                    html += "<th colspan=2>Ore</th>";
                    html += "<th>Chance</th>";
                html += "</tr>";
                html += "<tr>";
                    html += "<td><img src='https://cdn.idle-pixel.com/images/stone.png' /></td>";
                    html += "<td style='border-right:1px solid silver'>Stone</td>";
                    html += "<td>Always</td>";
                html += "</tr>";
                html += "<tr>";
                    html += "<td><img src='https://cdn.idle-pixel.com/images/copper.png' /></td>";
                    html += "<td style='border-right:1px solid silver'>Copper</td>";
                    html += "<td>Always</td>";
                html += "</tr>";
                html += "<tr>";
                    html += "<td><img src='https://cdn.idle-pixel.com/images/iron.png' /></td>";
                    html += "<td style='border-right:1px solid silver'>Iron</td>";
                    html += "<td>1/5</td>";
                html += "</tr>";
                html += "<tr>";
                    html += "<td><img src='https://cdn.idle-pixel.com/images/silver.png' /></td>";
                    html += "<td style='border-right:1px solid silver'>Silver</td>";
                    html += "<td>1/25</td>";
                html += "</tr>";
                html += "<tr>";
                    html += "<td><img src='https://cdn.idle-pixel.com/images/gold.png' /></td>";
                    html += "<td style='border-right:1px solid silver'>Gold</td>";
                    html += "<td>1/300</td>";
                html += "</tr>";
            html += "</table>";
            document.getElementById("modal-mining-machinery-chance-table").innerHTML = html;
        }
        if(machine == "giant_drill") {
            var html = "";
            html += "<table width='70%' class='table-list-ores-chances'>";
                html += "<tr>";
                    html += "<th colspan=2>Ore</th>";
                    html += "<th>Chance</th>";
                html += "</tr>";
                html += "<tr>";
                    html += "<td><img src='https://cdn.idle-pixel.com/images/silver.png' /></td>";
                    html += "<td style='border-right:1px solid silver'>Silver</td>";
                    html += "<td>1/16</td>";
                html += "</tr>";
                html += "<tr>";
                    html += "<td><img src='https://cdn.idle-pixel.com/images/gold.png' /></td>";
                    html += "<td style='border-right:1px solid silver'>Gold</td>";
                    html += "<td>1/165</td>";
                html += "</tr>";
                html += "<tr>";
                    html += "<td><img src='https://cdn.idle-pixel.com/images/promethium.png' /></td>";
                    html += "<td style='border-right:1px solid silver'>Promethium</td>";
                    html += "<td>1/1,600</td>";
                html += "</tr>";
            html += "</table>";
            document.getElementById("modal-mining-machinery-chance-table").innerHTML = html;
        }
        if(machine == "excavator") {
            var html = "";
            html += "<table width='70%' class='table-list-ores-chances'>";
                html += "<tr>";
                    html += "<th colspan=2>Ore</th>";
                    html += "<th>Chance</th>";
                html += "</tr>";
                html += "<tr>";
                    html += "<td><img src='https://cdn.idle-pixel.com/images/gold.png' /></td>";
                    html += "<td style='border-right:1px solid silver'>Gold</td>";
                    html += "<td>1/125</td>";
                html += "</tr>";
                html += "<tr>";
                    html += "<td><img src='https://cdn.idle-pixel.com/images/promethium.png' /></td>";
                    html += "<td style='border-right:1px solid silver'>Promethium</td>";
                    html += "<td>1/1,250</td>";
                html += "</tr>";
                html += "<tr>";
                    html += "<td><img src='https://cdn.idle-pixel.com/images/titanium.png' /></td>";
                    html += "<td style='border-right:1px solid silver'>Titanium</td>";
                    html += "<td>1/8,400</td>";
                html += "</tr>";
            html += "</table>";
            document.getElementById("modal-mining-machinery-chance-table").innerHTML = html;
        }

        if(machine == "giant_excavator") {
            var html = "";
            html += "<table width='70%' class='table-list-ores-chances'>";
                html += "<tr>";
                    html += "<th colspan=2>Ore</th>";
                    html += "<th>Chance</th>";
                html += "</tr>";
                html += "<tr>";
                    html += "<td><img src='https://cdn.idle-pixel.com/images/titanium.png' /></td>";
                    html += "<td style='border-right:1px solid silver'>Titanium</td>";
                    html += "<td>1/4,100</td>";
                html += "</tr>";
                html += "<tr>";
                    html += "<td><img src='https://cdn.idle-pixel.com/images/ancient_ore.png' /></td>";
                    html += "<td style='border-right:1px solid silver'>Ancient Ore</td>";
                    html += "<td>1/16,000</td>";
                html += "</tr>";
            html += "</table>";
            document.getElementById("modal-mining-machinery-chance-table").innerHTML = html;
        }
        if(machine == "massive_excavator") {
            var html = "";
            html += "<table width='70%' class='table-list-ores-chances'>";
                html += "<tr>";
                    html += "<th colspan=2>Ore</th>";
                    html += "<th>Chance</th>";
                html += "</tr>";
                html += "<tr>";
                    html += "<td><img src='https://cdn.idle-pixel.com/images/ancient_ore.png' /></td>";
                    html += "<td style='border-right:1px solid silver'>Ancient Ore</td>";
                    html += "<td>1/4,100</td>";
                html += "</tr>";
                html += "<tr>";
                    html += "<td><img src='https://cdn.idle-pixel.com/images/dragon_ore.png' /></td>";
                    html += "<td style='border-right:1px solid silver'>Dragon Ore</td>";
                    html += "<td>1/16,000</td>";
                html += "</tr>";
            html += "</table>";
            document.getElementById("modal-mining-machinery-chance-table").innerHTML = html;
        }

        Modals.toggle("modal-mining-machinery");
    }

    static toggle_dialogue(id)
    {
        $('#' + id).modal('toggle');
    }

    static open_gathering_dialogue(gathering_area)
    {
        if(gathering_area == "fields" && Items.getItem("farming_unlocked") == 0) {
            Modals.open_image_modal("Skill Locked", "images/broken_rake.png", "You need to fix a rake obtained from gathering desert mines to unlock farming.");
            return;
        }
        if(gathering_area == "forest" && Items.getItem("woodcutting_unlocked") == 0) {
            Modals.open_image_modal("Skill Locked", "images/axe.png", "You must craft an <b><i style='color:red'>axe</i></b> to unlock woodcutting.");
            return;
        }
        if(gathering_area == "fishing_pond" && Items.getItem("fishing_unlocked") == 0) {
            Modals.open_image_modal("Skill Locked", "images/quests.png", "You must complete the quest: The Fisherman");
            return;
        }
        if(gathering_area == "kitchen" && Items.getItem("cooking_unlocked") == 0) {
            Modals.open_image_modal("Skill Locked", "images/bronze_oven.png", "You need to craft a bronze oven to unlock cooking.");
            return;
        }

        var regular = {};
        var uniques = {};
        
        switch(gathering_area)
        {
            case "mines":
                regular = Gathering.MINES_REGULAR;
                uniques = Gathering.MINES_UNIQUES;
            break;
            case "fields":
                regular = Gathering.FIELDS_REGULAR;
                uniques = Gathering.FIELDS_UNIQUES;
            break;
            case "forest":
                regular = Gathering.FOREST_REGULAR;
                uniques = Gathering.FOREST_UNIQUES;
            break;
            case "gem_mine":
                regular = Gathering.GEM_MINE_REGULAR;
                uniques = Gathering.GEM_MINE_UNIQUES;
            break;
            case "fishing_pond":
                regular = Gathering.FISHING_POND_REGULAR;
                uniques = Gathering.FISHING_POND_UNIQUES;
            break;
            case "kitchen":
                regular = Gathering.KITCHEN_REGULAR;
                uniques = Gathering.KITCHEN;
            break;
            case "castle":
                regular = Gathering.CASTLE_REGULAR;
                uniques = Gathering.CASTLE;
            break;
        }
        

        var table_data = "";

        table_data += "<tr style='background-color:#8d96a0'>";
            table_data += "<th class='font-large' colspan='3'>";
                table_data += "OTHER ITEMS<br /><i class='color-silver' style='font-size:8pt;'>Can be found repeatedly</i><br /><br />";
            table_data += "</th>";
        table_data += "</tr>";
        table_data += "<tr style='background-color:#CDCDCD'>";
            table_data += "<th>";
                table_data += "Item";
            table_data += "</th>";
            table_data += "<th>";
                table_data += "";
            table_data += "</th>";
            table_data += "<th>";
                table_data += "Rarity";
            table_data += "</th>";
        table_data += "</tr>";
        for(var i = 0; i < regular.length; i++)
        {
            var dict = regular[i];
            table_data += "<tr>";
                if(dict.item == "blood_diamond") {
                    table_data +=  "<td class='font-small center'>" + "<img src='https://cdn.idle-pixel.com/images/"+dict.item+".gif' class='w50' />" + "</td>";
                } else {
                    table_data +=  "<td class='font-small center'>" + "<img src='https://cdn.idle-pixel.com/images/"+dict.item+".png' class='w50' />" + "</td>";
                }
                
                table_data +=  "<td class='font-small center color-grey'>" + dict.label + "</td>";
                table_data +=  "<td class='font-small center color-grey'>" + dict.chance + "</td>";
            table_data += "</tr>";
            
        }
        table_data += "</table>";

        document.getElementById("modal-gathering-anyting-table").innerHTML = table_data;

        table_data = "" //reset
        table_data += "<table>";

        table_data += "<tr style='background-color:#8d96a0'>";
            table_data += "<th class='font-large' colspan='6'>";
            table_data += "UNIQUE ITEMS<br /><i class='color-silver' style='font-size:8pt;'>Can be found only once</i><br /><br />";
            table_data += "</th>";
        table_data += "</tr>";

        table_data += "<tr style='background-color:#CDCDCD'>";
            table_data += "<th>";
                table_data += "Item";
            table_data += "</th>";
            table_data += "<th>";
                table_data += "";
            table_data += "</th>";
            table_data += "<th>";
                table_data += "Level";
            table_data += "</th>";
            table_data += "<th>";
                table_data += "Rarity";
            table_data += "</th>";
            table_data += "<th>";
                table_data += "Found";
            table_data += "</th>";
            table_data += "<th>";
                table_data += "XP";
            table_data += "</th>";
        table_data += "</tr>";

        var uniquesFound = 0;
        var uniquesTotal = 0;
        for(var i = 0; i < uniques.length; i++)
        {
            var dict = uniques[i];
            var foundUnique = false;
            uniquesTotal++;
            if(Items.getItem(dict.item_unique_tracker)  >= 1) {
                foundUnique = true;
                uniquesFound++;
            }

            
            table_data += "<tr>";
            table_data +=  "<td class='font-small center'>" + "<img src='https://cdn.idle-pixel.com/images/"+dict.item+".png' class='w50' />" + "</td>";
            table_data +=  "<td class='font-small center color-grey'>" + dict.label + "</td>";

            var levelStyleColor = "color-red";
            if(get_level(Items.getItem("gathering_xp")) >= parseInt(dict.level))
                var levelStyleColor = "color-green";
            
            table_data +=  "<td class='font-small center "+levelStyleColor+"'>" + " Level " + dict.level + "</td>";
            table_data +=  "<td class='font-small center color-grey'>" + dict.chance + "</td>";

            if(Items.getItem(dict.item_unique_tracker) == 0)
            {
                if(dict.item == "toolkit" && Items.getItem("invention_unlocked") == 0)
                    table_data +=  "<td class='font-small center color-red'>" + "<img src='https://cdn.idle-pixel.com/images/invention.png' class='w15' />" + "INVENTION REQUIRED" + "</td>";
                else
                    table_data +=  "<td class='font-small center color-grey'>" + "<img src='https://cdn.idle-pixel.com/images/x.png' class='w20' />" + "</td>";
            }
            else
                table_data +=  "<td class='font-small center color-green'>" + "<img src='https://cdn.idle-pixel.com/images/check.png' class='w20' />" + "</td>";

           
            table_data +=  "<td class='font-small center'>" + format_number(dict.xp) + "</td>";

            table_data += "</tr>";
            
        }

        document.getElementById("modal-gathering-uniques-table").innerHTML = table_data;

        document.getElementById("modal-gathering-button").onclick = function()
        {
            websocket.send("GATHERING=" + gathering_area);
        }
        Modals.toggle("modal-gathering");
    }


    static clicks_watering_can()
    {
        var watering_can = Farming.getWateringCanToolData()[0];
        if(watering_can == "watering_can")
            Modals.open_image_modal("WATERING CAN","images/"+Farming.getWateringCanToolData()[0]+".png", "Water your crops to increase growrate?", "Water First Patch", "Cancel", "USE_WATERING_CAN");
        else
            Modals.open_image_modal("WATERING CAN","images/"+Farming.getWateringCanToolData()[0]+".png", "Water your crops to increase growrate?", "Water Patches", "Cancel", "USE_WATERING_CAN");
    }

    static open_the_achiever_dialogue()
    {
        for(var i = 1; i <= 5; i++)
        {
            if(Items.getItem("the_achiever_ach_" + i) == 1)
            {
                document.getElementById("modal-the-achiever-book-ach" + i).src = get_image("images/check.png");
            }
        }

        Modals.toggle("modal-the-acheiver-book");
    }

    static open_the_achiever_2_dialogue()
    {
        Modals.toggle("modal-the-acheiver-books");
    }

    static clicks_rocket()
    {
        if(Items.getItem("rocket_km") == 0)
        {
            websocket.send('CLICKS_ROCKET=0');
            return;
        }
        else if(Items.getItem("rocket_km") == Items.getItem("rocket_distance_required"))
        {
            set_image_src("modal-rocket-destination-img", "images/" + Items.getItemString("rocket_status") + ".png");
            Modals.toggle("modal-rocket-destination");
        }
        else if(Items.getItem("rocket_km") >= 1)
        {
            Modals.open_image_modal("ROCKET", "images/" + "rocket" + ".png", "Your rocket is currently traveling in space!",  "Close", null, "")
        }
    }

    static open_send_rocket_dialogue(moon_distance, sun_distance)
    {
        if(Items.getItem("mega_rocket") > 0)
        {
            Modals.toggle("modal-mega-rocket");
            document.getElementById("modal-mega-rocket-moon-distance").textContent = format_number(moon_distance) + "km";
            document.getElementById("modal-mega-rocket-sun-distance").textContent = format_number(sun_distance) + "km";
        }
        else
        {
            Modals.open_image_modal("ROCKET", "images/" + "rocket" + ".png", "Send rocket to the moon?<br /><br /><b>Distance:</b> "+ format_number(moon_distance)+" KM<br /><b>Average Speed:</b>5400 KM per hour<br /><br /><span style='color:grey'>The distance to the moon may change based on orbit.</span>",  "Lift off!", "Close", "CLICKS_ROCKET=1")
        }
    }

    static open_invention_instructions(step)
    {
        document.getElementById("modal-invention-instructions-button").style.display = "";

        if(step == 0)
        {
            var text = "Click continue to begin the Invention's guide.";
            var img = "https://cdn.idle-pixel.com/images/invention_icon.png";
            var next_step = 1;

            document.getElementById("modal-invention-instructions-img").src = img;
            document.getElementById("modal-invention-instructions-text").innerHTML = text;
            
            document.getElementById("modal-invention-instructions-button").onclick = function() {
                Modals.open_invention_instructions(next_step);
            }
            
            Modals.toggle("modal-invention-instructions");
        }

        if(step == 1)
        {
            var text = "There are 3 major steps when it comes to invention.";
            var img = "https://cdn.idle-pixel.com/images/invention_icon.png";
            var next_step = 2;

            document.getElementById("modal-invention-instructions-img").src = img;
            document.getElementById("modal-invention-instructions-text").innerHTML = text;
            
            document.getElementById("modal-invention-instructions-button").onclick = function() {
                Modals.open_invention_instructions(next_step);
            }
            
            Modals.toggle("modal-invention-instructions");
        }

        if(step == 2)
        {
            var text = "STEP 1";
            var img = "https://cdn.idle-pixel.com/images/warning.png";
            var next_step = 3;

            document.getElementById("modal-invention-instructions-img").src = img;
            document.getElementById("modal-invention-instructions-text").innerHTML = text;
            
            document.getElementById("modal-invention-instructions-button").onclick = function() {
                Modals.open_invention_instructions(next_step);
            }
            
            Modals.toggle("modal-invention-instructions");
        }

        if(step == 3)
        {
            var text = "Step 1 is breaking down weapons or amulets into components.";
            var img = "https://cdn.idle-pixel.com/images/invention_instructions_1.png";
            var next_step = 4;

            document.getElementById("modal-invention-instructions-img").src = img;
            document.getElementById("modal-invention-instructions-text").innerHTML = text;
            
            document.getElementById("modal-invention-instructions-button").onclick = function() {
                Modals.open_invention_instructions(next_step);
            }
            
            Modals.toggle("modal-invention-instructions");
        }

        if(step == 4)
        {
            var text = "Each weapon/amulet can be broken down into common compontents, or unique ones based on the item.";
            var img = "https://cdn.idle-pixel.com/images/invention_instructions_2.png";
            var next_step = 5;

            document.getElementById("modal-invention-instructions-img").src = img;
            document.getElementById("modal-invention-instructions-text").innerHTML = text;
            
            document.getElementById("modal-invention-instructions-button").onclick = function() {
                Modals.open_invention_instructions(next_step);
            }
            
            Modals.toggle("modal-invention-instructions");
        }

        if(step == 5)
        {
            var text = "The higher your invention level, the higher chance of getting better components.";
            var img = "https://cdn.idle-pixel.com/images/invention_icon.png";
            var next_step = 6;

            document.getElementById("modal-invention-instructions-img").src = img;
            document.getElementById("modal-invention-instructions-text").innerHTML = text;
            
            document.getElementById("modal-invention-instructions-button").onclick = function() {
                Modals.open_invention_instructions(next_step);
            }
            
            Modals.toggle("modal-invention-instructions");
        }

        if(step == 6)
        {
            var text = "Dessembling weapons and amulets will grant you some invention XP.";
            var img = "https://cdn.idle-pixel.com/images/invention_instructions_2.png";
            var next_step = 7;

            document.getElementById("modal-invention-instructions-img").src = img;
            document.getElementById("modal-invention-instructions-text").innerHTML = text;
            
            document.getElementById("modal-invention-instructions-button").onclick = function() {
                Modals.open_invention_instructions(next_step);
            }
            
            Modals.toggle("modal-invention-instructions");
        }

        if(step == 7)
        {
            var text = "STEP 2";
            var img = "https://cdn.idle-pixel.com/images/warning.png";
            var next_step = 8;

            document.getElementById("modal-invention-instructions-img").src = img;
            document.getElementById("modal-invention-instructions-text").innerHTML = text;
            
            document.getElementById("modal-invention-instructions-button").onclick = function() {
                Modals.open_invention_instructions(next_step);
            }
            
            Modals.toggle("modal-invention-instructions");
        }

        if(step == 8)
        {
            var text = "There are two different actions that you may perform with components.";
            var img = "https://cdn.idle-pixel.com/images/invention_instructions_3.png";
            var next_step = 9;

            document.getElementById("modal-invention-instructions-img").src = img;
            document.getElementById("modal-invention-instructions-text").innerHTML = text;
            
            document.getElementById("modal-invention-instructions-button").onclick = function() {
                Modals.open_invention_instructions(next_step);
            }
            
            Modals.toggle("modal-invention-instructions");
        }

        if(step == 9)
        {
            var text = "Option 1)  Reassemble more powerful weapons by combining multiple components together.";
            var img = "https://cdn.idle-pixel.com/images/invention_instructions_4.png";
            var next_step = 10;

            document.getElementById("modal-invention-instructions-img").src = img;
            document.getElementById("modal-invention-instructions-text").innerHTML = text;
            
            document.getElementById("modal-invention-instructions-button").onclick = function() {
                Modals.open_invention_instructions(next_step);
            }
            
            Modals.toggle("modal-invention-instructions");
        }

        if(step == 10)
        {
            var text = "Option 2)  Destroy those components, along with junk from gathering, to gain additional invention XP.";
            var img = "https://cdn.idle-pixel.com/images/invention_instructions_5.png";
            var next_step = 11;

            document.getElementById("modal-invention-instructions-img").src = img;
            document.getElementById("modal-invention-instructions-text").innerHTML = text;
            
            document.getElementById("modal-invention-instructions-button").onclick = function() {
                Modals.open_invention_instructions(next_step);
            }
            
            Modals.toggle("modal-invention-instructions");
        }

        if(step == 11)
        {
            var text = "Using option 1 will also grant you some invention XP, and will allow you to invent new weapons or amulets!";
            var img = "https://cdn.idle-pixel.com/images/invention_instructions_6.png";
            var next_step = 12;

            document.getElementById("modal-invention-instructions-img").src = img;
            document.getElementById("modal-invention-instructions-text").innerHTML = text;
            
            document.getElementById("modal-invention-instructions-button").onclick = function() {
                Modals.open_invention_instructions(next_step);
            }
            
            Modals.toggle("modal-invention-instructions");
        }

        if(step == 12)
        {
            var text = "STEP 3";
            var img = "https://cdn.idle-pixel.com/images/warning.png";
            var next_step = 13;

            document.getElementById("modal-invention-instructions-img").src = img;
            document.getElementById("modal-invention-instructions-text").innerHTML = text;
            
            document.getElementById("modal-invention-instructions-button").onclick = function() {
                Modals.open_invention_instructions(next_step);
            }
            
            Modals.toggle("modal-invention-instructions");
        }


        if(step == 13)
        {
            var text = "Enchantments!";
            var img = "https://cdn.idle-pixel.com/images/magic.png";
            var next_step = 14;

            document.getElementById("modal-invention-instructions-img").src = img;
            document.getElementById("modal-invention-instructions-text").innerHTML = text;
            
            document.getElementById("modal-invention-instructions-button").onclick = function() {
                Modals.open_invention_instructions(next_step);
            }
            
            Modals.toggle("modal-invention-instructions");
        }

        if(step == 14)
        {
            var text = "This new magic training method will allow you to enchant weapons and amulets.";
            var img = "https://cdn.idle-pixel.com/images/magic.png";
            var next_step = 15;

            document.getElementById("modal-invention-instructions-img").src = img;
            document.getElementById("modal-invention-instructions-text").innerHTML = text;
            
            document.getElementById("modal-invention-instructions-button").onclick = function() {
                Modals.open_invention_instructions(next_step);
            }
            
            Modals.toggle("modal-invention-instructions");
        }

        if(step == 15)
        {
            var text = "You'll need find unique monster parts while the blood moon is active for this.";
            var img = "https://cdn.idle-pixel.com/images/blood_moon.png";
            var next_step = 16;

            document.getElementById("modal-invention-instructions-img").src = img;
            document.getElementById("modal-invention-instructions-text").innerHTML = text;
            
            document.getElementById("modal-invention-instructions-button").onclick = function() {
                Modals.open_invention_instructions(next_step);
            }
            
            Modals.toggle("modal-invention-instructions");
        }

        if(step == 16)
        {
            var text = "These monster limbs can only be looted from blood monsters, that is when the blood moon is active.";
            var img = "https://cdn.idle-pixel.com/images/invention_instructions_8.png";
            var next_step = 17;

            document.getElementById("modal-invention-instructions-img").src = img;
            document.getElementById("modal-invention-instructions-text").innerHTML = text;
            
            document.getElementById("modal-invention-instructions-button").onclick = function() {
                Modals.open_invention_instructions(next_step);
            }
            
            Modals.toggle("modal-invention-instructions");
        }

        if(step == 17)
        {
            var text = "You'll then need to enchant the blood obtained from the limbs, in order to enchant weapons or amulets.";
            var img = "https://cdn.idle-pixel.com/images/magic.png";
            var next_step = 18;

            document.getElementById("modal-invention-instructions-img").src = img;
            document.getElementById("modal-invention-instructions-text").innerHTML = text;
            
            document.getElementById("modal-invention-instructions-button").onclick = function() {
                Modals.open_invention_instructions(next_step);
            }
            
            Modals.toggle("modal-invention-instructions");
        }

        if(step == 18)
        {
            var text = "INVENTION GUIDE COMPLETED!";
            var img = "https://cdn.idle-pixel.com/images/invention_icon.png";
            var next_step = -1;

            document.getElementById("modal-invention-instructions-img").src = img;
            document.getElementById("modal-invention-instructions-text").innerHTML = text;
            document.getElementById("modal-invention-instructions-button").style.display = "none";
            Modals.toggle("modal-invention-instructions");
        }
    }

    static open_fight_areas_dialogue(ignore_no_arrows_warning)
    {
        if(Combat.in_combat())
        {
            switch_panels("panel-combat-canvas");
            return;
        }
        if(Items.getItemString('weapon') == "wooden_bow" && Items.getItemString('arrows') == "none" && !ignore_no_arrows_warning)
        {
            Modals.toggle("modal-no-arrows-warning");
        } else if(Items.getItemString('weapon') == "none" && Items.getItem('melee_xp') == 0 && Items.getItem('archery_xp') == 0 && Items.getItem('magic_xp') == 0 && !ignore_no_arrows_warning) {
            Modals.toggle("modal-no-weapons-warning");
        }
        else
        {
            if(Items.getItem("blood_moon_active") > 0)
            {
                Combat.modal_load_blood_area_data();
                Modals.toggle("modal-fight-blood-areas");
                return;
            }
    
            Combat.modal_load_area_data();
            Modals.toggle("modal-fight-areas");
        } 
    }
    static clicks_beehive()
    {
        if(Items.getItem("beehive_timer") == 1) {
            websocket.send('COLLECT_BEEHIVE')
        }
        else if(Items.getItem("beehive_timer") > 1) {
            Modals.open_image_modal("BEEHIVE", "images/x.png", "You're bees are busy pollinating flowers.", "Close", null , "");
        }
        else {
            Modals.toggle("modal-beehive");
        }
        
    }

    static clicks_birdhouse()
    {
        if(Items.getItem("birdhouse_timer") >= 1) {
            document.getElementById("modal-birdhouse-loot-desc").innerHTML = "Your loot potential is: " + Farming.getBirdhouseSeedValue() + "/" + Farming.getBirdhouseMaxSeedValue();
            document.getElementById("modal-birdhouse-loot-max-level").innerHTML = Farming.getMaxBirdhouseLevel();
            Modals.toggle("modal-birdhouse-loot");
        }
        else {

            if(Items.getItem("redwood_birdhouse")) { 
                document.getElementById("modal-birdhouse-goldleafseeds-input-slider").style.display = "";
                document.getElementById("modal-birdhouse-crystalleafseeds-input-slider").style.display = "";
            }
            document.getElementById("modal-birdhouse-max-level").innerHTML = Farming.getMaxBirdhouseLevel();
            Modals.toggle("modal-birdhouse");
            
        }
            
    }

     

    static clicks_shooting_star()
    {
        var result = Quests.theMerchanterShowItem('shooting_star')
        if(!result)
        {
            Modals.toggle("modal-enchant-shooting-star");
        }
    }

    static clicks_needle() {
       
        Modals.toggle("modal-needle");
    }

    static clicks_needle_item(equipment) {
        Modals.open_input_dialogue_with_value(
            equipment,
            "USE NEEDLE",
            "<img src='https://cdn.idle-pixel.com/images/"+equipment+".png' class='w100' /><br /><br /><span class='color-grey'>How many to revert?</span>",
            "1",
            "USE_NEEDLE"
        );
    }
    static open_blue_orb_potion()
    {
        var html = "";
        // blue_pickaxe_orb
        // blue_hammer_orb
        // blue_woodcutting_orb
        // blue_oil_storage_orb
        // blue_oil_well_orb
        // blue_farming_orb

        // green_arrow_orb
        // green_boat_orb
        // green_bone_orb
        // green_charcoal_orb
        // green_log_orb

        var testingFor = "";

        testingFor = "blue_pickaxe_orb";
        if(Items.getItem(testingFor) > 0)
        {
            html += "<div onclick='Modals.reroll_blue_orb(\""+testingFor+"\")' class='reroll-blue-orb-entry hover'><img src='https://cdn.idle-pixel.com/images/"+testingFor+".png' /> Reroll</div>"
        }
        testingFor = "blue_hammer_orb";
        if(Items.getItem(testingFor) > 0)
        {
            html += "<div onclick='Modals.reroll_blue_orb(\""+testingFor+"\")' class='reroll-blue-orb-entry hover'><img src='https://cdn.idle-pixel.com/images/"+testingFor+".png' /> Reroll</div>"
        }
        testingFor = "blue_woodcutting_orb";
        if(Items.getItem(testingFor) > 0)
        {
            html += "<div onclick='Modals.reroll_blue_orb(\""+testingFor+"\")' class='reroll-blue-orb-entry hover'><img src='https://cdn.idle-pixel.com/images/"+testingFor+".png' /> Reroll</div>"
        }
        testingFor = "blue_oil_storage_orb";
        if(Items.getItem(testingFor) > 0)
        {
            html += "<div onclick='Modals.reroll_blue_orb(\""+testingFor+"\")' class='reroll-blue-orb-entry hover'><img src='https://cdn.idle-pixel.com/images/"+testingFor+".png' /> Reroll</div>"
        }
        testingFor = "blue_oil_well_orb";
        if(Items.getItem(testingFor) > 0)
        {
            html += "<div onclick='Modals.reroll_blue_orb(\""+testingFor+"\")' class='reroll-blue-orb-entry hover'><img src='https://cdn.idle-pixel.com/images/"+testingFor+".png' /> Reroll</div>"
        }
        testingFor = "blue_farming_orb";
        if(Items.getItem(testingFor) > 0)
        {
            html += "<div onclick='Modals.reroll_blue_orb(\""+testingFor+"\")' class='reroll-blue-orb-entry hover'><img src='https://cdn.idle-pixel.com/images/"+testingFor+".png' /> Reroll</div>"
        }

        if(html == "")
        {
            Modals.open_image_modal("ORBS MISSING", "images/x.png", "You do not have any unbound blue orbs to use this potion on.", "Close", null , "");
            return;
        }

        document.getElementById("modal-reroll-blue-orb-potion-area").innerHTML = html;
        Modals.toggle("modal-reroll-blue-orb-potion");
    }

    static open_green_orb_potion()
    {
        var html = "";
        // blue_pickaxe_orb
        // blue_hammer_orb
        // blue_woodcutting_orb
        // blue_oil_storage_orb
        // blue_oil_well_orb
        // blue_farming_orb

        // green_arrow_orb
        // green_boat_orb
        // green_bone_orb
        // green_charcoal_orb
        // green_log_orb

        var testingFor = "";

        testingFor = "green_arrow_orb";
        if(Items.getItem(testingFor) > 0)
        {
            html += "<div onclick='Modals.reroll_green_orb(\""+testingFor+"\")' class='reroll-green-orb-entry hover'><img src='https://cdn.idle-pixel.com/images/"+testingFor+".png' /> Reroll</div>"
        }
        testingFor = "green_boat_orb";
        if(Items.getItem(testingFor) > 0)
        {
            html += "<div onclick='Modals.reroll_green_orb(\""+testingFor+"\")' class='reroll-green-orb-entry hover'><img src='https://cdn.idle-pixel.com/images/"+testingFor+".png' /> Reroll</div>"
        }
        testingFor = "green_bone_orb";
        if(Items.getItem(testingFor) > 0)
        {
            html += "<div onclick='Modals.reroll_green_orb(\""+testingFor+"\")' class='reroll-green-orb-entry hover'><img src='https://cdn.idle-pixel.com/images/"+testingFor+".png' /> Reroll</div>"
        }
        testingFor = "green_charcoal_orb";
        if(Items.getItem(testingFor) > 0)
        {
            html += "<div onclick='Modals.reroll_green_orb(\""+testingFor+"\")' class='reroll-green-orb-entry hover'><img src='https://cdn.idle-pixel.com/images/"+testingFor+".png' /> Reroll</div>"
        }
        testingFor = "green_log_orb";
        if(Items.getItem(testingFor) > 0)
        {
            html += "<div onclick='Modals.reroll_green_orb(\""+testingFor+"\")' class='reroll-green-orb-entry hover'><img src='https://cdn.idle-pixel.com/images/"+testingFor+".png' /> Reroll</div>"
        }

        if(html == "")
        {
            Modals.open_image_modal("ORBS MISSING", "images/x.png", "You do not have any unbound green orbs to use this potion on.", "Close", null , "");
            return;
        }

        document.getElementById("modal-reroll-green-orb-potion-area").innerHTML = html;
        Modals.toggle("modal-reroll-green-orb-potion");
    }

    static open_red_orb_potion()
    {
        var html = "";
        // blue_pickaxe_orb
        // blue_hammer_orb
        // blue_woodcutting_orb
        // blue_oil_storage_orb
        // blue_oil_well_orb
        // blue_farming_orb

        // green_arrow_orb
        // green_boat_orb
        // green_bone_orb
        // green_charcoal_orb
        // green_log_orb

        // red_farming_orb
        // red_woodcutting_orb
        // red_combat_orb
        // red_oil_factory_orb
        // red_stardust_watch_orb


        var testingFor = "";

        testingFor = "red_farming_orb";
        if(Items.getItem(testingFor) > 0)
        {
            html += "<div onclick='Modals.reroll_red_orb(\""+testingFor+"\")' class='reroll-red-orb-entry hover'><img src='https://cdn.idle-pixel.com/images/"+testingFor+".png' /> Reroll</div>"
        }
        testingFor = "red_woodcutting_orb";
        if(Items.getItem(testingFor) > 0)
        {
            html += "<div onclick='Modals.reroll_red_orb(\""+testingFor+"\")' class='reroll-red-orb-entry hover'><img src='https://cdn.idle-pixel.com/images/"+testingFor+".png' /> Reroll</div>"
        }
        testingFor = "red_combat_orb";
        if(Items.getItem(testingFor) > 0)
        {
            html += "<div onclick='Modals.reroll_red_orb(\""+testingFor+"\")' class='reroll-red-orb-entry hover'><img src='https://cdn.idle-pixel.com/images/"+testingFor+".png' /> Reroll</div>"
        }
        testingFor = "red_oil_factory_orb";
        if(Items.getItem(testingFor) > 0)
        {
            html += "<div onclick='Modals.reroll_red_orb(\""+testingFor+"\")' class='reroll-red-orb-entry hover'><img src='https://cdn.idle-pixel.com/images/"+testingFor+".png' /> Reroll</div>"
        }
        testingFor = "red_stardust_watch_orb";
        if(Items.getItem(testingFor) > 0)
        {
            html += "<div onclick='Modals.reroll_red_orb(\""+testingFor+"\")' class='reroll-red-orb-entry hover'><img src='https://cdn.idle-pixel.com/images/"+testingFor+".png' /> Reroll</div>"
        }
        testingFor = "red_criptoe_orb";
        if(Items.getItem(testingFor) > 0)
        {
            html += "<div onclick='Modals.reroll_red_orb(\""+testingFor+"\")' class='reroll-red-orb-entry hover'><img src='https://cdn.idle-pixel.com/images/"+testingFor+".png' /> Reroll</div>"
        }

        if(html == "")
        {
            Modals.open_image_modal("ORBS MISSING", "images/x.png", "You do not have any unbound red orbs to use this potion on.", "Close", null , "");
            return;
        }

        document.getElementById("modal-reroll-red-orb-potion-area").innerHTML = html;
        Modals.toggle("modal-reroll-red-orb-potion");
    }

    static confirm_create_raids_team() {
        var value = document.querySelector('input[name="raid-req-radio"]:checked').value;
        if(value != null) {
            websocket.send('CREATE_RAID_TEAM=' + value);
        }
    }
    static raid_create_team_button() {
        Modals.toggle('modal-raids-create-party');
    }
    static raid_join_team_button() {
        Modals.toggle('modal-raid-join-button');
    }


    static reroll_blue_orb(orb)
    {
        Modals.toggle("modal-reroll-blue-orb-potion");
        Modals.open_image_modal('Pour Potion', 'images/'+orb+'.png', 'Pour potion on the orb to reroll it?', 'Pour the potion onto the orb!', 'Cancel', 'REROLL_BLUE_ORB=' + orb)
    }

    static reroll_red_orb(orb)
    {
        Modals.toggle("modal-reroll-red-orb-potion");
        Modals.open_image_modal('Pour Potion', 'images/'+orb+'.png', 'Pour potion on the orb to reroll it?', 'Pour the potion onto the orb!', 'Cancel', 'REROLL_RED_ORB=' + orb)
    }


    static open_robot_waves()
    {
        Modals.toggle("modal-robot-waves");
    }  

    static reroll_green_orb(orb)
    {
        Modals.toggle("modal-reroll-green-orb-potion");
        Modals.open_image_modal('Pour Potion', 'images/'+orb+'.png', 'Pour potion on the orb to reroll it?', 'Pour the potion onto the orb!', 'Cancel', 'REROLL_GREEN_ORB=' + orb)
    }
    
    static fight_robots(type)
    {
        var robot_image;
        if(type == 'novice')
        {
           robot_image = "images/robot_easy.png";
        }
        if(type == 'warrior')
        {
           robot_image = "images/robot_medium.png";
        }
        if(type == 'master')
        {
           robot_image = "images/robot_hard.png";
        }
        if(type == 'elite')
        {
           robot_image = "images/robot_elite.png";
        }

        Modals.open_image_modal('Pour Potion', robot_image, 'Fight robot waves?', 'Confirm Fight!', 'Cancel', 'ROBOT_WAVES=' + type)
    }

    static open_robot_loot_dialogue(tier)
    {
        document.getElementById('modal-robot-open-loot-button').onclick = function()
        {
            websocket.send('OPEN_ROBOT_LOOT=' + tier)
        }
        Modals.toggle("modal-robot-open-loot");
    }

    static open_add_friends_dialogue()
    {
        document.getElementById("modal-add-friend-input").value = "";
        Modals.toggle("modal-add-friend");
    }


    static clicks_oven()
    {
        var html = "";
        var has_logs = false;
        for(var key in Cooking.LOG_HEAT_MAP)
        {
            var log = key;
            var heat = Cooking.getHeatPerLog(log);

            if(Items.getItem(log) > 0)
            {
                has_logs = true;
                html += "<div onclick='Modals.clicks_oven_log(\""+log+"\")'  class='modal-cooking-select-log shadow hover center'>";
                html += get_item_name(log) + "<br /><span class='color-silver'>(<item-display data-format='number' data-key='"+log+"'>"+format_number(Items.getItem(log))+"</item-display>)</span>"
                html += "<br />";
                html += "<img src='https://cdn.idle-pixel.com/images/"+log+".png'>";
                html += "<br />";
                html += "<img src='https://cdn.idle-pixel.com/images/heat.png' class='w15'> " + heat;
                html += "</div>";
            }
        }

        if(Items.getItem('heat_potion') > 0)
        {
            html += "<div onclick='Brewing.quick_drink_heat_potion()'  class='modal-cooking-select-log modal-cooking-select-potion shadow hover center'>";
            html += "Heat Potion" + "<br /><span class='color-silver'>(<item-display data-format='number' data-key='heat_potion'>"+format_number(Items.getItem("heat_potion"))+"</item-display>)</span>"
            html += "<br />";
            html += "<img src='https://cdn.idle-pixel.com/images/heat_potion.png'>";
            html += "<br />";
            html += "DRINK";
            html += "</div>";
        }


        
        document.getElementById("modal-oven-body").innerHTML = html;
        if(has_logs)
            Modals.toggle("modal-oven");
        else
            Modals.open_image_modal("OVEN", "images/" + "logs" + ".png", "<img src='https://cdn.idle-pixel.com/images/x.png' class='w20'> You need logs to use the oven.",  "Close", null, "");
    }

    static clicks_oven_log(log_selected)
    {
        
        
        if(Items.getItem(log_selected) == 0)
        {
            Modals.open_image_modal("OVEN", "images/x.png", "You don't have any logs to add into your oven.", "Close", null , "");
            Modals.toggle("modal-oven");
            return;
        } else {
            var dict = {}
            dict[log_selected] = 1;
            
            var html = "<span class='font-large'>Add heat to your oven.</span><br /><br /><span class='color-grey'>Gain <img src='https://cdn.idle-pixel.com/images/heat.png' /> " + Cooking.getHeatPerLog(log_selected) +" heat per log.</span>"
            Modals.open_modern_input_dialogue_with_value(
                log_selected,
                "images/" + log_selected + ".png",
                dict,
                "MAX",
                html,
                'Add Heat',
                'ADD_HEAT=' + log_selected
            ); 
        }
    }

    static open_cook_dialogue(food)
    {
        var dict = {}
        dict[food] = 1;
        dict['heat'] = Cooking.FOOD_HEAT_REQ_MAP[food];

        Modals.open_modern_input_dialogue_with_value(
        food,
            "images/" + food + ".png",
            dict,
            "PLUS_ONE",
            null,
            'Cook',
            'COOK=' + food
        );
    }

    static clicksPickaxe() {
        var html = "<center>";
        html += "<table width='70%' class='table-list-ores-chances'>";
            html += "<tr>";
                html += "<th colspan=2>Ore</th>";
                html += "<th>Chance</th>";
            html += "</tr>";
            html += "<tr>";
                html += "<td><img src='https://cdn.idle-pixel.com/images/stone.png' /></td>";
                html += "<td style='border-right:1px solid silver'>Stone</td>";
                html += "<td>Always</td>";
            html += "</tr>";
            html += "<tr>";
                html += "<td><img src='https://cdn.idle-pixel.com/images/copper.png' /></td>";
                html += "<td style='border-right:1px solid silver'>Copper</td>";
                html += "<td>1/2</td>";
            html += "</tr>";
            html += "<tr>";
                html += "<td><img src='https://cdn.idle-pixel.com/images/iron.png' /></td>";
                html += "<td style='border-right:1px solid silver'>Iron</td>";
                html += "<td>1/340</td>";
            html += "</tr>";
        html += "</table>";
        html += "</center>";

        Modals.open_image_modal('Pickaxe', 'images/'+Ores.getPickaxeToolData()[0]+'.png', html, null, 'Close', null)
    }

   

    static clicks_stone_converter_potion()
    {
        Modals.toggle("modal-stone-converter-potion");
    }

    static clicks_combat_loot_potion()
    {
        Modals.open_image_modal('Combat Loot Potion', 'images/combat_loot_potion.png', 'Drink potion?', 'Drink', 'Cancel', 'BREWING_DRINK_COMBAT_LOOT_POTION')
    }

    static clicks_rotten_potion()
    {
        var potion = 'rotten_potion';
        if(Items.getItem('disable_drink_confirmation') == 1)
        {
            document.getElementById('item-box-image-' + potion).classList.add('shake');
            setTimeout(function() {
                document.getElementById('item-box-image-' + potion).classList.remove('shake');
            }, 500);

            websocket.send('BREWING_DRINK_ROTTEN_POTION');
            return;
        }

        Modals.open_image_modal('Rotten Potion', 'images/rotten_potion.png', 'Drink potion?', 'Drink', 'Cancel', 'BREWING_DRINK_ROTTEN_POTION')
    }

    static guardian_key_potion()
    {
        var potion = 'guardian_key_potion';
        if(Items.getItem('disable_drink_confirmation') == 1)
        {
            document.getElementById('item-box-image-' + potion).classList.add('shake');
            setTimeout(function() {
                document.getElementById('item-box-image-' + potion).classList.remove('shake');
            }, 500);

            websocket.send('BREWING_DRINK_GUARDIAN_KEY_POTION');
            return;
        }

        Modals.open_image_modal('Guardian Key Potion', 'images/guardian_key_potion.png', 'Drink potion?<br /><br /><span class="color-grey">Note that this potion will only work once during its cooldown period.</span>', 'Drink', 'Cancel', 'BREWING_DRINK_GUARDIAN_KEY_POTION')
    }

    static clicks_merchant_speed_potion()
    {
        
        var potion = 'merchant_speed_potion';
        if(Items.getItem('disable_drink_confirmation') == 1)
        {
            document.getElementById('item-box-image-' + potion).classList.add('shake');
            setTimeout(function() {
                document.getElementById('item-box-image-' + potion).classList.remove('shake');
            }, 500);

            websocket.send('BREWING_DRINK_MERCHANT_SPEED_POTION');
            return;
        }
        Modals.open_image_modal('Merchant Speed Potion', 'images/merchant_speed_potion.png', 'Drink potion?', 'Drink', 'Cancel', 'BREWING_DRINK_MERCHANT_SPEED_POTION')
    }

    static open_custom_crafting(item)
    {
        var item_variables = [];
        var labels = [];
        var images = [];
        var level = [];
        var materials_labels = []; //multi array
        var materials_item = []; //multi array
        var materials_amount = []; //multi array
        var description = [];
        
        switch(item)
        {
            case "arrows":
                item_variables = ["wooden_arrows", "fire_arrows", "ice_arrows", "ancient_arrows"];
                labels = ["15 Wooden arrows", "15 Fire arrows", "15 Ice arrows", "15 Ancient Arrows"];
                images = ["images/wooden_arrows.png", "images/fire_arrows.png", "images/ice_arrows.png", "images/ancient_arrows.png"];
                level = [1, 20, 40, 90];

                materials_labels[0] = ["Feathers", "Logs", "Iron bars"];
                materials_item[0] = ["feathers", "logs", "iron_bar"];
                materials_amount[0] = [15,5,5];

                materials_labels[1] = ["Fire feathers", "Oak logs", "Silver bars"];
                materials_item[1] = ["fire_feathers", "oak_logs", "silver_bar"];
                materials_amount[1] = [15,5,5];

                materials_labels[2] = ["Ice feathers", "Willow logs", "Gold bars"];
                materials_item[2] = ["ice_feathers", "willow_logs", "gold_bar"];
                materials_amount[2] = [15,5,5];

                materials_labels[3] = ["Ancient feathers", "Redwood logs", "Ancient bars"];
                materials_item[3] = ["ancient_feathers", "redwood_logs", "ancient_bar"];
                materials_amount[3] = [15,5,5];

                description = ["Basic arrows", "Very powerful againsts ice based monsters.  Very weak againsts water based monsters.", "Very powerful againsts fire based monsters.", "Strong arrows"];

            break;

            case "lizard_skin":
                item_variables = ["lizard_mask", "lizard_body", "lizard_legs", "lizard_gloves", "lizard_boots"];
                labels = ["Lizard Mask", "Lizard Body", "Lizard Legs", "Lizard Gloves", "Lizard Boots"];
                images = ["images/lizard_mask.png", "images/lizard_body.png", "images/lizard_legs.png", "images/lizard_gloves.png", "images/lizard_boots.png", ];
                level = [12, 12, 12, 12, 12];

                materials_labels[0] = ["Lizard Skin"];
                materials_item[0] = ["lizard_skin"];
                materials_amount[0] = [4];
                
                materials_labels[1] = ["Lizard Skin"];
                materials_item[1] = ["lizard_skin"];
                materials_amount[1] = [5];

                materials_labels[2] = ["Lizard Skin"];
                materials_item[2] = ["lizard_skin"];
                materials_amount[2] = [4];

                materials_labels[3] = ["Lizard Skin"];
                materials_item[3] = ["lizard_skin"];
                materials_amount[3] = [2];

                materials_labels[4] = ["Lizard Skin"];
                materials_item[4] = ["lizard_skin"];
                materials_amount[4] = [2];

                description = ["Increases your defence.", "Increases your defence.", "Increases your defence.", "Increases your defence.", "Increases your defence."];

            break;

            case "bat_skin":

                if(Items.getItem('wool') == 0) {
                    Modals.open_image_modal('BREEDING REQUIRMENT', 'images/wool.png', 'You need wool to craft this type of armour.  Wool can be obtained by raising <b>sheep</b> via the <b>breeding skill</b>.', null, 'Close', null)
                    return;
                }

                item_variables = ["bat_mask", "bat_body", "bat_legs", "bat_gloves", "bat_boots"];
                labels = ["Bat Mask", "Bat Body", "Bat Legs", "Bat Gloves", "Bat Boots"];
                images = ["images/bat_mask.png", "images/bat_body.png", "images/bat_legs.png", "images/bat_gloves.png", "images/bat_boots.png", ];
                level = [20, 20, 20, 20, 20];

                materials_labels[0] = ["Bat Skin", "Wool"];
                materials_item[0] = ["bat_skin", "wool"];
                materials_amount[0] = [4, 10];
                
                materials_labels[1] = ["Bat Skin", "Wool"];
                materials_item[1] = ["bat_skin", "wool"];
                materials_amount[1] = [5, 20];

                materials_labels[2] = ["Bat Skin", "Wool"];
                materials_item[2] = ["bat_skin", "wool"];
                materials_amount[2] = [4, 15];

                materials_labels[3] = ["Bat Skin", "Wool"];
                materials_item[3] = ["bat_skin", "wool"];
                materials_amount[3] = [2, 5];

                materials_labels[4] = ["Bat Skin", "Wool"];
                materials_item[4] = ["bat_skin", "wool"];
                materials_amount[4] = [2, 5];

                description = ["Increases your defence.", "Increases your defence.", "Increases your defence.", "Increases your defence.", "Increases your defence."];

            break;

            case "bear_fur":

                if(Items.getItem('wool') == 0) {
                    Modals.open_image_modal('BREEDING REQUIRMENT', 'images/wool.png', 'You need wool to craft this type of armour.  Wool can be obtained by raising <b>sheep</b> via the <b>breeding skill</b>.', null, 'Close', null)
                    return;
                }
                
                item_variables = ["bear_mask", "bear_body", "bear_legs", "bear_gloves", "bear_boots"];
                labels = ["Bear Mask", "Bear Body", "Bear Legs", "Bear Gloves", "Bear Boots"];
                images = ["images/bear_mask.png", "images/bear_body.png", "images/bear_legs.png", "images/bear_gloves.png", "images/bear_boots.png", ];
                level = [25, 25, 25, 25, 25];

                materials_labels[0] = ["Bear Skin", "Wool"];
                materials_item[0] = ["bear_fur", "wool"];
                materials_amount[0] = [4, 10];
                
                materials_labels[1] = ["Bear Skin", "Wool"];
                materials_item[1] = ["bear_fur", "wool"];
                materials_amount[1] = [5, 20];

                materials_labels[2] = ["Bear Skin", "Wool"];
                materials_item[2] = ["bear_fur", "wool"];
                materials_amount[2] = [4, 15];

                materials_labels[3] = ["Bear Skin", "Wool"];
                materials_item[3] = ["bear_fur", "wool"];
                materials_amount[3] = [2, 5];

                materials_labels[4] = ["Bear Skin", "Wool"];
                materials_item[4] = ["bear_fur", "wool"];
                materials_amount[4] = [2, 5];

                description = ["Increases your defence.", "Increases your defence.", "Increases your defence.", "Increases your defence.", "Increases your defence."];

            break;

            case "reaper_silk":
                item_variables = ["reaper_hood", "reaper_body", "reaper_skirt", "reaper_gloves", "reaper_boots"];
                labels = ["Crocodile Mask", "Crocodile Body", "Crocodile Legs", "Crocodile Gloves", "Crocodile Boots"];
                images = ["images/reaper_hood.png", "images/reaper_body.png", "images/reaper_skirt.png", "images/reaper_gloves.png", "images/reaper_boots.png", ];
                level = [52, 52, 52, 52, 52];

                materials_labels[0] = ["Reaper Silk"];
                materials_item[0] = ["reaper_silk"];
                materials_amount[0] = [15];
                
                materials_labels[1] = ["Reaper Silk"];
                materials_item[1] = ["reaper_silk"];
                materials_amount[1] = [25];

                materials_labels[2] = ["Reaper Silk"];
                materials_item[2] = ["reaper_silk"];
                materials_amount[2] = [21];

                materials_labels[3] = ["Reaper Silk"];
                materials_item[3] = ["reaper_silk"];
                materials_amount[3] = [8];

                materials_labels[4] = ["Reaper Silk"];
                materials_item[4] = ["reaper_silk"];
                materials_amount[4] = [8];

                description = ["Increases your magic bonus.", "Increases your magic bonus.", "Increases your magic bonus.", "Increases your magic bonus.", "Increases your magic bonus."];
            break;


            case "crocodile_hide":
                item_variables = ["crocodile_mask", "crocodile_body", "crocodile_legs", "crocodile_gloves", "crocodile_boots"];
                labels = ["Crocodile Mask", "Crocodile Body", "Crocodile Legs", "Crocodile Gloves", "Crocodile Boots"];
                images = ["images/crocodile_mask.png", "images/crocodile_body.png", "images/crocodile_legs.png", "images/crocodile_gloves.png", "images/crocodile_boots.png", ];
                level = [70, 70, 70, 70, 70];

                materials_labels[0] = ["Crocodile Hide"];
                materials_item[0] = ["crocodile_hide"];
                materials_amount[0] = [4];
                
                materials_labels[1] = ["Crocodile Hide"];
                materials_item[1] = ["crocodile_hide"];
                materials_amount[1] = [5];

                materials_labels[2] = ["Crocodile Hide"];
                materials_item[2] = ["crocodile_hide"];
                materials_amount[2] = [4];

                materials_labels[3] = ["Crocodile Hide"];
                materials_item[3] = ["crocodile_hide"];
                materials_amount[3] = [2];

                materials_labels[4] = ["Crocodile Hide"];
                materials_item[4] = ["crocodile_hide"];
                materials_amount[4] = [2];

                description = ["Increases your defence.", "Increases your defence.", "Increases your defence.", "Increases your defence.", "Increases your defence."];
            break;

            case "frozen_crocodile_hide":
                item_variables = ["frozen_crocodile_mask", "frozen_crocodile_body", "frozen_crocodile_legs", "frozen_crocodile_gloves", "frozen_crocodile_boots"];
                labels = ["Crocodile Mask (Frozen)", "Crocodile Body (Frozen)", "Crocodile Legs (Frozen)", "Crocodile Gloves (Frozen)", "Crocodile Boots (Frozen)"];
                images = ["images/frozen_crocodile_mask.png", "images/frozen_crocodile_body.png", "images/frozen_crocodile_legs.png", "images/frozen_crocodile_gloves.png", "images/frozen_crocodile_boots.png"];
                level = [90, 90, 90, 90, 90];

                materials_labels[0] = ["Crocodile Mask", "Crocodile Hide (Frozen)"];
                materials_item[0] = ["crocodile_mask", "frozen_crocodile_hide"];
                materials_amount[0] = [1, 4];
                
                materials_labels[1] = ["Crocodile Body", "Crocodile Hide (Frozen)"];
                materials_item[1] = ["crocodile_body", "frozen_crocodile_hide"];
                materials_amount[1] = [1, 5];

                materials_labels[2] = ["Crocodile Legs", "Crocodile Hide (Frozen)"];
                materials_item[2] = ["crocodile_legs", "frozen_crocodile_hide"];
                materials_amount[2] = [1, 4];

                materials_labels[3] = ["Crocodile Gloves", "Crocodile Hide (Frozen)"];
                materials_item[3] = ["crocodile_gloves", "frozen_crocodile_hide"];
                materials_amount[3] = [1, 2];

                materials_labels[4] = ["Crocodile Boots", "Crocodile Hide (Frozen)"];
                materials_item[4] = ["crocodile_boots", "frozen_crocodile_hide"];
                materials_amount[4] = [1, 2];

                description = ["Same as normal crocodile armour but protects you from cold damage.", "Same as normal crocodile armour but protects you from cold damage.", "Same as normal crocodile armour but protects you from cold damage.", "Same as normal crocodile armour but protects you from cold damage.", "Same as normal crocodile armour but protects you from cold damage."];

            break;

            case "skilling_crafting_outfit":
                item_variables = ["crafting_skilling_boots", "crafting_skilling_gloves", "crafting_skilling_pants", "crafting_skilling_shirt"];
                labels = ["Boots", "Gloves", "Pants", "Shirt"];
                images = ["images/crafting_skilling_boots.png", "images/crafting_skilling_gloves.png", "images/crafting_skilling_pants.png", "images/crafting_skilling_shirt.png", ];
                level = [50, 55, 60, 65];

                materials_labels[0] = ["Skillers Leather", "Diamond Needle"];
                materials_item[0] = ["skillers_leather", "diamond_needle"];
                materials_amount[0] = [3, 1];
                
                materials_labels[1] = ["Skillers Leather", "Diamond Needle"];
                materials_item[1] = ["skillers_leather", "diamond_needle"];
                materials_amount[1] = [3, 1];

                materials_labels[2] = ["Skillers Leather", "Diamond Needle"];
                materials_item[2] = ["skillers_leather", "diamond_needle"];
                materials_amount[2] = [4, 1];

                materials_labels[3] = ["Skillers Leather", "Diamond Needle"];
                materials_item[3] = ["skillers_leather"];
                materials_amount[3] = [5, 1];

                description = ["A piece of the crafting's skilling outfit.<br /><br /><span style='color:grey'>Skillers leather may be obtained by any monster.  The rate changes based on combat area.</span>", "A piece of the crafting's skilling outfit.<br /><br /><span style='color:grey'>Skillers leather may be obtained by any monster.  The rate changes based on combat area.</span>", "A piece of the crafting's skilling outfit.<br /><br /><span style='color:grey'>Skillers leather may be obtained by any monster.  The rate changes based on combat area.</span>", "A piece of the crafting's skilling outfit.<br /><br /><span style='color:grey'>Skillers leather may be obtained by any monster.  The rate changes based on combat area.</span>"];

            break;


            case "moonstone":
                item_variables = ["moonstone_mask", "moonstone_body", "moonstone_legs", "moonstone_gloves", "moonstone_boots"];
                labels = ["Moonstone Mask", "Moonstone Body", "Moonstone Legs", "Moonstone Gloves", "Moonstone Boots"];
                images = ["images/moonstone_mask.png", "images/moonstone_body.png", "images/moonstone_legs.png", "images/moonstone_gloves.png", "images/moonstone_boots.png", ];
                level = [60, 60, 60, 60, 60];

                materials_labels[0] = ["Moonstone"];
                materials_item[0] = ["moonstone"];
                materials_amount[0] = [4];
                
                materials_labels[1] = ["Moonstone"];
                materials_item[1] = ["moonstone"];
                materials_amount[1] = [5];

                materials_labels[2] = ["Moonstone"];
                materials_item[2] = ["moonstone"];
                materials_amount[2] = [4];

                materials_labels[3] = ["Moonstone"];
                materials_item[3] = ["moonstone"];
                materials_amount[3] = [2];

                materials_labels[4] = ["Moonstone"];
                materials_item[4] = ["moonstone"];
                materials_amount[4] = [2];

                description = ["Increases your defence.", "Increases your defence.", "Increases your defence.", "Increases your defence.", "Increases your defence."];

            break;

            case "staff_spirit":
                item_variables = ["undead_hp_staff", "undead_mana_staff", "undead_defence_staff", "undead_full_staff"];
                labels = ["Undead Staff (HP)", "Undead Staff (Mana)", "Undead Staff (Defence)", "Undead Staff (Full)"];
                images = ["images/undead_hp_staff.png", "images/undead_mana_staff.png", "images/undead_defence_staff.png", "images/undead_full_staff.png"];
                level = [90, 90, 90, 90, 90];

                materials_labels[0] = ["Undead Staff", "HP Spirit"];
                materials_item[0] = ["undead_staff", "hp_staff_spirit"];
                materials_amount[0] = [1, 1];
                
                materials_labels[1] = ["Undead Staff", "Mana Spirit"];
                materials_item[1] = ["undead_staff", "mana_staff_spirit"];
                materials_amount[1] = [1, 1];

                materials_labels[2] = ["Undead Staff", "Defence Spirit"];
                materials_item[2] = ["undead_staff", "defence_staff_spirit"];
                materials_amount[2] = [1, 1];

                materials_labels[3] = ["Undead Staff", "Combined Spirit"];
                materials_item[3] = ["undead_staff", "full_staff_spirit"];
                materials_amount[3] = [1, 1];

                description = [
                    "Casting your first spell in combat will increase your maximum hp by 10 during the fight.",
                    "Casting your first spell in combat will increase your maximum mana by 10 during the fight.",
                    "Casting your first spell in combat will decrease the enemy defence by 10 during the fight.",
                    "Casting your first spell in combat will apply all effects mentioned above."
                ];
            break;
            

            
            case "horseshoe":
                item_variables = ["breeding_fence_5", "breeding_fence_400", "breeding_fence_5000"];
                labels = ["Fence x 5", "Fence x 400", "Fence x 5000"];
                images = ["images/breeding_fence.png", "images/breeding_fence.png", "images/breeding_fence.png"];
                level = [30, 60, 90];

                materials_labels[0] = ["Horseshoe"];
                materials_item[0] = ["horseshoe"];
                materials_amount[0] = [1];
                
                materials_labels[1] = ["Horseshoe (Solid)"];
                materials_item[1] = ["solid_horseshoe"];
                materials_amount[1] = [1];

                materials_labels[2] = ["Horseshoe (Cemented)"];
                materials_item[2] = ["cemented_horseshoe"];
                materials_amount[2] = [1];

                description = ["A fence used to increase animal capacity.", "A fence used to increase animal capacity.", "A fence used to increase animal capacity."];
            break;

            
            case "water_bucket":
                item_variables = ["saltwater_bucket"];
                labels = ["Full bucket of Salt Water"];
                images = ["images/saltwater_bucket.png"];
                level = [1];

                materials_labels[0] = ["Bucket (Shark)", "Bucket (Puffer Fish)", "Bucket (Sea Solder)", "Bucket (Crocodile)"];
                materials_item[0] = ["shark_bucket", "puffer_fish_bucket", "sea_soldier_bucket", "saltwater_crocodile_bucket"];
                materials_amount[0] = [1, 1, 1, 1];
                
                description = ["A full bucket of salt water.<br /><span class='color-grey>Requires 1/4 of salt water from each monster at the ocean.</span>'"];
            break;

            case "string":
                item_variables = ["bad_fishing_net"];
                labels = ["Fishing Net"];
                images = ["images/bad_fishing_net.png"];
                level = [10];

                materials_labels[0] = ["String"];
                materials_item[0] = ["string"];
                materials_amount[0] = [10];
                
                description = ["A fishing net."];
            break;

            case "guardians_tear":
                item_variables = ["amulet_of_healing_rain"];
                labels = ["Amulet of Healing Rain"];
                images = ["images/amulet_of_healing_rain.png"];
                level = [75];

                materials_labels[0] = ["Gaurdian Tear", "Rain Potion", "String"];
                materials_item[0] = ["guardians_tear", "rain_potion", "string"];
                materials_amount[0] = [1, 25, 100];

                description = ["Acts like a rain potion when equipped."];
            break;

            case "long_bow_frame":
                item_variables = ["long_bow"];
                labels = ["Long bow"];
                images = ["images/long_bow.png"];
                level = [40];

                materials_labels[0] = ["String"];
                materials_item[0] = ["string"];
                materials_amount[0] = [50];
                
                description = ["A very accurate bow."];
            break;

            case "haunted_bow_frame":
                item_variables = ["haunted_bow"];
                labels = ["Haunted Bow"];
                images = ["images/haunted_bow.png"];
                level = [50];

                materials_labels[0] = ["Long bow"];
                materials_item[0] = ["long_bow"];
                materials_amount[0] = [2];
                
                description = ["Double damage on ghost type monsters."];
            break;

            case "train_cart_completed":
                item_variables = ["train_cart_completed"];
                labels = ["Train Cart"];
                images = ["images/train_cart_completed.png"];
                level = [10];

                materials_labels[0] = ["Train Cart (Piece 1)", "Train Cart (Piece 2)" ,"Train Cart (Piece 3)" ,"Train Cart (Piece 4)"];
                materials_item[0] = ["train_cart_piece_1","train_cart_piece_2","train_cart_piece_3","train_cart_piece_4"];
                materials_amount[0] = [1,1,1,1];
                
                description = ["Used to use the train track system; see side quest: Train Combat Network."];
            break;

            case "castle_portal":
                item_variables = ["castle_portal_2_completed", "castle_portal_3_completed"];
                labels = ["Portal (Floor 2)", "Portal (Floor 3)"];
                images = ["images/castle_portal_2_completed.png", "images/castle_portal_3_completed.png"];
                level = [100, 100];

                materials_labels[0] = ["Castle Portal Base (Floor 2)", "Castle Portal Energy (Floor 2)"];
                materials_item[0] = ["castle_portal_2", "portal_base_floor_2"];
                materials_amount[0] = [1,1];

                materials_labels[1] = ["Castle Portal Base (Floor 3)", "Castle Portal Energy (Floor 3)"];
                materials_item[1] = ["castle_portal_3", "portal_base_floor_3"];
                materials_amount[1] = [1,1];
                
                description = ["Ability to access floor 2 of the castle.", "Ability to access floor 3 of the castle."];
            break;

            

            case "robot":
                item_variables = ["robot"];
                labels = ["Robot"];
                images = ["images/robot.png"];
                level = [80];

                materials_labels[0] = ["Robot Head", "Robot Body", "Robot Legs", "Robot Hands", "Robot Feet"];
                materials_item[0] = ["robot_head", "robot_body", "robot_legs", "robot_hands", "robot_feet"];
                materials_amount[0] = [1,1,1,1,1];
                
                description = ["Hmm.  A robot."];
            break;

            case "ant_needles":
                item_variables = ["needle", "spiked_club"];
                labels = ["Needle", "Spiked Club"];
                images = ["images/needle.png", "images/spiked_club.png"];
                level = [20, 45];

                materials_labels[0] = ["Ant Needle", "String"];
                materials_item[0] = ["ant_needles", "string"];
                materials_amount[0] = [50, 10];
                
                materials_labels[1] = ["Club", "Ant Needle"];
                materials_item[1] = ["club", "ant_needles"];
                materials_amount[1] = [1, 100];

                description = [
                    "A needle allows you to convert armour back into its skin form.",
                    "Add spikes to a club, increasing its damage by 4."
                ];
            break;

            case "puffer_needles":
                item_variables = ["spiked_dense_club"];
                labels = ["Dense Spiked Club"];
                images = ["images/spiked_dense_club.png"];
                level = [100];

                materials_labels[0] = ["Dense Club", "Puffer Needle"];
                materials_item[0] = ["dense_club", "puffer_needles"];
                materials_amount[0] = [1, 100];
                
                description = [
                    "Add spikes to a club, increasing its damage by 10."
                ];
            break;

            case "castle_boots":
                item_variables = ["spiked_castle_boots"];
                labels = ["Spiked Castle Boots"];
                images = ["images/spiked_castle_boots.png"];
                level = [100];

                materials_labels[0] = ["Castle Boots", "Puffer Needle"];
                materials_item[0] = ["castle_boots", "puffer_needles"];
                materials_amount[0] = [1, 250];
                
                description = [
                    "Ability to walk on ice in the castle."
                ];
            break;

            case "fisherman_scroll":
                item_variables = ["fishing_net_quest"];
                labels = ["Sturdy Fishing Net"];
                images = ["images/fishing_net_quest.png"];
                level = [10];

                materials_labels[0] = ["Silver Bars", "Lizard Skin"];
                materials_item[0] = ["silver_bar", "lizard_skin"];
                materials_amount[0] = [5, 1];

                var description = ["A sturdy fishing net."];
            break;

            case "cannon":
                item_variables = ["cannon"];
                labels = ["Cannon"];
                images = ["images/cannon.png"];
                level = [100];

                materials_labels[0] = ["Cannon Base", "Cannon Barrel", "Cannon Wheels"];
                materials_item[0] = ["cannon_base", "cannon_barrel", "cannon_wheels"];
                materials_amount[0] = [1, 1, 1];

                var description = ["A cannon used in combat."];
            break;
            case "cannonball_mould":
                item_variables = ["iron_cannonball"];
                labels = ["Cannonball x 10"];
                images = ["images/cannonball.png"];
                level = [60];

                materials_labels[0] = ["Cannonball Mould", "Iron Bars"];
                materials_item[0] = ["cannonball_mould", "iron_bar"];
                materials_amount[0] = [1, 10];

                var description = ["Iron cannon balls"];
            break;

            case "giant_mould":
                item_variables = ["giant_metal_ball"];
                labels = ["Dense Metal Bar"];
                images = ["images/giant_metal_ball.png"];
                level = [100];

                materials_labels[0] = ["Giant Mould", "Bronze Bars", "Iron Bars", "Silver Bars", "Gold Bars"];
                materials_item[0] = ["giant_mould", "bronze_bar", "iron_bar", "silver_bar", "gold_bar"];
                materials_amount[0] = [1, 50000,40000,30000,20000];

                var description = ["A massive dense ball of metal.  I would not want to drop this from a high place."];
            break;

            
            
            case "poison":
                item_variables = ["poison_stinger", "poison_stinger_dagger", "poison_rapier", "poison_gold_rapier"];
                labels = ["Poison Stinger", "Poison Stinger Dagger", "Poison Rapier", "Poison Rapier (Gold)"];
                images = ["images/poison_stinger.png", "images/poison_stinger_dagger.png", "images/poison_rapier.png", "images/poison_gold_rapier.png"];
                level = [15, 60, 80, 90];

                materials_labels[0] = ["Poison", "Stinger"];
                materials_item[0] = ["poison", "stinger"];
                materials_amount[0] = [1,1];

                materials_labels[1] = ["Poison", "Stinger Dagger"];
                materials_item[1] = ["poison", "stinger_dagger"];
                materials_amount[1] = [4,1];

                materials_labels[2] = ["Poison", "Poison Rapier"];
                materials_item[2] = ["poison", "rapier"];
                materials_amount[2] = [10,1];

                materials_labels[3] = ["Poison", "Poison Rapier (Gold)"];
                materials_item[3] = ["poison", "gold_rapier"];
                materials_amount[3] = [10,1];

                description = [
                    "A poison stinger, deals extra damage and ignores enemy defence.",
                    "A poison stinger dagger, deals extra damage and ignores enemy defence.",
                    "A poison rapier, deals extra damage and ignores enemy defence.",
                    "A gold poison rapier, deals extra damage and ignores enemy defence.",
                ];
            break;

            case "invention_blueprint":
                item_variables = ["bronze_blood_grinder", "bronze_blood_glass_shrine"];
                labels = ["Cheap Blood Grinder", "Cheap Blood Statue"];
                images = ["images/bronze_blood_grinder.png", "images/bronze_blood_glass_shrine.png", "images/ice_arrows.png"];
                level = [60, 60];

                materials_labels[0] = ["Bronze Bars"];
                materials_item[0] = ["bronze_bar"];
                materials_amount[0] = [100];

                materials_labels[1] = ["Bronze Bars"];
                materials_item[1] = ["bronze_bar", "tutorial_evil_blood"];
                materials_amount[1] = [500, 10];

                description = ["Ability to crush limbs into evil blood", "Ability to remove the evil from blood with the help of magic."];

            break;

            case "treasure_chest_keys":
                item_variables = ["gold_key", "gold_sapphire_key", "gold_emerald_key", "gold_ruby_key", "gold_diamond_key"];
                labels = ["Gold Key", "Sapphire Key", "Emerald Key", "Ruby Key", "Diamond Key"];
                images = ["images/gold_key.png", "images/gold_sapphire_key.png", "images/gold_emerald_key.png", "images/gold_ruby_key.png", "images/gold_diamond_key.png", ];
                level = [15, 25, 35, 45, 55];

                materials_labels[0] = ["Gold Bars"];
                materials_item[0] = ["gold_bar"];
                materials_amount[0] = [5];
                
                materials_labels[1] = ["Gold Bars", "Sapphire"];
                materials_item[1] = ["gold_bar", "sapphire"];
                materials_amount[1] = [5,1];

                materials_labels[2] = ["Gold Bars", "Emerald"];
                materials_item[2] = ["gold_bar", "emerald"];
                materials_amount[2] = [5,1];

                materials_labels[3] = ["Gold Bars", "Ruby"];
                materials_item[3] = ["gold_bar", "ruby"];
                materials_amount[3] = [5,1];

                materials_labels[4] = ["Gold Bars", "Diamond"];
                materials_item[4] = ["gold_bar", "diamond"];
                materials_amount[4] = [5,1];

                description = ["A key for a treasure chest. (1 roll)", "A key for a treasure chest. (2 rolls)", "A key for a treasure chest. (3 rolls)", "A key for a treasure chest. (4 rolls)", "A key for a treasure chest. (6 rolls)"];
            break;

            case "green_treasure_chest_keys":
                item_variables = ["promethium_key", "promethium_sapphire_key", "promethium_emerald_key", "promethium_ruby_key", "promethium_diamond_key"];
                labels = ["Promethium Key", "Promethium Sapphire Key", "Promethium Emerald Key", "Promethium Ruby Key", "Promethium Diamond Key"];
                images = ["images/promethium_key.png", "images/promethium_sapphire_key.png", "images/promethium_emerald_key.png", "images/promethium_ruby_key.png", "images/promethium_diamond_key.png", ];
                level = [30, 40, 50, 60, 70];

                materials_labels[0] = ["Promethium Bars"];
                materials_item[0] = ["promethium_bar"];
                materials_amount[0] = [5];
                
                materials_labels[1] = ["Promethium Bars", "Sapphire"];
                materials_item[1] = ["promethium_bar", "sapphire"];
                materials_amount[1] = [5,1];

                materials_labels[2] = ["Promethium Bars", "Emerald"];
                materials_item[2] = ["promethium_bar", "emerald"];
                materials_amount[2] = [5,1];

                materials_labels[3] = ["Promethium Bars", "Ruby"];
                materials_item[3] = ["promethium_bar", "ruby"];
                materials_amount[3] = [5,1];

                materials_labels[4] = ["Promethium Bars", "Diamond"];
                materials_item[4] = ["promethium_bar", "diamond"];
                materials_amount[4] = [5,1];

                description = ["A key for a green treasure chest. (1 roll)", "A key for a green treasure chest. (2 rolls)", "A key for a green treasure chest. (3 rolls)", "A key for a green treasure chest. (4 rolls)", "A key for a green treasure chest. (6 rolls)"];
            break;

            case "red_treasure_chest_keys":
                item_variables = ["titanium_key", "titanium_sapphire_key", "titanium_emerald_key", "titanium_ruby_key", "titanium_diamond_key"];
                labels = ["Titanium Key", "Titanium Sapphire Key", "Titanium Emerald Key", "Titanium Ruby Key", "Titanium Diamond Key"];
                images = ["images/titanium_key.png", "images/titanium_sapphire_key.png", "images/titanium_emerald_key.png", "images/titanium_ruby_key.png", "images/titanium_diamond_key.png", ];
                level = [60, 70, 80, 90, 100];

                materials_labels[0] = ["Promethium Bars"];
                materials_item[0] = ["titanium_bar"];
                materials_amount[0] = [5];
                
                materials_labels[1] = ["Promethium Bars", "Sapphire"];
                materials_item[1] = ["titanium_bar", "sapphire"];
                materials_amount[1] = [5,1];

                materials_labels[2] = ["Promethium Bars", "Emerald"];
                materials_item[2] = ["titanium_bar", "emerald"];
                materials_amount[2] = [5,1];

                materials_labels[3] = ["Promethium Bars", "Ruby"];
                materials_item[3] = ["titanium_bar", "ruby"];
                materials_amount[3] = [5,1];

                materials_labels[4] = ["Promethium Bars", "Diamond"];
                materials_item[4] = ["titanium_bar", "diamond"];
                materials_amount[4] = [5,1];

                description = ["A key for a red treasure chest. (1 roll)", "A key for a red treasure chest. (2 rolls)", "A key for a red treasure chest. (3 rolls)", "A key for a red treasure chest. (4 rolls)", "A key for a red treasure chest. (6 rolls)"];
            break;

            case "ancient_broken_key":
                item_variables = ["ancient_key", "ancient_sapphire_key", "ancient_emerald_key", "ancient_ruby_key", "ancient_diamond_key"];
                labels = ["Ancient Key", "Ancient Sapphire Key", "Ancient Emerald Key", "Ancient Ruby Key", "Ancient Diamond Key"];
                images = ["images/ancient_key.png", "images/ancient_sapphire_key.png", "images/ancient_emerald_key.png", "images/ancient_ruby_key.png", "images/ancient_diamond_key.png", ];
                level = [100, 100, 100, 100, 100];

                materials_labels[0] = ["Ancient Broken Key", "Ancient Bars"];
                materials_item[0] = ["ancient_bar", "ancient_broken_key"];
                materials_amount[0] = [5, 1];
                
                materials_labels[1] = ["Ancient Broken Key", "Ancient Bars", "Sapphire"];
                materials_item[1] = ["ancient_bar", "ancient_broken_key","sapphire"];
                materials_amount[1] = [5,1,1];

                materials_labels[2] = ["Ancient Broken Key", "Ancient Bars", "Emerald"];
                materials_item[2] = ["ancient_bar","ancient_broken_key", "emerald"];
                materials_amount[2] = [5,1,1];

                materials_labels[3] = ["Ancient Broken Key", "Ancient Bars", "Ruby"];
                materials_item[3] = ["ancient_bar", "ancient_broken_key","ruby"];
                materials_amount[3] = [5,1,1];

                materials_labels[4] = ["Ancient Broken Key", "Ancient Bars", "Diamond"];
                materials_item[4] = ["ancient_bar", "ancient_broken_key","diamond"];
                materials_amount[4] = [5,1,1];

                description = ["A key for any treasure chest. (2 rolls)", "A key for any treasure chest. (4 rolls)", "A key for a any treasure chest. (6 rolls)", "A key for a any treasure chest. (8 rolls)", "A key for a any treasure chest. (12 rolls)"];
            break;

            case "sea_molten_glass":
                item_variables = ["mega_shiny_glass_ball_logs_plus", "mega_shiny_glass_ball_leaf_plus", "mega_shiny_glass_ball_fish_plus", "mega_shiny_glass_ball_monsters_plus"];
                labels = ["Mega Shiny Ball+", "Mega Shiny Ball+", "Mega Shiny Ball+", "Mega Shiny Ball+"];
                images = ["images/mega_shiny_glass_ball_logs_plus.png", "images/mega_shiny_glass_ball_leaf_plus.png", "images/mega_shiny_glass_ball_fish_plus.png" ,"images/mega_shiny_glass_ball_monsters_plus.png"];
                level = [100, 100,100, 100];

                materials_labels[0] = ["Mega Shiny Ball", "Sea Glass"];
                materials_item[0] = ["mega_shiny_glass_ball_logs", "sea_molten_glass"];
                materials_amount[0] = [1,5];

                materials_labels[1] = ["Mega Shiny Ball", "Sea Glass"];
                materials_item[1] = ["mega_shiny_glass_ball_leaf", "sea_molten_glass"];
                materials_amount[1] = [1,10];

                materials_labels[2] = ["Mega Shiny Ball", "Sea Glass"];
                materials_item[2] = ["mega_shiny_glass_ball_fish", "sea_molten_glass"];
                materials_amount[2] = [1,20];

                materials_labels[3] = ["Mega Shiny Ball", "Sea Glass"];
                materials_item[3] = ["mega_shiny_glass_ball_monsters", "sea_molten_glass"];
                materials_amount[3] = [1,35];

               
                description = ["Increases your chance of getting a shiny from 1% to 3%","Increases your chance of getting a shiny from 1% to 3%","Increases your chance of getting a shiny from 1% to 3%","Increases your chance of getting a shiny from 1% to 3%"];
            break;

            case "shiny_glass_ball":
                item_variables = ["shiny_glass_ball_logs", "shiny_glass_ball_leaf", "shiny_glass_ball_fish", "shiny_glass_ball_monsters"];
                labels = ["Shiny Woodcutting Orb", "Shiny Farming Orb", "Shiny Fish Orb", "Shiny Combat Orb"];
                images = ["images/shiny_glass_ball_logs.png", "images/shiny_glass_ball_leaf.png", "images/shiny_glass_ball_fish.png", "images/shiny_glass_ball_monsters.png"];
                level = [10, 15, 20, 25];

                materials_labels[0] = ["Maple Log"];
                materials_item[0] = ["maple_logs"];
                materials_amount[0] = [1];

                materials_labels[1] = ["Gold Leaf"];
                materials_item[1] = ["gold_leaf"];
                materials_amount[1] = [1];

                materials_labels[2] = ["Raw Piranha"];
                materials_item[2] = ["raw_piranha"];
                materials_amount[2] = [1];

                materials_labels[3] = ["Cave Skeleton Skull"];
                materials_item[3] = ["skull"];
                materials_amount[3] = [1];

                description = [
                    "1% chance that a tree will be shiny when it starts growing.<br /><br /><small>+1000 xp when enchanted</small>",
                    "1% chance that planting a seed will make your crop shiny.<br /><br /><small>+1500 xp when enchanted</small>",
                    "1% chance that catching any fish will make it shiny.<br /><br /><small>+2000 xp when enchanted</small>",
                    "1% chance that fighting a monster will be shiny.<br /><br /><small>+3000 xp when enchanted</small>",
                ];
            break;

            case "invisibility_spell":
                item_variables = ["glass_bottle_spell"];
                labels = ["???"];
                images = ["images/glass_bottle_spell.png"];
                level = [35];

                materials_labels[0] = ["Ghost in a bottle", "Ghost essence"];
                materials_item[0] = ["glass_bottle_ghost", "ghost_essence"];
                materials_amount[0] = [1, 666];

                description = [
                    "Makes you invisible for 2 seconds, avoiding 100% of damage.",
                ];
            break;

            case "blue_marble_mineral":
            case "amethyst_mineral":
            case "sea_crystal_mineral":
                item_variables = ["weak_defence_ring", "weak_damage_ring", "weak_accuracy_ring"];
                labels = ["Weak Defence Ring", "Weak Damage Ring", "Weak Accuracy Ring"];
                images = ["images/weak_defence_ring.png", "images/weak_damage_ring.png", "images/weak_accuracy_ring.png"];
                level = [40, 40, 40, 40];

                materials_labels[0] = ["Iron Bars", "Blue Marble"];
                materials_item[0] = ["iron_bar", "blue_marble_mineral"];
                materials_amount[0] = [20, 1];

                materials_labels[1] = ["Iron Bars", "Amethyst"];
                materials_item[1] = ["iron_bar", "amethyst_mineral"];
                materials_amount[1] = [20, 1];

                materials_labels[2] = ["Iron Bars", "Sea Crystal (Seal?)"];
                materials_item[2] = ["iron_bar", "sea_crystal_mineral"];
                materials_amount[2] = [20, 1];

                description = [
                    "+1 combat defence.",
                    "+1 combat melee and arrow damage.",
                    "+1 combat accuracy.",
                ];
            break;

            case "dense_marble_mineral":
            case "fluorite_mineral":
            case "clear_marble_mineral":
                item_variables = ["defence_ring", "damage_ring", "accuracy_ring"];
                labels = ["Defence Ring", "Damage Ring", "Accuracy Ring"];
                images = ["images/defence_ring.png", "images/damage_ring.png", "images/accuracy_ring.png"];
                level = [50, 50, 50, 50];

                materials_labels[0] = ["Silver Bars", "Dense Marble"];
                materials_item[0] = ["silver_bar", "dense_marble_mineral"];
                materials_amount[0] = [20, 1];

                materials_labels[1] = ["Silver Bars", "Fluorite"];
                materials_item[1] = ["silver_bar", "fluorite_mineral"];
                materials_amount[1] = [20, 1];

                materials_labels[2] = ["Silver Bars", "Clear Marble"];
                materials_item[2] = ["silver_bar", "clear_marble_mineral"];
                materials_amount[2] = [20, 1];

                description = [
                    "+2 combat defence.",
                    "+2 combat melee and arrow damage.",
                    "+2 combat accuracy.",
                ];
            break;

            case "jade_mineral":
            case "lime_quartz_mineral":
            case "opal_mineral":
                item_variables = ["good_defence_ring", "good_damage_ring", "good_accuracy_ring"];
                labels = ["Good Defence Ring", "Good Damage Ring", "Good Accuracy Ring"];
                images = ["images/good_defence_ring.png", "images/good_damage_ring.png", "images/good_accuracy_ring.png"];
                level = [60, 60, 60, 60];

                materials_labels[0] = ["Gold Bars", "Jade"];
                materials_item[0] = ["gold_bar", "jade_mineral"];
                materials_amount[0] = [20, 1];

                materials_labels[1] = ["Gold Bars", "Lime Quartz"];
                materials_item[1] = ["gold_bar", "lime_quartz_mineral"];
                materials_amount[1] = [20, 1];

                materials_labels[2] = ["Gold Bars", "Opal"];
                materials_item[2] = ["gold_bar", "opal_mineral"];
                materials_amount[2] = [20, 1];

                description = [
                    "+3 combat defence.",
                    "+3 combat melee and arrow damage.",
                    "+3 combat accuracy.",
                ];
            break;

            case "purple_quartz_mineral":
            case "amber_mineral":
            case "smooth_pearl_mineral":
                item_variables = ["great_defence_ring", "great_damage_ring", "great_accuracy_ring"];
                labels = ["Great Defence Ring", "Great Damage Ring", "Great Accuracy Ring"];
                images = ["images/great_defence_ring.png", "images/great_damage_ring.png", "images/great_accuracy_ring.png"];
                level = [70, 70, 70, 70];

                materials_labels[0] = ["Promethium Bars", "Purple Quartz"];
                materials_item[0] = ["promethium_bar", "purple_quartz_mineral"];
                materials_amount[0] = [20, 1];

                materials_labels[1] = ["Promethium Bars", "Amber"];
                materials_item[1] = ["promethium_bar", "amber_mineral"];
                materials_amount[1] = [20, 1];

                materials_labels[2] = ["Promethium Bars", "Smooth Pearl"];
                materials_item[2] = ["promethium_bar", "smooth_pearl_mineral"];
                materials_amount[2] = [20, 1];

                description = [
                    "+4 combat defence.",
                    "+4 combat melee and arrow damage.",
                    "+4 combat accuracy.",
                ];
            break;

            case "sulfer_mineral":
            case "topaz_mineral":
            case "tanzanite_mineral":
                item_variables = ["perfect_defence_ring", "perfect_damage_ring", "perfect_accuracy_ring"];
                labels = ["Perfect Defence Ring", "Perfect Damage Ring", "Perfect Accuracy Ring"];
                images = ["images/perfect_defence_ring.png", "images/perfect_damage_ring.png", "images/perfect_accuracy_ring.png"];
                level = [80, 80, 80, 80];

                materials_labels[0] = ["Titanium Bars", "Purple Quartz"];
                materials_item[0] = ["titanium_bar", "sulfer_mineral"];
                materials_amount[0] = [20, 1];

                materials_labels[1] = ["Titanium Bars", "Amber"];
                materials_item[1] = ["titanium_bar", "topaz_mineral"];
                materials_amount[1] = [20, 1];

                materials_labels[2] = ["Titanium Bars", "Smooth Pearl"];
                materials_item[2] = ["titanium_bar", "tanzanite_mineral"];
                materials_amount[2] = [20, 1];

                description = [
                    "+5 combat defence.",
                    "+5 combat melee and arrow damage.",
                    "+5 combat accuracy.",
                ];
            break;

            case "magnesium_mineral":
            case "frozen_mineral":
            case "blood_crystal_mineral":
                item_variables = ["ancient_defence_ring", "ancient_damage_ring", "ancient_accuracy_ring"];
                labels = ["Ancient Defence Ring", "Ancient Damage Ring", "Ancient Accuracy Ring"];
                images = ["images/ancient_defence_ring.png", "images/ancient_damage_ring.png", "images/ancient_accuracy_ring.png"];
                level = [90, 90, 90, 90];

                materials_labels[0] = ["Ancient Bars", "Purple Quartz"];
                materials_item[0] = ["ancient_bar", "magnesium_mineral"];
                materials_amount[0] = [20, 1];

                materials_labels[1] = ["Ancient Bars", "Amber"];
                materials_item[1] = ["ancient_bar", "frozen_mineral"];
                materials_amount[1] = [20, 1];

                materials_labels[2] = ["Ancient Bars", "Smooth Pearl"];
                materials_item[2] = ["ancient_bar", "blood_crystal_mineral"];
                materials_amount[2] = [20, 1];

                description = [
                    "+6 combat defence.",
                    "+6 combat melee and arrow damage.",
                    "+6 combat accuracy.",
                ];
            break;

            case "field_tablette":
                item_variables = ["field_tablette"];
                labels = ["Field Tablette"];
                images = ["images/field_tablette.png"];
                level = [60];

                materials_labels[0] = ["Poison", "Stinger"];
                materials_item[0] = ["field_tablette_1", "field_tablette_2", "field_tablette_3", "field_tablette_4", "field_tablette_5"];
                materials_amount[0] = [1,1,1,1,1];

                description = ["Create a tablette to learn how to invent powerful stingers."];
            break;

            case "forest_tablette":
                item_variables = ["forest_tablette"];
                labels = ["Forest Tablette"];
                images = ["images/forest_tablette.png"];
                level = [65];

                materials_labels[0] = ["Poison", "Stinger"];
                materials_item[0] = ["forest_tablette_1", "forest_tablette_2", "forest_tablette_3", "forest_tablette_4", "forest_tablette_5"];
                materials_amount[0] = [1,1,1,1,1];

                description = ["Create a tablette to learn how to invent powerful iron daggers."];
            break;

            case "cave_tablette":
                item_variables = ["cave_tablette"];
                labels = ["Cave Tablette"];
                images = ["images/cave_tablette.png"];
                level = [70];

                materials_labels[0] = ["Poison", "Stinger"];
                materials_item[0] = ["cave_tablette_1", "cave_tablette_2", "cave_tablette_3", "cave_tablette_4"];
                materials_amount[0] = [1,1,1,1];

                description = ["Create a tablette to learn how to invent more items."];
            break;

            case "volcano_tablette":
                item_variables = ["volcano_tablette"];
                labels = ["Volcano Tablette"];
                images = ["images/volcano_tablette.png"];
                level = [75];

                materials_labels[0] = ["Volcano Tablette 1", "Volcano Tablette 2"];
                materials_item[0] = ["volcano_tablette_1", "volcano_tablette_2", "volcano_tablette_3", "volcano_tablette_4"];
                materials_amount[0] = [1,1,1,1];

                description = ["Create a tablette to learn how to invent more items."];
            break;

            case "ancient_tablette":
                item_variables = ["ancient_tablette"];
                labels = ["Ancient Tablette"];
                images = ["images/ancient_tablette.png"];
                level = [95];

                materials_labels[0] = ["Ancient Tablette 1", "Ancient Tablette 2", "Ancient Tablette 3", "Ancient Tablette 4", "Ancient Tablette 5"];
                materials_item[0] = ["ancient_tablette_1", "ancient_tablette_2", "ancient_tablette_3", "ancient_tablette_4", "ancient_tablette_5"];
                materials_amount[0] = [1,1,1,1,1];

                description = ["Create a tablette to learn how to invent more items."];
            break;

            case "easter_2023":
                item_variables = [
                    "stone_egg",
                    "copper_egg",
                    "iron_egg",
                    "silver_egg",
                    "gold_egg",
                    "bronze_metal_egg",
                    "iron_metal_egg",
                    "silver_metal_egg",
                    "gold_metal_egg",
                    "dotted_green_leaf_egg",
                    "green_leaf_egg",
                    "lime_leaf_egg",
                    "gold_leaf_egg",
                    "logs_egg",
                    "oak_logs_egg",
                    "willow_logs_egg",
                    "maple_logs_egg",
                    "chocolate_bar_egg",
                    "apple_egg",
                    "banana_egg",
                    "maggot_egg",
                    "stinger_egg",
                    "iron_dagger_egg",

                ];
                labels = Array(item_variables.length).fill("Chocolate Egg?")
                images = [
                    "images/stone_egg.png",
                    "images/copper_egg.png",
                    "images/iron_egg.png",
                    "images/silver_egg.png",
                    "images/gold_egg.png",
                    "images/bronze_metal_egg.png",
                    "images/iron_metal_egg.png",
                    "images/silver_metal_egg.png",
                    "images/gold_metal_egg.png",
                    "images/dotted_green_leaf_egg.png",
                    "images/green_leaf_egg.png",
                    "images/lime_leaf_egg.png",
                    "images/gold_leaf_egg.png",
                    "images/logs_egg.png",
                    "images/oak_logs_egg.png",
                    "images/willow_logs_egg.png",
                    "images/maple_logs_egg.png",
                    "images/chocolate_bar_egg.png",
                    "images/apple_egg.png",
                    "images/banana_egg.png",
                    "images/maggot_egg.png",
                    "images/stinger_egg.png",
                    "images/iron_dagger_egg.png",
                ];
                level = Array(item_variables.length).fill(1)

                var counterLabel = 0;
                materials_labels[counterLabel] = ["Chocolate Egg", "Stone"];
                materials_item[counterLabel] = ["chocolate_egg", "stone"];
                materials_amount[counterLabel] = [1,1];
                counterLabel++;

                materials_labels[counterLabel] = ["Chocolate Egg", "Copper"];
                materials_item[counterLabel] = ["chocolate_egg", "copper"];
                materials_amount[counterLabel] = [1,1];
                counterLabel++;

                materials_labels[counterLabel] = ["Chocolate Egg", "Iron"];
                materials_item[counterLabel] = ["chocolate_egg", "iron"];
                materials_amount[counterLabel] = [1,1];
                counterLabel++;

                materials_labels[counterLabel] = ["Chocolate Egg", "Silver"];
                materials_item[counterLabel] = ["chocolate_egg", "silver"];
                materials_amount[counterLabel] = [1,1];
                counterLabel++;

                materials_labels[counterLabel] = ["Chocolate Egg", "Gold"];
                materials_item[counterLabel] = ["chocolate_egg", "gold"];
                materials_amount[counterLabel] = [1,1];
                counterLabel++;

                materials_labels[counterLabel] = ["Chocolate Egg", "Bronze Bar"];
                materials_item[counterLabel] = ["chocolate_egg", "bronze_bar"];
                materials_amount[counterLabel] = [1,1];
                counterLabel++;

                materials_labels[counterLabel] = ["Chocolate Egg", "Iron Bar"];
                materials_item[counterLabel] = ["chocolate_egg", "iron_bar"];
                materials_amount[counterLabel] = [1,1];
                counterLabel++;

                materials_labels[counterLabel] = ["Chocolate Egg", "Silver Bar"];
                materials_item[counterLabel] = ["chocolate_egg", "silver_bar"];
                materials_amount[counterLabel] = [1,1];
                counterLabel++;

                materials_labels[counterLabel] = ["Chocolate Egg", "Gold Bar"];
                materials_item[counterLabel] = ["chocolate_egg", "gold_bar"];
                materials_amount[counterLabel] = [1,1];
                counterLabel++;

                materials_labels[counterLabel] = ["Chocolate Egg", "Dotted Green Leaf"];
                materials_item[counterLabel] = ["chocolate_egg", "dotted_green_leaf"];
                materials_amount[counterLabel] = [1,1];
                counterLabel++;

                materials_labels[counterLabel] = ["Chocolate Egg", "Green Leaf"];
                materials_item[counterLabel] = ["chocolate_egg", "green_leaf"];
                materials_amount[counterLabel] = [1,1];
                counterLabel++;

                materials_labels[counterLabel] = ["Chocolate Egg", "Lime Leaf"];
                materials_item[counterLabel] = ["chocolate_egg", "lime_leaf"];
                materials_amount[counterLabel] = [1,1];
                counterLabel++;

                materials_labels[counterLabel] = ["Chocolate Egg", "Gold Leaf"];
                materials_item[counterLabel] = ["chocolate_egg", "gold_leaf"];
                materials_amount[counterLabel] = [1,1];
                counterLabel++;

                materials_labels[counterLabel] = ["Chocolate Egg", "Logs"];
                materials_item[counterLabel] = ["chocolate_egg", "logs"];
                materials_amount[counterLabel] = [1,1];
                counterLabel++;

                materials_labels[counterLabel] = ["Chocolate Egg", "Oak Logs"];
                materials_item[counterLabel] = ["chocolate_egg", "oak_logs"];
                materials_amount[counterLabel] = [1,1];
                counterLabel++;

                materials_labels[counterLabel] = ["Chocolate Egg", "Willow Logs"];
                materials_item[counterLabel] = ["chocolate_egg", "willow_logs"];
                materials_amount[counterLabel] = [1,1];
                counterLabel++;

                materials_labels[counterLabel] = ["Chocolate Egg", "Maple Logs"];
                materials_item[counterLabel] = ["chocolate_egg", "maple_logs"];
                materials_amount[counterLabel] = [1,1];
                counterLabel++;


                materials_labels[counterLabel] = ["Chocolate Egg", "Chocolate Bar"];
                materials_item[counterLabel] = ["chocolate_egg", "chocolate"];
                materials_amount[counterLabel] = [1,1];
                counterLabel++;

                materials_labels[counterLabel] = ["Chocolate Egg", "Apple"];
                materials_item[counterLabel] = ["chocolate_egg", "apple"];
                materials_amount[counterLabel] = [1,1];
                counterLabel++;

                materials_labels[counterLabel] = ["Chocolate Egg", "Banana"];
                materials_item[counterLabel] = ["chocolate_egg", "banana"];
                materials_amount[counterLabel] = [1,1];
                counterLabel++;

                materials_labels[counterLabel] = ["Chocolate Egg", "Maggots"];
                materials_item[counterLabel] = ["chocolate_egg", "maggots"];
                materials_amount[counterLabel] = [1,1];
                counterLabel++;

                materials_labels[counterLabel] = ["Chocolate Egg", "Stinger"];
                materials_item[counterLabel] = ["chocolate_egg", "stinger"];
                materials_amount[counterLabel] = [1,1];
                counterLabel++;

                materials_labels[counterLabel] = ["Chocolate Egg", "Iron Dagger"];
                materials_item[counterLabel] = ["chocolate_egg", "iron_dagger"];
                materials_amount[counterLabel] = [1,1];
                counterLabel++;

                description = Array(100).fill("A special, but weird chocolate egg.")
            break;
        }


        //DEFAULT
        var level_image = '<img src="https://cdn.idle-pixel.com/images/crafting.png" /> ';
        var confirmation_modal_text = 'CRAFT';
        document.getElementById('multi-craft-modal-title').innerHTML = 'CRAFT';
        

        //SPECIAL CASES
        if(item == "shiny_glass_ball")
        {
            level_image = '<img src="https://cdn.idle-pixel.com/images/magic.png" /> ';
            document.getElementById('multi-craft-modal-title').innerHTML = 'ENCHANT';
            confirmation_modal_text = 'ENCHANT';
        }
        if(item == "invisibility_spell")
        {
            level_image = '<img src="https://cdn.idle-pixel.com/images/magic.png" /> ';
            document.getElementById('multi-craft-modal-title').innerHTML = 'ENCHANT';
            confirmation_modal_text = 'ENCHANT';
        }

        var table_element = document.getElementById("modal-crafting-custom-table");

        var html = "";
        html += '<tr class="center border background-grey color-silver">';
        html += '<th class="p-2"></th><th class="p-2">Item</th><th class="p-2 left">Level</th><th class="p-2 left">Materials</th><th class="p-2">Description</th>';
        html += '</tr>';

        for(var i = 0; i < labels.length; i++)
        {
            //Modals.open_image_modal("Crafting", "images/" + crafting_row_item + ".png", "Craft item?", "Craft", "Cancel", "CRAFT=" + crafting_row_item)
            if(item_variables[i].startsWith("breeding_fence_")) {
                
                html += '<tr onclick="Modals.open_input_dialogue_with_value(\''+item_variables[i]+'\', \'Crafting\', \'How many do you want to craft?\', \'1\', \'CRAFT\');" class="center border hover-tr">';
            }
            else {
                html += '<tr onclick="Modals.open_image_modal(\'Crafting\', \''+images[i]+'\', \''+confirmation_modal_text+'\', \''+confirmation_modal_text+'\', \'Cancel\', \'CRAFT='+item_variables[i]+'~1\')" class="center border hover-tr">';
            }
            
            
            html += '<td class="p-2" width="10%">';
                html += "<img src='https://cdn.idle-pixel.com/"+images[i]+"' />";
            html += '</td>';
            html += '<td class="p-2" width="15%">';
                html += "<span>" + labels[i] + "</span>";
            html += '</td>';

                html += '<td class="p-2" width=20%">';
                    html += '<div>'+level_image+' ' + level[i] + "</div>";
                html += "</td>";

                html += '<td class="p-2" width="20%">';
                for(var j = 0; j < materials_item[i].length; j++)
                {
                    var missing_label = "";
                    if(Items.getItem(materials_item[i][j]) < materials_amount[i][j])
                        missing_label = "<img class='img-20' style='margin-top:-3px;' src='https://cdn.idle-pixel.com/images/x.png'>";
    
                    var extra_label = "";
                    switch(materials_item[i][j]) {
                        case "field_tablette_1":
                            extra_label = "<i class='color-grey small'>(Blood Chicken)</i>";
                        break;
                        case "field_tablette_2":
                            extra_label = "<i class='color-grey small'>(Blood Rat)</i>";
                        break;
                        case "field_tablette_3":
                            extra_label = "<i class='color-grey small'>(Blood Spider)</i>";
                        break;
                        case "field_tablette_4":
                            extra_label = "<i class='color-grey small'>(Blood Bee)</i>";
                        break;
                        case "field_tablette_5":
                            extra_label = "<i class='color-grey small'>(Blood Lizard)</i>";
                        break;

                        case "forest_tablette_1":
                            extra_label = "<i class='color-grey small'>(Blood Snake)</i>";
                        break;
                        case "forest_tablette_2":
                            extra_label = "<i class='color-grey small'>(Blood Ants)</i>";
                        break;
                        case "forest_tablette_3":
                            extra_label = "<i class='color-grey small'>(Blood Wolf)</i>";
                        break;
                        case "forest_tablette_4":
                            extra_label = "<i class='color-grey small'>(Blood Ent)</i>";
                        break;
                        case "forest_tablette_5":
                            extra_label = "<i class='color-grey small'>(Blood Thief)</i>";
                        break;

                        case "cave_tablette_1":
                            extra_label = "<i class='color-grey small'>(Blood Bear)</i>";
                        break;
                        case "cave_tablette_2":
                            extra_label = "<i class='color-grey small'>(Blood Goblin)</i>";
                        break;
                        case "cave_tablette_3":
                            extra_label = "<i class='color-grey small'>(Blood Bat)</i>";
                        break;
                        case "cave_tablette_4":
                            extra_label = "<i class='color-grey small'>(Blood Skeleton)</i>";
                        break;

                        case "volcano_tablette_1":
                            extra_label = "<i class='color-grey small'>(Blood Fire Snake)</i>";
                        break;
                        case "volcano_tablette_2":
                            extra_label = "<i class='color-grey small'>(Blood Fire Hawk)</i>";
                        break;
                        case "volcano_tablette_3":
                            extra_label = "<i class='color-grey small'>(Blood Fire Golem)</i>";
                        break;
                        case "volcano_tablette_4":
                            extra_label = "<i class='color-grey small'>(Blood Fire Witch)</i>";
                        break;

                        case "ancient_tablette_1":
                            extra_label = "<i class='color-grey small'>(Elite Achievments)</i>";
                        break;
                        case "ancient_tablette_2":
                            extra_label = "<i class='color-grey small'>(Elite Achievments)</i>";
                        break;
                        case "ancient_tablette_3":
                            extra_label = "<i class='color-grey small'>(Elite Achievments)</i>";
                        break;
                        case "ancient_tablette_4":
                            extra_label = "<i class='color-grey small'>(Elite Achievments)</i>";
                        break;
                        case "ancient_tablette_5":
                            extra_label = "<i class='color-grey small'>(Elite Achievments)</i>";
                        break;
                    }
                    
                    html += '<img class="w20" src="https://cdn.idle-pixel.com/images/'+materials_item[i][j]+'.png"> ';
                    html += materials_amount[i][j];
                    html += " " + missing_label;
                    html += " " + extra_label;
                    html += '<br />';
                    html += '<br />';
                }

                html += '<td class="p-2 font-small">';
                    html += description[i];
                html += "</td>";

                html += "</td>";

            html += "</tr>";
        }


        table_element.innerHTML = html;
        Modals.toggle("modal-crafting-custom");
    }

    static clicksTutorialTablettes() {
        if(Items.getItem("lab_tablette_1") > 0 && Items.getItem("lab_tablette_2") > 0 && Items.getItem("lab_tablette_3") > 0) {

        } else {
            Modals.open_image_modal('TABLET', 'images/x.png', 'You need 3 tablette pieces to finish this.', null, 'Close', null);
        }
    }

    static clicks_crafted_tablette(item_selected)
    {
        var data = Invention.get_bloodify_tablette_dict(item_selected)

        var html = ""
        for(var i = 0; i < data['items_1'].length; i++)
        {
            var item = data['items_1'][i];
            var amount = data['amounts_1'][i];

            var amount_label = "";
            if(Items.getItem(item) >= amount)
                amount_label = "<span class='color-lime'>"+amount+"</span>";
            else
                amount_label = "<span class='color-red'>"+amount+"</span>";

            html += "<img src='https://cdn.idle-pixel.com/images/"+item+".png' /> " + amount_label + "<br />";
        }

        var level_required = parseInt(data['level_1']);
        var blood_required = parseInt(data['blood_1']);

        if(level_required > get_level(Items.getItem("invention_xp"), false))
            document.getElementById("modal-invention-charge-tablette-invention-level-1").innerHTML = level_required + " <img style='margin-top:-7px;' class='w20' src='https://cdn.idle-pixel.com/images/x.png' />";
        else
            document.getElementById("modal-invention-charge-tablette-invention-level-1").innerHTML = level_required + " <img style='margin-top:-7px;' class='w20' src='https://cdn.idle-pixel.com/images/check.png' />";
       
        if(blood_required > Items.getItem("cleansed_blood"))
            document.getElementById("modal-invention-charge-tablette-invention-blood-1").innerHTML = blood_required + " <img style='margin-top:-7px;' class='w20' src='https://cdn.idle-pixel.com/images/x.png' />";
        else
            document.getElementById("modal-invention-charge-tablette-invention-blood-1").innerHTML = blood_required + " <img style='margin-top:-7px;' class='w20' src='https://cdn.idle-pixel.com/images/check.png' />";

        document.getElementById("modal-invention-charge-tablette-option-1").innerHTML = html;
        
        html = ""
        for(var i = 0; i < data['items_2'].length; i++)
        {
            var item = data['items_2'][i];
            var amount = data['amounts_2'][i];

            var amount_label = "";
            if(Items.getItem(item) >= amount)
                amount_label = "<span class='color-lime'>"+amount+"</span>";
            else
                amount_label = "<span class='color-red'>"+amount+"</span>";

            html += "<img src='https://cdn.idle-pixel.com/images/"+item+".png' /> " + amount_label + "<br />";
        }
        level_required = parseInt(data['level_2']);
        blood_required = parseInt(data['blood_2']);

        if(level_required > get_level(Items.getItem("invention_xp"), false))
            document.getElementById("modal-invention-charge-tablette-invention-level-2").innerHTML = level_required + " <img style='margin-top:-7px;' class='w20' src='https://cdn.idle-pixel.com/images/x.png' />";
        else
            document.getElementById("modal-invention-charge-tablette-invention-level-2").innerHTML = level_required + " <img style='margin-top:-7px;' class='w20' src='https://cdn.idle-pixel.com/images/check.png' />";
       
        if(blood_required > Items.getItem("cleansed_blood"))
            document.getElementById("modal-invention-charge-tablette-invention-blood-2").innerHTML = blood_required + " <img style='margin-top:-7px;' class='w20' src='https://cdn.idle-pixel.com/images/x.png' />";
        else
            document.getElementById("modal-invention-charge-tablette-invention-blood-2").innerHTML = blood_required + " <img style='margin-top:-7px;' class='w20' src='https://cdn.idle-pixel.com/images/check.png' />";


        document.getElementById("modal-invention-charge-tablette-option-2").innerHTML = html;
        
        document.getElementById("modal-invention-charge-tablette-option-button-1").onclick = function() {
            websocket.send('BLOODIFY=' + item_selected + '~' + 1);
        }
        document.getElementById("modal-invention-charge-tablette-option-button-2").onclick = function() {
            websocket.send('BLOODIFY=' + item_selected + '~' + 2);
        }
    
        Modals.toggle("modal-invention-charge-tablette");
    }

    static open_settings_progress_bars() {
        Modals.toggle("modal-menu-bar-settings");
    }

    static fight_evil_pirate()
    {
        Modals.open_image_modal("EVIL PIRATE", "images/" + "evil_pirate" + ".png", "Fight the evil pirate?",  "Fight!", "Maybe later", "FIGHT_EVIL_PIRATE");
    }

    static fight_item_boss(boss)
    {
        if(boss == "treasure_chest_mimic") {
            var energyReq = 10000;
            var energyImg = "<img src='https://cdn.idle-pixel.com/images/energy.png' class='w20' /> " + format_number(energyReq)
            if(Items.getItem("energy") >= energyReq) {
                energyImg = "<span class='color-green'>" + energyImg + "</span>";
            } else {
                energyImg = "<span class='color-red'>" + energyImg + "</span>";
            }
            var html = "Fight the mimic?<br /><br />" + energyImg;
            
            Modals.open_image_modal(get_item_name(boss).toUpperCase(), "images/" + boss + ".png", html,  "Fight!", "Leave", "FIGHT_ITEM_BOSS=" + boss);
            return;
        }
        if(boss == "green_treasure_chest_mimic") {
            var energyReq = 50000;
            var energyImg = "<img src='https://cdn.idle-pixel.com/images/energy.png' class='w20' /> " + format_number(energyReq)
            if(Items.getItem("energy") >= energyReq) {
                energyImg = "<span class='color-green'>" + energyImg + "</span>";
            } else {
                energyImg = "<span class='color-red'>" + energyImg + "</span>";
            }
            var html = "Fight the mimic?<br /><br />" + energyImg;
            
            Modals.open_image_modal(get_item_name(boss).toUpperCase(), "images/" + boss + ".png", html,  "Fight!", "Leave", "FIGHT_ITEM_BOSS=" + boss);
            return;
        }
        if(boss == "red_treasure_chest_mimic") {
            var energyReq = 100000;
            var energyImg = "<img src='https://cdn.idle-pixel.com/images/energy.png' class='w20' /> " + format_number(energyReq)
            if(Items.getItem("energy") >= energyReq) {
                energyImg = "<span class='color-green'>" + energyImg + "</span>";
            } else {
                energyImg = "<span class='color-red'>" + energyImg + "</span>";
            }
            var html = "Fight the mimic?<br /><br />" + energyImg;
            
            Modals.open_image_modal(get_item_name(boss).toUpperCase(), "images/" + boss + ".png", html,  "Fight!", "Leave", "FIGHT_ITEM_BOSS=" + boss);
            return;
        }
        if(boss == "mixed_treasure_chest_mimic") {
            var energyReq = 500000;
            var energyImg = "<img src='https://cdn.idle-pixel.com/images/energy.png' class='w20' /> " + format_number(energyReq)
            if(Items.getItem("energy") >= energyReq) {
                energyImg = "<span class='color-green'>" + energyImg + "</span>";
            } else {
                energyImg = "<span class='color-red'>" + energyImg + "</span>";
            }
            var html = "Fight the mimic?<br /><br />" + energyImg;
            
            Modals.open_image_modal(get_item_name(boss).toUpperCase(), "images/" + boss + ".png", html,  "Fight!", "Leave", "FIGHT_ITEM_BOSS=" + boss);
            return;
        }

        Modals.open_image_modal(get_item_name(boss).toUpperCase(), "images/" + boss + ".png", "...",  "Fight!", "Leave", "FIGHT_ITEM_BOSS=" + boss);
        
    }

    static cannot_view_loot()
    {
        Modals.open_image_modal("LOOT", "images/" + "x" + ".png", "You cannot view the loot of a monster for which you have not killed.",  "Close", null, "")
    }
    
    static refresh_penguin_tickets_data(raw) {

        if(raw == "none") {
            document.getElementById("panel-penguin-content").innerHTML = "No one has bought any tickets yet.";
            return;
        }
        var dataArray = raw.split("~");
        var html = "";
        for(var i = 0; i < dataArray.length; i+=0) {
            var username = dataArray[i];
            i++
            var ticket_number = dataArray[i];
            i++;
            
            html += "<div class='penguin-ticket-wrapper'>"+capitalizeFirstLetter(username)+"<div class='penguin-ticket'>#"+ticket_number+"</div></div>";
        }
        
        document.getElementById("panel-penguin-content").innerHTML = html;
    }

    static clicks_faradox_gaurdians_notes()
    {
        if(Items.getItem("guardian_one_kills") > 0) document.getElementById("guardian_one_kills-status").src = "https://cdn.idle-pixel.com/images/check.png";
        if(Items.getItem("guardian_two_kills") > 0) document.getElementById("guardian_two_kills-status").src = "https://cdn.idle-pixel.com/images/check.png";
        if(Items.getItem("guardian_three_kills") > 0) document.getElementById("guardian_three_kills-status").src = "https://cdn.idle-pixel.com/images/check.png";
        if(Items.getItem("guardian_four_kills") > 0) document.getElementById("guardian_four_kills-status").src = "https://cdn.idle-pixel.com/images/check.png";
        Modals.toggle("modal-faradox-gaurdians");
    }

    static refreshBTNRememberTakeFromStore() {
        var item = Items.getItem("last_take_from_storage_var");
        var amount = Items.getItem("last_take_from_storage_amount");

        document.getElementById("remember-storage-take-div").innerHTML = "<img src='https://cdn.idle-pixel.com/images/"+item+".png' class='w20' />" + " x " + format_number(amount) + " Withdraw Again";
    }
    

    static disable_clicksRememberTakeFromStore = false;
    static clicksRememberTakeFromStore() {

        if(Modals.disable_clicksRememberTakeFromStore) {
            alert('Please wait one second between withdraws.')
        } else {
            websocket.send('TEAM_TAKE_ITEM='+Items.getItem('last_take_from_storage_var')+'~' + Items.getItem('last_take_from_storage_amount'))
            Modals.disable_clicksRememberTakeFromStore = true;
            setTimeout(function() {Modals.disable_clicksRememberTakeFromStore = false}, 500)
        }
        
    }

    static clicksAddItemTeamStorage() {
        if(document.getElementById("add-item-teams-label").innerHTML == "Add Item") {
            document.getElementById("add-item-teams-label").innerHTML = "Loading...";
            websocket.send("TEAMS_TRADABLE_MODAL");
        }
    }

    static market_select_tradable_item(is_selling)
    {
        var html = "";
        var current_category = "";
        var onclick_data = "Market.browse_get_table(\"all\");";
        html += "<div class='select-item-tradables-catagory shadow'>ALL<hr />";
        html += "<div onclick='"+onclick_data+";Modals.toggle(\"modal-market-select-item\");' class='market-tradable-item p-1 m-1 hover shadow' style='background-color:black'>";
        html += "<img src='https://cdn.idle-pixel.com/images/infinite_icon_white.png' width='50px' height='50px' />";
        html += "</div>";
        html += "</div>";

        for(var i = 0; i < Market.tradables.length;i ++)
        {
            var entry = Market.tradables[i];
            var item = entry.item;
            var lower_limit = parseInt(entry.lower_limit);
            var upper_limit = parseInt(entry.upper_limit);

            var category = entry.category;

            if(current_category != category)
            {
                if(current_category != "")
                    html += "</div>"

                html += "<div class='select-item-tradables-catagory shadow'>"+ category+ "<hr />"
                current_category = category;
            }
            onclick_data = "Market.browse_get_table(\""+item+"\");";
            if(is_selling)
                onclick_data = "Modals.market_configure_item_to_sell(\""+item+"\",\""+lower_limit+"\",\""+upper_limit+"\")";
                
            html += "<div onclick='"+onclick_data+";Modals.toggle(\"modal-market-select-item\");' class='market-tradable-item p-1 m-1 hover shadow' style='background-color:"+Market.get_category_background_color(category)+"'>";
                html += "<img src='https://cdn.idle-pixel.com/images/"+item+".png' width='50px' height='50px' />";
            html += "</div>";
        }

        document.getElementById("modal-market-select-item-section").innerHTML = html;
        Modals.toggle("modal-market-select-item");
    }

    
    static open_tcg_give_card(modal_id, card) {
        if(modal_id != null)
            Modals.toggle(modal_id)

        document.getElementById("modal-open-tcg-give-card-hidden").value = card;
        Modals.toggle('modal-open-tcg-give-card')
    }

    static clicks_start_raid_btn(raid) {
        if(raid == 2) {
            Modals.toggle("modal-select-raid-level-toybox");
        } else if(raid == 3) {
            Modals.toggle("modal-select-raid-level-easter2024");
        }
        else {
            Modals.toggle("modal-select-raid-level");
        }
        
    }

    static read_learn_raids_potion_recipe(item) {
        Modals.open_image_modal('Brewing Scroll', 'images/'+item+'.png', "Readn & learn how to make a new potion?", 'Read', 'Cancel', 'READ_BREWING_SCROLL=' + item);
    }
    static open_tcg_unknown() {
        Modals.toggle('modal-open-tcg-unknown')
    }

    static open_buy_tcg() {
        Modals.toggle('modal-buy-tcg')
    }

    static confirmGiftCard() {
        var usernameChosen = document.getElementById("modal-open-tcg-give-card-input").value;
        var cardChosen = document.getElementById("modal-open-tcg-give-card-hidden").value;
        websocket.send('GIVE_TCG_CARD=' + usernameChosen + "~" + cardChosen);
    }

    static clicksShopItem(item) {

        var custom_dialogue = false;
        var html = "Purchase this item?<br /><br />"
        var currency = "coins"
        var amount = 0;

        switch(item) {
            case "donor_shop":
                html += "<span class='color-grey'>Gain access to the donor shop which allows you to purchase unique perks for your account.<br /><br /><i class='color-red font-small'>Note that the game can be 100% completed without the use of the donor shop. It is stricly used to support server costs and help fund development time.</i></span><br /><br />"
                currency  = "coins";
                amount = 5000;
                custom_dialogue = true;
            break;
        }

        if(custom_dialogue) {
            html += "<img src='https://cdn.idle-pixel.com/images/"+currency+".png' class='w15' /> " + amount;
            if(Items.getItem(currency) >= amount) {
                html += " <img src='https://cdn.idle-pixel.com/images/check.png' class='w15' /> ";
            } else {
                html += " <img src='https://cdn.idle-pixel.com/images/x.png' class='w15' /> ";
            }
            Modals.open_image_modal('Purchace Item', 'images/'+item+'.png', html, 'Buy', 'Cancel', 'SHOP=' + item);

        } else {
            Modals.open_image_modal('Purchace Item', 'images/'+item+'.png', 'Purchase this item?', 'Buy', 'Cancel', 'SHOP=' + item)
        }
        
    }


    static clicksBreedingPen(pen) {
        if(Items.getItem('breeding_fence_5_crafted') > 0) {
            var at = Items.getItem(pen + '_upgraded_fence');
            var required = Breeding.getFenceRequiredForUpgrade(at);
            if(required > Items.getItem('breeding_fence')) {
                Modals.open_image_modal('Fencing Missing', 'images/x.png', 'You need ' + format_number(required) + ' fences to further upgrade the capacity.', null, 'Close', null)
            } else {
                Modals.open_image_modal('Upgrade Capacity', 'images/breeding_fence.png', 'You will use ' + format_number(required) + ' fences to upgrade the capacity.<br /><br />Are you sure you want to upgrade?', 'Upgrade!', 'Cancel', 'BREEDING_UPGRADE_CAPACITY=' + pen)
            }
        }
    }
    
    static showBloodLab() {
        document.getElementById("blood-lab-modal-img").src = "https://cdn.idle-pixel.com/images/blood_lab_picture.png";
        Modals.toggle('modal-bloodlab');
    }

    static unlock_invention() {
        Modals.open_image_modal("Elite Skill Available", "images/invention.png", "You now have the requirements to complete a quest to unlock the elite invention skill.", null, "Close");
    }

    static clicks_mirror()
    {
        if(rand(0, 10) == 0)
            set_image_src("mirror-look-img", "images/mirror_look_2.png");
        else
            set_image_src("mirror-look-img", "images/mirror_look.png");

        if(Items.getItem("mirror") == 1 && Items.getItem("fire_witch_sister_quest") == 3)
        {
            document.getElementById("modal-mirror-smash-pickaxe-btn").innerHTML = "<span style='font-size:16pt'><img class='w50' src='https://cdn.idle-pixel.com/images/"+Ores.getPickaxeToolData()[0]+".png' /> SMASH MIRROR WITH PICKAXE</span>";
            document.getElementById("modal-mirror-smash-hammer-btn").innerHTML = "<span style='font-size:16pt'><img class='w50' src='https://cdn.idle-pixel.com/images/"+Crafting.getHammerToolData()[0]+".png' /> SMASH MIRROR WITH HAMMER</span>";

            Modals.toggle("modal-mirror-smash-options");
        }
        else
            Modals.toggle("modal-mirror-look");
    }
    static market_configure_item_to_sell(item, lower_limit, upper_limit)
    {
        //clear fields
        document.getElementById("modal-market-configure-item-to-sell-amount").value = Items.getItem(item);
        document.getElementById("modal-market-configure-item-to-sell-price-each").value = "";

        document.getElementById("modal-market-configure-item-to-sell").value = item;
        document.getElementById("modal-market-configure-item-to-sell-label").innerHTML = Items.get_pretty_item_name(item);
        document.getElementById("modal-market-configure-item-to-sell-image").src = get_image("images/" + item + ".png");
        document.getElementById("modal-market-configure-item-to-sell-label-lower-limit").innerHTML = format_number(lower_limit);
        document.getElementById("modal-market-configure-item-to-sell-label-upper-limit").innerHTML = format_number(upper_limit);
        Modals.toggle("modal-market-configure-item-to-sell");
    }

    static market_purchase_item(market_id, item, amount, price_each)
    {
        document.getElementById("modal-market-purchase-item-market-id").value = market_id;
        document.getElementById("modal-market-purchase-item-label").innerHTML = Items.get_pretty_item_name(item);
        document.getElementById("modal-market-purchase-item-image").src = get_image("images/" + item + ".png");
        document.getElementById("modal-market-purchase-item-amount-left").value = "Amount left: " + format_number(amount);
        document.getElementById("modal-market-purchase-item-price-each").value = "Price each: " + Market.get_price_after_tax(price_each);

        if(item == "unbound_donor_coins")
            document.getElementById("market-buy-donor-coins-warning").style.display = "";
        else
            document.getElementById("market-buy-donor-coins-warning").style.display = "none";
            
        Modals.toggle("modal-market-purchase-item");
    }

    static clicks_gatherer()
    {
        if (Achievements.has_completed_set("gathering", "hard"))
        {
            Modals.toggle("modal-gatherer-menu");
        }
    }


    static clicks_brewing_xp_mixer()
    {
        if(Items.getItem("brewing_xp_mixer_enchanted") == 0)
        {
            Modals.open_image_modal("ENCHANT MIXER", "images/brewing_xp_mixer.png", "For this mixer to work, you must enchant it with magic.<br /><br /><img src='https://cdn.idle-pixel.com/images/magic.png' class='w15' /> Level 50",  "Enchant", "Close", "ENCHANT_POTION_MIXER");
        }
        else
        {
            document.getElementById('modal-brewing-xp-mixer-potion-available').style.display = "none";
            document.getElementById('modal-brewing-xp-mixer-potion-unavailable').style.display = "none";

            if(Items.getItem("brewing_xp_mixer_used") >= 5)
            document.getElementById('modal-brewing-xp-mixer-potion-unavailable').style.display = "";
            else
                document.getElementById('modal-brewing-xp-mixer-potion-available').style.display = "";

            if(Items.getItem("stardust_brewing_xp_mixer") > 0)
            {
                document.getElementById("modal-brewing-xp-mixer-stardust-section-button").style.display = '';
                document.getElementById("modal-brewing-xp-mixer-stardust-section-button").disabled = false;
                document.getElementById("modal-brewing-xp-mixer-stardust-section-button").value = "REROLL";

                if(Items.getItem('stardust_brewing_xp_mixer_timer') > 0)
                {
                    document.getElementById("modal-brewing-xp-mixer-stardust-section-button").disabled = true;
                    document.getElementById("modal-brewing-xp-mixer-stardust-section-button").value = format_time(Items.getItem('stardust_brewing_xp_mixer_timer'));
                }
            }
            Modals.toggle("modal-brewing-xp-mixer-potion");
        }
    }

    static clicks_bobs_book()
    {
        Modals.toggle("modal-bobs-book");
    }

    static bobs_book_next_image()
    {
        var current_image = document.getElementById("modal-bobs-book-img").src;
        var image_values =  current_image.split("/");
        var image_name = image_values[image_values.length -1];
        
        switch(image_name)
        {
            case "bobs_legacy_1.png":
                document.getElementById("modal-bobs-book-img").src = "https://cdn.idle-pixel.com/images/bobs_legacy_2.png";
            break;
            case "bobs_legacy_2.png":
                document.getElementById("modal-bobs-book-img").src = "https://cdn.idle-pixel.com/images/bobs_legacy_3.png";
            break;
            case "bobs_legacy_3.png":
                document.getElementById("modal-bobs-book-img").src = "https://cdn.idle-pixel.com/images/bobs_legacy_4.png";
            break;
            case "bobs_legacy_4.png":
                document.getElementById("modal-bobs-book-img").src = "https://cdn.idle-pixel.com/images/bobs_legacy_5.png";
            break;
            case "bobs_legacy_5.png":
                document.getElementById("modal-bobs-book-img").src = "https://cdn.idle-pixel.com/images/bobs_legacy_6.png";
            break;
            case "bobs_legacy_6.png":
                document.getElementById("modal-bobs-book-img").src = "https://cdn.idle-pixel.com/images/bobs_legacy_7.png";
            break;
            case "bobs_legacy_7.png":
                document.getElementById("modal-bobs-book-img").src = "https://cdn.idle-pixel.com/images/bobs_legacy_8.png";
            break;
            case "bobs_legacy_8.png":
                document.getElementById("modal-bobs-book-img").src = "https://cdn.idle-pixel.com/images/bobs_legacy_9.png";
            break;
            case "bobs_legacy_9.png":
                document.getElementById("modal-bobs-book-img").src = "https://cdn.idle-pixel.com/images/bobs_legacy_1.png";
            break;
        }
    }


    static aquarium()
    {
        if(Items.getItem('aquarium') == 0)
        {
            document.getElementById("modal-aquarium-menu-add-fish-button-label").innerHTML = "SWAP FISH";
        }

        if(Achievements.has_completed_set("cooking", "hard") || Items.getItem("super_bait") > 0)
        {
           document.getElementById("modal-aquarium-menu-super-bait").style.display = "";
        }

        if(Items.getItem("mega_bait") > 0)
        {
            document.getElementById("modal-aquarium-menu-mega-bait").style.display = "";
        }
        else
        {
            document.getElementById("modal-aquarium-menu-mega-bait").style.display = "none";
        }
        
        Modals.toggle("modal-aquarium-menu");
    }

    static open_donor_event_modal() {
        Modals.toggle("modal-configure-event");
    }

    static clicks_mineral(mineral)
    {
        document.getElementById("modal-mineral-options-ring-html").innerHTML = Ores.getRingsCompletedFromMineral(mineral);
        document.getElementById("modal-mineral-options-mineral-selected").value = mineral;
        Modals.toggle("modal-mineral-options");
    }
    
    static open_cooking_results_dialogue(cooked_food_name, cooked, cooked_xp, burnt, burnt_xp)
    {
        Modals.open_image_modal(
            "COOKING RESULTS",
            "images/"+Cooking.getOven()+".png",
            "<div class='center'><img src='https://cdn.idle-pixel.com/images/"+cooked_food_name+".png'> "+format_number(cooked)+" Cooked. <span class='color-grey'>("+cooked_xp+" xp)</span></div><div class='center'><img class='grayscale' src='https://cdn.idle-pixel.com/images/"+cooked_food_name+".png'> "+format_number(burnt)+" Burnt. <span class='color-grey'>("+burnt_xp+" xp)</span></div>",
            null,
            "Close",
            null,
        )
    }

    static show_instagram_popup()
    {
        Modals.toggle("modal-instagram");
    }


    static fisherman_scroll()
    {
        Modals.toggle("modal-quest-fishing-net");
    }


    static fishing_net()
    {
        Modals.toggle("modal-fishing-net-log");
    }

    static fishing_rod()
    {
        Modals.toggle("modal-fishing-rod-log");
    }

    static harpoon()
    {
        Modals.toggle("modal-fishing-harpoon-log");
    }

    static show_combat_select_area(area)
    {
        Combat.modal_area_last_selected = area; 
        Combat.modal_load_area_data(); 
        Modals.toggle('modal-fight-areas');
    }
    static clicks_upgrade_gem_tool(tool)
    {
        var tool_data;

        switch(tool){
            case "pickaxe":
                tool_data = Ores.getPickaxeToolData();
            break;
            case "hammer":
                tool_data = Crafting.getHammerToolData();
            break;
            case "axe":
                tool_data = Woodcutting.getAxeToolData();
            break;
            case "rake":
                tool_data = Farming.getRakeToolData();
            break;
            case "fishing_net":
            case "fishing_rod":
            case "harpoon":
                tool_data = Fishing.getFishingNetToolData(tool);
            break;
            case "needle":
                tool_data = Needle.getNeedleToolData();
            break;
            case "brewing_kit":
                tool_data = Brewing.getBrewingKitToolData();
            break;
            case "chisel":
                tool_data = Ores.getChiselToolData();
            break;
            case "watering_can":
                tool_data = Farming.getWateringCanToolData();
            break;
            case "toolkit":
                tool_data = Invention.getToolkitToolData();
            break;
            case "magnet":
                tool_data = Invention.getMagnetToolData();
            break;
            case "machete":
                tool_data = Woodcutting.getMacheteToolData();
            break;
            case "trowel":
                tool_data = Farming.getTrowelToolData();
            break;
        }

        var current = tool_data[0];
        var gem = tool_data[1];

        if(current == "none")
        {
            Modals.open_image_modal("UPGRADE TOOL", "images/" + "x" + ".png", "You don't have this tool yet.",  "Close", null, "")
        }
        else
        {
            Modals.open_image_modal("UPGRADE TOOL", "images/" + gem + ".png", "Upgrade your tool?",  "Upgrade", "Cancel", "UPGRADE_TOOL=" + tool)
        }
    }

    static clicks_red_combat_orb()
    {
        if(Items.getItem("red_combat_orb_absorbed_timer") > 0)
        {
            Modals.open_image_modal("RED COMBAT ORB", "images/" + "x" + ".png", "This orb is currently on cooldown.",  "Close", null, "")
        }
        else
        {
            Modals.open_image_modal("RED COMBAT ORB", "images/" + "red_combat_orb" + ".png", "Activate red shiny combat orb?.",  "Activate", "Cancel", "USE_RED_COMBAT_ORB")
        }
    }

    static clicks_toolkit()
    {
        var invention_level = get_level(Items.getItem("invention_xp"));
        var testing_for;

        document.getElementById("modal-toolkit-success-rate-" + testing_for)

        testing_for = "stinger"
        document.getElementById("modal-toolkit-success-rate-label-" + testing_for).innerHTML = "SUCCESS DISASSEMBLE RATE:"
        document.getElementById("modal-toolkit-success-rate-" + testing_for).innerHTML = Invention.dissambleChance(testing_for) * 100 + "%";

        testing_for = "iron_dagger"
        document.getElementById("modal-toolkit-success-rate-label-" + testing_for).innerHTML = "SUCCESS DISASSEMBLE RATE:"
        document.getElementById("modal-toolkit-success-rate-" + testing_for).innerHTML = "";
        
        if(invention_level < 20)
            document.getElementById("modal-toolkit-success-rate-label-" + testing_for).innerHTML = "<span class='color-red'>REQUIRES LEVEL 20</span>"
        else
            document.getElementById("modal-toolkit-success-rate-" + testing_for).innerHTML = Invention.dissambleChance(testing_for) * 100 + "%";

        testing_for = "skeleton_sword"
        document.getElementById("modal-toolkit-success-rate-label-" + testing_for).innerHTML = "SUCCESS DISASSEMBLE RATE:"
        document.getElementById("modal-toolkit-success-rate-" + testing_for).innerHTML = "";
        
        if(invention_level < 30)
            document.getElementById("modal-toolkit-success-rate-label-" + testing_for).innerHTML = "<span class='color-red'>REQUIRES LEVEL 30</span>"
        else
            document.getElementById("modal-toolkit-success-rate-" + testing_for).innerHTML = Invention.dissambleChance(testing_for) * 100 + "%";

        testing_for = "bone_amulet"
        document.getElementById("modal-toolkit-success-rate-label-" + testing_for).innerHTML = "SUCCESS DISASSEMBLE RATE:"
        document.getElementById("modal-toolkit-success-rate-" + testing_for).innerHTML = "";
        
        if(invention_level < 40)
            document.getElementById("modal-toolkit-success-rate-label-" + testing_for).innerHTML = "<span class='color-red'>REQUIRES LEVEL 40</span>"
        else
            document.getElementById("modal-toolkit-success-rate-" + testing_for).innerHTML = Invention.dissambleChance(testing_for) * 100 + "%";

        
        testing_for = "club"
        document.getElementById("modal-toolkit-success-rate-label-" + testing_for).innerHTML = "SUCCESS DISASSEMBLE RATE:"
        document.getElementById("modal-toolkit-success-rate-" + testing_for).innerHTML = "";
        
        if(invention_level < 70)
            document.getElementById("modal-toolkit-success-rate-label-" + testing_for).innerHTML = "<span class='color-red'>REQUIRES LEVEL 70</span>"
        else
            document.getElementById("modal-toolkit-success-rate-" + testing_for).innerHTML = Invention.dissambleChance(testing_for) * 100 + "%";

        testing_for = "spiked_club"
        document.getElementById("modal-toolkit-success-rate-label-" + testing_for).innerHTML = "SUCCESS DISASSEMBLE RATE:"
        document.getElementById("modal-toolkit-success-rate-" + testing_for).innerHTML = "";
        
        if(invention_level < 70)
            document.getElementById("modal-toolkit-success-rate-label-" + testing_for).innerHTML = "<span class='color-red'>REQUIRES LEVEL 70</span>"
        else
            document.getElementById("modal-toolkit-success-rate-" + testing_for).innerHTML = Invention.dissambleChance(testing_for) * 100 + "%";

        testing_for = "scythe"
        document.getElementById("modal-toolkit-success-rate-label-" + testing_for).innerHTML = "SUCCESS DISASSEMBLE RATE:"
        document.getElementById("modal-toolkit-success-rate-" + testing_for).innerHTML = "";
        
        if(invention_level < 70)
            document.getElementById("modal-toolkit-success-rate-label-" + testing_for).innerHTML = "<span class='color-red'>REQUIRES LEVEL 70</span>"
        else
            document.getElementById("modal-toolkit-success-rate-" + testing_for).innerHTML = Invention.dissambleChance(testing_for) * 100 + "%";

            
            
        testing_for = "trident"
        document.getElementById("modal-toolkit-success-rate-label-" + testing_for).innerHTML = "SUCCESS DISASSEMBLE RATE:"
        document.getElementById("modal-toolkit-success-rate-" + testing_for).innerHTML = "";
        
        if(invention_level < 85)
            document.getElementById("modal-toolkit-success-rate-label-" + testing_for).innerHTML = "<span class='color-red'>REQUIRES LEVEL 85</span>"
        else
            document.getElementById("modal-toolkit-success-rate-" + testing_for).innerHTML = Invention.dissambleChance(testing_for) * 100 + "%";
    
        testing_for = "undead_staff"
        document.getElementById("modal-toolkit-success-rate-label-" + testing_for).innerHTML = "SUCCESS DISASSEMBLE RATE:"
        document.getElementById("modal-toolkit-success-rate-" + testing_for).innerHTML = "";
        
        if(invention_level < 90)
            document.getElementById("modal-toolkit-success-rate-label-" + testing_for).innerHTML = "<span class='color-red'>REQUIRES LEVEL 90</span>"
        else
            document.getElementById("modal-toolkit-success-rate-" + testing_for).innerHTML = Invention.dissambleChance(testing_for) * 100 + "%";

            
        Modals.toggle('modal-toolkit')
    }

    static convert_invention_equipment(item)
    {
        Modals.open_input_dialogue_with_value(item, "Disassemble", "Disassemble equipment: " + item, Items.getItem(item), "INVENTION_DISASSEMBLE");
    }

    static open_chisel_dialogue()
    {
        var current_chsiel = Ores.getChiselToolData()[0];

        Modals.toggle("modal-chisel");
    }
    static use_fruit_tree_fertilizer()
    {
        Modals.open_image_modal("FRUIT TREE FERTILIZER", "images/" + "fruit_tree_fertilizer" + ".png", "Use this to permanently fertilize your woodcutting patches to grow <b>fruit trees</b> for extra energy.",  "Fertilize Patches", "Cancel", "USE_FRUIT_TREE_FERTILIZER");
    }

    static open_oil_factory_dialogue()
    {
        if(Items.getItem('red_oil_factory_orb_absorbed') >= 1)
        {
            document.getElementById("oil-factory-workers-max").innerHTML = "30";
        }
        Modals.toggle("modal-oil-factory");
    }

    static open_wiki_database(item) {
        window.open("http://database.idle-pixel.com/"+item+"/", "_blank");
    }

    static build_carpenters_house()
    {
        if(Items.getItem("house_0") == 1)
            Modals.open_image_modal("BUILD", "images/" + "pine_logs" + ".png", "Build house base with 50 x pine logs?",  "BUILD", "Cancel", "THE_CARPENTER_BUILD");
        else if(Items.getItem("house_1") == 1)
            Modals.open_image_modal("BUILD", "images/" + "gold_bar" + ".png", "Build house base with 200 x gold bars?",  "BUILD", "Cancel", "THE_CARPENTER_BUILD");
        else if(Items.getItem("house_2") == 1)
            Modals.open_image_modal("BUILD", "images/" + "molten_glass" + ".png", "Build house base with 5 x molten glass?",  "BUILD", "Cancel", "THE_CARPENTER_BUILD");
        else if(Items.getItem("house_3") == 1)
            Modals.open_image_modal("BUILD", "images/" + "promethium_bar" + ".png", "Build house base with 5 x promethium bars?",  "BUILD", "Cancel", "THE_CARPENTER_BUILD");
        else if(Items.getItem("house_4") == 1)
            Modals.open_image_modal("BUILD", "images/" + "stone" + ".png", "Build house base with 100,000 x stone?",  "BUILD", "Cancel", "THE_CARPENTER_BUILD");
        else if(Items.getItem("house_5") == 1)
            Modals.open_image_modal("BUILD", "images/" + "strange_leaf" + ".png", "Build house base with 5 x strange leaves?",  "BUILD", "Cancel", "THE_CARPENTER_BUILD");
        else if(Items.getItem("house_6") == 1)
            Modals.open_image_modal("BUILD", "images/" + "lava" + ".png", "Build house base with 5 x lava?",  "BUILD", "Cancel", "THE_CARPENTER_BUILD");
        else if(Items.getItem("house_7") == 1)
            Modals.open_image_modal("BUILD", "images/" + "check" + ".png", "I think the house is ready!  I should speak with the carpenter.",  "Close", null, "");
    }
    static open_combat_train_modal()
    {
        Modals.toggle("modal-fight-train");
    }

    static open_beach_action()
    {
        let d = new Date();
        let hour = d.getHours();
        if(Items.getItem("beach_map_bought") == 0) {
            Modals.open_image_modal('ARCADE', 'images/x.png', 'You need to have access to the beach.', null, 'Close', null)
        }
        else {
            if(hour >= 5 && hour <= 19) {
                Modals.open_image_modal('ARCADE', 'images/sun.png', 'The blood moon only rises after 8:00 PM local time.   Come back later.', null, 'Close', null)
                return;
            }
            else {
                Modals.toggle("modal-beach-action-1");
            }
            
        }
        
    }

    static open_beach_spell_action()
    {
        if(Items.getItem('invisibility_spellscroll_learnt') == 1)
        {
            document.getElementById("beach-invisibility-spell").disabled = false;
        } else {
            document.getElementById("beach-invisibility-spell").disabled = true;
        }
        Modals.toggle("modal-beach-action-2");
    }


    static open_combat_beach_modal()
    {
        Modals.toggle("modal-fight-beach");
    }

    static clicks_rare_monster_potion()
    {
        Modals.toggle("modal-rare-monster-potion");
    }
    static clicks_super_rare_monster_potion()
    {
        Modals.toggle("modal-super-rare-monster-potion");
    }
    
    static open_mute_dialogue(username_target)
    {
        document.getElementById('modal-mutes-username').value = username_target;
        Modals.toggle("modal-mutes");
    }
    
    static apply_mute()
    {
        var username_target = document.getElementById('modal-mutes-username').value;
        var hours = document.getElementById('modal-mutes-hours').value;
        var reason = document.getElementById('modal-mutes-reason').value;
        var is_ip = 0;
        if(document.getElementById('modal-mutes-ip-checkbox').checked) 
            is_ip = 1;

        websocket.send("MUTE=" + username_target + "~" + hours + "~" + reason + "~" + is_ip);
    }

    static open_treasure_map_modal()
    {
        var treasure_map_id = Items.getItem("treasure_map");
        Modals.show_map_hint(treasure_map_id);
    }

    static open_green_treasure_map_modal()
    {
        var treasure_map_id = Items.getItem("green_treasure_map");
        Modals.show_green_map_hint(treasure_map_id);
    }


    static clicks_bird_bath()
    {
        Modals.open_image_modal("WARNING","images/warning.png", "This item requires water to use.  <b>Kill any monster in the beach to permanently add water in this item.</b>");
    }

    
    static open_red_treasure_map_modal()
    {
        var treasure_map_id = Items.getItem("red_treasure_map");
        Modals.show_red_map_hint(treasure_map_id);
    }

    static clicks_random_treasure_chest() {
        Modals.open_image_modal("Unknown Chest", "images/" + "random_treasure_chest" + ".png", "Identify chest?",  "Identify", "Cancel", "RANDOM_TREASURE_CHEST");
    }

    static clicks_treasure_chest()
    {
        Modals.toggle("modal-treasure-chest-options");
    }

    static clicks_green_treasure_chest()
    {
        Modals.toggle("modal-green-treasure-chest-options");
    }

    static clicks_red_treasure_chest()
    {
        Modals.toggle("modal-red-treasure-chest-options");
    }

    static clicks_mixed_treasure_chest()
    {
        Modals.mixed_treasure_chest_select_key()
    }

    static show_map_hint(id)
    {
        switch(id)
        {
            case 1:
                Modals.open_image_modal("TREAUSRE MAP", "images/" + "treasure_map" + ".png", "<b>tsevrah a:</b> dees fael emil",  "Close", null, "");
            break;
            case 2:
                Modals.open_image_modal("TREAUSRE MAP", "images/" + "treasure_map" + ".png", "Sell me: VII silver.",  "Close", null, "");
            break;
            case 3:
                Modals.open_image_modal("TREAUSRE MAP", "images/" + "treasure_map" + ".png", "<b>Au</b> to the shop!",  "Close", null, "");
            break;
            case 4:
                Modals.open_image_modal("TREAUSRE MAP", "images/" + "treasure_map" + ".png", "A fruit a day keeps the doctor away.",  "Close", null, "");
            break;
            case 5:
                Modals.open_image_modal("TREAUSRE MAP", "images/" + "treasure_map" + ".png", "One sip one star, another sip another star.",  "Close", null, "");
            break;
            case 6:
                Modals.open_image_modal("TREAUSRE MAP", "images/" + "treasure_map" + ".png", "Metal into xp.",  "Close", null, "");
            break;
            case 7:
                Modals.open_image_modal("TREAUSRE MAP", "images/" + "treasure_map" + ".png", "A shop, with green coins.",  "Close", null, "");
            break;
            case 8:
                Modals.open_image_modal("TREAUSRE MAP", "images/" + "treasure_map" + ".png", "<b><u>WILL</u></b> you sell an item? <b><u>OW</u></b>!  That hurt!",  "Close", null, "");
            break;
            case 9:
                Modals.open_image_modal("TREAUSRE MAP", "images/" + "treasure_map" + ".png", "drill drill crusher.",  "Close", null, "");
            break;
            case 10:
                Modals.open_image_modal("TREAUSRE MAP", "images/" + "treasure_map" + ".png", "I really wish my crops grew faster.",  "Close", null, "");
            break;
            case 11:
                Modals.open_image_modal("TREAUSRE MAP", "images/" + "treasure_map" + ".png", "Select a fighting area in a hot place.",  "Close", null, "");
            break;
        }
    }

    static show_green_map_hint(id)
    {
        switch(id)
        {
            case 1:
                Modals.open_image_modal("TREAUSRE MAP", "images/" + "green_treasure_map" + ".png", "A source of energy to smelt ores, but it's not oil, and it's not lava.  Produce me.",  "Close", null, "");
            break;
            case 2:
                Modals.open_image_modal("TREAUSRE MAP", "images/" + "green_treasure_map" + ".png", "Sell one ore to the npc shop:  A mix of magenta and yellow.",  "Close", null, "");
            break;
            case 3:
                Modals.open_image_modal("TREAUSRE MAP", "images/" + "green_treasure_map" + ".png", "Click me:  A skull stuck in a shiny glass orb.",  "Close", null, "");
            break;
            case 4:
                Modals.open_image_modal("TREAUSRE MAP", "images/" + "green_treasure_map" + ".png", "What am I wearing today?  Perhaps I'll check the closet.",  "Close", null, "");
            break;
            case 5:
                Modals.open_image_modal("TREAUSRE MAP", "images/" + "green_treasure_map" + ".png", "I wish I could go to space.  Perhaps crafting might help.",  "Close", null, "");
            break;
            case 6:
                Modals.open_image_modal("TREAUSRE MAP", "images/" + "green_treasure_map" + ".png", "Incinerate me.",  "Close", null, "");
            break;
            case 7:
                Modals.open_image_modal("TREAUSRE MAP", "images/" + "green_treasure_map" + ".png", "Browsing Stonks",  "Close", null, "");
            break;
            case 8:
                Modals.open_image_modal("TREAUSRE MAP", "images/" + "green_treasure_map" + ".png", "How do I get energy without food?",  "Close", null, "");
            break;
            case 9:
                Modals.open_image_modal("TREAUSRE MAP", "images/" + "green_treasure_map" + ".png", "A cooks dish, anyone of them.",  "Close", null, "");
            break;
            case 10:
                Modals.open_image_modal("TREAUSRE MAP", "images/" + "green_treasure_map" + ".png", "They say that consuming fishing bait is great for fish.",  "Close", null, "");
            break;
            case 11:
                Modals.open_image_modal("TREAUSRE MAP", "images/" + "green_treasure_map" + ".png", "Spooky spooky skeleton, in a dark place.",  "Close", null, "");
            break;
        }
    }

    static show_red_map_hint(id)
    {
        switch(id)
        {
            case 1:
                Modals.open_image_modal("TREAUSRE MAP", "images/" + "red_treasure_map" + ".png", "<img src='https://cdn.idle-pixel.com/images/egg.png' /><img src='https://cdn.idle-pixel.com/images/egg.png' /><img src='https://cdn.idle-pixel.com/images/egg.png' /><img src='https://cdn.idle-pixel.com/images/egg.png' /><img src='https://cdn.idle-pixel.com/images/egg.png' /><br /><img src='https://cdn.idle-pixel.com/images/flour.png' /><br /><img src='https://cdn.idle-pixel.com/images/chocolate.png' />",  "Close", null, "");
            break;
            case 2:
                Modals.open_image_modal("TREAUSRE MAP", "images/" + "red_treasure_map" + ".png", "Sell to npc shop: <b>Au</b> before <b>Fe</b>",  "Close", null, "");
            break;
            case 3:
                Modals.open_image_modal("TREAUSRE MAP", "images/" + "red_treasure_map" + ".png", "01101001 01110010 01101111 01101110 00100000 01100010 01110101 01100011 01101011 01100101 01110100",  "Close", null, "");
            break;
            case 4:
                Modals.open_image_modal("TREAUSRE MAP", "images/" + "red_treasure_map" + ".png", "Gain some XP based on:<br /><br /><b>See you</b> later<br /><b>C you</b> later<br /><b>C u</b> later<br /><b>Cu</b> later.",  "Close", null, "");
            break;
            case 5:
                Modals.open_image_modal("TREAUSRE MAP", "images/" + "red_treasure_map" + ".png", "I observe the universe but cannot see.  All I rely on is the wave lengths that shall be!",  "Close", null, "");
            break;
            case 6:
                Modals.open_image_modal("TREAUSRE MAP", "images/" + "red_treasure_map" + ".png", "Crack this clue and you will see, a great shiny item for mining XP.",  "Close", null, "");
            break;
            case 7:
                Modals.open_image_modal("TREAUSRE MAP", "images/" + "red_treasure_map" + ".png", "Obtain some stardust.  I don't need the charcoal anyways.",  "Close", null, "");
            break;
            case 8:
                Modals.open_image_modal("TREAUSRE MAP", "images/" + "red_treasure_map" + ".png", "Have you ever mined in the desert?  No?  I'm sure you've been there a few times.",  "Close", null, "");
            break;
            case 9:
                Modals.open_image_modal("TREAUSRE MAP", "images/" + "red_treasure_map" + ".png", "<img src='https://cdn.idle-pixel.com/images/invention.png' /> It's pointy, it stings, and it's common.",  "Close", null, "");
            break;
            case 10:
                Modals.open_image_modal("TREAUSRE MAP", "images/" + "red_treasure_map" + ".png", "Let's eat!  Not for energy but for something else! <img src='https://cdn.idle-pixel.com/images/stardust.png' /",  "Close", null, "");
            break;
            case 11:
                Modals.open_image_modal("TREAUSRE MAP", "images/" + "red_treasure_map" + ".png", "RIP the combat instructor.  I should pay him a visit sometime",  "Close", null, "");
            break;
        }
    }

    static treasure_chest_select_key()
    {

        document.getElementById("open-treasure-chest-gold-key-button").style.display = "none";
        document.getElementById("open-treasure-chest-gold-sapphire-key-button").style.display = "none";
        document.getElementById("open-treasure-chest-gold-emerald-key-button").style.display = "none";
        document.getElementById("open-treasure-chest-gold-ruby-key-button").style.display = "none";
        document.getElementById("open-treasure-chest-gold-diamond-key-button").style.display = "none";

        document.getElementById("open-treasure-chest-ancient-key-button").style.display = "none";
        document.getElementById("open-treasure-chest-ancient-sapphire-key-button").style.display = "none";
        document.getElementById("open-treasure-chest-ancient-emerald-key-button").style.display = "none";
        document.getElementById("open-treasure-chest-ancient-ruby-key-button").style.display = "none";
        document.getElementById("open-treasure-chest-ancient-diamond-key-button").style.display = "none";

        var has_key = false;

        if(Items.getItem("gold_key") > 0)
        {
            document.getElementById("open-treasure-chest-gold-key-button").style.display = "";
            has_key = true;
        }
        if(Items.getItem("gold_sapphire_key") > 0)
        {
            document.getElementById("open-treasure-chest-gold-sapphire-key-button").style.display = "";
            has_key = true;
        }
        if(Items.getItem("gold_emerald_key") > 0)
        {
            document.getElementById("open-treasure-chest-gold-emerald-key-button").style.display = "";
            has_key = true;
        }
        if(Items.getItem("gold_ruby_key") > 0)
        {
            document.getElementById("open-treasure-chest-gold-ruby-key-button").style.display = "";
            has_key = true;
        }
        if(Items.getItem("gold_diamond_key") > 0)
        {
            document.getElementById("open-treasure-chest-gold-diamond-key-button").style.display = "";
            has_key = true;
        }
        

        if(Items.getItem("ancient_key") > 0)
        {
            document.getElementById("open-treasure-chest-ancient-key-button").style.display = "";
            has_key = true;
        }
        if(Items.getItem("ancient_sapphire_key") > 0)
        {
            document.getElementById("open-treasure-chest-ancient-sapphire-key-button").style.display = "";
            has_key = true;
        }
        if(Items.getItem("ancient_emerald_key") > 0)
        {
            document.getElementById("open-treasure-chest-ancient-emerald-key-button").style.display = "";
            has_key = true;
        }
        if(Items.getItem("ancient_ruby_key") > 0)
        {
            document.getElementById("open-treasure-chest-ancient-ruby-key-button").style.display = "";
            has_key = true;
        }
        if(Items.getItem("ancient_diamond_key") > 0)
        {
            document.getElementById("open-treasure-chest-ancient-diamond-key-button").style.display = "";
            has_key = true;
        }


        if(has_key)
            Modals.toggle('modal-treasure-chest-select-key');
        else
            Modals.open_image_modal("NO KEY", "images/" + "x" + ".png", "You must craft a treasure chest key first!",  "Close", null, "");
    }

    static green_treasure_chest_select_key()
    {

        document.getElementById("open-treasure-chest-promethium-key-button").style.display = "none";
        document.getElementById("open-treasure-chest-promethium-sapphire-key-button").style.display = "none";
        document.getElementById("open-treasure-chest-promethium-emerald-key-button").style.display = "none";
        document.getElementById("open-treasure-chest-promethium-ruby-key-button").style.display = "none";
        document.getElementById("open-treasure-chest-promethium-diamond-key-button").style.display = "none";

        document.getElementById("open-green-treasure-chest-ancient-key-button").style.display = "none";
        document.getElementById("open-green-treasure-chest-ancient-sapphire-key-button").style.display = "none";
        document.getElementById("open-green-treasure-chest-ancient-emerald-key-button").style.display = "none";
        document.getElementById("open-green-treasure-chest-ancient-ruby-key-button").style.display = "none";
        document.getElementById("open-green-treasure-chest-ancient-diamond-key-button").style.display = "none";

        var has_key = false;

        if(Items.getItem("promethium_key") > 0)
        {
            document.getElementById("open-treasure-chest-promethium-key-button").style.display = "";
            has_key = true;
        }
        if(Items.getItem("promethium_sapphire_key") > 0)
        {
            document.getElementById("open-treasure-chest-promethium-sapphire-key-button").style.display = "";
            has_key = true;
        }
        if(Items.getItem("promethium_emerald_key") > 0)
        {
            document.getElementById("open-treasure-chest-promethium-emerald-key-button").style.display = "";
            has_key = true;
        }
        if(Items.getItem("promethium_ruby_key") > 0)
        {
            document.getElementById("open-treasure-chest-promethium-ruby-key-button").style.display = "";
            has_key = true;
        }
        if(Items.getItem("promethium_diamond_key") > 0)
        {
            document.getElementById("open-treasure-chest-promethium-diamond-key-button").style.display = "";
            has_key = true;
        }

        if(Items.getItem("ancient_key") > 0)
        {
            document.getElementById("open-green-treasure-chest-ancient-key-button").style.display = "";
            has_key = true;
        }
        if(Items.getItem("ancient_sapphire_key") > 0)
        {
            document.getElementById("open-green-treasure-chest-ancient-sapphire-key-button").style.display = "";
            has_key = true;
        }
        if(Items.getItem("ancient_emerald_key") > 0)
        {
            document.getElementById("open-green-treasure-chest-ancient-emerald-key-button").style.display = "";
            has_key = true;
        }
        if(Items.getItem("ancient_ruby_key") > 0)
        {
            document.getElementById("open-green-treasure-chest-ancient-ruby-key-button").style.display = "";
            has_key = true;
        }
        if(Items.getItem("ancient_diamond_key") > 0)
        {
            document.getElementById("open-green-treasure-chest-ancient-diamond-key-button").style.display = "";
            has_key = true;
        }
        
        if(has_key)
            Modals.toggle('modal-green-treasure-chest-select-key');
        else
            Modals.open_image_modal("NO KEY", "images/" + "x" + ".png", "You must craft a promethium treasure chest key first!",  "Close", null, "");
    }

    static red_treasure_chest_select_key()
    {

        document.getElementById("open-treasure-chest-titanium-key-button").style.display = "none";
        document.getElementById("open-treasure-chest-titanium-sapphire-key-button").style.display = "none";
        document.getElementById("open-treasure-chest-titanium-emerald-key-button").style.display = "none";
        document.getElementById("open-treasure-chest-titanium-ruby-key-button").style.display = "none";
        document.getElementById("open-treasure-chest-titanium-diamond-key-button").style.display = "none";

        document.getElementById("open-red-treasure-chest-ancient-key-button").style.display = "none";
        document.getElementById("open-red-treasure-chest-ancient-sapphire-key-button").style.display = "none";
        document.getElementById("open-red-treasure-chest-ancient-emerald-key-button").style.display = "none";
        document.getElementById("open-red-treasure-chest-ancient-ruby-key-button").style.display = "none";
        document.getElementById("open-red-treasure-chest-ancient-diamond-key-button").style.display = "none";

        var has_key = false;

        if(Items.getItem("titanium_key") > 0)
        {
            document.getElementById("open-treasure-chest-titanium-key-button").style.display = "";
            has_key = true;
        }
        if(Items.getItem("titanium_sapphire_key") > 0)
        {
            document.getElementById("open-treasure-chest-titanium-sapphire-key-button").style.display = "";
            has_key = true;
        }
        if(Items.getItem("titanium_emerald_key") > 0)
        {
            document.getElementById("open-treasure-chest-titanium-emerald-key-button").style.display = "";
            has_key = true;
        }
        if(Items.getItem("titanium_ruby_key") > 0)
        {
            document.getElementById("open-treasure-chest-titanium-ruby-key-button").style.display = "";
            has_key = true;
        }
        if(Items.getItem("titanium_diamond_key") > 0)
        {
            document.getElementById("open-treasure-chest-titanium-diamond-key-button").style.display = "";
            has_key = true;
        }

        if(Items.getItem("ancient_key") > 0)
        {
            document.getElementById("open-red-treasure-chest-ancient-key-button").style.display = "";
            has_key = true;
        }
        if(Items.getItem("ancient_sapphire_key") > 0)
        {
            document.getElementById("open-red-treasure-chest-ancient-sapphire-key-button").style.display = "";
            has_key = true;
        }
        if(Items.getItem("ancient_emerald_key") > 0)
        {
            document.getElementById("open-red-treasure-chest-ancient-emerald-key-button").style.display = "";
            has_key = true;
        }
        if(Items.getItem("ancient_ruby_key") > 0)
        {
            document.getElementById("open-red-treasure-chest-ancient-ruby-key-button").style.display = "";
            has_key = true;
        }
        if(Items.getItem("ancient_diamond_key") > 0)
        {
            document.getElementById("open-red-treasure-chest-ancient-diamond-key-button").style.display = "";
            has_key = true;
        }

        if(has_key)
            Modals.toggle('modal-red-treasure-chest-select-key');
        else
            Modals.open_image_modal("NO KEY", "images/" + "x" + ".png", "You must craft a titanium treasure chest key first!",  "Close", null, "");
    }

    static mixed_treasure_chest_select_key()
    {

        document.getElementById("open-mixed-treasure-chest-ancient-key-button").style.display = "none";
        document.getElementById("open-mixed-treasure-chest-ancient-sapphire-key-button").style.display = "none";
        document.getElementById("open-mixed-treasure-chest-ancient-emerald-key-button").style.display = "none";
        document.getElementById("open-mixed-treasure-chest-ancient-ruby-key-button").style.display = "none";
        document.getElementById("open-mixed-treasure-chest-ancient-diamond-key-button").style.display = "none";

        var has_key = false;

        if(Items.getItem("ancient_key") > 0)
        {
            document.getElementById("open-mixed-treasure-chest-ancient-key-button").style.display = "";
            has_key = true;
        }
        if(Items.getItem("ancient_sapphire_key") > 0)
        {
            document.getElementById("open-mixed-treasure-chest-ancient-sapphire-key-button").style.display = "";
            has_key = true;
        }
        if(Items.getItem("ancient_emerald_key") > 0)
        {
            document.getElementById("open-mixed-treasure-chest-ancient-emerald-key-button").style.display = "";
            has_key = true;
        }
        if(Items.getItem("ancient_ruby_key") > 0)
        {
            document.getElementById("open-mixed-treasure-chest-ancient-ruby-key-button").style.display = "";
            has_key = true;
        }
        if(Items.getItem("ancient_diamond_key") > 0)
        {
            document.getElementById("open-mixed-treasure-chest-ancient-diamond-key-button").style.display = "";
            has_key = true;
        }


        if(has_key)
            Modals.toggle('modal-mixed-treasure-chest-select-key');
        else
            Modals.open_image_modal("NO KEY", "images/" + "x" + ".png", "You must craft an ancient treasure chest key first!",  "Close", null, "");
    }

    static clicks_blue_orb(orb)
    {
        Modals.open_image_modal("BLUE ORB", "images/" + orb + ".png", "Absorb this blue orb?",  "Absorb", "Cancel", "BLUE_ORB=" + orb);
    }

    static clicks_green_blue_orb(orb)
    {
        Modals.open_image_modal("GREEN ORB", "images/" + orb + ".png", "Absorb this green orb?",  "Absorb", "Cancel", "GREEN_ORB=" + orb);
    }

    static clicks_red_blue_orb(orb)
    {
        Modals.open_image_modal("RED ORB", "images/" + orb + ".png", "Absorb this red orb?",  "Absorb", "Cancel", "RED_ORB=" + orb);
    }

    static open_combat_presets()
    {
        Combat.refresh_presets_modal();
        Modals.toggle('modal-combat-presets');
    }

    static change_preset_looks(id)
    {
        document.getElementById("modal-combat-preset-looks-id").value = id;
        
        Modals.toggle('modal-combat-presets');
        Modals.toggle('modal-combat-presets-looks');
    }

    static change_combat_preset_look_icon(img_element)
    {
        var image_icon_section = document.getElementById("modal-combat-preset-looks-icon");
        var img_array = image_icon_section.getElementsByTagName("img");
        for(var i =0 ; i < img_array.length; i ++)
        {
            img_array[i].style.backgroundColor = "";
        }
        
        img_element.style.backgroundColor = "green";
    }
    
    static confirm_change_combat_preset_look_icon()
    {
        var id = document.getElementById("modal-combat-preset-looks-id").value;
        var color = document.getElementById("modal-combat-preset-looks-color").value;
        var icon = "";
        var image_icon_section = document.getElementById("modal-combat-preset-looks-icon");
        var img_array = image_icon_section.getElementsByTagName("img");
        for(var i =0 ; i < img_array.length; i ++)
        {
            if(img_array[i].style.backgroundColor == "green")
                icon = img_array[i].getAttribute("data-image-name");
        }
        
        websocket.send("COMBAT_PRESET_LOOKS=" + id + "~" + color + "~" + icon);
    }
    
}