class TooltipContent
{

  static build_tooltip_html_weapon_stats(accuracy, damage, magic, speed, defence, isBow) {
    var html = "<img src='https://cdn.idle-pixel.com/images/accuracy_white.png' /> "+accuracy+" Accuracy";
    html += "<br />";
    if(isBow) {
      html += "<img src='https://cdn.idle-pixel.com/images/melee_damage_white.png' /> <i class='color-grey'>Arrow Dependent</i>";
    } else {
      html += "<img src='https://cdn.idle-pixel.com/images/melee_damage_white.png' /> "+damage+" Attack";
    }
    html += "<br />";
    html += "<img src='https://cdn.idle-pixel.com/images/magic_damage_white.png' /> "+magic+" Magic";
    html += "<br />";
    html += "<img src='https://cdn.idle-pixel.com/images/speed_white.png' /> "+speed+" Speed";
    html += "<br />";
    html += "<img src='https://cdn.idle-pixel.com/images/defence_white.png' /> "+defence+" Defence";
    html += "<br />";
    return html;
  }

  static refresh_tooltip(element, id) {
    switch(id) {
      case "stone":
        document.getElementById("tooltip-stone_total").innerHTML = format_number(Items.getItem("stone_total"));
      break;
      case "copper":
        document.getElementById("tooltip-copper_total").innerHTML = format_number(Items.getItem("copper_total"));
      break;
      case "iron":
        document.getElementById("tooltip-iron_total").innerHTML = format_number(Items.getItem("iron_total"));
      break;
      case "silver":
        document.getElementById("tooltip-silver_total").innerHTML = format_number(Items.getItem("silver_total"));
      break;
      case "gold":
        document.getElementById("tooltip-gold_total").innerHTML = format_number(Items.getItem("gold_total"));
      break;
      case "promethium":
        document.getElementById("tooltip-promethium_total").innerHTML = format_number(Items.getItem("promethium_total"));
      break;
      case "titanium":
        document.getElementById("tooltip-titanium_total").innerHTML = format_number(Items.getItem("titanium_total"));
      break;
      case "ancient_ore":
        document.getElementById("tooltip-ancient_ore_total").innerHTML = format_number(Items.getItem("ancient_ore_total"));
      break;
      case "dragon_ore":
        document.getElementById("tooltip-dragon_ore_total").innerHTML = format_number(Items.getItem("dragon_ore_total"));
      break;

      case "sapphire":
      case "emerald":
      case "ruby":
      case "diamond":
      case "blood_diamond":
        document.getElementById("tooltip-"+id+"_total").innerHTML = format_number(Items.getItem(id + "_total"));
      break;

      case "bronze_bar":
      case "iron_bar":
      case "silver_bar":
      case "gold_bar":
      case "promethium_bar":
      case "titanium_bar":
      case "ancient_bar":
      case "dragon_bar":
        document.getElementById("tooltip-"+id+"_total").innerHTML = format_number(Items.getItem(id + "_total"));
      break;

      case "logs":
        document.getElementById("tooltip-tree_chopped").innerHTML = format_number(Items.getItem("tree_chopped"));
        document.getElementById("tooltip-" + id + "-heat").innerHTML = Cooking.getHeatPerLog(id);
      break;
      case "oak_logs":
        document.getElementById("tooltip-oak_tree_chopped").innerHTML = format_number(Items.getItem("oak_tree_chopped"));
        document.getElementById("tooltip-" + id + "-heat").innerHTML = Cooking.getHeatPerLog(id);
      break;
      case "willow_logs":
        document.getElementById("tooltip-willow_tree_chopped").innerHTML = format_number(Items.getItem("willow_tree_chopped"));
        document.getElementById("tooltip-" + id + "-heat").innerHTML = Cooking.getHeatPerLog(id);
      break;
      case "maple_logs":
        document.getElementById("tooltip-maple_tree_chopped").innerHTML = format_number(Items.getItem("maple_tree_chopped"));
        document.getElementById("tooltip-" + id + "-heat").innerHTML = Cooking.getHeatPerLog(id);
      break;
      case "stardust_logs":
        document.getElementById("tooltip-stardust_tree_chopped").innerHTML = format_number(Items.getItem("stardust_tree_chopped"));
        document.getElementById("tooltip-" + id + "-heat").innerHTML = Cooking.getHeatPerLog(id);
      break;
      case "pine_logs":
        document.getElementById("tooltip-pine_tree_chopped").innerHTML = format_number(Items.getItem("pine_tree_chopped"));
        document.getElementById("tooltip-" + id + "-heat").innerHTML = Cooking.getHeatPerLog(id);
      break;
      case "redwood_logs":
        document.getElementById("tooltip-redwood_tree_chopped").innerHTML = format_number(Items.getItem("redwood_tree_chopped"));
        document.getElementById("tooltip-" + id + "-heat").innerHTML = Cooking.getHeatPerLog(id);
      break;
      case "dense_logs":
        document.getElementById("tooltip-" + id + "-heat").innerHTML = Cooking.getHeatPerLog(id);
      break;

      case "drill":
      case "crusher":
      case "giant_drill":
      case "excavator":
      case "giant_excavator":
      case "massive_excavator":
        document.getElementById("tooltip-"+id+"_on").innerHTML = Items.getItem(id + "_on")
      break;

      case "red_mushroom_seeds":
      case "stardust_seeds":
        document.getElementById("tooltip-"+id+"_total").innerHTML = format_number(Items.getItem(id + "_total"));
        if(get_level(Items.getItem('farming_xp')) >= 1) 
          set_image_src("tooltip-plant-level-img-" + id, "images/check.png");
        else 
          set_image_src("tooltip-plant-level-img-" + id, "images/x.png");

        if(get_level(Items.getItem('farming_xp')) >= 1) 
          set_image_src("tooltip-plant-level-img-"+id+"_death", "images/check.png");
        else 
          set_image_src("tooltip-plant-level-img-"+id+"_death", "images/x.png");

        document.getElementById("tooltip-"+id+"_rarity").innerHTML = "1/" + Farming.get_seed_rarity(21600);
      break;

      case "dotted_green_leaf_seeds":
        document.getElementById("tooltip-"+id+"_total").innerHTML = format_number(Items.getItem(id + "_total"));
        if(get_level(Items.getItem('farming_xp')) >= 1) 
          set_image_src("tooltip-plant-level-img-" + id, "images/check.png");
        else 
          set_image_src("tooltip-plant-level-img-" + id, "images/x.png");

        if(get_level(Items.getItem('farming_xp')) >= 15) 
          set_image_src("tooltip-plant-level-img-"+id+"_death", "images/check.png");
        else 
          set_image_src("tooltip-plant-level-img-"+id+"_death", "images/x.png");

        document.getElementById("tooltip-"+id+"_rarity").innerHTML = "1/" + Farming.get_seed_rarity(21600);
      break;

      case "green_leaf_seeds":
        document.getElementById("tooltip-"+id+"_total").innerHTML = format_number(Items.getItem(id + "_total"));
        if(get_level(Items.getItem('farming_xp')) >= 10) 
          set_image_src("tooltip-plant-level-img-" + id, "images/check.png");
        else 
          set_image_src("tooltip-plant-level-img-" + id, "images/x.png");

        if(get_level(Items.getItem('farming_xp')) >= 25) 
          set_image_src("tooltip-plant-level-img-"+id+"_death", "images/check.png");
        else 
          set_image_src("tooltip-plant-level-img-"+id+"_death", "images/x.png");
  
        document.getElementById("tooltip-"+id+"_rarity").innerHTML = "1/" + Farming.get_seed_rarity(43200);
      break;

      case "lime_leaf_seeds":
        document.getElementById("tooltip-"+id+"_total").innerHTML = format_number(Items.getItem(id + "_total"));
        if(get_level(Items.getItem('farming_xp')) >= 25) 
          set_image_src("tooltip-plant-level-img-" + id, "images/check.png");
        else 
          set_image_src("tooltip-plant-level-img-" + id, "images/x.png");

        if(get_level(Items.getItem('farming_xp')) >= 40) 
          set_image_src("tooltip-plant-level-img-"+id+"_death", "images/check.png");
        else 
          set_image_src("tooltip-plant-level-img-"+id+"_death", "images/x.png");

        if(Items.getItem('bonemeal') >= 25) 
          set_image_src("tooltip-plant-level-img-"+id+"_bonemeal", "images/check.png");
        else 
          set_image_src("tooltip-plant-level-img-"+id+"_bonemeal", "images/x.png");

        document.getElementById("tooltip-"+id+"_rarity").innerHTML = "1/" + Farming.get_seed_rarity(112320);
      break;

      case "gold_leaf_seeds":
        document.getElementById("tooltip-"+id+"_total").innerHTML = format_number(Items.getItem(id + "_total"));
        if(get_level(Items.getItem('farming_xp')) >= 50) 
          set_image_src("tooltip-plant-level-img-" + id, "images/check.png");
        else 
          set_image_src("tooltip-plant-level-img-" + id, "images/x.png");

        if(get_level(Items.getItem('farming_xp')) >= 60) 
          set_image_src("tooltip-plant-level-img-"+id+"_death", "images/check.png");
        else 
          set_image_src("tooltip-plant-level-img-"+id+"_death", "images/x.png");

        if(Items.getItem('bonemeal') >= 25) 
          set_image_src("tooltip-plant-level-img-"+id+"_bonemeal", "images/check.png");
        else 
          set_image_src("tooltip-plant-level-img-"+id+"_bonemeal", "images/x.png");

        document.getElementById("tooltip-"+id+"_rarity").innerHTML = "1/" + Farming.get_seed_rarity(432000);
      break;
      case "crystal_leaf_seeds":
        document.getElementById("tooltip-"+id+"_total").innerHTML = format_number(Items.getItem(id + "_total"));
        if(get_level(Items.getItem('farming_xp')) >= 70) 
          set_image_src("tooltip-plant-level-img-" + id, "images/check.png");
        else 
          set_image_src("tooltip-plant-level-img-" + id, "images/x.png");

        if(get_level(Items.getItem('farming_xp')) >= 80) 
          set_image_src("tooltip-plant-level-img-"+id+"_death", "images/check.png");
        else 
          set_image_src("tooltip-plant-level-img-"+id+"_death", "images/x.png");

        if(Items.getItem('bonemeal') >= 25) 
          set_image_src("tooltip-plant-level-img-"+id+"_bonemeal", "images/check.png");
        else 
          set_image_src("tooltip-plant-level-img-"+id+"_bonemeal", "images/x.png");

        document.getElementById("tooltip-"+id+"_rarity").innerHTML = "1/" + Farming.get_seed_rarity(3000000);
      break;

      case "tree_seeds":
        if(get_level(Items.getItem('farming_xp')) >= 10) 
          set_image_src("tooltip-plant-level-img-" + id, "images/check.png");
        else 
          set_image_src("tooltip-plant-level-img-" + id, "images/x.png");

        if(get_level(Items.getItem('farming_xp')) >= 25) 
          set_image_src("tooltip-plant-level-img-"+id+"_death", "images/check.png");
        else 
          set_image_src("tooltip-plant-level-img-"+id+"_death", "images/x.png");

        if(Items.getItem('bonemeal') >= 10) 
          set_image_src("tooltip-plant-level-img-"+id+"_bonemeal", "images/check.png");
        else 
          set_image_src("tooltip-plant-level-img-"+id+"_bonemeal", "images/x.png");

      break;

      case "oak_tree_seeds":
        if(get_level(Items.getItem('farming_xp')) >= 25) 
          set_image_src("tooltip-plant-level-img-" + id, "images/check.png");
        else 
          set_image_src("tooltip-plant-level-img-" + id, "images/x.png");

        if(get_level(Items.getItem('farming_xp')) >= 40) 
          set_image_src("tooltip-plant-level-img-"+id+"_death", "images/check.png");
        else 
          set_image_src("tooltip-plant-level-img-"+id+"_death", "images/x.png");

        if(Items.getItem('bonemeal') >= 25) 
          set_image_src("tooltip-plant-level-img-"+id+"_bonemeal", "images/check.png");
        else 
          set_image_src("tooltip-plant-level-img-"+id+"_bonemeal", "images/x.png");

      break;

      case "willow_tree_seeds":
        if(get_level(Items.getItem('farming_xp')) >= 37) 
          set_image_src("tooltip-plant-level-img-" + id, "images/check.png");
        else 
          set_image_src("tooltip-plant-level-img-" + id, "images/x.png");

        if(get_level(Items.getItem('farming_xp')) >= 55) 
          set_image_src("tooltip-plant-level-img-"+id+"_death", "images/check.png");
        else 
          set_image_src("tooltip-plant-level-img-"+id+"_death", "images/x.png");

        if(Items.getItem('bonemeal') >= 50) 
          set_image_src("tooltip-plant-level-img-"+id+"_bonemeal", "images/check.png");
        else 
          set_image_src("tooltip-plant-level-img-"+id+"_bonemeal", "images/x.png");

      break;


      case "maple_tree_seeds":
        if(get_level(Items.getItem('farming_xp')) >= 50) 
          set_image_src("tooltip-plant-level-img-" + id, "images/check.png");
        else 
          set_image_src("tooltip-plant-level-img-" + id, "images/x.png");

        if(get_level(Items.getItem('farming_xp')) >= 65) 
          set_image_src("tooltip-plant-level-img-"+id+"_death", "images/check.png");
        else 
          set_image_src("tooltip-plant-level-img-"+id+"_death", "images/x.png");

        if(Items.getItem('bonemeal') >= 120) 
          set_image_src("tooltip-plant-level-img-"+id+"_bonemeal", "images/check.png");
        else 
          set_image_src("tooltip-plant-level-img-"+id+"_bonemeal", "images/x.png");

      break;

      case "stardust_tree_seeds":
        if(get_level(Items.getItem('farming_xp')) >= 65) 
          set_image_src("tooltip-plant-level-img-" + id, "images/check.png");
        else 
          set_image_src("tooltip-plant-level-img-" + id, "images/x.png");

        if(get_level(Items.getItem('farming_xp')) >= 80) 
          set_image_src("tooltip-plant-level-img-"+id+"_death", "images/check.png");
        else 
          set_image_src("tooltip-plant-level-img-"+id+"_death", "images/x.png");

        if(Items.getItem('bonemeal') >= 150) 
          set_image_src("tooltip-plant-level-img-"+id+"_bonemeal", "images/check.png");
        else 
          set_image_src("tooltip-plant-level-img-"+id+"_bonemeal", "images/x.png");

      break;

      case "pine_tree_seeds":
        if(get_level(Items.getItem('farming_xp')) >= 70) 
          set_image_src("tooltip-plant-level-img-" + id, "images/check.png");
        else 
          set_image_src("tooltip-plant-level-img-" + id, "images/x.png");

        if(get_level(Items.getItem('farming_xp')) >= 85) 
          set_image_src("tooltip-plant-level-img-"+id+"_death", "images/check.png");
        else 
          set_image_src("tooltip-plant-level-img-"+id+"_death", "images/x.png");

        if(Items.getItem('bonemeal') >= 180) 
          set_image_src("tooltip-plant-level-img-"+id+"_bonemeal", "images/check.png");
        else 
          set_image_src("tooltip-plant-level-img-"+id+"_bonemeal", "images/x.png");

      break;

      case "redwood_tree_seeds":
        if(get_level(Items.getItem('farming_xp')) >= 80) 
          set_image_src("tooltip-plant-level-img-" + id, "images/check.png");
        else 
          set_image_src("tooltip-plant-level-img-" + id, "images/x.png");

        if(get_level(Items.getItem('farming_xp')) >= 92) 
          set_image_src("tooltip-plant-level-img-"+id+"_death", "images/check.png");
        else 
          set_image_src("tooltip-plant-level-img-"+id+"_death", "images/x.png");

        if(Items.getItem('bonemeal') >= 300) 
          set_image_src("tooltip-plant-level-img-"+id+"_bonemeal", "images/check.png");
        else 
          set_image_src("tooltip-plant-level-img-"+id+"_bonemeal", "images/x.png");

      break;

      case "apple_tree_seeds":
        if(get_level(Items.getItem('farming_xp')) >= 40) 
          set_image_src("tooltip-plant-level-img-" + id, "images/check.png");
        else 
          set_image_src("tooltip-plant-level-img-" + id, "images/x.png");

        if(get_level(Items.getItem('farming_xp')) >= 55) 
          set_image_src("tooltip-plant-level-img-"+id+"_death", "images/check.png");
        else 
          set_image_src("tooltip-plant-level-img-"+id+"_death", "images/x.png");

        if(Items.getItem('bonemeal') >= 300) 
          set_image_src("tooltip-plant-level-img-"+id+"_bonemeal", "images/check.png");
        else 
          set_image_src("tooltip-plant-level-img-"+id+"_bonemeal", "images/x.png");
      break;

      case "banana_tree_seeds":
        if(get_level(Items.getItem('farming_xp')) >= 57) 
          set_image_src("tooltip-plant-level-img-" + id, "images/check.png");
        else 
          set_image_src("tooltip-plant-level-img-" + id, "images/x.png");

        if(get_level(Items.getItem('farming_xp')) >= 62) 
          set_image_src("tooltip-plant-level-img-"+id+"_death", "images/check.png");
        else 
          set_image_src("tooltip-plant-level-img-"+id+"_death", "images/x.png");

        if(Items.getItem('bonemeal') >= 300) 
          set_image_src("tooltip-plant-level-img-"+id+"_bonemeal", "images/check.png");
        else 
          set_image_src("tooltip-plant-level-img-"+id+"_bonemeal", "images/x.png");
      break;

      case "orange_tree_seeds":
        if(get_level(Items.getItem('farming_xp')) >= 66) 
          set_image_src("tooltip-plant-level-img-" + id, "images/check.png");
        else 
          set_image_src("tooltip-plant-level-img-" + id, "images/x.png");

        if(get_level(Items.getItem('farming_xp')) >= 70) 
          set_image_src("tooltip-plant-level-img-"+id+"_death", "images/check.png");
        else 
          set_image_src("tooltip-plant-level-img-"+id+"_death", "images/x.png");

        if(Items.getItem('bonemeal') >= 300) 
          set_image_src("tooltip-plant-level-img-"+id+"_bonemeal", "images/check.png");
        else 
          set_image_src("tooltip-plant-level-img-"+id+"_bonemeal", "images/x.png");
      break;

      case "palm_tree_seeds":
        if(get_level(Items.getItem('farming_xp')) >= 82) 
          set_image_src("tooltip-plant-level-img-" + id, "images/check.png");
        else 
          set_image_src("tooltip-plant-level-img-" + id, "images/x.png");

        if(get_level(Items.getItem('farming_xp')) >= 90) 
          set_image_src("tooltip-plant-level-img-"+id+"_death", "images/check.png");
        else 
          set_image_src("tooltip-plant-level-img-"+id+"_death", "images/x.png");

        if(Items.getItem('bonemeal') >= 300) 
          set_image_src("tooltip-plant-level-img-"+id+"_bonemeal", "images/check.png");
        else 
          set_image_src("tooltip-plant-level-img-"+id+"_bonemeal", "images/x.png");
      break;

      case "dragon_fruit_tree_seeds":
        if(get_level(Items.getItem('farming_xp')) >= 90) 
          set_image_src("tooltip-plant-level-img-" + id, "images/check.png");
        else 
          set_image_src("tooltip-plant-level-img-" + id, "images/x.png");

        if(get_level(Items.getItem('farming_xp')) >= 100) 
          set_image_src("tooltip-plant-level-img-"+id+"_death", "images/check.png");
        else 
          set_image_src("tooltip-plant-level-img-"+id+"_death", "images/x.png");

        if(Items.getItem('bonemeal') >= 300) 
          set_image_src("tooltip-plant-level-img-"+id+"_bonemeal", "images/check.png");
        else 
          set_image_src("tooltip-plant-level-img-"+id+"_bonemeal", "images/x.png");
      break;
    }

  }

  static content = {
    "menu-bar-coins": "<img src='https://cdn.idle-pixel.com/images/coins.png' /> <span class='color-primary'>Coins</span><br /><br />Can be used to purchase items from the game shop or to buy items from other players on the online market.",
    "menu-bar-donor-coins": "<img src='https://cdn.idle-pixel.com/images/donor_coins.png' /> <span class='color-primary'>Donor Coins</span><br /><br />Can be used to purchase perks from the donor shop.",
    "menu-bar-oil": "<img src='https://cdn.idle-pixel.com/images/oil.png' /> <span class='color-primary'>Oil</span><br /><br />Depletes when running machinery.<br /><br />Capacity can be increased using oil storage related items.",
    "shop-pickaxe": "<img src='https://cdn.idle-pixel.com/images/pickaxe.png' /><span class='color-primary mx-2'>Pickaxe</span><br /><br />You'll need this if you want to start mining some ore!",
    "shop-wooden_sword": "<img src='https://cdn.idle-pixel.com/images/wooden_sword.png' /><span class='color-primary mx-2'>Wooden Sword</span><br /><br />Buying this item unlocks the combat skill.<br /><br /><span class='color-lime'>Max hit: 1<br />Type: Slash</span>",
    "shop-wooden_bow": "<img src='https://cdn.idle-pixel.com/images/wooden_bow.png' /><span class='color-primary mx-2'>Wooden Bow</span><br /><br />Buying this item unlocks the combat skill.<br /><br /><span class='color-lime'>Max hit: 1<br />Type: Archery</span>",
    "shop-wooden_staff": "<img src='https://cdn.idle-pixel.com/images/wooden_staff.png' /><span class='color-primary mx-2'>Wooden Staff</span><br /><br />Buying this item unlocks the combat skill.<br /><br /><span class='color-lime'>Max hit: 1<br />Type: Magic</span>",
    "shop-arcade_ticket": "<img src='https://cdn.idle-pixel.com/images/arcade_ticket.png' /><span class='color-primary mx-2'>Arcade Ticket</span><br /><br />Buy and use this item to play a minigame and earn rewards!",
    "shop-criptoe_market": "<img src='https://cdn.idle-pixel.com/images/criptoe_market.png' /><span class='color-primary mx-2'>Criptoe Market</span><br /><br />Ability to invest into special currency: criptoe.  Seems like a scam.",
    
    "shop-hammer": "<img src='https://cdn.idle-pixel.com/images/hammer.png' /><span class='color-primary mx-2'>Hammer</span><br /><br />Can be upgraded to reduce the stardust required when converting bars into xp.",
    "shop-coconut": "<img src='https://cdn.idle-pixel.com/images/coconut.png' /><span class='color-primary mx-2'>3 Coconuts</span><br /><br />Can be consumed for <img src='https://cdn.idle-pixel.com/images/energy.png' /> 1000 energy each.",
    "shop-mirror":"<img src='https://cdn.idle-pixel.com/images/mirror.png' /><span class='color-primary mx-2'>Mirror</span><br /><br />I'll be able to see what I look like in the mornings before going on my adventure!",
    
    "shop-pancakes":"<img src='https://cdn.idle-pixel.com/images/pancakes.png' /><span class='color-primary mx-2'>Pancakes</span><br /><br />With real maple syrup from Montreal!",
    "shop-dragon_bones":"<img src='https://cdn.idle-pixel.com/images/dragon_bones.png' /><span class='color-primary mx-2'>Dragon bones</span><br /><br />Legend says that these bones are from a guardian controlled by Faradox.  It can be used for a ton of bonemeal.",
    "shop-crystal_ball":"<img src='https://cdn.idle-pixel.com/images/crystal_ball.png' /><span class='color-primary mx-2'>Angels Magic XP Ball</span><br /><br />Ability to contact the deceased angels which will lead you to more magic XP by completing certain tasks.",

    "shop-pancakes":"<img src='https://cdn.idle-pixel.com/images/pancakes.png' /><span class='color-primary mx-2'>Pancakes</span><br /><br />With real maple syrup from Montreal!",
    
    "shop-pirate":"<img src='https://cdn.idle-pixel.com/images/pirate.png' /><span class='color-primary mx-2'>Pirate</span><br /><br />Hire pirates to find treasure maps leading to powerful loot!",
    "shop-donor_coins": "<img src='https://cdn.idle-pixel.com/images/donor_coins.png' /><span class='color-primary mx-2'>DONOR COINS</span><br /><br />Donor coins are used to purchases unique perks for your account.<br /><br /><span class='color-lime'>Click to purchase at 1 USD per coin</span></span>",
    "shop-donor-farming": "<img src='https://cdn.idle-pixel.com/images/donor_coins.png' /><span class='color-primary mx-2'>DONOR COINS x 2</span><br /><br />Unlock 2 addition farming patches.<br /><br /><span class='color-lime'>(Lasts for 30 days)</span>",
    "shop-donor-woodcutting": "<img src='https://cdn.idle-pixel.com/images/donor_coins.png' /><span class='color-primary mx-2'>DONOR COINS x 2</span><br /><br />Unlock 2 addition woodcutting patches.<br /><br /><span class='color-lime'>(Lasts for 30 days)</span>",
    "shop-donor-potion-stacker": "<img src='https://cdn.idle-pixel.com/images/donor_coins.png' /><span class='color-primary mx-2'>DONOR COINS x 4</span><br /><br />Ability two stack two potions, doubling the timer.<br /><br /><span class='color-lime'>(Lasts for 30 days)</span>",
    "shop-donor-offline-time": "<img src='https://cdn.idle-pixel.com/images/donor_coins.png' /><span class='color-primary mx-2'>DONOR COINS x 4</span><br /><br />Gain 12h of offline time instead of 8h.<br /><br /><span class='color-lime'>(Lasts for 30 days)</span>",
    "shop-donor-bonus-xp": "<img src='https://cdn.idle-pixel.com/images/donor_coins.png' /><span class='color-primary mx-2'>DONOR COINS x 4</span><br /><br />Increases XP by 10% from all sources.<br /><br /><span class='color-lime'>(Lasts for 30 days)</span>",
    "shop-donor-event": "<img src='https://cdn.idle-pixel.com/images/donor_coins.png' /><span class='color-primary mx-2'>DONOR COINS x 50</span><br /><br />Trigger a global event for everyone on the server to join.  Note that these events can occur naturally.<br /><br /><span class='color-grey'>Click to configure (donor coins will not be used until confirmation)</span><br /><br /><span class='color-red'>One time purchase!</span>",
    "unbound_donor_coins": "<img src='https://cdn.idle-pixel.com/images/donor_coins.png' /><span class='color-primary mx-2'>DONOR COINS</span><br /><br />Click to bind the donor coins to your account in order to use them.<br /><br />Note that bound donor coins can not longer be sold on the player market.",
    
    "socket_scroll": "<span class='color-primary'>Socket Scroll</span><br /><br />Ability to upgrade your tools with gems.",
    "toolkit": "<span class='color-primary'>Toolkit</span><br /><br />Break down weapons or amulets into components.<br /><br /><span class='color-lime'>Click to use</span>",
    
    "incinerator": "<span class='color-primary'>Incinerator</span><br /><br />Can incinerate bones into ashes.<br /><br /><span class='color-lime'>Lava cost: 10<br />Ashes per second: 10% for bones to become ashes every second<br />Lasts for: 10 minutes.<br /><br /></span><span class='color-grey'>Cooldown: 24h</span>",
    
    "boat": "<span class='color-primary'>Boat</span><br /><br />Send your boat out to catch extra fish.",
    "pirate_ship": "<span class='color-primary'>Pirate Ship</span><br /><br />Send your pirate ship out to locate and kidnap evil pirates from the ocean.<br /><br />Kidnapping pirates requires energy as you must board other ships and use energy to force the pirate as a prisoner.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='w20' /> <span class='color-red'>Energy required based on # pirates.</span><br /><br /><span class='color-orange'>There is also a rare chance of finding cannon parts when the collecting from the pirate's ship.</span>",
    "robot_waves": "<span class='color-primary'>Robots</span><br /><br />Click to challenge the robots.",

    "evil_pirate": "<span class='color-primary'>Evil Pirate</span><br /><br />\"How dare you kidnap me!  Fight me so I can end you once and for all and return to the sea!\".<br /><br /><u class='color-orange'>Notable drops:</u><span class='color-orange'><br />Sextant (Unique)<br />Cannon base<br />Cannon barrel<br />Cannon wheels<br />Canonballs<br />Cannonball mould</span>",


    "criptoe_man": "<span class='color-primary'>Criptoe Guide</span><br /><br />You should take the time and talk to the guide to understand what you are getting into.  Mistakes could lead in large amounts of coins lost.",
    "buy_criptoe": "<span class='color-primary'>Buying Criptoe</span><br /><br />You can only purchase a criptoe package once a day<br /><br /><img src='https://cdn.idle-pixel.com/images/criptoe_coin.png' class='w15'> 10,000 maximum daily.",
    "criptoe": "<span class='color-primary'>Criptoe</span><br /><br />Can be invested in the cirptoe market or used to research new perks.",
    "criptoe_spend": "<span class='color-primary'>Spend Criptoe</span><br /><br />Use your hard earned criptoe to purchase items or services.",

    "researcher_points": "<span class='color-primary'>Researcher Points</span><br /><br />Reseacher points are increased as you actively invest criptoe into the market.",
    

    "criptoe_shop_researcher1": "<span class='color-primary'>Researcher (Intern)</span><br /><br />Ability to generate more research points when you are actively investing, which can be used to gain new perks.<br /><br /><span class='color-orange'>Multiplier: 1</span><br /><br /><i class='font-small color-grey'>Stacks with other researchers</i>",
    "criptoe_shop_researcher2": "<span class='color-primary'>Researcher (Junior)</span><br /><br />Ability to generate more research points when you are actively investing, which can be used to gain new perks.<br /><br /><span class='color-orange'>Multiplier: 2</span><br /><br /><i class='font-small color-grey'>Stacks with other researchers</i>",
    "criptoe_shop_researcher3": "<span class='color-primary'>Researcher (Intermediate)</span><br /><br />Ability to generate more research points when you are actively investing, which can be used to gain new perks.<br /><br /><span class='color-orange'>Multiplier: 3</span><br /><br /><i class='font-small color-grey'>Stacks with other researchers</i>",
    "criptoe_shop_researcher4": "<span class='color-primary'>Researcher (Expert)</span><br /><br />Ability to generate more research points when you are actively investing, which can be used to gain new perks.<br /><br /><span class='color-orange'>Multiplier: 4</span<br /><br /><i class='font-small color-grey'>Stacks with other researchers</i>>",
    "criptoe_shop_researcher5": "<span class='color-primary'>Researcher (Master)</span><br /><br />Ability to generate more research points when you are actively investing, which can be used to gain new perks.<br /><br /><span class='color-orange'>Multiplier: 8</span><br /><br /><i class='font-small color-grey'>Stacks with other researchers</i>",
    
    "criptoe_shop_banker1": "<span class='color-primary'>Banker (Intern)</span><br /><br />Helps you manage your investements.<br /><br /><span class='color-purple'><img src='https://cdn.idle-pixel.com/images/criptoe_coin.png'>Automatically gain an average of 10 criptoe per hour.</span><br /><br /><i class='font-small color-grey'>Stacks with other bankers</i>",
    "criptoe_shop_banker2": "<span class='color-primary'>Banker (Junior)</span><br /><br />Helps you manage your investements.<br /><br /><span class='color-purple'><img src='https://cdn.idle-pixel.com/images/criptoe_coin.png'>Automatically gain an average of 30 criptoe per hour.</span><br /><br /><i class='font-small color-grey'>Stacks with other bankers</i>",
    "criptoe_shop_banker3": "<span class='color-primary'>Banker (Intermediate)</span><br /><br />Helps you manage your investements.<br /><br /><span class='color-purple'><img src='https://cdn.idle-pixel.com/images/criptoe_coin.png'>Automatically gain an average of 80 criptoe per hour.</span><br /><br /><i class='font-small color-grey'>Stacks with other bankers</i>",
    "criptoe_shop_banker4": "<span class='color-primary'>Banker (Expert)</span><br /><br />Helps you manage your investements.<br /><br /><span class='color-purple'><img src='https://cdn.idle-pixel.com/images/criptoe_coin.png'>Automatically gain an average of 500 criptoe per hour.</span><br /><br /><i class='font-small color-grey'>Stacks with other bankers</i>",
    "criptoe_shop_banker5": "<span class='color-primary'>Banker (Master)</span><br /><br />Helps you manage your investements.<br /><br /><span class='color-purple'><img src='https://cdn.idle-pixel.com/images/criptoe_coin.png'>Automatically gain an average of 1200 criptoe per hour.</span><br /><br /><i class='font-small color-grey'>Stacks with other bankers</i>",


    "magnet_upgrade": "<span class='color-primary'>Magnet XP boost</span><br /><br />You will now gain 1 gathering xp per bag obtained from junk.",
    
    "magnet_shield": "<span class='color-primary'>Magnet (offhand)</span><br /><br />Collects special combat junk from any normal area when equipped.",
    "junk_collector_combat": "<span class='color-primary'>Combat Junk</span><br /><br />Obtained by equipping a magnet and finding junk from combat.  The junk collector wants some of this from each area.",
    
    "seed_compactor": "<span class='color-primary'>Seed Compactor</span><br /><br />Presses seeds together to make a mega seed.",
   
    "sapphire_fragments": "<div class='tooltip-title'> SAPPHIRE FRAGMENTS <br /> <span class='tooltip-rarity'><img style='padding-top:-4px' src='https://cdn.idle-pixel.com/images/rarity_icon_very_common.png' class='w15'> Very Common</span> </div> <span class='tooltip-description'>Gem fragments are usually found by gathering in the gem mine.  However for this quest you can use a drill to find them.</span> <br /> <br /> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/quests.png' class='w30' /> </div> <div class='tooltip-hint-content color-cyan'> Quest Item </div> </div>",
    "emerald_fragments": "<div class='tooltip-title'> EMERALD FRAGMENTS <br /> <span class='tooltip-rarity'><img style='padding-top:-4px' src='https://cdn.idle-pixel.com/images/rarity_icon_very_common.png' class='w15'> Very Common</span> </div> <span class='tooltip-description'>Gem fragments are usually found by gathering in the gem mine.  However for this quest you can use a drill to find them.</span> <br /> <br /> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/quests.png' class='w30' /> </div> <div class='tooltip-hint-content color-cyan'> Quest Item </div> </div>",
    "ruby_fragments": "<div class='tooltip-title'> RUBY FRAGMENTS <br /> <span class='tooltip-rarity'><img style='padding-top:-4px' src='https://cdn.idle-pixel.com/images/rarity_icon_very_common.png' class='w15'> Very Common</span> </div> <span class='tooltip-description'>Gem fragments are usually found by gathering in the gem mine.  However for this quest you can use a drill to find them.</span> <br /> <br /> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/quests.png' class='w30' /> </div> <div class='tooltip-hint-content color-cyan'> Quest Item </div> </div>",
    "diamond_fragments": "<div class='tooltip-title'> DIAMOND FRAGMENTS <br /> <span class='tooltip-rarity'><img style='padding-top:-4px' src='https://cdn.idle-pixel.com/images/rarity_icon_very_common.png' class='w15'> Very Common</span> </div> <span class='tooltip-description'>Gem fragments are usually found by gathering in the gem mine.  However for this quest you can use a drill to find them.</span> <br /> <br /> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/quests.png' class='w30' /> </div> <div class='tooltip-hint-content color-cyan'> Quest Item </div> </div>",
    
    "gathering_sapphire_fragments": "<span class='color-primary'>Sapphire Fragments</span><br /><br />Contains bits and pieces of a sapphire.<br /><br /><span class='color-lime'>Requires 10 to make a sapphire</span>",
    "gathering_emerald_fragments": "<span class='color-primary'>Emerald Fragments</span><br /><br />Contains bits and pieces of a emerald.<br /><br /><span class='color-lime'>Requires 10 to make an emerald</span>",
    "gathering_ruby_fragments": "<span class='color-primary'>Ruby Fragments</span><br /><br />Contains bits and pieces of a ruby.<br /><br /><span class='color-lime'>Requires 10 to make a ruby</span>",
    "gathering_diamond_fragments": "<span class='color-primary'>Diamond Fragments</span><br /><br />Contains bits and pieces of a diamond.<br /><br /><span class='color-lime'>Requires 10 to make a diamond</span>",
    
    "fruit_tree_fertilizer": "<img src='https://cdn.idle-pixel.com/images/fruit_tree_fertilizer.png' /><span class='color-primary mx-2'>Fruit Patch Fertilizer</span><br /><br />Seems like someone left this behind in the forest.<br /><br /><span class='color-lime'>Can be used to permanently fertilize your woodcutting patches for fruit trees to start growing!</span>",
    
    "combat-heal-spell": "<span class='color-primary'>2 mana cost</span><br />+25 xp<br /><br /><span class='color-grey'>Shortcut: Q</span>",
    "combat-fire-spell": "<span class='color-primary'>3 mana cost</span><br />+35 xp<br /><br /><span class='color-grey'>Shortcut: W</span>",
    "combat-reflect-spell": "<span class='color-primary'>1 mana cost</span><br />+70 xp<br /><br /><span class='color-grey'>Shortcut: E</span>",
    "combat-invis-spell": "<span class='color-primary'>2 mana cost</span><br />+100 xp<br /><br /><span class='color-grey'>Shortcut: R</span>",
    
    "in-combat-cannon": "<span class='color-grey'>Shortcut: C</span>",
  
    

    "sapphire_scroll": "<span class='color-primary'>Sapphire Scroll</span><br /><br />Read this to start learning how to mine <span class='color-blue'>sapphires</span>.",
    "emerald_scroll": "<span class='color-primary'>Emerald Scroll</span><br /><br />Read this to start learning how to mine <span class='color-lime'>emeralds</span>.",
    "ruby_scroll": "<span class='color-primary'>Ruby Scroll</span><br /><br />Read this to start learning how to mine <span class='color-red'>rubies</span>.",
    "diamond_scroll": "<span class='color-primary'>Diamond Scroll</span><br /><br />Read this to start learning how to mine <span class='color-cyan'>diamonds</span>.",
  
    "stone": "<div class='tooltip-title'> STONE <br /> <span class='tooltip-rarity'><img style='padding-top:-4px' src='https://cdn.idle-pixel.com/images/rarity_icon_very_common.png' class='w15'> Very Common</span> </div> <img src='https://cdn.idle-pixel.com/images/coins.png' class='w15'> Sells for 1 coin <br /> <br /> <span class='tooltip-description'>This common ore is the only ore which may not be used in a furnace.  It is rock solid, and used as a primary resource when crafting items.</span> <br /> <br /> <span class='color-orange'><b>Total mined:</b> <span id='tooltip-stone_total'>0</span></span> <br /> <br /> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/stardust.png' class='w30' /> </div> <div class='tooltip-hint-content'> Can be converted into <u>mining XP</u> with the help of stardust. </div> </div>",
    "copper": "<div class='tooltip-title'> COPPER <br /> <span class='tooltip-rarity'><img style='padding-top:-4px' src='https://cdn.idle-pixel.com/images/rarity_icon_common.png' class='w15'> Common</span> </div> <img src='https://cdn.idle-pixel.com/images/coins.png' class='w15'> Sells for 2 coins <br /> <br /> <span class='tooltip-description'>This common ore can be smelted into bronze bars  It's not a very strong metal but it certainly has its uses.</span> <br /> <br /> <span class='color-orange'><b>Total mined:</b> <span id='tooltip-copper_total'>0</span></span> <br /> <br /> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/bronze_bar.png' class='w30' /> </div> <div class='tooltip-hint-content'> Can be smelted into bronze bars with oil and a furnace. </div> </div> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/stardust.png' class='w30' /> </div> <div class='tooltip-hint-content'> Can be converted into <u>mining XP</u> with the help of stardust. </div> </div>",
    "iron": "<div class='tooltip-title'> IRON <br /> <span class='tooltip-rarity'><img style='padding-top:-4px' src='https://cdn.idle-pixel.com/images/rarity_icon_common.png' class='w15'> Common</span> </div> <img src='https://cdn.idle-pixel.com/images/coins.png' class='w15'> Sells for 3 coins <br /> <br /> <span class='tooltip-description'>This common ore can be smelted into iron bars.</span> <br /> <br /> <span class='color-orange'><b>Total mined:</b> <span id='tooltip-iron_total'>0</span></span> <br /> <br /> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/iron_bar.png' class='w30' /> </div> <div class='tooltip-hint-content'> Can be smelted into iron bars with oil and a furnace. </div> </div> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/stardust.png' class='w30' /> </div> <div class='tooltip-hint-content'> Can be converted into <u>mining XP</u> with the help of stardust. </div> </div>",
    "silver": "<div class='tooltip-title'> SILVER <br /> <span class='tooltip-rarity'><img style='padding-top:-4px' src='https://cdn.idle-pixel.com/images/rarity_icon_common.png' class='w15'> Common</span> </div> <img src='https://cdn.idle-pixel.com/images/coins.png' class='w15'> Sells for 5 coins <br /> <br /> <span class='tooltip-description'>This common ore can be smelted into silver bars.</span> <br /> <br /> <span class='color-orange'><b>Total mined:</b> <span id='tooltip-silver_total'>0</span></span> <br /> <br /> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/silver_bar.png' class='w30' /> </div> <div class='tooltip-hint-content'> Can be smelted into silver bars with a lot of oil and a furnace. </div> </div> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/stardust.png' class='w30' /> </div> <div class='tooltip-hint-content'> Can be converted into <u>mining XP</u> with the help of stardust. </div> </div>",
    "gold": "<div class='tooltip-title'> GOLD <br /> <span class='tooltip-rarity'><img style='padding-top:-4px' src='https://cdn.idle-pixel.com/images/rarity_icon_uncommon.png' class='w15'> Uncommon</span> </div> <img src='https://cdn.idle-pixel.com/images/coins.png' class='w15'> Sells for 10 coins <br /> <br /> <span class='tooltip-description'>This ore is uncommon and is a great conductor when smelted into gold bars.</span> <br /> <br /> <span class='color-orange'><b>Total mined:</b> <span id='tooltip-gold_total'>0</span></span> <br /> <br /> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/gold_bar.png' class='w30' /> </div> <div class='tooltip-hint-content'> Can be smelted into gold bars with a lot of oil and a furnace. </div> </div> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/stardust.png' class='w30' /> </div> <div class='tooltip-hint-content'> Can be converted into <u>mining XP</u> with the help of stardust. </div> </div>",
    "promethium": "<div class='tooltip-title'> PROMETHIUM <br /> <span class='tooltip-rarity'><img style='padding-top:-4px' src='https://cdn.idle-pixel.com/images/rarity_icon_rare.png' class='w15'> Rare</span> </div> <img src='https://cdn.idle-pixel.com/images/coins.png' class='w15'> Sells for 90 coins <br /> <br /> <span class='tooltip-description'>This rare ore is very durable.</span> <br /> <br /> <span class='color-orange'><b>Total mined:</b> <span id='tooltip-promethium_total'>0</span></span> <br /> <br /> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/promethium_bar.png' class='w30' /> </div> <div class='tooltip-hint-content'> Can be smelted into promethium bars with oil, charcoal and a furnace. </div> </div> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/stardust.png' class='w30' /> </div> <div class='tooltip-hint-content'> Can be converted into <u>mining XP</u> with the help of stardust. </div> </div>",
    "titanium": "<div class='tooltip-title'> TITANIUM <br /> <span class='tooltip-rarity'><img style='padding-top:-4px' src='https://cdn.idle-pixel.com/images/rarity_icon_rare.png' class='w15'> Rare</span> </div> <img src='https://cdn.idle-pixel.com/images/coins.png' class='w15'> Sells for 300 coins <br /> <br /> <span class='tooltip-description'>This rare ore is extremely durable.  It takes a lot of time to smelt, and requires a lot of charcoal and some lava.</span> <br /> <br /> <span class='color-orange'><b>Total mined:</b> <span id='tooltip-titanium_total'>0</span></span> <br /> <br /> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/titanium_bar.png' class='w30' /> </div> <div class='tooltip-hint-content'> Can be smelted into titanium bars with oil, charcoal, lava and a furnace. </div> </div> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/stardust.png' class='w30' /> </div> <div class='tooltip-hint-content'> Can be converted into <u>mining XP</u> with the help of stardust. </div> </div>",
    "ancient_ore": "<div class='tooltip-title'> ANCIENT ORE <br /> <span class='tooltip-rarity'><img style='padding-top:-4px' src='https://cdn.idle-pixel.com/images/rarity_icon_veryrare.png' class='w15'> Very Rare</span> </div> <img src='https://cdn.idle-pixel.com/images/coins.png' class='w15'> Sells for 1000 coins <br /> <br /> <span class='tooltip-description'>This very rare ore is wanted by many.  Only the best machinery can mine this type of ore.  It requieres a ton of charcoal, lava and even plasma to smelt.</span> <br /> <br /> <span class='color-orange'><b>Total mined:</b> <span id='tooltip-ancient_ore_total'>0</span></span> <br /> <br /> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/ancient_bar.png' class='w30' /> </div> <div class='tooltip-hint-content'> Can be smelted into ancient bars with oil, charcoal, lava, plasma and a furnace. </div> </div> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/stardust.png' class='w30' /> </div> <div class='tooltip-hint-content'> Can be converted into <u>mining XP</u> with the help of stardust. </div> </div>",

    "oil_silo_1": "<span class='color-primary'>Silver Oil Silo</span><br /><br />Increased oil capacity by 250.",
    "oil_silo_2": "<span class='color-primary'>Gold Oil Silo</span><br /><br />Increased oil capacity by 1000.",
    "oil_silo_3": "<span class='color-primary'>Promethium Oil Silo</span><br /><br />Increased oil capacity by 10,000.",
    "oil_silo_4": "<span class='color-primary'>Titanium Oil Silo</span><br /><br />Increased oil capacity by 25,000.",
    "oil_silo_5": "<span class='color-primary'>Ancient Oil Silo</span><br /><br />Increased oil capacity by 50,000.",

    "booster": "<span class='color-primary'>Rocket Booster</span><br /><br />Requires four to build a rocket.",
    "mega_boosters": "<span class='color-primary'>Mega Rocket Booster</span><br /><br />Can be used to upgrade your rocket.",
    "rocket": "<span class='color-primary'>Rocket</span><br /><br />Ability to send a rocket to the moon and collect moonstone and rarely a shooting star.<br /><br /><u>Requirements:</u><br />Rocket Fuel found in gathering desert mine.<br />Oxygen tank and mask dropped from a monter in the haunted mansion.<br /><br /><span class='color-primary'>Level 55 mining</span><br /><br /><span class='color-lime'>Click to use</span>",
    "mega_rocket": "<span class='color-primary'>Mega Rocket</span><br /><br />Ability to send a rocket to the moon or the sun and collect moonstone, plasma, meteors, and rarely a shooting star.<br /><br /><u>Requirements:</u><br />Rocket Fuel found in gathering desert mine.<br />Oxygen tank and mask dropped from a monter in the haunted mansion.<br /><br /><span class='color-primary'>Level 55 mining</span><br /><br /><span class='color-lime'>Click to use</span>",
    "rocket_fuel": "<span class='color-primary'>Rocket Fuel</span><br /><br />Requires one barrel to send your rocket to the moon.<br /><br />Requires three barrels to send your rocket to mars.",
    
    "fruit_skin": "<span class='color-primary'>Fruit Skin</span><br /><br />The left over skin from fruits.  This compostable item can be useful for attracting bait.<br /><br /><span class='color-lime'>Slowly attracts super bait which will be placed in your fishing section.</span><br /><br /><span class='color-orange'>Your fruit skin will deplete overtime, and has a small chance of getting super bait (1/50).</span>",
    "enchanted_shooting_star": "<span class='color-primary'>Enchanted Shooting Star</span><br /><br />A primary ingredient to brew special potions to reroll certain orbs from chests.",
    
    "pirates_gold": "<span class='color-primary'>Pirate's Gold</span><br /><br />A very valuable ore to pirates.",
    
    
    "shooting_star": "<span class='color-primary'>Shooting Star</span><br /><br />A shooting star found in space!  Wonder what I can use this for?<br /><br /><img src='https://cdn.idle-pixel.com/images/magic.png' class='w20' /> <i class='color-cyan'>Click to enchant</i>",
  
    "boating_dock": "<span class='color-primary'>Boating Dock</span><br /><br />Ability to send 2 boats at the same time.",
  
    "orb_potion": "<span class='color-primary'>Reroll Orb Potion</span><br /><br />Ability to reroll an unbound orb.<br /><br /><span class='color-lime'>Click to use</span>",
  

    "stinger_pieces": "<span class='color-primary'>Stinger Pieces</span><br /><br />Broken down pieces from a stringer.",
    "stinger_handle": "<span class='color-primary'>Stinger Handle</span><br /><br />A broken down handle of a stinger.",
    "stinger_edge": "<span class='color-primary'>Stinger Edge</span><br /><br />The edge side of a stinger.  It's quite sharp.",
  
    "dagger_pieces": "<span class='color-primary'>Dagger Pieces</span><br /><br />Broken down pieces of an iron dagger.",
    "dagger_handle": "<span class='color-primary'>Dagger Handle</span><br /><br />A broken down handle from an iron dagger.",
    "dagger_blade": "<span class='color-primary'>Dagger Blade</span><br /><br />A very sharp, but small blade.",
  
    "skeleton_sword_pieces": "<span class='color-primary'>Skeleton Sword Pieces</span><br /><br />Broken down pieces of an skeleton sword.",
    "skeleton_sword_handle": "<span class='color-primary'>Skeleton Sword Handle</span><br /><br />A broken down handle from an skeleton sword.",
    "skeleton_sword_blade": "<span class='color-primary'>Skeleton Sword Blade</span><br /><br />A very sharp skeleton sword blade.",
  
    "scythe_pieces": "<span class='color-primary'>Scythe Pieces</span><br /><br />Broken down pieces of a scythe.",
    "scythe_blade": "<span class='color-primary'>Scythe Blade</span><br /><br />A very sharp scythe blade.",
    "trident_head": "<span class='color-primary'>Trident Head</span><br /><br />The top of a trident.",
    "empty_staff_spirit": "<span class='color-primary'>Undead Staff Spirit (Empty)</span><br /><br />Contains no power.",

    "ring_parts": "<span class='color-primary'>Ring Parts</span><br /><br />A broken ring.  It seems to have magical properties even though it's broken.",
    

    "bone_amulet_pieces": "<span class='color-primary'>Bone Amulet Pieces</span><br /><br />Broken down pieces of a bone amulet.",
    "bone_amulet_medalion": "<span class='color-primary'>Bone Amulet Medalion</span><br /><br />The medalion of a bone amulet.  The primary item to upgrade your amulet.",
    

    "equipment_orb": "<span class='color-primary'>Equipment Orb</span><br /><br />An orb that allows you to enchant a weapon using magic and invention.",
    
    "cookie_dough": "<span class='color-primary'>Cookie Dough</span><br /><br />Used in the Christmas 2023 event.",
    "soul": "<span class='color-primary'>Soul</span><br /><br />Used in the Christmas 2023 event.",
    "buttons": "<span class='color-primary'>Buttons</span><br /><br />Used in the Christmas 2023 event.",
    "snow": "<span class='color-primary'>Snow</span><br /><br />Used in the Christmas 2023 event.",
    "cream": "<span class='color-primary'>Cream</span><br /><br />Used in the Christmas 2023 event.",
  

    
    "watering_can": "<span class='color-primary'>Watering Can</span><br /><br />Holds rain water which can be used to increase the growing rate of your crops.<br /><br /><img src='https://cdn.idle-pixel.com/images/water.png' />Rain water is collected slowly overtime.<br /><br /><span class='color-lime'>Only applied to first farming patch when activated.</span>",
    "sapphire_watering_can": "<span class='color-primary'>Watering Can</span><br /><br />Holds rain water which can be used to increase the growing rate of your crops.<br /><br /><img src='https://cdn.idle-pixel.com/images/water.png' />Rain water is collected slowly overtime.<br /><br /><span class='color-lime'>Applied to first and second farming patches when activated.</span>",
    "emerald_watering_can": "<span class='color-primary'>Watering Can</span><br /><br />Holds rain water which can be used to increase the growing rate of your crops.<br /><br /><img src='https://cdn.idle-pixel.com/images/water.png' />Rain water is collected slowly overtime.<br /><br /><span class='color-lime'>Applied to first, second and third  farming patches when activated.</span>",
    "ruby_watering_can": "<span class='color-primary'>Watering Can</span><br /><br />Holds rain water which can be used to increase the growing rate of your crops.<br /><br /><img src='https://cdn.idle-pixel.com/images/water.png' />Rain water is collected slowly overtime.<br /><br /><span class='color-lime'>Applied to all but one patches when activated.</span>",
    "diamond_watering_can": "<span class='color-primary'>Watering Can</span><br /><br />Holds rain water which can be used to increase the growing rate of your crops.<br /><br /><img src='https://cdn.idle-pixel.com/images/water.png' />Rain water is collected slowly overtime.<br /><br /><span class='color-lime'>Applied to all patches when activated.</span>",

    "robot_piece": "<span class='color-primary'>Robot piece</span><br /><br />A piece of what seems to be a robot.<br /><br /><span class='color-lime'>Click to craft</span>",
    "robot_piece": "<span class='color-primary'>Robot piece</span><br /><br />A piece of what seems to be a robot.<br /><br /><span class='color-lime'>Click to craft</span>",
    "robot_piece": "<span class='color-primary'>Robot piece</span><br /><br />A piece of what seems to be a robot.<br /><br /><span class='color-lime'>Click to craft</span>",
    "robot_piece": "<span class='color-primary'>Robot piece</span><br /><br />A piece of what seems to be a robot.<br /><br /><span class='color-lime'>Click to craft</span>",
    "robot_piece": "<span class='color-primary'>Robot piece</span><br /><br />A piece of what seems to be a robot.<br /><br /><span class='color-lime'>Click to craft</span>",
   
    "robot_novice_loot": "<span class='color-primary'>Robot Waves Loot (Novice)</span><br /><br />Loot from completing robot waves.<br /><br /><span class='color-lime'>Click to open</span>",
    "robot_warrior_loot": "<span class='color-primary'>Robot Waves Loot (Warrior)</span><br /><br />Loot from completing robot waves.<br /><br /><span class='color-lime'>Click to open</span>",
    "robot_master_loot": "<span class='color-primary'>Robot Waves Loot (Master)</span><br /><br />Loot from completing robot waves.<br /><br /><span class='color-lime'>Click to open</span>",
    "robot_elite_loot": "<span class='color-primary'>Robot Waves Loot (Elite)</span><br /><br />Loot from completing robot waves.<br /><br /><span class='color-lime'>Click to open</span>",
   

    "bronze_bar": "<div class='tooltip-title'> BRONZE BAR <br /> <span class='tooltip-rarity'><img style='padding-top:-4px' src='https://cdn.idle-pixel.com/images/rarity_icon_common.png' class='w15'> Common</span> </div> <img src='https://cdn.idle-pixel.com/images/coins.png' class='w15'> Sells for 3 coins <br /> <br /> <span class='tooltip-description'>A bar that was created from smelting ore into a furnace.</span> <br /> <br /> <span class='color-orange'><b>Total smelted:</b> <span id='tooltip-bronze_bar_total'>0</span></span> <br /> <br /> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/stardust.png' class='w30' /> </div> <div class='tooltip-hint-content'> Can be converted into <u>crafting XP</u> with the help of stardust. </div> </div>",
    "iron_bar": "<div class='tooltip-title'> IRON BAR <br /> <span class='tooltip-rarity'><img style='padding-top:-4px' src='https://cdn.idle-pixel.com/images/rarity_icon_common.png' class='w15'> Common</span> </div> <img src='https://cdn.idle-pixel.com/images/coins.png' class='w15'> Sells for 5 coins <br /> <br /> <span class='tooltip-description'>A bar that was created from smelting ore into a furnace.</span> <br /> <br /> <span class='color-orange'><b>Total smelted:</b> <span id='tooltip-iron_bar_total'>0</span></span> <br /> <br /> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/stardust.png' class='w30' /> </div> <div class='tooltip-hint-content'> Can be converted into <u>crafting XP</u> with the help of stardust. </div> </div>",
    "silver_bar": "<div class='tooltip-title'> SILVER BAR <br /> <span class='tooltip-rarity'><img style='padding-top:-4px' src='https://cdn.idle-pixel.com/images/rarity_icon_common.png' class='w15'> Common</span> </div> <img src='https://cdn.idle-pixel.com/images/coins.png' class='w15'> Sells for 10 coins <br /> <br /> <span class='tooltip-description'>A bar that was created from smelting ore into a furnace.</span> <br /> <br /> <span class='color-orange'><b>Total smelted:</b> <span id='tooltip-silver_bar_total'>0</span></span> <br /> <br /> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/stardust.png' class='w30' /> </div> <div class='tooltip-hint-content'> Can be converted into <u>crafting XP</u> with the help of stardust. </div> </div>",
    "gold_bar": "<div class='tooltip-title'> GOLD BAR <br /> <span class='tooltip-rarity'><img style='padding-top:-4px' src='https://cdn.idle-pixel.com/images/rarity_icon_uncommon.png' class='w15'> Uncommon</span> </div> <img src='https://cdn.idle-pixel.com/images/coins.png' class='w15'> Sells for 50 coins <br /> <br /> <span class='tooltip-description'>A bar that was created from smelting ore into a furnace.</span> <br /> <br /> <span class='color-orange'><b>Total smelted:</b> <span id='tooltip-gold_bar_total'>0</span></span> <br /> <br /> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/stardust.png' class='w30' /> </div> <div class='tooltip-hint-content'> Can be converted into <u>crafting XP</u> with the help of stardust. </div> </div>",
    "promethium_bar": "<div class='tooltip-title'> PROMETHIUM BAR <br /> <span class='tooltip-rarity'><img style='padding-top:-4px' src='https://cdn.idle-pixel.com/images/rarity_icon_rare.png' class='w15'> Rare</span> </div> <img src='https://cdn.idle-pixel.com/images/coins.png' class='w15'> Sells for 1000 coins <br /> <br /> <span class='tooltip-description'>A bar that was created from smelting ore into a furnace.</span> <br /> <br /> <span class='color-orange'><b>Total smelted:</b> <span id='tooltip-promethium_bar_total'>0</span></span> <br /> <br /> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/stardust.png' class='w30' /> </div> <div class='tooltip-hint-content'> Can be converted into <u>crafting XP</u> with the help of stardust. </div> </div>",
    "titanium_bar": "<div class='tooltip-title'> TITANIUM BAR <br /> <span class='tooltip-rarity'><img style='padding-top:-4px' src='https://cdn.idle-pixel.com/images/rarity_icon_veryrare.png' class='w15'> Very Rare</span> </div> <img src='https://cdn.idle-pixel.com/images/coins.png' class='w15'> Sells for 5000 coins <br /> <br /> <span class='tooltip-description'>A bar that was created from smelting ore into a furnace.</span> <br /> <br /> <span class='color-orange'><b>Total smelted:</b> <span id='tooltip-titanium_bar_total'>0</span></span> <br /> <br /> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/stardust.png' class='w30' /> </div> <div class='tooltip-hint-content'> Can be converted into <u>crafting XP</u> with the help of stardust. </div> </div>",
    "ancient_bar": "<div class='tooltip-title'> ANCIENT BAR <br /> <span class='tooltip-rarity'><img style='padding-top:-4px' src='https://cdn.idle-pixel.com/images/rarity_icon_veryrare.png' class='w15'> Very Rare</span> </div> <img src='https://cdn.idle-pixel.com/images/coins.png' class='w15'> Sells for 25,000 coins <br /> <br /> <span class='tooltip-description'>A bar that was created from smelting ore into a furnace.</span> <br /> <br /> <span class='color-orange'><b>Total smelted:</b> <span id='tooltip-ancient_bar_total'>0</span></span> <br /> <br /> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/stardust.png' class='w30' /> </div> <div class='tooltip-hint-content'> Can be converted into <u>crafting XP</u> with the help of stardust. </div> </div>",
   
    "stone_furnace": "<span class='color-primary'>Stone Furnace</span><br /><br />Smelt ores into metal bars.<br /><br /><span class='color-lime'>Capacy: 10</span>",
    "bronze_furnace": "<span class='color-primary'>Bronze Furnace</span><br /><br />Smelt ores into metal bars.<br /><br /><span class='color-lime'>Capacy: 50</span>",
    "iron_furnace": "<span class='color-primary'>Iron Furnace</span><br /><br />Smelt ores into metal bars.<br /><br /><span class='color-lime'>Capacy: 100</span>",
    "silver_furnace": "<span class='color-primary'>Silver Furnace</span><br /><br />Smelt ores into metal bars.<br /><br /><span class='color-lime'>Capacy: 200</span>",
    "gold_furnace": "<span class='color-primary'>Gold Furnace</span><br /><br />Smelt ores into metal bars.<br /><br /><span class='color-lime'>Capacy: 500</span>",
    "promethium_furnace": "<span class='color-primary'>Promethium Furnace</span><br /><br />Smelt ores into metal bars.<br /><br /><span class='color-lime'>Capacy: 900</span>",
    "titanium_furnace": "<span class='color-primary'>Titanium Furnace</span><br /><br />Smelt ores into metal bars.<br /><br /><span class='color-lime'>Capacy: 1500</span>",
    "ancient_furnace": "<span class='color-primary'>Ancient Furnace</span><br /><br />Smelt ores into metal bars.<br /><br /><span class='color-lime'>Capacy: 3000</span>",
    "dragon_furnace": "<span class='color-red'>Dragon Furnace</span><br /><br />Smelt ores into metal bars.<br /><br /><span class='color-lime'>Capacy: 5000</span><br /><br /><span class='color-red'>This furnace can smelt dragon ore.</span>",
   
    "magnet": "<span class='color-primary'>Magnet</span><br /><br />A magnet has the ability to filter through junk to find precious metals and other unique items.<br /><br />This tool can be upgraded with the socket scroll.<br /><br /><span class='color-cyan'>Converts junk into special loot bags every minute.",
    "sapphire_magnet": "<span class='color-primary'>Magnet</span><br /><br />A magnet has the ability to filter through junk to find precious metals and other unique items.<br /><br />This tool can be upgraded with the socket scroll.<br /><br /><span class='color-cyan'>Converts junk into special loot bags every 45 seconds.",
    "emerald_magnet": "<span class='color-primary'>Magnet</span><br /><br />A magnet has the ability to filter through junk to find precious metals and other unique items.<br /><br />This tool can be upgraded with the socket scroll.<br /><br /><span class='color-cyan'>Converts junk into special loot bags every 20 seconds.",
    "ruby_magnet": "<span class='color-primary'>Magnet</span><br /><br />A magnet has the ability to filter through junk to find precious metals and other unique items.<br /><br />This tool can be upgraded with the socket scroll.<br /><br /><span class='color-cyan'>Converts junk into special loot bags every 5 seconds.",
    "diamond_magnet": "<span class='color-primary'>Magnet</span><br /><br />A magnet has the ability to filter through junk to find precious metals and other unique items.<br /><br /><span class='color-cyan'>Converts junk into special loot bags every second.",
    
    "pickaxe": "<span class='color-primary'>Pickaxe</span><br /><br />Slowly collects ore.<br /><img class='w20' src='https://cdn.idle-pixel.com/images/stone.png'> <img class='w20' src='https://cdn.idle-pixel.com/images/copper.png'> <img class='w20' src='https://cdn.idle-pixel.com/images/iron.png'>",
    "hammer": "<span class='color-primary'>Hammer</span><br /><br />Eases the process of converting bars into xp using upgrades.  Requires the knowledge of upgrading tools to work.",
    "upgraded-hammer": "<span class='color-primary'>Hammer</span><br /><br />Eases the process of converting bars into xp using upgrades.",
    "rake": "<span class='color-primary'>Rake</span><br /><br />Automatically collects seeds overtime.  Seeds are rare, and it may take a bit of time to find some with just a rake.",
    "trowel": "<span class='color-primary'>Trowel</span><br /><br />Ability to find vegetable seeds for extra energy.",
    "axe": "<span class='color-primary'>Axe</span><br /><br />Used to chop down trees.",
    "drill": "<div class='tooltip-title'> DRILL <br /> <span class='tooltip-rarity'><img style='padding-top:-4px' src='https://cdn.idle-pixel.com/images/rarity_icon_common.png' class='w15'> Common</span> </div> <span class='tooltip-description'>Can be turned on to gain better ores.  The more you turn on, the faster ores you mine.</span> <br /> <br /> <span class='color-orange'><b>Currently Active: </b><span id='tooltip-drill_on'>0</span></span> <br /> <br /> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/mining.png' class='w30' /> </div> <div class='tooltip-hint-content'> Requires level 1 mining to activate. </div> </div> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/oil.png' class='w30' /> </div> <div class='tooltip-hint-content'> Requires 1 oil per second when active. </div> </div> <div class='tooltip-hint-green'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/stone.png' class='w30' /> </div> <div class='tooltip-hint-content'> Stone chance: 1/8 per second per drill active. </div> </div> <div class='tooltip-hint-green'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/copper.png' class='w30' /> </div> <div class='tooltip-hint-content'> Copper chance: 1/21 per second per drill active. </div> </div> <div class='tooltip-hint-green'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/iron.png' class='w30' /> </div> <div class='tooltip-hint-content'> Iron chance: 1/21 per second per drill active. </div> </div> <div class='tooltip-hint-green'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/silver.png' class='w30' /> </div> <div class='tooltip-hint-content'> Silver chance: 1/500 per second per drill active. </div> </div>",
    "crusher": "<div class='tooltip-title'> CRUSHER <br /> <span class='tooltip-rarity'><img style='padding-top:-4px' src='https://cdn.idle-pixel.com/images/rarity_icon_common.png' class='w15'> Common</span> </div> <span class='tooltip-description'>Can be turned on to gain better ores.  The more you turn on, the faster ores you mine.</span> <br /> <br /> <span class='color-orange'><b>Currently Active: </b><span id='tooltip-crusher_on'>0</span></span> <br /> <br /> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/mining.png' class='w30' /> </div> <div class='tooltip-hint-content'> Requires level 10 mining to activate. </div> </div> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/oil.png' class='w30' /> </div> <div class='tooltip-hint-content'> Requires 3 oil per second when active. </div> </div> <div class='tooltip-hint-green'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/stone.png' class='w30' /> </div> <div class='tooltip-hint-content'> Stone chance: 1/6 per second per crusher active. </div> </div> <div class='tooltip-hint-green'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/copper.png' class='w30' /> </div> <div class='tooltip-hint-content'> Copper chance: 1/15 per second per crusher active. </div> </div> <div class='tooltip-hint-green'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/iron.png' class='w30' /> </div> <div class='tooltip-hint-content'> Iron chance: 1/50 per second per crusher active. </div> </div> <div class='tooltip-hint-green'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/silver.png' class='w30' /> </div> <div class='tooltip-hint-content'> Silver chance: 1/300 per second per crusher active. </div> </div> <div class='tooltip-hint-green'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/gold.png' class='w30' /> </div> <div class='tooltip-hint-content'> Gold chance: 1/3600 per second per crusher active. </div> </div>",
    "giant_drill": "<div class='tooltip-title'> GIANT DRILL <br /> <span class='tooltip-rarity'><img style='padding-top:-4px' src='https://cdn.idle-pixel.com/images/rarity_icon_uncommon.png' class='w15'> Uncommon</span> </div> <span class='tooltip-description'>Can be turned on to gain better ores.  The more you turn on, the faster ores you mine.</span> <br /> <br /> <span class='color-orange'><b>Currently Active: </b><span id='tooltip-giant_drill_on'>0</span></span> <br /> <br /> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/mining.png' class='w30' /> </div> <div class='tooltip-hint-content'> Requires level 25 mining to activate. </div> </div> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/oil.png' class='w30' /> </div> <div class='tooltip-hint-content'> Requires 8 oil per second when active. </div> </div> <div class='tooltip-hint-green'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/silver.png' class='w30' /> </div> <div class='tooltip-hint-content'> Silver chance: 1/200 per second per giant drill active. </div> </div> <div class='tooltip-hint-green'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/gold.png' class='w30' /> </div> <div class='tooltip-hint-content'> Gold chance: 1/2000 per second per giant drill active. </div> </div> <div class='tooltip-hint-green'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/promethium.png' class='w30' /> </div> <div class='tooltip-hint-content'> Promethium chance: 1/20,000 per second per giant drill active. </div> </div>",
    "excavator": "<div class='tooltip-title'> EXCAVATOR <br /> <span class='tooltip-rarity'><img style='padding-top:-4px' src='https://cdn.idle-pixel.com/images/rarity_icon_rare.png' class='w15'> Rare</span> </div> <span class='tooltip-description'>Can be turned on to gain better ores.  The more you turn on, the faster ores you mine.</span> <br /> <br /> <span class='color-orange'><b>Currently Active: </b><span id='tooltip-excavator_on'>0</span></span> <br /> <br /> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/mining.png' class='w30' /> </div> <div class='tooltip-hint-content'> Requires level 60 mining to activate. </div> </div> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/oil.png' class='w30' /> </div> <div class='tooltip-hint-content'> Requires 10 oil per second when active. </div> </div> <div class='tooltip-hint-green'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/gold.png' class='w30' /> </div> <div class='tooltip-hint-content'> Gold chance: 1/1500 per second per excavator active. </div> </div> <div class='tooltip-hint-green'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/promethium.png' class='w30' /> </div> <div class='tooltip-hint-content'> Promethium chance: 1/15,000 per second excavator drill active. </div> </div> <div class='tooltip-hint-green'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/titanium.png' class='w30' /> </div> <div class='tooltip-hint-content'> Titanium chance: 1/100,000 per second excavator drill active. </div> </div>",
    "giant_excavator": "<div class='tooltip-title'> GIANT EXCAVATOR <br /> <span class='tooltip-rarity'><img style='padding-top:-4px' src='https://cdn.idle-pixel.com/images/rarity_icon_rare.png' class='w15'> Rare</span> </div> <span class='tooltip-description'>Can be turned on to gain better ores.  The more you turn on, the faster ores you mine.</span> <br /> <br /> <span class='color-orange'><b>Currently Active: </b><span id='tooltip-giant_excavator_on'>0</span></span> <br /> <br /> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/mining.png' class='w30' /> </div> <div class='tooltip-hint-content'> Requires level 80 mining to activate. </div> </div> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/oil.png' class='w30' /> </div> <div class='tooltip-hint-content'> Requires 20 oil per second when active. </div> </div> <div class='tooltip-hint-green'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/titanium.png' class='w30' /> </div> <div class='tooltip-hint-content'> Titanium chance: 1/50,000 per second excavator drill active. </div> </div> <div class='tooltip-hint-green'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/ancient_ore.png' class='w30' /> </div> <div class='tooltip-hint-content'> Ancient ore chance: 1/200,000 per second excavator drill active. </div> </div>",
    "massive_excavator": "<div class='tooltip-title'> MASSIVE EXCAVATOR <br /> <span class='tooltip-rarity'><img style='padding-top:-4px' src='https://cdn.idle-pixel.com/images/rarity_icon_veryrare.png' class='w15'> Very Rare</span> </div> <span class='tooltip-description'>Can be turned on to gain better ores.  The more you turn on, the faster ores you mine.</span> <br /> <br /> <span class='color-orange'><b>Currently Active: </b><span id='tooltip-massive_excavator_on'>0</span></span> <br /> <br /> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/mining.png' class='w30' /> </div> <div class='tooltip-hint-content'> Requires level 100 mining to activate. </div> </div> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/oil.png' class='w30' /> </div> <div class='tooltip-hint-content'> Requires 100 oil per second when active. </div> </div> <div class='tooltip-hint-green'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/ancient_ore.png' class='w30' /> </div> <div class='tooltip-hint-content'> Ancient ore chance: 1/50,000 per massive excavator active. </div> </div> <div class='tooltip-hint-green'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/dragon_ore.png' class='w30' /> </div> <div class='tooltip-hint-content'> Ancient ore chance: 1/200,000 per second per massive excavator active. </div> </div>",
    
    "meteor_radar_detector": "<span class='color-primary'>Meteor Radar Detector</span><br /><br />Ability to track meteor's near the sun.<br /><br /><span class='color-lime'>Highly increases your chance of finding meteor's when sending your rocket to the sun.</span>",
    
    "balance": "<span class='color-primary'>The balance of life</span><br /><br />Click to permanently activate offline progress for this account.",
    "badge_points_menu": "<span class='color-primary'>Combat Badges Points</span><br /><br />Gain levels in melee, archery or magic to earn badge points.  Click to manage combat badges and unlock permanent combat perks.",
    
    
    "shark_bucket": "<span class='color-primary'>1/4 Salt Water (Shark)</span><br /><br />Contain a bit of salt water.  Click to craft.",
    "puffer_fish_bucket": "<span class='color-primary'>1/4 Salt Water (Pufferfish)</span><br /><br />Contain a bit of salt water.  Click to craft.",
    "sea_soldier_bucket": "<span class='color-primary'>1/4 Salt Water (Sea Soldier)</span><br /><br />Contain a bit of salt water.  Click to craft.",
    "saltwater_crocodile_bucket": "<span class='color-primary'>1/4 Salt Water  (Crocodile)</span><br /><br />Contain a bit of salt water.  Click to craft.",
    "saltwater_bucket": "<span class='color-primary'>Salt Water</span><br /><br />Contain a lot of salt water.  Click to boil.",
    "water_bucket": "<span class='color-primary'>Water</span><br /><br />Some pure drinkable water.  Can be further enchanted.",
    "enchanted_water_bucket": "<span class='color-primary'>Enchanted Water</span><br /><br />Infinite supply of pure drinkable water.<br /><br /><span class='color-blue'>Side Quest: I should show this to the very nice bird.</span>",
    
    
    "time_warp_chemist_dust": "<span class='color-primary'>Dust</span><br /><br />Dust to be used with the <b class='color-orange'>time warp chemist</b> quest...I wonder how much I need to make the perfect potion?",
    
    "dragon_ore": "<div class='tooltip-title'> DRAGON ORE <br /> <span class='tooltip-rarity'><img style='padding-top:-4px' src='https://cdn.idle-pixel.com/images/rarity_icon_megarare.png' class='w15'> Mega Rare</span> </div> <span class='tooltip-description'>The rare ore in the game.  It seems to be radiating heat.</span> <br /> <br /> <span class='color-orange'><b>Total mined:</b> <span id='tooltip-dragon_ore_total'>0</span></span> <br /> <br /> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/dragon_bar.png' class='w30' /> </div> <div class='tooltip-hint-content'> Can be smelted into the best bars in the game. </div> </div> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/stardust.png' class='w30' /> </div> <div class='tooltip-hint-content'> Can be converted into <u>mining XP</u> with the help of stardust. </div> </div>",
    "dragon_bar": "<div class='tooltip-title'> DRAGON BAR <br /> <span class='tooltip-rarity'><img style='padding-top:-4px' src='https://cdn.idle-pixel.com/images/rarity_icon_megarare.png' class='w15'> Mega Rare</span> </div> <span class='tooltip-description'>A bar that was created from smelting ore into a furnace.</span> <br /> <br /> <span class='color-red'>This is the rarest and best bar in the game.</span> <br /> <br /> <span class='color-orange'><b>Total smelted:</b> <span id='tooltip-dragon_bar_total'>0</span></span> <br /> <br /> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/stardust.png' class='w30' /> </div> <div class='tooltip-hint-content'> Can be converted into <u>mining XP</u> with the help of stardust. </div> </div>",
    
    "mixed_bar": "<span class='color-primary'>Mixed Bar</span><br /><br />A weird looking bar.  It seems to be a melted bronze, iron, silver and gold bar into one.<br /><br /> <img src='https://cdn.idle-pixel.com/images/coins.png' class='w15'> Sells for 10,000 coins <br />",
    "pyre_logs": "<span class='color-primary'>Pyre logs</span><br /><br />A log that is covered with bones.  You can feel the spirits, but maybe you're just crazy.",
    
    "flexible_logs": "<span class='color-primary'>Flex logs</span><br /><br />These logs are filled with water making them very flexible.  They don't give much heat due to the water content, but can be useful for making flexible items, such as balistas.",
    

    "charcoal": "<span class='color-primary'>Charcoal</span><br /><br />Mainly used to smelt high level ores.",
    
    "timewarp_dust": "Magical dust that can be made into a niche timewarp potion.",

    "cooks_dust_potion": "<span class='color-primary'>Dust Potion (Cooks book)</span><br /><br />Go forward in time:  Instantly completes the timer for the cook's book.",
    "fighting_dust_potion": "<span class='color-primary'>Dust Potion (Fight points)</span><br /><br />Go forward in time:  Instantly restores your fightpoints.",
    "tree_dust_potion": "<span class='color-primary'>Dust Potion (Trees)</span><br /><br />Go forward in time:  Instantly grows all tree patches.",
    "farm_dust_potion": "<span class='color-primary'>Dust Potion (Farming)</span><br /><br />Go forward in time:  Instantly grows all planted seeds.<br /><br /><span class='color-grey'>Note that they may still die without the appropriate farming level.</span>",
   


    "machete": "<span class='color-primary'>Machete</span><br /><br />10% chance to get double the fruit when chopping fruit trees.<br /><br /><span class='color-orange'>Can be upgraded with the socket scroll.</span>",
    "sapphire_machete": "<span class='color-primary'>Sapphire Machete</span><br /><br />15% chance to get double the fruit when chopping fruit trees.<br /><br /><span class='color-orange'>Can be upgraded with the socket scroll.</span>",
    "emerald_machete": "<span class='color-primary'>Emerald Machete</span><br /><br />30% chance to get double the fruit when chopping fruit trees.<br /><br /><span class='color-orange'>Can be upgraded with the socket scroll.</span>",
    "ruby_machete": "<span class='color-primary'>Ruby Machete</span><br /><br />60% chance to get double the fruit when chopping fruit trees.<br /><br /><span class='color-orange'>Can be upgraded with the socket scroll.</span>",
    "diamond_machete": "<span class='color-primary'>Diamond Machete</span><br /><br />100% chance to get double the fruit when chopping fruit trees.",

    "stone_statue": "<div class='tooltip-title'> STONE STATUE <br /> <span class='tooltip-rarity'><img style='padding-top:-4px' src='https://cdn.idle-pixel.com/images/rarity_icon_very_common.png' class='w15'> Very Common</span> </div> <span class='tooltip-description'>A statue made completely from stone.  Dwarfs seem to love to decorate their houses with such statues.  Perhaps one day I can make a diamond one.</span> <br /> <br /> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/quests.png' class='w30' /> </div> <div class='tooltip-hint-content color-cyan'> Quest Item </div> </div>",
    "bronze_statue": "<span class='color-primary'>Bronze Statue</span><br /><br />A small statue made of pure bronze.  Doric the crafter would love this.",
    "glass_statue": "<span class='color-primary'>Glass Statue</span><br /><br />A small statue made of glass.  Doric the crafter would love this.",

    "bronze_oil_well": "<span class='color-primary'>Bronze Oil Well</span><br /><br />Brings in 1 oil every second.",
    "iron_oil_well": "<span class='color-primary'>Iron Oil Well</span><br /><br />Brings in 2 oil every second.",
    "silver_oil_well": "<span class='color-primary'>Silver Oil Well</span><br /><br />Brings in 3 oil every second.",
    "gold_oil_well": "<span class='color-primary'>Gold Oil Well</span><br /><br />Brings in 5 oil every second.",
    "promethium_oil_well": "<span class='color-primary'>Promethium Oil Well</span><br /><br />Brings in 10 oil every second.",
    "titanium_oil_well": "<span class='color-primary'>Titanium Oil Well</span><br /><br />Brings in 25 oil every second.",
    "ancient_oil_well": "<span class='color-primary'>Ancient Oil Well</span><br /><br />Brings in 40 oil every second.",

    "shop-leather": "<span class='color-primary'>Leather</span><br /><br />A base material for crafting.",
    "shop-player_market": "<span class='color-primary'>Player Market</span><br /><br />Access to player market to trade with other players.",
    "shop-donor_shop": "<span class='color-primary'>Donor shop</span><br /><br />Ability to purchase temporary perks.",

    "leather": "<span class='color-primary'>Leather</span><br /><br />A base material for crafting.",

    
    "dark_diamond_fragments_1": "<span class='color-primary'>Dark Diamond Fragments</span><br /><br />Four",
    "dark_diamond_fragments_2": "<span class='color-primary'>Dark Diamond Fragments</span><br /><br />Elements",
    "dark_diamond_fragments_3": "<span class='color-primary'>Dark Diamond Fragments</span><br /><br />That",
    "dark_diamond_fragments_4": "<span class='color-primary'>Dark Diamond Fragments</span><br /><br />You",
    "dark_diamond_fragments_5": "<span class='color-primary'>Dark Diamond Fragments</span><br /><br />Must",
    "dark_diamond_fragments_6": "<span class='color-primary'>Dark Diamond Fragments</span><br /><br />Answer",
    "dark_diamond_stoned": "<span class='color-primary'>Dark Diamond (With Tar)</span><br /><br />There seems to be some very deep and sticky tar in this gem.",
    "dark_diamond_unpowered": "<span class='color-primary'>Dark Diamond (Unpowered)</span><br /><br />The gem has lost its power.",
    "dark_diamond": "<span class='color-primary'>Dark Diamond</span><br /><br />Can be used to craft a legendary dark sword.",
    
    "stardust_watch": "<span class='color-primary'>Stardust Watch</span><br /><br />Ability to go into the future 1 hour at a time at the cost of stardust.<br /><br /><span class='color-orange'>This requires charges that replenish overtime.</span>",

    "achievements_book": "A collection of achievements.<br /><br /><span class='color-lime'>Open the book to view achievements.</span>",
    "achievements_books": "A large collection of achievements.<br /><br /><span class='color-lime'>Open the book to view achievements.</span>",

    "gathering_loot_unique":"<span class='color-primary'>Unique Item</span><br /><br />Wonder what's inside!",
    "broken_rake":"<span class='color-primary'>Broken Rake</span><br /><br />This item needs a few iron bars to be fixed.<br /><br /><span class='color-lime'>Click to fix.</span>",
    
    "bones": "<span class='color-primary'>Bones</span><br /><br />Bones are filled with calcium.  They can be converted to bonemeal which is required to plant high level seeds.<br /><br /><span class='color-lime'>Bonemeal: 1</span>",
    "big_bones": "<span class='color-primary'>Big Bones</span><br /><br />Bones are filled with calcium.  They can be converted to bonemeal which is required to plant high level seeds.<br /><br /><span class='color-lime'>Bonemeal: 2</span>",
    "ice_bones": "<span class='color-primary'>Ice Bones</span><br /><br />Bones are filled with calcium.  Frozen bones conserved more calcium.  They can be converted to bonemeal which is required to plant high level seeds.<br /><br /><span class='color-lime'>Bonemeal: 3</span>",
    "blood_bones": "<span class='color-primary'>Blood Bones</span><br /><br />Bones are filled with calcium.  Blood also contains a lot of calcium.  Can be converted to bonemeal which is required to plant high level seeds.<br /><br /><span class='color-lime'>Bonemeal: 4</span>",
    "ashes": "<span class='color-primary'>Ashes</span><br /><br />I guess they used to be bones.  They can be converted to bonemeal which is required to plant high level seeds.<br /><br /><span class='color-lime'>Bonemeal: 2</span>",
    "dragon_bones": "<span class='color-primary'>Dragon Bones</span><br /><br />Bones are filled with calcium.  Dragon bones have a ton of calcium. Legend says that they can be obtained from guardians controlled by Faradox. They can be converted to bonemeal which is required to plant high level seeds.<br /><br /><span class='color-lime'>Bonemeal: 500</span>",
    
    "crystal_ball": "<span class='color-primary'>Angel's Magic XP Ball</span><br /><br />Can be touched to contact deceased angels.  They can lead you to a path to more magic XP.",
    

    "long_bow_frame": "<span class='color-primary'>Long Bow Frame</span><br /><br />A long bow base.  This bow has a much higher accuracy than a wooden bow.<br /><br /><span class='color-lime'>Click to craft.</span>",
    
    "crafted_tablette": "<span class='color-primary'>Uncharged Tablette</span><br /><br />Made from various pieces.  There seems to be some powerful blood stuck within the essence.<br /><br /><span class='color-lime'>Click to bloodify.</span>",
    "charged_tablette": "<span class='color-primary'>Charged Tablette</span><br /><br />Contains valuable information on how to invent things.",

    "tablette_field": "<span class='color-primary'>Field's Tablette Piece</span><br /><br />Can be combined into a full tablette.<br /><br /><span class='color-lime'>Click to combine.</span>",
    "tablette_forest": "<span class='color-primary'>Forest's Tablette Piece</span><br /><br />Can be combined into a full tablette.<br /><br /><span class='color-lime'>Click to combine.</span>",
    "tablette_cave": "<span class='color-primary'>Caves's Tablette Piece</span><br /><br />Can be combined into a full tablette.<br /><br /><span class='color-lime'>Click to combine.</span>",
    "tablette_volcano": "<span class='color-primary'>Volcano's Tablette Piece</span><br /><br />Can be combined into a full tablette.<br /><br /><span class='color-lime'>Click to combine.</span>",
    "tablette_ancient": "<span class='color-primary'>Ancient Tablette Piece</span><br /><br />Can be combined into a full tablette with 5 pieces found from any blood monster.<br /><br /><span class='color-lime'>Click to combine.</span>",
    
    "aquarium":"<span class='color-primary'>Aquarium</span><br /><br />I can put fish obtained from the fishing net in here.  I can then feed them for more additional fishing xp.<br /><br /><span class='color-lime'>Click to manage.</span>",

    "blood_grinder": "<span class='color-primary'>Blood Grinder</span><br /><br />Grind limbs from monsters fought while the blood moon is active.<br /><br /><span class='color-lime'><img src='https://cdn.idle-pixel.com/images/blood_icon.png' /> Click looted limbs to grind into blood.</span>",
    "evil_blood": "<span class='color-primary'>Evil Blood</span><br /><br />Obtained from grinding monster limbs.  This blood is still tainted with Faradox's magic.  We must remove the evil from it with our magic.<br /><br /><span class='color-orange'>Requires glass blood statue from crafting.</span>",
    "cleansed_blood": "<span class='color-primary'>Cleansed Blood</span><br /><br />Pure blood that has been cleansed after being affected by the bloodmoon.</span>",
    
    "blood_limb_fields": "<span class='color-primary'>Field Limbs</span><br /><br />A limb that contains evil blood.<br /><br /><span class='color-lime'>Can be extracted using a meat grinder from crafting.</span><br /><br /><span class='color-red'><img src='https://cdn.idle-pixel.com/images/blood_icon.png' /> 5 - 10 blood</span>",
    "blood_limb_fields_rare": "<span class='color-primary'>Field Limbs</span><br /><br />A limb that contains evil blood.<br /><br /><span class='color-lime'>Can be extracted using a meat grinder from crafting.</span><br /><br /><span class='color-red'><img src='https://cdn.idle-pixel.com/images/blood_icon.png' /> 10 - 15 blood</span>",
    "blood_glass_shrine": "<span class='color-primary'>Blood Glass Statue</span><br /><br />Filled with magic.<br /><br /><span class='color-lime'>Can be prayed with evil blood to remove the evilness from the blood.</span><br /><br />This statue seems weird.  Maybe the dwarf's have more info.",
    
    "blood_limb_forest": "<span class='color-primary'>Forest Limbs</span><br /><br />A limb that contains evil blood.<br /><br /><span class='color-lime'>Can be extracted using a meat grinder from crafting.</span><br /><br /><span class='color-red'><img src='https://cdn.idle-pixel.com/images/blood_icon.png' /> 15 - 25 blood</span>",
    "blood_limb_forest_rare": "<span class='color-primary'>Forest Limbs</span><br /><br />A limb that contains evil blood.<br /><br /><span class='color-lime'>Can be extracted using a meat grinder from crafting.</span><br /><br /><span class='color-red'><img src='https://cdn.idle-pixel.com/images/blood_icon.png' /> 30 - 40 blood</span>",

    "blood_limb_cave": "<span class='color-primary'>Cave Limbs</span><br /><br />A limb that contains evil blood.<br /><br /><span class='color-lime'>Can be extracted using a meat grinder from crafting.</span><br /><br /><span class='color-red'><img src='https://cdn.idle-pixel.com/images/blood_icon.png' /> 50 - 70 blood</span>",
    "blood_limb_cave_rare": "<span class='color-primary'>Cave Limbs</span><br /><br />A limb that contains evil blood.<br /><br /><span class='color-lime'>Can be extracted using a meat grinder from crafting.</span><br /><br /><span class='color-red'><img src='https://cdn.idle-pixel.com/images/blood_icon.png' /> 90 - 120 blood</span>",
    
    "blood_limb_volcano": "<span class='color-primary'>Volcano Limbs</span><br /><br />A limb that contains evil blood.<br /><br /><span class='color-lime'>Can be extracted using a meat grinder from crafting.</span><br /><br /><span class='color-red'><img src='https://cdn.idle-pixel.com/images/blood_icon.png' /> 95 - 120 blood</span>",
    "blood_limb_volcano_rare": "<span class='color-primary'>Volcano Limbs</span><br /><br />A limb that contains evil blood.<br /><br /><span class='color-lime'>Can be extracted using a meat grinder from crafting.</span><br /><br /><span class='color-red'><img src='https://cdn.idle-pixel.com/images/blood_icon.png' /> 130 - 150 blood</span>",


    "dotted_green_leaf_seeds": "<div class='tooltip-title'> DOTTED GREEN LEAF SEEDS <br /> <span class='tooltip-rarity'><img style='padding-top:-4px' src='https://cdn.idle-pixel.com/images/rarity_icon_common.png' class='w15'> Common</span> </div> <br /> <span class='tooltip-description'>A common seed which yields the priamry ingredient for brewing potions.</span> <br /> <br /> <span class='color-cyan'><b>Type: </b>Leaf seed</span></span> <br /> <span class='color-green'><b>Rarity: </b> <span id='tooltip-dotted_green_leaf_seeds_rarity'>1/43,200</span></span> <br /> <span class='color-orange'><b>Found: </b> <span id='tooltip-dotted_green_leaf_seeds_total'>0</span></span> <br /> <br /> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/farming.png' class='w30' /> </div> <div class='tooltip-hint-content'> Planting: Level 1 <img class='w15' id='tooltip-plant-level-img-dotted_green_leaf_seeds' /><br /> Stops Dying: Level 15. <img class='w15' id='tooltip-plant-level-img-dotted_green_leaf_seeds_death' /> </div> </div> <div class='tooltip-hint-green'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/xp_arrow.png' class='w30' /> </div> <div class='tooltip-hint-content'> 150 XP </div> </div> <div class='tooltip-hint-yellow'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/hourglass.png' class='w30' /> </div> <div class='tooltip-hint-content'> 15 Minutes </div> </div>",
    "green_leaf_seeds": "<div class='tooltip-title'> GREEN LEAF SEEDS <br /> <span class='tooltip-rarity'><img style='padding-top:-4px' src='https://cdn.idle-pixel.com/images/rarity_icon_common.png' class='w15'> Common</span> </div> <br /> <span class='tooltip-description'>A common seed which yields the priamry ingredient for brewing potions.</span> <br /> <br /> <span class='color-cyan'><b>Type: </b>Leaf seed</span></span> <br /> <span class='color-green'><b>Rarity: </b> <span id='tooltip-green_leaf_seeds_rarity'>1/43,200</span></span> <br /> <span class='color-orange'><b>Found: </b> <span id='tooltip-green_leaf_seeds_total'>0</span></span> <br /> <br /> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/farming.png' class='w30' /> </div> <div class='tooltip-hint-content'> Planting: Level 25 <img class='w15' id='tooltip-plant-level-img-green_leaf_seeds' /><br /> Stops Dying: Level 40. <img class='w15' id='tooltip-plant-level-img-green_leaf_seeds_death' /> </div> </div> <div class='tooltip-hint-green'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/xp_arrow.png' class='w30' /> </div> <div class='tooltip-hint-content'> 300 XP </div> </div> <div class='tooltip-hint-yellow'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/hourglass.png' class='w30' /> </div> <div class='tooltip-hint-content'> 30 Minutes </div> </div>",
    "lime_leaf_seeds": "<div class='tooltip-title'> LIME LEAF SEEDS <br /> <span class='tooltip-rarity'><img style='padding-top:-4px' src='https://cdn.idle-pixel.com/images/rarity_icon_uncommon.png' class='w15'> Uncommon</span> </div> <br /> <span class='tooltip-description'>A uncommon seed which yields the priamry ingredient for brewing potions.</span> <br /> <br /> <span class='color-cyan'><b>Type: </b>Leaf seed</span></span> <br /> <span class='color-green'><b>Rarity: </b> <span id='tooltip-lime_leaf_seeds_rarity'>1/432,000</span></span> <br /> <span class='color-orange'><b>Found: </b> <span id='tooltip-lime_leaf_seeds_total'>0</span></span> <br /> <br /> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/farming.png' class='w30' /> </div> <div class='tooltip-hint-content'> Planting: Level 25 <img class='w15' id='tooltip-plant-level-img-lime_leaf_seeds' /><br /> Stops Dying: Level 40. <img class='w15' id='tooltip-plant-level-img-lime_leaf_seeds_death' /> </div> </div> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/bonemeal.png' class='w30' /> </div> <div class='tooltip-hint-content'> Bonemeal: 1 <img class='w15' id='tooltip-plant-level-img-lime_leaf_seeds_bonemeal' /> </div> </div> <div class='tooltip-hint-green'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/xp_arrow.png' class='w30' /> </div> <div class='tooltip-hint-content'> 390 XP </div> </div> <div class='tooltip-hint-yellow'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/hourglass.png' class='w30' /> </div> <div class='tooltip-hint-content'> 1 Hour </div> </div>",
    "gold_leaf_seeds": "<div class='tooltip-title'> GOLD LEAF SEEDS <br /> <span class='tooltip-rarity'><img style='padding-top:-4px' src='https://cdn.idle-pixel.com/images/rarity_icon_rare.png' class='w15'> Rare</span> </div> <br /> <span class='tooltip-description'>A rare seed which yields the priamry ingredient for brewing potions.</span> <br /> <br /> <span class='color-cyan'><b>Type: </b>Leaf seed</span></span> <br /> <span class='color-green'><b>Rarity: </b> <span id='tooltip-gold_leaf_seeds_rarity'>1/432,000</span></span> <br /> <span class='color-orange'><b>Found: </b> <span id='tooltip-gold_leaf_seeds_total'>0</span></span> <br /> <br /> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/farming.png' class='w30' /> </div> <div class='tooltip-hint-content'> Planting: Level 50 <img class='w15' id='tooltip-plant-level-img-gold_leaf_seeds' /><br /> Stops Dying: Level 60. <img class='w15' id='tooltip-plant-level-img-gold_leaf_seeds_death' /> </div> </div> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/bonemeal.png' class='w30' /> </div> <div class='tooltip-hint-content'> Bonemeal: 5  <img class='w15' id='tooltip-plant-level-img-gold_leaf_seeds_bonemeal' /> </div> </div> <div class='tooltip-hint-green'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/xp_arrow.png' class='w30' /> </div> <div class='tooltip-hint-content'> 1000 XP </div> </div> <div class='tooltip-hint-yellow'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/hourglass.png' class='w30' /> </div> <div class='tooltip-hint-content'> 2 Hours </div> </div>",
    "crystal_leaf_seeds": "<div class='tooltip-title'> CRYSTAL LEAF SEEDS <br /> <span class='tooltip-rarity'><img style='padding-top:-4px' src='https://cdn.idle-pixel.com/images/rarity_icon_megarare.png' class='w15'> Mega Rare</span> </div> <br /> <span class='tooltip-description'>A mega rare seed which yields the priamry ingredient for brewing potions.  The base chance of finding this seed with a rake is 1 in 3 million per second.</span> <br /> <br /> <span class='color-cyan'><b>Type: </b>Leaf seed</span></span> <br /> <span class='color-green'><b>Rarity: </b> <span id='tooltip-crystal_leaf_seeds_rarity'>1/3,000,000</span></span> <br /> <span class='color-orange'><b>Found: </b> <span id='tooltip-crystal_leaf_seeds_total'>0</span></span> <br /> <br /> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/farming.png' class='w30' /> </div> <div class='tooltip-hint-content'> Planting: Level 70 <img class='w15' id='tooltip-plant-level-img-crystal_leaf_seeds' /><br /> Stops Dying: Level 80. <img class='w15' id='tooltip-plant-level-img-crystal_leaf_seeds_death' /> </div> </div> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/bonemeal.png' class='w30' /> </div> <div class='tooltip-hint-content'> Bonemeal: 25  <img class='w15' id='tooltip-plant-level-img-crystal_leaf_seeds_bonemeal' /> </div> </div> <div class='tooltip-hint-green'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/xp_arrow.png' class='w30' /> </div> <div class='tooltip-hint-content'> 2452 XP </div> </div> <div class='tooltip-hint-yellow'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/hourglass.png' class='w30' /> </div> <div class='tooltip-hint-content'> 5 Hours </div> </div>",
    "white_leaf_seeds": "<span class='color-primary'>White Leaf Seeds</span><br /><br />An extremely rare seed obtain from Bob the farmer.<br /><br /><span class='color-lime'><span class='color-orange'>Level: 70</span> <span class='color-grey'>(Stops Dying: 100)</span><br /><span class='color-orange'>Farming XP: ???</span><br />Growtime: 7 hours<br />Bonemeal Required: 100</span></span><br /><br /><span class='color-red'>Level 70 Farming: 90% chance of dying.<br />Level 80 Farming: 66% chance of dying.<br />Level 90 Farming: 50% chance of dying.<br />Level 100 Farming: 0% chance of dying.</span><br /><br /><span class='color-pink font-small'><img src='https://cdn.idle-pixel.com/images/brewing.png' class='w20' /> Anti disease potions can help reduce chance of death.</span>",
    
    "magic_beans_seeds": "<span class='color-primary'>Magic Beans</span><br /><br />A seed that can grow really high!<br /><br /><span class='color-lime'><span class='color-orange'>Level: 20</span>",
    
    "mega_dotted_green_leaf_seeds": "<div class='tooltip-title'> DOTTED GREEN LEAF SEEDS (MEGA) </div>  <span class='tooltip-description'>Has an extremely high yeild.  The seed is so compact that is weighs over 25 pounds.  They require a lot of bonemeal to plant, and cannot be artifically shinied as they are much too dense.  However, they may become shiny naturally.</span><br /><br /> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/farming.png' class='w30' /> </div> <div class='tooltip-hint-content'> Planting: Level 70 <br /> Stops Dying: Cannot die. </div> </div> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/bonemeal.png' class='w30' /> </div> <div class='tooltip-hint-content'> Bonemeal: 300  </div></div> <div class='tooltip-hint-green'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/xp_arrow.png' class='w30' /> </div> <div class='tooltip-hint-content'> 15,000 XP </div> </div> <div class='tooltip-hint-yellow'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/hourglass.png' class='w30' /> </div> <div class='tooltip-hint-content'> 24 Hours </div> </div>",
    "mega_green_leaf_seeds": "<div class='tooltip-title'> GREEN LEAF SEEDS (MEGA) </div>  <span class='tooltip-description'>Has an extremely high yeild.  The seed is so compact that is weighs over 25 pounds.  They require a lot of bonemeal to plant, and cannot be artifically shinied as they are much too dense.  However, they may become shiny naturally.</span><br /><br /> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/farming.png' class='w30' /> </div> <div class='tooltip-hint-content'> Planting: Level 80 <br /> Stops Dying: Cannot die. </div> </div> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/bonemeal.png' class='w30' /> </div> <div class='tooltip-hint-content'> Bonemeal: 500  </div></div> <div class='tooltip-hint-green'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/xp_arrow.png' class='w30' /> </div> <div class='tooltip-hint-content'> 30,000 XP </div> </div> <div class='tooltip-hint-yellow'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/hourglass.png' class='w30' /> </div> <div class='tooltip-hint-content'> 26 Hours </div> </div>",
    "mega_lime_leaf_seeds": "<div class='tooltip-title'> LIME LEAF SEEDS (MEGA) </div>  <span class='tooltip-description'>Has an extremely high yeild.  The seed is so compact that is weighs over 25 pounds.  They require a lot of bonemeal to plant, and cannot be artifically shinied as they are much too dense.  However, they may become shiny naturally.</span><br /><br /> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/farming.png' class='w30' /> </div> <div class='tooltip-hint-content'> Planting: Level 90 <br /> Stops Dying: Cannot die. </div> </div> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/bonemeal.png' class='w30' /> </div> <div class='tooltip-hint-content'> Bonemeal: 1000  </div></div> <div class='tooltip-hint-green'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/xp_arrow.png' class='w30' /> </div> <div class='tooltip-hint-content'> 39,000 XP </div> </div> <div class='tooltip-hint-yellow'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/hourglass.png' class='w30' /> </div> <div class='tooltip-hint-content'> 30 Hours </div> </div>",
    "mega_gold_leaf_seeds": "<div class='tooltip-title'> GOLD LEAF SEEDS (MEGA) </div>  <span class='tooltip-description'>Has an extremely high yeild.  The seed is so compact that is weighs over 25 pounds.  They require a lot of bonemeal to plant, and cannot be artifically shinied as they are much too dense.  However, they may become shiny naturally.</span><br /><br /> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/farming.png' class='w30' /> </div> <div class='tooltip-hint-content'> Planting: Level 95 <br /> Stops Dying: Cannot die. </div> </div> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/bonemeal.png' class='w30' /> </div> <div class='tooltip-hint-content'> Bonemeal: 1850  </div></div> <div class='tooltip-hint-green'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/xp_arrow.png' class='w30' /> </div> <div class='tooltip-hint-content'> 100,000 XP </div> </div> <div class='tooltip-hint-yellow'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/hourglass.png' class='w30' /> </div> <div class='tooltip-hint-content'> 37 Hours </div> </div>",
    "mega_crystal_leaf_seeds": "<div class='tooltip-title'> CRYSTAL LEAF SEEDS (MEGA) </div>  <span class='tooltip-description'>Has an extremely high yeild.  The seed is so compact that is weighs over 25 pounds.  They require a lot of bonemeal to plant, and cannot be artifically shinied as they are much too dense.  However, they may become shiny naturally.</span><br /><br /> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/farming.png' class='w30' /> </div> <div class='tooltip-hint-content'> Planting: Level 100 <br /> Stops Dying: Cannot die. </div> </div> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/bonemeal.png' class='w30' /> </div> <div class='tooltip-hint-content'> Bonemeal: 3000  </div></div> <div class='tooltip-hint-green'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/xp_arrow.png' class='w30' /> </div> <div class='tooltip-hint-content'> 245,200 XP </div> </div> <div class='tooltip-hint-yellow'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/hourglass.png' class='w30' /> </div> <div class='tooltip-hint-content'> 48 Hours </div> </div>",
    "mega_red_mushroom_seeds": "<div class='tooltip-title'> RED MUSHROOM SEEDS (MEGA) </div>  <span class='tooltip-description'>Has an extremely high yeild.  The seed is so compact that is weighs over 25 pounds.  They require a lot of bonemeal to plant, and cannot be artifically shinied as they are much too dense.  However, they may become shiny naturally.</span><br /><br /> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/farming.png' class='w30' /> </div> <div class='tooltip-hint-content'> Planting: Level 70 <br /> Stops Dying: Cannot die. </div> </div> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/bonemeal.png' class='w30' /> </div> <div class='tooltip-hint-content'> Bonemeal:  150 </div></div> <div class='tooltip-hint-green'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/xp_arrow.png' class='w30' /> </div> <div class='tooltip-hint-content'> 4000 XP </div> </div> <div class='tooltip-hint-yellow'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/hourglass.png' class='w30' /> </div> <div class='tooltip-hint-content'> 15 Hours </div> </div>",
    
    "mega_magic_beans_seeds": "<div class='tooltip-title'> MAGIC BEANS SEEDS (MEGA) </div>  <span class='tooltip-description'>A mega seed!</span><br /><br /> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/farming.png' class='w30' /> </div> <div class='tooltip-hint-content'> Planting: Level 70 <br /> Stops Dying: Cannot die. </div> </div> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/bonemeal.png' class='w30' /> </div> <div class='tooltip-hint-content'> Bonemeal:  1000 </div></div>  <div class='tooltip-hint-yellow'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/hourglass.png' class='w30' /> </div> <div class='tooltip-hint-content'> 24 Hours </div> </div>",
    

     
    "xp_geode": "<span class='color-primary'>XP Geode</span><br /><br />Can be cracked open for additional mining XP.<br /><br /><span class='color-grey'>This geode is obtained by having the dwarf path selected in the criptoe investment system.</span>",

    "stone_geode": "<span class='color-primary'>Stone Geode</span><br /><br />Can be cracked open to find stone.",
    "grey_geode": "<span class='color-primary'>Grey Geode</span><br /><br />Can be cracked open to find ore and minerals.<br /><br /><span class='color-lime'><u>Minerals:</u><br />Blue Marble (common)<br />Amethyst (uncommon)<br />Sea Crystal (Rare)</span><br /><br /><span class='color-grey'>Requires level 20 mining to open.</span>",
    "blue_geode": "<span class='color-primary'>Blue Geode</span><br /><br />Can be cracked open to find ore and minerals.<br /><br /><span class='color-lime'><u>Minerals:</u><br />Dense Marble (common)<br />Fluorite (uncommon)<br />Clear Marble (Rare)</span><br /><br /><span class='color-grey'>Requires level 35 mining to open.</span>",
    "green_geode": "<span class='color-primary'>Green Geode</span><br /><br />Can be cracked open to find ore and minerals.<br /><br /><span class='color-lime'><u>Minerals:</u><br />Jade (common)<br />Lime Quartz (uncommon)<br />Opal (Rare)</span><br /><br /><span class='color-grey'>Requires level 50 mining to open.</span>",
    "red_geode": "<span class='color-primary'>Red Geode</span><br /><br />Can be cracked open to find ore and minerals.<br /><br /><span class='color-lime'><u>Minerals:</u><br />Purple Quartz (common)<br />Amber (uncommon)<br />Smooth Pearl (Rare)</span><br /><br /><span class='color-grey'>Requires level 70 mining to open.</span>",
    "cyan_geode": "<span class='color-primary'>Cyan Geode</span><br /><br />Can be cracked open to find ore and minerals.<br /><br /><span class='color-lime'><u>Minerals:</u><br />Sulfer (common)<br />Topaz (uncommon)<br />Tanzanite (Rare)</span><br /><br /><span class='color-grey'>Requires level 85 mining to open.</span>",
    "ancient_geode": "<span class='color-primary'>Ancient Geode</span><br /><br />Can be cracked open to find ore and minerals.<br /><br /><span class='color-lime'><u>Minerals:</u><br />Magnesium (common)<br />Frozen Mineral (uncommon)<br />Blood Crystal (Rare)</span><br /><br /><span class='color-grey'>Requires level 90 mining to open.</span>",
    
    "teleport_crystal": "<span class='color-primary'>Teleport Crystal</span><br /><br />Can be used to teleport out of combat by clicking your name.  You can also use the shortcut 'T' to activate the crystal.<br /><br />Note that the crystal can only be used every 24h.",
    

    //minerals
    "blue_marble_mineral": "<span class='color-primary'>Blue Marble</span><br /><br />A mineral obtained from a grey geode.  I can either use this for crafting or convert into mining XP.<br /><br /><span class='color-lime'>Can be converted into "+Ores.MINERALS_XP_MAP['blue_marble_mineral']+" mining xp.</span>",
    "amethyst_mineral": "<span class='color-primary'>Amethyst</span><br /><br />A mineral obtained from a grey geode.  I can either use this for crafting or convert into mining XP.<br /><br /><span class='color-lime'>Can be converted into "+Ores.MINERALS_XP_MAP['amethyst_mineral']+" mining xp.</span>",
    "sea_crystal_mineral": "<span class='color-primary'>Sea Crystal</span><br /><br />A mineral obtained from a grey geode.  I can either use this for crafting or convert into mining XP.<br /><br /><span class='color-lime'>Can be converted into "+Ores.MINERALS_XP_MAP['sea_crystal_mineral']+" mining xp.</span>",
    
    "dense_marble_mineral": "<span class='color-primary'>Dense Marble</span><br /><br />A mineral obtained from a blue geode.  I can either use this for crafting or convert into mining XP.<br /><br /><span class='color-lime'>Can be converted into "+Ores.MINERALS_XP_MAP['dense_marble_mineral']+" mining xp.</span>",
    "fluorite_mineral": "<span class='color-primary'>Fluorite</span><br /><br />A mineral obtained from a blue geode.  I can either use this for crafting or convert into mining XP.<br /><br /><span class='color-lime'>Can be converted into "+Ores.MINERALS_XP_MAP['fluorite_mineral']+" mining xp.</span>",
    "clear_marble_mineral": "<span class='color-primary'>Clear Marble</span><br /><br />A mineral obtained from a blue geode.  I can either use this for crafting or convert into mining XP.<br /><br /><span class='color-lime'>Can be converted into "+Ores.MINERALS_XP_MAP['clear_marble_mineral']+" mining xp.</span>",
    
    "jade_mineral": "<span class='color-primary'>Jade</span><br /><br />A mineral obtained from a green geode.  I can either use this for crafting or convert into mining XP.<br /><br /><span class='color-lime'>Can be converted into "+Ores.MINERALS_XP_MAP['jade_mineral']+" mining xp.</span>",
    "lime_quartz_mineral": "<span class='color-primary'>Lime Quartz</span><br /><br />A mineral obtained from a green geode.  I can either use this for crafting or convert into mining XP.<br /><br /><span class='color-lime'>Can be converted into "+Ores.MINERALS_XP_MAP['lime_quartz_mineral']+" mining xp.</span>",
    "opal_mineral": "<span class='color-primary'>Opal</span><br /><br />A mineral obtained from a green geode.  I can either use this for crafting or convert into mining XP.<br /><br /><span class='color-lime'>Can be converted into "+Ores.MINERALS_XP_MAP['opal_mineral']+" mining xp.</span>",
    
    "purple_quartz_mineral": "<span class='color-primary'>Purple Quartz</span><br /><br />A mineral obtained from a red geode.  I can either use this for crafting or convert into mining XP.<br /><br /><span class='color-lime'>Can be converted into "+Ores.MINERALS_XP_MAP['purple_quartz_mineral']+" mining xp.</span>",
    "amber_mineral": "<span class='color-primary'>Amber</span><br /><br />A mineral obtained from a red geode.  I can either use this for crafting or convert into mining XP.<br /><br /><span class='color-lime'>Can be converted into "+Ores.MINERALS_XP_MAP['amber_mineral']+" mining xp.</span>",
    "smooth_pearl_mineral": "<span class='color-primary'>Smooth Pearl</span><br /><br />A mineral obtained from a red geode.  I can either use this for crafting or convert into mining XP.<br /><br /><span class='color-lime'>Can be converted into "+Ores.MINERALS_XP_MAP['smooth_pearl_mineral']+" mining xp.</span>",
    
    "sulfer_mineral": "<span class='color-primary'>Sulfer</span><br /><br />A mineral obtained from a cyan geode.  I can either use this for crafting or convert into mining XP.<br /><br /><span class='color-lime'>Can be converted into "+Ores.MINERALS_XP_MAP['sulfer_mineral']+" mining xp.</span>",
    "topaz_mineral": "<span class='color-primary'>Topaz</span><br /><br />A mineral obtained from a cyan geode.  I can either use this for crafting or convert into mining XP.<br /><br /><span class='color-lime'>Can be converted into "+Ores.MINERALS_XP_MAP['topaz_mineral']+" mining xp.</span>",
    "tanzanite_mineral": "<span class='color-primary'>Tanzanite</span><br /><br />A mineral obtained from a cyan geode.  I can either use this for crafting or convert into mining XP.<br /><br /><span class='color-lime'>Can be converted into "+Ores.MINERALS_XP_MAP['tanzanite_mineral']+" mining xp.</span>",
    
    "magnesium_mineral": "<span class='color-primary'>Magnesium</span><br /><br />A mineral obtained from an ancient geode.  I can either use this for crafting or convert into mining XP.<br /><br /><span class='color-lime'>Can be converted into "+Ores.MINERALS_XP_MAP['magnesium_mineral']+" mining xp.</span>",
    "frozen_mineral": "<span class='color-primary'>Frozen Mineral</span><br /><br />A mineral obtained from an ancient geode.  I can either use this for crafting or convert into mining XP.<br /><br /><span class='color-lime'>Can be converted into "+Ores.MINERALS_XP_MAP['frozen_mineral']+" mining xp.</span>",
    "blood_crystal_mineral": "<span class='color-primary'>Blood Crystal</span><br /><br />A mineral obtained from an ancient geode.  I can either use this for crafting or convert into mining XP.<br /><br /><span class='color-lime'>Can be converted into "+Ores.MINERALS_XP_MAP['blood_crystal_mineral']+" mining xp.</span>",
    

    //rings
    "weak_defence_ring": "<span class='color-primary'>Defence Ring (weak)</span><br /><br />You can wear as many different types of rings as you wish.<br /><br /><span class='color-lime'>Defence: 1</span>",
    "weak_damage_ring": "<span class='color-primary'>Damage Ring (weak)</span><br /><br />You can wear as many different types of rings as you wish.<br /><br /><span class='color-lime'>Melee Damage: 1<br />Arrow Damage: 1</span>",
    "weak_accuracy_ring": "<span class='color-primary'>Accuracy Ring (weak)</span><br /><br />You can wear as many different types of rings as you wish.<br /><br /><span class='color-lime'>Accuracy: 1</span>",
    "defence_ring": "<span class='color-primary'>Defence Ring (normal)</span><br /><br />You can wear as many different types of rings as you wish.<br /><br /><span class='color-lime'>Defence: 2</span>",
    "damage_ring": "<span class='color-primary'>Damage Ring (normal)</span><br /><br />You can wear as many different types of rings as you wish.<br /><br /><span class='color-lime'>Melee Damage: 2<br />Arrow Damage: 2</span>",
    "accuracy_ring": "<span class='color-primary'>Accuracy Ring (normal)</span><br /><br />You can wear as many different types of rings as you wish.<br /><br /><span class='color-lime'>Accuracy: 2</span>",
    "good_defence_ring": "<span class='color-primary'>Defence Ring (good)</span><br /><br />You can wear as many different types of rings as you wish.<br /><br /><span class='color-lime'>Defence: 3</span>",
    "good_damage_ring": "<span class='color-primary'>Damage Ring (good)</span><br /><br />You can wear as many different types of rings as you wish.<br /><br /><span class='color-lime'>Melee Damage: 3<br />Arrow Damage: 3</span>",
    "good_accuracy_ring": "<span class='color-primary'>Accuracy Ring (good)</span><br /><br />You can wear as many different types of rings as you wish.<br /><br /><span class='color-lime'>Accuracy: 3</span>",
    "great_defence_ring": "<span class='color-primary'>Defence Ring (great)</span><br /><br />You can wear as many different types of rings as you wish.<br /><br /><span class='color-lime'>Defence: 4</span>",
    "great_damage_ring": "<span class='color-primary'>Damage Ring (great)</span><br /><br />You can wear as many different types of rings as you wish.<br /><br /><span class='color-lime'>Melee Damage: 4<br />Arrow Damage: 4</span>",
    "great_accuracy_ring": "<span class='color-primary'>Accuracy Ring (great)</span><br /><br />You can wear as many different types of rings as you wish.<br /><br /><span class='color-lime'>Accuracy: 4</span>",
    "perfect_defence_ring": "<span class='color-primary'>Defence Ring (perfect)</span><br /><br />You can wear as many different types of rings as you wish.<br /><br /><span class='color-lime'>Defence: 5</span>",
    "perfect_damage_ring": "<span class='color-primary'>Damage Ring (perfect)</span><br /><br />You can wear as many different types of rings as you wish.<br /><br /><span class='color-lime'>Melee Damage: 5<br />Arrow Damage: 5</span>",
    "perfect_accuracy_ring": "<span class='color-primary'>Accuracy Ring (perfect)</span><br /><br />You can wear as many different types of rings as you wish.<br /><br /><span class='color-lime'>Accuracy: 5</span>",
    "ancient_defence_ring": "<span class='color-primary'>Defence Ring (ancient)</span><br /><br />You can wear as many different types of rings as you wish.<br /><br /><span class='color-lime'>Defence: 6</span>",
    "ancient_damage_ring": "<span class='color-primary'>Damage Ring (ancient)</span><br /><br />You can wear as many different types of rings as you wish.<br /><br /><span class='color-lime'>Melee Damage: 6<br />Arrow Damage: 6</span>",
    "ancient_accuracy_ring": "<span class='color-primary'>Accuracy Ring (ancient)</span><br /><br />You can wear as many different types of rings as you wish.<br /><br /><span class='color-lime'>Accuracy: 6</span>",
    "master_ring": "<span class='color-primary'>Master Ring (best)</span><br /><br /><span class='color-lime'>Defence: 25</span><br /><span class='color-lime'>Melee Damage: 25</span><br /><span class='color-lime'>Arrow Damage: 25</span><br /><span class='color-lime'>Accuracy: 25</span><br /><br /><span class='color-orange'>Fight points regenerate twice as fast.</span>",
    
    "peekaboo_ring": "<span class='color-primary'>Peekaboo Ring</span><br /><br />Allows you to see if you or your enemy fails to hit through armour.<br /><br /><span class='color-grey'>\"This ring was also used by a hero named Mario.  It's quite ugly though, it looks like paper.\"</span>",
    "ring_of_light": "<span class='color-primary'>Ring of Light</span><br /><br />Provides a light source.",
    "magic_ring": "<span class='color-primary'>Magic Ring</span><br /><br />+10 Magic bonus",
    "castle_key": "<span class='color-primary'>Dungeon Castle Key (Floor 1)</span><br /><br />A key found within Faradox's castle.",
    "castle_key_floor2": "<span class='color-primary'>Frozen Dungeon Castle Key (Floor 2)</span><br /><br />A key found within Faradox's castle.",
    "castle_key_floor3": "<span class='color-primary'>Hot Dungeon Castle Key (Floor 3)</span><br /><br />A key found within Faradox's castle.",
    
    "undead_staff": "<span class='color-primary'>Undead Staff (Uncharged)</span><br /><br />Can be charged using a spirit looted from the <i>Mansion of the Undead Raids</i></span><br /><br /><span class='color-lime'>Magic: 5</span>",
    "undead_hp_staff": "<span class='color-primary'>Undead Staff (Charged)</span><br /><br />Can be charged using a spirit looted from the <i>Mansion of the Undead Raids</i></span><br /><br /><img src='https://cdn.idle-pixel.com/images/hp_staff_spirit.png' class='w15' /><span class='color-cyan'>Casting your first spell in combat will heal you for 10 HP and allow you to heal over your maximum HP.</span><br /><br /><span class='color-lime'>Magic: 5</span><br /><br /><i class='color-grey'>I can remove the orb from the staff and get it back by speaking to the ghost miner from quests.</i>",
    "undead_mana_staff": "<span class='color-primary'>Undead Staff (Charged)</span><br /><br />Can be charged using a spirit looted from the <i>Mansion of the Undead Raids</i></span><br /><br /><img src='https://cdn.idle-pixel.com/images/mana_staff_spirit.png' class='w15' /><span class='color-cyan'>Casting your first spell in combat will increase your maximum mana by 10 during the fight.</span><br /><br /><span class='color-lime'>Magic: 5</span><br /><br /><i class='color-grey'>I can remove the orb from the staff and get it back by speaking to the ghost miner from quests.</i>",
    "undead_defence_staff": "<span class='color-primary'>Undead Staff (Charged)</span><br /><br />Can be charged using a spirit looted from the <i>Mansion of the Undead Raids</i></span><br /><br /><img src='https://cdn.idle-pixel.com/images/defence_staff_spirit.png' class='w15' /><span class='color-cyan'>Casting your first spell in combat will increase your maximum mana by 10 during the fight.</span><br /><br /><span class='color-lime'>Magic: 5</span><br /><br /><i class='color-grey'>I can remove the orb from the staff and get it back by speaking to the ghost miner from quests.</i>",
    "undead_full_staff": "<span class='color-primary'>Undead Staff (Full Charge)</span><br /><br />Can be charged using a spirit looted from the <i>Mansion of the Undead Raids</i></span><br /><br /><img src='https://cdn.idle-pixel.com/images/hp_staff_spirit.png' class='w15' /><span class='color-cyan'>Casting your first spell in combat will heal you for 10 HP and allow you to heal over your maximum HP.</span><br /><img src='https://cdn.idle-pixel.com/images/mana_staff_spirit.png' class='w15' /><span class='color-cyan'>Casting your first spell in combat will increase your maximum mana by 10 during the fight.</span><br /><img src='https://cdn.idle-pixel.com/images/defence_staff_spirit.png' class='w15' /><span class='color-cyan'>Casting your first spell in combat will decrease the monster's defence by 10.</span><br /><br /><span class='color-lime'>Magic: 10</span><br /><br /><i class='color-grey'>I can remove the orb from the staff and get it back by speaking to the ghost miner from quests.</i>",
    

    "tree_seeds": "<div class='tooltip-title'> TREE SEEDS <br /> <span class='tooltip-rarity'><img style='padding-top:-4px' src='https://cdn.idle-pixel.com/images/rarity_icon_common.png' class='w15'> Common</span> </div> <br /> <span class='tooltip-description'> Tree seeds are mostly obtained by chopping trees using the woodcutting skill.  You have a 10% chance of getting a seed from chopping trees given you have the easy woodcutting achievements completed. <br /> <br /> <span class='color-lime'>Tree seeds require more bonemeal and has a high grow time but yields massive farming XP.</span> </span> <br /> <br /> <span class='color-cyan'><b>Type: </b>Tree seed</span></span> <br /> <br /> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/farming.png' class='w30' /> </div> <div class='tooltip-hint-content'> Planting: Level 10 <img class='w15' id='tooltip-plant-level-img-tree_seeds' /><br /> Stops Dying: Level 25. <img class='w15' id='tooltip-plant-level-img-tree_seeds_death' /> </div> </div> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/bonemeal.png' class='w30' /> </div> <div class='tooltip-hint-content'> Bonemeal: 10  <img class='w15' id='tooltip-plant-level-img-tree_seeds_bonemeal' /> </div> </div> <div class='tooltip-hint-green'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/xp_arrow.png' class='w30' /> </div> <div class='tooltip-hint-content'> 3000 XP </div> </div> <div class='tooltip-hint-yellow'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/hourglass.png' class='w30' /> </div> <div class='tooltip-hint-content'> 2 Hours </div> </div>",
    "oak_tree_seeds": "<div class='tooltip-title'> OAK TREE SEEDS <br /> <span class='tooltip-rarity'><img style='padding-top:-4px' src='https://cdn.idle-pixel.com/images/rarity_icon_uncommon.png' class='w15'> Uncommon</span> </div> <br /> <span class='tooltip-description'> Tree seeds are mostly obtained by chopping trees using the woodcutting skill.  You have a 10% chance of getting a seed from chopping trees given you have the easy woodcutting achievements completed. <br /> <br /> <span class='color-lime'>Tree seeds require more bonemeal and has a high grow time but yields massive farming XP.</span> </span> <br /> <br /> <span class='color-cyan'><b>Type: </b>Tree seed</span></span> <br /> <br /> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/farming.png' class='w30' /> </div> <div class='tooltip-hint-content'> Planting: Level 25 <img class='w15' id='tooltip-plant-level-img-oak_tree_seeds' /><br /> Stops Dying: Level 40. <img class='w15' id='tooltip-plant-level-img-oak_tree_seeds_death' /> </div> </div> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/bonemeal.png' class='w30' /> </div> <div class='tooltip-hint-content'> Bonemeal: 25  <img class='w15' id='tooltip-plant-level-img-oak_tree_seeds_bonemeal' /> </div> </div> <div class='tooltip-hint-green'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/xp_arrow.png' class='w30' /> </div> <div class='tooltip-hint-content'> 10,000 XP </div> </div> <div class='tooltip-hint-yellow'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/hourglass.png' class='w30' /> </div> <div class='tooltip-hint-content'> 4 Hours </div> </div>",
    "willow_tree_seeds": "<div class='tooltip-title'> WILLOW TREE SEEDS <br /> <span class='tooltip-rarity'><img style='padding-top:-4px' src='https://cdn.idle-pixel.com/images/rarity_icon_uncommon.png' class='w15'> Uncommon</span> </div> <br /> <span class='tooltip-description'> Tree seeds are mostly obtained by chopping trees using the woodcutting skill.  You have a 10% chance of getting a seed from chopping trees given you have the easy woodcutting achievements completed. <br /> <br /> <span class='color-lime'>Tree seeds require more bonemeal and has a high grow time but yields massive farming XP.</span> </span> <br /> <br /> <span class='color-cyan'><b>Type: </b>Tree seed</span></span> <br /> <br /> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/farming.png' class='w30' /> </div> <div class='tooltip-hint-content'> Planting: Level 37 <img class='w15' id='tooltip-plant-level-img-willow_tree_seeds' /><br /> Stops Dying: Level 55. <img class='w15' id='tooltip-plant-level-img-willow_tree_seeds_death' /> </div> </div> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/bonemeal.png' class='w30' /> </div> <div class='tooltip-hint-content'> Bonemeal: 50  <img class='w15' id='tooltip-plant-level-img-willow_tree_seeds_bonemeal' /> </div> </div> <div class='tooltip-hint-green'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/xp_arrow.png' class='w30' /> </div> <div class='tooltip-hint-content'> 20,000 XP </div> </div> <div class='tooltip-hint-yellow'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/hourglass.png' class='w30' /> </div> <div class='tooltip-hint-content'> 8 Hours </div> </div>",
    "maple_tree_seeds": "<div class='tooltip-title'> MAPLE TREE SEEDS <br /> <span class='tooltip-rarity'><img style='padding-top:-4px' src='https://cdn.idle-pixel.com/images/rarity_icon_rare.png' class='w15'> Rare</span> </div> <br /> <span class='tooltip-description'> Tree seeds are mostly obtained by chopping trees using the woodcutting skill.  You have a 10% chance of getting a seed from chopping trees given you have the easy woodcutting achievements completed. <br /> <br /> <span class='color-lime'>Tree seeds require more bonemeal and has a high grow time but yields massive farming XP.</span> </span> <br /> <br /> <span class='color-cyan'><b>Type: </b>Tree seed</span></span> <br /> <br /> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/farming.png' class='w30' /> </div> <div class='tooltip-hint-content'> Planting: Level 50 <img class='w15' id='tooltip-plant-level-img-maple_tree_seeds' /><br /> Stops Dying: Level 65. <img class='w15' id='tooltip-plant-level-img-maple_tree_seeds_death' /> </div> </div> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/bonemeal.png' class='w30' /> </div> <div class='tooltip-hint-content'> Bonemeal: 120  <img class='w15' id='tooltip-plant-level-img-maple_tree_seeds_bonemeal' /> </div> </div> <div class='tooltip-hint-green'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/xp_arrow.png' class='w30' /> </div> <div class='tooltip-hint-content'> 45,000 XP </div> </div> <div class='tooltip-hint-yellow'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/hourglass.png' class='w30' /> </div> <div class='tooltip-hint-content'> 12 Hours </div> </div>",
    "stardust_tree_seeds": "<div class='tooltip-title'> STARDUST TREE SEEDS <br /> <span class='tooltip-rarity'><img style='padding-top:-4px' src='https://cdn.idle-pixel.com/images/rarity_icon_veryrare.png' class='w15'> Very Rare</span> </div> <br /> <span class='tooltip-description'> Tree seeds are mostly obtained by chopping trees using the woodcutting skill.  You have a 10% chance of getting a seed from chopping trees given you have the easy woodcutting achievements completed. <br /> <br /> <span class='color-lime'>Tree seeds require more bonemeal and has a high grow time but yields massive farming XP.</span> </span> <br /> <br /> <span class='color-cyan'><b>Type: </b>Tree seed</span></span> <br /> <br /> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/farming.png' class='w30' /> </div> <div class='tooltip-hint-content'> Planting: Level 65 <img class='w15' id='tooltip-plant-level-img-stardust_tree_seeds' /><br /> Stops Dying: Level 80. <img class='w15' id='tooltip-plant-level-img-stardust_tree_seeds_death' /> </div> </div> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/bonemeal.png' class='w30' /> </div> <div class='tooltip-hint-content'> Bonemeal: 150  <img class='w15' id='tooltip-plant-level-img-stardust_tree_seeds_bonemeal' /> </div> </div> <div class='tooltip-hint-green'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/xp_arrow.png' class='w30' /> </div> <div class='tooltip-hint-content'> 70,000 XP </div> </div> <div class='tooltip-hint-yellow'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/hourglass.png' class='w30' /> </div> <div class='tooltip-hint-content'> 15 Hours </div> </div>",
    "pine_tree_seeds": "<div class='tooltip-title'> PINE TREE SEEDS <br /> <span class='tooltip-rarity'><img style='padding-top:-4px' src='https://cdn.idle-pixel.com/images/rarity_icon_veryrare.png' class='w15'> Very Rare</span> </div> <br /> <span class='tooltip-description'> Tree seeds are mostly obtained by chopping trees using the woodcutting skill.  You have a 10% chance of getting a seed from chopping trees given you have the easy woodcutting achievements completed. <br /> <br /> <span class='color-lime'>Tree seeds require more bonemeal and has a high grow time but yields massive farming XP.</span> </span> <br /> <br /> <span class='color-cyan'><b>Type: </b>Tree seed</span></span> <br /> <br /> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/farming.png' class='w30' /> </div> <div class='tooltip-hint-content'> Planting: Level 70 <img class='w15' id='tooltip-plant-level-img-pine_tree_seeds' /><br /> Stops Dying: Level 85. <img class='w15' id='tooltip-plant-level-img-pine_tree_seeds_death' /> </div> </div> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/bonemeal.png' class='w30' /> </div> <div class='tooltip-hint-content'> Bonemeal: 180  <img class='w15' id='tooltip-plant-level-img-pine_tree_seeds_bonemeal' /> </div> </div> <div class='tooltip-hint-green'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/xp_arrow.png' class='w30' /> </div> <div class='tooltip-hint-content'> 90,000 XP </div> </div> <div class='tooltip-hint-yellow'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/hourglass.png' class='w30' /> </div> <div class='tooltip-hint-content'> 17 Hours </div> </div>",
    "redwood_tree_seeds": "<div class='tooltip-title'> REDWOOD TREE SEEDS <br /> <span class='tooltip-rarity'><img style='padding-top:-4px' src='https://cdn.idle-pixel.com/images/rarity_icon_veryrare.png' class='w15'> Very Rare</span> </div> <br /> <span class='tooltip-description'> Tree seeds are mostly obtained by chopping trees using the woodcutting skill.  You have a 10% chance of getting a seed from chopping trees given you have the easy woodcutting achievements completed. <br /> <br /> <span class='color-lime'>Tree seeds require more bonemeal and has a high grow time but yields massive farming XP.</span> </span> <br /> <br /> <span class='color-cyan'><b>Type: </b>Tree seed</span></span> <br /> <br /> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/farming.png' class='w30' /> </div> <div class='tooltip-hint-content'> Planting: Level 80 <img class='w15' id='tooltip-plant-level-img-redwood_tree_seeds' /><br /> Stops Dying: Level 92. <img class='w15' id='tooltip-plant-level-img-redwood_tree_seeds_death' /> </div> </div> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/bonemeal.png' class='w30' /> </div> <div class='tooltip-hint-content'> Bonemeal: 300  <img class='w15' id='tooltip-plant-level-img-redwood_tree_seeds_bonemeal' /> </div> </div> <div class='tooltip-hint-green'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/xp_arrow.png' class='w30' /> </div> <div class='tooltip-hint-content'> 150,000 XP </div> </div> <div class='tooltip-hint-yellow'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/hourglass.png' class='w30' /> </div> <div class='tooltip-hint-content'> 22 Hours </div> </div>",
    
    "apple_tree_seeds": "<div class='tooltip-title'> APPLE TREE SEEDS <br /> <span class='tooltip-rarity'><img style='padding-top:-4px' src='https://cdn.idle-pixel.com/images/rarity_icon_uncommon.png' class='w15'> Uncommon</span> </div> <br /> <span class='tooltip-description'> Fruit tree seeds are mostly obtained by chopping trees using the woodcutting skill.  You have a 10% chance of getting a seed from chopping trees given you have the medium woodcutting achievements completed. <br /> <br /> <span class='color-lime'>Fruit tree seeds require more bonemeal and has a high grow time but yields massive farming XP and give fruit for more energy.</span> </span> <br /> <br /> <span class='color-cyan'><b>Type: </b>Fruit tree seed</span></span> <br /> <br /> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/farming.png' class='w30' /> </div> <div class='tooltip-hint-content'> Planting: Level 40 <img class='w15' id='tooltip-plant-level-img-apple_tree_seeds' /><br /> Stops Dying: Level 55. <img class='w15' id='tooltip-plant-level-img-apple_tree_seeds_death' /> </div> </div> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/bonemeal.png' class='w30' /> </div> <div class='tooltip-hint-content'> Bonemeal: 50  <img class='w15' id='tooltip-plant-level-img-apple_tree_seeds_bonemeal' /> </div> </div> <div class='tooltip-hint-green'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/xp_arrow.png' class='w30' /> </div> <div class='tooltip-hint-content'> 20,000 XP </div> </div> <div class='tooltip-hint-yellow'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/hourglass.png' class='w30' /> </div> <div class='tooltip-hint-content'> 8 Hours </div> </div>",
    "banana_tree_seeds": "<div class='tooltip-title'> BANANA TREE SEEDS <br /> <span class='tooltip-rarity'><img style='padding-top:-4px' src='https://cdn.idle-pixel.com/images/rarity_icon_uncommon.png' class='w15'> Uncommon</span> </div> <br /> <span class='tooltip-description'> Fruit tree seeds are mostly obtained by chopping trees using the woodcutting skill.  You have a 10% chance of getting a seed from chopping trees given you have the medium woodcutting achievements completed. <br /> <br /> <span class='color-lime'>Fruit tree seeds require more bonemeal and has a high grow time but yields massive farming XP and give fruit for more energy.</span> </span> <br /> <br /> <span class='color-cyan'><b>Type: </b>Fruit tree seed</span></span> <br /> <br /> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/farming.png' class='w30' /> </div> <div class='tooltip-hint-content'> Planting: Level 57 <img class='w15' id='tooltip-plant-level-img-banana_tree_seeds' /><br /> Stops Dying: Level 62. <img class='w15' id='tooltip-plant-level-img-banana_tree_seeds_death' /> </div> </div> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/bonemeal.png' class='w30' /> </div> <div class='tooltip-hint-content'> Bonemeal: 70  <img class='w15' id='tooltip-plant-level-img-banana_tree_seeds_bonemeal' /> </div> </div> <div class='tooltip-hint-green'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/xp_arrow.png' class='w30' /> </div> <div class='tooltip-hint-content'> 47,800 XP </div> </div> <div class='tooltip-hint-yellow'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/hourglass.png' class='w30' /> </div> <div class='tooltip-hint-content'> 11 Hours </div> </div>",
    "orange_tree_seeds": "<div class='tooltip-title'> ORANGE TREE SEEDS <br /> <span class='tooltip-rarity'><img style='padding-top:-4px' src='https://cdn.idle-pixel.com/images/rarity_icon_rare.png' class='w15'> Rare</span> </div> <br /> <span class='tooltip-description'> Fruit tree seeds are mostly obtained by chopping trees using the woodcutting skill.  You have a 10% chance of getting a seed from chopping trees given you have the medium woodcutting achievements completed. <br /> <br /> <span class='color-lime'>Fruit tree seeds require more bonemeal and has a high grow time but yields massive farming XP and give fruit for more energy.</span> </span> <br /> <br /> <span class='color-cyan'><b>Type: </b>Fruit tree seed</span></span> <br /> <br /> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/farming.png' class='w30' /> </div> <div class='tooltip-hint-content'> Planting: Level 66 <img class='w15' id='tooltip-plant-level-img-orange_tree_seeds' /><br /> Stops Dying: Level 70. <img class='w15' id='tooltip-plant-level-img-orange_tree_seeds_death' /> </div> </div> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/bonemeal.png' class='w30' /> </div> <div class='tooltip-hint-content'> Bonemeal: 120  <img class='w15' id='tooltip-plant-level-img-orange_tree_seeds_bonemeal' /> </div> </div> <div class='tooltip-hint-green'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/xp_arrow.png' class='w30' /> </div> <div class='tooltip-hint-content'> 72,850 XP </div> </div> <div class='tooltip-hint-yellow'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/hourglass.png' class='w30' /> </div> <div class='tooltip-hint-content'> 15 Hours </div> </div>",
    "palm_tree_seeds": "<div class='tooltip-title'> PALM TREE SEEDS <br /> <span class='tooltip-rarity'><img style='padding-top:-4px' src='https://cdn.idle-pixel.com/images/rarity_icon_veryrare.png' class='w15'> Very Rare</span> </div> <br /> <span class='tooltip-description'> Fruit tree seeds are mostly obtained by chopping trees using the woodcutting skill.  You have a 10% chance of getting a seed from chopping trees given you have the medium woodcutting achievements completed. <br /> <br /> <span class='color-lime'>Fruit tree seeds require more bonemeal and has a high grow time but yields massive farming XP and give fruit for more energy.</span> </span> <br /> <br /> <span class='color-cyan'><b>Type: </b>Fruit tree seed</span></span> <br /> <br /> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/farming.png' class='w30' /> </div> <div class='tooltip-hint-content'> Planting: Level 82 <img class='w15' id='tooltip-plant-level-img-palm_tree_seeds' /><br /> Stops Dying: Level 90. <img class='w15' id='tooltip-plant-level-img-palm_tree_seeds_death' /> </div> </div> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/bonemeal.png' class='w30' /> </div> <div class='tooltip-hint-content'> Bonemeal: 200  <img class='w15' id='tooltip-plant-level-img-palm_tree_seeds_bonemeal' /> </div> </div> <div class='tooltip-hint-green'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/xp_arrow.png' class='w30' /> </div> <div class='tooltip-hint-content'> 100,000 XP </div> </div> <div class='tooltip-hint-yellow'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/hourglass.png' class='w30' /> </div> <div class='tooltip-hint-content'> 19 Hours </div> </div>",
    "dragon_fruit_tree_seeds": "<div class='tooltip-title'> DRAGON FRUIT TREE SEEDS <br /> <span class='tooltip-rarity'><img style='padding-top:-4px' src='https://cdn.idle-pixel.com/images/rarity_icon_megarare.png' class='w15'> Mega Rare</span> </div> <br /> <span class='tooltip-description'> Fruit tree seeds are mostly obtained by chopping trees using the woodcutting skill.  You have a 10% chance of getting a seed from chopping trees given you have the medium woodcutting achievements completed. <br /> <br /> <span class='color-lime'>Fruit tree seeds require more bonemeal and has a high grow time but yields massive farming XP and give fruit for more energy.</span> </span> <br /> <br /> <span class='color-cyan'><b>Type: </b>Fruit tree seed</span></span> <br /> <br /> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/farming.png' class='w30' /> </div> <div class='tooltip-hint-content'> Planting: Level 90 <img class='w15' id='tooltip-plant-level-img-dragon_fruit_tree_seeds' /><br /> Stops Dying: Level 100. <img class='w15' id='tooltip-plant-level-img-dragon_fruit_tree_seeds_death' /> </div> </div> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/bonemeal.png' class='w30' /> </div> <div class='tooltip-hint-content'> Bonemeal: 500  <img class='w15' id='tooltip-plant-level-img-dragon_fruit_tree_seeds_bonemeal' /> </div> </div> <div class='tooltip-hint-green'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/xp_arrow.png' class='w30' /> </div> <div class='tooltip-hint-content'> 400,000 XP </div> </div> <div class='tooltip-hint-yellow'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/hourglass.png' class='w30' /> </div> <div class='tooltip-hint-content'> 24 Hours </div> </div>",
    
    "bone_tree_seeds": "<span class='color-primary'>Bone Tree Seeds (Special tree)</span><br /><br />A seed obtained from woodcutting.  Yields high XP but takes a long time to grow.<br /><br /><span class='color-lime'><span class='color-orange'>Level: 80</span> <span class='color-grey'>(Stops Dying: 88)</span><br /><span class='color-orange'>Farming XP: 200,000</span><br />Growtime: 18 hours<br />Bonemeal Required: 0</span></span>",
    "lava_tree_seeds": "<span class='color-primary'>Lava Tree Seeds (Special tree)</span><br /><br />A seed obtained from woodcutting.  Yields high XP but takes a long time to grow.<br /><br /><span class='color-lime'><span class='color-orange'>Level: 91</span> <span class='color-grey'>(Stops Dying: 97)</span><br /><span class='color-orange'>Farming XP: 264,000</span><br />Growtime: 23 hours<br />Bonemeal Required: 300</span></span>",
    "strange_tree_seeds": "<span class='color-primary'>Strange Tree Seeds (Special tree)</span><br /><br />A seed obtained from woodcutting.  Yields high XP but takes a long time to grow.<br /><br /><span class='color-lime'><span class='color-orange'>Level: 92</span> <span class='color-grey'>(Stops Dying: 100)</span><br /><span class='color-orange'>Farming XP: 425,145</span><br />Growtime: 26 hours<br />Bonemeal Required: 500</span></span>",

    "potato_seeds": "<span class='color-primary'>Potato Seeds (Elite Farming Achievements)</span><br /><br />A seed obtained from a trowel.  A great source for quick energy.<br /><br /><span class='color-lime'><span class='color-orange'>Level: 60</span><br /><span class='color-orange'>Farming XP: 2142</span><br />Growtime: 30 min<br />Bonemeal Required: 50</span></span><br /><br /><span class='color-grey'>Vegetable seeds have a chance to give seeds back on harvest.</span>",
    "carrot_seeds": "<span class='color-primary'>Carrot Seeds (Elite Farming Achievements)</span><br /><br />A seed obtained from a trowel.  A great source for quick energy.<br /><br /><span class='color-lime'><span class='color-orange'>Level: 70</span><br /><span class='color-orange'>Farming XP: 3518</span><br />Growtime: 45 min<br />Bonemeal Required: 100</span></span><br /><br /><span class='color-grey'>Vegetable seeds have a chance to give seeds back on harvest.</span>",
    "beet_seeds": "<span class='color-primary'>Beet Seeds (Elite Farming Achievements)</span><br /><br />A seed obtained from a trowel.  A great source for quick energy.<br /><br /><span class='color-lime'><span class='color-orange'>Level: 80</span><br /><span class='color-orange'>Farming XP: 5152</span><br />Growtime: 1 hour<br />Bonemeal Required: 220</span></span><br /><br /><span class='color-grey'>Vegetable seeds have a chance to give seeds back on harvest.</span>",
    "broccoli_seeds": "<span class='color-primary'>Broccoli Seeds (Elite Farming Achievements)</span><br /><br />A seed obtained from a trowel.  A great source for quick energy.<br /><br /><span class='color-lime'><span class='color-orange'>Level: 90</span><br /><span class='color-orange'>Farming XP: 8758</span><br />Growtime: 2 hours<br />Bonemeal Required: 300</span></span><br /><br /><span class='color-grey'>Vegetable seeds have a chance to give seeds back on harvest.</span>",

    "mixed_seeds": "<span class='color-primary'>Mixed Seeds</span><br /><br />A bunch of seeds.  It's hard to know what will grow.  It requires some bonemeal to plant, hope it will be worth it.<br /><br /><span class='color-lime'><span class='color-orange'>Level: 50</span><br /><span class='color-orange'>Farming XP: Varies</span><br />Growtime: 3 hours<br />Bonemeal Required: 50</span></span>",

    "poppy_flower_seeds": "<span class='color-primary'>Poppy Flower Seeds</span><br /><br />A seed obtained from a birdhouse.<br /><br /><span class='color-lime'><span class='color-orange'>Level: 50</span><br /><span class='color-orange'>Farming XP: 500</span><br />Growtime: 1 hour</span></span><br /><br /><span class='color-grey'>Flowers can be used with a beehive to collect honey, and earn some extra brewing XP.</span>",
    "rose_flower_seeds": "<span class='color-primary'>Rose Flower Seeds</span><br /><br />A seed obtained from a birdhouse.<br /><br /><span class='color-lime'><span class='color-orange'>Level: 60</span><br /><span class='color-orange'>Farming XP: 1000</span><br />Growtime: 1 hour</span></span><br /><br /><span class='color-grey'>Flowers can be used with a beehive to collect honey, and earn some extra brewing XP.</span>",
    "tulip_flower_seeds": "<span class='color-primary'>Tulip Flower Seeds</span><br /><br />A seed obtained from a birdhouse.<br /><br /><span class='color-lime'><span class='color-orange'>Level: 70</span><br /><span class='color-orange'>Farming XP: 2500</span><br />Growtime: 1 hour</span></span><br /><br /><span class='color-grey'>Flowers can be used with a beehive to collect honey, and earn some extra brewing XP.</span>",

    "birdhouse": "<span class='color-primary'>Birdhouse</span><br /><br />Click to setup.",
    "beehive": "<span class='color-primary'>Beehive</span><br /><br />Click to setup.",

    "flower": "<span class='color-primary'>Flower</span><br /><br />Can be used with a beehive to attract bees.",

    "beehive_potion": "<span class='color-primary'>Beehive Potion</span><br /><br />You can feel heat when touching the glass from this potion.<br /><br />Drink it to gain brewing experience and some honey.",


    "stardust_seeds": "<div class='tooltip-title'> STARDUST SEEDS <br /> <span class='tooltip-rarity'><img style='padding-top:-4px' src='https://cdn.idle-pixel.com/images/rarity_icon_common.png' class='w15'> Common</span> </div> <br /> <span class='tooltip-description'>A common seed which yields stardust.  This is very useful if you need stardust to level other skills, such as mining or crafting.</span> <br /> <br /> <span class='color-cyan'><b>Type: </b>Misc Seed</span></span> <br /> <span class='color-green'><b>Rarity: </b> <span id='tooltip-stardust_seeds_rarity'>1/21,600</span></span> <br /> <span class='color-orange'><b>Found: </b> <span id='tooltip-stardust_seeds_total'>0</span></span> <br /> <br /> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/farming.png' class='w30' /> </div> <div class='tooltip-hint-content'> Planting: Level 1 <img class='w15' id='tooltip-plant-level-img-stardust_seeds' /><br /> Stops Dying: Cannot die <img class='w15' id='tooltip-plant-level-img-stardust_seeds_death' /> </div> </div> <div class='tooltip-hint-green'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/xp_arrow.png' class='w30' /> </div> <div class='tooltip-hint-content'> 222 XP </div> </div> <div class='tooltip-hint-yellow'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/hourglass.png' class='w30' /> </div> <div class='tooltip-hint-content'> 20 Minutes </div> </div>",
    
    "red_mushroom_seeds": "<div class='tooltip-title'> RED MUSHROOM SEEDS <br /> <span class='tooltip-rarity'><img style='padding-top:-4px' src='https://cdn.idle-pixel.com/images/rarity_icon_very_common.png' class='w15'> Very Common</span> </div> <br /> <span class='tooltip-description'>A very common seed which yields a secondary ingredient for brewing potions.</span> <br /> <br /> <span class='color-cyan'><b>Type: </b>Secondary seed</span></span> <br /> <span class='color-green'><b>Rarity: </b> <span id='tooltip-red_mushroom_seeds_rarity'>1/21,600</span></span> <br /> <span class='color-orange'><b>Found: </b> <span id='tooltip-red_mushroom_seeds_total'>0</span></span> <br /> <br /> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/farming.png' class='w30' /> </div> <div class='tooltip-hint-content'> Planting: Level 1 <img class='w15' id='tooltip-plant-level-img-red_mushroom_seeds' /><br /> Stops Dying: Cannot die <img class='w15' id='tooltip-plant-level-img-red_mushroom_seeds_death' /> </div> </div> <div class='tooltip-hint-green'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/xp_arrow.png' class='w30' /> </div> <div class='tooltip-hint-content'> 40 XP </div> </div> <div class='tooltip-hint-yellow'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/hourglass.png' class='w30' /> </div> <div class='tooltip-hint-content'> 5 Minutes </div> </div>",
    "eggplant_seeds": "<span class='color-primary'>Eggplant Seeds</span><br /><br />I need to grow this for a quest.<br /><br /><span class='color-lime'><span class='color-orange'>Level: 1</span><br /><span class='color-orange'>Farming XP: 100</span><br />Growtime: 5:00</span>",
   
    "menu-bar-stardust": "Can be used to convert items into XP for certain skills.<br /><br /><span class='color-grey'>Works on ores and bars.</span>",

    "eggplant": "<span class='color-primary'>Eggplant</span><br /><br />An eggplant grown for the stardust expert.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='w20' /> <span class='color-lime'>100 energy</span>",

    "bonemeal_bin": "<span class='color-primary'>Bonemeal Bin</span><br /><br />Click bones to convert to bonemeal and store them in here.<br /><br />High level seeds require bonemeal to be planted.",
    
    "brewing_xp_mixer": "<span class='color-primary'>Brewing XP Mixer</span><br /><br />After being enchanted, the brewing XP mixer will have magical powers for you to gain additional XP after drinking a potion.<br /><br /><span class='color-lime'>Click for details</span>",

    "dotted_green_leaf": "<span class='color-primary'>Primary Ingredient</span><br /><br />A primary ingredient for brewing potions.",
    "green_leaf": "<span class='color-primary'>Primary Ingredient</span><br /><br />A primary ingredient for brewing potions.",
    "lime_leaf": "<span class='color-primary'>Primary Ingredient</span><br /><br />A primary ingredient for brewing potions.",
    "gold_leaf": "<span class='color-primary'>Primary Ingredient</span><br /><br />A primary ingredient for brewing potions.",
    "crystal_leaf": "<span class='color-primary'>Primary Ingredient</span><br /><br />A primary ingredient for brewing potions.",
    "white_leaf": "<span class='color-primary'>Primary Ingredient</span><br /><br />A primary ingredient for brewing potions.  Sadly I cannot keep this as I'm helping out for a quest.",
    
    "red_mushroom": "<span class='color-primary'>Secondary Ingredient</span><br /><br />A secondary ingredient for brewing potions.",
    "strange_leaf": "<span class='color-primary'>Secondary Ingredient</span><br /><br />A secondary ingredient for brewing potions. <br /><br /><span class='color-grey font-small'>Strange leaves like this one are usually used for combat related potions.</span>",
    "stranger_leaf": "<span class='color-primary'>Secondary Ingredient</span><br /><br />A secondary ingredient for brewing potions.<br /><br /><span class='color-grey font-small'>Strange leaves like this one are usually used for combat related potions.</span>",
    "strangest_leaf": "<span class='color-primary'>Secondary Ingredient</span><br /><br />A secondary ingredient for brewing potions.<span class='color-grey font-small'>Strange leaves like this one are usually used for combat related potions.</span>",

    "gathering_loot_bag_mines": "<span class='color-primary'>Loot Bag (Mines)</span><br /><br />Contains stone.",
    "gathering_loot_bag_fields": "<span class='color-primary'>Loot Bag (Fields)</span><br /><br />Contains bones and seeds.",
    "gathering_loot_bag_forest": "<span class='color-primary'>Loot Bag (Forest)</span><br /><br />Contains big bones, leaves and wood.",
    "gathering_loot_bag_fishing_pond": "<span class='color-primary'>Loot Bag (Pond)</span><br /><br />Contains seaweed and fishing bait.",
    "gathering_loot_bag_gem_mine": "<span class='color-primary'>Loot Bag (Gem Mine)</span><br /><br />Contains stone and gem fragments.",
    "gathering_loot_bag_castle": "<span class='color-primary'>Loot Bag (Castle)</span><br /><br />Contains tained coins and rare dragon ore/bars.",
    "gathering_loot_bag_kitchen": "<span class='color-primary'>Loot Bag (Kitchen)</span><br /><br />Contains food for energy.",
    "gathering_loot_bag_junk": "<span class='color-primary'>Loot Bag (Junk)</span><br /><br />Contains metals and unique robot pieces.",

    "portal_base": "<span class='color-primary'>Portal Base</span><br /><br />Can be combined with portal energy found from guardians to advance in the castle.",
    "castle_portal_2": "<span class='color-primary'>Portal Energy (Floor 2)</span><br /><br />Can be combined with a portal base.",
    "castle_portal_3": "<span class='color-primary'>Portal Energy (Floor 3)</span><br /><br />Can be combined with a portal base.",
    "tainted_coins": "<span class='color-primary'>Tainted Coins</span><br /><br />Faradox's currency.<br /><br /><span class='color-grey'>Maybe I can use these within the castle?</span>",
    
    
    //potions
    // DONT FORGET TO UPDATE tooltips.js --> load_brewing_timer_tooltips()
    "stardust_potion": "<span class='color-primary'>Stardust Potion</span><br /><br />Gain a small amount of stardust.<br /><br /><span class='color-lime'>Lasts for: "+Brewing.get_potion_timer("stardust_potion", true)+".</span>",
    "energy_potion": "<span class='color-primary'>Energy Potion</span><br /><br />Gain a small amount of energy.<br /><br /><span class='color-lime'>Lasts for: "+Brewing.get_potion_timer("energy_potion", true)+".</span>",
    "anti_disease_potion": "<span class='color-primary'>Anti-disease Potion</span><br /><br />Decreases your chance of farming crops dying by 50%.<br /><br /><span class='color-lime'>Lasts for: "+Brewing.get_potion_timer("anti_disease_potion", true)+".</span>",
    "smelting_upgrade_potion": "<span class='color-primary'>Smelting Upgrade Potion</span><br /><br />Smelting ore will yield a better metal bar.<br /><br /><span class='color-grey'>Copper &rarr; Iron bar<br />Iron &rarr; Silver bar<br />Silver &rarr; Gold bar</span><br /><br /><span class='color-lime'>Lasts for: "+Brewing.get_potion_timer("smelting_upgrade_potion", true)+".</span>",
    "farming_speed_potion": "<span class='color-primary'>Farming Speed Potion</span><br /><br />Farming crops grow twice as fast.<br /><br /><span class='color-lime'>Lasts for: "+Brewing.get_potion_timer("farming_speed_potion", true)+".</span>",
    "tree_speed_potion": "<span class='color-primary'>Tree Speed Potion</span><br /><br />Trees grow twice as fast.<br /><br /><span class='color-lime'>Lasts for: "+Brewing.get_potion_timer("tree_speed_potion", true)+".</span>",
    "rare_monster_potion": "<span class='color-primary'>Select Monster Potion</span><br /><br />Ability to select a monster to fight.<br /><br /><span class='color-grey'><b>Works on:</b> Fields, forest, caves, volcano</span><br /><br /><span class='color-lime'>Lasts for: "+Brewing.get_potion_timer("rare_monster_potion", true)+".</span>",
    "super_stardust_potion": "<span class='color-primary'>Super Stardust Potion</span><br /><br />Gain a lot of stardust.<br /><br /><span class='color-lime'>Lasts for: "+Brewing.get_potion_timer("super_stardust_potion", true)+".</span>",
    "gathering_unique_potion": "<span class='color-primary'>Unique Gathering Potion</span><br /><br />Increases the chance of finding unique items from gathering by 25%.<br /><br /><span class='color-lime'>Lasts for: "+Brewing.get_potion_timer("gathering_unique_potion", true)+".</span>",
    "great_stardust_potion": "<span class='color-primary'>Great Stardust Potion</span><br /><br />Gain more stardust overtime.<br /><br /><span class='color-lime'>Lasts for: "+Brewing.get_potion_timer("great_stardust_potion", true)+".</span>",
    "heat_potion": "<span class='color-primary'>Heat Potion</span><br /><br />+1 heat per log burned in your oven.<br /><br /><span class='color-lime'>Lasts for: "+Brewing.get_potion_timer("heat_potion", true)+".</span><br /><br /><span class='color-grey'>(Note that you will get +1 heat for ever log that is currently burning, not when inserting logs in the oven)</span>",
    "bait_potion": "<span class='color-primary'>Bait Potion</span><br /><br />Automatically find bait when gathering from the quiet pond.<br /><br /><span class='color-orange'>Note:  You must be gathering from the quiet pond to get the extra bait.  It will automatically be added to your inventory.</span><br /><br /><span class='color-lime'>Lasts for: "+Brewing.get_potion_timer("bait_potion", true)+".</span>",
    "bone_potion": "<span class='color-primary'>Bone Potion</span><br /><br />Gain bones overtime.<br /><br /><span class='color-lime'>Lasts for: "+Brewing.get_potion_timer("bone_potion", true)+".</span>",
    "furnace_speed_potion": "<span class='color-primary'>Furnace Speed Potion</span><br /><br />Smelting bars in your furnace will be 5x faster.<br /><br /><span class='color-lime'>Lasts for: "+Brewing.get_potion_timer("furnace_speed_potion", true)+".</span>",
    "promethium_potion": "<span class='color-primary'>Promethium Potion</span><br /><br />Triples your promethium ores obtained from mining machinery.<br /><br /><span class='color-lime'>Lasts for: "+Brewing.get_potion_timer("promethium_potion", true)+".</span>",
    "oil_potion": "<span class='color-primary'>Oil Potion</span><br /><br />Doubles the amount of oil you gain.<br /><br /><span class='color-lime'>Lasts for: "+Brewing.get_potion_timer("oil_potion", true)+".</span>",
    "super_rare_monster_potion": "<span class='color-primary'>Select Monster Potion+</span><br /><br />Ability to select a monster to fight.<br /><br /><span class='color-grey'><b>Works on:</b> Northern fields, ghost mansion, beach</span><br /><br /><span class='color-lime'>Lasts for: "+Brewing.get_potion_timer("super_rare_monster_potion", true)+".</span>",
    "ultra_stardust_potion": "<span class='color-primary'>Ultra Stardust Potion</span><br /><br />Gain even more stardust.<br /><br /><span class='color-lime'>Lasts for: "+Brewing.get_potion_timer("ultra_stardust_potion", true)+".</span>",
    "birdhouse_potion": "<span class='color-primary'>Birdhouse Potion</span><br /><br />Ability to gain multiple levels when collecting from a birdhouse. Potion must be active when collecting from birdhouse.<br /><br /><span class='color-lime'>Lasts for: "+Brewing.get_potion_timer("birdhouse_potion", true)+".</span>",
    "rocket_potion": "<span class='color-primary'>Rocket Speed Potion</span><br /><br />Increases your rocket's velocity.<br /><br /><span class='color-lime'>Lasts for: "+Brewing.get_potion_timer("rocket_potion", true)+".</span>",
    "titanium_potion": "<span class='color-primary'>Titanium Potion</span><br /><br />Triples your titanium ores obtained from mining machinery.<br /><br /><span class='color-lime'>Lasts for: "+Brewing.get_potion_timer("titanium_potion", true)+".</span>",
    "ancient_potion": "<span class='color-primary'>Ancient Potion</span><br /><br />Triples your ancient ores obtained from mining machinery.<br /><br /><span class='color-lime'>Lasts for: "+Brewing.get_potion_timer("ancient_potion", true)+".</span>",
    "geode_potion": "<span class='color-primary'>Geode Potion</span><br /><br />Doubles the chance of finding geodes given you have the mining level.<br /><br /><span class='color-lime'>Lasts for: "+Brewing.get_potion_timer("geode_potion", true)+".</span>",
    "magic_shiny_crystal_ball_potion": "<span class='color-primary'>Angels Potion (SHINY)</span><br /><br />Casting the correct spell from the Angel's magic XP ball will shiny the monster.<br /><br /><span class='color-lime'>Lasts for: "+Brewing.get_potion_timer("magic_shiny_crystal_ball_potion", true)+".</span><br /><br /><b>Make sure you drink this potion before casting the spell.</b>",
    "magic_crystal_ball_potion": "<span class='color-primary'>Angels Potion (XP)</span><br /><br />Obtain 10x the magic experience when you trigger the Angel's magic XP ball. This also increases the cooldown for the ball by 5x.<br /><br /><span class='color-lime'>Lasts for: "+Brewing.get_potion_timer("magic_crystal_ball_potion", true)+".</span>",
    "rain_potion": "<span class='color-primary'>Rain Healing Potion</span><br /><br />If it rains while fighting in the ocean, you will also get healed at a slower rate.<br /><br /><span class='color-lime'>Lasts for: "+Brewing.get_potion_timer("rain_potion", true)+".</span>",
    "gathering_worker_potion": "<span class='color-primary'>Gathering Worker Potion</span><br /><br />Your gathering worker will collect bags twice as fast.<br /><br /><span class='color-lime'>Lasts for: "+Brewing.get_potion_timer("gathering_worker_potion", true)+".</span>",

    "guardians_tear": "<span class='color-primary'>Gaurdian's Tear</span><br /><br />The frozen tear of a crying guardian #2.",

    "ticket_printer_ice": "<span class='color-primary'>Ticket Printer (Stuck in Ice)</span><br /><br />Some kind of weird machine stuck in ice.",
    "ticket_printer": "<span class='color-primary'>Ticket Printer</span><br /><br />Some kind of weird machine.",


    "stone_converter_potion": "<span class='color-primary'>Stone Converter Potion</span><br /><br />Converts any type of ore into stone.<br /><br /><span class='color-orange'>12h Cooldown</span>",
    "combat_loot_potion": "<span class='color-primary'>Combat Loot Potion</span><br /><br />The next monster killed will give double the loot.<br /><br /><span class='color-orange'>12h Cooldown</span>",
    "rotten_potion": "<span class='color-primary'>Rotten Potion</span><br /><br />Increases the rate at which fruit skin depletes.<br /><br /><span class='color-orange'>12h Cooldown</span>",
    "guardian_key_potion": "<span class='color-primary'>Guardian Key Potion</span><br /><br />Drastically increase the chance of finding any guardian key.  Can only be triggered once per cooldown.<br /><br /><span class='color-orange'>24h Cooldown</span>",
    "merchant_speed_potion": "<span class='color-primary'>Merchant Speed Potion</span><br /><br />Instantly changes the merchant's shop should you send him away.<br /><br /><span class='color-orange'>3 Day Cooldown</span>",

    "chefs_hat": "<span class='color-primary'>Chef's Hat</span><br /><br />Preparing 5 or more of any recipe will reduce its prep time by half, forever.<br /><br />Preparing 10 or more of any recipe will allow you to get double the food output, forever",

    "foundry_storage": "<span class='color-primary'>Charcoal Foundry Storage</span><br /><br />Increases oil foundry to hold 10x more logs.",


    //equipment
    "wooden_sword": "<span class='color-primary'>Wooden Sword</span><br /><br />A sword made out of wood.  It's not very strong but it's better than nothing.<br /><br />" + TooltipContent.build_tooltip_html_weapon_stats(0, 1, 0, 3, 0, false),
    "stinger": "<span class='color-primary'>Stinger</span><br /><br />The stinger of a bee.<br /><br /><img src='https://cdn.idle-pixel.com/images/melee.png' class='w20' /> Level 5<br /><br />" + TooltipContent.build_tooltip_html_weapon_stats(0, 2, 0, 3, 0, false),
    "poison_stinger": "<span class='color-primary'>Poison Stinger</span><br /><br />The stinger of a bee dipped in poison.<br /><br /><span class='color-cyan'>Melee level req: 5.</span><br /><br />" + TooltipContent.build_tooltip_html_weapon_stats(0, 2, 0, 3, 0, false) + "<br /><span class='color-grey'><img src='https://cdn.idle-pixel.com/images/poison.png' class='w20' /> 33% chance of dealing poison damage on hit, ignoring enemy defence.</span>",
    "iron_dagger": "<span class='color-primary'>Iron Dagger</span><br /><br />The dagger from a thief.<br /><br /><span class='color-cyan'>Melee level req: 10.</span><br /><br /><span class='color-lime'>Accuracy: 0</span><br /><span class='color-lime'>Melee damage: 2</span><br /><span class='color-lime'>Speed: Fast</span></span>",
    "skeleton_sword": "<span class='color-primary'>Skeleton Sword</span><br /><br />The sword from a skeleton.<br /><br /><span class='color-cyan'>Melee level req: 20.<br /><br /><span class='color-lime'>Accuracy: 1</span><br /><span class='color-lime'>Melee damage: 5</span><br /><br /><span class='color-lime'>Speed: Normal</span></span>",
    "club": "<span class='color-primary'>Club</span><br /><br />A weapon which yeti's love to use.  It's quite heavy.<br /><br /><span class='color-cyan'>Melee level req: 30.<br /><br /><span class='color-lime'>Accuracy: 4</span><br /><span class='color-lime'>Melee damage: 8</span><br /><span class='color-red'>Speed: Slow</span></span>",
    "spiked_club": "<span class='color-primary'>Club (Spiked)</span><br /><br />A weapon which yeti's love to use.  It's quite heavy.  Spikes have been attached to it.<br /><br /><span class='color-cyan'>Melee level req: 30.<br /><br /><span class='color-lime'>Accuracy: 4</span><br /><span class='color-lime'>Melee damage: 12</span><br /><span class='color-red'>Speed: Slow</span></span>",
    "dense_club": "<span class='color-primary'>Dense Club</span><br /><br />A weapon which yeti's wish to have.  It's quite heavy.<br /><br /><span class='color-cyan'>Melee level req: 80.<br /><br /><span class='color-lime'>Accuracy: 7</span><br /><span class='color-lime'>Melee damage: 20</span><br /><span class='color-red'>Speed: Slow</span></span>",
    "spiked_dense_club": "<span class='color-primary'>Dense Club (Spiked)</span><br /><br />A weapon which yeti's wish to have.  It's quite heavy.<br /><br /><span class='color-cyan'>Melee level req: 100.<br /><br /><span class='color-lime'>Accuracy: 7</span><br /><span class='color-lime'>Melee damage: 30</span><br /><span class='color-red'>Speed: Slow</span></span>",
    "lantern": "<span class='color-primary'>Lanturn (lit)</span><br /><br />A light source.  Allows you to see clearly in dark combat areas.</span>",
    "skeleton_shield": "<span class='color-primary'>Skeleton Shield</span><br /><br />The shield from a skeleton.<br /><br /><span class='color-cyan'>Melee level req: 20.<br /><br /><span class='color-lime'>Defence: 4</span></span>",
    "scythe": "<span class='color-primary'>Scythe</span><br /><br />The scythe from a reaper.<br /><br /><span class='color-cyan'>Melee level req: 40.<br /><br /><span class='color-lime'>Accuracy: 4</span><br /><span class='color-lime'>Melee damage: 8</span><br /><br /><span class='color-lime'>Speed: Normal</span></span><br /><br /><img src='https://cdn.idle-pixel.com/images/ghost_icon.png' class='w15' /> Double damage on monsters from haunted mansion.",
    "double_scythe": "<span class='color-primary'>Scythe+</span><br /><br />The scythe from a reaper that's been upgraded via invention.<br /><br /><span class='color-cyan'>Melee level req: 100.<br /><br /><span class='color-lime'>Accuracy: 4</span><br /><span class='color-lime'>Melee damage: 8</span><br /><br /><span class='color-lime'>Speed: Normal</span></span><br /><br /><img src='https://cdn.idle-pixel.com/images/ghost_icon.png' class='w15' /> 4x damage on monsters from haunted mansion.",
    "rapier": "<span class='color-primary'>Rapier</span><br /><br />A rapier obtained from robots.<br /><br /><span class='color-cyan'>Melee level req: 90.<br /><br /><span class='color-lime'>Accuracy: 7</span><br /><span class='color-lime'>Melee damage: 12</span><br /><br /><span class='color-lime'>Speed: Normal</span></span>",
    "gold_rapier": "<span class='color-primary'>Gold Rapier</span><br /><br />A golden rapier obtained from elite robots.  This rapier is much faster than the original one.<br /><br /><span class='color-cyan'>Melee level req: 90.<br /><br /><span class='color-lime'>Accuracy: 7</span><br /><span class='color-lime'>Melee damage: 12</span><br /><br /><span class='color-lime'>Speed: Fast</span></span>",
    "degradable_gold_rapier": "<span class='color-primary'>Gold Rapier (Degradable)</span><br /><br />A golden rapier.  Known to be owned by the elite robots.  This version of the rapier will only last 24h, for which the timer begins as soon as it's equipped.<br /><br /><span class='color-cyan'>Melee level req: 90.<br /><br /><span class='color-lime'>Accuracy: 7</span><br /><span class='color-lime'>Melee damage: 12</span><br /><br /><span class='color-lime'>Speed: Fast</span></span>",
    "trident": "<span class='color-primary'>Trident</span><br /><br />The trident of a sea soldier.<br /><br /><span class='color-cyan'>Melee level req: 70.<br /><br /><span class='color-lime'>Accuracy: 4</span><br /><span class='color-lime'>Melee damage: 7</span><br /><br /><span class='color-lime'>Speed: Normal</span></span><br /><br /><img src='https://cdn.idle-pixel.com/images/water.png' class='w15' /> Double damage on water based monsters.",
    "long_trident": "<span class='color-primary'>Long Trident</span><br /><br />The trident of a sea soldier which was upgraded via invention.<br /><br /><span class='color-cyan'>Melee level req: 70.<br /><br /><span class='color-lime'>Accuracy: 4</span><br /><span class='color-lime'>Melee damage: 7</span><br /><br /><span class='color-lime'>Speed: Normal</span></span><br /><br /><img src='https://cdn.idle-pixel.com/images/water.png' class='w15' /> Double damage on water based monsters.<br /><br />Ability to hit monsters using melee but at a distance.",
    "dark_sword": "<span class='color-primary'>Dark Sword <span class='color-orange'>(Level 1)</span></span><br /><br />A legendary sword.  This item can be further upgraded with invention.<br /><br /><span class='color-cyan'>Melee level req: 100.<br /><br /><span class='color-lime'>Accuracy: 10</span><br /><span class='color-lime'>Melee damage: 15</span><br /><br /><span class='color-lime'>Speed: Normal</span></span><br /><br /><img src='https://cdn.idle-pixel.com/images/death.png' class='w15' /> Faradox has many swords like this one.",

    "dragon_shield": "<span class='color-primary'>Dragon Shield</span><br /><br />The shield which resists dragonfire.<br /><br /><span class='color-cyan'>Melee level req: 80.<br /><br /><span class='color-lime'>Defence: 8</span></span><br /><br /><img src='https://cdn.idle-pixel.com/images/heat.png' /><span class='color-red'> -20% damage from dragon's breath.</span>",

    "tcg": "Collectible Cards Collection",
    "tcg_unknown": "An unknown collectible card.  Should I reveal at it?  Or I can trade it away.",
    

    "train_cart_piece": "<span class='color-primary'>Train Cart Piece (1 of 4 pieces)</span><br /><br /><span class='color-yellow'><img src='https://cdn.idle-pixel.com/images/quests.png' class='w20' /> Used for the side quest: Train Combat Network</span>",
    "train_cart_completed": "<span class='color-primary'>Train Cart (Completed)</span><br /><br /><span class='color-yellow'><img src='https://cdn.idle-pixel.com/images/quests.png' class='w20' /> Used for the side quest: Train Combat Network</span>",
    

    
    "castle_portal_2_completed": "<span class='color-primary'>Portal</span><br /><br />A portal has been activated within the castle.  Can you find it?",
    "castle_portal_3_completed": "<span class='color-primary'>Portal</span><br /><br />A portal has been activated within the castle.  Can you find it?",

    "dragon_shield_left_half": "<span class='color-primary'>Dragon Shield (Left Half)</span><br /><br /><span class='color-red'>Can be crafted into a dragon shield with the other half.</span>",
    "dragon_shield_right_half": "<span class='color-primary'>Dragon Shield (Right Half)</span><br /><br /><span class='color-red'>Can be crafted into a dragon shield with the other half.</span>",

    "stinger_dagger": "<span class='color-primary'>Stinger Dagger</span><br /><br />A dagger made from stingers.<br /><br /><span class='color-cyan'>Melee level req: 60.<br /><br /><span class='color-lime'>Accuracy: 4</span><br /><span class='color-lime'>Melee damage: 2</span><br /><br /><span class='color-lime'>Speed: Normal</span></span><br /><br /><img src='https://cdn.idle-pixel.com/images/invention.png' class='w15' /> If you successfully hit through the enemies defence, you will hit the opponent three times.  Failing to do so will result in hitting a zero.",
    "poison_stinger_dagger": "<span class='color-primary'>Poison Stinger Dagger</span><br /><br />A dagger made from stingers.  It has poison applied on it.<br /><br /><span class='color-cyan'>Melee level req: 60.<br /><br /><span class='color-lime'>Accuracy: 4</span><br /><span class='color-lime'>Melee damage: 2</span><br /><br /><span class='color-lime'>Speed: Normal</span></span><br /><br /><img src='https://cdn.idle-pixel.com/images/invention.png' class='w15' /> If you successfully hit through the enemies defence, you will hit the opponent three times.  Failing to do so will result in hitting a zero.",

    "battle_axe": "<span class='color-primary'>Battle Axe</span><br /><br />An axe that can both be used for chopping wood or attacking enemies.<br /><br /><span class='color-cyan'>Melee level req: 65.<br /><br /><span class='color-lime'>Accuracy: 4</span><br /><span class='color-lime'>Melee damage: 7</span><br /><br /><span class='color-red'>Speed: Slow</span></span><br /><br /><img src='https://cdn.idle-pixel.com/images/invention.png' class='w15' /> Killing ents in the forest will yeild more logs.",
    "long_spear": "<span class='color-primary'>Long Spear</span><br /><br />An extremely long spear which allows you to hit monsters at a distance.<br /><br /><span class='color-cyan'>Melee level req: 70.<br /><br /><span class='color-lime'>Accuracy: 3</span><br /><span class='color-lime'>Melee damage: 7</span><br /><br /><span class='color-red'>Speed: Slow</span></span><br /><br /><img src='https://cdn.idle-pixel.com/images/invention.png' class='w15' /> Ability to hit monsters using melee but at a distance.",

    "iron_defender": "<span class='color-primary'>Iron Defender</span><br /><br />Weilded in your other hand, providing offensive stats.<br /><br /><span class='color-cyan'>Melee level req: 60.<br /><br /><span class='color-lime'>Accuracy: 1</span",
    "skeleton_defender": "<span class='color-primary'>Skeleton Defender</span><br /><br />Weilded in your other hand, providing offensive stats.<br /><br /><span class='color-cyan'>Melee level req: 70.<br /><br /><span class='color-lime'>Accuracy: 2</span",
    
    "flippers": "<span class='color-primary'>Flippers</span><br /><br />A pair of flippers.  I bet I can swim fast with these!<br /><br /><span class='color-lime'>Attack speed when fighting in water is increased.</span>",

    "click-to-purchase": "Click to purchase.<br /><br /><span class='font-small color-grey'>Your coins on located on the top left.</span>",

    "mimic": "<span class='color-primary'>Mimic</span><br /><br /><span class='color-grey'>The chest has come to life!</span><br /><br /><img src='https://cdn.idle-pixel.com/images/heart_icon.png' /> 25 HP<br /><img src='https://cdn.idle-pixel.com/images/accuracy_white.png' /> 8 Accuracy<br /><img src='https://cdn.idle-pixel.com/images/melee_damage_white.png' /> 5 Attack<br /><img src='https://cdn.idle-pixel.com/images/speed_white.png' /> 3 Speed<br /><img src='https://cdn.idle-pixel.com/images/defence_white.png' /> 5 Defence<br /><br /><span class='font-small color-red'>May randomly bite the other player.</span><br /><br /><span class='color-purple'>You may only hold 1 mimic at a time</span>",
    "green_mimic": "<span class='color-primary'>Mimic (Green)</span><br /><br /><span class='color-grey'>The chest has come to life!</span><br /><br /><img src='https://cdn.idle-pixel.com/images/heart_icon.png' /> 60 HP<br /><img src='https://cdn.idle-pixel.com/images/accuracy_white.png' /> 14 Accuracy<br /><img src='https://cdn.idle-pixel.com/images/melee_damage_white.png' /> 10 Attack<br /><img src='https://cdn.idle-pixel.com/images/speed_white.png' /> 3 Speed<br /><img src='https://cdn.idle-pixel.com/images/defence_white.png' /> 28 Defence<br /><br /><span class='font-small color-red'>May randomly bite the other player.</span><br /><br /><span class='color-purple'>You may only hold 1 mimic at a time</span>",
    "red_mimic": "<span class='color-primary'>Mimic (Red)</span><br /><br /><span class='color-grey'>The chest has come to life!</span><br /><br /><img src='https://cdn.idle-pixel.com/images/heart_icon.png' /> 200 HP<br /><img src='https://cdn.idle-pixel.com/images/accuracy_white.png' /> 25 Accuracy<br /><img src='https://cdn.idle-pixel.com/images/melee_damage_white.png' /> 15 Attack<br /><img src='https://cdn.idle-pixel.com/images/speed_white.png' /> 3 Speed<br /><img src='https://cdn.idle-pixel.com/images/defence_white.png' /> 40 Defence<br /><br /><span class='font-small color-red'>May randomly bite the other player.</span><br /><br /><span class='color-purple'>You may only hold 1 mimic at a time</span>",
    "mixed_mimic": "<span class='color-primary'>Mimic (Mixed)</span><br /><br /><span class='color-grey'>The chest has come to life!</span><br /><br /><img src='https://cdn.idle-pixel.com/images/heart_icon.png' /> 500 HP<br /><img src='https://cdn.idle-pixel.com/images/accuracy_white.png' /> 42 Accuracy<br /><img src='https://cdn.idle-pixel.com/images/melee_damage_white.png' /> 15 Attack<br /><img src='https://cdn.idle-pixel.com/images/speed_white.png' /> 3 Speed<br /><img src='https://cdn.idle-pixel.com/images/defence_white.png' /> 64 Defence<br /><br /><span class='font-small color-red'>May randomly bite the other player.</span><br /><br /><span class='color-purple'>You may only hold 1 mimic at a time</span>",


    "wooden_bow": "<span class='color-primary'>Wooden Bow</span><br /><br />A bow made out of wood.  It's not very strong but it's better than nothing.<br /><br /><span class='color-lime'>Accuracy: 1</span><br /><span class='color-lime'>Speed: Normal</span><br /><br /><span class='color-grey font-small'>Arrows are required with this weapon.</span>",
    "long_bow": "<span class='color-primary'>Long Bow</span><br /><br />A bow made out of wood.<br /><br /><span class='color-cyan'>Archery level req: 25.<br /><br /><span class='color-lime'>Accuracy: 3</span><br /><span class='color-lime'>Speed: Normal</span><br /><br /><span class='color-grey font-small'>Arrows are required with this weapon.</span>",
    "toy_slingshot": "<span class='color-primary'>Toy Slingshot</span><br /><br />A slingshot found in a toybox.<br /><br /><span class='color-cyan'>Archery level req: 25.<br /><br /><span class='color-lime'>Accuracy: 3</span><br /><span class='color-lime'>Stone Damage: 5</span><br /><span class='color-lime'>Speed: Normal</span><br /><br /><span class='color-grey font-small'>Stone is required for this weapon.  Arrows have no effect.</span>",
    "haunted_bow": "<span class='color-primary'>Haunted Bow</span><br /><br />A bow made out of a haunted bow frame found in haunted mansion.<br /><br /><span class='color-cyan'>Archery level req: 40.<br /><br /><span class='color-lime'>Accuracy: 4</span><br /><span class='color-lime'>Speed: Normal</span><br /><br /><span class='color-grey font-small'>Arrows are required with this weapon.</span><br /><br /><img src='https://cdn.idle-pixel.com/images/ghost_icon.png' class='w15' /> Double damage on monstes from haunted mansion.",
    "wooden_staff": "<span class='color-primary'>Wooden Staff</span><br /><br />A staff made out of wood.  It's not very strong but it's better than nothing.<br /><br /><span class='color-lime'>Melee damage: 1<br />Magic bonus: 1</span><br /><span class='color-lime'>Speed: Slow</span><br /><br /><span class='color-grey font-small'>Magic weapons should be used with spells.  Something you have not unlocked yet.</span>",

    "reaper_hood": "<span class='color-primary'>Reaper Hood</span><br /><br />A magical magic armour that increases XP when casting spells in combat.<br /><br /><i>XP Stacks with other reaper robes.</i><br /><span class='color-lime'>Magic Bonus: 1</span><br /><span class='color-cyan'>Bonus XP: +50%</span>",
    "reaper_body": "<span class='color-primary'>Reaper Shirt</span><br /><br />A magical magic armour that increases XP when casting spells in combat.<br /><br /><i>XP Stacks with other reaper robes.</i><br /><span class='color-lime'>Magic Bonus: 1</span><br /><span class='color-cyan'>Bonus XP:  +50%</span>",
    "reaper_skirt": "<span class='color-primary'>Reaper Skirt</span><br /><br />A magical magic armour that increases XP when casting spells in combat.<br /><br /><i>XP Stacks with other reaper robes.</i><br /><span class='color-lime'>Magic Bonus: 1</span><br /><span class='color-cyan'>Bonus XP:  +50%</span>",
    "reaper_gloves": "<span class='color-primary'>Reaper Gloves</span><br /><br />A magical magic armour that increases XP when casting spells in combat.<br /><br /><i>XP Stacks with other reaper robes.</i><br /><span class='color-lime'>Magic Bonus: 1</span><br /><span class='color-cyan'>Bonus XP: +50%</span>",
    "reaper_boots": "<span class='color-primary'>Reaper Boots</span><br /><br />A magical magic armour that increases XP when casting spells in combat.<br /><br /><i>XP Stacks with other reaper robes.</i><br /><span class='color-lime'>Magic Bonus: 1</span><br /><span class='color-cyan'>Bonus XP:  +50%</span>",
   
    "reaper_super_hood": "<span class='color-primary'>Reaper Hood+</span><br /><br />A magical magic armour that is tainted with undead power.<br /><br /><i>XP Stacks with other reaper robes.</i><br /><span class='color-lime'>Magic Bonus: 2</span><br /><span class='color-cyan'>Bonus XP: +50%</span><br /><span class='color-purple'>20% chance that your fire spell becomes undead, dealing 4x damage on undead monsters.</span>",
    "reaper_super_body": "<span class='color-primary'>Reaper Hood+</span><br /><br />A magical magic armour that is tainted with undead power.<br /><br /><i>XP Stacks with other reaper robes.</i><br /><span class='color-lime'>Magic Bonus: 2</span><br /><span class='color-cyan'>Bonus XP: +50%</span><br /><span class='color-purple'>20% chance that your fire spell becomes undead, dealing 4x damage on undead monsters.</span>",
    "reaper_super_skirt": "<span class='color-primary'>Reaper Hood+</span><br /><br />A magical magic armour that is tainted with undead power.<br /><br /><i>XP Stacks with other reaper robes.</i><br /><span class='color-lime'>Magic Bonus: 2</span><br /><span class='color-cyan'>Bonus XP: +50%</span><br /><span class='color-purple'>20% chance that your fire spell becomes undead, dealing 4x damage on undead monsters.</span>",
    "reaper_super_gloves": "<span class='color-primary'>Reaper Hood+</span><br /><br />A magical magic armour that is tainted with undead power.<br /><br /><i>XP Stacks with other reaper robes.</i><br /><span class='color-lime'>Magic Bonus: 2</span><br /><span class='color-cyan'>Bonus XP: +50%</span><br /><span class='color-purple'>20% chance that your fire spell becomes undead, dealing 4x damage on undead monsters.</span>",
    "reaper_super_boots": "<span class='color-primary'>Reaper Hood+</span><br /><br />A magical magic armour that is tainted with undead power.<br /><br /><i>XP Stacks with other reaper robes.</i><br /><span class='color-lime'>Magic Bonus: 2</span><br /><span class='color-cyan'>Bonus XP: +50%</span><br /><span class='color-purple'>20% chance that your fire spell becomes undead, dealing 4x damage on undead monsters.</span>",

    "balista": "<span class='color-primary'>Balista</span><br /><br />A massive range weapon made out of a dragon frame.  Maybe it has a good use against dragons?<br /><br /><span class='color-cyan'>Archery level req: 80.<br /><br /><span class='color-lime'>Accuracy: 7</span><br /><span class='color-red'>Speed: Slow</span><br /><br /><span class='color-grey font-small'><u>Five</u> arrows are required with this weapon.</span><br /><br /><img src='https://cdn.idle-pixel.com/images/wooden_arrows.png' class='w15' /> Arrow damage doubled.",

    "wooden_arrows": "<span class='color-primary'>Wooden Arrows</span><br /><br />Arrows made out of wood.  They are not that accurate.<br /><br />A bow is required to use arrows.<br /><br /><span class='color-lime'>Arrow Damage: 2</span>",
    "fire_arrows": "<span class='color-primary'>Fire Arrows</span><br /><br />An arrow surrounded by fire.<br /><br />A bow is required to use arrows.<br /><br /><span class='color-lime'>Arrow Damage: 5</span><br /><br /><span class='color-lime'>Double damage on ice monsters.</span><br /><span class='color-red'>Useless againsts water monsters.</span>",
    "ice_arrows": "<span class='color-primary'>Ice Arrows</span><br /><br />An arrow surrounded by ice.<br /><br />A bow is required to use arrows.<br /><br /><span class='color-lime'>Arrow Damage: 7</span><br /><br /><span class='color-lime'>Double damage on fire monsters.</span><br /><span class='color-red'>Useless againsts ice monsters.</span>",
    "iron_cannonball": "<span class='color-primary'>Cannon Balls</span><br /><br />Cannon balls made out of iron.<br /><br />A cannon is required to use cannonballs.",
    
   
    "lizard_mask": "<span class='color-primary'>Lizard Mask</span><br /><br />A piece of armour made out of lizard skin.<br /><br /><span class='color-lime'>Defence: 2</span>",
    "lizard_body": "<span class='color-primary'>Lizard Body</span><br /><br />A piece of armour made out of lizard skin.<br /><br /><span class='color-lime'>Defence: 3</span>",
    "lizard_legs": "<span class='color-primary'>Lizard Legs</span><br /><br />A piece of armour made out of lizard skin.<br /><br /><span class='color-lime'>Defence: 2</span>",
    "lizard_gloves": "<span class='color-primary'>Lizard Gloves</span><br /><br />A piece of armour made out of lizard skin.<br /><br /><span class='color-lime'>Defence: 1</span>",
    "lizard_boots": "<span class='color-primary'>Lizard Boots</span><br /><br />A piece of armour made out of lizard skin.<br /><br /><span class='color-lime'>Defence: 1</span>",
    


    "bat_mask": "<span class='color-primary'>Bat Mask</span><br /><br />A piece of armour made out of bat skin.<br /><br /><span class='color-lime'>Defence: 3</span>",
    "bat_body": "<span class='color-primary'>Bat Body</span><br /><br />A piece of armour made out of bat skin.<br /><br /><span class='color-lime'>Defence: 4</span>",
    "bat_legs": "<span class='color-primary'>Bat Legs</span><br /><br />A piece of armour made out of bat skin.<br /><br /><span class='color-lime'>Defence: 3</span>",
    "bat_gloves": "<span class='color-primary'>Bat Gloves</span><br /><br />A piece of armour made out of bat skin.<br /><br /><span class='color-lime'>Defence: 2</span>",
    "bat_boots": "<span class='color-primary'>Bat Boots</span><br /><br />A piece of armour made out of bat skin.<br /><br /><span class='color-lime'>Defence: 2</span>",

    "moonstone_mask": "<span class='color-primary'>Moonstone Mask</span><br /><br />A piece of armour made out of moonstone.<br /><br /><span class='color-lime'>Defence: 5</span><br /><br /><img src='https://cdn.idle-pixel.com/images/moonstone.png' width='15px' /> Double defence from monsters found in space.",
    "moonstone_body": "<span class='color-primary'>Moonstone Body</span><br /><br />A piece of armour made out of moonstone.<br /><br /><span class='color-lime'>Defence: 6</span><br /><br /><img src='https://cdn.idle-pixel.com/images/moonstone.png' width='15px' /> Double defence from monsters found in space.",
    "moonstone_legs": "<span class='color-primary'>Moonstone Legs</span><br /><br />A piece of armour made out of moonstone.<br /><br /><span class='color-lime'>Defence: 5</span><br /><br /><img src='https://cdn.idle-pixel.com/images/moonstone.png' width='15px' /> Double defence from monsters found in space.",
    "moonstone_gloves": "<span class='color-primary'>Moonstone Gloves</span><br /><br />A piece of armour made out of moonstone.<br /><br /><span class='color-lime'>Defence: 4</span><br /><br /><img src='https://cdn.idle-pixel.com/images/moonstone.png' width='15px' /> Double defence from monsters found in space.",
    "moonstone_boots": "<span class='color-primary'>Moonstone Boots</span><br /><br />A piece of armour made out of moonstone.<br /><br /><span class='color-lime'>Defence: 4</span><br /><br /><img src='https://cdn.idle-pixel.com/images/moonstone.png' width='15px' /> Double defence from monsters found in space.",
    
    "crocodile_mask": "<span class='color-primary'>Crocodile Mask</span><br /><br />A piece of armour made out of crocodile hides.<br /><br /><span class='color-lime'>Defence: 6</span>",
    "crocodile_body": "<span class='color-primary'>Crocodile Body</span><br /><br />A piece of armour made out of crocodile hides.<br /><br /><span class='color-lime'>Defence: 7</span>",
    "crocodile_legs": "<span class='color-primary'>Crocodile Legs</span><br /><br />A piece of armour made out of crocodile hides.<br /><br /><span class='color-lime'>Defence: 6</span>",
    "crocodile_gloves": "<span class='color-primary'>Crocodile Gloves</span><br /><br />A piece of armour made out of crocodile hides.<br /><br /><span class='color-lime'>Defence: 5</span>",
    "crocodile_boots": "<span class='color-primary'>Crocodile Boots</span><br /><br />A piece of armour made out of crocodile hides.<br /><br /><span class='color-lime'>Defence: 5</span>",
   
    "frozen_crocodile_mask": "<span class='color-primary'>Crocodile Mask (Frozen)</span><br /><br />A piece of armour made out of crocodile hides.<br /><br /><span class='color-lime'>Defence: 6</span><br /><br /><img src='https://cdn.idle-pixel.com/images/snowflake.png' /><span class='color-cyan'> -20% damage in cold environments.</span>",
    "frozen_crocodile_body": "<span class='color-primary'>Crocodile Body (Frozen)</span><br /><br />A piece of armour made out of crocodile hides.<br /><br /><span class='color-lime'>Defence: 7</span><br /><br /><img src='https://cdn.idle-pixel.com/images/snowflake.png' /><span class='color-cyan'> -20% damage in cold environments.</span>",
    "frozen_crocodile_legs": "<span class='color-primary'>Crocodile Legs (Frozen)</span><br /><br />A piece of armour made out of crocodile hides.<br /><br /><span class='color-lime'>Defence: 6</span><br /><br /><img src='https://cdn.idle-pixel.com/images/snowflake.png' /><span class='color-cyan'> -20% damage in cold environments.</span>",
    "frozen_crocodile_gloves": "<span class='color-primary'>Crocodile Gloves (Frozen)</span><br /><br />A piece of armour made out of crocodile hides.<br /><br /><span class='color-lime'>Defence: 5</span><br /><br /><img src='https://cdn.idle-pixel.com/images/snowflake.png' /><span class='color-cyan'> -20% damage in cold environments.</span>",
    "frozen_crocodile_boots": "<span class='color-primary'>Crocodile Boots (Frozen)</span><br /><br />A piece of armour made out of crocodile hides.<br /><br /><span class='color-lime'>Defence: 5</span><br /><br /><img src='https://cdn.idle-pixel.com/images/snowflake.png' /><span class='color-cyan'> -20% damage in cold environments.</span>",
   
    "dragon_mould": "<span class='color-primary'>Dragon Mould</span><br /><br />Used to craft dragon armour.  The mould will melt as you craft the armour piece, making you lose it.",
   

    "dragon_helmet": "<span class='color-primary'>Dragon Armour</span><br /><br />A very strong solid piece of armour.<br /><br /><span class='color-lime'>Defence: 10</span><br /><br /><img src='https://cdn.idle-pixel.com/images/heat.png' /><span class='color-red'> -10% damage from dragon's breath.</span>",
    "dragon_body": "<span class='color-primary'>Dragon Body</span><br /><br />A very strong solid piece of armour.<br /><br /><span class='color-lime'>Defence: 15</span><br /><br /><img src='https://cdn.idle-pixel.com/images/heat.png' /><span class='color-red'> -10% damage from dragon's breath.</span>",
    "dragon_legs": "<span class='color-primary'>Dragon Legs</span><br /><br />A very strong solid piece of armour.<br /><br /><span class='color-lime'>Defence: 11</span><br /><br /><img src='https://cdn.idle-pixel.com/images/heat.png' /><span class='color-red'> -10% damage from dragon's breath.</span>",
    "dragon_gloves": "<span class='color-primary'>Dragon Gloves</span><br /><br />A very strong solid piece of armour.<br /><br /><span class='color-lime'>Defence: 8</span><br /><br /><img src='https://cdn.idle-pixel.com/images/heat.png' /><span class='color-red'> -10% damage from dragon's breath.</span>",
    "dragon_boots": "<span class='color-primary'>Dragon Boots</span><br /><br />A very strong solid piece of armour.<br /><br /><span class='color-lime'>Defence: 8</span><br /><br /><img src='https://cdn.idle-pixel.com/images/heat.png' /><span class='color-red'> -10% damage from dragon's breath.</span>",
   

    "gold_helmet": "<span class='color-primary'>Gold Armour (Legendary rarity)</span><br /><br />A piece of armour made from the 3rd age gods.<br /><br /><span class='color-lime'>Defence: 6</span>",
    "gold_body": "<span class='color-primary'>Gold Body (Legendary rarity)</span><br /><br />A piece of armour made from the 3rd age gods.<br /><br /><span class='color-lime'>Defence: 7</span>",
    "gold_legs": "<span class='color-primary'>Gold Legs (Legendary rarity)</span><br /><br />A piece of armour made from the 3rd age gods.<br /><br /><span class='color-lime'>Defence: 6</span>",
    "gold_gloves": "<span class='color-primary'>Gold Gloves (Legendary rarity)</span><br /><br />A piece of armour made from the 3rd age gods.<br /><br /><span class='color-lime'>Defence: 5</span>",
    "gold_boots": "<span class='color-primary'>Gold Boots (Legendary rarity)</span><br /><br />A piece of armour made from the 3rd age gods.<br /><br /><span class='color-lime'>Defence: 5</span>",
   


    "sea_helmet": "<span class='color-primary'>Sea Helmet</span><br /><br />A piece of armour obtained from sea soldiers.  These are quite hard to come by.<br /><br /><span class='color-lime'>Defence: 10</span>",
    "castle_useless_item": "<span class='color-primary'>Useless Item</span><br /><br />This item serves no purpose.  It was purchases from a merchant in the castle on floor 2.",
    "castle_boots": "<span class='color-primary'>Castle Boots</span><br /><br />Spikes can be added to the boots.",
    "spiked_castle_boots": "<span class='color-primary'>Castle Boots (Spiked)</span><br /><br />Ability to walk on ice in the castle on floor 2.",


    "oxygen_mask": "<span class='color-primary'>Oxygen Mask</span><br /><br /><i>Exorcist: \"I stole this from my grandmother in the haunted mansion.\"</i><br /><br />A useful item for space exploration.<br /><br /><span class='color-lime'>Defence: 4</span>",
    "oxygen_tank": "<span class='color-primary'>Oxygen Mask</span><br /><br /><i>Exorcist: \"I stole this from my grandmother in the haunted mansion.\"</i><br /><br />A useful item for space exploration.<br /><br /><span class='color-lime'>Defence: 5</span>",

    "bear_mask": "<span class='color-primary'>Bear Mask</span><br /><br />A piece of armour made out of bear fur.  It does not provide any defence but will protect you from the cold.<br /><br /><span class='color-red'>Defence: 0</span><br /><br /><img src='https://cdn.idle-pixel.com/images/snowflake.png' /><span class='color-cyan'> -20% damage in cold environments.</span>",
    "bear_body": "<span class='color-primary'>Bear Body</span><br /><br />A piece of armour made out of bear fur.  It does not provide any defence but will protect you from the cold.<br /><br /><span class='color-red'>Defence: 0</span><br /><br /><img src='https://cdn.idle-pixel.com/images/snowflake.png' /><span class='color-cyan'> -20% damage in cold environments.</span>",
    "bear_legs": "<span class='color-primary'>Bear Legs</span><br /><br />A piece of armour made out of bear fur.  It does not provide any defence but will protect you from the cold.<br /><br /><span class='color-red'>Defence: 0</span><br /><br /><img src='https://cdn.idle-pixel.com/images/snowflake.png' /><span class='color-cyan'> -20% damage in cold environments.</span>",
    "bear_gloves": "<span class='color-primary'>Bear Gloves</span><br /><br />A piece of armour made out of bear fur.  It does not provide any defence but will protect you from the cold.<br /><br /><span class='color-red'>Defence: 0</span><br /><br /><img src='https://cdn.idle-pixel.com/images/snowflake.png' /><span class='color-cyan'> -20% damage in cold environments.</span>",
    "bear_boots": "<span class='color-primary'>Bear Boots</span><br /><br />A piece of armour made out of bear fur.  It does not provide any defence but will protect you from the cold.<br /><br /><span class='color-red'>Defence: 0</span><br /><br /><img src='https://cdn.idle-pixel.com/images/snowflake.png' /><span class='color-cyan'> -20% damage in cold environments.</span>",


    //logs
    "logs": "<div class='tooltip-title'> LOGS <br /> <span class='tooltip-rarity'><img style='padding-top:-4px' src='https://cdn.idle-pixel.com/images/rarity_icon_common.png' class='w15'> Common</span> </div> <img src='https://cdn.idle-pixel.com/images/coins.png' class='w15'> Sells for 10 coins <br /> <br /> <span class='tooltip-description'>A common log obtained by a regular tree.  The quality of wood is not that great.</span> <br /> <br /> <span class='color-orange'><b>Regular Trees Chopped: </b> <span id='tooltip-tree_chopped'>0</span></span> <br /> <br /> <div class='tooltip-hint-green'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/xp_arrow.png' class='w30' /> </div> <div class='tooltip-hint-content'> 1000 XP per tree chop </div> </div> <div class='tooltip-hint-yellow'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/heat.png' class='w30' /> </div> <div class='tooltip-hint-content'> <span id='tooltip-logs-heat'></span> Heat </div> </div>",
    "oak_logs": "<div class='tooltip-title'> OAK LOGS <br /> <span class='tooltip-rarity'><img style='padding-top:-4px' src='https://cdn.idle-pixel.com/images/rarity_icon_common.png' class='w15'> Common</span> </div> <img src='https://cdn.idle-pixel.com/images/coins.png' class='w15'> Sells for 20 coins <br /> <br /> <span class='tooltip-description'>A common log obtained from an oak tree.  The quality of wood is so-so.</span> <br /> <br /> <span class='color-orange'><b>Oak Trees Chopped: </b> <span id='tooltip-oak_tree_chopped'>0</span></span> <br /> <br /> <div class='tooltip-hint-green'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/xp_arrow.png' class='w30' /> </div> <div class='tooltip-hint-content'> 2000 XP per tree chop </div> </div> <div class='tooltip-hint-yellow'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/heat.png' class='w30' /> </div> <div class='tooltip-hint-content'> <span id='tooltip-oak_logs-heat'></span> Heat </div> </div>",
    "willow_logs": "<div class='tooltip-title'> WILLOW LOGS <br /> <span class='tooltip-rarity'><img style='padding-top:-4px' src='https://cdn.idle-pixel.com/images/rarity_icon_uncommon.png' class='w15'> Uncommon</span> </div> <img src='https://cdn.idle-pixel.com/images/coins.png' class='w15'> Sells for 30 coins <br /> <br /> <span class='tooltip-description'>A common log obtained from an willow tree.  The quality of wood is so-so.</span> <br /> <br /> <span class='color-orange'><b>Willow Trees Chopped: </b> <span id='tooltip-willow_tree_chopped'>0</span></span> <br /> <br /> <div class='tooltip-hint-green'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/xp_arrow.png' class='w30' /> </div> <div class='tooltip-hint-content'> 4000 XP per tree chop </div> </div> <div class='tooltip-hint-yellow'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/heat.png' class='w30' /> </div> <div class='tooltip-hint-content'> <span id='tooltip-willow_logs-heat'></span> Heat </div> </div>",
    "maple_logs": "<div class='tooltip-title'> MAPLE LOGS <br /> <span class='tooltip-rarity'><img style='padding-top:-4px' src='https://cdn.idle-pixel.com/images/rarity_icon_uncommon.png' class='w15'> Uncommon</span> </div> <img src='https://cdn.idle-pixel.com/images/coins.png' class='w15'> Sells for 50 coins <br /> <br /> <span class='tooltip-description'>Logs obtained from a maple tree.  The quality of wood is good.  Maple trees may also give maple syrup when chopped.</span> <br /> <br /> <span class='color-orange'><b>Maple Trees Chopped: </b> <span id='tooltip-maple_tree_chopped'>0</span></span> <br /> <br /> <div class='tooltip-hint-green'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/xp_arrow.png' class='w30' /> </div> <div class='tooltip-hint-content'> 10,000 XP per tree chop </div> </div> <div class='tooltip-hint-yellow'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/heat.png' class='w30' /> </div> <div class='tooltip-hint-content'> <span id='tooltip-maple_logs-heat'></span> Heat </div> </div>",
    "stardust_logs": "<div class='tooltip-title'> STARDUST LOGS <br /> <span class='tooltip-rarity'><img style='padding-top:-4px' src='https://cdn.idle-pixel.com/images/rarity_icon_rare.png' class='w15'> Rare</span> </div> <img src='https://cdn.idle-pixel.com/images/coins.png' class='w15'> Sells for 100 coins <br /> <br /> <span class='tooltip-description'>Logs obtained from a stardust tree.  This log seems to contain stardust within it.  It can be easily extracted.</span> <br /> <br /> <span class='color-orange'><b>Stardust Trees Chopped: </b> <span id='tooltip-stardust_tree_chopped'>0</span></span> <br /> <br /> <div class='tooltip-hint-green'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/xp_arrow.png' class='w30' /> </div> <div class='tooltip-hint-content'> 15,000 XP per tree chop </div> </div> <div class='tooltip-hint-yellow'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/heat.png' class='w30' /> </div> <div class='tooltip-hint-content'> <span id='tooltip-stardust_logs-heat'></span> Heat </div> </div> <div class='tooltip-hint-yellow'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/stardust.png' class='w30' /> </div> <div class='tooltip-hint-content'> Yields stardust when burned using a charcoal foundry or an oven. </div> </div>",
    "pine_logs": "<div class='tooltip-title'> PINE LOGS <br /> <span class='tooltip-rarity'><img style='padding-top:-4px' src='https://cdn.idle-pixel.com/images/rarity_icon_rare.png' class='w15'> Rare</span> </div> <img src='https://cdn.idle-pixel.com/images/coins.png' class='w15'> Sells for 200 coins <br /> <br /> <span class='tooltip-description'>Logs obtained from a pine tree.  The quality of wood is great.  The logs are very cold, and a lot of them are known to grow in the northern fields.</span> <br /> <br /> <span class='color-orange'><b>Pine Trees Chopped: </b> <span id='tooltip-pine_tree_chopped'>0</span></span> <br /> <br /> <div class='tooltip-hint-green'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/xp_arrow.png' class='w30' /> </div> <div class='tooltip-hint-content'> 17,000 XP per tree chop </div> </div> <div class='tooltip-hint-yellow'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/heat.png' class='w30' /> </div> <div class='tooltip-hint-content'> <span id='tooltip-pine_logs-heat'></span> Heat </div> </div>",
    "redwood_logs": "<div class='tooltip-title'> REDWOOD LOGS <br /> <span class='tooltip-rarity'><img style='padding-top:-4px' src='https://cdn.idle-pixel.com/images/rarity_icon_veryrare.png' class='w15'> Very Rare</span> </div> <img src='https://cdn.idle-pixel.com/images/coins.png' class='w15'> Sells for 500 coins <br /> <br /> <span class='tooltip-description'>Logs obtained from a redwood tree.  The quality of wood is excellent.</span> <br /> <br /> <span class='color-orange'><b>Redwood Trees Chopped: </b> <span id='tooltip-redwood_tree_chopped'>0</span></span> <br /> <br /> <div class='tooltip-hint-green'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/xp_arrow.png' class='w30' /> </div> <div class='tooltip-hint-content'> 25,000 XP per tree chop </div> </div> <div class='tooltip-hint-yellow'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/heat.png' class='w30' /> </div> <div class='tooltip-hint-content'> <span id='tooltip-redwood_logs-heat'></span> Heat </div> </div>",
    "dense_logs": "<div class='tooltip-title'> DENSE LOGS <br /> <span class='tooltip-rarity'><img style='padding-top:-4px' src='https://cdn.idle-pixel.com/images/rarity_icon_megarare.png' class='w15'> Mega Rare</span> </div> <img src='https://cdn.idle-pixel.com/images/coins.png' class='w15'> Sells for 10,000 coins <br /> <br /> <span class='tooltip-description'>Logs obtained from disassembling a club.  This log is very dense, packing a lot of heat.</span> <br /> <br /> <div class='tooltip-hint-yellow'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/heat.png' class='w30' /> </div> <div class='tooltip-hint-content'> <span id='tooltip-dense_logs-heat'></span> Heat </div> </div>",

    //food
    "bread": "<span class='color-primary'>Bread</span><br /><br />A nice loaf of bread.  It's still warm as it just came out of the oven.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 500</span>",
    "honey": "<span class='color-primary'>Honey</span><br /><br />Obtained from killing a bee.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 30</span>",
    "cheese": "<span class='color-primary'>Cheese</span><br /><br />Obtained from killing a rat.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 25</span>",
    "cooked_chicken": "<span class='color-primary'>Chicken</span><br /><br />A freshly baked chicken.  Crispy skin all around.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 50</span>",
    "cooked_bird_meat": "<span class='color-primary'>Cooked Bird Meat</span><br /><br />A cooked piece of bird meat.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 100</span>",
    "cooked_meat": "<span class='color-primary'>Cooked Meat</span><br /><br />A cooked piece of red meat.  My father always said, don't put ketchup on red meat.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 200</span>",
    
    //fruit tree food
    // DONT FORGET TO UPDATE tooltips.js --> load_fruit_bonus_energy_from_medium_ach()
    "apple": "<span class='color-primary'>Apples</span><br /><br />Obtained from fruit trees.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 25</span>",
    "banana": "<span class='color-primary'>Banana</span><br /><br />Obtained from fruit trees.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 50</span>",
    "orange": "<span class='color-primary'>Orange</span><br /><br />Obtained from fruit trees.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 100</span>",
    "coconut": "<span class='color-primary'>Coconut</span><br /><br />Obtained from fruit trees.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 1000</span>",
    "dragon_fruit": "<span class='color-primary'>Dragon Fruit</span><br /><br />Obtained from fruit trees.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 20,000</span>",

    "potato": "<span class='color-primary'>Potatoes</span><br /><br />Obtained from vegetable seeds.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 1000</span>",
    "carrot": "<span class='color-primary'>Carrots</span><br /><br />Obtained from vegetable seeds.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 2000</span>",
    "beet": "<span class='color-primary'>Beets</span><br /><br />Obtained from vegetable seeds.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 3000</span>",
    "broccoli": "<span class='color-primary'>Broccolis</span><br /><br />Obtained from vegetable seeds.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 5000</span>",
    
    
    "maple_syrup": "<span class='color-primary'>Maple Syrup (Produced in Canada, Quebec)</span><br /><br />Obtained from chopping down a maple tree.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 125</span>",
    
    "egg": "<span class='color-primary'>Egg</span><br /><br />A primary ingredients for the cook's book.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 50</span>",
    "chocolate": "<span class='color-primary'>Chocolate</span><br /><br />A primary ingredients for the cook's book.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 75</span>",
    "flour": "<span class='color-primary'>Flour</span><br /><br />A primary ingredients for the cook's book.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' />",

    "dotted_salad": "<span class='color-primary'>Dotted Leaf Salad</span><br /><br />Created using instructions from the cook's book.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: "+Cooking.ENERGY_MAP['dotted_salad']+"</span>",
    "chocolate_cake": "<span class='color-primary'>Chocolate Cake</span><br /><br />Created using instructions from the cook's book.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: "+Cooking.ENERGY_MAP['chocolate_cake']+"</span>",
    "lime_leaf_salad": "<span class='color-primary'>Lime Leaf Salad</span><br /><br />Created using instructions from the cook's book.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: "+Cooking.ENERGY_MAP['lime_leaf_salad']+"</span>",
    "golden_apple": "<span class='color-primary'>Golden Apple</span><br /><br />Created using instructions from the cook's book.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: "+Cooking.ENERGY_MAP['golden_apple']+"</span>",
    "banana_jello": "<span class='color-primary'>Banana Jello</span><br /><br />Created using instructions from the cook's book.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: "+Cooking.ENERGY_MAP['banana_jello']+"</span>",
    "orange_pie": "<span class='color-primary'>Orange Pie</span><br /><br />Created using instructions from the cook's book.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: "+Cooking.ENERGY_MAP['orange_pie']+"</span>",
    "pancakes": "<span class='color-primary'>Pancakes</span><br /><br />Created using instructions from the cook's book.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: "+Cooking.ENERGY_MAP['pancakes']+"</span>",
    "coconut_stew": "<span class='color-primary'>Coconut Stew</span><br /><br />Created using instructions from the cook's book.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: "+Cooking.ENERGY_MAP['coconut_stew']+"</span>",
    "dragon_fruit_salad": "<span class='color-primary'>Dragonfruit Salad</span><br /><br />Created using instructions from the cook's book.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: "+Cooking.ENERGY_MAP['dragon_fruit_salad']+"</span>",

    "potato_shake": "<span class='color-primary'>Shake (Potatoes)</span><br /><br />Created using instructions from the cook's book along with elite achievements from cooking.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: "+Cooking.ENERGY_MAP['potato_shake']+"</span>",
    "carrot_shake": "<span class='color-primary'>Shake (Carrots)</span><br /><br />Created using instructions from the cook's book along with elite achievements from cooking.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: "+Cooking.ENERGY_MAP['carrot_shake']+"</span>",
    "beet_shake": "<span class='color-primary'>Shake (Beets)</span><br /><br />Created using instructions from the cook's book along with elite achievements from cooking.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: "+Cooking.ENERGY_MAP['beet_shake']+"</span>",
    "broccoli_shake": "<span class='color-primary'>Shake (Broccoli)</span><br /><br />Created using instructions from the cook's book along with elite achievements from cooking.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: "+Cooking.ENERGY_MAP['broccoli_shake']+"</span>",

    "bird_bath": "<span class='color-primary'>Bird Bath (Dry)</span><br /><br />Attracts birds for your birdhouse.<br /><br /><span class='color-orange'>Requires water to work;  Defeat any enemy at the beach to add water to this item.</span>",
    "bird_bath_filled": "<span class='color-primary'>Bird Bath</span><br /><br />Attracts birds for your birdhouse.<br /><br /><span class='color-green'>The next time you add seeds to your bird house, the timer will be reduced from 24h to 6h.</span><br /><br /><span class='color-red'>The water will empty and will require a refill on use.</span>",
    "bird_bath_enchanted": "<span class='color-primary'>Bird Bath (Enchanted)</span><br /><br />Attracts birds for your birdhouse.<br /><br /><span class='color-green'>The next time you add seeds to your bird house, the timer will be reduced from 24h to 6h.</span>",

    
    "maggots": "<span class='color-primary'>Maggots</span><br /><br />Yuck!<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 1</span>",
    "candy": "<span class='color-primary'>Candy</span><br /><br />Happy Holidays!<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 1</span>",

    "mega_tablette_50": "<span class='color-primary'>Mega Tablette</span><br /><br />Add extra tablette pieces to help complete this community mega tablette.<br /><br /><span class='color-lime'>Click to view</span>",


    //food fish
    "cooked_shrimp": "<span class='color-primary'>Shrimp</span><br /><br />A cooked fish obtained from a fishing net.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 25</span>",
    "cooked_anchovy": "<span class='color-primary'>Anchovy</span><br /><br />A cooked fish obtained from a fishing net.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 100</span>",
    "cooked_sardine": "<span class='color-primary'>Sardine</span><br /><br />A cooked fish obtained from a fishing net.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 200</span>",
    "cooked_crab": "<span class='color-primary'>Crab</span><br /><br />A cooked fish obtained from a fishing net.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 500</span>",
    "cooked_piranha": "<span class='color-primary'>Piranha</span><br /><br />A cooked fish obtained from a fishing net.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 1000</span>",
    
    "cooked_salmon": "<span class='color-primary'>Salmon</span><br /><br />A cooked fish obtained from a fishing rod.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 100</span>",
    "cooked_trout": "<span class='color-primary'>Trout</span><br /><br />A cooked fish obtained from a fishing rod.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 300</span>",
    "cooked_pike": "<span class='color-primary'>Pike</span><br /><br />A cooked fish obtained from a fishing rod.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 1000</span>",
    "cooked_eel": "<span class='color-primary'>Eel</span><br /><br />A cooked fish obtained from a fishing rod.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 3000</span>",
    "cooked_rainbow_fish": "<span class='color-primary'>Rainbow Fish</span><br /><br />A cooked fish obtained from a fishing rod.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 30,000</span>",
    
    "cooked_tuna": "<span class='color-primary'>Tuna</span><br /><br />A cooked fish obtained from a harpoon.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 500</span>",
    "cooked_swordfish": "<span class='color-primary'>Swordfish</span><br /><br />A cooked fish obtained from a harpoon.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 3000</span>",
    "cooked_manta_ray": "<span class='color-primary'>Manta Ray</span><br /><br />A cooked fish obtained from a harpoon.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 9000</span>",
    "cooked_shark": "<span class='color-primary'>Shark</span><br /><br />A cooked fish obtained from a harpoon.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 20,000</span>",
    "cooked_bloated_shark": "<span class='color-primary'>Shark</span><br /><br />A cooked fish obtained from killing a shark from the beach.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 20,000</span>",
    "cooked_whale": "<span class='color-primary'>Whale</span><br /><br />A cooked fish obtained from a harpoon.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 40,000</span>",

    "cooked_angler_fish": "<span class='color-primary'>Angler Fish</span><br /><br />A cooked fish obtained from a submarine.  It's very bright!<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 100,000</span>",

    //food fish (shiny)
    "cooked_shrimp_shiny": "<span class='color-primary'>Shrimp</span><br /><br />A cooked fish obtained from a fishing net.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 125</span>",
    "cooked_anchovy_shiny": "<span class='color-primary'>Anchovy</span><br /><br />A cooked fish obtained from a fishing net.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 500</span>",
    "cooked_sardine_shiny": "<span class='color-primary'>Sardine</span><br /><br />A cooked fish obtained from a fishing net.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 1000</span>",
    "cooked_crab_shiny": "<span class='color-primary'>Crab</span><br /><br />A cooked fish obtained from a fishing net.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 2500</span>",
    "cooked_piranha_shiny": "<span class='color-primary'>Piranha</span><br /><br />A cooked fish obtained from a fishing net.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 5000</span>",
    
    "cooked_salmon_shiny": "<span class='color-primary'>Salmon</span><br /><br />A cooked fish obtained from a fishing rod.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 500</span>",
    "cooked_trout_shiny": "<span class='color-primary'>Trout</span><br /><br />A cooked fish obtained from a fishing rod.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 1500</span>",
    "cooked_pike_shiny": "<span class='color-primary'>Pike</span><br /><br />A cooked fish obtained from a fishing rod.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 5000</span>",
    "cooked_eel_shiny": "<span class='color-primary'>Eel</span><br /><br />A cooked fish obtained from a fishing rod.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 15,000</span>",
    "cooked_rainbow_fish_shiny": "<span class='color-primary'>Rainbow Fish</span><br /><br />A cooked fish obtained from a fishing rod.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 150,000</span>",
    
    "cooked_tuna_shiny": "<span class='color-primary'>Tuna</span><br /><br />A cooked fish obtained from a harpoon.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 2500</span>",
    "cooked_swordfish_shiny": "<span class='color-primary'>Swordfish</span><br /><br />A cooked fish obtained from a harpoon.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 15,000</span>",
    "cooked_manta_ray_shiny": "<span class='color-primary'>Manta Ray</span><br /><br />A cooked fish obtained from a harpoon.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 45,000</span>",
    "cooked_shark_shiny": "<span class='color-primary'>Shark</span><br /><br />A cooked fish obtained from a harpoon.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 100,000</span>",
    "cooked_whale_shiny": "<span class='color-primary'>Whale</span><br /><br />A cooked fish obtained from a harpoon.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 200,000</span>",

    //food fish (mega)
    "cooked_shrimp_mega_shiny": "<span class='color-primary'>Shrimp</span><br /><br />A cooked fish obtained from a fishing net.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 625</span>",
    "cooked_anchovy_mega_shiny": "<span class='color-primary'>Anchovy</span><br /><br />A cooked fish obtained from a fishing net.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 2500</span>",
    "cooked_sardine_mega_shiny": "<span class='color-primary'>Sardine</span><br /><br />A cooked fish obtained from a fishing net.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 5000</span>",
    "cooked_crab_mega_shiny": "<span class='color-primary'>Crab</span><br /><br />A cooked fish obtained from a fishing net.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 10,000</span>",
    "cooked_piranha_mega_shiny": "<span class='color-primary'>Piranha</span><br /><br />A cooked fish obtained from a fishing net.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 25,000</span>",
    
    "cooked_salmon_mega_shiny": "<span class='color-primary'>Salmon</span><br /><br />A cooked fish obtained from a fishing rod.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 2500</span>",
    "cooked_trout_mega_shiny": "<span class='color-primary'>Trout</span><br /><br />A cooked fish obtained from a fishing rod.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 7500</span>",
    "cooked_pike_mega_shiny": "<span class='color-primary'>Pike</span><br /><br />A cooked fish obtained from a fishing rod.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 25,000</span>",
    "cooked_eel_mega_shiny": "<span class='color-primary'>Eel</span><br /><br />A cooked fish obtained from a fishing rod.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 75,000</span>",
    "cooked_rainbow_fish_mega_shiny": "<span class='color-primary'>Rainbow Fish</span><br /><br />A cooked fish obtained from a fishing rod.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 750,000</span>",
    
    "cooked_tuna_mega_shiny": "<span class='color-primary'>Tuna</span><br /><br />A cooked fish obtained from a harpoon.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 10,000</span>",
    "cooked_swordfish_mega_shiny": "<span class='color-primary'>Swordfish</span><br /><br />A cooked fish obtained from a harpoon.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 75,000</span>",
    "cooked_manta_ray_mega_shiny": "<span class='color-primary'>Manta Ray</span><br /><br />A cooked fish obtained from a harpoon.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 225,000</span>",
    "cooked_shark_mega_shiny": "<span class='color-primary'>Shark</span><br /><br />A cooked fish obtained from a harpoon.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 500,000</span>",
    "cooked_whale_mega_shiny": "<span class='color-primary'>Whale</span><br /><br />A cooked fish obtained from a harpoon.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 1,000,000</span>",


    //food stardust fish
    "cooked_small_stardust_fish": "<span class='color-primary'>Stardust Fish (small)</span><br /><br />A cooked fish obtained from the stardust boat.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 1000</span><br /><br />Eating this will give you stardust.",
    "cooked_medium_stardust_fish": "<span class='color-primary'>Stardust Fish (medium)</span><br /><br />A cooked fish obtained from the stardust boat.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 2500</span><br /><br />Eating this will give you stardust.",
    "cooked_large_stardust_fish": "<span class='color-primary'>Stardust Fish (large)</span><br /><br />A cooked fish obtained from the stardust boat.<br /><br /><img src='https://cdn.idle-pixel.com/images/energy.png' class='img-20' /> <span class='color-lime'>Energy: 5000</span><br /><br />Eating this will give you stardust.",
    
    "cooks_book": "<span class='color-primary'>Cooks Book</span><br /><br />A book filled with instructions to create dishes for extra energy.",

    "sigil": "<span class='color-primary'>Sigil</span><br /><br />A sigil used as a chat icon.<br /><br /><span class='color-lime'>Click to enable</span>",
    
    "green_gaurdian_key": "<span class='color-primary'>Green Guardian Key</span><br /><br />Use this key to fight the guardian in the haunted mansion.<br /><br /><span class='color-lime'>Fightpoints: 4000<br />Energy: 5000</span>",
    "blue_gaurdian_key": "<span class='color-primary'>Blue Guardian Key</span><br /><br />Use this key to fight the guardian from the beach.<br /><br /><span class='color-lime'>Fightpoints: 6000<br />Energy: 20,000</span>",
    "purple_gaurdian_key": "<span class='color-primary'>Purple Guardian Key</span><br /><br />Use this key to fight the guardian from the first floor of the castle.<br /><br /><span class='color-lime'>Fightpoints: 10,000<br />Energy: 50,000</span>",
    "mixed_gaurdian_key": "<span class='color-primary'>Mixed Guardian Key</span><br /><br />Use this key to fight the last guardian, the dragon.<br /><br /><span class='color-lime'>Fightpoints: 10,000<br />Energy: 200,000</span>",
    
    
    "shop-ghost": "<span class='color-primary'>Ghost Shop</span><br /><br />This item requires ghost essence to purchase, looted from the haunted mansion.",

    "bone_amulet": "<span class='color-primary'>Bone amulet</span><br /><br />Obtain double loot for <u>normal</u> bones.",
    "ashes_amulet": "<span class='color-primary'>Ashes amulet</span><br /><br />Obtain double loot for normal bones and ashes.",
    "ice_amulet": "<span class='color-primary'>Ice amulet</span><br /><br />Obtain double loot for normal bones, ashes and ice bones.",
    "blood_amulet": "<span class='color-primary'>Blood amulet</span><br /><br />Obtain double loot for normal bones, ashes and ice bones and blood bones.",

    "amulet_of_healing_rain": "<span class='color-primary'>Amulet of Healing Rain</span><br /><br />Acts like a rain potion when equipped, healing you when it rains during combat.",

    "telescope": "<span class='color-primary'>Telescope</span><br /><br />Click to observe the night sky.",


    "charcoal_foundry": "<span class='color-primary'>Charcoal Foundry</span><br /><br />Small chance to convert logs into charcoal.",
    "titanium_charcoal_foundry": "<span class='color-primary'>Titanium Charcoal Foundry</span><br /><br />Obtain double charcoal from logs.",


    

    //misc
    "feathers": "<span class='color-primary'>Feathers</span><br /><br />Used to make arrows with iron bars and logs.<br /><br /><span class='color-lime'>Click to craft</span>",
    "fire_feathers": "<span class='color-primary'>Fire Feathers</span><br /><br />Used to make arrows with silver bars and oak logs.<br /><br /><span class='color-lime'>Click to craft</span>",
    "ice_feathers": "<span class='color-primary'>Ice Feathers</span><br /><br />Used to make arrows with gold bars and willow logs.<br /><br /><span class='color-lime'>Click to craft</span>",
    "ancient_feathers": "<span class='color-primary'>Ancient Feathers</span><br /><br />Used to make arrows with ancient bars and redwood logs.<br /><br /><span class='color-lime'>Click to craft</span>",
    "lizard_skin": "<span class='color-primary'>Lizard Skin</span><br /><br />Can be crafted into lizard armour.<br /><br /><span class='color-lime'>Click to craft</span>",
    "moonstone": "<span class='color-primary'>Moonstone</span><br /><br />Can be crafted into moonstone armour.<br /><br /><span class='color-lime'>Click to craft</span>",
    "meteor": "<span class='color-primary'>Meteor</span><br /><br />Can be mined for various materials.<br /><br /><span class='color-lime'>Click to mine</span><br /><br /><span class='color-cyan'>Requires level 90 mining.</span>",
    "bat_skin": "<span class='color-primary'>Bat Skin</span><br /><br />Can be crafted into bat armour.<br /><br /><span class='color-lime'>Click to craft</span>",
    "bear_fur": "<span class='color-primary'>Bear Fur</span><br /><br />Can be crafted into bear armour.  It does not provide any defence but it's nice and warm.<br /><br /><span class='color-lime'>Click to craft</span>",
    "crocodile_hide": "<span class='color-primary'>Crocodile Hide</span><br /><br />Can be crafted into crocodile armour.<br /><br /><span class='color-lime'>Click to craft</span>",
    "reaper_silk": "<span class='color-primary'>Reaper Silk</span><br /><br />Can be crafted into reaper robes.<br /><br /><span class='color-lime'>Click to craft</span>",
    "frozen_crocodile_hide": "<span class='color-primary'>Crocodile Hide (Frozen)</span><br /><br />Can be crafted into frozen crocodile armour.<br /><br /><span class='color-lime'>Click to craft</span>",
    "poison": "<span class='color-primary'>Poison</span><br /><br />Ability to cover certain weapons to poison them.<br /><br /><span class='color-lime'>Click to add poison to a weapon</span>",
    "bait": "<span class='color-primary'>Fishing Bait</span><br /><br />Throw some bait into the water to instantly catch a fish.  The fish type you get depends on your fishing level and fishing tool.<br /><br /><span class='color-lime'>Click to throw bait into the water</span>",
    "super_bait": "<span class='color-primary'>Super Fishing Bait</span><br /><br />Throw some bait into the water to instantly catch a shiny fish.  The fish type you get depends on your fishing level and fishing tool.<br /><br /><span class='color-lime'>Click to throw super bait into the ocean</span><br /><br /><span class='color-orange'>Note: Can be used to feed fish in an aquarium.</span>",
    "mega_bait": "<span class='color-primary'>Mega Fishing Bait</span><br /><br />Throw some bait into the water to instantly catch a mega shiny fish.  The fish type you get depends on your fishing level and fishing tool.<br /><br /><span class='color-lime'>Click to throw mega bait into the ocean</span><br /><br /><span class='color-orange'>Note: Can be used to feed fish in an aquarium.</span>",
    "thief_leader_note": "<span class='color-primary'>A note</span><br /><br />Left behind after the thief leader teleported out of combat.",
    "gathering_worker": "<span class='color-primary'>Gatherer</span><br /><br />Slowly gathers bags for you in a random area. (Unable to find uniques)",
    "goblin_toenails": "<span class='color-primary'>Goblin Toenails</span><br /><br />They stink.",
    "fight_points": "<span class='color-primary'>Fight points</span><br /><br />Fight points are required to fight in combat areas.  The harder the area, the more points required.<br /><br /><span class='color-lime'>+1 point per second</span>",
    "sapphire_fight_points": "<span class='color-primary'>Fight points</span><br /><br />Fight points are required to fight in combat areas.  The harder the area, the more points required.<br /><br /><span class='color-grey'>Cap: 2000</span><br /><span class='color-lime'>+1 point per second</span>",
    "emerald_fight_points": "<span class='color-primary'>Fight points</span><br /><br />Fight points are required to fight in combat areas.  The harder the area, the more points required.<br /><br /><span class='color-grey'>Cap: 4000</span><br /><span class='color-lime'>+1 point per second</span>",
    "ruby_fight_points": "<span class='color-primary'>Fight points</span><br /><br />Fight points are required to fight in combat areas.  The harder the area, the more points required.<br /><br /><span class='color-grey'>Cap: 8000</span><br /><span class='color-lime'>+1 point per second</span>",
    "diamond_fight_points": "<span class='color-primary'>Fight points</span><br /><br />Fight points are required to fight in combat areas.  The harder the area, the more points required.<br /><br /><span class='color-grey'>Cap: 12,000</span><br /><span class='color-lime'>+1 point per second</span>",
    "combat_log": "<span class='color-primary'>Combat Log</span><br /><br />Track the number of monsters you have killed and ability to see what loot they drop.<br /><br /><span class='color-lime'>Click to read</span>",
    "ant_needles": "<span class='color-primary'>Ant Needles</span><br /><br />These are very sharp!<br /><br /><span class='color-lime'>Click to craft</span>",
    "needle": "<span class='color-primary'>Needle</span><br /><br />Ability to turn armour back into skin.<br /><br /><span class='color-lime'>Click to use</span>",
    "oil_factory": "<span class='color-primary'>Oil Factory</span><br /><br />Hire workers to gather oil for you.<br /><br /><span class='color-lime'>Click to manage</span>",
    "pirate": "<span class='color-primary'>Pirate</span><br /><br />Actively looking for treasure maps.  The more pirates you hire, the better the chance of finding treasure maps.",
    "monoculars": "<span class='color-primary'>Monoculars</span><br /><br />Pirates may now find <span class='color-lime'>green maps</span> for <span class='color-lime'>green treasure chests</span> which can<br />give <span class='color-lime'>green orbs</span> and other loot.",
    "sextant": "<span class='color-primary'>Sextant</span><br /><br />Pirates may now find <span class='color-red'>red maps</span> for <span class='color-red'>red treasure chests</span> which can<br />give <span class='color-red'>red orbs</span> and other loot.",
    "cannon_base": "<span class='color-primary'>Cannon Base</span><br /><br />A 1/3 piece required to craft a cannon.",
    "cannonball_mould": "<span class='color-primary'>Cannonball Mould</span><br /><br />One time use to craft additional cannonballs. <br /><br /><span class='color-lime'>Click to craft.</span>",
    "cannon_wheels": "<span class='color-primary'>Cannon Wheels</span><br /><br />A 1/3 piece required to craft a cannon.",
    "cannon_barrel": "<span class='color-primary'>Cannon Barrel</span><br /><br />A 1/3 piece required to craft a cannon.",
    "iron_bucket": "<span class='color-primary'>Iron Bucket</span><br /><br />A solid bucket that can hold lava.<br /><br /><span class='color-grey'>Killing an enemy in the volcano will automatically fill up a bucket with lava.</span>",
    "lava": "<span class='color-primary'>Lava</span><br /><br />Can be used to smelt titanium ore.",
    "plasma": "<span class='color-primary'>Plasma</span><br /><br />Can be used to smelt ancient ore.",
    "dragon_fire": "<span class='color-primary'>Dragon's Breath</span><br /><br /><span class='color-red'>Can be used to smelt dragon ore.</span>",
    "train_cart": "<span class='color-primary'>Train Cart</span><br /><br />Wonder what I can do with this.",
    "string": "<span class='color-primary'>String</span><br /><br />Click to craft.",
    "junk": "<span class='color-primary'>Junk</span><br /><br />A bunch of random junk found from gathering.<br /><br />I wonder if this will have a use?",
    "menu_bar_crystals": "<span class='color-primary'>Crystals</span><br /><br />According to the wizard, I need all crystals to protect ourselves from Faradox.",
    "bomb": "<span class='color-primary'>Bomb</span><br /><br />This bomb is not very useful in combat.  Detonating it would kill both you and the enemy.<br /><br />It can be used as a mining method, detonating deep into a mine.<br /><br /><span class='color-lime'>Click to detonate into the mines.</span>",
    "tnt": "<span class='color-primary'>TNT</span><br /><br />This tnt is not very useful in combat.  Detonating it would kill both you and the enemy.<br /><br />It can be used as a mining method, detonating deep into a mine.  Creating an extremely large explosion.<br /><br /><span class='color-lime'>Click to detonate into the mines.</span>",
    "heavy_rock": "<span class='color-primary'>Heavy Rock</span><br /><br />A very heavy rock.  Can be useful for pressure plates found all around the castle.",
    "mega_bomb": "<span class='color-primary'>Mega Bomb</span><br /><br />This is not very useful in combat.  Detonating it would kill both you and the enemy.<br /><br />It can be used as a mining method, detonating deep into a mine.  Creating an mega explosion.<br /><br /><span class='color-lime'>Click to detonate into the mines.</span>",
    "mirror":"<span class='color-primary'>Mirror</span><br /><br />Click to look at yourself.",
    "mirror_smashed":"<span class='color-primary'>Mirror</span><br /><br />Huh, you have a bad feeling about smashing your mirror.",
    "shovel_handle": "<span class='color-primary'>Shovel Handle</span><br /><br />Can be used to made into a shovel from the crafting table.",
    "goblin_mask": "<span class='color-primary'>Goblin Mask</span><br /><br />Doesn't have any stats.  Perhaps only useful for cosplay.",
    "blood_goblin_mask": "<span class='color-primary'>Goblin Mask</span><br /><br />Doesn't have any stats.  Perhaps only useful for cosplay.",
    "thiefs_mask": "<span class='color-primary'>Thiefs Mask</span><br /><br />Doesn't have any stats.<br /><br />20% chance to steal items without paying when interacting with the merchant.<br /><br /><span class='color-grey'>You do not have to be wearing the mask for this to work, having it in your inventory or wielding it is fine.</span>",
    "brewing_kit": "<span class='color-primary'>Brewing Kit</span><br /><br />Increases duration of all potions when upgraded.<br /><br /><span class='color-lime'>+0% potion timers</span>",
    "sapphire_brewing_kit": "<span class='color-primary'>Brewing Kit</span><br /><br />Increases duration of all potions.<br /><br /><span class='color-lime'>+25% potion timers</span>",
    "emerald_brewing_kit": "<span class='color-primary'>Brewing Kit</span><br /><br />Increases duration of all potions.<br /><br /><span class='color-lime'>+50% potion timers</span>",
    "ruby_brewing_kit": "<span class='color-primary'>Brewing Kit</span><br /><br />Increases duration of all potions.<br /><br /><span class='color-lime'>+75% potion timers</span>",
    "diamond_brewing_kit": "<span class='color-primary'>Brewing Kit</span><br /><br />Increases duration of all potions.<br /><br /><span class='color-lime'>+100% potion timers</span>",
    "strange_leaf_fertilizer":"<span class='color-primary'>Fertilizer</span><br /><br />Permanently gives you a chance of obtaining strange leaves when chopping any tree.<br /><br /><span class='color-lime'>Click to use.</span>",
    "molten_glass":"<span class='color-primary'>Molten glass</span><br /><br />Can be used to create glass items from crafting.",
    "dense_molten_glass":"<span class='color-primary'>Molten glass (Dense)</span><br /><br />Can be used to create superior glass items from invention.",
    "sea_molten_glass":"<span class='color-primary'>Sea glass (Very Dense)</span><br /><br />Can be used to create superior glass items from crafting.  This glass has been sitting in the bottom of the ocean for decades.",
    
    "shiny_glass_ball":"<span class='color-primary'>Shiny Glass Orb</span><br /><br />Can be enchanted which allows you to have a small chance of getting shiny resources based on enchantment chosen.<br /><br /><span class='color-lime'>Click to enchant.</span>",
    "shiny_glass_ball_logs":"<span class='color-primary'>Shiny Glass Orb (Woodcutting)</span><br /><br />1% chance that when a tree starts growing, it'll become shiny.",
    "shiny_glass_ball_leaf":"<span class='color-primary'>Shiny Glass Orb (Farming)</span><br /><br />1% chance that planting some crops will make it become shiny.",
    "shiny_glass_ball_fish":"<span class='color-primary'>Shiny Glass Orb (Fishing)</span><br /><br />1% chance that catching a fish will be shiny.",
    "shiny_glass_ball_monsters":"<span class='color-primary'>Shiny Glass Orb (Combat)</span><br /><br />1% chance that any monster encountered will be shiny.",
   
    "mega_shiny_glass_ball_logs":"<span class='color-primary'>Shiny Glass Orb (Woodcutting)</span><br /><br />1% chance that when a tree starts growing, it'll become shiny.  There is also a 1% chance that the shiny tree will become mega shiny.",
    "mega_shiny_glass_ball_leaf":"<span class='color-primary'>Shiny Glass Orb (Farming)</span><br /><br />1% chance that planting some crops will make it become shiny.  There is also a 1% chance that the crop will become mega shiny.",
    "mega_shiny_glass_ball_fish":"<span class='color-primary'>Shiny Glass Orb (Fishing)</span><br /><br />1% chance that catching a fish will be shiny. There is also a 1% chance that the fish will become mega shiny.",
    "mega_shiny_glass_ball_monsters":"<span class='color-primary'>Shiny Glass Orb (Combat)</span><br /><br />1% chance that any monster encountered will be shiny. There is also a 1% chance that the monster will become mega shiny.",
   
    "mega_shiny_glass_ball_logs_plus":"<span class='color-primary'>Shiny Glass Orb (Woodcutting)</span><br /><br />2% chance that when a tree starts growing, it'll become shiny.  There is also a 1% chance that the shiny tree will become mega shiny.",
    "mega_shiny_glass_ball_leaf_plus":"<span class='color-primary'>Shiny Glass Orb (Farming)</span><br /><br />2% chance that planting some crops will make it become shiny.  There is also a 1% chance that the crop will become mega shiny.",
    "mega_shiny_glass_ball_fish_plus":"<span class='color-primary'>Shiny Glass Orb (Fishing)</span><br /><br />2% chance that catching a fish will be shiny. There is also a 1% chance that the fish will become mega shiny.",
    "mega_shiny_glass_ball_monsters_plus":"<span class='color-primary'>Shiny Glass Orb (Combat)</span><br /><br />2% chance that any monster encountered will be shiny. There is also a 1% chance that the monster will become mega shiny.",

    "skull":"<span class='color-primary'>Skull</span><br /><br />I wonder what this is for.",
    "oven_boost":"<span class='color-primary'>Oven Booster</span><br /><br />Adding logs to your oven will convert into heat much faster.",
    "dragon_oven_boost":"<span class='color-primary'>Oven Booster+</span><br /><br />Adding logs to your oven will be processed into heat almost instantly.",
    
    "submarine_boat":"<span class='color-primary'>Submarine</span><br /><br />Ability to explore the ocean's floor, containing special treasure chests, keys, weapon parts and more.<br /><br /><span class='color-grey'>A submarine is considered a boat item type.</span>",
    
    "easter2024":"<span class='color-primary'>Easter Event 2024</span>",
    "chocolate_certificate":"<span class='color-primary'>Chocolate Certificate</span><br /><br />Valid for one entry to bunny raiding.",

    "raids_hp_potion":"<span class='color-primary'>Raids Potion (HP)</span><br /><br />Fully heal during a raid.<br /><br /><span class='color-grey font-small'>Can only be used once per raid</span>",
    "raids_mana_potion":"<span class='color-primary'>Raids Potion (Mana)</span><br /><br />Fully recover mana during a raid.<br /><br /><span class='color-grey font-small'>Can only be used once per raid</span>",
    "raids_crits_potion":"<span class='color-primary'>Raids Potion (Crits)</span><br /><br />Critical hits are now every 4 hits instead of 5 and lasts for the full duration of one raid.<br /><span class='color-lime'>Applies to all team members!</span><br /><br /><span class='color-grey font-small'>Can only be used once per raid</span>",
    

    "bobs_book":"<span class='color-primary'>Bob's Legacy</span><br /><br />A book of bob's legacy.",
    "sledge_hammer":"<span class='color-primary'>Doric's Sledge Hammer</span><br /><br />Can be used to break rocks within the castle.<br /><br />Rest in peace Doric.",
    

    "treasure_map": "<span class='color-primary'>Treasure Map</span><br /><br />Click to read map.<br /><br /><span class='color-grey'>You may only hold one map of this type at a time.</span>",
    "green_treasure_map": "<span class='color-primary'>Green Treasure Map</span><br /><br />Click to read map.<br /><br /><span class='color-grey'>You may only hold one map of this type at a time.</span>",
    "red_treasure_map": "<span class='color-primary'>Red Treasure Map</span><br /><br />Click to read map.<br /><br /><span class='color-grey'>You may only hold one map of this type at a time.</span>",

    "small_stardust_prism": "<span class='color-primary'>Stardust Prism (Small)</span><br /><br />Contains a small amount of stardust.",
    "medium_stardust_prism": "<span class='color-primary'>Stardust Prism (Medium)</span><br /><br />Contains a medium amount of stardust.",
    "large_stardust_prism": "<span class='color-primary'>Stardust Prism (Large)</span><br /><br />Contains a lot of stardust.",
    "huge_stardust_prism": "<span class='color-primary'>Stardust Prism (Huge)</span><br /><br />Contains a ton of stardust.",

    
    "giant_mould": "<span class='color-primary'>Giant Mould</span><br /><br />Ability to craft a very dense metal bar made from different types of bars.<br /><br />Click to craft.",
    "giant_metal_ball": "<span class='color-primary'>Giant Dense Metal Ball</span><br /><br />Can be dropped from a high place within the castle.",
    
    "shark_tooth": "<span class='color-primary'>Shark Tooth</span><br /><br />Obtained from sharks roaming the beach.  It's very sharp!",
    "puffer_needles": "<span class='color-primary'>Puffer Needles</span><br /><br />These are extremely sharp!<br /><br /><span class='color-lime'>Click to craft</span>",

    //gems
    "sapphire": "<div class='tooltip-title'> SAPPHIRE <br /> <span class='tooltip-rarity'><img style='padding-top:-4px' src='https://cdn.idle-pixel.com/images/rarity_icon_rare.png' class='w15'> Rare</span> </div> <img src='https://cdn.idle-pixel.com/images/coins.png' class='w15'> Sells for 10,000 coins <br /> <br /> <span class='tooltip-description'>This is the most common of the four gems.  The dark blue color reminds you of the ocean, which is filled with sharks, puffer fishes and other monsters which I can fight later on.</span> <br /> <br /> <span class='color-orange'><b>Total mined:</b> <span id='tooltip-sapphire_total'>0</span></span> <br /> <br /> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/info.png' class='w30' /> </div> <div class='tooltip-hint-content'> The drop rate for sapphires is 1/100,000 every second. </div> </div>",
    "emerald": "<div class='tooltip-title'> EMERALD <br /> <span class='tooltip-rarity'><img style='padding-top:-4px' src='https://cdn.idle-pixel.com/images/rarity_icon_rare.png' class='w15'> Rare</span> </div> <img src='https://cdn.idle-pixel.com/images/coins.png' class='w15'> Sells for 25,000 coins <br /> <br /> <span class='tooltip-description'>This is the second most common of the four gems.  The light green color reminds you of the poison green spit from snakes in the forest.  I should be careful fighting this monster later on.</span> <br /> <br /> <span class='color-orange'><b>Total mined:</b> <span id='tooltip-emerald_total'>0</span></span> <br /> <br /> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/info.png' class='w30' /> </div> <div class='tooltip-hint-content'> The drop rate for emeralds is 1/250,000 every second. </div> </div>",
    "ruby": "<div class='tooltip-title'> RUBY <br /> <span class='tooltip-rarity'><img style='padding-top:-4px' src='https://cdn.idle-pixel.com/images/rarity_icon_veryrare.png' class='w15'> Very Rare</span> </div> <img src='https://cdn.idle-pixel.com/images/coins.png' class='w15'> Sells for 50,000 coins <br /> <br /> <span class='tooltip-description'>This is the second rarest gem between the four, just behind the diamond.  The dark red color reminds you of the blood moon.  I hope this event doesn't occur anytime soon.</span> <br /> <br /> <span class='color-orange'><b>Total mined:</b> <span id='tooltip-ruby_total'>0</span></span> <br /> <br /> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/info.png' class='w30' /> </div> <div class='tooltip-hint-content'> The drop rate for rubies are 1/500,000 every second. </div> </div>",
    "diamond": "<div class='tooltip-title'> DIAMOND <br /> <span class='tooltip-rarity'><img style='padding-top:-4px' src='https://cdn.idle-pixel.com/images/rarity_icon_veryrare.png' class='w15'>Very Rare</span> </div> <img src='https://cdn.idle-pixel.com/images/coins.png' class='w15'> Sells for 100,000 coins <br /> <br /> <span class='tooltip-description'>This is the rarest of the four gems.  The light blue color reminds you of the sky.  You can see rockets currently going to the moon & sun.  Hopefully I'll be on one of those someday.</span> <br /> <br /> <span class='color-orange'><b>Total mined:</b> <span id='tooltip-diamond_total'>0</span></span> <br /> <br /> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/info.png' class='w30' /> </div> <div class='tooltip-hint-content'> The drop rate for diamonds is 1/1,000,000 every second. </div> </div>",
    "blood_diamond": "<div class='tooltip-title'> BLOOD DIAMOND <br /> <span class='tooltip-rarity'><img style='padding-top:-4px' src='https://cdn.idle-pixel.com/images/rarity_icon_legendary.png' class='w15'>Legendary</span> </div> <img src='https://cdn.idle-pixel.com/images/coins.png' class='w15'> Sells for 2,500,000 coins <br /> <br /> <span class='tooltip-description color-red'>The legendary blood diamond is the rarest gem in the game.  Most players do not get this item.  It reminds you of the evil Faradox.</span> <br /> <br /> <span class='color-orange'><b>Total mined:</b> <span id='tooltip-blood_diamond_total'>0</span></span> <br /> <br /> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/info.png' class='w30' /> </div> <div class='tooltip-hint-content'> The drop rate for diamonds is 1/25,000,000 every second. </div> </div> <div class='tooltip-hint'> <div class='tooltip-hint-image'> <img src='https://cdn.idle-pixel.com/images/trophy.png' class='w30' /> </div> <div class='tooltip-hint-content'> Trophy Item. </div> </div>",
    
    "glass_bottle_ghost": "<span class='color-primary'>Ghost</span><br /><br />A captured ghost from the haunted mansion.<br /><br /><span class='color-lime'>Click to interact</span>",
    "glass_bottle": "<span class='color-primary'>Glass Bottle</span><br /><br />Can be used to collect ghosts from the haunted mansion.<br /><br /><span class='color-lime'>Specifically this ghost: <img src='https://cdn.idle-pixel.com/images/ghost_icon.png' /></span>",
    "ghost_essence": "<span class='color-primary'>Ghost Essence</span><br /><br />Ghost essence found in the haunted mansion.",
    "glass_bottle_spell": "Click to open",

    //combat presets
    "combat-preset-1": "<span class='color-primary'>PRESETS</span><br /><br />Press 1 to quickload.",
    "combat-preset-2": "<span class='color-primary'>PRESETS</span><br /><br />Press 2 to quickload.",
    "combat-preset-3": "<span class='color-primary'>PRESETS</span><br /><br />Press 3 to quickload.",
    "combat-preset-4": "<span class='color-primary'>PRESETS</span><br /><br />Press 4 to quickload.",
    "combat-preset-5": "<span class='color-primary'>PRESETS</span><br /><br />Press 5 to quickload.",
    
    "gold_key": "<span class='color-primary'>Treasure Chest Key</span><br /><br />Can be used to open a treasure chest.<br /><br /><span class='color-grey'>1 roll</span>",
    "gold_sapphire_key": "<span class='color-primary'>Treasure Chest Key</span><br /><br />Can be used to open a treasure chest.<br /><br /><span class='color-grey'>2 rolls</span>",
    "gold_emerald_key": "<span class='color-primary'>Treasure Chest Key</span><br /><br />Can be used to open a treasure chest.<br /><br /><span class='color-grey'>3 rolls</span>",
    "gold_ruby_key": "<span class='color-primary'>Treasure Chest Key</span><br /><br />Can be used to open a treasure chest.<br /><br /><span class='color-grey'>4 rolls</span>",
    "gold_diamond_key": "<span class='color-primary'>Treasure Chest Key</span><br /><br />Can be used to open a treasure chest.<br /><br /><span class='color-grey'>6 rolls</span>",
    
    "promethium_key": "<span class='color-primary'>Treasure Chest Key</span><br /><br />Can be used to open a green treasure chest.<br /><br /><span class='color-grey'>1 roll</span>",
    "promethium_sapphire_key": "<span class='color-primary'>Treasure Chest Key</span><br /><br />Can be used to open a green treasure chest.<br /><br /><span class='color-grey'>2 rolls</span>",
    "promethium_emerald_key": "<span class='color-primary'>Treasure Chest Key</span><br /><br />Can be used to open a green treasure chest.<br /><br /><span class='color-grey'>3 rolls</span>",
    "promethium_ruby_key": "<span class='color-primary'>Treasure Chest Key</span><br /><br />Can be used to open a green treasure chest.<br /><br /><span class='color-grey'>4 rolls</span>",
    "promethium_diamond_key": "<span class='color-primary'>Treasure Chest Key</span><br /><br />Can be used to open a green treasure chest.<br /><br /><span class='color-grey'>6 rolls</span>",

    "titanium_key": "<span class='color-primary'>Treasure Chest Key</span><br /><br />Can be used to open a red treasure chest.<br /><br /><span class='color-grey'>1 roll</span>",
    "titanium_sapphire_key": "<span class='color-primary'>Treasure Chest Key</span><br /><br />Can be used to open a red treasure chest.<br /><br /><span class='color-grey'>2 rolls</span>",
    "titanium_emerald_key": "<span class='color-primary'>Treasure Chest Key</span><br /><br />Can be used to open a red treasure chest.<br /><br /><span class='color-grey'>3 rolls</span>",
    "titanium_ruby_key": "<span class='color-primary'>Treasure Chest Key</span><br /><br />Can be used to open a red treasure chest.<br /><br /><span class='color-grey'>4 rolls</span>",
    "titanium_diamond_key": "<span class='color-primary'>Treasure Chest Key</span><br /><br />Can be used to open a red treasure chest.<br /><br /><span class='color-grey'>6 rolls</span>",

    "ancient_broken_key": "<span class='color-primary'>Broken key</span><br /><br />I can probably fix this.<br /><br /><span class='color-lime'>Click to craft</span>",
    "ancient_key": "<span class='color-primary'>Ancient Chest Key</span><br /><br />Can be used to open a red treasure chest.<br /><br /><span class='color-grey'>2 roll</span>",
    "ancient_sapphire_key": "<span class='color-primary'>Ancient Chest Key</span><br /><br />Can be used to open a any treasure chest.<br /><br /><span class='color-grey'>4 rolls</span>",
    "ancient_emerald_key": "<span class='color-primary'>Ancient Chest Key</span><br /><br />Can be used to open a any treasure chest.<br /><br /><span class='color-grey'>6 rolls</span>",
    "ancient_ruby_key": "<span class='color-primary'>Ancient Chest Key</span><br /><br />Can be used to open a any treasure chest.<br /><br /><span class='color-grey'>8 rolls</span>",
    "ancient_diamond_key": "<span class='color-primary'>Ancient Chest Key</span><br /><br />Can be used to open a any treasure chest.<br /><br /><span class='color-grey'>12 rolls</span>",
    
    "crafed-easter-egg": "<span class='color-primary'>Weird chocolate crafted egg</span><br /><br />Hopefully the easter bunny will like this one.",


    "tutorial_rapier_pieces": "A piece of a broken down rapier.",
    "blood_limbs": "Limbs from monsters in a lab.  Can be crushed to extract evil blood",
    "lab_tablette": "One of 3 pieces to craft a full tablette, unlocking the ability to make items for invention.",
    "bronze_blood_grinder": "Ability to grind down limbs by clicking on them.",
    "bronze_blood_glass_shrine": "Ability to convert evil blood into cleansed blood.",

    "blue_pickaxe_orb": "<span class='color-primary'>Blue Orb</span><br /><br />Can be absorbed for a permanent boost.<br /><br /><span class='color-lime'>Reduces the stardust requires when converting ores to xp by 2.</span><br /><br /><span class='color-grey'>Click to absorb.</span>",
    "blue_hammer_orb": "<span class='color-primary'>Blue Orb</span><br /><br />Can be absorbed for a permanent boost.<br /><br /><span class='color-lime'>Reduces the stardust requires when converting bars to xp by 2.</span><br /><br /><span class='color-grey'>Click to absorb.</span>",
    "blue_oil_storage_orb": "<span class='color-primary'>Blue Orb</span><br /><br />Can be absorbed for a permanent boost.<br /><br /><span class='color-lime'>Doubles your oil capacity.</span><br /><br /><span class='color-grey'>Click to absorb.</span>",
    "blue_oil_well_orb": "<span class='color-primary'>Blue Orb</span><br /><br />Can be absorbed for a permanent boost.<br /><br /><span class='color-lime'>Doubles your oil income.</span><br /><br /><span class='color-grey'>Click to absorb.</span>",
    "blue_farming_orb": "<span class='color-primary'>Blue Orb</span><br /><br />Can be absorbed for a permanent boost.<br /><br /><span class='color-lime'>10% chance that harvesting leaves will make them regrow instantly.</span><br /><br /><span class='color-grey'>Click to absorb.</span>",
    "blue_woodcutting_orb": "<span class='color-primary'>Blue Orb</span><br /><br />Can be absorbed for a permanent boost.<br /><br /><span class='color-lime'>10% chance that chopping down a tree will make it regrow instantly.</span><br /><br /><span class='color-grey'>Click to absorb.</span>",
    
    "blue_pickaxe_orb_absorbed": "<span class='color-primary'>Blue Pickaxe Orb</span><br /><br /><span class='color-lime'>Reduces the stardust requires when converting ores to xp by 2.</span>",
    "blue_hammer_orb_absorbed": "<span class='color-primary'>Blue Hammer Orb</span><br /><br /><span class='color-lime'>Reduces the stardust requires when converting bars to xp by 2.</span>",
    "blue_oil_storage_orb_absorbed": "<span class='color-primary'>Blue Oil Storage Orb</span><br /><br /><span class='color-lime'>Doubles your oil capacity.</span>",
    "blue_oil_well_orb_absorbed": "<span class='color-primary'>Blue Oil Well Orb</span><br /><br /><span class='color-lime'>Doubles your oil income.</span>",
    "blue_farming_orb_absorbed": "<span class='color-primary'>Blue Farming Orb</span><br /><br /><span class='color-lime'>10% chance that harvesting leaves will make them regrow instantly.</span>",
    "blue_woodcutting_orb_absorbed": "<span class='color-primary'>Blue Woodcutting Orb</span><br /><br /><span class='color-lime'>10% chance that chopping down a tree will make it regrow instantly.</span>",
    

    "green_charcoal_orb": "<span class='color-primary'>Green Orb</span><br /><br />Can be absorbed for a permanent boost.<br /><br /><span class='color-lime'>Doubles the charcoal obtained from the foundry.  Works with titanium foundry.</span><br /><br /><span class='color-grey'>Click to absorb.</span>",
    "green_arrow_orb": "<span class='color-primary'>Green Orb</span><br /><br />Can be absorbed for a permanent boost.<br /><br /><span class='color-lime'>50% chance to reclaim an arrow used in combat.</span><br /><br /><span class='color-grey'>Click to absorb.</span>",
    "green_bone_orb": "<span class='color-primary'>Green Orb</span><br /><br />Can be absorbed for a permanent boost.<br /><br /><span class='color-lime'>+1 bonemeal for every bonemeal source.</span><br /><br /><span class='color-grey'>Click to absorb.</span>",
    "green_log_orb": "<span class='color-primary'>Green Orb</span><br /><br />Can be absorbed for a permanent boost.<br /><br /><span class='color-lime'>Gain additional logs when chopping trees.</span><br /><br /><span class='color-grey'>Click to absorb.</span>",
    "green_boat_orb": "<span class='color-primary'>Green Orb</span><br /><br />Can be absorbed for a permanent boost.<br /><br /><span class='color-lime'>Doubles the fish you get from boats, including fishing XP</span><br /><br /><span class='color-grey'>Click to absorb.</span>",
    
    "red_farming_orb": "<span class='color-primary'>Red Orb</span><br /><br />Can be absorbed for a permanent boost.<br /><br /><span class='color-red'>Ability to shiny a <u>growing</u> crop every 7 days.</span><br /><br /><span class='color-grey'>Click to absorb.</span>",
    "red_woodcutting_orb": "<span class='color-primary'>Red Orb</span><br /><br />Can be absorbed for a permanent boost.<br /><br /><span class='color-red'>Ability to shiny a <u>growing</u> tree every 7 days.</span><br /><br /><span class='color-grey'>Click to absorb.</span>",
    "red_combat_orb": "<span class='color-primary'>Red Orb</span><br /><br />Can be absorbed for a permanent boost.<br /><br /><span class='color-red'>Ability to shiny a the next monster you fight. There is a 1% cahnce that it becomes mega shiny. This orb may not be used in combat.  Can only be triggered every 7 days</span><br /><br /><span class='color-grey'>Click to absorb.</span>",
    "red_oil_factory_orb": "<span class='color-primary'>Red Orb</span><br /><br />Can be absorbed for a permanent boost.<br /><br /><span class='color-red'>Increases the capacity of workers you can hire in your oil factory.</span><br /><br /><span class='color-grey'>Click to absorb.</span>",
    "red_stardust_watch_orb": "<span class='color-primary'>Red Orb</span><br /><br />Can be absorbed for a permanent boost.<br /><br /><span class='color-red'>Doubles the maximum charge of a stardust watch while also charging up twice as fast.</span><br /><br /><span class='color-grey'>Click to absorb.</span>",
    "red_criptoe_orb": "<span class='color-primary'>Red Orb</span><br /><br />Can be absorbed for a permanent boost.<br /><br /><span class='color-red'>Choosing a criptoe path unlocks it permanently.</span><br /><br /><span class='color-grey'>Click to absorb.</span>",
   
    "cannon": "<span class='color-primary'>Cannon</span><br /><br />Ability to fire your cannon in combat. This item requires cannonballs and may only be used once per fighting session.<br/ ><br /><span class='color-orange'>The damage inflicted on the monster changes every few seconds and can be seen before actually firing the cannon.  It ranges from 1 to the 20% of the monster's <b>current</b> HP.<br /><br /><span class='color-lime'>Timing is important, and the lower the monster's hp, the less effective the cannon becomes.</span></span>",
   

    "green_charcoal_orb_absorbed": "<span class='color-primary'>Green Charcoal Orb</span><br /><br /><span class='color-lime'>Doubles the charcoal obtained from the foundry.  Works with titanium foundry.</span>",
    "green_arrow_orb_absorbed": "<span class='color-primary'>Green Arrow Orb</span><br /><br /><span class='color-lime'>50% chance to reclaim an arrow used in combat.</span>",
    "green_bone_orb_absorbed": "<span class='color-primary'>Green Bone Orb</span><br /><br /><span class='color-lime'>+1 bonemeal for every bonemeal source.</span>",
    "green_log_orb_absorbed": "<span class='color-primary'>Green Log Orb</span><br /><br /><span class='color-lime'>Gain additional logs when chopping trees.</span>",
    "green_boat_orb_absorbed": "<span class='color-primary'>Green Boat Orb</span><br /><br /><span class='color-lime'>Doubles the fish you get from boats, including fishing XP</span>",
    
    "red_farming_orb_absorbed": "<span class='color-primary'>Red Shiny Farming Orb</span><br /><br /><span class='color-red'>Ability to shiny a <u>growing</u> crop every 7 days.</span><br /><br /><span class='color-lime'>Click on a growing crop to activate.</span>",
    "red_woodcutting_orb_absorbed": "<span class='color-primary'>Red Shiny Woodcutting Orb</span><br /><br /><span class='color-red'>Ability to shiny a <u>growing</u> tree every 7 days.</span><br /><br /><span class='color-lime'>Click to growing tree to activate.</span>",
    "red_combat_orb_absorbed": "<span class='color-primary'>Red Shiny Combat Orb</span><br /><br /><span class='color-red'>Ability to shiny a the next monster you fight. Therre is a 1% chance that it becomes mega shiny.  This orb may not be used in combat.  Can only be triggered every 7 days</span><br /><br /><span class='color-lime'>Click the orb to activate.</span>",
    "red_oil_factory_orb_absorbed": "<span class='color-primary'>Red Oil Factory Orb</span><br /><br /><span class='color-red'>Increases the capacity of workers you can hire in your oil factory.</span>",
    "red_stardust_watch_orb_absorbed": "<span class='color-primary'>Red Stardust Watch Orb</span><br /><br /><span class='color-red'>Doubles the maximum charge of a stardust watch while also charging up twice as fast.</span>",
    "red_criptoe_orb_absorbed": "<span class='color-primary'>Criptoe Orb</span><br /><br /><span class='color-red'>Choosing a criptoe path unlocks it permanently.</span>",
   
    
    "in-combat-shiny-angel-tooltip": "Shiny Angel Potion",
    "in-combat-loot-potion": "Combat Loot Potion",
    "in-combat-rain-potion": "Rain Potion",

    //crystals
    "crystal": "<span class='color-primary'>Crytsal</span><br /><br />An ancient crystal that Faradox stole.<br /><br /><span class='color-lime'>Click to absorb</span>",

    //spell scrolls
    "spellscroll": "<span class='color-primary'>Spell Scroll</span><br /><br />There seems to be information on how to cast a combat spell on this scroll.<br /><br /><span class='color-lime'>Click to learn</span>",
    "spellscroll-upgrade": "<span class='color-primary'>Upgrade Spell</span><br /><br />Ability to upgrade a current spell.<br /><br /><span class='color-lime'>Click to learn</span>",
   
    //raw food
    "raw_chicken": "<span class='color-primary'>Raw Chicken</span><br /><br />I can cook this using an oven.<br /><br /><img src='https://cdn.idle-pixel.com/images/heat.png'> -10<br /><img src='https://cdn.idle-pixel.com/images/energy.png'> +50<br /><br /><span class='color-lime'>Click to cook</span>",
    "raw_bird_meat": "<span class='color-primary'>Raw Bird Meat</span><br /><br />I can cook this using an oven.<br /><br /><img src='https://cdn.idle-pixel.com/images/heat.png'> -20<br /><img src='https://cdn.idle-pixel.com/images/energy.png'> +100<br /><br /><span class='color-lime'>Click to cook</span>",
    "raw_meat": "<span class='color-primary'>Raw Meat</span><br /><br />I can cook this using an oven.<br /><br /><img src='https://cdn.idle-pixel.com/images/heat.png'> -40<br /><img src='https://cdn.idle-pixel.com/images/energy.png'> +200<br /><br /><span class='color-lime'>Click to cook</span>",
   
    
    //raw stardust fish
    "raw_small_stardust_fish": "<span class='color-primary'>Raw Stardust Fish (small)</span><br /><br />I can cook this using an oven.<br /><br /><img src='https://cdn.idle-pixel.com/images/heat.png'> -" + Cooking.FOOD_HEAT_REQ_MAP["raw_small_stardust_fish"] + "<br /><img src='https://cdn.idle-pixel.com/images/energy.png'> +"+Cooking.ENERGY_MAP["raw_small_stardust_fish"]+"<br /><br /><span class='color-lime'>Level 50 <span class='color-grey'>(Recommended)</span></span><br /><span class='color-lime'>Click to cook</span><br /><br />Eating this will give you stardust.",
    "raw_medium_stardust_fish": "<span class='color-primary'>Raw Stardust Fish (medium)</span><br /><br />I can cook this using an oven.<br /><br /><img src='https://cdn.idle-pixel.com/images/heat.png'> -" + Cooking.FOOD_HEAT_REQ_MAP["raw_medium_stardust_fish"] + "<br /><img src='https://cdn.idle-pixel.com/images/energy.png'> +"+Cooking.ENERGY_MAP["raw_medium_stardust_fish"]+"<br /><br /><span class='color-lime'>Level 60 <span class='color-grey'>(Recommended)</span></span><br /><span class='color-lime'>Click to cook</span><br /><br />Eating this will give you stardust.",
    "raw_large_stardust_fish": "<span class='color-primary'>Raw Stardust Fish (large)</span><br /><br />I can cook this using an oven.<br /><br /><img src='https://cdn.idle-pixel.com/images/heat.png'> -" + Cooking.FOOD_HEAT_REQ_MAP["raw_large_stardust_fish"] + "<br /><img src='https://cdn.idle-pixel.com/images/energy.png'> +"+Cooking.ENERGY_MAP["raw_large_stardust_fish"]+"<br /><br /><span class='color-lime'>Level 70 <span class='color-grey'>(Recommended)</span></span><br /><span class='color-lime'>Click to cook</span><br /><br />Eating this will give you stardust.",
    

    //raw fish
    "raw_shrimp": "<span class='color-primary'>Raw Shrimp</span><br /><br />I can cook this using an oven.<br /><br /><img src='https://cdn.idle-pixel.com/images/heat.png'> -" + Cooking.FOOD_HEAT_REQ_MAP["raw_shrimp"] + "<br /><img src='https://cdn.idle-pixel.com/images/energy.png'> +"+Cooking.ENERGY_MAP["raw_shrimp"]+"<br /><br /><span class='color-lime'>Click to cook</span>",
    "raw_anchovy": "<span class='color-primary'>Raw Anchovy</span><br /><br />I can cook this using an oven.<br /><br /><img src='https://cdn.idle-pixel.com/images/heat.png'> -" + Cooking.FOOD_HEAT_REQ_MAP["raw_anchovy"] + "<br /><img src='https://cdn.idle-pixel.com/images/energy.png'> +"+Cooking.ENERGY_MAP["raw_anchovy"]+"<br /><br /><span class='color-lime'>Level 5 <span class='color-grey'>(Recommended)</span></span><br /><span class='color-lime'>Click to cook</span>",
    "raw_sardine": "<span class='color-primary'>Raw Sardine</span><br /><br />I can cook this using an oven.<br /><br /><img src='https://cdn.idle-pixel.com/images/heat.png'> -" + Cooking.FOOD_HEAT_REQ_MAP["raw_sardine"] + "<br /><img src='https://cdn.idle-pixel.com/images/energy.png'> +"+Cooking.ENERGY_MAP["raw_sardine"]+"<br /><br /><span class='color-lime'>Level 10 <span class='color-grey'>(Recommended)</span></span><br /><span class='color-lime'>Click to cook</span>",
    "raw_crab": "<span class='color-primary'>Raw Crab</span><br /><br />I can cook this using an oven.<br /><br /><img src='https://cdn.idle-pixel.com/images/heat.png'> -" + Cooking.FOOD_HEAT_REQ_MAP["raw_crab"] + "<br /><img src='https://cdn.idle-pixel.com/images/energy.png'> +"+Cooking.ENERGY_MAP["raw_crab"]+"<br /><br /><span class='color-lime'>Level 35 <span class='color-grey'>(Recommended)</span></span><br /><span class='color-lime'>Click to cook</span>",
    "raw_piranha": "<span class='color-primary'>Raw Piranha</span><br /><br />I can cook this using an oven.<br /><br /><img src='https://cdn.idle-pixel.com/images/heat.png'> -" + Cooking.FOOD_HEAT_REQ_MAP["raw_piranha"] + "<br /><img src='https://cdn.idle-pixel.com/images/energy.png'> +"+Cooking.ENERGY_MAP["raw_piranha"]+"<br /><br /><span class='color-lime'>Level 50 <span class='color-grey'>(Recommended)</span></span><br /><span class='color-lime'>Click to cook</span>",
    
    "raw_salmon": "<span class='color-primary'>Raw Salmon</span><br /><br />I can cook this using an oven.<br /><br /><img src='https://cdn.idle-pixel.com/images/heat.png'> -" + Cooking.FOOD_HEAT_REQ_MAP["raw_salmon"] + "<br /><img src='https://cdn.idle-pixel.com/images/energy.png'> +"+Cooking.ENERGY_MAP["raw_salmon"]+"<br /><br /><span class='color-lime'>Level 10 <span class='color-grey'>(Recommended)</span></span><br /><span class='color-lime'>Click to cook</span>",
    "raw_trout": "<span class='color-primary'>Raw Trout</span><br /><br />I can cook this using an oven.<br /><br /><img src='https://cdn.idle-pixel.com/images/heat.png'> -" + Cooking.FOOD_HEAT_REQ_MAP["raw_trout"] + "<br /><img src='https://cdn.idle-pixel.com/images/energy.png'> +"+Cooking.ENERGY_MAP["raw_trout"]+"<br /><br /><span class='color-lime'>Level 20 <span class='color-grey'>(Recommended)</span></span><br /><span class='color-lime'>Click to cook</span>",
    "raw_pike": "<span class='color-primary'>Raw Pike</span><br /><br />I can cook this using an oven.<br /><br /><img src='https://cdn.idle-pixel.com/images/heat.png'> -" + Cooking.FOOD_HEAT_REQ_MAP["raw_pike"] + "<br /><img src='https://cdn.idle-pixel.com/images/energy.png'> +"+Cooking.ENERGY_MAP["raw_pike"]+"<br /><br /><span class='color-lime'>Level 35 <span class='color-grey'>(Recommended)</span></span><br /><span class='color-lime'>Click to cook</span>",
    "raw_eel": "<span class='color-primary'>Raw Eel</span><br /><br />I can cook this using an oven.<br /><br /><img src='https://cdn.idle-pixel.com/images/heat.png'> -" + Cooking.FOOD_HEAT_REQ_MAP["raw_eel"] + "<br /><img src='https://cdn.idle-pixel.com/images/energy.png'> +"+Cooking.ENERGY_MAP["raw_eel"]+"<br /><br /><span class='color-lime'>Level 55 <span class='color-grey'>(Recommended)</span></span><br /><span class='color-lime'>Click to cook</span>",
    "raw_rainbow_fish": "<span class='color-primary'>Raw Rainbow Fish</span><br /><br />I can cook this using an oven.<br /><br /><img src='https://cdn.idle-pixel.com/images/heat.png'> -" + Cooking.FOOD_HEAT_REQ_MAP["raw_rainbow_fish"] + "<br /><img src='https://cdn.idle-pixel.com/images/energy.png'> +"+Cooking.ENERGY_MAP["raw_rainbow_fish"]+"<br /><br /><span class='color-lime'>Level 70 <span class='color-grey'>(Recommended)</span></span><br /><span class='color-lime'>Click to cook</span>",
    
    "raw_tuna": "<span class='color-primary'>Raw Tuna</span><br /><br />I can cook this using an oven.<br /><br /><img src='https://cdn.idle-pixel.com/images/heat.png'> -" + Cooking.FOOD_HEAT_REQ_MAP["raw_tuna"] + "<br /><img src='https://cdn.idle-pixel.com/images/energy.png'> +"+Cooking.ENERGY_MAP["raw_tuna"]+"<br /><br /><span class='color-lime'>Level 35 <span class='color-grey'>(Recommended)</span></span><br /><span class='color-lime'>Click to cook</span>",
    "raw_swordfish": "<span class='color-primary'>Raw Swordfish</span><br /><br />I can cook this using an oven.<br /><br /><img src='https://cdn.idle-pixel.com/images/heat.png'> -" + Cooking.FOOD_HEAT_REQ_MAP["raw_swordfish"] + "<br /><img src='https://cdn.idle-pixel.com/images/energy.png'> +"+Cooking.ENERGY_MAP["raw_swordfish"]+"<br /><br /><span class='color-lime'>Level 50 <span class='color-grey'>(Recommended)</span></span><br /><span class='color-lime'>Click to cook</span>",
    "raw_manta_ray": "<span class='color-primary'>Raw Mantaray</span><br /><br />I can cook this using an oven.<br /><br /><img src='https://cdn.idle-pixel.com/images/heat.png'> -" + Cooking.FOOD_HEAT_REQ_MAP["raw_manta_ray"] + "<br /><img src='https://cdn.idle-pixel.com/images/energy.png'> +"+Cooking.ENERGY_MAP["raw_manta_ray"]+"<br /><br /><span class='color-lime'>Level 75 <span class='color-grey'>(Recommended)</span></span><br /><span class='color-lime'>Click to cook</span>",
    "raw_shark": "<span class='color-primary'>Raw Shark</span><br /><br />I can cook this using an oven.<br /><br /><img src='https://cdn.idle-pixel.com/images/heat.png'> -" + Cooking.FOOD_HEAT_REQ_MAP["raw_shark"] + "<br /><img src='https://cdn.idle-pixel.com/images/energy.png'> +"+Cooking.ENERGY_MAP["raw_shark"]+"<br /><br /><span class='color-lime'>Level 82 <span class='color-grey'>(Recommended)</span></span><br /><span class='color-lime'>Click to cook</span>",
    "raw_bloated_shark": "<span class='color-primary'>Raw Shark (Bloated)</span><br /><br />I can cook this using an oven.  Hmm this shark's stomach seems to be bigger than others.<br /><br /><img src='https://cdn.idle-pixel.com/images/heat.png'> -" + Cooking.FOOD_HEAT_REQ_MAP["raw_shark"] + "<br /><img src='https://cdn.idle-pixel.com/images/energy.png'> +"+Cooking.ENERGY_MAP["raw_shark"]+"<br /><br /><span class='color-lime'>Level 82 <span class='color-grey'>(Recommended)</span></span><br /><span class='color-lime'>Click to cook</span>",
    "raw_whale": "<span class='color-primary'>Raw Whale</span><br /><br />I can cook this using an oven.<br /><br /><img src='https://cdn.idle-pixel.com/images/heat.png'> -" + Cooking.FOOD_HEAT_REQ_MAP["raw_whale"] + "<br /><img src='https://cdn.idle-pixel.com/images/energy.png'> +"+Cooking.ENERGY_MAP["raw_whale"]+"<br /><br /><span class='color-lime'>Level 90 <span class='color-grey'>(Recommended)</span></span><br /><span class='color-lime'>Click to cook</span>",

    "raw_angler_fish": "<span class='color-primary'>Raw Angler Fish</span><br /><br />I can cook this using an oven.<br /><br /><img src='https://cdn.idle-pixel.com/images/heat.png'> -" + Cooking.FOOD_HEAT_REQ_MAP["raw_angler_fish"] + "<br /><img src='https://cdn.idle-pixel.com/images/energy.png'> +"+Cooking.ENERGY_MAP["raw_angler_fish"]+"<br /><br /><span class='color-lime'>Level 100 <span class='color-grey'>(Recommended)</span></span><br /><span class='color-lime'>Click to cook</span>",

    //raw fish - shiny
    "raw_shrimp_shiny": "<span class='color-primary'>Raw Shrimp</span><br /><br />I can cook this using an oven.<br /><br /><img src='https://cdn.idle-pixel.com/images/heat.png'> -" + Cooking.FOOD_HEAT_REQ_MAP["raw_shrimp"] + "<br /><img src='https://cdn.idle-pixel.com/images/energy.png'> +"+Cooking.ENERGY_MAP["raw_shrimp_shiny"]+"<br /><br /><span class='color-lime'>Click to cook</span>",
    "raw_anchovy_shiny": "<span class='color-primary'>Raw Anchovy</span><br /><br />I can cook this using an oven.<br /><br /><img src='https://cdn.idle-pixel.com/images/heat.png'> -" + Cooking.FOOD_HEAT_REQ_MAP["raw_anchovy"] + "<br /><img src='https://cdn.idle-pixel.com/images/energy.png'> +"+Cooking.ENERGY_MAP["raw_anchovy_shiny"]+"<br /><br /><span class='color-lime'>Level 5 <span class='color-grey'>(Recommended)</span></span><br /><span class='color-lime'>Click to cook</span>",
    "raw_sardine_shiny": "<span class='color-primary'>Raw Sardine</span><br /><br />I can cook this using an oven.<br /><br /><img src='https://cdn.idle-pixel.com/images/heat.png'> -" + Cooking.FOOD_HEAT_REQ_MAP["raw_sardine"] + "<br /><img src='https://cdn.idle-pixel.com/images/energy.png'> +"+Cooking.ENERGY_MAP["raw_sardine_shiny"]+"<br /><br /><span class='color-lime'>Level 10 <span class='color-grey'>(Recommended)</span></span><br /><span class='color-lime'>Click to cook</span>",
    "raw_crab_shiny": "<span class='color-primary'>Raw Crab</span><br /><br />I can cook this using an oven.<br /><br /><img src='https://cdn.idle-pixel.com/images/heat.png'> -" + Cooking.FOOD_HEAT_REQ_MAP["raw_crab"] + "<br /><img src='https://cdn.idle-pixel.com/images/energy.png'> +"+Cooking.ENERGY_MAP["raw_crab_shiny"]+"<br /><br /><span class='color-lime'>Level 35 <span class='color-grey'>(Recommended)</span></span><br /><span class='color-lime'>Click to cook</span>",
    "raw_piranha_shiny": "<span class='color-primary'>Raw Piranha</span><br /><br />I can cook this using an oven.<br /><br /><img src='https://cdn.idle-pixel.com/images/heat.png'> -" + Cooking.FOOD_HEAT_REQ_MAP["raw_piranha"] + "<br /><img src='https://cdn.idle-pixel.com/images/energy.png'> +"+Cooking.ENERGY_MAP["raw_piranha_shiny"]+"<br /><br /><span class='color-lime'>Level 50 <span class='color-grey'>(Recommended)</span></span><br /><span class='color-lime'>Click to cook</span>",
    
    "raw_salmon_shiny": "<span class='color-primary'>Raw Salmon</span><br /><br />I can cook this using an oven.<br /><br /><img src='https://cdn.idle-pixel.com/images/heat.png'> -" + Cooking.FOOD_HEAT_REQ_MAP["raw_salmon"] + "<br /><img src='https://cdn.idle-pixel.com/images/energy.png'> +"+Cooking.ENERGY_MAP["raw_salmon_shiny"]+"<br /><br /><span class='color-lime'>Level 10 <span class='color-grey'>(Recommended)</span></span><br /><span class='color-lime'>Click to cook</span>",
    "raw_trout_shiny": "<span class='color-primary'>Raw Trout</span><br /><br />I can cook this using an oven.<br /><br /><img src='https://cdn.idle-pixel.com/images/heat.png'> -" + Cooking.FOOD_HEAT_REQ_MAP["raw_trout"] + "<br /><img src='https://cdn.idle-pixel.com/images/energy.png'> +"+Cooking.ENERGY_MAP["raw_trout_shiny"]+"<br /><br /><span class='color-lime'>Level 20 <span class='color-grey'>(Recommended)</span></span><br /><span class='color-lime'>Click to cook</span>",
    "raw_pike_shiny": "<span class='color-primary'>Raw Pike</span><br /><br />I can cook this using an oven.<br /><br /><img src='https://cdn.idle-pixel.com/images/heat.png'> -" + Cooking.FOOD_HEAT_REQ_MAP["raw_pike"] + "<br /><img src='https://cdn.idle-pixel.com/images/energy.png'> +"+Cooking.ENERGY_MAP["raw_pike_shiny"]+"<br /><br /><span class='color-lime'>Level 35 <span class='color-grey'>(Recommended)</span></span><br /><span class='color-lime'>Click to cook</span>",
    "raw_eel_shiny": "<span class='color-primary'>Raw Eel</span><br /><br />I can cook this using an oven.<br /><br /><img src='https://cdn.idle-pixel.com/images/heat.png'> -" + Cooking.FOOD_HEAT_REQ_MAP["raw_eel"] + "<br /><img src='https://cdn.idle-pixel.com/images/energy.png'> +"+Cooking.ENERGY_MAP["raw_eel_shiny"]+"<br /><br /><span class='color-lime'>Level 55 <span class='color-grey'>(Recommended)</span></span><br /><span class='color-lime'>Click to cook</span>",
    "raw_rainbow_fish_shiny": "<span class='color-primary'>Raw Rainbow Fish</span><br /><br />I can cook this using an oven.<br /><br /><img src='https://cdn.idle-pixel.com/images/heat.png'> -" + Cooking.FOOD_HEAT_REQ_MAP["raw_rainbow_fish"] + "<br /><img src='https://cdn.idle-pixel.com/images/energy.png'> +"+Cooking.ENERGY_MAP["raw_rainbow_fish_shiny"]+"<br /><br /><span class='color-lime'>Level 70 <span class='color-grey'>(Recommended)</span></span><br /><span class='color-lime'>Click to cook</span>",
    
    "raw_tuna_shiny": "<span class='color-primary'>Raw Tuna</span><br /><br />I can cook this using an oven.<br /><br /><img src='https://cdn.idle-pixel.com/images/heat.png'> -" + Cooking.FOOD_HEAT_REQ_MAP["raw_tuna"] + "<br /><img src='https://cdn.idle-pixel.com/images/energy.png'> +"+Cooking.ENERGY_MAP["raw_tuna_shiny"]+"<br /><br /><span class='color-lime'>Level 35 <span class='color-grey'>(Recommended)</span></span><br /><span class='color-lime'>Click to cook</span>",
    "raw_swordfish_shiny": "<span class='color-primary'>Raw Swordfish</span><br /><br />I can cook this using an oven.<br /><br /><img src='https://cdn.idle-pixel.com/images/heat.png'> -" + Cooking.FOOD_HEAT_REQ_MAP["raw_swordfish"] + "<br /><img src='https://cdn.idle-pixel.com/images/energy.png'> +"+Cooking.ENERGY_MAP["raw_swordfish_shiny"]+"<br /><br /><span class='color-lime'>Level 50 <span class='color-grey'>(Recommended)</span></span><br /><span class='color-lime'>Click to cook</span>",
    "raw_manta_ray_shiny": "<span class='color-primary'>Raw Mantaray</span><br /><br />I can cook this using an oven.<br /><br /><img src='https://cdn.idle-pixel.com/images/heat.png'> -" + Cooking.FOOD_HEAT_REQ_MAP["raw_manta_ray"] + "<br /><img src='https://cdn.idle-pixel.com/images/energy.png'> +"+Cooking.ENERGY_MAP["raw_manta_ray_shiny"]+"<br /><br /><span class='color-lime'>Level 75 <span class='color-grey'>(Recommended)</span></span><br /><span class='color-lime'>Click to cook</span>",
    "raw_shark_shiny": "<span class='color-primary'>Raw Shark</span><br /><br />I can cook this using an oven.<br /><br /><img src='https://cdn.idle-pixel.com/images/heat.png'> -" + Cooking.FOOD_HEAT_REQ_MAP["raw_shark"] + "<br /><img src='https://cdn.idle-pixel.com/images/energy.png'> +"+Cooking.ENERGY_MAP["raw_shark_shiny"]+"<br /><br /><span class='color-lime'>Level 82 <span class='color-grey'>(Recommended)</span></span><br /><span class='color-lime'>Click to cook</span>",
    "raw_whale_shiny": "<span class='color-primary'>Raw Whale</span><br /><br />I can cook this using an oven.<br /><br /><img src='https://cdn.idle-pixel.com/images/heat.png'> -" + Cooking.FOOD_HEAT_REQ_MAP["raw_whale"] + "<br /><img src='https://cdn.idle-pixel.com/images/energy.png'> +"+Cooking.ENERGY_MAP["raw_whale_shiny"]+"<br /><br /><span class='color-lime'>Level 90 <span class='color-grey'>(Recommended)</span></span><br /><span class='color-lime'>Click to cook</span>",

    //raw fish - mega
    "raw_shrimp_mega_shiny": "<span class='color-primary'>Raw Shrimp</span><br /><br />I can cook this using an oven.<br /><br /><img src='https://cdn.idle-pixel.com/images/heat.png'> -" + Cooking.FOOD_HEAT_REQ_MAP["raw_shrimp"] + "<br /><img src='https://cdn.idle-pixel.com/images/energy.png'> +"+Cooking.ENERGY_MAP["raw_shrimp_mega_shiny"]+"<br /><br /><span class='color-lime'>Click to cook</span>",
    "raw_anchovy_mega_shiny": "<span class='color-primary'>Raw Anchovy</span><br /><br />I can cook this using an oven.<br /><br /><img src='https://cdn.idle-pixel.com/images/heat.png'> -" + Cooking.FOOD_HEAT_REQ_MAP["raw_anchovy"] + "<br /><img src='https://cdn.idle-pixel.com/images/energy.png'> +"+Cooking.ENERGY_MAP["raw_anchovy_mega_shiny"]+"<br /><br /><span class='color-lime'>Level 5 <span class='color-grey'>(Recommended)</span></span><br /><span class='color-lime'>Click to cook</span>",
    "raw_sardine_mega_shiny": "<span class='color-primary'>Raw Sardine</span><br /><br />I can cook this using an oven.<br /><br /><img src='https://cdn.idle-pixel.com/images/heat.png'> -" + Cooking.FOOD_HEAT_REQ_MAP["raw_sardine"] + "<br /><img src='https://cdn.idle-pixel.com/images/energy.png'> +"+Cooking.ENERGY_MAP["raw_sardine_mega_shiny"]+"<br /><br /><span class='color-lime'>Level 10 <span class='color-grey'>(Recommended)</span></span><br /><span class='color-lime'>Click to cook</span>",
    "raw_crab_mega_shiny": "<span class='color-primary'>Raw Crab</span><br /><br />I can cook this using an oven.<br /><br /><img src='https://cdn.idle-pixel.com/images/heat.png'> -" + Cooking.FOOD_HEAT_REQ_MAP["raw_crab"] + "<br /><img src='https://cdn.idle-pixel.com/images/energy.png'> +"+Cooking.ENERGY_MAP["raw_crab_mega_shiny"]+"<br /><br /><span class='color-lime'>Level 35 <span class='color-grey'>(Recommended)</span></span><br /><span class='color-lime'>Click to cook</span>",
    "raw_piranha_mega_shiny": "<span class='color-primary'>Raw Piranha</span><br /><br />I can cook this using an oven.<br /><br /><img src='https://cdn.idle-pixel.com/images/heat.png'> -" + Cooking.FOOD_HEAT_REQ_MAP["raw_piranha"] + "<br /><img src='https://cdn.idle-pixel.com/images/energy.png'> +"+Cooking.ENERGY_MAP["raw_piranha_mega_shiny"]+"<br /><br /><span class='color-lime'>Level 50 <span class='color-grey'>(Recommended)</span></span><br /><span class='color-lime'>Click to cook</span>",
    
    "raw_salmon_mega_shiny": "<span class='color-primary'>Raw Salmon</span><br /><br />I can cook this using an oven.<br /><br /><img src='https://cdn.idle-pixel.com/images/heat.png'> -" + Cooking.FOOD_HEAT_REQ_MAP["raw_salmon"] + "<br /><img src='https://cdn.idle-pixel.com/images/energy.png'> +"+Cooking.ENERGY_MAP["raw_salmon_mega_shiny"]+"<br /><br /><span class='color-lime'>Level 10 <span class='color-grey'>(Recommended)</span></span><br /><span class='color-lime'>Click to cook</span>",
    "raw_trout_mega_shiny": "<span class='color-primary'>Raw Trout</span><br /><br />I can cook this using an oven.<br /><br /><img src='https://cdn.idle-pixel.com/images/heat.png'> -" + Cooking.FOOD_HEAT_REQ_MAP["raw_trout"] + "<br /><img src='https://cdn.idle-pixel.com/images/energy.png'> +"+Cooking.ENERGY_MAP["raw_trout_mega_shiny"]+"<br /><br /><span class='color-lime'>Level 20 <span class='color-grey'>(Recommended)</span></span><br /><span class='color-lime'>Click to cook</span>",
    "raw_pike_mega_shiny": "<span class='color-primary'>Raw Pike</span><br /><br />I can cook this using an oven.<br /><br /><img src='https://cdn.idle-pixel.com/images/heat.png'> -" + Cooking.FOOD_HEAT_REQ_MAP["raw_pike"] + "<br /><img src='https://cdn.idle-pixel.com/images/energy.png'> +"+Cooking.ENERGY_MAP["raw_pike_mega_shiny"]+"<br /><br /><span class='color-lime'>Level 35 <span class='color-grey'>(Recommended)</span></span><br /><span class='color-lime'>Click to cook</span>",
    "raw_eel_mega_shiny": "<span class='color-primary'>Raw Eel</span><br /><br />I can cook this using an oven.<br /><br /><img src='https://cdn.idle-pixel.com/images/heat.png'> -" + Cooking.FOOD_HEAT_REQ_MAP["raw_eel"] + "<br /><img src='https://cdn.idle-pixel.com/images/energy.png'> +"+Cooking.ENERGY_MAP["raw_eel_mega_shiny"]+"<br /><br /><span class='color-lime'>Level 55 <span class='color-grey'>(Recommended)</span></span><br /><span class='color-lime'>Click to cook</span>",
    "raw_rainbow_fish_mega_shiny": "<span class='color-primary'>Raw Rainbow Fish</span><br /><br />I can cook this using an oven.<br /><br /><img src='https://cdn.idle-pixel.com/images/heat.png'> -" + Cooking.FOOD_HEAT_REQ_MAP["raw_rainbow_fish"] + "<br /><img src='https://cdn.idle-pixel.com/images/energy.png'> +"+Cooking.ENERGY_MAP["raw_rainbow_fish_mega_shiny"]+"<br /><br /><span class='color-lime'>Level 70 <span class='color-grey'>(Recommended)</span></span><br /><span class='color-lime'>Click to cook</span>",
    
    "raw_tuna_mega_shiny": "<span class='color-primary'>Raw Tuna</span><br /><br />I can cook this using an oven.<br /><br /><img src='https://cdn.idle-pixel.com/images/heat.png'> -" + Cooking.FOOD_HEAT_REQ_MAP["raw_tuna"] + "<br /><img src='https://cdn.idle-pixel.com/images/energy.png'> +"+Cooking.ENERGY_MAP["raw_tuna_mega_shiny"]+"<br /><br /><span class='color-lime'>Level 35 <span class='color-grey'>(Recommended)</span></span><br /><span class='color-lime'>Click to cook</span>",
    "raw_swordfish_mega_shiny": "<span class='color-primary'>Raw Swordfish</span><br /><br />I can cook this using an oven.<br /><br /><img src='https://cdn.idle-pixel.com/images/heat.png'> -" + Cooking.FOOD_HEAT_REQ_MAP["raw_swordfish"] + "<br /><img src='https://cdn.idle-pixel.com/images/energy.png'> +"+Cooking.ENERGY_MAP["raw_swordfish_mega_shiny"]+"<br /><br /><span class='color-lime'>Level 50 <span class='color-grey'>(Recommended)</span></span><br /><span class='color-lime'>Click to cook</span>",
    "raw_manta_ray_mega_shiny": "<span class='color-primary'>Raw Mantaray</span><br /><br />I can cook this using an oven.<br /><br /><img src='https://cdn.idle-pixel.com/images/heat.png'> -" + Cooking.FOOD_HEAT_REQ_MAP["raw_manta_ray"] + "<br /><img src='https://cdn.idle-pixel.com/images/energy.png'> +"+Cooking.ENERGY_MAP["raw_manta_ray_mega_shiny"]+"<br /><br /><span class='color-lime'>Level 75 <span class='color-grey'>(Recommended)</span></span><br /><span class='color-lime'>Click to cook</span>",
    "raw_shark_mega_shiny": "<span class='color-primary'>Raw Shark</span><br /><br />I can cook this using an oven.<br /><br /><img src='https://cdn.idle-pixel.com/images/heat.png'> -" + Cooking.FOOD_HEAT_REQ_MAP["raw_shark"] + "<br /><img src='https://cdn.idle-pixel.com/images/energy.png'> +"+Cooking.ENERGY_MAP["raw_shark_mega_shiny"]+"<br /><br /><span class='color-lime'>Level 82 <span class='color-grey'>(Recommended)</span></span><br /><span class='color-lime'>Click to cook</span>",
    "raw_whale_mega_shiny": "<span class='color-primary'>Raw Whale</span><br /><br />I can cook this using an oven.<br /><br /><img src='https://cdn.idle-pixel.com/images/heat.png'> -" + Cooking.FOOD_HEAT_REQ_MAP["raw_whale"] + "<br /><img src='https://cdn.idle-pixel.com/images/energy.png'> +"+Cooking.ENERGY_MAP["raw_whale_mega_shiny"]+"<br /><br /><span class='color-lime'>Level 90 <span class='color-grey'>(Recommended)</span></span><br /><span class='color-lime'>Click to cook</span>",


    
    //ovens
    "bronze_oven": "<span class='color-primary'>Bronze Oven</span><br /><br />I must first heat up the oven before using it to cook food.<br /><br /><img src='https://cdn.idle-pixel.com/images/cooking.png'> 50% chance of burning food.<br /><br /><span class='color-lime'>Click to add logs.</span>",
    "iron_oven": "<span class='color-primary'>Iron Oven</span><br /><br />I must first heat up the oven before using it to cook food.<br /><br /><img src='https://cdn.idle-pixel.com/images/cooking.png'> 40% chance of burning food.<br /><br /><span class='color-lime'>Click to add logs.</span>",
    "silver_oven": "<span class='color-primary'>Silver Oven</span><br /><br />I must first heat up the oven before using it to cook food.<br /><br /><img src='https://cdn.idle-pixel.com/images/cooking.png'> 30% chance of burning food.<br /><br /><span class='color-lime'>Click to add logs.</span>",
    "gold_oven": "<span class='color-primary'>Gold Oven</span><br /><br />I must first heat up the oven before using it to cook food.<br /><br /><img src='https://cdn.idle-pixel.com/images/cooking.png'> 20% chance of burning food.<br /><br /><span class='color-lime'>Click to add logs.</span>",
    "promethium_oven": "<span class='color-primary'>Promethium Oven</span><br /><br />I must first heat up the oven before using it to cook food.<br /><br /><img src='https://cdn.idle-pixel.com/images/cooking.png'> 10% chance of burning food.<br /><br /><span class='color-lime'>Click to add logs.</span>",
    "titanium_oven": "<span class='color-primary'>Titanium Oven</span><br /><br />I must first heat up the oven before using it to cook food.<br /><br /><img src='https://cdn.idle-pixel.com/images/cooking.png'> 5% chance of burning food.<br /><br /><span class='color-lime'>Click to add logs.</span>",
    "ancient_oven": "<span class='color-primary'>Ancient Oven</span><br /><br />I must first heat up the oven before using it to cook food.<br /><br /><img src='https://cdn.idle-pixel.com/images/cooking.png'> This oven will never burn food.<br /><br /><span class='color-lime'>Click to add logs.</span>",

    //badges
    "badge_field_fp_reduction": Combat.BADGES['badge_field_fp_reduction'],
    "badge_chicken_feather": Combat.BADGES['badge_chicken_feather'],
    "badge_spider_poison": Combat.BADGES['badge_spider_poison'],
    "badge_ant_needles": Combat.BADGES['badge_ant_needles'],
    "badge_strange_leaf": Combat.BADGES['badge_strange_leaf'],
    "badge_coin_thief": Combat.BADGES['badge_coin_thief'],

    "badge_ten_melee_levels_hp": Combat.BADGES['badge_ten_melee_levels_hp'],
    "badge_ten_archery_levels_hp": Combat.BADGES['badge_ten_archery_levels_hp'],
    "badge_ten_magic_levels_hp": Combat.BADGES['badge_ten_magic_levels_hp'],
    "badge_pine_logs": Combat.BADGES['badge_pine_logs'],
    "badge_skeleton_bones": Combat.BADGES['badge_skeleton_bones'],
    "badge_molten_glass": Combat.BADGES['badge_molten_glass'],
    "badge_wield_bucket": Combat.BADGES['badge_wield_bucket'],
    "badge_fire_hawk_feather": Combat.BADGES['badge_fire_hawk_feather'],
    "badge_ice_hawk_feather": Combat.BADGES['badge_ice_hawk_feather'],
    "badge_grow_pine_farming": Combat.BADGES['badge_grow_pine_farming'],
    "badge_grow_pine_woodcutting": Combat.BADGES['badge_grow_pine_woodcutting'],


    "badge_free_spell_cast": Combat.BADGES['badge_free_spell_cast'],
    "badge_ghost_essence": Combat.BADGES['badge_ghost_essence'],
    "beach_fp_refund": Combat.BADGES['beach_fp_refund'],
    "badge_double_shark_tooth": Combat.BADGES['badge_double_shark_tooth'],
    "badge_beach_mega_bait": Combat.BADGES['badge_beach_mega_bait'],
    "badge_double_guardian_key_one": Combat.BADGES['badge_double_guardian_key_one'],
    "badge_tsunami": Combat.BADGES['badge_tsunami'],
    "badge_sea_soldier_helmet": Combat.BADGES['badge_sea_soldier_helmet'],

    "badge_critical_strike": Combat.BADGES['badge_critical_strike'],
    "badge_blood_limbs": Combat.BADGES['badge_blood_limbs'],
    "badge_double_tnt": Combat.BADGES['badge_double_tnt'],
    "badge_double_guardian_key_two": Combat.BADGES['badge_double_guardian_key_two'],
    "badge_death_1_hp": Combat.BADGES['badge_death_1_hp'],
    "badge_10_percent_fp": Combat.BADGES['badge_10_percent_fp'],
    "badge_10_percent_energy": Combat.BADGES['badge_10_percent_energy'],

    "badge_ancient_tablette": Combat.BADGES['badge_ancient_tablette'],
    "badge_double_loot": Combat.BADGES['badge_double_loot'],
    "badge_20_hp": Combat.BADGES['badge_20_hp'],


    "staff_spirit":  "<span class='color-primary'>Staff Spirit</span><br /><br />Can be attached to an undead staff.  Click for more info.",

    //random
    "fishing_net_quest": "<span class='color-primary'>Fishing Net</span><br /><br />I should talk to the fisherman quest.",
    "max_heart_crystal": "<span class='color-primary'>Heart Crystal</span><br /><br />This powerful crystal can be touched to <span class='color-lime'>increase you max hp by 5 permanently</span>.",
    "max_mana_crystal": "<span class='color-primary'>Mana Crystal</span><br /><br />This powerful crystal can be touched to <span class='color-lime'>increase you max mana by 5 permanently</span>.",
    "max_mana_crystal_mega": "<span class='color-primary'>Mana Crystal</span><br /><br />This powerful crystal can be touched to <span class='color-lime'>increase you max mana by 10 permanently</span>.",
  }
}